/*
 * config.h
 * Copyright (C) 2006-2008, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __Mylene0fa_CONFIG_H__
#define __Mylene0fa_CONFIG_H__

#include <autoconfig.h>

#if defined HAVE_ENDIAN_H
# include <endian.h>
#endif				/* HAVE_ENDIAN_H */
#include <libx1f4i2.h>

#define __SYNCRONIZE_STREAMS__		1

#if defined HAVE_ENDIAN_H
# if __BYTE_ORDER == __BIG_ENDIAN
#  define WORDS_BIGENDIAN		1
# endif				/* __BYTE_ORDER == __BIG_ENDIAN */
#endif				/* HAVE_ENDIAN_H */

#if !defined WORDS_BIGENDIAN
# define WORDS_BIGENDIAN		0
#endif				/* !WORDS_BIGENDIAN */

#if !defined __LIBx1f4i2_KSET_INTER__
# define __Mylene0fa_KSET_INTER__	0
#elif !__LIBx1f4i2_KSET_INTER__
# define __Mylene0fa_KSET_INTER__	0
#else
# define __Mylene0fa_KSET_INTER__	1
#endif				/* !__LIBx1f4i2_KSET_INTER__ */

#if !defined __LIBx1f4i2_LINE_INTER__
# define __Mylene0fa_LINE_INTER__	0
#elif !__LIBx1f4i2_LINE_INTER__
# define __Mylene0fa_LINE_INTER__	0
#else
# define __Mylene0fa_LINE_INTER__	1
#endif				/* !__LIBx1f4i2_LINE_INTER__ */

#define EXIT_UNDERFLOW			0
#define WAIT_UNDERFLOW			1

#define HERE_UNDERFLOW			EXIT_UNDERFLOW

#define Mylene0fa_SLEEP			0
#define libx1f4i2_SLEEP			1

#define HERE_SLEEP			Mylene0fa_SLEEP

#define WAIT_SLEEP			Mylene0fa_SLEEP

#if HERE_SLEEP == libx1f4i2_SLEEP
# define Mylene0fa_play_xaudio		x1f4_play_xaudio
#else
# define Mylene0fa_play_xaudio		x1f4_qlay_xaudio
#endif				/* HERE_SLEEP == libx1f4i2_SLEEP */

#if WORDS_BIGENDIAN
# define ADVANCE_COMPLETIONS(completions) \
    (completions)++
#else
# define ADVANCE_COMPLETIONS(completions) \
    (completions) = ((completions) & 127) | ((completions) >> 1 & ~127);      \
    (completions)++;							      \
    (completions) = ((completions) & 127) | ((completions) << 1 & ~255) | 128
#endif				/* WORDS_BIGENDIAN */

#if HERE_UNDERFLOW == EXIT_UNDERFLOW
# define PANIC_THRESHOLD		4
#endif				/* HERE_UNDERFLOW == EXIT_UNDERFLOW */

#endif				/* __Mylene0fa_CONFIG_H__ */
