/*
 * logique.1.h
 * Copyright (C) 2006-2011, 2014, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __Mylene0fa_logique_1_H__
#define __Mylene0fa_logique_1_H__

#include <config.h>

#include <libx1f4i2.h>

#include <sys/time.h>

typedef struct context_state {
    const char *Mylene0fa, *device;
    int down, miss_stamp, pending_1f4, shmid;
    struct state_type *head_state, *tail_state;
    struct timeval *atime;
    struct x1f4_aerror_type aerror;
    unsigned block, cache_size, completions;
#if HERE_SLEEP == Mylene0fa_SLEEP
    unsigned delay;
#endif				/* HERE_SLEEP == Mylene0fa_SLEEP */
    unsigned detached, e0fa_index, e1f4_size, flush_loss, latency, loss_index,
	outgoing, output_size, paused;
#if WAIT_SLEEP == Mylene0fa_SLEEP
    unsigned second_a, second_f, violet_a, violet_f;
#endif				/* WAIT_SLEEP == Mylene0fa_SLEEP */
    unsigned size, *state;
    unsigned char e1f4_data[0x40];
    void *audio, *output;
#if !__Mylene0fa_LINE_INTER__
    void *segment;
#endif				/* !__Mylene0fa_LINE_INTER__ */
    void *xaudio;
} context_state;

typedef struct state_type {
    int do_stamp;
    struct state_type *state_data;
    unsigned bias_0, bias_1, channels, e0fa_index, post_index,
	sampling_frequency, size;
} state_type;

#endif				/* __Mylene0fa_logique_1_H__ */
