/*
 * fsvv.1.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <fspost.h>
#include <fsvv-defs.h>
#include <fsvv-types.h>
#include <trans.h>
#include <tslist.h>

#define fs_shift(list, fslist_data) \
    ((char *) (list) + (fslist_data)->link_0.ts_1)
#define ts_shift(list) \
    ((char *) (list) - sizeof(struct fslist_type))

static int miss_post(void *, void *);

static int
miss_post(void *miss, void *node)
{
    return x1f4_miss_fspost(miss, *(void **) node);
}


int
x1f4_fini_fslist(void **fslist)
{
    int status;
    struct fslist_type *fslist_data;
    struct trans_type trans;
    void *list;

    list = *fslist;

    fslist_data = (void *) ts_shift(list);

    x1f4_aime_fspost((void *) fs_shift(list, fslist_data), &trans);

    if (1) {
	status = x1f4_well_tslist
	    (list, fs_shift(list, fslist_data), miss_post);
    }
    if (1) {
	int excess;

	excess = x1f4_flat_fspost((void *) fs_shift(list, fslist_data));
	if (excess) {
	    if (status) {
	    } else {
		status = excess;
	    }
	}
    }
    if (1) {
	int excess;

	excess = x1f4_flat_tslist(list);
	if (excess) {
	    if (status) {
	    } else {
		status = excess;
	    }
	}
    }
    if (1) {
	int excess;

	excess = trans.free(trans.data, fslist_data);
	if (excess) {
	    if (status) {
	    } else {
		status = FREE_ERROR;
	    }
	}
    }

    return status;
}
