/*
 * fsvv.2.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <fspost.h>
#include <fsvv-types.h>
#include <tslist.h>

#define fs_shift(list, fslist_data) \
    ((char *) (list) + (fslist_data)->link_0.ts_1)
#define ts_shift(list) \
    ((char *) (list) - sizeof(struct fslist_type))

typedef struct miss_type {
    int excess;
    void *list;
} miss_type;

static int miss_post(void *, void *);

static int
miss_post(void *miss, void *node)
{
    int status;
    void *list;

    list = ((struct miss_type *) miss)->list;

    status = x1f4_miss_fspost
	(fs_shift(list, (struct fslist_type *) ts_shift(list)),
	 *(void **) node);
    ((struct miss_type *) miss)->excess = status;

    return status;
}


int
x1f4_miss_fslist(void *fslist, unsigned index)
{
    int status;
    struct miss_type miss;

    miss.list = fslist;

    status = x1f4_clip_tslist(fslist, index, &miss, miss_post);
    if (status) {
    } else {
	status = miss.excess;
    }

    return status;
}
