/*
 * fsvv.3.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <fspost.h>
#include <fsvv-types.h>

#define fs_shift(list, fslist_data) \
    ((char *) (list) + (fslist_data)->link_0.ts_1)
#define ts_shift(list) \
    ((char *) (list) - sizeof(struct fslist_type))

int
x1f4_push_fslist(void *fslist, unsigned index, unsigned size, const char *data,
		 unsigned link, unsigned *miss, void **push)
{
    struct fslist_type *fslist_data;
    void *list;

    list = fslist;

    fslist_data = (void *) ts_shift(list);

    fslist_data->link_2.link = link;
    fslist_data->link_1.miss = miss;
    fslist_data->link_1.push = push;

    fslist_data->link_2.spin = index;

    return x1f4_push_fspost(fs_shift(list, fslist_data), data, size);
}
