/*
 * fsvv.9.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string.h>

#include <fsvv-types.h>
#include <tslist.h>

#define ts_shift(list) \
    ((char *) (list) - sizeof(struct fslist_type))

int
x1f4_next_fslist(void *fslist, void **peek, void **post, void **node,
		 void **base, void *class)
{
    int delete;
    void *data;

    delete = x1f4_next_tslist(&data, (char *) class - sizeof(void *));
    if (delete) {
	*node = *(void **) data;

	data = (void **) data + 1;

	*peek = data;

	data = (char *) data
	    + ((struct fslist_type *) ts_shift(fslist))->link_0.base;

	*base = data;

	*post = (char *) data + strlen(data) + 1;
    }

    return delete;
}
