/*
 * fsxx-types.h
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_fsxx_types_H__
#define __LIBx1f4_fsxx_types_H__

struct fsnode_type;

typedef struct fslist_type {
    struct fsnode_type **fslist;
    unsigned size;
} fslist_type;

typedef struct fsnode_type {
    struct fslist_type fslist;
    struct fsnode_type *fsnode_data;
    unsigned miss, size;
} fsnode_type;

typedef struct fsmiss_type {
    struct fsnode_type fsnode;
} fsmiss_type;

typedef struct screen_type {
    int (*link) (void *, const char *, unsigned, void *);
    struct trans_type *trans_data;
    void *text;
} screen_type;

typedef struct fspost_type {
    struct {
	struct fsmiss_type fsmiss;
    } link_a;
    struct {
	int (*link) (void *, const char *, unsigned, void *);
	void *text;
    } link_c;
    struct {
	int (*free) (void *, void *), (*link) (void *, void **, unsigned),
	    (*mode) (void *, void **, unsigned);
	void *data;
    } link_m;
} fspost_type;

#endif				/* __LIBx1f4_fsxx_types_H__ */
