/*
 * fsxx.4.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string.h>

#include <fsxx-types.h>

static int type_post(struct fsnode_type *, void **);

static int
type_post(struct fsnode_type *fsnode_data, void **data)
{
    struct fsnode_type *uplink_data;

    uplink_data = fsnode_data->fsnode_data;
    if (uplink_data) {
	char *line;
	unsigned size;

	type_post(uplink_data, data);

	line = *data;
	size = fsnode_data->size;
	memcpy(line, fsnode_data + 1, size);
	line += size;
	*line = 0x2f;
	*data = line + 1;
    }

    return 0;
}


int
x1f4_type_fspost(void *fsnode, void **data)
{
    return type_post(fsnode, data);
}
