/*
 * fsxx.6.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <fsxx-types.h>

static int file_post(struct fsnode_type *, unsigned *);

static int
file_post(struct fsnode_type *fsnode_data, unsigned *size)
{
    struct fsnode_type *uplink_data;

    uplink_data = fsnode_data->fsnode_data;
    if (uplink_data) {
	unsigned file;

	file = fsnode_data->size + 1;

	while (1) {
	    fsnode_data = uplink_data->fsnode_data;
	    if (fsnode_data) {
		file += uplink_data->size + 1;
		uplink_data = fsnode_data->fsnode_data;
		if (uplink_data) {
		    file += fsnode_data->size + 1;
		} else {
		    break;
		}
	    } else {
		break;
	    }
	}

	*size += file;
    }

    return 0;
}


int
x1f4_file_fspost(void *fsnode, unsigned *size)
{
    return file_post(fsnode, size);
}
