/*
 * fsxx.7.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <fsxx-types.h>

static int line_post(struct fsnode_type *, void *,
		     int (*) (void *, const char *, unsigned));

static int
line_post(struct fsnode_type *fsnode_data, void *data,
	  int (*type) (void *, const char *, unsigned))
{
    int status;
    struct fsnode_type *uplink_data;

    uplink_data = fsnode_data->fsnode_data;
    if (!uplink_data) {
	status = 0;
    } else {
	status = line_post(uplink_data, data, type);
	if (status) {
	} else {
	    status = type(data, (void *) (fsnode_data + 1), fsnode_data->size);
	    if (status) {
	    } else {
		status = type(data, "/", 1);
	    }
	}
    }

    return status;
}


int
x1f4_line_fspost(void *fsnode, void *data,
		 int (*type) (void *, const char *, unsigned))
{
    return line_post(fsnode, data, type);
}
