/*
 * fsxx.d.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <fsxx-defs.h>
#include <fsxx-types.h>
#include <mask.0.h>
#include <trans.h>

#define fspost(fspost)			((struct fspost_type *) (fspost))

static int init_post(struct fspost_type *);

static int
init_post(struct fspost_type *fspost_data)
{
    int (*link) (void *, void **, unsigned), status;
    void *fslist, *fsnode, *text;

    link = fspost_data->link_m.link;
    text = fspost_data->link_m.data;

    status = link(text, &fsnode, sizeof(struct fsnode_type));
    if (status) {
	status = LINK_ERROR;
    } else {
	status = link(text, &fslist, sizeof(struct fsnode_type *));
	if (status) {
	    status = LINK_ERROR;

	    fspost_data->link_m.free(text, fsnode);
	} else {
	    struct fsnode_type **fsdata, *fsnode_data;

	    fsnode_data = fsnode;

	    fsdata = fslist;

	    fsnode_data->fslist.size = 0;
	    fsnode_data->fsnode_data = &fspost_data->link_a.fsmiss.fsnode;
	    fsnode_data->miss = 1;
	    fsnode_data->size = 0;

	    *fsdata = fsnode_data;

	    fspost_data->link_a.fsmiss.fsnode.fslist.size = 1;
	    fspost_data->link_a.fsmiss.fsnode.fslist.fslist = fslist;
	    fspost_data->link_a.fsmiss.fsnode.miss = 1;
	}
    }

    return status;
}


int
x1f4_fast_fspost(void *fspost, unsigned flags,
		 struct screen_type *screen_data)
{
    int status;

    if (0) {
    } else {
	fspost(fspost)->link_a.fsmiss.fsnode.fsnode_data = NULL;

	if (flags & TRANS_MASK) {
	    struct trans_type *trans_data;

	    trans_data = screen_data->trans_data;

	    fspost(fspost)->link_m.data = trans_data->data;
	    fspost(fspost)->link_m.free = trans_data->free;
	    fspost(fspost)->link_m.link = trans_data->link;
	    fspost(fspost)->link_m.mode = trans_data->mode;
	} else {
	    fspost(fspost)->link_m.free = _libx1f4l2_free_data;
	    fspost(fspost)->link_m.link = _libx1f4l2_link_data;
	    fspost(fspost)->link_m.mode = _libx1f4l2_mode_data;
	}

	if (1) {
	    fspost(fspost)->link_c.link = screen_data->link;
	    fspost(fspost)->link_c.text = screen_data->text;
	}

	status = init_post(fspost);
    }

    return status;
}
