/*
 * tsxx-inter.h
 * Copyright (C) 2008-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#ifndef __LIBx1f4_tsxx_inter_H__
#define __LIBx1f4_tsxx_inter_H__

#include <tsxx-names.h>
#include <tsxx-types.h>

#define _libx1f4l2_fast_tslist		x1f4_fast_tslist
#define _libx1f4l2_fini_tslist		x1f4_fini_tslist
#define _libx1f4l2_flat_tslist		x1f4_flat_tslist
#define _libx1f4l2_init_tslist		x1f4_init_tslist
#define _libx1f4l2_move_tslist		x1f4_move_tslist
#define _libx1f4l2_spin_tslist		x1f4_spin_tslist

extern int _libx1f4l2_away_tslist(void *, void *, int (*) (void *, void *));
extern int _libx1f4l2_back_tslist(void **, void *);
extern int _libx1f4l2_beta_tslist(void *, void *);
extern int _libx1f4l2_case_tslist(void *, unsigned, void *, void **);
extern int _libx1f4l2_ceil_tslist(void *);
extern int _libx1f4l2_dana_tslist(void *, void *);
extern int _libx1f4l2_dawn_tslist
    (void *, void *, void *, int (*) (void *, void *, void *), unsigned);
extern int _libx1f4l2_elif_tslist
    (void *, void *, int (*) (void *, void *), unsigned, unsigned, void **,
     int (*) (void *, unsigned, void **));
extern int _libx1f4l2_else_tslist(void *, unsigned, void **);
extern int _libx1f4l2_fair_tslist(void *, unsigned, void *, unsigned);
extern int _libx1f4l2_fast_tslist(void *, unsigned, struct screen_type *);
extern int _libx1f4l2_fini_tslist(void **);
extern int _libx1f4l2_flat_tslist(void *);
extern int _libx1f4l2_here_tslist(void *, unsigned, void **);
extern int _libx1f4l2_init_tslist(void **, unsigned, struct screen_type *);
extern int _libx1f4l2_lane_tslist(void *, unsigned, unsigned);
extern int _libx1f4l2_late_tslist(void *, void *, int (*) (void *, void *));
extern int _libx1f4l2_lock_tslist(void **, void *);
extern int _libx1f4l2_long_tslist(void *, void *, int (*) (void *, void *));
extern int _libx1f4l2_lose_tslist(void *, unsigned, void **);
extern int _libx1f4l2_nand_tslist
    (void *, unsigned, void *, int (*) (void *, void *));
extern int _libx1f4l2_moon_tslist(void *, unsigned, void *);
extern int _libx1f4l2_move_tslist(void *, unsigned, unsigned);
extern int _libx1f4l2_rail_tslist
    (void *, void *, int (*) (void *, unsigned *, const void *),
     int (*) (void *, void *, const void *), int (*) (void *, void *), void *);
extern int _libx1f4l2_spin_tslist(void *, unsigned, unsigned);
extern int _libx1f4l2_wave_tslist
    (void *, void *, void *, int (*) (void *, void *));

#endif				/* __LIBx1f4_tsxx_inter_H__ */
