/*
 * tsxx.3.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <tsxx-inter.h>
#include <tsxx-names.h>
#include <tsxx-types.h>

#define tslist(tslist)			((struct tslist_type *) (tslist))

static int flow_list(struct fpnode_type *);
static int lock_list(struct fpnode_type *, unsigned *);

static int
flow_list(struct fpnode_type *fpnode_data)
{
    unsigned flow;

    return lock_list(fpnode_data, &flow);
}


static int
lock_list(struct fpnode_type *fpnode_data, unsigned *fast)
{
    int status;

    do {
	unsigned size = 1;

	if (fpnode_data->fqnode.fbnode.bits & LAST_T) {
	} else {
	    unsigned fast;

	    status = lock_list(fpnode_data->fpnode_data[0], &fast);
	    if (status) {
		break;
	    } else {
		size += fast;
	    }
	}

	if (fpnode_data->fqnode.fbnode.bits & NEXT_T) {
	} else {
	    unsigned fast;

	    status = lock_list(fpnode_data->fpnode_data[1], &fast);
	    if (status) {
		break;
	    } else {
		size += fast;
	    }
	}

	if (size == fpnode_data->fqnode.size) {
	    status = 0;

	    *fast = size;
	} else {
	    status = 2;
	}
    } while (0);

    return status;
}


int
x1f4_flow_tslist(void *tslist)
{
    int status;
    struct fpnode_type *fpnode_data;

    fpnode_data = tslist(tslist)->link_a.fplist.fplink.fpnode_data[0];
    if (!fpnode_data) {
	if (tslist(tslist)->link_a.fplist.fplink.fqnode.size) {
	    status = 1;
	} else {
	    status = 0;
	}
    } else {
	status = flow_list(fpnode_data);
    }

    return status;
}
