/*
 * tsxx.7.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <tsxx-inter.h>
#include <tsxx-names.h>
#include <tsxx-types.h>

#define __DEEP_NODE__			1
#define __NEXT_NODE__			2

#define __LIME_NODE__			__DEEP_NODE__

#define ____LIME_NODE__			__LIME_NODE__

#define __UNBALANCED__			1

#define Delete				0

#define tslist(tslist)			((struct tslist_type *) (tslist))

#if ____LIME_NODE__ == __NEXT_NODE__
static int back_list(struct tslist_type *, void *, int (*) (void *, void *));
#endif				/* ____LIME_NODE__ == __NEXT_NODE__ */
static int back_node(struct fpnode_type *, void *, int (*) (void *, void *));

#if ____LIME_NODE__ == __NEXT_NODE__
static int
back_list(struct tslist_type *tslist_data, void *back,
	  int (*call) (void *, void *))
{
    void *tsnode;

    _libx1f4l2_else_tslist(tslist_data, 0, &tsnode);

    return back_node(tsnode, back, call);
}
#endif				/* ____LIME_NODE__ == __NEXT_NODE__ */


#if ____LIME_NODE__ == __DEEP_NODE__
static int
back_node(struct fpnode_type *fpnode_data, void *back,
	  int (*call) (void *, void *))
{
    int delete;

    do {
	if (fpnode_data->fqnode.fbnode.bits & LAST_T) {
	} else {
# if __UNBALANCED__
	    struct fpnode_type *fqnode_data;
# endif				/* __UNBALANCED__ */

# if __UNBALANCED__
	    fqnode_data = fpnode_data->fpnode_data[0];
# endif				/* __UNBALANCED__ */

# if __UNBALANCED__
	    if (fqnode_data->fqnode.fbnode.bits & LAST_T) {
	    } else {
		delete = back_node(fqnode_data->fpnode_data[0], back, call);
		if (delete) {
		    break;
		}
	    }
# endif				/* __UNBALANCED__ */

# if __UNBALANCED__
	    if (1) {
		delete = call(back, fqnode_data + 1);
		if (delete) {
		    break;
		}
	    }
# else
	    delete = back_node(fpnode_data->fpnode_data[0], back, call);
	    if (delete) {
		break;
	    }
# endif				/* __UNBALANCED__ */

# if __UNBALANCED__
	    if (fqnode_data->fqnode.fbnode.bits & NEXT_T) {
	    } else {
		delete = back_node(fqnode_data->fpnode_data[1], back, call);
		if (delete) {
		    break;
		}
	    }
# endif				/* __UNBALANCED__ */
	}

	if (1) {
	    delete = call(back, fpnode_data + 1);
	    if (delete) {
		break;
	    }
	}

	if (fpnode_data->fqnode.fbnode.bits & NEXT_T) {
	} else {
	    delete = back_node(fpnode_data->fpnode_data[1], back, call);
	    if (Delete) {
		break;
	    }
	}
    } while (0);

    return delete;
}
#endif				/* ____LIME_NODE__ == __DEEP_NODE__ */


#if ____LIME_NODE__ == __NEXT_NODE__
static int
back_node(struct fpnode_type *fpnode_data, void *back,
	  int (*call) (void *, void *))
{
    int delete;

    while (1) {
	delete = call(back, fpnode_data + 1);
	if (delete) {
	    break;
	}

	if (fpnode_data->fqnode.fbnode.bits & NEXT_T) {
	    fpnode_data = fpnode_data->fpnode_data[1];
	    if (!fpnode_data) {
		delete = 0;

		break;
	    }
	} else {
	    fpnode_data = fpnode_data->fpnode_data[1];
	    while (1) {
		if (fpnode_data->fqnode.fbnode.bits & LAST_T) {
		    break;
		} else {
		    fpnode_data = fpnode_data->fpnode_data[0];
		    if (fpnode_data->fqnode.fbnode.bits & LAST_T) {
			break;
		    } else {
			fpnode_data = fpnode_data->fpnode_data[0];
		    }
		}
	    }
	}
    }

    return delete;
}
#endif				/* ____LIME_NODE__ == __NEXT_NODE__ */


int
x1f4_lime_tslist(void *tslist, void *back, int (*call) (void *, void *))
{
    int delete;
#if ____LIME_NODE__ == __DEEP_NODE__
    struct fpnode_type *fpnode_data;
#endif				/* ____LIME_NODE__ == __DEEP_NODE__ */

#if ____LIME_NODE__ == __DEEP_NODE__
    fpnode_data = tslist(tslist)->link_a.fplist.fplink.fpnode_data[0];
#endif				/* ____LIME_NODE__ == __DEEP_NODE__ */

#if ____LIME_NODE__ == __DEEP_NODE__
    if (fpnode_data) {
	delete = back_node(fpnode_data, back, call);
    } else {
	delete = 0;
    }
#elif __LIME_NODE__ == __NEXT_NODE__
    if (tslist(tslist)->link_a.fplist.fplink.fqnode.size) {
	delete = back_list(tslist, back, call);
    } else {
	delete = 0;
    }
#endif				/* ____LIME_NODE__ == __DEEP_NODE__ */

    return delete;
}
