/*
 * tsxx.9.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <tsxx-defs.h>
#include <tsxx-inter.h>
#include <tsxx-names.h>
#include <tsxx-types.h>

#define tslist(tslist)			((struct tslist_type *) (tslist))

static int fast_list(struct tslist_type *, unsigned, unsigned);

static int
fast_list(struct tslist_type *tslist_data, unsigned index, unsigned class)
{
    int status;
    void *tsnode;

    status = _libx1f4l2_lose_tslist(tslist_data, index, &tsnode);
    if (status) {
    } else {
	if (index < class) {
	    class--;
	}

	status = _libx1f4l2_moon_tslist(tslist_data, class, tsnode);
	if (status) {
	    /*
	     * TODO/FEATURES
	     *
	     * some leakage here...
	     */
	}
    }

    return status;
}


int
x1f4_move_tslist(void *tslist, unsigned index, unsigned class)
{
    int status;
    unsigned count;

    count = tslist(tslist)->link_a.fplist.fplink.fqnode.size;

    if (!(index < count)) {
	status = DECK_ERROR;
    } else {
	if (count < class) {
	    status = DECK_ERROR;
	} else {
	    if (index == class) {
		status = 0;
	    } else {
		if (index + 1 == class) {
		    status = 0;
		} else {
		    status = fast_list(tslist, index, class);
		}
	    }
	}
    }

    return status;
}
