/*
 * tsxx.a.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <tsxx-inter.h>
#include <tsxx-names.h>
#include <tsxx-types.h>

#define tslist(tslist)			((struct tslist_type *) (tslist))

static int deck_list(struct tslist_type *, unsigned, unsigned);
static int ever_list(struct tslist_type *, unsigned, unsigned);

static int
deck_list(struct tslist_type *tslist_data, unsigned index, unsigned count)
{
    int status;

    do {
	status = _libx1f4l2_move_tslist(tslist_data, 0, count);
	if (status) {
	    break;
	} else {
	    index--;
	}
    } while (index);

    return status;
}


static int
ever_list(struct tslist_type *tslist_data, unsigned index, unsigned count)
{
    int status;

    index = count - index;

    --count;

    do {
	status = _libx1f4l2_move_tslist(tslist_data, count, 0);
	if (status) {
	    break;
	} else {
	    index--;
	}
    } while (index);

    return status;
}


int
x1f4_deck_tslist(void *tslist, int class)
{
    int status;
    unsigned count;

    count = tslist(tslist)->link_a.fplist.fplink.fqnode.size;

    if (!count) {
	status = 0;
    } else {
	class %= (int) count;
	if (!class) {
	    status = 0;
	} else {
	    if (class < 0) {
		class += count;
	    }

	    if (class << 1 < count) {
		status = deck_list(tslist, class, count);
	    } else {
		status = ever_list(tslist, class, count);
	    }
	}
    }

    return status;
}
