/*
 * tsxx.e.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <tsxx-defs.h>
#include <tsxx-inter.h>
#include <tsxx-names.h>
#include <tsxx-types.h>

#define tslist(tslist)			((struct tslist_type *) (tslist))

static int wind_list(struct tslist_type *, unsigned, struct tslist_type *,
		     unsigned);

static int
wind_list(struct tslist_type *tslist_data, unsigned index,
	  struct tslist_type *tslist_text, unsigned class)
{
    int status;
    void *tsnode;

    status = _libx1f4l2_lose_tslist(tslist_data, index, &tsnode);
    if (status) {
    } else {
	tslist_data->link_a.fplist.fplink.fqnode.size--;

	status = _libx1f4l2_moon_tslist(tslist_text, class, tsnode);
	if (status) {
	    /*
	     * TODO/FEATURES
	     *
	     * some leakage here...
	     */
	} else {
	    tslist_text->link_a.fplist.fplink.fqnode.size++;
	}
    }

    return status;
}


int
x1f4_wind_tslist(void *tsdata, unsigned index, void *tstext, unsigned class)
{
    int status;

    if (tsdata == tstext) {
	status = _libx1f4l2_move_tslist(tsdata, index, class);
    } else {
	if (!(index < tslist(tsdata)->link_a.fplist.fplink.fqnode.size)) {
	    status = DECK_ERROR;
	} else {
	    if (tslist(tstext)->link_a.fplist.fplink.fqnode.size < class) {
		status = DECK_ERROR;
	    } else {
		status = wind_list(tsdata, index, tstext, class);
	    }
	}
    }

    return status;
}
