/*
 * tsxx.r.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <tsxx-inter.h>
#include <tsxx-names.h>
#include <tsxx-types.h>

#define tsnode(tsnode)			((struct fpnode_type *) (tsnode))

#define tslist(tslist)			((struct tslist_type *) (tslist))

int
_libx1f4l2_fair_tslist(void *tcdata, unsigned index, void *tctext,
		       unsigned order)
{
    struct fpnode_type *fpnode_data, *fqnode_data, *fxnode_data, *fznode_data;
    unsigned fast = 0, tilt = 0;

    fpnode_data = tslist(tcdata)->link_a.fplist.fplink.fpnode_data[0];
    fqnode_data = &tslist(tcdata)->link_a.fplist.fplink;

    while (1) {
	unsigned class;

	class = fpnode_data->fqnode.size;
	if (class == 1) {
	    break;
	} else {
	    if (fpnode_data->fqnode.fbnode.bits & LAST_T) {
		if (!index) {
		    break;
		} else {
		    if (0) {
		    } else {
			index--;
			tilt = 1;
		    }
		}
	    } else {
		struct fpnode_type *fpnode_miss;
		unsigned Class;

		fpnode_miss = fpnode_data->fpnode_data[0];
		Class = fpnode_miss->fqnode.size;
		if (Class == index) {
		    break;
		} else {
		    if (index < Class) {
			tilt = 0;
		    } else {
			index -= Class + 1;
			tilt = 1;
		    }
		}
	    }
	}

	fqnode_data = fpnode_data;

	fpnode_data = fpnode_data->fpnode_data[tilt];
    }

    fxnode_data = tslist(tctext)->link_a.fplist.fplink.fpnode_data[0];
    fznode_data = &tslist(tctext)->link_a.fplist.fplink;

    while (1) {
	unsigned class;

	class = fxnode_data->fqnode.size;
	if (class == 1) {
	    break;
	} else {
	    if (fxnode_data->fqnode.fbnode.bits & LAST_T) {
		if (!order) {
		    break;
		} else {
		    if (0) {
		    } else {
			order--;
			fast = 1;
		    }
		}
	    } else {
		struct fpnode_type *fxnode_miss;
		unsigned Class;

		fxnode_miss = fxnode_data->fpnode_data[0];
		Class = fxnode_miss->fqnode.size;
		if (Class == order) {
		    break;
		} else {
		    if (order < Class) {
			fast = 0;
		    } else {
			order -= Class + 1;
			fast = 1;
		    }
		}
	    }
	}

	fznode_data = fxnode_data;

	fxnode_data = fxnode_data->fpnode_data[fast];
    }

    if (1) {
	void *f0node, *f1node, *f2node, *f3node;

	if (_libx1f4l2_back_tslist(&f0node, fpnode_data)) {
	} else {
	    f0node = NULL;
	}
	if (_libx1f4l2_back_tslist(&f2node, fxnode_data)) {
	} else {
	    f2node = NULL;
	}
	if (_libx1f4l2_lock_tslist(&f1node, fpnode_data)) {
	} else {
	    f1node = NULL;
	}
	if (_libx1f4l2_lock_tslist(&f3node, fxnode_data)) {
	} else {
	    f3node = NULL;
	}
	if (f0node) {
	    if (tsnode(f0node)->fqnode.fbnode.bits & NEXT_T) {
		tsnode(f0node)->fpnode_data[1] = fxnode_data;
	    }
	}
	if (f1node) {
	    if (tsnode(f1node)->fqnode.fbnode.bits & LAST_T) {
		tsnode(f1node)->fpnode_data[0] = fxnode_data;
	    }
	}
	if (f2node) {
	    if (tsnode(f2node)->fqnode.fbnode.bits & NEXT_T) {
		tsnode(f2node)->fpnode_data[1] = fpnode_data;
	    }
	}
	if (f3node) {
	    if (tsnode(f3node)->fqnode.fbnode.bits & LAST_T) {
		tsnode(f3node)->fpnode_data[0] = fpnode_data;
	    }
	}
    }

    fqnode_data->fpnode_data[tilt] = fxnode_data;

    fznode_data->fpnode_data[fast] = fpnode_data;

    if (1) {
	struct fpnode_type fpnode_class;

	fpnode_class = *fpnode_data;
	*fpnode_data = *fxnode_data;
	*fxnode_data = fpnode_class;
    }

    return 0;
}
