/*
 * tsxx.t.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <tsxx-defs.h>
#include <tsxx-names.h>
#include <tsxx-types.h>

#define tslist(tslist)			((struct tslist_type *) (tslist))

static int free_node(struct fpnode_type *, void *, int (*) (void *, void *),
		     void *, int (*) (void *, void *));

static int
free_node(struct fpnode_type *fpnode_data, void *back,
	  int (*call) (void *, void *), void *data,
	  int (*free) (void *, void *))
{
    int status;

    do {
	if (fpnode_data->fqnode.fbnode.bits & LAST_T) {
	} else {
	    status = free_node
		(fpnode_data->fpnode_data[0], back, call, data, free);
	    if (status) {
		break;
	    }
	}

	if (fpnode_data->fqnode.fbnode.bits & NEXT_T) {
	} else {
	    status = free_node
		(fpnode_data->fpnode_data[1], back, call, data, free);
	    if (status) {
		fpnode_data->fpnode_data[0] = NULL;

		fpnode_data->fqnode.fbnode.bits |= LAST_T;

		break;
	    }
	}

	if (1) {
	    status = call(back, fpnode_data + 1);
	    if (status) {
		status = CALL_ERROR;

		fpnode_data->fpnode_data[0] = NULL;
		fpnode_data->fpnode_data[1] = NULL;

		fpnode_data->fqnode.fbnode.bits |= LAST_T | NEXT_T;

		break;
	    }
	}

	if (1) {
	    status = free(data, fpnode_data);
	    if (status) {
		status = FREE_ERROR;

		fpnode_data->fpnode_data[0] = NULL;
		fpnode_data->fpnode_data[1] = NULL;

		fpnode_data->fqnode.fbnode.bits |= LAST_T | NEXT_T;
	    }
	}
    } while (0);

    return status;
}


int
_libx1f4l2_late_tslist(void *tslist, void *back, int (*call) (void *, void *))
{
    int status;
    struct fpnode_type *fpnode_data;

    fpnode_data = tslist(tslist)->link_a.fplist.fplink.fpnode_data[0];
    if (fpnode_data) {
	status = free_node
	    (fpnode_data, back, call, tslist(tslist)->link_m.data,
	     tslist(tslist)->link_m.free);
	if (status) {
	} else {
	    tslist(tslist)->link_a.fplist.fplink.fpnode_data[0] = NULL;
	    tslist(tslist)->link_a.fplist.fplink.fqnode.size = 0;
	}
    } else {
	status = 0;
    }

    return status;
}
