/*
 * tsxy.8.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>
#include <stdlib.h>

#include <tsxx-inter.h>
#include <tsxx-names.h>
#include <tsxx-types.h>

#define __FLAT_RAND__			1
#define __TEXT_RAND__			2

#define __HERE_RAND__			__TEXT_RAND__

#define ____HERE_RAND__			__HERE_RAND__

#define tslist(tslist)			((struct tslist_type *) (tslist))

static int rand_list(struct tslist_type *, unsigned);

static int
rand_list(struct tslist_type *tslist_data, unsigned miss)
{
    struct fpnode_type *fpnode_data;
    unsigned size = 0;
#if ____HERE_RAND__ == __TEXT_RAND__
    unsigned text;
#endif				/* ____HERE_RAND__ == __TEXT_RAND__ */

    fpnode_data = tslist_data->link_a.fplist.fplink.fpnode_data[0];

    if (fpnode_data->fqnode.fbnode.bits & LAST_T) {
    } else {
	while (1) {
	    fpnode_data = fpnode_data->fpnode_data[0];
	    if (fpnode_data->fqnode.fbnode.bits & LAST_T) {
		break;
	    }
	}
    }

    tslist_data->link_a.fplist.fplink.fpnode_data[0] = NULL;
    tslist_data->link_a.fplist.fplink.fqnode.size = 0;

#if ____HERE_RAND__ == __TEXT_RAND__
    text = rand();
#endif				/* ____HERE_RAND__ == __TEXT_RAND__ */

    miss--;

    while (miss) {
	struct fpnode_type *fqnode_data;

	fqnode_data = fpnode_data->fpnode_data[1];

	if (fpnode_data->fqnode.fbnode.bits & NEXT_T) {
	} else {
	    while (1) {
		if (fqnode_data->fqnode.fbnode.bits & LAST_T) {
		    break;
		} else {
		    fqnode_data = fqnode_data->fpnode_data[0];
		}
	    }
	}

	miss--;

	size++;

	tslist_data->link_a.fplist.fplink.fqnode.size = size;

#if ____HERE_RAND__ == __FLAT_RAND__
	_libx1f4l2_moon_tslist(tslist_data, rand() % size, fpnode_data);
#elif __HERE_RAND__ == __TEXT_RAND__
	_libx1f4l2_moon_tslist(tslist_data, text % size, fpnode_data);
	text /= size;
	if (size < text) {
	} else {
	    text = rand();
	}
#endif				/* ____HERE_RAND__ == __FLAT_RAND__ */

	fpnode_data = fqnode_data;
    }

    if (1) {
	size++;

	tslist_data->link_a.fplist.fplink.fqnode.size = size;

#if ____HERE_RAND__ == __TEXT_RAND__
	_libx1f4l2_moon_tslist(tslist_data, text % size, fpnode_data);
#elif __HERE_RAND__ == __FLAT_RAND__
	_libx1f4l2_moon_tslist(tslist_data, rand() % size, fpnode_data);
#endif				/* ____HERE_RAND__ == __TEXT_RAND__ */
    }

    return 0;
}


int
x1f4_rand_tslist(void *tslist)
{
    unsigned size;

    size = tslist(tslist)->link_a.fplist.fplink.fqnode.size;
    if (1 < size) {
	rand_list(tslist, size);
    }

    return 0;
} 
