/*
 * tsxy.d.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <tsxx-names.h>
#include <tsxx-types.h>

#define WAY_L(fpnode_data) \
    ((fpnode_data)->fqnode.fbnode.bits & LAST_T)
#define WAY_N(fpnode_data) \
    ((fpnode_data)->fqnode.fbnode.bits & NEXT_T)

#define tslist(tslist)			((struct tslist_type *) (tslist))

static int seek_list(void *, void *, unsigned, int (*) (void *, void *),
		     unsigned *);

static int
seek_list(void *tslist, void *text, unsigned offset,
	  int (*land) (void *, void *), unsigned *seek)
{
    int delete;
    struct fpnode_type *fpnode_data;
    unsigned left = 0;

    offset += sizeof(struct fpnode_type);

    fpnode_data = tslist(tslist)->link_a.fplist.fplink.fpnode_data[0];
    while (1) {
	int slip;

	slip = land(text, (char *) fpnode_data + offset);
	if (!slip) {
	    delete = 1;

	    if (WAY_L(fpnode_data)) {
	    } else {
		left += fpnode_data->fpnode_data[0]->fqnode.size;
	    }

	    *seek = left;

	    break;
	} else {
	    if (slip < 0) {
		if (WAY_L(fpnode_data)) {
		    delete = 0;
		    if (1) {
			break;
		    }
		} else {
		    fpnode_data = fpnode_data->fpnode_data[0];
		}
	    } else {
		if (WAY_N(fpnode_data)) {
		    delete = 0;
		    if (1) {
			break;
		    }
		} else {
		    left++;
		    if (WAY_L(fpnode_data)) {
		    } else {
			left += fpnode_data->fpnode_data[0]->fqnode.size;
		    }

		    fpnode_data = fpnode_data->fpnode_data[1];
		}
	    }
	}
    }

    return delete;
}


int
x1f4_seek_tslist(void *tslist, void *text, unsigned slip,
		 int (*land) (void *, void *), unsigned *seek)
{
    int delete;

    if (tslist(tslist)->link_a.fplist.fplink.fqnode.size) {
	delete = seek_list(tslist, text, slip, land, seek);
    } else {
	delete = 0;
    }

    return delete;
}
