/*
 * tsxy.f.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <tsxx-inter.h>
#include <tsxx-names.h>
#include <tsxx-types.h>

#define tslist(tslist)			((struct tslist_type *) (tslist))

static int sort_list(struct tslist_type *, unsigned, void *, unsigned,
		     int (*) (void *, void *, void *));

static int
sort_list(struct tslist_type *tslist_data, unsigned miss, void *text,
	  unsigned slip, int (*land) (void *, void *, void *))
{
    struct fpnode_type *fpnode_data;
    unsigned size = 0;

    fpnode_data = tslist_data->link_a.fplist.fplink.fpnode_data[0];

    if (fpnode_data->fqnode.fbnode.bits & LAST_T) {
    } else {
	while (1) {
	    fpnode_data = fpnode_data->fpnode_data[0];
	    if (fpnode_data->fqnode.fbnode.bits & LAST_T) {
		break;
	    }
	}
    }

    tslist_data->link_a.fplist.fplink.fpnode_data[0] = NULL;
    tslist_data->link_a.fplist.fplink.fqnode.size = 0;

    slip += sizeof(struct fpnode_type);

    miss--;

    while (miss) {
	struct fpnode_type *fqnode_data;

	fqnode_data = fpnode_data->fpnode_data[1];

	if (fpnode_data->fqnode.fbnode.bits & NEXT_T) {
	} else {
	    while (1) {
		if (fqnode_data->fqnode.fbnode.bits & LAST_T) {
		    break;
		} else {
		    fqnode_data = fqnode_data->fpnode_data[0];
		}
	    }
	}

	miss--;

	size++;

	tslist_data->link_a.fplist.fplink.fqnode.size = size;

	_libx1f4l2_dawn_tslist(tslist_data, fpnode_data, text, land, slip);

	fpnode_data = fqnode_data;
    }

    if (1) {
	size++;

	tslist_data->link_a.fplist.fplink.fqnode.size = size;

	_libx1f4l2_dawn_tslist(tslist_data, fpnode_data, text, land, slip);
    }

    return 0;
}


int
x1f4_sort_tslist(void *tslist, void *text, unsigned slip,
		 int (*land) (void *, void *, void *))
{
    unsigned size;

    size = tslist(tslist)->link_a.fplist.fplink.fqnode.size;
    if (1 < size) {
	sort_list(tslist, size, text, slip, land);
    }

    return 0;
} 
