/*
 * cards.c
 * Copyright (C) 2002-2007, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

int
x1f4_match_cards(const char *major, unsigned major_length, const char *minor,
		 unsigned minor_length, char *buffer)
{
    for (; major_length; major_length--) {
	if (*major == '*') {
	    char *my_buffer;
	    int ing;
	    unsigned escaped_length, length;

	    for (; *major == '*' && major_length; major++, major_length--);
	    for (my_buffer = buffer, length = major_length;
		 length && *major != '*' && *major != '?'; length--) {
		if (*major == '\\') {
		    major++;
		    length--;
		    if (!*major) {
			return (unsigned) ~0 >> 1;
		    }
		}
		*my_buffer++ = *major++;
	    }
	    length = major_length - length;
	    if (!length) {
		return 0;
	    } else {
		if (!minor_length) {
		    return -(int) major_length;
		}
	    }
	    escaped_length = my_buffer - buffer;
	    ing = minor_length;
	    major -= length;
	    while (escaped_length < minor_length + 1) {
		if (!x1f4_match_cards
		    (major, major_length, minor, minor_length, my_buffer)) {
		    return 0;
		}
		minor++;
		minor_length--;
	    }

	    return ing;
	} else if (*major == '?') {
	    if (!minor_length) {
		return -(int) major_length;
	    }
	    major++;
	    minor++;
	    minor_length--;
	} else {
	    if (!minor_length) {
		return -(int) major_length;
	    }
	    if (*major == '\\') {
		major++;
		major_length--;
		if (!*major) {
		    return (unsigned) ~0 >> 1;
		}
	    }
	    if (*major == *minor) {
		major++;
		minor++;
		minor_length--;
	    } else {
		return minor_length;
	    }
	}
    }

    return minor_length;
}
