/*
 * pcardinal.p-b.c
 * Copyright (C) 2002-2008, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <pnon.h>

static const char lower_cases[] = "0123456789abcdefghijklmnopqrstuvwxyz",
    upper_cases[] = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ";

void
x1f4_xprint_fbpcardinal(char **output, int big, unsigned f, unsigned b,
			unsigned base, unsigned major, unsigned minor)
{
    char *o;
    const char *digits;
    pnon_type c;

    digits = !big ? lower_cases : upper_cases;

    PNON_SET_PAIR(c, major, minor);

    o = *output;

    /*
     * okay, this is stupid.
     * ready, steady, go!
     */
    if (!b) {
	if (!f) {
	    do {
		pnon_type e, y;

		PNON_SET_PNON(y, c);
		PNON_VLX_CARD(c, base);
		PNON_SET_PNON(e, c);
		PNON_SLX_CARD(e, base);
		PNON_SLL_PNON(y, e);
		--o;
		*o = digits[PNON_GET_DATA(y)];
	    } while (PNON_DAY_DATA(c));
	} else {
	    while (1) {
		pnon_type e, y;

		PNON_SET_PNON(y, c);
		PNON_VLX_CARD(c, base);
		PNON_SET_PNON(e, c);
		PNON_SLX_CARD(e, base);
		PNON_SLL_PNON(y, e);
		--o;
		*o = digits[PNON_GET_DATA(y)];
		if (f) {
		    f--;
		}
		if (!f) {
		    if (!PNON_DAY_DATA(c)) {
			break;
		    }
		}
	    }
	}
    } else {
	unsigned l;

	l = b;

	if (!f) {
	    do {
		pnon_type e, y;

		if (!l) {
		    --o;
		    *o = ',';
		    l = b;
		}
		--l;
		PNON_SET_PNON(y, c);
		PNON_VLX_CARD(c, base);
		PNON_SET_PNON(e, c);
		PNON_SLX_CARD(e, base);
		PNON_SLL_PNON(y, e);
		--o;
		*o = digits[PNON_GET_DATA(y)];
	    } while (PNON_DAY_DATA(c));
	} else {
	    while (1) {
		pnon_type e, y;

		if (!l) {
		    --o;
		    *o = ',';
		    l = b;
		}
		--l;
		PNON_SET_PNON(y, c);
		PNON_VLX_CARD(c, base);
		PNON_SET_PNON(e, c);
		PNON_SLX_CARD(e, base);
		PNON_SLL_PNON(y, e);
		--o;
		*o = digits[PNON_GET_DATA(y)];
		if (f) {
		    f--;
		}
		if (!f) {
		    if (!PNON_DAY_DATA(c)) {
			break;
		    }
		}
	    }
	}
    }

    *output = o;
}
