/*
 * printf6.h
 * Copyright (C) 2004-2008, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __LIBx1f4_PRINTF6_H__
#define __LIBx1f4_PRINTF6_H__

#include <stdio.h>

#define X1f4_FORMAT_ALTERNATE		(1 << 0x10)
#define X1f4_FORMAT_INDEXED		(1 << 0x11)
#define X1f4_FORMAT_UNINDEXED		(1 << 0x12)

#define X1f4_FORMAT_ITERATE		(1 << 0x13)

#define X1f4_FORMAT_DETAILED		(1 << 0x14)

typedef struct x1f4_efield_type {
    const char *description;
    const struct x1f4_efield_type *efield_data;
    unsigned (*count_field) (void *, unsigned), flags, index;
    void (*put_field) (void *, unsigned);
} x1f4_efield_type;

typedef struct x1f4_f6link_type {
   unsigned (*count_string) (void *, char *, unsigned);
   void (*put_space) (void *, unsigned, char *, unsigned),
	(*put_string) (void *, char *, unsigned),
	(*set_index) (void *, unsigned), (*set_scope) (void *, unsigned),
	(*get_scope) (void *, unsigned);
} x1f4_f6link_type;

typedef struct x1f4_ffield_type {
    const char *description;
    const struct x1f4_efield_type *efield_data;
    unsigned (*count_field) (void *, unsigned), flags, index;
    void (*put_field) (void *, unsigned);
} x1f4_ffield_type;

typedef void *x1f4_format_type;

extern int x1f4_parse_format6
    (x1f4_format_type *, const struct x1f4_ffield_type *,
     const struct x1f4_f6link_type *, const char *);

extern void x1f4_detail_format6(x1f4_format_type, unsigned *, unsigned **);
extern void x1f4_free_format6(x1f4_format_type *);
extern void x1f4_lprint_ffields6(FILE *, const struct x1f4_ffield_type *);
extern void x1f4_pprint_ffields6(FILE *, const struct x1f4_ffield_type *);
extern void x1f4_print_format6(FILE *, x1f4_format_type);
extern void x1f4_run_format6(x1f4_format_type, void *);
extern void x1f4_tprint_ffields6(FILE *, const struct x1f4_ffield_type *);

#endif				/* __LIBx1f4_PRINTF6_H__ */
