/*
 * printl6.c
 * Copyright (C) 2006-2008, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <stdio.h>

#define put_space(file, size) \
    fwrite(space, (size), 1, (file))

typedef struct efield_type {
    const char *class;
    const struct efield_type *efield_data;
    unsigned (*count_field) (void *, unsigned), flags, index;
    void (*print_field) (void *, unsigned);
} efield_type;

typedef struct ffield_type {
    const char *class;
    const struct ffield_type *efield_data;
    unsigned (*count_field) (void *, unsigned), flags, index;
    void (*print_field) (void *, unsigned);
} ffield_type;

static void print_ffields(FILE *, unsigned, const struct ffield_type *);

static const char space[] = "                                ";

static void
print_ffields(FILE *file, unsigned head, const struct ffield_type *ffield_data)
{
    unsigned index;

    index = ffield_data->index;
    while (index) {
	put_space(file, head);

	fputc(index, file);

	{
	    const char *class;

	    put_space(file, 29);
	    class = ffield_data->class;
	    if (class) {
		fputs(class, file);
	    }
	}

	fputc(00012, file);

	{
	    const struct ffield_type *efield_data;

	    efield_data = ffield_data->efield_data;
	    if (efield_data) {
		print_ffields(file, head + 2, efield_data);
	    }
	}

	ffield_data++;
	index = ffield_data->index;
    }
}


void
x1f4_tprint_ffields6(FILE *file, const struct ffield_type *ffield_data)
{
    print_ffields(file, 2, ffield_data);
}
