/*
 * access.h
 * Copyright (C) 2005-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __Mylene1f4_ACCESS_H__
#define __Mylene1f4_ACCESS_H__

#include <config.h>

#include <state.h>

#define ALBUM(context)			ACCESS((context), text).album
#define ATIME(context)			ACCESS((context), time)
#define AUDIO(context)			ACCESS((context), audio)
#define BACKSEEK(context) \
    ACCESS((context), no_backward_seek_complaints)
#define BECCA(context)			ACCESS((context), becca)
#if __NEAR_LINK_BITS__
# define BITS(context)			ACCESS((context), bits)
#endif				/* __NEAR_LINK_BITS__ */
#define C1f4(context)			ACCESS((context), e1f4_index)
#define CACHE(context)			ACCESS((context), cache_size)
#define CHANNELS(context)		ACCESS((context), channels)
#define CLASS(context)			ACCESS((context), class)
#define CLAUSE(context)			ACCESS((context), clause_data)
#define CLEAR(context)			ACCESS((context), do_clear)
#define CLIP(context)			ACCESS((context), clip)
#define COMPLETED(context)		ACCESS((context), completed)
#define COUNT(context)			ACCESS((context), count)
#define DEVICE(context)			ACCESS((context), device)
#define DRIVER(context)			ACCESS((context), driver_data)
#if __ENABLE_FILTER__
# define E4DECK(context)		ACCESS((context), e4deck)
# define E4LINE(context)		ACCESS((context), e4line)
#endif				/* __ENABLE_FILTER__ */
#if __LINK_CELL_A52A_LOADER__
# define EA52AL(context)		ACCESS((context), ea52al)
#endif				/* __LINK_CELL_A52A_LOADER__ */
#define EID3WL(context)			ACCESS((context), eid3wl)
#if __ENABLE_x00696e6b__
# define ENTRY2(context)		ACCESS((context), audio_entry)
#endif				/* __ENABLE_x00696e6b__ */
#define EPRINTF(context)		ACCESS((context), printf_error)
#define EXCESS(context)			ACCESS((context), excess)
#define EXTRA(context)			ACCESS((context), flags)
#define FILTER(context)			ACCESS((context), filter)
#define FINI(context)			ACCESS((context), patch_64)
#define FLAGS(context)			ACCESS((context), flags)
#define GROUND(context)			ACCESS((context), ground)
#define HEAD(context)			ACCESS((context), head)
#define ID3T(context)			ACCESS((context), id3t)
#define ID3W(context)			ACCESS((context), id3w)
#define ID3X(context)			ACCESS((context), id3x)
#define INIT(context)			ACCESS((context), patch_32)
#define INPUT(context)			ACCESS((context), input)
#define INCOMING(context)		ACCESS((context), incoming)
#define L1f4(context)			ACCESS((context), line_index)
#define LBASE(context)			ACCESS((context), text).lbase
#define LINE(context)			ACCESS((context), line_out)
#define LINK(context)			ACCESS((context), link)
#define LOADER(context)			ACCESS((context), loader)
#define LOAD_ORDER(context)		ACCESS((context), load_order)
#define LPATH(context)			ACCESS((context), text).lpath
#define MATCH(context)			ACCESS((context), text).match
#define MIRROR(context)			ACCESS((context), mirror)
#define MODE(context)			ACCESS((context), mode)
#define MPEG(context)			ACCESS((context), mpeg)
#define Mylene1ST(context)		ACCESS((context), fd_0)
#define Mylene1f4(context)		ACCESS((context), Mylene1f4)
#define Mylene2ND(context)		ACCESS((context), fd_1)
#define NOTES(context)			ACCESS((context), text).notes
#define OUTGOING(context)		ACCESS((context), outgoing)
#define OUTPUT(context)			ACCESS((context), output)
#define OUTPUT_SIZE(context)		ACCESS((context), output_size)
#define PID(context)			ACCESS((context), pid)
#define PLAY(context)			ACCESS((context), play)
#define PRINTER(context)		ACCESS((context), printer_data)
#define PROGRESS(context)		ACCESS((context), progress)
#define PROGRESS1(context)		ACCESS((context), progress1)
#define PROGRESS2(context)		ACCESS((context), progress2)
#define PROGRESS3(context)		ACCESS((context), progress3)
#define RECORD(context)			ACCESS((context), record_data)
#define REFERENCE(context)		ACCESS((context), temporal_reference)
#define RELEASE(context)		ACCESS((context), audio_release_size)
#define REPEAT(context)			ACCESS((context), do_repeat)
#if __RESTART_Mylene0fa__
# define RESTARTS(context)		ACCESS((context), restarts)
#endif				/* __RESTART_Mylene0fa__ */
#define SAMPLING(context)		ACCESS((context), sampling_frequency)
#define SELECT(context)			ACCESS((context), select)
#define SEQUEL(context)			ACCESS((context), sequel_data)
#define SHMID(context)			ACCESS((context), shmid)
#define SIGCHLD_handler(context)	ACCESS((context), SIGCHLD_handler)
#define SIGCHLD_received(context)	ACCESS((context), SIGCHLD_received)
#define SIZE(context)			ACCESS((context), size)
#define SLACK(context)			ACCESS((context), text).slack
#if __RESTART_Mylene0fa__
# define SLIDE(context)			ACCESS((context), restarts_count)
#endif				/* __RESTART_Mylene0fa__ */
#define SOURCE(context)			ACCESS((context), source)
#define START(context)			ACCESS((context), start)
#define START2(context)			ACCESS((context), pickup).page
#define START3(context)			ACCESS((context), index_frame)
#define START6(context)			ACCESS((context), pickup).time
#define STATE(context)			ACCESS((context), state)
#define STORAGE(context)		ACCESS((context), storage)
#define STREAMS(context)		ACCESS((context), streams)
#define SYNCHRONIZE(context)		ACCESS((context), do_synchronize)
#if __ENABLE_TAGGED_LIST__
# define TAGGED(context)		ACCESS((context), atomic).tagged
#endif				/* __ENABLE_TAGGED_LIST__ */
#define TAIL(context)			ACCESS((context), tail)
#define TARGET(context)			ACCESS((context), target)
#define TITLE(context)			ACCESS((context), text).title
#define VERBOSE(context)		ACCESS((context), do_explain)
#if __WAIT_VIOLET__
# define VIOLET(context)		ACCESS((context), violet)
#endif				/* __WAIT_VIOLET__ */
#define WINDOW(context)			ACCESS((context), window)
#define WIRE(context)			ACCESS((context), wire)
#define X1f42(context)			ACCESS((context), x1f42)
#define Z0fa(context)			ACCESS((context), pending_0fa)

#define ACCESS(context, member)		(CONTEXT(context)->member)

#define CONTEXT(context)		((struct context_state *) (context))

#endif				/* __Mylene1f4_ACCESS_H__ */
