/*
 * aime1.c
 * Copyright (C) 2007-2015, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#if __ENABLE_EQUEUE__
# include <aime.h>
# include <stddef.h>
# include <stdlib.h>
# include <string.h>
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# include <access.h>
# include <aime1.h>
# include <defs.h>
# include <excess4.h>
# include <excess7.h>
# include <inter.h>
# include <types.h>
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define __DUMP_DECK__			0
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define I_MODE(i)			(*((X1f4_E4_C_MODE *) (i)))
# define I_USER(t)			(*((X1f4_E4_C_USER *) (t)))
# define I_TEXT(i)			(*((X1f4_E4_C_TEXT *) (i)))
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define M500_L7_DECK			Mylene1f4_L7_DECK
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define l_MODE(output, e) \
    {									      \
	X1f4_E4_C_MODE *l;						      \
									      \
	l = (output);							      \
	*l = (e);							      \
    }
# define l_USER(output, e) \
    {									      \
	X1f4_E4_C_USER *l;						      \
									      \
	l = (output);							      \
	*l = (e);							      \
    }
# define l_TEXT(output, e) \
    {									      \
	X1f4_E4_C_TEXT *l;						      \
									      \
	l = (output);							      \
	*l = (e);							      \
    }
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define e4text(context) \
    ((struct e4text_type *) Frame4((context))->lxdeck)
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define Frame4(context) \
    ((struct frame4_type *) &Frame7((context))->_1.frame4)
# define Frame7(context) \
    ((struct frame7_type *) WINDOW((context)).server.window)
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define dxflat(dxflat) \
    ((struct x1f4_dxflat_type *) (dxflat))
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define equeue(equeue) \
    ((struct equeue_type *) (equeue))
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
extern struct x1f4_dxflat_type _Mylene1f4_e4lx_flat[];
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
static int nonsense_081020_0(void *, void *, void **);
static int nonsense_081025_0(void *, void *, void **);
static int nonsense_081105_0(void *, void *, void **);
static int nonsense_081116_0(void *, void *, void **);
static int nonsense_081116_1(void *, void *, void **);
static int nonsense_081117_0(void *, void *, void **);
static int nonsense_081117_1(void *, void *, void **);
static int nonsense_081117_2(void *, void *, void **);
static int nonsense_081117_3(void *, void *, void **);
static int nonsense_081120_0(void *, void *, void **);
static int nonsense_090607_0(void *, void *, void **);
static int nonsense_090617_0(void *, void *, void **);
static int nonsense_090706_0(void *, void *, void **);
static int nonsense_091228_0(void *, void *, void **);
static int nonsense_091228_1(void *, void *, void **);
static int nonsense_120308_0(void *, void *, void **);
static int nonsense_120308_1(void *, void *, void **);
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
static int c_____D__[] = {
/* *INDENT-OFF* */
    M500_L7_DECK,
    X1f4_E4_POST_XSET
/* *INDENT-ON* */
}, c_____D_m[] = {
/* *INDENT-OFF* */
    M500_L7_DECK,
    X1f4_E4_MODE,
    X1f4_E4_POST_XSET,
    0
/* *INDENT-ON* */
}, c_____D_t[] = {
/* *INDENT-OFF* */
    M500_L7_DECK,
    X1f4_E4_TEXT
/* *INDENT-ON* */
};
static const int c_____m__[] = {
/* *INDENT-OFF* */
    X1f4_E4_MODE
/* *INDENT-ON* */
}, c_____m_m[] = {
/* *INDENT-OFF* */
    X1f4_E4_MODE,
    X1f4_E4_MODE
/* *INDENT-ON* */
};
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
struct x1f4_function_type _Mylene1f4_aime_1_F__[] = {
/* *INDENT-OFF* */
    {	"F_delete",		nonsense_081025_0,
	X1f4_E4_VOID,		c_____m__,	1,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						8			},
    {	"F_move",		nonsense_081105_0,
	X1f4_E4_VOID,		c_____m_m,	2,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						6			},
    {	NULL,			NULL,
	0,			NULL,		0,
	0,					1			}
/* *INDENT-ON* */
}, _Mylene1f4_aime_1_I_2[] = {
/* *INDENT-OFF* */
    {	"I_self",		nonsense_081117_0,
	X1f4_E4_VOID,		c_____D__,	1,
	X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE | X1f4_E4_TEXT_LINK
	| M1f4_L7_TEXT_LINK,			6			},
    {	"I_running",		nonsense_081117_0,
	X1f4_E4_VOID,		c_____D__,	1,
	X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE | X1f4_E4_TEXT_LINK
	| M1f4_L7_TEXT_LINK,			9			},
    {	NULL,			NULL,
	0,			NULL,		0,
	0,					1			}
/* *INDENT-ON* */
}, _Mylene1f4_aime_1_I_3[] = {
/* *INDENT-OFF* */
    {	"I_running",		nonsense_081117_2,
	X1f4_E4_VOID,		c_____D__,	1,
	X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE | X1f4_E4_TEXT_LINK
	| M1f4_L7_TEXT_LINK,			9			},
    {	NULL,			NULL,
	0,			NULL,		0,
	0,					1			}
/* *INDENT-ON* */
}, _Mylene1f4_aime_1_I__[] = {
/* *INDENT-OFF* */
    {	"I_queue",		nonsense_081116_0,
	X1f4_E4_VOID,		c_____D_m,	2,
	X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE | X1f4_E4_TEXT_LINK
	| M1f4_L7_TEXT_LINK,			7			},
    {	NULL,			NULL,
	0,			NULL,		0,
	0,					1			}
/* *INDENT-ON* */
}, _Mylene1f4_aime_1_L_2[] = {
/* *INDENT-OFF* */
    {	"L_self",		nonsense_081117_1,
	M500_L7_DECK,		NULL,		0,
	X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,	6			},
    {	"L_running",		nonsense_081117_1,
	M500_L7_DECK,		NULL,		0,
	X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,	9			},
    {	NULL,			NULL,
	0,			NULL,		0,
	0,					1			}
/* *INDENT-ON* */
}, _Mylene1f4_aime_1_L_3[] = {
/* *INDENT-OFF* */
    {	"L_running",		nonsense_081117_3,
	M500_L7_DECK,		NULL,		0,
	X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,	9			},
    {	NULL,			NULL,
	0,			NULL,		0,
	0,					1			}
/* *INDENT-ON* */
}, _Mylene1f4_aime_1_L__[] = {
/* *INDENT-OFF* */
    {	"L_queue",		nonsense_081116_1,
	M500_L7_DECK,		c_____m__,	1,
	X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,	7			},
    {	"L_queue_length",	nonsense_081020_0,
	X1f4_E4_MODE,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						14			},
    {	NULL,			NULL,
	0,			NULL,		0,
	0,					1			}
/* *INDENT-ON* */
}, _Mylene1f4_aime_1___3[] = {
/* *INDENT-OFF* */
    {	"running",		nonsense_090706_0,
	X1f4_E4_MODE,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						7			},
    {	NULL,			NULL,
	0,			NULL,		0,
	0,					1			}
/* *INDENT-ON* */
}, _Mylene1f4_aime_1____[] = {
/* *INDENT-OFF* */
    {	"connected",		nonsense_090617_0,
	X1f4_E4_MODE,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						9			},
    {	"major",		nonsense_120308_0,
	X1f4_E4_MODE,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						5			},
    {	"minor",		nonsense_120308_1,
	X1f4_E4_MODE,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						5			},
    {	NULL,			NULL,
	0,			NULL,		0,
	0,					1			}
/* *INDENT-ON* */
}, _Mylene1f4_aime_1_q_l[] = {
/* *INDENT-OFF* */
    {	"q_l_major",		nonsense_091228_0,
	X1f4_E4_MODE,		c_____D__,	1,
	0,					9			},
    {	"q_l_minor",		nonsense_091228_1,
	X1f4_E4_MODE,		c_____D__,	1,
	0,					9			},
    {	"q_l_title",		nonsense_081120_0,
	X1f4_E4_TEXT,		c_____D__,	1,
	X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,	9			},
    {	NULL,			NULL,
	0,			NULL,		0,
	0,					1			}
/* *INDENT-ON* */
}, _Mylene1f4_aime_1_q_s[] = {
/* *INDENT-OFF* */
    {	"q_s_title",		nonsense_090607_0,
	X1f4_E4_VOID,		c_____D_t,	2,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						9			},
    {	NULL,			NULL,
	0,			NULL,		0,
	0,					1			}
/* *INDENT-ON* */
};
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
static int
nonsense_081020_0(void *context, void *output, void **input)
{
    l_MODE(output, Frame4(context)->iqueue.lqueue);

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_081025_0(void *context, void *output, void **input)
{
    if (Frame4(context)->iqueue.lqueue) {
	X1f4_E4_C_MODE mode;
	int sign = 0;

	mode = I_MODE(input[0]);
	if (mode < 0) {
	    mode = -mode;
	    sign = 1;
	}

	Mylene1f4_slip_equeue(context, sign, mode);
    }

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_081105_0(void *context, void *output, void **input)
{
    if (Frame4(context)->iqueue.lqueue) {
	X1f4_E4_C_MODE miss, mode;
	int post = 0, sign = 0;

	mode = I_MODE(input[0]);
	if (mode < 0) {
	    mode = -mode;
	    sign = 1;
	}

	miss = I_MODE(input[1]);
	if (miss < 0) {
	    miss = -miss;
	    post = 1;
	}

	Mylene1f4_swap_equeue(context, post, miss, sign, mode);
    }

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_081116_0(void *context, void *output, void **input)
{
    int status;
    void *dxflat;

    do {
	X1f4_E4_C_MODE index;
	struct frame4_type *frame4_data;
	unsigned count;

	frame4_data = Frame4(context);

	count = frame4_data->iqueue.lqueue;

	index = I_MODE(input[1]);
	if (index < 0) {
	    if (count < index) {
		dxflat = _Mylene1f4_e4lx_flat;
		status = 0;
		break;
	    } else {
		index += count;
	    }
	} else {
	    if (index < count) {
	    } else {
		dxflat = _Mylene1f4_e4lx_flat;
		status = 0;
		break;
	    }
	}

	{
	    struct equeue_type *equeue_data;

	    equeue_data = frame4_data->iqueue.head_equeue;
	    while (index) {
		index--;
		equeue_data = equeue_data->equeue_data;
	    }

	    status = Mylene1f4_side_equeue(equeue_data, &dxflat);
	}
    } while (0);

    if (status) {
    } else {
	struct x1f4_dxflat_type *dxflat_data;

	dxflat_data = dxflat;
	dxflat_data->call++;

	Mylene1f4_call_equeue(I_USER(input[0]));

	l_USER(input[0], dxflat);
    }

# if __DUMP_DECK__
    if (status) {
    } else {
	Mylene1f4_dump_deck
	    (context, "I_queue(%u) call\n", (unsigned) I_MODE(input[1]));
    }
# endif				/* __DUMP_DECK__ */

    return status;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_081116_1(void *context, void *output, void **input)
{
    int status;

    do {
	X1f4_E4_C_MODE index;
	struct frame4_type *frame4_data;
	unsigned count;

	frame4_data = Frame4(context);

	count = frame4_data->iqueue.lqueue;

	index = I_MODE(input[0]);
	if (index < 0) {
	    if (count < index) {
		l_USER(output, _Mylene1f4_e4lx_flat);
		status = 0;
		break;
	    } else {
		index += count;
	    }
	} else {
	    if (index < count) {
	    } else {
		l_USER(output, _Mylene1f4_e4lx_flat);
		status = 0;
		break;
	    }
	}

	{
	    struct equeue_type *equeue_data;
	    void *dxflat;

	    equeue_data = frame4_data->iqueue.head_equeue;
	    while (index) {
		index--;
		equeue_data = equeue_data->equeue_data;
	    }

	    status = Mylene1f4_high_equeue(context, equeue_data, &dxflat);
	    if (status) {
	    } else {
		l_USER(output, dxflat);
	    }
	}
    } while (0);

# if __DUMP_DECK__
    if (status) {
    } else {
	Mylene1f4_dump_deck
	    (context, "L_queue(%u) call\n", (unsigned) I_MODE(input[0]));
    }
# endif				/* __DUMP_DECK__ */

    return status;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_081117_0(void *context, void *output, void **input)
{
    int status;
    void *dxflat;

    status = Mylene1f4_side_equeue(Frame4(context)->dana.eclass, &dxflat);
    if (status) {
    } else {
	struct x1f4_dxflat_type *dxflat_data;

	dxflat_data = dxflat;
	dxflat_data->call++;

	Mylene1f4_call_equeue(I_USER(input[0]));

	l_USER(input[0], dxflat);
    }

# if __DUMP_DECK__
    if (status) {
    } else {
	Mylene1f4_dump_deck(context, "I_self call\n");
    }
# endif				/* __DUMP_DECK__ */

    return status;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_081117_1(void *context, void *output, void **input)
{
    int status;
    void *dxflat;

    status = Mylene1f4_high_equeue
	(context, Frame4(context)->dana.eclass, &dxflat);
    if (status) {
    } else {
	l_USER(output, dxflat);
    }

# if __DUMP_DECK__
    if (status) {
    } else {
	Mylene1f4_dump_deck(context, "L_self call\n");
    }
# endif				/* __DUMP_DECK__ */

    return status;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_081117_2(void *context, void *output, void **input)
{
    int status;
    struct frame4_type *frame4_data;
    void *dxflat;

    frame4_data = Frame4(context);
    if (frame4_data->flags & Mylene1f4_AIME_LINKED) {
	status = Mylene1f4_side_equeue(frame4_data->dana.eclass, &dxflat);
    } else {
	dxflat = _Mylene1f4_e4lx_flat;
	status = 0;
    }

    if (status) {
    } else {
	struct x1f4_dxflat_type *dxflat_data;

	dxflat_data = dxflat;
	dxflat_data->call++;

	Mylene1f4_call_equeue(I_USER(input[0]));

	l_USER(input[0], dxflat);
    }

# if __DUMP_DECK__
    if (status) {
    } else {
	Mylene1f4_dump_deck(context, "I_running call\n");
    }
# endif				/* __DUMP_DECK__ */

    return status;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_081117_3(void *context, void *output, void **input)
{
    int status;
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    if (frame4_data->flags & Mylene1f4_AIME_LINKED) {
	void *dxflat;

	status = Mylene1f4_high_equeue
	    (context, frame4_data->dana.eclass, &dxflat);
	if (status) {
	} else {
	    l_USER(output, dxflat);
	}
    } else {
	l_USER(output, _Mylene1f4_e4lx_flat);
	status = 0;
    }

# if __DUMP_DECK__
    if (status) {
    } else {
	Mylene1f4_dump_deck(context, "L_running call\n");
    }
# endif				/* __DUMP_DECK__ */

    return status;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_081120_0(void *context, void *output, void **input)
{
    int status;
    struct equeue_type *equeue_data;

    equeue_data = dxflat(I_USER(input[0]))->data;
    if (equeue_data) {
	char *name;

	name = equeue_data->name;
	if (name) {
	    struct x1f4_indexset_type *indexset_data;

	    indexset_data = e4text(context)->indexset;
	    status = x1f4_auto_text
		(&indexset_data->autolink_set, equeue_data->slip.aime.e8port,
		 name, strlen(name), output);
	} else {
	    status = 0;
	    l_TEXT(output, (char *) x1f4_c1_empty_string);
	}
    } else {
	status = 0;
	l_TEXT(output, (char *) x1f4_c1_empty_string);
    }

    return status;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_090607_0(void *context, void *output, void **input)
{
    struct equeue_type *equeue_data;
    int status;

    equeue_data = dxflat(I_USER(input[0]))->data;

    if (equeue_data) {
	do {
	    char *name, *text;
	    unsigned post;

	    text = I_TEXT(input[1]);
	    post = strlen(text);
	    if (!post) {
		text = NULL;
	    } else {
		char *swap;

		post++;

		swap = (char *) malloc(post);
		if (!swap) {
		    status = -1;

		    break;
		} else {
		    memcpy(swap, text, post);
		    text = swap;
		}
	    }

	    name = equeue_data->name;
	    equeue_data->name = text;

	    if (name) {
		if (equeue_data->bits & Mylene1f4_EXTERN_LOGIC) {
		} else {
		    free(name);
		}
	    }

	    status = 0;
	} while (0);
    } else {
	status = 0;
    }

    return status;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_090617_0(void *context, void *output, void **input)
{
# if __ENABLE_CHANNEL_EQUEUE__
    struct frame4_type *frame4_data;
# endif				/* __ENABLE_CHANNEL_EQUEUE__ */

# if __ENABLE_CHANNEL_EQUEUE__
    frame4_data = Frame4(context);
# endif				/* __ENABLE_CHANNEL_EQUEUE__ */

# if __ENABLE_CHANNEL_EQUEUE__
    if (!(frame4_data->flags & Mylene1f4_AIME_TARGET)) {
# endif				/* __ENABLE_CHANNEL_EQUEUE__ */
	l_MODE(output, 0);
# if __ENABLE_CHANNEL_EQUEUE__
    } else {
	if (frame4_data->client_id != frame4_data->client_up) {
	    l_MODE(output, 0);
	} else {
	    l_MODE(output, 1);
	}
    }
# endif				/* __ENABLE_CHANNEL_EQUEUE__ */

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_090706_0(void *context, void *output, void **input)
{
    l_MODE(output, Frame4(context)->flags & Mylene1f4_AIME_LINKED);

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_091228_0(void *context, void *output, void **input)
{
    struct equeue_type *equeue_data;

    equeue_data = dxflat(I_USER(input[0]))->data;
    if (equeue_data) {
	l_MODE(output, equeue_data->major);
    } else {
	l_MODE(output, 0);
    }

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_091228_1(void *context, void *output, void **input)
{
    struct equeue_type *equeue_data;

    equeue_data = dxflat(I_USER(input[0]))->data;
    if (equeue_data) {
	l_MODE(output, equeue_data->minor);
    } else {
	l_MODE(output, 0);
    }

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_120308_0(void *context, void *output, void **input)
{
    l_MODE(output, equeue(Frame4(context)->dana.equeue)->major);

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_120308_1(void *context, void *output, void **input)
{
    l_MODE(output, equeue(Frame4(context)->dana.equeue)->minor);

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */
