/*
 * aime2.c
 * Copyright (C) 2007-2013, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#if __ENABLE_EQUEUE__
# include <aime.h>
# include <stddef.h>
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# include <aime1.h>
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define _Mylene1f4_aime_2_f_args_0 \
    const void *, const struct x1f4_function_type *, void **
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
static int link_data(const void *, const struct x1f4_function_type *, void **);
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
int (*const _Mylene1f4_aime_2_f[]) (_Mylene1f4_aime_2_f_args_0) = {
/* *INDENT-OFF* */
    link_data
/* *INDENT-ON* */
};
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
static int
link_data(const void *context, const struct x1f4_function_type *function_data,
	  void **link)
{
    if (function_data->flags & M1f4_L7_TEXT_LINK) {
	*link = (void *) context;
    } else {
	*link = (void *)
	    ((struct x1f4_linetext_type *)
	     ((const char *) function_data
	      - offsetof(struct x1f4_linetext_type, function)))->context;
    }

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */
