/*
 * aime3.c
 * Copyright (C) 2007-2011, 2013-2015, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#if __ENABLE_EQUEUE__
# include <aime.h>
# if defined HAVE_LIBx1f4l0
#  include <libx1f4l0.h>
# endif				/* HAVE_LIBx1f4l0 */
# include <stdio.h>
# include <stddef.h>
# include <stdlib.h>
# include <string.h>
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# include <access.h>
# include <aime1.h>
# include <defs.h>
# include <excess4.h>
# include <excess7.h>
# include <inter.h>
# include <sfnote.h>
# include <types.h>
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
#else
# undef __ENABLE_FQUEUE__
# define __ENABLE_FQUEUE__		0
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define __RESET_MPEG_EQUALIZER__	0
#else
# define __RESET_MPEG_EQUALIZER__	0
#endif				/* __ENABLE_EQUEUE__ */

/*
 * TODO
 *
 * move this elsewhere
 */
#if __ENABLE_EQUEUE__
# define __E1211_LIBRARY__		0
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define INTEGER_STATE			0
# define TEXT_STATE			1
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define MAKE_SINGLE(a, b)		a
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define I_MODE(i)			(*((X1f4_E4_C_MODE *) (i)))
# define I_REAL(i)			(*((X1f4_E4_C_REAL *) (i)))
# define I_TEXT(t)			(*((X1f4_E4_C_TEXT *) (t)))
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define l_MODE(output, e) \
    {									      \
	X1f4_E4_C_MODE *l;						      \
									      \
	l = (output);							      \
	*l = (e);							      \
    }
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define l_REAL(output, e) \
    {									      \
	X1f4_E4_C_REAL *l;						      \
									      \
	l = (output);							      \
	*l = (e);							      \
    }
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define l_TEXT(output, e) \
    {									      \
	X1f4_E4_C_TEXT *l;						      \
									      \
	l = (output);							      \
	*l = (void *) (e);						      \
    }
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define equeue(equeue) \
    ((struct equeue_type *) (equeue))
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define e4text(context) \
    ((struct e4text_type *) Frame4((context))->lxdeck)
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define Frame4(context) \
    ((struct frame4_type *) &Frame7((context))->_1.frame4)
# define Frame7(context) \
    ((struct frame7_type *) WINDOW((context)).server.window)
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define Album(context) \
    (Frame4((context))->text.album)
# define Lbase(context) \
    (Frame4((context))->text.lbase)
# define Lpath(context) \
    (Frame4((context))->text.lpath)
# define Match(context) \
    (Frame4((context))->text.match)
# define Notes(context) \
    (Frame4((context))->text.notes)
# define Title(context) \
    (Frame4((context))->text.title)
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define swap_data			Mylene1f4_swap_graphique
# define swap_deck			Mylene1f4_swap_filter
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define Q___sets_count(Q___sets) \
    (sizeof((Q___sets)) / sizeof(struct x1f4_function_type *))
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
typedef X1f4_E4_C_TEXT e4_c_text;
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
static int fix_field(void *, void *, struct string_type *);
static int g10xx_t_t(void *, void *, void **);
static int nonsense_080101_0(void *, void *, void **);
static int nonsense_080101_1(void *, void *, void **);
static int nonsense_080101_2(void *, void *, void **);
static int nonsense_080101_3(void *, void *, void **);
static int nonsense_080101_4(void *, void *, void **);
static int nonsense_080101_5(void *, void *, void **);
static int nonsense_080101_6(void *, void *, void **);
static int nonsense_080101_7(void *, void *, void **);
static int nonsense_080102_2(void *, void *, void **);
static int nonsense_080102_3(void *, void *, void **);
static int nonsense_080103_2(void *, void *, void **);
static int nonsense_080103_3(void *, void *, void **);
static int nonsense_080103_4(void *, void *, void **);
static int nonsense_080103_5(void *, void *, void **);
static int nonsense_080106_0(void *, void *, void **);
static int nonsense_080106_1(void *, void *, void **);
static int nonsense_080106_2(void *, void *, void **);
static int nonsense_080106_3(void *, void *, void **);
static int nonsense_080106_4(void *, void *, void **);
static int nonsense_080115_2(void *, void *, void **);
static int nonsense_080115_3(void *, void *, void **);
static int nonsense_080115_4(void *, void *, void **);
static int nonsense_080716_0(void *, void *, void **);
#endif				/* __ENABLE_EQUEUE__ */
#if __RESET_MPEG_EQUALIZER__
static int nonsense_080716_1(void *, void *, void **);
#endif				/* __RESET_MPEG_EQUALIZER__ */
#if __ENABLE_EQUEUE__
static int nonsense_080716_2(void *, void *, void **);
static int nonsense_080716_3(void *, void *, void **);
#endif				/* __ENABLE_EQUEUE__ */
#if __RESET_MPEG_EQUALIZER__
static int nonsense_080716_4(void *, void *, void **);
#endif				/* __RESET_MPEG_EQUALIZER__ */
#if __ENABLE_EQUEUE__
static int nonsense_080716_5(void *, void *, void **);
static int nonsense_080716_6(void *, void *, void **);
#endif				/* __ENABLE_EQUEUE__ */
#if __RESET_MPEG_EQUALIZER__
static int nonsense_080716_7(void *, void *, void **);
#endif				/* __RESET_MPEG_EQUALIZER__ */
#if __ENABLE_EQUEUE__
static int nonsense_080716_8(void *, void *, void **);
static int nonsense_080505_0(void *, void *, void **);
static int nonsense_080806_0(void *, void *, void **);
static int nonsense_080806_1(void *, void *, void **);
static int nonsense_080806_2(void *, void *, void **);
static int nonsense_080806_3(void *, void *, void **);
static int nonsense_080806_4(void *, void *, void **);
static int nonsense_080806_5(void *, void *, void **);
static int nonsense_081107_0(void *, void *, void **);
static int nonsense_081114_1(void *, void *, void **);
static int nonsense_081114_2(void *, void *, void **);
static int nonsense_081114_3(void *, void *, void **);
static int nonsense_081115_1(void *, void *, void **);
static int nonsense_081115_2(void *, void *, void **);
static int nonsense_081115_3(void *, void *, void **);
#endif				/* __ENABLE_EQUEUE__ */
#if __E1211_LIBRARY__
static int nonsense_081211_0(void *, void *, void **);
static int nonsense_081211_3(void *, void *, void **);
static int nonsense_081211_4(void *, void *, void **);
#endif				/* __E1211_LIBRARY__ */
#if __ENABLE_EQUEUE__
static int nonsense_090214_0(void *, void *, void **);
static int nonsense_090214_1(void *, void *, void **);
static int nonsense_090706_0(void *, void *, void **);
static int nonsense_090706_1(void *, void *, void **);
static int nonsense_110211_0(void *, void *, void **);
static int nonsense_110211_1(void *, void *, void **);
static int nonsense_110211_2(void *, void *, void **);
static int nonsense_110222_0(void *, void *, void **);
static int nonsense_130701_0(void *, void *, void **);
static int nonsense_140324_0(void *, void *, void **);
static int nonsense_140324_1(void *, void *, void **);
static int nonsense_140324_2(void *, void *, void **);
static int nonsense_140324_3(void *, void *, void **);
static int set_field(void *, void **, struct string_type *,
		     struct string_type *);
static int set_progress(void *, void **, void *, const char *);
static int snow_white(void *, const char *, unsigned);
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
static const int c_____m__[] = {
/* *INDENT-OFF* */
    X1f4_E4_MODE
/* *INDENT-ON* */
}, c_____m_r[] = {
/* *INDENT-OFF* */
    X1f4_E4_MODE,
    X1f4_E4_REAL
/* *INDENT-ON* */
}, c_____r__[] = {
/* *INDENT-OFF* */
    X1f4_E4_REAL
/* *INDENT-ON* */
}, c_____t__[] = {
/* *INDENT-OFF* */
    X1f4_E4_TEXT
/* *INDENT-ON* */
}, c_____t_m[] = {
/* *INDENT-OFF* */
    X1f4_E4_TEXT,
    X1f4_E4_MODE,
    0,
    X1f4_E4_POST_XSET
/* *INDENT-ON* */
}, c_____t_t[] = {
/* *INDENT-OFF* */
    X1f4_E4_TEXT,
    X1f4_E4_TEXT,
    0,
    X1f4_E4_POST_XSET
/* *INDENT-ON* */
}, c___m_m_t[] = {
/* *INDENT-OFF* */
    X1f4_E4_MODE,
    X1f4_E4_MODE,
    X1f4_E4_TEXT
/* *INDENT-ON* */
};
static struct x1f4_linetext_type a10xx_t_t = {
/* *INDENT-OFF* */
    {	MAKE_SINGLE("+", " "),  g10xx_t_t,
	X1f4_E4_TEXT,		c_____t_t,	2,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,	1		},
    NULL
/* *INDENT-ON* */
};
static const struct x1f4_2ndscope_type d10xx_t_t[] = {
/* *INDENT-OFF* */
    {	X1f4_E4_CALL_LINK,	&a10xx_t_t			}
/* *INDENT-ON* */
};
static const struct x1f4_operator_type f10xx_t_t[] = {
/* *INDENT-OFF* */
    {	MAKE_SINGLE("+", " "),  NULL,		0230,
	X1f4_E4_TEXT,		c_____t_t,
	X1f4_E4_E2ND_LINK | X1f4_E4_KEEP_CALL,	1,
	NULL,			d10xx_t_t + 0			}
/* *INDENT-ON* */
};
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
const struct x1f4_function_type _Mylene1f4_aime_3_F__[] = {
/* *INDENT-OFF* */
    {	"F_detach",		nonsense_081107_0,
	X1f4_E4_VOID,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						8			},
    {	"F_pause",		nonsense_080505_0,
	X1f4_E4_VOID,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						7			},
    {	"F_send",		nonsense_110222_0,
	X1f4_E4_VOID,		c___m_m_t,	3,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						6			},
    {	"F_scrap",		nonsense_110211_0,
	X1f4_E4_VOID,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						7			},
    {	NULL,			NULL,
	0,			NULL,		0,
	0,					1			}
/* *INDENT-ON* */
}, _Mylene1f4_aime_3_I__[] = {
#endif				/* __ENABLE_EQUEUE__ */
#if __E1211_LIBRARY__
/* *INDENT-OFF* */
    {	"I_back",		nonsense_081211_3,
	X1f4_E4_MODE,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						6			},
    {	"I_class",		nonsense_081211_0,
	X1f4_E4_MODE,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						7			},
    {	"I_skip",		nonsense_081211_4,
	X1f4_E4_MODE,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						6			},
    {	NULL,			NULL,
	0,			NULL,		0,
	0,					1			}
/* *INDENT-ON* */
#endif				/* __E1211_LIBRARY__ */
#if __ENABLE_EQUEUE__
}, _Mylene1f4_aime_3_L_2[] = {
/* *INDENT-OFF* */
    {	"L_lead",		nonsense_110211_2,
	X1f4_E4_TEXT,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						6			},
    {	"L_long",		nonsense_110211_1,
	X1f4_E4_MODE,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						6			},
    {	NULL,			NULL,
	0,			NULL,		0,
	0,					1			}
/* *INDENT-ON* */
}, _Mylene1f4_aime_3_L__[] = {
/* *INDENT-OFF* */
    {	"L_album",		nonsense_080106_0,
	X1f4_E4_TEXT,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						7			},
    {	"L_artist",		nonsense_080106_1,
	X1f4_E4_TEXT,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						8			},
    {	"L_back",		nonsense_080115_3,
	X1f4_E4_MODE,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						6			},
    {	"L_basename",		nonsense_080806_0,
	X1f4_E4_TEXT,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						10			},
    {	"L_class",		nonsense_080106_4,
	X1f4_E4_TEXT,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						7			},
    {	"L_comment",		nonsense_080106_2,
	X1f4_E4_TEXT,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						9			},
    {	"L_filter",		nonsense_080106_4,
	X1f4_E4_TEXT,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						8			},
    {	"L_integer",		nonsense_140324_0,
	X1f4_E4_MODE,		c_____t_m,	2,
	X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE | X1f4_E4_TEXT_LINK
	| M1f4_L7_TEXT_LINK,			9			},
    {	"L_l3amplification",	nonsense_080716_8,
	X1f4_E4_REAL,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						17			},
    {	"L_l3frequency",	nonsense_080716_5,
	X1f4_E4_REAL,		c_____m__,	1,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						13			},
    {	"L_l3level",		nonsense_080716_2,
	X1f4_E4_REAL,		c_____m__,	1,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						9			},
    {	"L_last",		nonsense_080115_3,
	X1f4_E4_MODE,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						6			},
    {	"L_match",		nonsense_080106_1,
	X1f4_E4_TEXT,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						7			},
    {	"L_next",		nonsense_080115_2,
	X1f4_E4_MODE,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						6			},
    {	"L_original",		nonsense_090214_1,
	X1f4_E4_MODE,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						10			},
    {	"L_path",		nonsense_080806_1,
	X1f4_E4_TEXT,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						6			},
    {	"L_previous",		nonsense_080115_3,
	X1f4_E4_MODE,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						10			},
    {	"L_random",		nonsense_080115_4,
	X1f4_E4_MODE,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						8			},
    {	"L_repeat",		nonsense_130701_0,
	X1f4_E4_MODE,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						8			},
    {	"L_shuffled",		nonsense_090214_0,
	X1f4_E4_MODE,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						10			},
    {	"L_text",		nonsense_140324_2,
	X1f4_E4_MODE,		c_____t_t,	2,
	X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE | X1f4_E4_TEXT_LINK
	| M1f4_L7_TEXT_LINK,			6			},
    {	"L_title",		nonsense_080106_3,
	X1f4_E4_TEXT,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						7			},
    {	NULL,			NULL,
	0,			NULL,		0,
	0,					1			}
/* *INDENT-ON* */
}, _Mylene1f4_aime_3_R__[] = {
/* *INDENT-OFF* */
    {	"R_album",		nonsense_080101_0,
	X1f4_E4_VOID,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						7			},
    {	"R_artist",		nonsense_080101_1,
	X1f4_E4_VOID,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						8			},
    {	"R_basename",		nonsense_080806_2,
	X1f4_E4_VOID,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						10			},
    {	"R_class",		nonsense_080102_2,
	X1f4_E4_VOID,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						7			},
    {	"R_comment",		nonsense_080101_2,
	X1f4_E4_VOID,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						9			},
    {	"R_filter",		nonsense_080102_2,
	X1f4_E4_VOID,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						8			},
#endif				/* __ENABLE_EQUEUE__ */
#if __RESET_MPEG_EQUALIZER__
    {	"R_l3amplification",	nonsense_080716_7,
	X1f4_E4_VOID,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						17			},
    {	"R_l3frequency",	nonsense_080716_4,
	X1f4_E4_VOID,		c_____m__,	1,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						13			},
    {	"R_l3level",		nonsense_080716_1,
	X1f4_E4_VOID,		c_____m__,	1,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						9			},
#endif				/* __RESET_MPEG_EQUALIZER__ */
#if __ENABLE_EQUEUE__
    {	"R_match",		nonsense_080101_1,
	X1f4_E4_VOID,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						7			},
    {	"R_path",		nonsense_080806_3,
	X1f4_E4_VOID,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						6			},
    {	"R_progress1",		nonsense_081114_1,
	X1f4_E4_VOID,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						11			},
    {	"R_progress2",		nonsense_081114_2,
	X1f4_E4_VOID,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						11			},
    {	"R_progress3",		nonsense_081114_3,
	X1f4_E4_VOID,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						11			},
    {	"R_order",		nonsense_080103_5,
	X1f4_E4_VOID,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						7			},
    {	"R_title",		nonsense_080101_3,
	X1f4_E4_VOID,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						7			},
    {	NULL,			NULL,
	0,			NULL,		0,
	0,					1			}
/* *INDENT-ON* */
}, _Mylene1f4_aime_3_S__[] = {
/* *INDENT-OFF* */
    {	"S_album",		nonsense_080101_4,
	X1f4_E4_VOID,		c_____t__,	1,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						7			},
    {	"S_artist",		nonsense_080101_5,
	X1f4_E4_VOID,		c_____t__,	1,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						8			},
    {	"S_back",		nonsense_080103_3,
	X1f4_E4_VOID,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						6			},
    {	"S_back2",		nonsense_090706_1,
	X1f4_E4_VOID,		c_____m__,	1,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						7			},
    {	"S_basename",		nonsense_080806_4,
	X1f4_E4_VOID,		c_____t__,	1,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						10			},
    {	"S_class",		nonsense_080102_3,
	X1f4_E4_VOID,		c_____t__,	1,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						7			},
    {	"S_comment",		nonsense_080101_6,
	X1f4_E4_VOID,		c_____t__,	1,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						9			},
    {	"S_filter",		nonsense_080102_3,
	X1f4_E4_VOID,		c_____t__,	1,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						8			},
    {	"S_integer",		nonsense_140324_1,
	X1f4_E4_VOID,		c_____t_m,	2,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						9			},
    {	"S_l3amplification",	nonsense_080716_6,
	X1f4_E4_VOID,		c_____r__,	1,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						17			},
    {	"S_l3frequency",	nonsense_080716_3,
	X1f4_E4_VOID,		c_____m_r,	2,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						13			},
    {	"S_l3level",		nonsense_080716_0,
	X1f4_E4_VOID,		c_____m_r,	2,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						9			},
    {	"S_last",		nonsense_080103_3,
	X1f4_E4_VOID,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						6			},
    {	"S_match",		nonsense_080101_5,
	X1f4_E4_VOID,		c_____t__,	1,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						7			},
    {	"S_next",		nonsense_080103_2,
	X1f4_E4_VOID,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						6			},
    {	"S_path",		nonsense_080806_5,
	X1f4_E4_VOID,		c_____t__,	1,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						6			},
    {	"S_previous",		nonsense_080103_3,
	X1f4_E4_VOID,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						10			},
    {	"S_progress1",		nonsense_081115_1,
	X1f4_E4_VOID,		c_____t__,	1,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						11			},
    {	"S_progress2",		nonsense_081115_2,
	X1f4_E4_VOID,		c_____t__,	1,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						11			},
    {	"S_progress3",		nonsense_081115_3,
	X1f4_E4_VOID,		c_____t__,	1,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						11			},
    {	"S_random",		nonsense_080103_4,
	X1f4_E4_VOID,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						8			},
    {	"S_skip2",		nonsense_090706_0,
	X1f4_E4_VOID,		c_____m__,	1,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						7			},
    {	"S_text",		nonsense_140324_3,
	X1f4_E4_VOID,		c_____t_t,	2,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						6			},
    {	"S_title",		nonsense_080101_7,
	X1f4_E4_VOID,		c_____t__,	1,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						7			},
    {	NULL,			NULL,
	0,			NULL,		0,
	0,					1			}
/* *INDENT-ON* */
};
const struct x1f4_operator_type *_Mylene1f4_aime_3_B[] = {
/* *INDENT-OFF* */
    f10xx_t_t,
    NULL
/* *INDENT-ON* */
};
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
static int
call_state(void *context, char *text, int land, unsigned size, void **post)
{
    int delete = 0;

    do {
	int *call;
	struct frame4_type *frame4_data;
	void *data, *states;

	frame4_data = Frame4(context);

	states = frame4_data->line.states;
	if (states) {
	} else {
	    break;
	}

	if (frame4_data->line.down && size < frame4_data->line.size + 1) {
	    int status;

	    status = x1f4_post_sfnote(states, text, sizeof(int) + size, &data);
	    if (status) {
		if (status == X1f4_SFNOTE_EVER_MATCH) {
		} else {
		    break;
		}
	    } else {
		frame4_data->line.down--;
		frame4_data->line.size -= size;

		call = data;

		delete = 1;

		*call = land;

		*post = call + 1;

		break;
	    }
	} else {
	    if (x1f4_find_sfnote(states, text, &data)) {
	    } else {
		break;
	    }
	}

	call = data;
	if (*call ^ land) {
	    int status;
	    unsigned miss;

	    miss = land ^ TEXT_STATE
		? sizeof(int) : strlen((void *) (call + 1)) + 1;

	    status = x1f4_pass_sfnote(states, text);
	    if (status) {
		break;
	    } else {
		frame4_data->line.down++;
		frame4_data->line.size += miss;

		status = x1f4_post_sfnote
		    (states, text, sizeof(int) + size, &data);
		if (status) {
		    break;
		} else {
		    call = data;

		    frame4_data->line.down--;
		    frame4_data->line.size -= size;
		}
	    }
	}

	delete = 1;

	*call = land;

	*post = call + 1;
    } while (0);

    return delete;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
fix_field(void *context, void *output, struct string_type *field)
{
    int status;
    unsigned size;

    size = field->size;
    if (!size) {
	void *data;

	status = x1f4_link_e2list
	    (equeue(Frame4(context)->dana.equeue)->slip.aime.e2list, &data, 2);
	if (!status) {
	    char *text;

	    text = data;

	    l_TEXT(output, text);

	    *text++ = '*';
	    *text = 0;
	}
    } else {
	void *data;

	status = x1f4_link_e2list
	    (equeue(Frame4(context)->dana.equeue)->slip.aime.e2list, &data,
	     size + 1);
	if (!status) {
	    char *text;

	    text = data;

	    l_TEXT(output, text);

	    memcpy(text, field->data, size);
	    text += size;
	    *text = 0;
	}
    }

    return status;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
g10xx_t_t(void *context, void *output, void **input)
{
    char *head, *tail;
    int status;
    unsigned base, half;
    void *data;

    head = I_TEXT(input[0]);
    tail = I_TEXT(input[1]);

    base = strlen(head);
    half = strlen(tail);

# if 1
    status = x1f4_link_e2list
	(equeue(Frame4(context)->dana.equeue)->slip.aime.e2list, &data,
	 base + half + 1);
# else
    status = indexset_data->autolink_set.link
	(indexset_data->autolink_set.data, &data, base + half + 1);
# endif				/* 0 */
    if (status) {
    } else {
	char *text;

	text = data;

	l_TEXT(output, text);

	memcpy(text, head, base);
	text += base;
	memcpy(text, tail, half + 1);
    }

    return status;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_080101_0(void *context, void *output, void **input)
{
    return swap_data(&ALBUM(context), &Album(context));
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_080101_1(void *context, void *output, void **input)
{
    return swap_data(&MATCH(context), &Match(context));
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_080101_2(void *context, void *output, void **input)
{
    return swap_data(&NOTES(context), &Notes(context));
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_080101_3(void *context, void *output, void **input)
{
    return swap_data(&TITLE(context), &Title(context));
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_080101_4(void *context, void *output, void **input)
{
    return set_field(context, input, &ALBUM(context), &Album(context));
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_080101_5(void *context, void *output, void **input)
{
    return set_field(context, input, &MATCH(context), &Match(context));
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_080101_6(void *context, void *output, void **input)
{
    return set_field(context, input, &NOTES(context), &Notes(context));
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_080101_7(void *context, void *output, void **input)
{
    return set_field(context, input, &TITLE(context), &Title(context));
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_080102_2(void *context, void *output, void **input)
{
    return swap_deck(context, Frame4(context)->e4deck);
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_080102_3(void *context, void *output, void **input)
{
    int status;
    void *c_filter;

    status = Mylene1f4_init_filter
	(context, I_TEXT(((void **) input)[0]), &c_filter, 0);
    if (!status) {
	void *e4deck;

	e4deck = E4DECK(context);
	if (e4deck != Frame4(context)->e4deck) {
	    if (e4deck) {
		Mylene1f4_fini_filter(context, &e4deck);
	    }
	}

	E4DECK(context) = c_filter;
    }

    return status;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_080103_2(void *context, void *output, void **input)
{
    Mylene1f4_swap_last(context, Mylene1f4_LOAD_NEXT);

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_080103_3(void *context, void *output, void **input)
{
    Mylene1f4_swap_last(context, Mylene1f4_LOAD_LAST);

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_080103_4(void *context, void *output, void **input)
{
    Mylene1f4_swap_last(context, Mylene1f4_LOAD_RAND);

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_080103_5(void *context, void *output, void **input)
{
    Mylene1f4_swap_last(context, Frame4(context)->text.load_order);

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_080106_0(void *context, void *output, void **input)
{
    return fix_field(context, output, &ALBUM(context));
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_080106_1(void *context, void *output, void **input)
{
    return fix_field(context, output, &MATCH(context));
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_080106_2(void *context, void *output, void **input)
{
    return fix_field(context, output, &NOTES(context));
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_080106_3(void *context, void *output, void **input)
{
    return fix_field(context, output, &TITLE(context));
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_080106_4(void *context, void *output, void **input)
{
    int status;
    void *e4deck;

    e4deck = E4DECK(context);
    if (!e4deck) {
	void *data;

	status = x1f4_link_e2list
	    (equeue(Frame4(context)->dana.equeue)->slip.aime.e2list, &data, 1);
	if (!status) {
	    char *text;

	    text = data;

	    l_TEXT(output, text);

	    *text = 0;
	}
    } else {
	unsigned size = 0;
	void *data;

	x1f4_nprint_expression(&size, e4deck, 0);
	status = x1f4_link_e2list
	    (equeue(Frame4(context)->dana.equeue)->slip.aime.e2list, &data,
	     size + 1);
	if (!status) {
	    char *text;

	    text = data;

	    l_TEXT(output, text);

	    x1f4_vprint_expression(&text, snow_white, e4deck, 0);
	    *text = 0;
	}
    }

    return status;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_080115_2(void *context, void *output, void **input)
{
    l_MODE(output, LOAD_ORDER(context) == Mylene1f4_LOAD_NEXT);

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_080115_3(void *context, void *output, void **input)
{
    l_MODE(output, LOAD_ORDER(context) == Mylene1f4_LOAD_LAST);

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_080115_4(void *context, void *output, void **input)
{
    l_MODE(output, LOAD_ORDER(context) == Mylene1f4_LOAD_RAND);

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_080505_0(void *context, void *output, void **input)
{
    Mylene1f4_send_mylene0fa(context, 0x0d, NULL);

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_080716_0(void *context, void *output, void **input)
{
# if __ENABLE_MPEG_EQUALIZER__
    Mylene1f4_set_mode(context, I_MODE(input[0]), I_REAL(input[1]));
# endif				/* __ENABLE_MPEG_EQUALIZER__ */

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __RESET_MPEG_EQUALIZER__
static int
nonsense_080716_1(void *context, void *output, void **input)
{
# if __ENABLE_MPEG_EQUALIZER__
# endif				/* __ENABLE_MPEG_EQUALIZER__ */

    return 0;
}
#endif				/* __RESET_MPEG_EQUALIZER__ */


#if __ENABLE_EQUEUE__
static int
nonsense_080716_2(void *context, void *output, void **input)
{
# if __ENABLE_MPEG_EQUALIZER__
    X1f4_E4_C_MODE index;
# endif				/* __ENABLE_MPEG_EQUALIZER__ */

# if __ENABLE_MPEG_EQUALIZER__
    index = I_MODE(input[0]);
    if (index < 0) {
    } else {
	if (index < MPEG(context).count) {
	    l_REAL(output, MPEG(context).l3band_data[index].level);
	}
    }
# endif				/* __ENABLE_MPEG_EQUALIZER__ */

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_080716_3(void *context, void *output, void **input)
{
# if __ENABLE_MPEG_EQUALIZER__
    Mylene1f4_fix_mode(context, I_MODE(input[0]), I_REAL(input[1]));
# endif				/* __ENABLE_MPEG_EQUALIZER__ */

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __RESET_MPEG_EQUALIZER__
static int
nonsense_080716_4(void *context, void *output, void **input)
{
# if __ENABLE_MPEG_EQUALIZER__
# endif				/* __ENABLE_MPEG_EQUALIZER__ */

    return 0;
}
#endif				/* __RESET_MPEG_EQUALIZER__ */


#if __ENABLE_EQUEUE__
static int
nonsense_080716_5(void *context, void *output, void **input)
{
# if __ENABLE_MPEG_EQUALIZER__
    X1f4_E4_C_MODE index;
# endif				/* __ENABLE_MPEG_EQUALIZER__ */

# if __ENABLE_MPEG_EQUALIZER__
    index = I_MODE(input[0]);
    if (index < 0) {
    } else {
	if (index < MPEG(context).count) {
	    l_REAL(output, MPEG(context).l3band_data[index].frequency);
	}
    }
# endif				/* __ENABLE_MPEG_EQUALIZER__ */

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_080716_6(void *context, void *output, void **input)
{
# if __ENABLE_MPEG_EQUALIZER__
    Mylene1f4_add_mode(context, I_REAL(input[0]));
# endif				/* __ENABLE_MPEG_EQUALIZER__ */

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __RESET_MPEG_EQUALIZER__
static int
nonsense_080716_7(void *context, void *output, void **input)
{
# if __ENABLE_MPEG_EQUALIZER__
# endif				/* __ENABLE_MPEG_EQUALIZER__ */

    return 0;
}
#endif				/* __RESET_MPEG_EQUALIZER__ */


#if __ENABLE_EQUEUE__
static int
nonsense_080716_8(void *context, void *output, void **input)
{
# if __ENABLE_MPEG_EQUALIZER__
    l_REAL(output, MPEG(context).amplification);
# endif				/* __ENABLE_MPEG_EQUALIZER__ */

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_080806_0(void *context, void *output, void **input)
{
    return fix_field(context, output, &LBASE(context));
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_080806_1(void *context, void *output, void **input)
{
    return fix_field(context, output, &LPATH(context));
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_080806_2(void *context, void *output, void **input)
{
    return swap_data(&LBASE(context), &Lbase(context));
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_080806_3(void *context, void *output, void **input)
{
    return swap_data(&LPATH(context), &Lpath(context));
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_080806_4(void *context, void *output, void **input)
{
    return set_field(context, input, &LBASE(context), &Lbase(context));
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_080806_5(void *context, void *output, void **input)
{
    return set_field(context, input, &LPATH(context), &Lpath(context));
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_081107_0(void *context, void *output, void **input)
{
    Mylene1f4_send_mylene0fa(context, 0x20, NULL);

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_081114_1(void *context, void *output, void **input)
{
    Mylene1f4_swap_progress
	(context, &PROGRESS1(context), Frame4(context)->progress1);

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_081114_2(void *context, void *output, void **input)
{
    Mylene1f4_swap_progress
	(context, &PROGRESS2(context), Frame4(context)->progress2);

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_081114_3(void *context, void *output, void **input)
{
    Mylene1f4_swap_progress
	(context, &PROGRESS3(context), Frame4(context)->progress3);

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_081115_1(void *context, void *output, void **input)
{
    set_progress(context, &PROGRESS1(context), Frame4(context)->progress1,
		 I_TEXT(input[0]));

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_081115_2(void *context, void *output, void **input)
{
    set_progress(context, &PROGRESS2(context), Frame4(context)->progress2,
		 I_TEXT(input[0]));

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_081115_3(void *context, void *output, void **input)
{
    set_progress(context, &PROGRESS3(context), Frame4(context)->progress3,
		 I_TEXT(input[0]));

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __E1211_LIBRARY__
static int
nonsense_081211_0(void *context, void *output, void **input)
{
    l_MODE(output, ~Frame4(context)->i144.post);

    return 0;
}
#endif				/* __E1211_LIBRARY__ */


#if __E1211_LIBRARY__
static int
nonsense_081211_3(void *context, void *output, void **input)
{
    unsigned load_order;

    load_order = LOAD_ORDER(context);
    if (load_order == Mylene1f4_LOAD_RAND) {
	l_MODE(output, 0);
    } else {
	X1f4_E4_C_MODE mode;
	struct frame4_type *frame4_data;
	unsigned post;

	frame4_data = Frame4(context);

	post = frame4_data->i144.post;
	if (!frame4_data->i144.last) {
	    post = ~0;
	}
	if (!~post) {
	    if (load_order == Mylene1f4_LOAD_LAST) {
		mode = 1;
	    } else {
		mode = -1;
	    }
	} else {
	    if (frame4_data->i144.sign != Mylene1f4_LOAD_NEXT) {
		mode = post;
	    } else {
		mode = -post;
	    }
	}

	l_MODE(output, mode);
    }

    return 0;
}
#endif				/* __E1211_LIBRARY__ */


#if __E1211_LIBRARY__
static int
nonsense_081211_4(void *context, void *output, void **input)
{
    unsigned load_order;

    load_order = LOAD_ORDER(context);
    if (load_order == Mylene1f4_LOAD_RAND) {
	l_MODE(output, 0);
    } else {
	X1f4_E4_C_MODE mode;
	struct frame4_type *frame4_data;
	unsigned post;

	frame4_data = Frame4(context);

	post = frame4_data->i144.post;
	if (!frame4_data->i144.last) {
	    post = ~0;
	}
	if (!~post) {
	    if (load_order == Mylene1f4_LOAD_NEXT) {
		mode = 1;
	    } else {
		mode = -1;
	    }
	} else {
	    if (frame4_data->i144.sign != Mylene1f4_LOAD_LAST) {
		mode = post;
	    } else {
		mode = -post;
	    }
	}

	l_MODE(output, mode);
    }

    return 0;
}
#endif				/* __E1211_LIBRARY__ */


#if __ENABLE_EQUEUE__
static int
nonsense_090214_0(void *context, void *output, void **input)
{
    l_MODE(output, !(FLAGS(context) & Mylene1f4_TILED_LIST) ? 0 : 1);

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_090214_1(void *context, void *output, void **input)
{
    l_MODE(output, !(FLAGS(context) & Mylene1f4_TILED_LIST) ? 1 : 0);

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_090706_0(void *context, void *output, void **input)
{
    X1f4_E4_C_MODE mode;
    unsigned deck, miss;

    mode = I_MODE(input[0]);
    if (mode < 0) {
	deck = 1;
	miss = -mode;
    } else {
	deck = 0;
	miss = +mode;
    }

    return Mylene1f4_lock_i144(context, 0x34, deck, miss);
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_090706_1(void *context, void *output, void **input)
{
    X1f4_E4_C_MODE mode;
    unsigned deck, miss;

    mode = I_MODE(input[0]);
    if (mode < 0) {
	deck = 1;
	miss = -mode;
    } else {
	deck = 0;
	miss = +mode;
    }

    return Mylene1f4_lock_i144(context, 0x35, deck, miss);
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_110211_0(void *context, void *output, void **input)
{
    int status;
    struct equeue_type *equeue_data;
    struct frame4_type *frame4_data;
    struct report_type *report_data;

    frame4_data = Frame4(context);

    equeue_data = frame4_data->dana.equeue;

    report_data = equeue_data->head_report;
    if (report_data) {
	struct report_type *post_report;

	post_report = report_data->report_data;

	status = Mylene1f4_free_moon(frame4_data, report_data);
	if (status) {
	} else {
	    if (post_report) {
		equeue_data->head_report = post_report;
	    } else {
		equeue_data->head_report = NULL;
		equeue_data->tail_report = NULL;
	    }
	}
    } else {
	status = 0;
    }

    return status;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_110211_1(void *context, void *output, void **input)
{
    l_MODE(output, equeue(Frame4(context)->dana.equeue)->head_report ? 1 : 0);

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_110211_2(void *context, void *output, void **input)
{
    struct report_type *report_data;

    report_data = equeue(Frame4(context)->dana.equeue)->head_report;

    l_TEXT(output, report_data ? (char *) (report_data + 1) : "");

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_110222_0(void *context, void *output, void **input)
{
    X1f4_E4_C_TEXT text;

    text = I_TEXT(input[2]);

    Mylene1f4_link_note
	(context, I_MODE(input[0]), I_MODE(input[1]), strlen(text) + 1, text);

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_130701_0(void *context, void *output, void **input)
{
    l_MODE(output, Frame4(context)->already);

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_140324_0(void *context, void *output, void **input)
{
    int delete;
    void *states;

    states = Frame4(context)->line.states;
    if (states) {
	void *data;

	delete = x1f4_find_sfnote(states, I_TEXT(input[0]), &data);
	if (delete) {
	    int *call;

	    call = data;
	    if (*call ^ INTEGER_STATE) {
		delete = 0;
	    } else {
		l_MODE(input[1], call[1]);
	    }
	}
    } else {
	delete = 0;
    }

    l_MODE(output, delete);

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_140324_1(void *context, void *output, void **input)
{
    void *data;

    if (call_state
	(context, I_TEXT(input[0]), INTEGER_STATE, sizeof(int), &data)) {
	int *call;

	call = data;
	call[0] = I_MODE(input[1]);
    }

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_140324_2(void *context, void *output, void **input)
{
    int delete;
    struct frame4_type *frame4_data;
    void *states;

    frame4_data = Frame4(context);

    states = frame4_data->line.states;
    if (states) {
	void *data;

	delete = x1f4_find_sfnote(states, I_TEXT(input[0]), &data);
	if (delete) {
	    int *call;

	    call = data;
	    if (*call ^ TEXT_STATE) {
		delete = 0;
	    } else {
		char *text;
		unsigned size;

		text = (void *) (call + 1);

		size = strlen(text) + 1;
		if (Mylene1f4_link_moon(frame4_data, &data, size)) {
		    delete = 0;
		} else {
		    memcpy(data, text, size);

		    text = I_TEXT(input[1]);
		    if (text != x1f4_c1_empty_string) {
			Mylene1f4_free_moon(frame4_data, text);
		    }

		    l_TEXT(input[1], data);
		}
	    }
	}
    } else {
	delete = 0;
    }

    l_MODE(output, delete);

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_140324_3(void *context, void *output, void **input)
{
    X1f4_E4_C_TEXT text;
    unsigned size;
    void *data;

    text = I_TEXT(input[1]);

    size = strlen(text) + 1;

    if (call_state(context, I_TEXT(input[0]), TEXT_STATE, size, &data)) {
	memcpy(data, text, size);
    }

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
set_field(void *context, void **input, struct string_type *major,
	  struct string_type *minor)
{
    int status = 0;

    do {
	char *data;
	unsigned size;

	data = I_TEXT(((void **) input)[0]);
	size = strlen(data);

	if (!size) {
	    data = NULL;
	} else {
	    char *slip;
	    unsigned i;

	    slip = data;
	    i = size;
	    for (; i; i--) {
		if (*slip != '*') {
		    break;
		} else {
		    slip++;
		}
	    }
	    if (!i) {
		data = NULL;
		size = 0;
	    } else {
		unsigned l = 0, s = 1, v = 1;

		slip = data;
		i = size;
		for (; i; i--) {
		    s = v;
		    v = *slip == '*' ? 0 : 1;
		    l += s | v;
		    slip++;
		}

		{
		    char *swap;

		    swap = (char *) malloc(l + 1);
		    if (!swap) {
			status = 1;

			break;
		    } else {
			slip = data;
			data = swap;
			i = size;
			size = l;
			s = 1;
			v = 1;
			for (; i; i--) {
			    s = v;
			    v = *slip == '*' ? 0 : 1;
			    if (s | v) {
				*swap++ = *slip;
			    }
			    slip++;
			}

			*swap = 0;
		    }
		}
	    }
	}

	if (SLACK(context).size < size) {
	    char *Swap;

	    Swap = (char *) malloc(size);
	    if (!data) {
		status = 1;

		free(data);

		break;
	    } else {
		char *swap;

		swap = SLACK(context).data;

		SLACK(context).data = Swap;
		SLACK(context).size = size;

		if (swap) {
		    free(swap);
		}
	    }
	}

	{
	    char *text;

	    text = (char *) major->data;

	    major->data = data;
	    major->size = size;

	    if (text != minor->data) {
		if (text) {
		    free(text);
		}
	    }
	}
    } while (0);

    return status;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
set_progress(void *context, void **third, void *minor, const char *data)
{
    void *c_format;

    if (!Mylene1f4_init_format(context, data, &c_format)) {
	void *major;

	major = *third;

	*third = c_format;

	if (major != minor) {
	    if (major) {
		Mylene1f4_fini_format(context, &major);
	    }
	}
    }

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
snow_white(void *address, const char *data, unsigned size)
{
    char **line, *miss;

    line = address;
    miss = *line;
    memcpy(miss, data, size);
    *line = miss + size;

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */
