/*
 * aime5.c
 * Copyright (C) 2007-2014, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#if __ENABLE_EQUEUE__
# include <aime.h>
# if defined HAVE_LIBLEWD
#  include <lewd.h>
# endif				/* HAVE_LIBLEWD */
# if defined HAVE_LIBx1f4l0
#  include <libx1f4l0.h>
# endif				/* HAVE_LIBx1f4l0 */
# include <stddef.h>
# include <stdlib.h>
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# include <access.h>
# include <aime1.h>
# include <defs.h>
# include <excess4.h>
# include <excess7.h>
# include <inter.h>
# include <types.h>
# if !defined HAVE_LIBLEWD
#  include <vtkey.h>
# endif				/* !HAVE_LIBLEWD */
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define ABORT_CLASS			1
# define BECCA_CLASS			2
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define SLIP_AIME			slip_aime
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define I_MODE(i)			(*((X1f4_E4_C_MODE *) (i)))
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define Frame4(context) \
    ((struct frame4_type *) &Frame7((context))->_1.frame4)
# define Frame7(context) \
    ((struct frame7_type *) WINDOW((context)).server.window)
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define a1text(context) \
    ((struct a1text_type *) Frame4((context))->a1text)
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define e1text(context) \
    ((struct e1text_state *) Frame4((context))->e1text)
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define e4text(context) \
    ((struct e4text_type *) Frame4((context))->lxdeck)
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
typedef struct e1text_state {
    int delete, linked;
    unsigned consolidated;
    void *functions[2];
} e1text_state;
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
extern const struct x1f4_function_type _Mylene1f4_aime_1_F__[],
    _Mylene1f4_aime_1_I_3[], _Mylene1f4_aime_1_I__[], _Mylene1f4_aime_1_L_3[],
    _Mylene1f4_aime_1_L__[], _Mylene1f4_aime_1___3[], _Mylene1f4_aime_1____[],
    _Mylene1f4_aime_1_q_l[], _Mylene1f4_aime_1_q_s[], _Mylene1f4_aime_3_F__[],
    _Mylene1f4_aime_3_L_2[], _Mylene1f4_aime_3_L__[], _Mylene1f4_aime_3_R__[],
    _Mylene1f4_aime_3_S__[], _Mylene1f4_filter_F__[],
    _Mylene1f4_filter_N__[], _Mylene1f4_filter_U__[];
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
static int init_1fix(struct sample_type *, struct e1text_state *, void *);
static int init_2fix(struct sample_type *, struct e1text_state *, void *);
static int init_aime(void *, struct equeue_type *, int);
static int init_text(void *);
static int line_text(void *);
static int nonsense_081103_0(void *, void *, void **);
static int nonsense_081103_1(void *, void *, void **);
static int nonsense_081123_0(void *, void *, void **);
static int nonsense_130311_0(void *, void *, void **);
static int port_aime(void *, struct equeue_type *, int);
static int slip_aime(void *, struct equeue_type *);
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
static void fini_text(void *, struct e1text_state *);
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
static const int c_____m__[] = {
/* *INDENT-OFF* */
    X1f4_E4_MODE
/* *INDENT-ON* */
};
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
const struct x1f4_function_type _Mylene1f4_aime_5_F_2[] = {
/* *INDENT-OFF* */
    {	"F_skip",		nonsense_130311_0,
	X1f4_E4_VOID,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						6			},
    {	NULL,			NULL,
	0,			NULL,		0,
	0,					1			}
/* *INDENT-ON* */
}, _Mylene1f4_aime_5_F__[] = {
/* *INDENT-OFF* */
    {	"F_abort",		nonsense_081103_0,
	X1f4_E4_VOID,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						7			},
    {	"F_interrupt",		nonsense_081103_1,
	X1f4_E4_VOID,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						11			},
    {	"F_suspend",		nonsense_081123_0,
	X1f4_E4_VOID,		c_____m__,	1,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						9			},
    {	NULL,			NULL,
	0,			NULL,		0,
	0,					1			}
/* *INDENT-ON* */
};
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
static const struct x1f4_function_type *NON_mets[] = {
/* *INDENT-OFF* */
    _Mylene1f4_aime_1_F__,
    _Mylene1f4_aime_1_I_3,
    _Mylene1f4_aime_1_I__,
    _Mylene1f4_aime_1_L_3,
    _Mylene1f4_aime_1_L__,
    _Mylene1f4_aime_1___3,
    _Mylene1f4_aime_1____,
    _Mylene1f4_aime_1_q_l,
    _Mylene1f4_aime_1_q_s,
    _Mylene1f4_aime_3_F__,
    _Mylene1f4_aime_3_L_2,
    _Mylene1f4_aime_3_L__,
    _Mylene1f4_aime_3_R__,
    _Mylene1f4_aime_3_S__,
    _Mylene1f4_aime_5_F_2,
    _Mylene1f4_aime_5_F__,
    _Mylene1f4_filter_F__,
    _Mylene1f4_filter_N__,
    _Mylene1f4_filter_U__,
    NULL
/* *INDENT-ON* */
}, *NON_sets[] = {
/* *INDENT-OFF* */
    _Mylene1f4_aime_1_F__,
    _Mylene1f4_aime_1_I_3,
    _Mylene1f4_aime_1_I__,
    _Mylene1f4_aime_1_L_3,
    _Mylene1f4_aime_1_L__,
    _Mylene1f4_aime_1___3,
    _Mylene1f4_aime_1____,
    _Mylene1f4_aime_1_q_l,
    _Mylene1f4_aime_1_q_s,
    _Mylene1f4_aime_3_F__,
    _Mylene1f4_aime_3_L_2,
    _Mylene1f4_aime_3_L__,
    _Mylene1f4_aime_3_R__,
    _Mylene1f4_aime_3_S__,
    _Mylene1f4_aime_5_F__,
    _Mylene1f4_filter_F__,
    _Mylene1f4_filter_N__,
    _Mylene1f4_filter_U__,
    NULL
/* *INDENT-ON* */
};
static const struct x1f4_linetext_type *NON_nets[] = {
/* *INDENT-OFF* */
    NULL
/* *INDENT-ON* */
};
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
static int
init_1fix(struct sample_type *sample_data, struct e1text_state *e1text_data,
	  void *context)
{
    int status;

    if (e1text_data->linked) {
	status = 0;
	sample_data->operator1s = a1text(context)->prefixing;
    } else {
	status = Mylene1f4_push_aime(context);
	if (status) {
	} else {
	    e1text_data->linked = 1;
	    sample_data->operator1s = a1text(context)->prefixing;
	}
    }

    return status;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
init_2fix(struct sample_type *sample_data, struct e1text_state *e1text_data,
	  void *context)
{
    int status;

    if (e1text_data->linked) {
	status = 0;
	sample_data->operator2s = a1text(context)->operators;
    } else {
	status = Mylene1f4_push_aime(context);
	if (status) {
	} else {
	    e1text_data->linked = 1;
	    sample_data->operator2s = a1text(context)->operators;
	}
    }

    return status;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
init_aime(void *context, struct equeue_type *equeue_data, int index)
{
    int status;
    struct e1text_state *e1text_data;
    struct frame4_type *frame4_data;
    struct sample_type sample;

    frame4_data = Frame4(context);

    e1text_data = frame4_data->e1text;

    status = init_2fix(&sample, e1text_data, context);
    if (status) {
    } else {
	status = init_1fix(&sample, e1text_data, context);
	if (status) {
	} else {
	    sample.function_set.miss = e1text_data->functions[index];

	    status = Mylene1f4_pick_aime(context, equeue_data, &sample);
	}
    }

    return status;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
init_text(void *context)
{
    int status;

    status = line_text(context);
    if (status) {
    } else {
	struct e1text_state *e1text_data;

	e1text_data = (struct e1text_state *)
	    malloc(sizeof(struct e1text_state));
	if (!e1text_data) {
	    status = -1;
	} else {
	    status = 0;

	    e1text_data->functions[0] = NULL;
	    e1text_data->functions[1] = NULL;

	    e1text_data->linked = 0;

	    e1text_data->consolidated = WINDOW(context).server.intermiss;

	    Frame4(context)->e1text = e1text_data;
	}
    }

    return status;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
line_text(void *context)
{
    int status;

    status = Mylene1f4_line_filter(context);
    if (status) {
    } else {
	status = Mylene1f4_line_e4lx(context);
    }

    return status;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_081103_0(void *context, void *output, void **input)
{
    e1text(context)->delete = ABORT_CLASS;

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_081103_1(void *context, void *output, void **input)
{
    e1text(context)->delete = BECCA_CLASS;

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_081123_0(void *context, void *output, void **input)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    if (frame4_data->flags & Mylene1f4_AIME_LINKED) {
	X1f4_E4_C_MODE mode;
	unsigned post, sign, tail;

	mode = I_MODE(input[0]);
	if (mode < 0) {
	    post = -mode;
	    sign = 1;
	} else {
	    post = mode;
	    sign = 0;
	}

	tail = frame4_data->iqueue.lqueue;

	if (tail + sign < post) {
	} else {
	    if (Mylene1f4_back_aime(context)) {
	    } else {
		if (sign) {
		    post = tail + 1 - post;
		}

		frame4_data->logic = Mylene1f4_link_aime;

		if (post) {
		    Mylene1f4_push_equeue(context, post + 1);
		}
	    }
	}
    }

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
nonsense_130311_0(void *context, void *output, void **input)
{
    Frame4(context)->request = Mylene1f4_SKIP_Mylene;

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
port_aime(void *context, struct equeue_type *equeue_data, int index)
{
    int false;

    if (equeue_data->bits & Mylene1f4_INTERN_LOGIC) {
	false = SLIP_AIME(context, equeue_data);
    } else {
	do {
	    int status;

	    {
		struct e1text_state *e1text_data;

		e1text_data = Frame4(context)->e1text;
		if (e1text_data->functions[index]) {
		} else {
		    status = Mylene1f4_line_aime
			(e1text_data->functions + index,
			 e4text(context)->indexset, NON_nets,
			 index ? NON_mets : NON_sets);
		    if (status) {
			false = 1;
			break;
		    }
		}
	    }

	    status = init_aime(context, equeue_data, index);
	    if (status) {
		false = 1;
	    } else {
		false = SLIP_AIME(context, equeue_data);
	    }
	} while (0);
    }

    return false;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
slip_aime(void *context, struct equeue_type *equeue_data)
{
    int false, (*tail) (void *);
    struct e1text_state *e1text_data;
    struct frame4_type *frame4_data;
    void *aime;

    frame4_data = Frame4(context);

# if __ENABLE_CHANNEL_SERVER__
    frame4_data->channel = equeue_data->channel;
    frame4_data->client_id = equeue_data->client;
# endif				/* __ENABLE_CHANNEL_SERVER__ */

    aime = equeue_data->data.aime;

    e1text_data = e1text(context);

    e1text_data->delete = 0;

    tail = equeue_data->fine.tail;

    if (tail(aime)) {
	false = 1;
    } else {
	int (*flat) (void **), (*slip) (void *);
	unsigned interrupt, run = 0;
	void *deck;

	interrupt = WINDOW(context).server.interrupt;
	if (1) {
	    unsigned intermiss;

	    intermiss = e1text_data->consolidated;
	    if (intermiss) {
		if (intermiss < interrupt) {
		    interrupt = intermiss;
		}
	    }
	}

	frame4_data->dana.eport = equeue_data->slip.aime.e8port;

	frame4_data->dana.equeue = equeue_data;

	frame4_data->dana.flat = 0;

	deck = equeue_data->deck.data;
	flat = equeue_data->deck.flat;

	slip = equeue_data->fine.slip;

	while (1) {
	    int status;

	    status = slip(aime);

	    if (frame4_data->dana.flat) {
		int excess;

		frame4_data->dana.flat = 0;

		excess = flat(&deck);
		if (excess) {
		    if (status) {
		    } else {
			status = excess;
		    }
		}
	    }

	    if (status) {
		if (equeue_data->bits & Mylene1f4_FAILED_LOGIC) {
		} else {
		    Mylene1f4_fail_aime(context, equeue_data);
		}

		false = 1;

		break;
	    } else {
		if (tail(aime)) {
		    false = 1;
		    break;
		} else {
		    int delete;

		    delete = e1text(context)->delete;
		    if (delete) {
			if (delete == ABORT_CLASS) {
			    false = 1;
			} else {
			    false = 0;
			}

			break;
		    } else {
			if (interrupt) {
			    if (run == interrupt) {
				if (run == WINDOW(context).server.interrupt) {
				    Mylene1f4_ceil_aime
					(context, equeue_data->name);
				} else {
				    Mylene1f4_cell_aime(context);

				    e1text_data->consolidated = 0;
				}

				false = 1;

				break;
			    } else {
				run++;
			    }
			}
		    }
		}
	    }
	}

	equeue_data->slip.aime.e8port = frame4_data->dana.eport;

	if (1) {
	    unsigned intermiss;

	    intermiss = e1text_data->consolidated;
	    if (intermiss) {
		e1text_data->consolidated = intermiss - run;
	    }
	}
    }

    return false;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static void
fini_text(void *context, struct e1text_state *e1text_data)
{
    unsigned i;
    void *data;

    if (e1text_data->linked) {
	Mylene1f4_miss_aime(context);
    }

    for (i = 0; i < 2; i++) {
	data = e1text_data->functions[i];
	if (data) {
	    x1f4_fini_mxdeck(&data);
	}
    }

    free(e1text_data);
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
int
Mylene1f4_class_aime(void *context)
{
    struct e1text_state *e1text_data;

    e1text_data = Frame4(context)->e1text;
    if (e1text_data) {
	fini_text(context, e1text_data);
    }

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
int
Mylene1f4_port_aime(void *context, void *stripe, int index)
{
    struct e1text_state *e1text_data;
    struct equeue_type *equeue_data, *link_equeue = NULL;
    struct iqueue_type *iqueue_data;
    unsigned lqueue, rqueue;

    iqueue_data = &(*(struct stripe_type **) stripe)->iqueue;

    lqueue = iqueue_data->lqueue;
    rqueue = lqueue;

    equeue_data = iqueue_data->head_equeue;

    e1text_data = e1text(context);
    if (e1text_data) {
    } else {
	init_text(context);
	e1text_data = e1text(context);
    }
    if (e1text_data) {
	e1text_data->consolidated = WINDOW(context).server.intermiss;

	do {
	    if (port_aime(context, equeue_data, index)) {
		struct equeue_type *post_equeue;

		post_equeue = equeue_data->equeue_data;

		Mylene1f4_free_equeue(context, equeue_data);

		equeue_data = post_equeue;

		rqueue--;

		if (post_equeue) {
		    if (link_equeue) {
			link_equeue->equeue_data = post_equeue;
		    } else {
			iqueue_data->head_equeue = post_equeue;
		    }
		} else {
		    if (link_equeue) {
			link_equeue->equeue_data = NULL;
			iqueue_data->tail_equeue = link_equeue;
		    } else {
			iqueue_data->head_equeue = NULL;
			iqueue_data->tail_equeue = NULL;
		    }
		}
	    } else {
		link_equeue = equeue_data;
		equeue_data = equeue_data->equeue_data;
	    }

	    lqueue--;

	    if (e1text_data->consolidated) {
	    } else {
		if (WINDOW(context).server.intermiss) {
		    rqueue = 0;
		    Mylene1f4_fini_iqueue
			(context, iqueue_data->head_equeue, iqueue_data);
		    break;
		}
	    }

	    if (Frame4(context)->request == Mylene1f4_SKIP_Mylene) {
		break;
	    }
	} while (lqueue);
    }

    if (rqueue) {
	iqueue_data->lqueue = rqueue;
    } else {
	void **extent;

	extent = stripe;
	free(*extent);
	*extent = NULL;
    }

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
int
Mylene1f4_reset_aime(void *context)
{
    Frame4(context)->e1text = NULL;

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */
