/*
 * aime6.c
 * Copyright (C) 2007-2014, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#if __ENABLE_EQUEUE__
# include <aime.h>
# include <stddef.h>
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# include <access.h>
# include <excess4.h>
# include <excess7.h>
# include <inter.h>
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define equeue(equeue) \
    ((struct equeue_type *) (equeue))
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define frame4(frame4) \
    ((struct frame4_type *) (frame4))
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define Frame4(context) \
    ((struct frame4_type *) &Frame7((context))->_1.frame4)
# define Frame7(context) \
    ((struct frame7_type *) WINDOW((context)).server.window)
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
int
Mylene1f4_ceil_aime(void *context, const char *name)
{
    Mylene1f4_fprintf_error
	(context, "%s: stopping program", Mylene1f4(context));
    if (name) {
	Mylene1f4_fprintf_error(context, " `%s'", name);
    }
    Mylene1f4_fprintf_error
	(context, " execution for just exceeding uninterrupted instruction e"
	 "xecution count limit (%u)\n", WINDOW(context).server.interrupt);

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
int
Mylene1f4_cell_aime(void *context)
{
    Mylene1f4_fprintf_error
	(context, "%s: stopping context execution for just exceeding uninter"
	 "rupted instruction execution count limit (%u)\n", Mylene1f4(context),
	 WINDOW(context).server.intermiss);

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
int
Mylene1f4_fail_aime(void *context, void *equeue)
{
    unsigned line;

    equeue(equeue)->june.look(equeue(equeue)->data.aime, &line);
    if (1) {
	const char *rate;

	rate = equeue(equeue)->rate;
	if (rate) {
	    unsigned copy;

	    copy = line;
	    line = 1;
	    while (copy) {
		if (*rate == 10) {
		    line++;
		}

		copy--;
		rate++;
	    }
	}
    }

    Mylene1f4_fprintf_error
	(context, "%s: cannot execute program (line %d)\n", Mylene1f4(context),
	 line);

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
int
Mylene1f4_stat_aime(void *context, char *this, char *data, int error,
		    int shuffle, void *b1record)
{
    Mylene1f4_fprintf_error(context, "%s: cannot intern", Mylene1f4(context));
    if (this) {
	Mylene1f4_fprintf_error(context, " `%s'", this);
    }
    Mylene1f4_fprintf_error(context, " program execution request\n");
    if (error == X1f4_C1_ALLOC_ERROR) {
    } else {
	struct x1f4_eelookup_type e4lookup;
	struct x1f4_indexset_type *indexset_data;

	indexset_data =
	    ((struct e4text_type *) Frame4(context)->lxdeck)->indexset;

	e4lookup.type_l.fix = x1f4_look_indexset;
	e4lookup.type_l.context = indexset_data;
	e4lookup.type_q.e4fine = indexset_data->transfer_set.fine;

	Mylene1f4_fprintf_error(context, "%s: ", Mylene1f4(context));
	if (this) {
	    Mylene1f4_fprintf_error(context, "%s: ", this);
	}
	if (shuffle) {
	    struct x1f4_a1record_type *a1record_data;

	    a1record_data = b1record;

	    a1record_data->pick = 1;

	    x1f4_stat_shuffle
		(context, Mylene1f4_fprintc_error, data, b1record, &e4lookup);
	} else {
	    struct x1f4_c1record_type *c1record_data;

	    c1record_data = b1record;

	    c1record_data->pick = 1;

	    x1f4_stat_program
		(context, Mylene1f4_fprintc_error, data, b1record, &e4lookup);
	}

	Mylene1f4_fprintf_error(context, "\n");
    }

    Mylene1f4_fprintf_error
	(context, "%s: the failed program was:\n%s\n", Mylene1f4(context),
	 data);

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */
