/*
 * aime7.c
 * Copyright (C) 2007-2013, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#if __ENABLE_EQUEUE__
# include <aime.h>
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# include <aime1.h>
# include <inter.h>
# include <types.h>
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
extern struct x1f4_cxflat_type _Mylene1f4_e4lx_flat_types[];
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
static int link_list(void *, const struct x1f4_function_type *);
static int link_text(void *, const struct x1f4_linetext_type *);
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
static int
link_list(void *deck, const struct x1f4_function_type *function_data)
{
    const char *name;
    int flat, status = 0;

    flat = _Mylene1f4_e4lx_flat_types[0].type;

    name = function_data->name;
    while (name) {
	status = x1f4_post_mxpath
	    (deck, name, function_data->length, function_data);
	if (status) {
	    break;
	} else {
	    int type;
	    unsigned count;

	    type = function_data->type;
	    if (type == Mylene1f4_L7_DECK) {
		((struct x1f4_function_type *) function_data)->type = flat;
	    }

	    count = function_data->count;
	    if (count) {
		int *args;

		args = (int *) function_data->args;
		for (; count; count--) {
		    if (*args == Mylene1f4_L7_DECK) {
			*args = flat;
		    }

		    args++;
		}
	    }

	    function_data++;
	    name = function_data->name;
	}
    }

    return status;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
link_text(void *deck, const struct x1f4_linetext_type *linetext_data)
{
    const struct x1f4_function_type *function_data;
    const char *name;
    int status = 0;

    function_data = &linetext_data->function;
    name = function_data->name;
    while (name) {
	status = x1f4_post_mxpath
	    (deck, name, function_data->length, function_data);
	if (status) {
	    break;
	} else {
	    linetext_data++;
	    function_data = &linetext_data->function;
	    name = function_data->name;
	}
    }

    return status;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
int
Mylene1f4_line_aime(void **sets, void *indexset, void *NON_nets,
		    void *NON_sets)
{
    int status;
    void *miss;

    status = x1f4_copy_mxdeck
	(&miss, ((struct x1f4_indexset_type *) indexset)->function_set.text);

    if (status) {
    } else {
	const struct x1f4_function_type *function_data, **sets;

	sets = NON_sets;

	function_data = *sets;
	while (function_data) {
	    status = link_list(miss, function_data);
	    if (status) {
		break;
	    } else {
		sets++;
		function_data = *sets;
	    }
	}
    }

    if (status) {
    } else {
	const struct x1f4_linetext_type **nets;

	nets = NON_nets;

	if (1) {
	    const struct x1f4_linetext_type *linetext_data;

	    linetext_data = *nets;
	    while (linetext_data) {
		status = link_text(miss, linetext_data);
		if (status) {
		    break;
		} else {
		    nets++;
		    linetext_data = *nets;
		}
	    }
	}
    }

    if (status) {
	x1f4_fini_mxdeck(&miss);
    } else {
	*sets = miss;
    }

    return status;
}
#endif				/* __ENABLE_EQUEUE__ */
