/*
 * aime8.c
 * Copyright (C) 2007-2014, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#if __ENABLE_EQUEUE__
# include <aime.h>
# include <stddef.h>
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# include <aime1.h>
# include <inter.h>
# include <types.h>
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define M500_L7_LIST			Mylene1f4_L7_LIST
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define Q___sets_count(Q___sets) \
    (sizeof((Q___sets)) / sizeof(struct x1f4_function_type *))
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
extern const struct x1f4_function_type _Mylene1f4_aime_1_F__[],
    _Mylene1f4_aime_1_I_2[], _Mylene1f4_aime_1_I_3[], _Mylene1f4_aime_1_I__[],
    _Mylene1f4_aime_1_L_2[], _Mylene1f4_aime_1_L_3[], _Mylene1f4_aime_1_L__[],
    _Mylene1f4_aime_1___3[], _Mylene1f4_aime_1____[], _Mylene1f4_aime_1_q_l[],
    _Mylene1f4_aime_1_q_s[], _Mylene1f4_aime_3_F__[], _Mylene1f4_aime_3_L_2[],
    _Mylene1f4_aime_3_L__[], _Mylene1f4_aime_3_R__[],
    _Mylene1f4_aime_3_S__[], _Mylene1f4_aime_5_F__[], _Mylene1f4_aime_5_F_2[],
    _Mylene1f4_aime___E__[], _Mylene1f4_aime___F__[], _Mylene1f4_filter_F__[],
    _Mylene1f4_filter_N__[], _Mylene1f4_filter_U__[];
extern const struct x1f4_operator_type *_Mylene1f4_aime_3_B[];
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
static int list_lead(void *, const void *, void *, int);
static int list_text(void *, const void *, void *);
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
static void dump_functions(void *);
static void dump_operators(void *, int);
static void list_0010(void *, void *,
		      int (*) (const struct x1f4_lxnote_type **),
		      int (*fset) (void *,
				   const struct x1f4_linetext_type **));
static void list_0011(void *, void *,
		      int (*) (const struct x1f4_lxnote_type **),
		      int (*fset) (void *,
				   const struct x1f4_linetext_type **), int);
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
static const struct x1f4_function_type *Q_F_sets[] = {
/* *INDENT-OFF* */
    _Mylene1f4_aime_1_F__,
    _Mylene1f4_aime_3_F__,
    _Mylene1f4_aime___F__
/* *INDENT-ON* */
}, *Q_f_sets[] = {
/* *INDENT-OFF* */
    _Mylene1f4_aime_1_F__,
    _Mylene1f4_aime_3_F__,
    _Mylene1f4_aime_5_F__
/* *INDENT-ON* */
}, *Q_L_sets[] = {
/* *INDENT-OFF* */
    _Mylene1f4_aime_1_L__,
    _Mylene1f4_aime_3_L__
/* *INDENT-ON* */
};
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
static int
list_lead(void *context, const void *text, void *indexset, int c)
{
    const char *name;
    const struct x1f4_linetext_type *linetext_data;

    linetext_data = text;

    name = linetext_data->function.name;
    while (name) {
	if (*name == c) {
	    x1f4_print_htfunction
		(stdout, &linetext_data->function, "    ", indexset,
		 x1f4_look_indexset);
	}
	linetext_data++;
	name = linetext_data->function.name;
    }

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
list_text(void *context, const void *text, void *indexset)
{
    const char *name;
    const struct x1f4_linetext_type *linetext_data;

    linetext_data = text;

    name = linetext_data->function.name;
    while (name) {
	x1f4_print_htfunction
	    (stdout, &linetext_data->function, "    ", indexset,
	     x1f4_look_indexset);
	linetext_data++;
	name = linetext_data->function.name;
    }

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static void
dump_functions(void *context)
{
    int class, frame;
    struct x1f4_indexset_type indexset;

    frame = !Mylene1f4_fast_e4lx(context, NULL, &class, &indexset);

    puts("\
Math and text functions:");
    x1f4_print_hfunctions(stdout, x1f4_e4_defaults, "    ");
    if (frame) {
	puts("\n\
Text functions:");
	list_0010(context, &indexset, x1f4_note_lxtext, x1f4_fset_lxtext);
    }
    puts("\n\
Text functions (continued):");
    x1f4_print_hfunctions(stdout, _Mylene1f4_filter_U__, "    ");
    if (frame) {
	puts("\n\
List functions:");
	list_0010(context, &indexset, x1f4_note_lxlist, x1f4_fset_lxlist);
	puts("\n\
String map functions:");
	list_0010(context, &indexset, x1f4_note_lxline, x1f4_fset_lxline);
	puts("\n\
Date and time functions:");
	list_0010(context, &indexset, x1f4_note_lxdate, x1f4_fset_lxdate);
	puts("\n\
Byte array functions:");
	list_0010(context, &indexset, x1f4_note_lxdata, x1f4_fset_lxdata);
	puts("\n\
Typeless interfaces functions:");
	list_0010(context, &indexset, x1f4_note_lxcast, x1f4_fset_lxcast);
    }
    puts("\n\
File attributes retrieving functions:");
    x1f4_print_hfunctions(stdout, _Mylene1f4_filter_F__, "    ");
    puts("\n\
State retrieving functions:");
    x1f4_print_hfunctions(stdout, _Mylene1f4_filter_N__, "    ");
    puts("\n\
State retrieving functions (continued):");
    x1f4_print_hfunctions(stdout, _Mylene1f4_aime_1____, "    ");
    puts("\n\
State retrieving functions (continued):");
    Mylene1f4_list_sets(NULL, Q_L_sets, Q___sets_count(Q_L_sets));
    puts("\n\
State retrieving functions (concluded):");
    x1f4_print_htfunctions
	(stdout, _Mylene1f4_aime_1_I__, "    ", NULL, Mylene1f4_look_aime);
    puts("\n\
Execution queue state retrieving functions:");
    x1f4_print_htfunctions
	(stdout, _Mylene1f4_aime_1_L_2, "    ", NULL, Mylene1f4_look_aime);
    puts("\n\
Execution queue state retrieving functions (concluded):");
    x1f4_print_htfunctions
	(stdout, _Mylene1f4_aime_1_I_2, "    ", NULL, Mylene1f4_look_aime);
    puts("\n\
Context execution lists state retrieving functions:");
    x1f4_print_htfunctions
	(stdout, _Mylene1f4_aime_1___3, "    ", NULL, Mylene1f4_look_aime);
    puts("\n\
Context execution lists state retrieving functions (continued):");
    x1f4_print_htfunctions
	(stdout, _Mylene1f4_aime_1_L_3, "    ", NULL, Mylene1f4_look_aime);
    puts("\n\
Context execution lists state retrieving functions (concluded):");
    x1f4_print_htfunctions
	(stdout, _Mylene1f4_aime_1_I_3, "    ", NULL, Mylene1f4_look_aime);
    puts("\n\
Execution queue and context execution lists state retrieving functions:");
    x1f4_print_hfunctions(stdout, _Mylene1f4_aime_3_L_2, "    ");
    puts("\n\
State setting functions:");
    x1f4_print_hfunctions(stdout, _Mylene1f4_aime_3_S__, "    ");
    puts("\n\
State resetting functions:");
    x1f4_print_hfunctions(stdout, _Mylene1f4_aime_3_R__, "    ");
    puts("\n\
Queue programs functions:");
    x1f4_print_htfunctions
	(stdout, _Mylene1f4_aime_1_q_l, "    ", NULL, Mylene1f4_look_aime);
    puts("\n\
Queue programs functions (continued):");
    x1f4_print_htfunctions
	(stdout, _Mylene1f4_aime_1_q_s, "    ", NULL, Mylene1f4_look_aime);
    if (frame) {
	puts("\n\
Issuing client output functions:");
	list_0011(context, &indexset, x1f4_note_lxnear, x1f4_fset_lxnear, 'C');
	puts("\n\
Output functions:");
	list_0011(context, &indexset, x1f4_note_lxnear, x1f4_fset_lxnear, 'O');
	puts("\n\
Error functions:");
	list_0011(context, &indexset, x1f4_note_lxnear, x1f4_fset_lxnear, 'V');
    }
    puts("\n\
Execution queue pseudo effector functions:");
    Mylene1f4_list_sets(NULL, Q_F_sets, Q___sets_count(Q_F_sets));
    puts("\n\
Context execution lists pseudo effector functions:");
    Mylene1f4_list_sets(NULL, Q_f_sets, Q___sets_count(Q_f_sets));
    puts("\n\
Play start execution list pseudo effector functions:");
    list_text(NULL, _Mylene1f4_aime_5_F_2, &indexset);
    puts("\n\
Effector functions (execution queue only):");
    x1f4_print_hfunctions(stdout, _Mylene1f4_aime___E__, "    ");

    if (frame) {
	Mylene1f4_flat_e4lx(&indexset);
    }
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static void
dump_operators(void *context, int head)
{
    int class;
    struct x1f4_indexset_type indexset;

    if (Mylene1f4_fast_e4lx(context, NULL, &class, &indexset)) {
    } else {
	x1f4_print_tboperators
	    (stdout, indexset.operator_set.operator2s, head, &indexset,
	     x1f4_look_indexset);
	x1f4_print_boperators(stdout, _Mylene1f4_aime_3_B, 0);
    }
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static void
list_0010(void *context, void *indexset,
	  int (*note) (const struct x1f4_lxnote_type **),
	  int (*fset) (void *, const struct x1f4_linetext_type **))
{
    struct x1f4_indexset_type *indexset_data;
    const struct x1f4_linetext_type *linetext_data;
    struct x1f4_lxslip_type *lxslip_data;

    indexset_data = indexset;

    lxslip_data = indexset_data->sliplong_set.lxslip_data;
    while (lxslip_data->note != note) {
	lxslip_data++;
    }

    fset(lxslip_data->slip, &linetext_data);

    list_text(NULL, linetext_data, indexset_data);
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static void
list_0011(void *context, void *indexset,
	  int (*note) (const struct x1f4_lxnote_type **),
	  int (*fset) (void *, const struct x1f4_linetext_type **), int c)
{
    struct x1f4_indexset_type *indexset_data;
    const struct x1f4_linetext_type *linetext_data;
    struct x1f4_lxslip_type *lxslip_data;

    indexset_data = indexset;

    lxslip_data = indexset_data->sliplong_set.lxslip_data;
    while (lxslip_data->note != note) {
	lxslip_data++;
    }

    fset(lxslip_data->slip, &linetext_data);

    list_lead(NULL, linetext_data, indexset_data, c);
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
int
Mylene1f4_detail_aime(void *context, int mode)
{
    if (mode == 035) {
	dump_functions(context);
    } else if (mode == 154) {
	dump_operators(context, 1);
    } else if (mode == 155) {
	dump_operators(context, 0);
    } else if (mode == 156) {
	Mylene1f4_dump_filter(037);
    } else {
	Mylene1f4_dump_filter(030);
    }

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */
