/*
 * alia.c
 * Copyright (C) 2005-2013, 2015, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#if __ENABLE_CONTROLLING_SERVER__
# include <stddef.h>
# include <stdlib.h>
# include <string.h>
#endif				/* __ENABLE_CONTROLLING_SERVER__ */

#if __ENABLE_CONTROLLING_SERVER__
# include <access.h>
# include <defs.h>
# include <excess4.h>
# include <excess7.h>
# include <inter.h>
#endif				/* __ENABLE_CONTROLLING_SERVER__ */

#if __ENABLE_CONTROLLING_SERVER__
# define swap_data			Mylene1f4_swap_graphique
# define swap_deck			Mylene1f4_swap_filter
#endif				/* __ENABLE_CONTROLLING_SERVER__ */

#if __ENABLE_CONTROLLING_SERVER__
# define __SEEK_XMPEG1__		0
#endif				/* __ENABLE_CONTROLLING_SERVER__ */

#if __ENABLE_CONTROLLING_SERVER__
# define string(none) \
    ((struct string_type *) (none))
#endif				/* __ENABLE_CONTROLLING_SERVER__ */

#if __ENABLE_CONTROLLING_SERVER__
# define Album(context) \
    (Frame4((context))->text.album)
# define Lbase(context) \
    (Frame4((context))->text.lbase)
# define Lpath(context) \
    (Frame4((context))->text.lpath)
# define Match(context) \
    (Frame4((context))->text.match)
# define Notes(context) \
    (Frame4((context))->text.notes)
# define Title(context) \
    (Frame4((context))->text.title)
#endif				/* __ENABLE_CONTROLLING_SERVER__ */

#if __ENABLE_CONTROLLING_SERVER__
# define Less_1(frame4) \
    ((frame4)->progress1)
# define Less_2(frame4) \
    ((frame4)->progress2)
# define Less_3(frame4) \
    ((frame4)->progress3)
#endif				/* __ENABLE_CONTROLLING_SERVER__ */

#if __RECORD_DEVICE__
#else
# define case_0021			case_0020
#endif				/* __RECORD_DEVICE__ */

#if __RECORD_DEVICE__
#else
# define deck_0014			deck_0002
# define deck_0015			deck_0002
# define deck_0040			deck_0002
# define deck_0041			deck_0002
#endif				/* __RECORD_DEVICE__ */

#if __ENABLE_CONTROLLING_SERVER__
# define Frame4(context) \
    ((struct frame4_type *) &Frame7((context))->_1.frame4)
# define Frame7(context) \
    ((struct frame7_type *) WINDOW((context)).server.window)
#endif				/* __ENABLE_CONTROLLING_SERVER__ */

#if __ENABLE_CHANNEL_SERVER__
# define MISS_BACK(context, Data, Size) \
     Frame4(context)->every4.miss_back((context), (Data), (Size))
#elif __ENABLE_CONTROLLING_SERVER__
# define MISS_BACK(context, Data, Size) \
    Mylene1f4_miss_back((context), (Data), (Size))
#endif				/* __ENABLE_CHANNEL_SERVER__ */

#if __ENABLE_CHANNEL_SERVER__
# define PIPE_BACK(context, Data, Size) \
     Frame4(context)->every4.pipe_back((context), (Data), (Size))
#elif __ENABLE_CONTROLLING_SERVER__
# define PIPE_BACK(context, Data, Size) \
    Mylene1f4_pipe_back((context), (Data), (Size))
#endif				/* __ENABLE_CHANNEL_SERVER__ */

#if __ENABLE_CONTROLLING_SERVER__
#define swap_miss(context, PROGRESS, progress) \
    Mylene1f4_swap_progress((context), &PROGRESS((context)), (progress))
#endif				/* __ENABLE_CONTROLLING_SERVER__ */

#if __EDITABLE_PLAYLIST__
# define miss_play_list(context) \
    (EXCESS((context)).e1.list87.count < WINDOW((context)).server.list_length)
#endif				/* __EDITABLE_PLAYLIST__ */

#if __ENABLE_CONTROLLING_SERVER__
static int back_list(void *);
static int case_0000(void *, unsigned);
static int case_0010(void *, unsigned);
static int case_0020(void *, unsigned);
#endif				/* __ENABLE_CONTROLLING_SERVER__ */
#if __RECORD_DEVICE__
static int case_0021(void *, unsigned);
#endif				/* __RECORD_DEVICE__ */
#if __ENABLE_CONTROLLING_SERVER__
static int case_0030(void *, unsigned);
static int case_0040(void *, unsigned);
static int case_0050(void *, unsigned);
static int case_0060(void *, unsigned);
static int case_0070(void *, unsigned);
static int case_0100(void *, unsigned);
static int case_0110(void *, unsigned);
static int case_0120(void *, unsigned);
static int case_0130(void *, unsigned);
#endif				/* __ENABLE_CONTROLLING_SERVER__ */
#if __RECORD_DEVICE__
static int case_0141(void *, unsigned);
static int case_0151(void *, unsigned);
#endif				/* __RECORD_DEVICE__ */
#if __ENABLE_CONTROLLING_SERVER__
static int case_0170(void *, unsigned);
static int case_0200(void *, unsigned);
static int case_0210(void *, unsigned);
static int case_0220(void *, unsigned);
static int case_0230(void *, unsigned);
static int case_0240(void *, unsigned);
static int case_0250(void *, unsigned);
static int case_0270(void *, unsigned);
static int case_0300(void *, unsigned);
static int case_0320(void *, unsigned);
static int case_0330(void *, unsigned);
static int case_0340(void *, unsigned);
static int case_0350(void *, unsigned);
static int case_0360(void *, unsigned);
static int case_0370(void *, unsigned);
#endif				/* __ENABLE_CONTROLLING_SERVER__ */
#if __RECORD_DEVICE__
static int case_0401(void *, unsigned);
static int case_0411(void *, unsigned);
#endif				/* __RECORD_DEVICE__ */
#if __ENABLE_CONTROLLING_SERVER__
static int case_0420(void *, unsigned);
static int case_0430(void *, unsigned);
static int case_0440(void *, unsigned);
static int case_0450(void *, unsigned);
static int case_0460(void *, unsigned);
static int case_0470(void *, unsigned);
static int case_0500(void *, unsigned);
static int case_0510(void *, unsigned);
static int case_0520(void *, unsigned);
static int case_0530(void *, unsigned);
static int case_0540(void *, unsigned);
static int case_0550(void *, unsigned);
static int case_0560(void *, unsigned);
static int case_0570(void *, unsigned);
static int case_0600(void *, unsigned);
static int case_0610(void *, unsigned);
static int case_0620(void *, unsigned);
static int case_0630(void *, unsigned);
static int case_0640(void *, unsigned);
static int case_0650(void *, unsigned);
static int case_0660(void *, unsigned);
static int case_0670(void *, unsigned);
static int case_0700(void *, unsigned);
static int case_0710(void *, unsigned);
static int case_0720(void *, unsigned);
static int case_0730(void *, unsigned);
static int case_0740(void *, unsigned);
static int case_0741(void *, unsigned);
static int case_0750(void *, unsigned);
static int case_0751(void *, unsigned);
static int case_0760(void *, unsigned);
static int case_0770(void *, unsigned);
static int case_1000(void *, unsigned);
static int case_1010(void *, unsigned);
static int case_1020(void *, unsigned);
static int case_1150(void *, unsigned);
static int case_1160(void *, unsigned);
static int case_1200(void *, unsigned);
static int case_1210(void *, unsigned);
static int case_1240(void *, unsigned);
static int case_1330(void *, unsigned);
static int case_1340(void *, unsigned);
static int case_1350(void *, unsigned);
static int case_1360(void *, unsigned);
static int case_1370(void *, unsigned);
static int case_1401(void *, unsigned);
static int case_1410(void *, unsigned);
static int case_1420(void *, unsigned);
static int case_1550(void *, unsigned);
static int case_1560(void *, unsigned);
static int case_1600(void *, unsigned);
static int case_1610(void *, unsigned);
static int case_1640(void *, unsigned);
static int case_1740(void *, unsigned);
static int case_1750(void *, unsigned);
static int case_1760(void *, unsigned);
static int case_1770(void *, unsigned);
static int case_2000(void *, unsigned);
static int case_2010(void *, unsigned);
static int case_2150(void *, unsigned);
static int case_2160(void *, unsigned);
static int case_2240(void *, unsigned);
static int case_2610(void *, unsigned);
static int case_2620(void *, unsigned);
static int case_2630(void *, unsigned);
static int clip_text(void *);
static int deck_back(void *, unsigned);
static int deck_miss(void *, unsigned);
static int deck_post(void *, unsigned);
static int deck_sign(void *, unsigned);
static int head_list(void *);
static int lose_text(void *);
static int mind_post(void *, unsigned);
#endif				/* __ENABLE_CONTROLLING_SERVER__ */
#if __ENABLE_EQUEUE_SERVER__
static int miss_cEil(void *, unsigned, unsigned, unsigned);
static int miss_name(void *);
static int miss_rail(void *, struct equeue_type *, unsigned *,
		     struct equeue_type **);
static int miss_tail(void *, unsigned);
#endif				/* __ENABLE_EQUEUE_SERVER__ */
#if __ENABLE_CONTROLLING_SERVER__
static int mode_aime(void *, unsigned);
static int mode_alia(void *, unsigned);
static int mode_ever(void *, unsigned);
static int near_x1st(void *, unsigned);
static int near_x2nd(void *, unsigned);
static int near_x3rd(void *, unsigned);
static int pick_e0fa(void *, unsigned, unsigned);
static int pick_list(void *);
static int seek_e0fa(void *, unsigned, unsigned);
static int side_baCk(void *, unsigned);
static int side_back(void *, unsigned);
static int side_teXt(void *, unsigned, unsigned);
static int side_text(void *, unsigned, unsigned);
static int slip_id3v(void *, void *, void *, unsigned);
static int slip_id3w(void *, void *, void *, unsigned);
static int slip_id3x(void *, void *, void *, const char *, unsigned);
static int slip_less(void *, unsigned, unsigned);
static int slip_miss(void *, void *, void *);
static int slip_text(void *, unsigned, unsigned);
static int text____0(void *, unsigned);
static int text____1(void *, unsigned);
#endif				/* __ENABLE_CONTROLLING_SERVER__ */

#if __ENABLE_CONTROLLING_SERVER__
static int (*const deck_0000[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    case_0000
/* *INDENT-ON* */
}, (*const deck_0001[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    case_0010
/* *INDENT-ON* */
}, (*const deck_0002[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    case_0021
/* *INDENT-ON* */
}, (*const deck_0003[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    case_0030
/* *INDENT-ON* */
}, (*const deck_0004[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    mind_post,
    deck_post,
    case_0040
/* *INDENT-ON* */
}, (*const deck_0005[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    case_0050
/* *INDENT-ON* */
}, (*const deck_0006[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    case_0060
/* *INDENT-ON* */
}, (*const deck_0007[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    case_0070
/* *INDENT-ON* */
}, (*const deck_0010[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    case_0100
/* *INDENT-ON* */
}, (*const deck_0011[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    mind_post,
    deck_sign,
    deck_miss,
    deck_post,
    case_0110
/* *INDENT-ON* */
}, (*const deck_0012[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    case_0120
/* *INDENT-ON* */
}, (*const deck_0013[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    case_0130
/* *INDENT-ON* */
#if __RECORD_DEVICE__
}, (*const deck_0014[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    case_0141
/* *INDENT-ON* */
}, (*const deck_0015[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    case_0151
/* *INDENT-ON* */
#endif				/* __RECORD_DEVICE__ */
}, (*const deck_0016[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    mind_post,
    deck_sign,
    deck_miss,
    deck_post,
    deck_back,
    case_0110
/* *INDENT-ON* */
}, (*const deck_0017[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    mind_post,
    deck_post,
    text____1,
    side_baCk,
    case_0170
/* *INDENT-ON* */
}, (*const deck_0020[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    mind_post,
    deck_post,
    case_0200
/* *INDENT-ON* */
}, (*const deck_0021[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    case_0210
/* *INDENT-ON* */
}, (*const deck_0022[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    case_0220
/* *INDENT-ON* */
}, (*const deck_0023[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    case_0230
/* *INDENT-ON* */
}, (*const deck_0024[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    case_0240
/* *INDENT-ON* */
}, (*const deck_0025[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    case_0250
/* *INDENT-ON* */
}, (*const deck_0026[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    mind_post,
    deck_sign,
    deck_miss,
    deck_post,
    deck_back,
    case_0270
/* *INDENT-ON* */
}, (*const deck_0027[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    mind_post,
    deck_sign,
    deck_miss,
    deck_post,
    case_0270
/* *INDENT-ON* */
}, (*const deck_0030[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    mind_post,
    deck_post,
    near_x1st,
    mind_post,
    deck_post,
    near_x2nd,
    mind_post,
    deck_post,
    near_x3rd,
    mind_post,
    deck_post,
    case_0300
/* *INDENT-ON* */
}, (*const deck_0032[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    mind_post,
    deck_sign,
    deck_miss,
    deck_post,
    case_0320
/* *INDENT-ON* */
}, (*const deck_0033[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    mind_post,
    deck_sign,
    deck_miss,
    deck_post,
    case_0330
/* *INDENT-ON* */
}, (*const deck_0034[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    mind_post,
    deck_sign,
    deck_miss,
    deck_post,
    case_0340
/* *INDENT-ON* */
}, (*const deck_0035[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    mind_post,
    deck_post,
    near_x1st,
    mind_post,
    deck_post,
    near_x2nd,
    mind_post,
    deck_post,
    near_x3rd,
    mind_post,
    deck_post,
    case_0350
/* *INDENT-ON* */
}, (*const deck_0036[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    mind_post,
    deck_post,
    near_x1st,
    mind_post,
    deck_post,
    near_x2nd,
    mind_post,
    deck_post,
    near_x3rd,
    mind_post,
    deck_post,
    case_0360
/* *INDENT-ON* */
}, (*const deck_0037[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    mind_post,
    deck_post,
    near_x1st,
    mind_post,
    deck_post,
    near_x2nd,
    mind_post,
    deck_post,
    near_x3rd,
    mind_post,
    deck_post,
    case_0370
/* *INDENT-ON* */
#if __RECORD_DEVICE__
}, (*const deck_0040[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    case_0401
/* *INDENT-ON* */
}, (*const deck_0041[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    case_0411
/* *INDENT-ON* */
#endif				/* __RECORD_DEVICE__ */
}, (*const deck_0042[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    mind_post,
    deck_post,
    text____1,
    side_baCk,
    case_0420
/* *INDENT-ON* */
}, (*const deck_0043[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    case_0430
/* *INDENT-ON* */
}, (*const deck_0044[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    case_0440
/* *INDENT-ON* */
}, (*const deck_0045[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    mind_post,
    deck_post,
    case_0450
/* *INDENT-ON* */
}, (*const deck_0046[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    case_0460
/* *INDENT-ON* */
}, (*const deck_0047[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    case_0470
/* *INDENT-ON* */
}, (*const deck_0050[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    mind_post,
    deck_post,
    text____1,
    side_baCk,
    case_0500
/* *INDENT-ON* */
}, (*const deck_0051[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    mind_post,
    deck_sign,
    deck_miss,
    deck_post,
    case_0510
/* *INDENT-ON* */
}, (*const deck_0052[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    case_0520
/* *INDENT-ON* */
}, (*const deck_0053[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    case_0530
/* *INDENT-ON* */
}, (*const deck_0054[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    case_0540
/* *INDENT-ON* */
}, (*const deck_0055[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    case_0550
/* *INDENT-ON* */
}, (*const deck_0056[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    mind_post,
    deck_post,
    mode_alia,
    mind_post,
    deck_sign,
    deck_miss,
    deck_post,
    case_0560
/* *INDENT-ON* */
}, (*const deck_0057[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    mind_post,
    deck_sign,
    deck_miss,
    deck_post,
    case_0570
/* *INDENT-ON* */
}, (*const deck_0060[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    mind_post,
    deck_post,
    mode_alia,
    mind_post,
    deck_sign,
    deck_miss,
    deck_post,
    case_0600
/* *INDENT-ON* */
}, (*const deck_0061[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    mind_post,
    deck_post,
    text____1,
    side_baCk,
    case_0610
/* *INDENT-ON* */
}, (*const deck_0062[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    mind_post,
    deck_post,
    text____1,
    side_baCk,
    case_0620
/* *INDENT-ON* */
}, (*const deck_0063[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    mind_post,
    deck_post,
    text____1,
    side_baCk,
    case_0630
/* *INDENT-ON* */
}, (*const deck_0064[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    mind_post,
    deck_sign,
    deck_miss,
    deck_post,
    case_0640
/* *INDENT-ON* */
}, (*const deck_0065[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    mind_post,
    deck_sign,
    deck_miss,
    deck_post,
    case_0650
/* *INDENT-ON* */
}, (*const deck_0066[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    mind_post,
    deck_sign,
    deck_miss,
    deck_post,
    case_0660
/* *INDENT-ON* */
}, (*const deck_0067[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    mind_post,
    deck_sign,
    deck_miss,
    deck_post,
    mode_aime,
    mind_post,
    deck_post,
    text____1,
    side_baCk,
    case_0670
/* *INDENT-ON* */
}, (*const deck_0070[]) (void *, unsigned) = {
/* *indent-off* */
    case_0700
/* *indent-on* */
}, (*const deck_0071[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    mind_post,
    deck_sign,
    deck_miss,
    deck_post,
    mode_aime,
    mind_post,
    deck_sign,
    deck_miss,
    deck_post,
    case_0710
/* *INDENT-ON* */
}, (*const deck_0072[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    mind_post,
    deck_post,
    text____1,
    side_baCk,
    case_0720
/* *INDENT-ON* */
}, (*const deck_0073[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    mind_post,
    deck_post,
    case_0730
/* *INDENT-ON* */
}, (*const deck_0074[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    mind_post,
    case_0740,
    deck_post,
    case_0741
/* *INDENT-ON* */
}, (*const deck_0075[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    mind_post,
    case_0750,
    deck_post,
    text____1,
    side_baCk,
    case_0751
/* *INDENT-ON* */
}, (*const deck_0076[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    mind_post,
    deck_sign,
    deck_miss,
    deck_post,
    case_0760
/* *INDENT-ON* */
}, (*const deck_0077[]) (void *, unsigned) = {
/* *indent-off* */
    case_0770
/* *indent-on* */
}, (*const deck_0100[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    mind_post,
    deck_sign,
    deck_miss,
    deck_post,
    mode_aime,
    mind_post,
    deck_post,
    text____1,
    side_baCk,
    case_1000
/* *INDENT-ON* */
}, (*const deck_0101[]) (void *, unsigned) = {
/* *indent-off* */
    case_1010
/* *indent-on* */
}, (*const deck_0102[]) (void *, unsigned) = {
/* *indent-off* */
    case_1020
/* *indent-on* */
}, (*const deck_0115[]) (void *, unsigned) = {
/* *indent-off* */
    case_1150
/* *indent-on* */
}, (*const deck_0116[]) (void *, unsigned) = {
/* *indent-off* */
    case_1160
/* *indent-on* */
}, (*const deck_0120[]) (void *, unsigned) = {
/* *indent-off* */
    case_1200
/* *indent-on* */
}, (*const deck_0121[]) (void *, unsigned) = {
/* *indent-off* */
    case_1210
/* *indent-on* */
}, (*const deck_0124[]) (void *, unsigned) = {
/* *indent-off* */
    case_1240
/* *indent-on* */
}, (*const deck_0133[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    mind_post,
    deck_post,
    case_1330
/* *INDENT-ON* */
}, (*const deck_0134[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    mind_post,
    deck_sign,
    deck_miss,
    deck_post,
    mode_aime,
    mind_post,
    deck_post,
    text____1,
    side_baCk,
    case_1340
/* *INDENT-ON* */
}, (*const deck_0135[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    mind_post,
    deck_sign,
    deck_miss,
    deck_post,
    mode_aime,
    mind_post,
    deck_post,
    text____1,
    side_baCk,
    case_1350
/* *INDENT-ON* */
}, (*const deck_0136[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    mind_post,
    deck_sign,
    deck_miss,
    deck_post,
    case_1360
/* *INDENT-ON* */
}, (*const deck_0137[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    mind_post,
    deck_sign,
    deck_miss,
    deck_post,
    case_1370
/* *INDENT-ON* */
}, (*const deck_0140[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    mind_post,
    deck_sign,
    deck_miss,
    deck_post,
    mode_aime,
    mind_post,
    case_0750,
    deck_post,
    text____1,
    side_baCk,
    case_1401
/* *INDENT-ON* */
}, (*const deck_0141[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    mind_post,
    deck_post,
    text____0,
    side_back,
    case_1410
/* *INDENT-ON* */
}, (*const deck_0142[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    mind_post,
    deck_post,
    text____0,
    side_back,
    case_1420
/* *INDENT-ON* */
}, (*const deck_0155[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    mind_post,
    deck_post,
    text____0,
    side_back,
    case_1550
/* *INDENT-ON* */
}, (*const deck_0156[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    mind_post,
    deck_post,
    text____0,
    side_back,
    case_1560
/* *INDENT-ON* */
}, (*const deck_0160[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    mind_post,
    deck_post,
    text____1,
    side_baCk,
    case_1600
/* *INDENT-ON* */
}, (*const deck_0161[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    mind_post,
    deck_post,
    text____0,
    side_back,
    case_1610
/* *INDENT-ON* */
}, (*const deck_0164[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    mind_post,
    deck_post,
    text____0,
    side_back,
    case_1640
/* *INDENT-ON* */
}, (*const deck_0174[]) (void *, unsigned) = {
/* *indent-off* */
    mind_post,
    deck_post,
    mode_alia,
    mind_post,
    deck_post,
    mode_ever,
    mind_post,
    deck_post,
    text____1,
    side_baCk,
    case_1740
/* *indent-on* */
}, (*const deck_0175[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    case_1750
/* *INDENT-ON* */
}, (*const deck_0176[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    mind_post,
    deck_post,
    case_1760
/* *INDENT-ON* */
}, (*const deck_0177[]) (void *, unsigned) = {
/* *indent-off* */
    case_1770
/* *indent-on* */
}, (*const deck_0200[]) (void *, unsigned) = {
/* *indent-off* */
    mind_post,
    deck_post,
    mode_alia,
    mind_post,
    deck_post,
    mode_ever,
    mind_post,
    deck_post,
    text____1,
    side_baCk,
    case_2000
/* *indent-on* */
}, (*const deck_0201[]) (void *, unsigned) = {
/* *indent-off* */
    case_2010
/* *indent-on* */
}, (*const deck_0215[]) (void *, unsigned) = {
/* *indent-off* */
    case_2150
/* *indent-on* */
}, (*const deck_0216[]) (void *, unsigned) = {
/* *indent-off* */
    case_2160
/* *indent-on* */
}, (*const deck_0224[]) (void *, unsigned) = {
/* *indent-off* */
    case_2240
/* *indent-on* */
}, (*const deck_0261[]) (void *, unsigned) = {
/* *indent-off* */
    case_2610
/* *indent-on* */
}, (*const deck_0262[]) (void *, unsigned) = {
/* *indent-off* */
    case_2620
/* *indent-on* */
}, (*const deck_0263[]) (void *, unsigned) = {
/* *indent-off* */
    case_2630
/* *indent-on* */
}, (*const *const ever_0160[]) (void *, unsigned) = {
/* *INDENT-OFF* */
    /* 00 -- EXIT         */
    deck_0000,
    /* 01 -- SKIP         */
    deck_0001,
    /* 02 -- SPACE        */
    deck_0002,
    /* 03 -- CYCLE        */
    deck_0003,
    /* 04 -- START        */
    deck_0004,
    /* 05 -- StarT        */
    deck_0005,
    /* 06 -- BACK         */
    deck_0006,
    /* 07 -- JOIN         */
    deck_0007,
    /* 08 -- RAND         */
    deck_0010,
    /* 09 -- SKIP1        */
    deck_0011,
    /* 0a -- CYCLE_off    */
    deck_0012,
    /* 0b -- CYCLE_On     */
    deck_0013,
    /* 0c -- SPACE_off    */
    deck_0014,
    /* 0d -- SPACE_On     */
    deck_0015,
    /* 0e -- BACK1        */
    deck_0016,
    /* 0f -- FORMAT       */
    deck_0017,
    /* 10 -- CYCLE_tail   */
    deck_0020,
    /* 11 -- ORDER_n      */
    deck_0021,
    /* 12 -- ORDER_p      */
    deck_0022,
    /* 13 -- ORDER_z      */
    deck_0023,
    /* 14 -- LOAD         */
    deck_0024,
    /* 15 -- CLEAR        */
    deck_0025,
    /* 16 -- CYCLE_m      */
    deck_0026,
    /* 17 -- CYCLE_p      */
    deck_0027,
    /* 18 -- BEGIN        */
    deck_0030,
    /* 19 -- BegiN        */
    deck_0005,
    /* 1a -- PICK         */
    deck_0032,
    /* 1b -- PICK_m       */
    deck_0033,
    /* 1c -- PICK_p       */
    deck_0034,
    /* 1d -- SEEK         */
    deck_0035,
    /* 1e -- SEEK_m       */
    deck_0036,
    /* 1f -- SEEK_p       */
    deck_0037,
    /* 20 -- DETACH       */
    deck_0040,
    /* 21 -- ATTACH       */
    deck_0041,
    /* 22 -- QUEUE        */
    deck_0042,
    /* 23 -- ABORT        */
    deck_0043,
    /* 24 -- DEQUE        */
    deck_0044,
    /* 25 -- DEQUE_c      */
    deck_0045,
    /* 26 -- DEQUE_all    */
    deck_0046,
    /* 27 -- WIND         */
    deck_0047,
    /* 28 -- DIVA         */
    deck_0050,
    /* 29 -- DELETE       */
    deck_0051,
    /* 2a -- SHUFFLE      */
    deck_0052,
    /* 2b -- RESTORE      */
    deck_0053,
    /* 2c -- HEAD         */
    deck_0054,
    /* 2d -- TAIL         */
    deck_0055,
    /* 2e -- CLASS_3      */
    deck_0056,
    /* 2f -- WIND1        */
    deck_0057,
    /* 30 -- LEVEL_3      */
    deck_0060,
    /* 31 -- LESS1        */
    deck_0061,
    /* 32 -- LESS2        */
    deck_0062,
    /* 33 -- LESS3        */
    deck_0063,
    /* 34 -- HEAD_n       */
    deck_0064,
    /* 35 -- TAIL_n       */
    deck_0065,
    /* 36 -- SCALE_3      */
    deck_0066,
    /* 37 -- INSERT       */
    deck_0067,
    /* 38 -- SUSPEND      */
    deck_0070,
    /* 39 -- MOVE         */
    deck_0071,
    /* 3a -- ADD          */
    deck_0072,
    /* 3b -- REMOVE       */
    deck_0073,
    /* 3c -- ReMOvE       */
    deck_0074,
    /* 3d -- Add          */
    deck_0075,
    /* 3e -- SuSpEnD      */
    deck_0076,
    /* 3f -- FLUSH        */
    deck_0077,
    /* 40 -- AdD          */
    deck_0100,
    /* 41 -- AlbuM        */
    deck_0101,
    /* 42 -- LbasE        */
    deck_0102,
    /* 43 */
    NULL,
    /* 44 */
    NULL,
    /* 45 */
    NULL,
    /* 46 */
    NULL,
    /* 47 */
    NULL,
    /* 48 */
    NULL,
    /* 49 */
    NULL,
    /* 4a */
    NULL,
    /* 4b */
    NULL,
    /* 4c */
    NULL,
    /* 4d -- MatcH        */
    deck_0115,
    /* 4e -- NoteS        */
    deck_0116,
    /* 4f */
    NULL,
    /* 50 -- PresS        */
    deck_0120,
    /* 51 -- LpatH        */
    deck_0121,
    /* 52 */
    NULL,
    /* 53 */
    NULL,
    /* 54 -- TitlE        */
    deck_0124,
    /* 55 */
    NULL,
    /* 56 */
    NULL,
    /* 57 */
    NULL,
    /* 58 */
    NULL,
    /* 59 */
    NULL,
    /* 5a */
    NULL,
    /* 5b -- POST         */
    deck_0133,
    /* 5c -- INSERT_s     */
    deck_0134,
    /* 5d -- INSERT_c     */
    deck_0135,
    /* 5e -- DELETE_c     */
    deck_0136,
    /* 5f -- DELETE_s     */
    deck_0137,
    /* 60 -- ADd          */
    deck_0140,
    /* 61 -- ALBUM        */
    deck_0141,
    /* 62 -- LBASE        */
    deck_0142,
    /* 63 */
    NULL,
    /* 64 */
    NULL,
    /* 65 */
    NULL,
    /* 66 */
    NULL,
    /* 67 */
    NULL,
    /* 68 */
    NULL,
    /* 69 */
    NULL,
    /* 6a */
    NULL,
    /* 6b */
    NULL,
    /* 6c */
    NULL,
    /* 6d -- MATCH        */
    deck_0155,
    /* 6e -- NOTES        */
    deck_0156,
    /* 6f */
    NULL,
    /* 70 -- PRESS        */
    deck_0160,
    /* 71 -- LPATH        */
    deck_0161,
    /* 72 */
    NULL,
    /* 73 */
    NULL,
    /* 74 -- TITLE        */
    deck_0164,
    /* 75 */
    NULL,
    /* 76 */
    NULL,
    /* 77 */
    NULL,
    /* 78 */
    NULL,
    /* 79 */
    NULL,
    /* 7a */
    NULL,
    /* 7b */
    NULL,
    /* 7c -- INSTANT      */
    deck_0174,
    /* 7d -- SCRAP        */
    deck_0175,
    /* 7e -- LOSE         */
    deck_0176,
    /* 7f -- Flush        */
    deck_0177,
    /* 80 -- MAIL         */
    deck_0200,
    /* 81 -- Album        */
    deck_0201,
    /* 82 */
    NULL,
    /* 83 */
    NULL,
    /* 84 */
    NULL,
    /* 85 */
    NULL,
    /* 86 */
    NULL,
    /* 87 */
    NULL,
    /* 88 */
    NULL,
    /* 89 */
    NULL,
    /* 8a */
    NULL,
    /* 8b */
    NULL,
    /* 8c */
    NULL,
    /* 8d -- Match        */
    deck_0215,
    /* 8e -- Notes        */
    deck_0216,
    /* 8f */
    NULL,
    /* 90 */
    NULL,
    /* 91 */
    NULL,
    /* 92 */
    NULL,
    /* 93 */
    NULL,
    /* 94 -- Title        */
    deck_0224,
    /* 95 */
    NULL,
    /* 96 */
    NULL,
    /* 97 */
    NULL,
    /* 98 */
    NULL,
    /* 99 */
    NULL,
    /* 9a */
    NULL,
    /* 9b */
    NULL,
    /* 9c */
    NULL,
    /* 9d */
    NULL,
    /* 9e */
    NULL,
    /* 9f */
    NULL,
    /* a0 */
    NULL,
    /* a1 */
    NULL,
    /* a2 */
    NULL,
    /* a3 */
    NULL,
    /* a4 */
    NULL,
    /* a5 */
    NULL,
    /* a6 */
    NULL,
    /* a7 */
    NULL,
    /* a8 */
    NULL,
    /* a9 */
    NULL,
    /* aa */
    NULL,
    /* ab */
    NULL,
    /* ac */
    NULL,
    /* ad */
    NULL,
    /* ae */
    NULL,
    /* af */
    NULL,
    /* b0 */
    NULL,
    /* b1 -- Less1        */
    deck_0261,
    /* b2 -- Less2        */
    deck_0262,
    /* b3 -- Less3        */
    deck_0263,
    /* b4 */
    NULL,
    /* b5 */
    NULL,
    /* b6 */
    NULL,
    /* b7 */
    NULL,
    /* b8 */
    NULL,
    /* b9 */
    NULL,
    /* ba */
    NULL,
    /* bb */
    NULL,
    /* bc */
    NULL,
    /* bd */
    NULL,
    /* be */
    NULL,
    /* bf */
    NULL,
    /* c0 */
    NULL,
    /* c1 */
    NULL,
    /* c2 */
    NULL,
    /* c3 */
    NULL,
    /* c4 */
    NULL,
    /* c5 */
    NULL,
    /* c6 */
    NULL,
    /* c7 */
    NULL,
    /* c8 */
    NULL,
    /* c9 */
    NULL,
    /* ca */
    NULL,
    /* cb */
    NULL,
    /* cc */
    NULL,
    /* cd */
    NULL,
    /* ce */
    NULL,
    /* cf */
    NULL,
    /* d0 */
    NULL,
    /* d1 */
    NULL,
    /* d2 */
    NULL,
    /* d3 */
    NULL,
    /* d4 */
    NULL,
    /* d5 */
    NULL,
    /* d6 */
    NULL,
    /* d7 */
    NULL,
    /* d8 */
    NULL,
    /* d9 */
    NULL,
    /* da */
    NULL,
    /* db */
    NULL,
    /* dc */
    NULL,
    /* dd */
    NULL,
    /* de */
    NULL,
    /* df */
    NULL,
    /* e0 */
    NULL,
    /* e1 */
    NULL,
    /* e2 */
    NULL,
    /* e3 */
    NULL,
    /* e4 */
    NULL,
    /* e5 */
    NULL,
    /* e6 */
    NULL,
    /* e7 */
    NULL,
    /* e8 */
    NULL,
    /* e9 */
    NULL,
    /* ea */
    NULL,
    /* eb */
    NULL,
    /* ec */
    NULL,
    /* ed */
    NULL,
    /* ee */
    NULL,
    /* ef */
    NULL,
    /* f0 */
    NULL,
    /* f1 */
    NULL,
    /* f2 */
    NULL,
    /* f3 */
    NULL,
    /* f4 */
    NULL,
    /* f5 */
    NULL,
    /* f6 */
    NULL,
    /* f7 */
    NULL,
    /* f8 */
    NULL,
    /* f9 */
    NULL,
    /* fa */
    NULL,
    /* fb */
    NULL,
    /* fc */
    NULL,
    /* fd */
    NULL,
    /* fe */
    NULL,
    /* ff */
    NULL
/* *INDENT-ON* */
};
#endif				/* __ENABLE_CONTROLLING_SERVER__ */

#if __ENABLE_CONTROLLING_SERVER__
static int
back_list(void *context)
{
    unsigned post;

    Mylene1f4_fix_index(context, &post);
    Frame4(context)->i144.post = EXCESS(context).e1.list87.count - 1 - post;

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0000(void *context, unsigned c)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    frame4_data->request = Mylene1f4_EXIT_Mylene;

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0010(void *context, unsigned c)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    frame4_data->i144.post = 1;
    frame4_data->i144.sign = Mylene1f4_LOAD_NEXT;

    frame4_data->request = Mylene1f4_SKIP_Mylene;

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0020(void *context, unsigned c)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    frame4_data->next.back = c;

    frame4_data->request = Mylene1f4_DEUX_Mylene;

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __RECORD_DEVICE__
static int
case_0021(void *context, unsigned c)
{
    WINDOW(context).server.setup ^= Mylene1f4_PAUSE_SERVER;

    return case_0020(context, c);
}
#endif				/* __RECORD_DEVICE__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0030(void *context, unsigned c)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    if (frame4_data->vertige) {
	frame4_data->vertige = 0;
    } else {
	frame4_data->vertige = 1;
    }

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0040(void *context, unsigned size)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    SELECT(context) = Mylene1f4_PAGE_PICKUP;
    START2(context) = size;

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0050(void *context, unsigned c)
{
    struct frame4_type *frame4_data;
    unsigned select;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    select = frame4_data->select;
    SELECT(context) = select;
    if (select == Mylene1f4_PAGE_PICKUP) {
	START2(context) = frame4_data->pickup.page;
    } else {
	START6(context) = frame4_data->pickup.time;
    }

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0060(void *context, unsigned c)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    frame4_data->i144.post = 1;
    frame4_data->i144.sign = Mylene1f4_LOAD_LAST;

    frame4_data->request = Mylene1f4_SKIP_Mylene;

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0070(void *context, unsigned c)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    clip_text(context);
    if (Frame4(context)->skipped) {
	frame4_data->request = Mylene1f4_SKIP_Mylene;
    }

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0100(void *context, unsigned c)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    pick_list(context);

    frame4_data->request = Mylene1f4_SKIP_Mylene;

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0110(void *context, unsigned size)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    frame4_data->i144.post = size;
    frame4_data->i144.sign =
	frame4_data->a112.data.sign.deck
	? Mylene1f4_LOAD_LAST : Mylene1f4_LOAD_NEXT;

    frame4_data->request = Mylene1f4_SKIP_Mylene;

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0120(void *context, unsigned c)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    if (1) {
	frame4_data->vertige = 0;
    }

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0130(void *context, unsigned c)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    if (1) {
	frame4_data->vertige = 1;
    }

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __RECORD_DEVICE__
static int
case_0141(void *context, unsigned c)
{
    WINDOW(context).server.setup &= ~Mylene1f4_PAUSE_SERVER;

    return case_0020(context, c);
}
#endif				/* __RECORD_DEVICE__ */


#if __RECORD_DEVICE__
static int
case_0151(void *context, unsigned c)
{
    WINDOW(context).server.setup |= Mylene1f4_PAUSE_SERVER;

    return case_0020(context, c);
}
#endif				/* __RECORD_DEVICE__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0170(void *context, unsigned size)
{
    char *data;
    int status;
    struct frame4_type *frame4_data;
    void *c_format;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    data = frame4_data->a112.data.text.text;

    data[size] = 0;

    status = Mylene1f4_init_format(context, data, &c_format);
    if (status) {
	Mylene1f4_near_slip(context, data);

	status = PIPE_BACK(context, "\0", 1);
    } else {
	struct buffer_type buffer_data = { NULL, 0, 0 };

	if (c_format) {
	    status = Mylene1f4_set_format(context, c_format, &buffer_data);
	}
	if (status) {
	} else {
	    status = MISS_BACK(context, buffer_data.data, buffer_data.length);
	}

	if (buffer_data.data) {
	    free(buffer_data.data);
	}

	if (c_format) {
	    Mylene1f4_fini_format(context, &c_format);
	}
    }

    lose_text(context);

    return status;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0200(void *context, unsigned size)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    frame4_data->vertige = (size & 0x3fffffff) << 1;

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0210(void *context, unsigned c)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    Mylene1f4_swap_last(context, Mylene1f4_LOAD_NEXT);

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0220(void *context, unsigned c)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    Mylene1f4_swap_last(context, Mylene1f4_LOAD_LAST);

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0230(void *context, unsigned c)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    Mylene1f4_swap_last(context, Mylene1f4_LOAD_RAND);

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0240(void *context, unsigned c)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    Mylene1f4_swap_last(context, frame4_data->text.load_order);

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0250(void *context, unsigned c)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    swap_data(&ALBUM(context), &frame4_data->text.album);
    swap_data(&LBASE(context), &frame4_data->text.lbase);
    swap_data(&LPATH(context), &frame4_data->text.lpath);
    swap_data(&MATCH(context), &frame4_data->text.match);
    swap_data(&NOTES(context), &frame4_data->text.notes);
    swap_data(&TITLE(context), &frame4_data->text.title);
# if __ENABLE_FILTER__
    swap_deck(context, Frame4(context)->e4deck);
# endif				/* __ENABLE_FILTER__ */

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0270(void *context, unsigned size)
{
    struct frame4_type *frame4_data;
    unsigned vertige;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    vertige = frame4_data->vertige;
    if (vertige & 1) {
	vertige = 0;
    } else {
	vertige >>= 1;
    }
    if (!frame4_data->a112.data.sign.deck) {
	frame4_data->vertige = (size + vertige) << 1;
    } else {
	if (vertige < size) {
	    frame4_data->vertige = 0;
	} else {
	    frame4_data->vertige = (vertige - size) << 1;
	}
    }

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0300(void *context, unsigned size)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    START6(context).h = frame4_data->a112.data.near.x1st;
    START6(context).m = frame4_data->a112.data.near.x2nd;
    START6(context).s = frame4_data->a112.data.near.x3rd;
    START6(context).x = size;

    SELECT(context) = Mylene1f4_TIME_PICKUP;

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0320(void *context, unsigned size)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    if (COUNT(context) == 1) {
	if (!frame4_data->a112.data.sign.deck) {
	    if (2) {
		if (1) {
		    frame4_data->next.deck = size;

		    frame4_data->request = Mylene1f4_JUMP_Mylene;
		}
	    }
	} else {
	    if (2) {
		struct x1f42a_type *x1f42a_data;

		x1f42a_data = X1f42(context);
		if (!x1f42a_data) {
		} else {
		    unsigned count, index;

		    count = x1f42a_data->frames;
		    index = size;
		    if (count < index) {
			index = 0;
		    } else {
			index = count - index;
		    }

		    frame4_data->next.deck = index;

		    frame4_data->request = Mylene1f4_JUMP_Mylene;
		}
	    }
	}
    }

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0330(void *context, unsigned size)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    if (COUNT(context) == 1) {
	pick_e0fa(context, frame4_data->a112.data.sign.deck, size);

	frame4_data->request = Mylene1f4_JUMP_Mylene;
    }

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0340(void *context, unsigned size)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    if (COUNT(context) == 1) {
	pick_e0fa(context, frame4_data->a112.data.sign.deck ^ 64, size);

	frame4_data->request = Mylene1f4_JUMP_Mylene;
    }

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0350(void *context, unsigned size)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    if (COUNT(context) == 1) {
	if (seek_e0fa(context, 0x1d, size)) {
	    frame4_data->request = Mylene1f4_JUMP_Mylene;
	}
    }

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0360(void *context, unsigned size)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    if (COUNT(context) == 1) {
	if (seek_e0fa(context, 0x1e, size)) {
	    frame4_data->request = Mylene1f4_JUMP_Mylene;
	}
    }

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0370(void *context, unsigned size)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    if (COUNT(context) == 1) {
	if (seek_e0fa(context, 0x1f, size)) {
	    frame4_data->request = Mylene1f4_JUMP_Mylene;
	}
    }

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __RECORD_DEVICE__
static int
case_0401(void *context, unsigned c)
{
    WINDOW(context).server.setup |= Mylene1f4_DELAY_SERVER;

    return case_0020(context, c);
}
#endif				/* __RECORD_DEVICE__ */


#if __RECORD_DEVICE__
static int
case_0411(void *context, unsigned c)
{
    WINDOW(context).server.setup &= ~Mylene1f4_DELAY_SERVER;

    return case_0020(context, c);
}
#endif				/* __RECORD_DEVICE__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0420(void *context, unsigned size)
{
# if __ENABLE_EQUEUE__
    int status;
# endif				/* __ENABLE_EQUEUE__ */
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

# if __ENABLE_EQUEUE__
    status = Mylene1f4_deck_alia(context, size);
    if (status) {
# endif				/* __ENABLE_EQUEUE__ */
	lose_text(context);
# if __ENABLE_EQUEUE__
	if (1) {
	    miss_name(context);
	}
    } else {
	frame4_data->flags &= ~Mylene1f4_FREE_CLIENT;
    }
# endif				/* __ENABLE_EQUEUE__ */

# if !__ENABLE_EQUEUE__
    return 0;
# else
    return status;
# endif				/* !__ENABLE_EQUEUE__ */
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0430(void *context, unsigned c)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

# if __ENABLE_EQUEUE_SERVER__
    Mylene1f4_lose_aime(context);
# endif				/* __ENABLE_EQUEUE_SERVER__ */

# if __ENABLE_EQUEUE_SERVER__
    {
	struct frame4_type *frame4_data;

	frame4_data = Frame4(context);

	if (!frame4_data->iqueue.head_equeue) {
	    frame4_data->logic = NULL;
	} else {
	    frame4_data->logic = Mylene1f4_link_aime;
	}
    }
# endif				/* __ENABLE_EQUEUE_SERVER__ */

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0440(void *context, unsigned c)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

# if __ENABLE_EQUEUE__
    miss_tail(context, 1);
# endif				/* __ENABLE_EQUEUE__ */

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0450(void *context, unsigned size)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

# if __ENABLE_EQUEUE__
    miss_tail(context, size);
# endif				/* __ENABLE_EQUEUE__ */

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0460(void *context, unsigned c)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

# if __ENABLE_EQUEUE__
    Mylene1f4_lose_equeue(context);
# endif				/* __ENABLE_EQUEUE__ */

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0470(void *context, unsigned c)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    frame4_data->i144.post = 1;
    frame4_data->i144.sign = LOAD_ORDER(context);

    frame4_data->request = Mylene1f4_SKIP_Mylene;

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0500(void *context, unsigned size)
{
    char *data;
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    data = frame4_data->a112.data.text.text;

    data[size] = 0;

# if __ENABLE_EQUEUE__
    if (1) {
	char *name;

	name = frame4_data->dana.name;
	if (name) {
	    free(name);
	}
    } else {
# endif				/* __ENABLE_EQUEUE__ */
	lose_text(context);
# if __ENABLE_EQUEUE__
    }
# endif				/* __ENABLE_EQUEUE__ */

# if __ENABLE_EQUEUE__
    frame4_data->dana.name = data;
# endif				/* __ENABLE_EQUEUE__ */

# if __ENABLE_EQUEUE__
    frame4_data->flags &= ~Mylene1f4_FREE_CLIENT;
# endif				/* __ENABLE_EQUEUE__ */

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0510(void *context, unsigned size)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

# if __ENABLE_EQUEUE__
    if (frame4_data->iqueue.lqueue) {
	Mylene1f4_slip_equeue(context, frame4_data->a112.data.sign.deck, size);
    }
# endif				/* __ENABLE_EQUEUE__ */

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0520(void *context, unsigned c)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    if (1) {
	Mylene1f4_sand_list(context);
    }

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0530(void *context, unsigned c)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    if (FLAGS(context) & Mylene1f4_TILED_LIST) {
	Mylene1f4_flat_list(context);
    }

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0540(void *context, unsigned c)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    head_list(context);

    frame4_data->i144.sign = Mylene1f4_LOAD_LAST;

    frame4_data->request = Mylene1f4_SKIP_Mylene;

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0550(void *context, unsigned c)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    back_list(context);

    frame4_data->i144.sign = Mylene1f4_LOAD_NEXT;

    frame4_data->request = Mylene1f4_SKIP_Mylene;

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0560(void *context, unsigned size)
{
# if __ENABLE_MPEG_EQUALIZER__
    double real;
# endif				/* __ENABLE_MPEG_EQUALIZER__ */
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

# if __ENABLE_MPEG_EQUALIZER__
    real = size;
    real /= 4096;
    if (frame4_data->a112.data.sign.deck) {
	real = -real;
    }
# endif				/* __ENABLE_MPEG_EQUALIZER__ */

# if __ENABLE_MPEG_EQUALIZER__
    Mylene1f4_fix_mode(context, frame4_data->a112.aime.alia.deck, real);
# endif				/* __ENABLE_MPEG_EQUALIZER__ */

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0570(void *context, unsigned size)
{
    struct frame4_type *frame4_data;
    unsigned order;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    frame4_data->i144.post = size;
    order = LOAD_ORDER(context);
    if (order != Mylene1f4_LOAD_RANDOM) {
	if (frame4_data->a112.data.sign.deck) {
	    order ^= Mylene1f4_LOAD_LAST ^ Mylene1f4_LOAD_NEXT;
	}
	frame4_data->i144.sign = order;
    }

    frame4_data->request = Mylene1f4_SKIP_Mylene;

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0600(void *context, unsigned size)
{
# if __ENABLE_MPEG_EQUALIZER__
    double real;
# endif				/* __ENABLE_MPEG_EQUALIZER__ */
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

# if __ENABLE_MPEG_EQUALIZER__
    real = size;
    real /= 4096;
    if (frame4_data->a112.data.sign.deck) {
	real = -real;
    }
# endif				/* __ENABLE_MPEG_EQUALIZER__ */

# if __ENABLE_MPEG_EQUALIZER__
    Mylene1f4_set_mode(context, frame4_data->a112.aime.alia.deck, real);
# endif				/* __ENABLE_MPEG_EQUALIZER__ */

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0610(void *context, unsigned size)
{
    return slip_less(context, size, 0061);
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0620(void *context, unsigned size)
{
    return slip_less(context, size, 0062);
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0630(void *context, unsigned size)
{
    return slip_less(context, size, 0063);
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0640(void *context, unsigned size)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    if (Mylene1f4_lock_i144
	(context, 0x34, frame4_data->a112.data.sign.deck, size)) {
    } else {
	frame4_data->request = Mylene1f4_SKIP_Mylene;
    }

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0650(void *context, unsigned size)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    if (Mylene1f4_lock_i144
	(context, 0x35, frame4_data->a112.data.sign.deck, size)) {
    } else {
	frame4_data->request = Mylene1f4_SKIP_Mylene;
    }

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0660(void *context, unsigned size)
{
# if __ENABLE_MPEG_EQUALIZER__
    double real;
# endif				/* __ENABLE_MPEG_EQUALIZER__ */
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

# if __ENABLE_MPEG_EQUALIZER__
    real = size;
    real /= 4096;
    if (frame4_data->a112.data.sign.deck) {
	real = -real;
    }
# endif				/* __ENABLE_MPEG_EQUALIZER__ */

# if __ENABLE_MPEG_EQUALIZER__
    Mylene1f4_add_mode(context, real);
# endif				/* __ENABLE_MPEG_EQUALIZER__ */

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0670(void *context, unsigned size)
{
# if __ENABLE_EQUEUE__
    int status;
# endif				/* __ENABLE_EQUEUE__ */
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

# if __ENABLE_EQUEUE__
    status = Mylene1f4_line_alia(context, size);
    if (status) {
# endif				/* __ENABLE_EQUEUE__ */
	lose_text(context);
# if __ENABLE_EQUEUE__
	if (1) {
	    miss_name(context);
	}
    } else {
	frame4_data->flags &= ~Mylene1f4_FREE_CLIENT;
    }
# endif				/* __ENABLE_EQUEUE__ */

# if !__ENABLE_EQUEUE__
    return 0;
# else
    return status;
# endif				/* !__ENABLE_EQUEUE__ */
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0700(void *context, unsigned c)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

# if __ENABLE_EQUEUE_SERVER__
    if (frame4_data->flags & Mylene1f4_AIME_LINKED) {
	struct equeue_type *head_equeue;

	head_equeue = frame4_data->iqueue.head_equeue;

	if (head_equeue) {
	    if (Mylene1f4_back_aime(context)) {
	    } else {
		struct equeue_type *equeue_data;

		equeue_data = frame4_data->iqueue.head_equeue;
		equeue_data->equeue_data = head_equeue->equeue_data;
		head_equeue->equeue_data = equeue_data;

		frame4_data->iqueue.head_equeue = head_equeue;

		frame4_data->logic = Mylene1f4_link_aime;
	    }
	}
    }
# endif				/* __ENABLE_EQUEUE_SERVER__ */

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0710(void *context, unsigned size)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

# if __ENABLE_EQUEUE_SERVER__
    if (frame4_data->iqueue.lqueue) {
	Mylene1f4_swap_equeue
	    (context, frame4_data->a112.data.sign.deck, size,
	     frame4_data->a112.aime.mode.sign,
	     frame4_data->a112.aime.mode.post);
    }
# endif				/* __ENABLE_EQUEUE_SERVER__ */

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0720(void *context, unsigned size)
{
    char *data;
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    data = frame4_data->a112.data.text.text;

# if __EDITABLE_PLAYLIST__
    if (miss_play_list(context)) {
	unsigned index;

	index = frame4_data->weave;
	frame4_data->weave = index + 1;
	Mylene1f4_push_list(context, index, size, data);
    } else {
	Mylene1f4_near_seek(context, size, data);
    }
# endif				/* __EDITABLE_PLAYLIST__ */

    lose_text(context);

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0730(void *context, unsigned size)
{
# if __EDITABLE_PLAYLIST__
    int clip;
# endif				/* __EDITABLE_PLAYLIST__ */
    struct frame4_type *frame4_data;
# if __EDITABLE_PLAYLIST__
    unsigned flags;
# endif				/* __EDITABLE_PLAYLIST__ */

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

# if __EDITABLE_PLAYLIST__
    flags = frame4_data->flags;
    Mylene1f4_clip_list(context, &clip, flags & Mylene1f4_FILE_ERASED, size);
    if (clip) {
	frame4_data->flags = flags | Mylene1f4_FILE_ERASED;
    }
# endif				/* __EDITABLE_PLAYLIST__ */

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0740(void *context, unsigned c)
{
    int status;
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    if (1 < c) {
	status = 1;
    } else {
	int (*const *ever) (void *, unsigned);

	ever = frame4_data->a112.ever;

	ever++;

	frame4_data->a112.ever = ever;

	status = 0;

	frame4_data->a112.data.ever.deck = c;
    }

    return status;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0741(void *context, unsigned size)
{
    struct frame4_type *frame4_data;
# if __EDITABLE_PLAYLIST__
    unsigned deck;
# endif				/* __EDITABLE_PLAYLIST__ */

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

# if __EDITABLE_PLAYLIST__
    deck = frame4_data->a112.data.ever.deck;
    if (deck < 2) {
	int clip;

	Mylene1f4_case_list(context, &clip, deck, &size);
	if (clip) {
	    frame4_data->flags |= Mylene1f4_FILE_ERASED;
	}
    }
# endif				/* __EDITABLE_PLAYLIST__ */

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0750(void *context, unsigned c)
{
    int status;
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    if (c & ~31) {
	status = 1;
    } else {
	int (*const *ever) (void *, unsigned);

	ever = frame4_data->a112.ever;

	ever++;

	frame4_data->a112.ever = ever;

	status = 0;

	frame4_data->a112.aime.mode.data.ever.deck = c;
    }

    return status;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0751(void *context, unsigned size)
{
    char *data;
# if __EDITABLE_PLAYLIST__
    int status;
# endif				/* __EDITABLE_PLAYLIST__ */
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    data = frame4_data->a112.data.text.text;

# if __EDITABLE_PLAYLIST__
    if (miss_play_list(context)) {
	unsigned index;

	index = frame4_data->weave;
	frame4_data->weave = index + 1;

#  if __ENABLE_TAGGED_LIST__
	if (!(FLAGS(context) & Mylene1f4_BREAK_LIST)) {
#  endif			/* __ENABLE_TAGGED_LIST__ */
	    if (frame4_data->a112.aime.mode.data.ever.deck) {
		data[size] = 0;
		size = strlen(data);
	    }

	    status = Mylene1f4_push_list(context, index, size, data);
#  if __ENABLE_TAGGED_LIST__
	} else {
	    status = Mylene1f4_line_list
		(context, index, frame4_data->a112.aime.mode.data.ever.deck,
		 size, data);
	    if (status) {
	    }
	}
#  endif			/* __ENABLE_TAGGED_LIST__ */
    } else {
	status = 0;

	Mylene1f4_near_seek(context, size, data);
    }
# endif				/* __EDITABLE_PLAYLIST__ */

    lose_text(context);

# if !__EDITABLE_PLAYLIST__
    return 0;
# else
    return status;
# endif				/* !__EDITABLE_PLAYLIST__ */
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0760(void *context, unsigned size)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

# if __ENABLE_EQUEUE__
    if (frame4_data->flags & Mylene1f4_AIME_LINKED) {
	if (frame4_data->iqueue.head_equeue) {
	    unsigned sign, tail;

	    tail = frame4_data->iqueue.lqueue;

	    sign = frame4_data->a112.data.sign.deck >> 6;
	    if (tail + sign < size) {
		Mylene1f4_near_post(context, size, sign, tail);
	    } else {
		if (Mylene1f4_back_aime(context)) {
		} else {
		    if (sign) {
			size = tail + 1 - size;
		    }

		    frame4_data->logic = Mylene1f4_link_aime;

		    if (size) {
			Mylene1f4_push_equeue(context, size + 1);
		    }
		}
	    }
	}
    }
# endif				/* __ENABLE_EQUEUE__ */

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_0770(void *context, unsigned c)
{
# if __ENABLE_FAST_INTER__
    int (*fast) (void *);
# endif				/* __ENABLE_FAST_INTER__ */
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

# if __ENABLE_FAST_INTER__
    fast = TARGET(context).fast;
    if (fast) {
	if (!fast(STORAGE(context))) {
# endif				/* __ENABLE_FAST_INTER__ */
	    frame4_data->request = Mylene1f4_LINE_Mylene;
# if __ENABLE_FAST_INTER__
	}
    }
# endif				/* __ENABLE_FAST_INTER__ */

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_1000(void *context, unsigned size)
{
    char *data;
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    data = frame4_data->a112.data.text.text;

# if __EDITABLE_PLAYLIST__
    if (miss_play_list(context)) {
	unsigned index;

	index = frame4_data->weave;
	frame4_data->weave = index + 1;
	Mylene1f4_post_list
	    (context, index, frame4_data->a112.aime.mode.sign,
	     frame4_data->a112.aime.mode.post, size, data);
    } else {
	Mylene1f4_near_seek(context, size, data);
    }
# endif				/* __EDITABLE_PLAYLIST__ */

    lose_text(context);
    
    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_1010(void *context, unsigned c)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    swap_data(&ALBUM(context), &frame4_data->text.album);

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_1020(void *context, unsigned c)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    swap_data(&LBASE(context), &frame4_data->text.lbase);

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_1150(void *context, unsigned c)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    swap_data(&MATCH(context), &frame4_data->text.match);

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_1160(void *context, unsigned c)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    swap_data(&NOTES(context), &frame4_data->text.notes);

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_1200(void *context, unsigned c)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

# if __ENABLE_FILTER__
    swap_deck(context, Frame4(context)->e4deck);
# endif				/* __ENABLE_FILTER__ */

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_1210(void *context, unsigned c)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    swap_data(&LPATH(context), &frame4_data->text.lpath);

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_1240(void *context, unsigned c)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    swap_data(&TITLE(context), &frame4_data->text.title);

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_1330(void *context, unsigned size)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

# if __ENABLE_CHANNEL_SERVER__
    frame4_data->channel_up = size;
# endif				/* __ENABLE_CHANNEL_SERVER__ */

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_1340(void *context, unsigned size)
{
# if __ENABLE_EQUEUE__
    int status;
# endif				/* __ENABLE_EQUEUE__ */
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

# if __ENABLE_EQUEUE__
    status = Mylene1f4_push_alia(context, 0x5c, size);
    if (status) {
# endif				/* __ENABLE_EQUEUE__ */
	lose_text(context);
# if __ENABLE_EQUEUE__
	if (1) {
	    miss_name(context);
	}
    } else {
	frame4_data->flags &= ~Mylene1f4_FREE_CLIENT;
    }
# endif				/* __ENABLE_EQUEUE__ */

# if !__ENABLE_EQUEUE__
    return 0;
# else
    return status;
# endif				/* !__ENABLE_EQUEUE__ */
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_1350(void *context, unsigned size)
{
# if __ENABLE_EQUEUE__
    int status;
# endif				/* __ENABLE_EQUEUE__ */
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

# if __ENABLE_EQUEUE__
    status = Mylene1f4_push_alia(context, 0x5d, size);
    if (status) {
# endif				/* __ENABLE_EQUEUE__ */
	lose_text(context);
# if __ENABLE_EQUEUE__
	if (1) {
	    miss_name(context);
	}
    } else {
	frame4_data->flags &= ~Mylene1f4_FREE_CLIENT;
    }
# endif				/* __ENABLE_EQUEUE__ */

# if !__ENABLE_EQUEUE__
    return 0;
# else
    return status;
# endif				/* !__ENABLE_EQUEUE__ */
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_1360(void *context, unsigned size)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

# if __ENABLE_EQUEUE__
    miss_cEil(context, 0x5e, frame4_data->a112.data.sign.deck, size);
# endif				/* __ENABLE_EQUEUE__ */

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_1370(void *context, unsigned size)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

# if __ENABLE_EQUEUE__
    miss_cEil(context, 0x5f, frame4_data->a112.data.sign.deck, size);
# endif				/* __ENABLE_EQUEUE__ */

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_1401(void *context, unsigned size)
{
    char *data;
# if __EDITABLE_PLAYLIST__
    int status;
# endif				/* __EDITABLE_PLAYLIST__ */
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    data = frame4_data->a112.data.text.text;

# if __EDITABLE_PLAYLIST__
    if (miss_play_list(context)) {
	unsigned index;

	index = frame4_data->weave;
	frame4_data->weave = index + 1;

#  if __ENABLE_TAGGED_LIST__
	if (!(FLAGS(context) & Mylene1f4_BREAK_LIST)) {
#  endif			/* __ENABLE_TAGGED_LIST__ */
	    if (frame4_data->a112.aime.mode.data.ever.deck) {
		data[size] = 0;
		size = strlen(data);
	    }

	    status = Mylene1f4_post_list
		(context, index, frame4_data->a112.aime.mode.sign,
		 frame4_data->a112.aime.mode.post, size, data);
#  if __ENABLE_TAGGED_LIST__
	} else {
	    status = Mylene1f4_land_list
		(context, index, frame4_data->a112.aime.mode.data.ever.deck,
		 frame4_data->a112.aime.mode.sign,
		 frame4_data->a112.aime.mode.post, size, data);
	    if (status) {
	    }
	}
#  endif			/* __ENABLE_TAGGED_LIST__ */
    } else {
	status = 0;

	Mylene1f4_near_seek(context, size, data);
    }
# endif				/* __EDITABLE_PLAYLIST__ */

    lose_text(context);

# if !__EDITABLE_PLAYLIST__
    return 0;
# else
    return status;
# endif				/* !__EDITABLE_PLAYLIST__ */
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_1410(void *context, unsigned size)
{
    return slip_text(context, size, 0141);
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_1420(void *context, unsigned size)
{
    return slip_text(context, size, 0142);
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_1550(void *context, unsigned size)
{
    return slip_text(context, size, 0155);
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_1560(void *context, unsigned size)
{
    return slip_text(context, size, 0156);
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_1600(void *context, unsigned size)
{
    char *data;
# if __ENABLE_FILTER__
    int status;
# endif				/* __ENABLE_FILTER__ */
    struct frame4_type *frame4_data;
# if __ENABLE_FILTER__
    void *c_filter;
# endif				/* __ENABLE_FILTER__ */

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    data = frame4_data->a112.data.text.text;

# if __ENABLE_FILTER__
    data[size] = 0;
# endif				/* __ENABLE_FILTER__ */

# if __ENABLE_FILTER__
    status = Mylene1f4_init_filter
	(context, data, &c_filter,
	 WINDOW(context).server.setup & Mylene1f4_FUSSY_FILTER);
    if (status) {
    } else {
	void *e4deck;

	e4deck = E4DECK(context);
	if (e4deck != Frame4(context)->e4deck) {
	    if (e4deck) {
		Mylene1f4_fini_filter(context, &e4deck);
	    }
	}

	E4DECK(context) = c_filter;
    }
# endif				/* __ENABLE_FILTER__ */

    lose_text(context);

# if !__ENABLE_FILTER__
    return 0;
# else
    return status;
# endif				/* !__ENABLE_FILTER__ */
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_1610(void *context, unsigned size)
{
    return slip_text(context, size, 0161);
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_1640(void *context, unsigned size)
{
    return slip_text(context, size, 0164);
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_1740(void *context, unsigned size)
{
# if __ENABLE_EQUEUE__
    int status;
# endif				/* __ENABLE_EQUEUE__ */
    struct frame4_type *frame4_data;
# if __ENABLE_EQUEUE__
    void *equeue;
# endif				/* __ENABLE_EQUEUE__ */

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

# if __ENABLE_EQUEUE__
    if (Mylene1f4_pick_note
	(context, frame4_data->a112.aime.alia.deck,
	 frame4_data->a112.aime.alia.data.ever.deck, &equeue)) {
	status = Mylene1f4_fast_alia(context, size, equeue);
	if (status) {
# endif				/* __ENABLE_EQUEUE__ */
	    lose_text(context);
# if __ENABLE_EQUEUE__
	} else {
	    frame4_data->flags &= ~Mylene1f4_FREE_CLIENT;
	}
    } else {
	status = 0;
	if (1) {
	    lose_text(context);
	}
    }
# endif				/* __ENABLE_EQUEUE__ */

# if !__ENABLE_EQUEUE__
    return 0;
# else
    return status;
# endif				/* !__ENABLE_EQUEUE__ */
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_1750(void *context, unsigned c)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

# if __EDITABLE_PLAYLIST__
    frame4_data->flags |= Mylene1f4_FILE_ERASED;
# endif				/* __EDITABLE_PLAYLIST__ */

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_1760(void *context, unsigned size)
{
    int status;
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

# if __ENABLE_CHANNEL_SERVER__
    if (!(frame4_data->flags & Mylene1f4_AIME_TARGET)) {
# endif				/* __ENABLE_CHANNEL_SERVER__ */
	status = 0;
# if __ENABLE_CHANNEL_SERVER__
    } else {
	status = PIPE_BACK(context, "\176", 1);
	if (status) {
	    if (0) {
		status = -1;
	    }
	} else {
	    if (1) {
#  if __ENABLE_CHANNEL_EQUEUE__
		Mylene1f4_case_equeue(context, size);
#  endif			/* __ENABLE_CHANNEL_EQUEUE__ */
	    }
	}
    }
# endif				/* __ENABLE_CHANNEL_SERVER__ */

    return status;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_1770(void *context, unsigned c)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    return PIPE_BACK(context, "\177", 1);
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_2000(void *context, unsigned size)
{
    char *data;
    int status;
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    data = frame4_data->a112.data.text.text;

    data[size] = 0;

# if __ENABLE_EQUEUE__
    status = Mylene1f4_link_note
	(context, frame4_data->a112.aime.alia.deck,
	 frame4_data->a112.aime.alia.data.ever.deck, size + 1, data);
# else
    status = 0;
# endif				/* __ENABLE_EQUEUE__ */

    lose_text(context);

    return status;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_2010(void *context, unsigned c)
{
    int status;
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    if (!ID3X(context)) {
	status = slip_miss(context, &ALBUM(context), &Album(context));
    } else if (ID3T(context) == Mylene1f4_MERGED_ID3TAG) {
	status = slip_id3v(context, &ALBUM(context), &Album(context), 0077);
    } else {
	status = slip_id3w
	    (context, &ALBUM(context), &Album(context), Mylene1f4_ALBUM_FIELD);
    }

    return status;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_2150(void *context, unsigned c)
{
    int status;
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    if (!ID3X(context)) {
	status = slip_miss(context, &MATCH(context), &Match(context));
    } else if (ID3T(context) == Mylene1f4_MERGED_ID3TAG) {
	status = slip_id3v(context, &MATCH(context), &Match(context), 0041);
    } else {
	status = slip_id3w(context, &MATCH(context), &Match(context),
			   Mylene1f4_MATCH_FIELD);
    }

    return status;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_2160(void *context, unsigned c)
{
    int status;
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    if (!ID3X(context)) {
	status = slip_miss(context, &NOTES(context), &Notes(context));
    } else if (ID3T(context) == Mylene1f4_MERGED_ID3TAG) {
	status = slip_id3v(context, &NOTES(context), &Notes(context), 0141);
    } else {
	status = slip_id3w(context, &NOTES(context), &Notes(context),
			   Mylene1f4_NOTES_FIELD);
    }

    return status;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_2240(void *context, unsigned c)
{
    int status;
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    if (!ID3X(context)) {
	status = slip_miss(context, &TITLE(context), &Title(context));
    } else if (ID3T(context) == Mylene1f4_MERGED_ID3TAG) {
	status = slip_id3v(context, &TITLE(context), &Title(context), 0003);
    } else {
	status = slip_id3w(context, &TITLE(context), &Title(context),
			   Mylene1f4_TITLE_FIELD);
    }

    return status;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_2610(void *context, unsigned c)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    swap_miss(context, PROGRESS1, frame4_data->progress1);

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_2620(void *context, unsigned c)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    swap_miss(context, PROGRESS2, frame4_data->progress2);

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
case_2630(void *context, unsigned c)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    swap_miss(context, PROGRESS3, frame4_data->progress3);

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
clip_text(void *context)
{
    if (Mylene1f4_clip_source(context)) {
	Frame4(context)->skipped++;
    } else {
	Frame4(context)->skipped = 0;
    }

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
deck_back(void *context, unsigned s)
{
    int (*const *ever) (void *, unsigned), status;
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.data.sign.deck ^= 64;

    ever = frame4_data->a112.ever;

    ever++;

    frame4_data->a112.ever = ever;

    status = (*ever) (context, s);

    return status;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
deck_miss(void *context, unsigned c)
{
    int status;
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    if (!(c & 127)) {
	status = 1;
    } else {
	int (*const *ever) (void *, unsigned);

	ever = frame4_data->a112.ever;

	ever++;

	frame4_data->a112.ever = ever;

	status = (*ever) (context, c);
    }

    return status;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
deck_post(void *context, unsigned c)
{
    int status;
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    if (c & 128) {
	unsigned size;

	c &= ~128;

	size = frame4_data->a112.deck;
	size <<= 7;
	size += c;
	frame4_data->a112.deck = size;

	status = 0;
    } else {
	int (*const *ever) (void *, unsigned);
	unsigned size;

	size = frame4_data->a112.deck;
	size <<= 7;
	size += c;
	frame4_data->a112.deck = size;

	ever = frame4_data->a112.ever;

	ever++;

	frame4_data->a112.ever = ever;

	status = (*ever) (context, size);
    }

    return status;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
deck_sign(void *context, unsigned c)
{
    int status;
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    if (c == 64) {
	status = 1;
    } else {
	int (*const *ever) (void *, unsigned);

        frame4_data->a112.data.sign.deck = c & 64;

	ever = frame4_data->a112.ever;

	if ((c & (64 | 63)) == 64) {
	    status = 0;

	    ever++;

	    frame4_data->a112.ever = ever;
        } else {
	    ever += 2;

	    frame4_data->a112.ever = ever;

	    status = (*ever) (context, c & ~64);
	}
    }

    return status;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
head_list(void *context)
{
    Mylene1f4_fix_index(context, &Frame4(context)->i144.post);

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
lose_text(void *context)
{
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    free(frame4_data->a112.data.text.text);

    frame4_data->flags &= ~Mylene1f4_FREE_CLIENT;

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
mind_post(void *context, unsigned c)
{
    int (*const *ever) (void *, unsigned);
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    ever = frame4_data->a112.ever;

    frame4_data->a112.deck = 0;

    ever++;

    frame4_data->a112.ever = ever;

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_EQUEUE_SERVER__
static int
miss_cEil(void *context, unsigned c, unsigned deck, unsigned size)
{
    struct frame4_type *frame4_data;
    struct stripe_type *stripe_data;

    frame4_data = Frame4(context);

    if (c == 0x5e) {
	stripe_data = frame4_data->clip_stripe;
    } else {
	stripe_data = frame4_data->play_stripe;
    }

    if (stripe_data) {
	unsigned lqueue;

	lqueue = stripe_data->iqueue.lqueue;

	if (lqueue) {
	    do {
		unsigned delete;

		delete = size;
		if (deck) {
		    if (lqueue < delete) {
			break;
		    } else {
			delete = lqueue - delete;
		    }
		} else {
		    if (delete < lqueue) {
		    } else {
			break;
		    }
		}

		/*
		 * TODO
		 *
		 * _miss_extent
		 */
		if (stripe_data->iqueue.lqueue == 1) {
		    Mylene1f4_free_equeue
			(context, stripe_data->iqueue.head_equeue);

		    free(stripe_data);

		    if (c == 0x5e) {
			frame4_data->clip_stripe = NULL;
		    } else {
			frame4_data->play_stripe = NULL;
		    }
		} else {
		    Mylene1f4_miss_iqueue
			(context, &stripe_data->iqueue, delete);
		}
	    } while (0);
	}
    }

    return 0;
}
#endif				/* __ENABLE_EQUEUE_SERVER__ */


#if __ENABLE_EQUEUE_SERVER__
static int
miss_name(void *context)
{
    char *name;
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    name = frame4_data->dana.name;
    if (name) {
	free(name);
	frame4_data->dana.name = NULL;
    }

    return 0;
}
#endif				/* __ENABLE_EQUEUE_SERVER__ */


#if __ENABLE_EQUEUE_SERVER__
static int
miss_rail(void *context, struct equeue_type *equeue_data, unsigned *v,
	  struct equeue_type **tail)
{
    {
	struct equeue_type *equeue_slip;

	equeue_slip = equeue_data->equeue_data;
	if (equeue_slip) {
	    miss_rail(context, equeue_slip, v, tail);
	}
    }
    {
	unsigned e;

	e = *v;
	if (~e) {
	    if (!e) {
		equeue_data->equeue_data = NULL;
		*tail = equeue_data;
		*v = ~0;
	    } else {
		Mylene1f4_free_equeue(context, equeue_data);
		*v = e - 1;
	    }
	}
    }

    return 0;
}
#endif				/* __ENABLE_EQUEUE_SERVER__ */


#if __ENABLE_EQUEUE_SERVER__
static int
miss_tail(void *context, unsigned v)
{
    struct frame4_type *frame4_data;
    unsigned lqueue;

    frame4_data = Frame4(context);

    lqueue = frame4_data->iqueue.lqueue;
    if (v < lqueue) {
	if (v) {
	    unsigned w[2];

	    w[0] = v;
	    frame4_data->iqueue.lqueue = lqueue - v;
	    miss_rail(context, frame4_data->iqueue.head_equeue, w,
		      &frame4_data->iqueue.tail_equeue);
	}
    } else {
	Mylene1f4_lose_equeue(context);
    }

    return 0;
}
#endif				/* __ENABLE_EQUEUE_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
mode_aime(void *context, unsigned size)
{
    int (*const *ever) (void *, unsigned), status;
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.aime.mode.post = size;
    frame4_data->a112.aime.mode.sign = frame4_data->a112.data.sign.deck;

    ever = frame4_data->a112.ever;

    ever++;

    frame4_data->a112.ever = ever;

    status = (*ever) (context, 0);

    return status;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
mode_alia(void *context, unsigned size)
{
    int (*const *ever) (void *, unsigned), status;
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.aime.alia.deck = size;

    ever = frame4_data->a112.ever;

    ever++;

    frame4_data->a112.ever = ever;

    status = (*ever) (context, 0);

    return status;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
mode_ever(void *context, unsigned size)
{
    int (*const *ever) (void *, unsigned), status;
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.aime.alia.data.ever.deck = size;

    ever = frame4_data->a112.ever;

    ever++;

    frame4_data->a112.ever = ever;

    status = (*ever) (context, 0);

    return status;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
near_x1st(void *context, unsigned size)
{
    int (*const *ever) (void *, unsigned);
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    ever = frame4_data->a112.ever;

    ever++;

    frame4_data->a112.ever = ever;

    frame4_data->a112.data.near.x1st = size;

    return (*ever) (context, size);
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
near_x2nd(void *context, unsigned size)
{
    int (*const *ever) (void *, unsigned);
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    ever = frame4_data->a112.ever;

    ever++;

    frame4_data->a112.ever = ever;

    frame4_data->a112.data.near.x2nd = size;

    return (*ever) (context, size);
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
near_x3rd(void *context, unsigned size)
{
    int (*const *ever) (void *, unsigned);
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    ever = frame4_data->a112.ever;

    ever++;

    frame4_data->a112.ever = ever;

    frame4_data->a112.data.near.x3rd = size;

    return (*ever) (context, size);
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
pick_e0fa(void *context, unsigned c, unsigned size)
{
    unsigned index;

    if (LINK(context)) {
	index = REFERENCE(context);
    } else {
	unsigned cache;

	cache = C1f4(context) - STATE(context)[Mylene1f4_REAL_STATE];
	if (SIZE(context) < cache) {
	    cache += SIZE(context);
	}
	index = REFERENCE(context) - cache / RELEASE(context);
    }
    if (c) {
	Frame4(context)->next.deck = size + index;
    } else {
	struct frame4_type *frame4_data;

	frame4_data = Frame4(context);
	if (index < size) {
	    frame4_data->next.deck = 0;
	} else {
	    frame4_data->next.deck = index - size;
	}
    }

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
pick_list(void *context)
{
    unsigned post, swap;

    Mylene1f4_fix_index(context, &post);
    swap = rand() % EXCESS(context).e1.list87.count;
    if (swap < post) {
	Frame4(context)->i144.post = post - swap;
	Frame4(context)->i144.sign = Mylene1f4_LOAD_LAST;
    } else {
	Frame4(context)->i144.post = swap - post;
	Frame4(context)->i144.sign = Mylene1f4_LOAD_NEXT;
    }

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
seek_e0fa(void *context, unsigned c, unsigned size)
{
    int delete;

    /*
     * TODO
     *
     * rewrite so that START6 it temporarily swapped for time to jump to
     */
    if (1) {
# if __SEEK_XMPEG1__
	struct sequel_type *sequel_data;
# endif					/* __SEEK_XMPEG1__ */

# if __SEEK_XMPEG1__
	if (!Mylene1f4_find_sequel
	    (context, Mylene1f4_XMPEG1_SEQUEL, (void *) &sequel_data)) {
	    delete = 0;
	} else {
# endif					/* __SEEK_XMPEG1__ */
	    double base;
	    struct frame4_type *frame4_data;
# if __SEEK_XMPEG1__
	    struct xmpeg1_type *xmpeg1_data;
# endif					/* __SEEK_XMPEG1__ */

	    frame4_data = Frame4(context);

	    base = frame4_data->a112.data.near.x1st * 3600
		+ frame4_data->a112.data.near.x2nd * 60
		+ frame4_data->a112.data.near.x3rd;
	    base = base + (double) size / 60;

# if __SEEK_XMPEG1__
	    xmpeg1_data = sequel_data->data;
# endif					/* __SEEK_XMPEG1__ */

# if __SEEK_XMPEG1__
	    base *= xmpeg1_data->frame_rate_n;
	    base /= xmpeg1_data->frame_rate_d;
# else
	    base *= SAMPLING(context) * CHANNELS(context) << 1;
	    base /= RELEASE(context);
# endif					/* __SEEK_XMPEG1__ */

	    delete = 1;

	    if (c != 0x1d) {
		pick_e0fa(context, c - 0x1e, base);
	    } else {
		frame4_data->next.deck = base;
	    }
# if __SEEK_XMPEG1__
	}
# endif					/* __SEEK_XMPEG1__ */
    }

    return delete;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
side_baCk(void *context, unsigned c)
{
    char *data;
    int status;
    struct frame4_type *frame4_data;
    unsigned size;

    frame4_data = Frame4(context);

    data = frame4_data->a112.data.text.data;
    size = frame4_data->a112.data.text.size;
    if (1) {
	data[0] = c;
    }
    size--;
    if (size) {
	status = 0;

	data++;

# if __NONBLOCKING_CLIENT_TRANSFER__
	if (Mylene1f4_edge_e3e8(context, &data, &size)) {
	    if (size) {
# endif				/* __NONBLOCKING_CLIENT_TRANSFER__ */
		frame4_data->a112.data.text.data = data;
		frame4_data->a112.data.text.size = size;
# if __NONBLOCKING_CLIENT_TRANSFER__
	    } else {
		int (*const *ever) (void *, unsigned);

		ever = frame4_data->a112.ever;

		ever++;

		frame4_data->a112.ever = ever;

		status = (*ever) (context, frame4_data->a112.deck);
	    }
	}
# endif				/* __NONBLOCKING_CLIENT_TRANSFER__ */
    } else {
	int (*const *ever) (void *, unsigned);

	ever = frame4_data->a112.ever;

	ever++;

	frame4_data->a112.ever = ever;

	status = (*ever) (context, frame4_data->a112.deck);
    }

    return status;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
side_back(void *context, unsigned c)
{
    char *data;
    int status;
    struct frame4_type *frame4_data;
    unsigned size;

    frame4_data = Frame4(context);

    data = frame4_data->a112.data.text.data;
    size = frame4_data->a112.data.text.size;
    if (c != '*') {
	data[0] = c;
    } else {
	if (size == frame4_data->a112.deck) {
	    data[0] = c;
	} else {
	    if (*(data - 1) != '*') {
		data[0] = c;
	    } else {
		data--;
		frame4_data->a112.deck--;
	    }
	}
    }
    size--;
    if (size) {
	status = 0;

	data++;
	frame4_data->a112.data.text.data = data;
	frame4_data->a112.data.text.size = size;
    } else {
	int (*const *ever) (void *, unsigned);

	ever = frame4_data->a112.ever;

	ever++;

	frame4_data->a112.ever = ever;

	status = (*ever) (context, frame4_data->a112.deck);
    }

    return status;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
side_teXt(void *context, unsigned size, unsigned extra)
{
    char *data;
    int status;
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    data = (char *) malloc(size + extra);
    if (!data) {
	status = -1;
    } else {
	frame4_data->a112.data.text.data = data;
	frame4_data->a112.data.text.size = size;
	frame4_data->a112.data.text.text = data;

	if (1) {
	    int (*const *ever) (void *, unsigned);

	    ever = frame4_data->a112.ever;

	    if (size) {
		ever++;
	    } else {
		ever += 2;
	    }

	    frame4_data->a112.ever = ever;

	    frame4_data->flags |= Mylene1f4_FREE_CLIENT;

	    if (size) {
		status = 0;
	    } else {
		status = (*ever) (context, size);
	    }
	}
    }

    return status;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
side_text(void *context, unsigned size, unsigned extra)
{
    int status;

    if (WINDOW(context).server.transfer < size) {
	Mylene1f4_near_side(context, size);

	status = -1;
    } else {
	status = side_teXt(context, size, extra);
    }

    return status;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
slip_id3v(void *context, void *major, void *minor, unsigned scope)
{
    const char *field;
    unsigned count = 30;

    field = (char *) ID3X(context) + scope;
    Mylene1f4_shrink_field(&field, &count);

    return slip_id3x(context, major, minor, field, count);
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
slip_id3w(void *context, void *major, void *minor, unsigned scope)
{
    struct id3tag_type *id3tag_data;

    id3tag_data = ID3X(context);

    return slip_id3x(context, major, minor, id3tag_data->data[scope],
		     id3tag_data->size[scope]);
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
slip_id3x(void *context, void *major, void *minor, const char *text,
	  unsigned size)
{
    int status = 0;

    do {
	char *data;

	if (!size) {
	    data = NULL;
	} else {
	    data = (char *) malloc(size + 1);
	    if (!data) {
		status = -1;

		break;
	    } else {
		memcpy(data, text, size);
		data[size] = 0;
	    }
	}

	if (SLACK(context).size < size) {
	    char *Swap;

	    Swap = (char *) malloc(size);
	    if (!Swap) {
		status = -1;

		if (data) {
		    free(data);
		}

		break;
	    } else {
		char *swap;

		swap = SLACK(context).data;

		SLACK(context).data = Swap;
		SLACK(context).size = size;

		if (swap) {
		    free(swap);
		}
	    }
	}

	{
	    char *text;

	    text = (char *) string(major)->data;

	    string(major)->data = data;
	    string(major)->size = size;

	    if (text != string(minor)->data) {
		if (text) {
		    free(text);
		}
	    }
	}
    } while (0);

    return status;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
slip_less(void *context, unsigned size, unsigned class)
{
    char *data;
    int status;
    struct frame4_type *frame4_data;
    void *c_format;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    data = frame4_data->a112.data.text.text;

    data[size] = 0;
    status = Mylene1f4_init_format(context, data, &c_format);
    if (status) {
	Mylene1f4_near_flat(context, data, class);

	status = 0;
    } else {
	if (1) {
	    void *major, *minor, **third;

	    if (class == 00061) {
		third = &PROGRESS1(context);
		minor = Less_1(frame4_data);
	    } else if (class == 00062) {
		third = &PROGRESS2(context);
		minor = Less_2(frame4_data);
	    } else {
		third = &PROGRESS3(context);
		minor = Less_3(frame4_data);
	    }

	    major = *third;

	    *third = c_format;

	    if (major != minor) {
		if (major) {
		    Mylene1f4_fini_format(context, &major);
		}
	    }
	}
    }

    lose_text(context);

    return status;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
slip_miss(void *context, void *major, void *minor)
{
    char *text;

    text = (char *) string(major)->data;

    string(major)->data = NULL;
    string(major)->size = 0;

    if (text != string(minor)->data) {
	if (text) {
	    free(text);
	}
    }

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
slip_text(void *context, unsigned size, unsigned class)
{
    int status;
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    frame4_data->a112.ever = NULL;

    do {
	char *data;

	data = frame4_data->a112.data.text.text;

	if (size == 1) {
	    if (*data == '*') {
		lose_text(context);
		data = NULL;
		size = 0;
	    }
	}

	if (SLACK(context).size < size) {
	    char *Swap;

	    Swap = (char *) malloc(size);
	    if (!Swap) {
		status = 1;

		if (data) {
		    lose_text(context);
		}

		break;
	    } else {
		char *swap;

		swap = SLACK(context).data;

		SLACK(context).data = Swap;
		SLACK(context).size = size;

		if (swap) {
		    free(swap);
		}
	    }
	}

	status = 0;

	{
	    char *text;
	    struct string_type *major, *minor;

	    if (class == 00141) {
		major = &ALBUM(context);
		minor = &Album(context);
	    } else if (class == 00142) {
		major = &LBASE(context);
		minor = &Lbase(context);
	    } else if (class == 00155) {
		major = &MATCH(context);
		minor = &Match(context);
	    } else if (class == 00156) {
		major = &NOTES(context);
		minor = &Notes(context);
	    } else if (class == 00161) {
		major = &LPATH(context);
		minor = &Lpath(context);
	    } else {
		major = &TITLE(context);
		minor = &Title(context);
	    }

	    text = (char *) major->data;

	    frame4_data->flags &= ~Mylene1f4_FREE_CLIENT;

	    major->data = data;
	    major->size = size;

	    if (text != minor->data) {
		if (text) {
		    free(text);
		}
	    }
	}
    } while (0);

    return status;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
text____0(void *context, unsigned size)
{
    return side_text(context, size, 0);
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
static int
text____1(void *context, unsigned size)
{
    return side_text(context, size, 1);
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
int
Mylene1f4_look_alia(void *context, unsigned c)
{
    Frame4(context)->a112.ever = ever_0160[c];

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */
