/*
 * back.c
 * Copyright (C) 2005-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#if __ENABLE_CONTROLLING_SERVER__
# include <stdlib.h>
# include <stddef.h>
# include <string.h>
#endif				/* __ENABLE_CONTROLLING_SERVER__ */

#if __ENABLE_CONTROLLING_SERVER__
# include <access.h>
# include <excess4.h>
# include <excess7.h>
#endif				/* __ENABLE_CONTROLLING_SERVER__ */

#if __ENABLE_CONTROLLING_SERVER__
# define Frame4(context) \
    ((struct frame4_type *) &Frame7((context))->_1.frame4)
# define Frame7(context) \
    ((struct frame7_type *) WINDOW((context)).server.window)
#endif				/* __ENABLE_CONTROLLING_SERVER__ */

#if __ENABLE_CONTROLLING_SERVER__
int
Mylene1f4_pipe_back(void *context, const char *Data, unsigned Size)
{
    char *data;
    int status = 0;
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    data = frame4_data->back.slack.data;
    if (!data) {
	data = (char *) malloc(Size);
	if (!data) {
	    status = -1;
	} else {
	    memcpy(data, Data, Size);

	    frame4_data->back.slack.data = data;
	    frame4_data->back.slack.size = Size;
	    frame4_data->back.slide.data = data;
	    frame4_data->back.slide.size = Size;
	}
    } else {
	do {
	    char *text;
	    unsigned back, post, size;

	    text = frame4_data->back.slide.data;

	    back = frame4_data->back.slide.size;
	    size = frame4_data->back.slack.size;

	    post = back + Size;

	    if (size - back < Size) {
		char *swap;

		swap = realloc(data, post);
		if (!swap) {
		    status = -1;
		    break;
		}

		if (swap != data) {
		    ptrdiff_t diff;

		    diff = text - data;
		    text = swap + diff;

		    data = swap;
		}

		frame4_data->back.slack.data = data;
		frame4_data->back.slack.size = post;
	    }

	    if (text != data) {
		memmove(data, text, back);
	    }

	    memcpy(data + back, Data, Size);

	    if (1) {
		frame4_data->back.slide.data = data;
		frame4_data->back.slide.size = post;
	    }
	} while (0);
    }

    return status;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */
