/*
 * back2.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#if __ENABLE_CHANNEL_EQUEUE__
# include <access.h>
# include <excess4.h>
# include <excess7.h>
# include <inter.h>
#endif				/* __ENABLE_CHANNEL_EQUEUE__ */

#if __ENABLE_CHANNEL_EQUEUE__
# define Frame4(context) \
    ((struct frame4_type *) &Frame7((context))->_1.frame4)
# define Frame7(context) \
    ((struct frame7_type *) WINDOW((context)).server.window)
#endif				/* __ENABLE_CHANNEL_EQUEUE__ */

#if __ENABLE_CHANNEL_EQUEUE__
int
Mylene1f4_case_back(void *context, const char *Data, unsigned Size)
{
    int status;
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    if (!(frame4_data->flags & Mylene1f4_AIME_TARGET)) {
	status = 0;
    } else {
	if (frame4_data->client_id != frame4_data->client_up) {
	    status = 0;
	} else {
	    status = Mylene1f4_fast_back(context, frame4_data->channel);
	    if (status) {
	    } else {
		status = Mylene1f4_miss_back(context, Data, Size);
	    }
	}
    }

    return status;
}
#endif				/* __ENABLE_CHANNEL_EQUEUE__ */
