/*
 * e4lx.c
 * Copyright (C) 2008-2014, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#if __ENABLE_EQUEUE__
# include <aime.h>
# include <stddef.h>
# include <stdlib.h>
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# include <access.h>
# include <aime1.h>
# include <defs.h>
# include <excess4.h>
# include <excess7.h>
# include <inter.h>
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define M500_L7_DECK			Mylene1f4_L7_DECK
# define M500_L7_TRAP			Mylene1f4_L7_TRAP
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define push_flat			Mylene1f4_fprintc_error
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define DATA_BITS \
    X1f4_LXDATA_EVERLINK
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define DATE_BITS \
    X1f4_LXDATE_EVERLINK
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define FLAT_BITS \
    X1f4_LXFLAT_ABSTRACT | X1f4_LXFLAT_RESOURCE
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define LINE_BITS \
    X1f4_LXLINE_EVERLINK | X1f4_LXLINE_RESETNEW
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define LIST_BITS \
    X1f4_LXLIST_EVERLINK | X1f4_LXLIST_RESETNEW
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define NEAR_BITS \
    X1f4_LXNEAR_LONGPIPE
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define TRAP_BITS \
    X1f4_LXTRAP_REPORTER
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_CHANNEL_EQUEUE__
# define back_text			Mylene1f4_case_back
#endif				/* __ENABLE_CHANNEL_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define equeue(equeue) \
    ((struct equeue_type *) (equeue))
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define frame4(frame4) \
    ((struct frame4_type *) (frame4))
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define Frame4(context) \
    ((struct frame4_type *) &Frame7((context))->_1.frame4)
# define Frame7(context) \
    ((struct frame7_type *) WINDOW((context)).server.window)
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
typedef struct e4deck_type {
    struct x1f4_e2line_type e2line;
    struct x1f4_indexset_type indexset;
} e4deck_type;
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
struct x1f4_cxflat_type _Mylene1f4_e4lx_flat_types[] = {
/* *INDENT-OFF* */
    {	"Deck",			0,		4,		}
/* *INDENT-ON* */
};
struct x1f4_dxflat_type _Mylene1f4_e4lx_flat[] = {
/* *INDENT-OFF* */
    {	1,			NULL,				}
/* *INDENT-ON* */
};
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_CHANNEL_EQUEUE__
#elif __ENABLE_EQUEUE__
static int back_text(void *, const char *, unsigned);
#endif				/* __ENABLE_CHANNEL_EQUEUE__ */
#if __ENABLE_EQUEUE__
static int call_flat(void *, void *);
static int fini_e4lx(void *, struct e4deck_type *, struct e4text_type *);
static int free_flat(void *, void *);
static int free_line(void *, void *);
static int init_e4lx(void *, struct e4deck_type *, struct e4text_type *);
static int init_line(void *, struct e4deck_type *, struct e4text_type *);
static int line_e4lx(void *);
static int line_flat(void *, int);
static int link_flat(void *, void **, unsigned);
static int link_line(void *, void **, unsigned);
static int link_text(void *, const char *, unsigned);
static int mode_flat(void *, void **, unsigned);
static int mode_line(void *, void **, unsigned);
static int pick_line(void *, void ***, int (*) (void *), unsigned, void **);
static int post_flat(void *);
static int slip_line(void *, void *, void *, int (*) (void *));
static int type_e4lx(void *, struct e4deck_type *, struct e4text_type *);
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
static struct x1f4_datapipe_type long_pipes[] = {
/* *INDENT-OFF* */
    {	"b",			x1f4_pipe_lxdata,
	0,			1,		NULL		}
/* *INDENT-ON* */
};
static struct x1f4_lxflat_type lxflat;
static struct x1f4_lxnear_type lxnear;
static struct x1f4_lxtrap_type lxtrap;
const static struct x1f4_lxtile_type tiles[] = {
/* *INDENT-OFF* */
    {	x1f4_note_lxcast,	0,		NULL		},
    {	x1f4_note_lxdata,	DATA_BITS,	NULL		},
    {	x1f4_note_lxdate,	DATE_BITS,	NULL		},
    {	x1f4_note_lxflat,	FLAT_BITS,	&lxflat		},
    {	x1f4_note_lxline,	LINE_BITS,	NULL		},
    {	x1f4_note_lxlist,	LIST_BITS,	NULL		},
    {	x1f4_note_lxmath,	0,		NULL		},
    {	x1f4_note_lxnear,	NEAR_BITS,	&lxnear		},
    {	x1f4_note_lxtext,	0,		NULL		},
    {	x1f4_note_lxtrap,	TRAP_BITS,	&lxtrap		}
/* *INDENT-ON* */
};
static struct x1f4_textpipe_type near_pipes[] = {
/* *INDENT-OFF* */
    {	"C",	back_text,			1,	NULL	},
    {	"O",	link_text,			1,	NULL	},
    {	"V",	Mylene1f4_fprintc_error,	1,	NULL	}
/* *INDENT-ON* */
};
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_CHANNEL_EQUEUE__
#elif __ENABLE_EQUEUE__
static int
back_text(void *context, const char *data, unsigned size)
{
    return 0;
}
#endif				/* __ENABLE_CHANNEL_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
call_flat(void *shrews, void *data)
{
    struct equeue_type *equeue_data;

    equeue_data = ((struct x1f4_dxflat_type *) data)->data;
    if (equeue_data) {
	equeue_data->dxflat = NULL;
    }

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
fini_e4lx(void *context, struct e4deck_type *e4deck_data,
	  struct e4text_type *e4text_data)
{
    Mylene1f4_flat_e4lx(&e4deck_data->indexset);

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
free_flat(void *frame4, void *data)
{
    free(data);

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
free_line(void *frame4, void *data)
{
    return x1f4_free_e2list
	(equeue(frame4(frame4)->dana.equeue)->slip.aime.e2list, data);
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
init_e4lx(void *context, struct e4deck_type *e4deck_data,
	  struct e4text_type *e4text_data)
{
    int status;

    init_line(context, e4deck_data, e4text_data);
    if (0) {
    } else {
	struct frame4_type *frame4_data;

	frame4_data = Frame4(context);

	status = Mylene1f4_fast_e4lx
	    (context, frame4_data, &frame4_data->dana.flat,
	     &e4deck_data->indexset);
    }

    return status;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
init_line(void *context, struct e4deck_type *e4deck_data,
	  struct e4text_type *e4text_data)
{
    struct frame4_type *frame4_data;

    e4deck_data->e2line.bits = X1f4_E2LIST_FLATLINE | X1f4_E2LIST_MISSLINK;

    frame4_data = Frame4(context);

    e4deck_data->e2line.e2list.flatline_set.class = &frame4_data->dana.flat;

    e4deck_data->e2line.e2list.misslink_set.data = frame4_data;

    e4deck_data->e2line.e2list.misslink_set.free = Mylene1f4_free_moon;
    e4deck_data->e2line.e2list.misslink_set.link = Mylene1f4_link_moon;
    e4deck_data->e2line.e2list.misslink_set.mode = Mylene1f4_mode_moon;

    e4text_data->e2line = &e4deck_data->e2line;

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
line_e4lx(void *context)
{
    int status;
    struct e4text_type *e4text_data;

    e4text_data = (struct e4text_type *) malloc(sizeof(struct e4text_type));
    if (!e4text_data) {
	status = -1;
    } else {
	struct e4deck_type *e4deck_data;

	e4deck_data = (struct e4deck_type *)
	    malloc(sizeof(struct e4deck_type));
	if (!e4deck_data) {
	    status = -1;
	} else {
	    status = init_e4lx(context, e4deck_data, e4text_data);
	}

	if (status) {
	    free(e4text_data);
	} else {
	    e4text_data->e4deck = e4deck_data;

	    e4text_data->indexset = &e4deck_data->indexset;

	    type_e4lx(context, e4deck_data, e4text_data);

	    Frame4(context)->lxdeck = e4text_data;
	}
    }

    return status;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
line_flat(void *context, int class)
{
    char *name;
    struct equeue_type *equeue_data;
    unsigned line;

    equeue_data = Frame4(context)->dana.equeue;

    name = equeue_data->name;

    equeue_data->bits |= Mylene1f4_FAILED_LOGIC;

    equeue_data->june.look(equeue_data->data.aime, &line);
    if (1) {
	const char *rate;

	rate = equeue_data->rate;
	if (rate) {
	    unsigned copy;

	    copy = line;
	    line = 1;
	    while (copy) {
		if (*rate == 10) {
		    line++;
		}

		copy--;
		rate++;
	    }
	}
    }

    Mylene1f4_fprintf_error(context, "%s: cannot execute", Mylene1f4(context));
    if (name) {
	Mylene1f4_fprintf_error(context, " `%s'", name);
    }
    Mylene1f4_fprintf_error(context, " program: %d: ", line);

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
link_flat(void *frame4, void **data, unsigned size)
{
    int status;
    void *text;

    text = malloc(size);
    if (text) {
	status = 0;
	*data = text;
    } else {
	status = -1;
    }

    return status;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
link_line(void *frame4, void **data, unsigned size)
{
    return x1f4_link_e2list
	(equeue(frame4(frame4)->dana.equeue)->slip.aime.e2list, data, size);
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
link_text(void *context, const char *data, unsigned size)
{
    LINE(context) (context, data, size);

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
mode_flat(void *frame4, void **data, unsigned size)
{
    int status;
    void *text;

    text = realloc(*data, size);
    if (text) {
	status = 0;
	*data = text;
    } else {
	status = -1;
    }

    return status;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
mode_line(void *frame4, void **data, unsigned size)
{
    return x1f4_mode_e2list
	(equeue(frame4(frame4)->dana.equeue)->slip.aime.e2list, data, size);
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
pick_line(void *frame4, void ***address, int (*f) (void *), unsigned size,
	  void **data)
{
    return x1f4_pick_e2list
	(equeue(frame4(frame4)->dana.equeue)->slip.aime.e2list, address, f,
	 size, data);
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
post_flat(void *context)
{
    Mylene1f4_fprintf_error(context, "\n");

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
slip_line(void *frame4, void *data, void *miss, int (*f) (void *))
{
    return x1f4_slip_e2list
	(equeue(frame4(frame4)->dana.equeue)->slip.aime.e2list, data, miss, f);
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
static int
type_e4lx(void *context, struct e4deck_type *e4deck_data,
	  struct e4text_type *e4text_data)
{
    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
int
Mylene1f4_fast_e4lx(void *context, void *frame4, int *class, void *indexset)
{
    struct x1f4_textport_type textport;
    unsigned i, textport_bits;

    textport_bits = X1f4_TEXTPORT_AUTOLINK | X1f4_TEXTPORT_CASTTYPE
	| X1f4_TEXTPORT_RESOURCE | X1f4_TEXTPORT_SUB2LIST
	| X1f4_TEXTPORT_SUBFLIST | X1f4_TEXTPORT_TEXTFLAT;

    textport.autolink_set.data = frame4;

    textport.autolink_set.free = free_line;
    textport.autolink_set.link = link_line;
    textport.autolink_set.mode = mode_line;
    textport.autolink_set.pick = pick_line;
    textport.autolink_set.slip = slip_line;

    textport.lasttype_set.type = X1f4_E4_LAST;

    textport.tilelong_set.lxtile_data = tiles;
    textport.tilelong_set.miss =
	sizeof(tiles) / sizeof(struct x1f4_lxtile_type);

    lxflat.abstract_set.call = call_flat;

    lxflat.datatype_set.cxflat_data = _Mylene1f4_e4lx_flat_types;
    lxflat.datatype_set.miss = 1;

    lxflat.resource_set.data = frame4;

    lxflat.resource_set.free = free_flat;
    lxflat.resource_set.link = link_flat;
    lxflat.resource_set.mode = mode_flat;

    lxnear.longpipe_set.datapipe_data = long_pipes;
    lxnear.longpipe_set.miss =
	sizeof(near_pipes) / sizeof(struct x1f4_datapipe_type);

    lxnear.nearpipe_set.textpipe_data = near_pipes;
    lxnear.nearpipe_set.miss =
	sizeof(near_pipes) / sizeof(struct x1f4_textpipe_type);

    i = sizeof(near_pipes) / sizeof(struct x1f4_textpipe_type);
    do {
	i--;
	near_pipes[i].text = context;
    } while (i);

    if (frame4) {
	frame4(frame4)->dana.plain.data = context;
	frame4(frame4)->dana.plain.line = line_flat;
	frame4(frame4)->dana.plain.post = post_flat;
	frame4(frame4)->dana.plain.push = push_flat;

	lxtrap.reporter_set.track = &frame4(frame4)->dana.eport;

	x1f4_rule_eproxy(&frame4(frame4)->dana.track);

	frame4(frame4)->dana.track.data = &frame4(frame4)->dana.eport;
    }

    textport.resource_set.data = frame4;

    textport.resource_set.free = Mylene1f4_free_moon;
    textport.resource_set.link = Mylene1f4_link_moon;
    textport.resource_set.mode = Mylene1f4_mode_moon;

    if (frame4) {
	textport.textflat_set = frame4(frame4)->dana.track;
    }

    textport.autodeck_set.class = class;

    return x1f4_fast_indexset(indexset, textport_bits, &textport);
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
int
Mylene1f4_flat_e4lx(void *indexset)
{
    return x1f4_flat_indexset(indexset);
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
int
Mylene1f4_line_e4lx(void *context)
{
    int status;

    if (Frame4(context)->lxdeck) {
	status = 0;
    } else {
	status = line_e4lx(context);
    }

    return status;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
int
Mylene1f4_wind_e4lx(void *context)
{
    struct e4text_type *e4text_data;

    e4text_data = Frame4(context)->lxdeck;
    if (e4text_data) {
	struct e4deck_type *e4deck_data;

	e4deck_data = e4text_data->e4deck;

	fini_e4lx(context, e4deck_data, e4text_data);

	free(e4deck_data);

	free(e4text_data);
    }

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
int
Mylene1f4_xset_e4lx(void *context)
{
    Frame4(context)->lxdeck = NULL;

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */
