/*
 * equeue1.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#if __ENABLE_CHANNEL_EQUEUE__
# include <access.h>
# include <excess4.h>
# include <excess7.h>
# include <inter.h>
# include <types.h>
#endif				/* __ENABLE_CHANNEL_EQUEUE__ */

#if __ENABLE_CHANNEL_EQUEUE__
# define Frame4(context) \
    ((struct frame4_type *) &Frame7((context))->_1.frame4)
# define Frame7(context) \
    ((struct frame7_type *) WINDOW((context)).server.window)
#endif				/* __ENABLE_CHANNEL_EQUEUE__ */

#if __ENABLE_CHANNEL_EQUEUE__
static int away_iqueue(struct iqueue_type *);
static int case_iqueue(struct iqueue_type *, unsigned);
#endif				/* __ENABLE_CHANNEL_EQUEUE__ */

#if __ENABLE_CHANNEL_EQUEUE__
static int
away_iqueue(struct iqueue_type *iqueue_data)
{
    unsigned l;

    l = iqueue_data->lqueue;
    if (l) {
	struct equeue_type *equeue_data;

	equeue_data = iqueue_data->head_equeue;
	while (1) {
	    if (1) {
		equeue_data->client = 0;
	    }

	    --l;
	    if (!l) {
		break;
	    } else {
		equeue_data = equeue_data->equeue_data;
	    }
	}
    }

    return 0;
}
#endif				/* __ENABLE_CHANNEL_EQUEUE__ */


#if __ENABLE_CHANNEL_EQUEUE__
static int
case_iqueue(struct iqueue_type *iqueue_data, unsigned track)
{
    unsigned l;

    l = iqueue_data->lqueue;
    if (l) {
	struct equeue_type *equeue_data;

	equeue_data = iqueue_data->head_equeue;
	while (1) {
	    if (equeue_data->channel == track) {
		equeue_data->client = 0;
	    }

	    --l;
	    if (!l) {
		break;
	    } else {
		equeue_data = equeue_data->equeue_data;
	    }
	}
    }

    return 0;
}
#endif				/* __ENABLE_CHANNEL_EQUEUE__ */


#if __ENABLE_CHANNEL_EQUEUE__
int
Mylene1f4_away_equeue(void *context)
{
    struct frame4_type *frame4_data;
    struct stripe_type *stripe_data;

    frame4_data = Frame4(context);

    away_iqueue(&frame4_data->iqueue);

    stripe_data = frame4_data->clip_stripe;
    if (stripe_data) {
	away_iqueue(&stripe_data->iqueue);
    }

    stripe_data = frame4_data->play_stripe;
    if (stripe_data) {
	away_iqueue(&stripe_data->iqueue);
    }

    if (frame4_data->flags & Mylene1f4_AIME_LINKED) {
	Mylene1f4_away_aime(context);
    }

    return 0;
}
#endif				/* __ENABLE_CHANNEL_EQUEUE__ */


#if __ENABLE_CHANNEL_EQUEUE__
int
Mylene1f4_case_equeue(void *context, unsigned track)
{
    struct frame4_type *frame4_data;
    struct stripe_type *stripe_data;

    frame4_data = Frame4(context);

    case_iqueue(&frame4_data->iqueue, track);

    stripe_data = frame4_data->clip_stripe;
    if (stripe_data) {
	case_iqueue(&stripe_data->iqueue, track);
    }

    stripe_data = frame4_data->play_stripe;
    if (stripe_data) {
	case_iqueue(&stripe_data->iqueue, track);
    }

    if (frame4_data->flags & Mylene1f4_AIME_LINKED) {
	Mylene1f4_case_aime(context, track);
    }

    return 0;
}
#endif				/* __ENABLE_CHANNEL_EQUEUE__ */
