/*
 * equeue2.c
 * Copyright (C) 2007-2011, 2013, 2014, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#if __ENABLE_EQUEUE__
# include <stdlib.h>
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# include <access.h>
# include <defs.h>
# include <excess4.h>
# include <excess7.h>
# include <inter.h>
# include <types.h>
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define frame4(becca2) \
    ((struct frame4_type *) (becca2))
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
static int fast_equeue(struct equeue_type *);
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
static int
fast_equeue(struct equeue_type *equeue_data)
{
    equeue_data->head_report = NULL;
    equeue_data->tail_report = NULL;

    equeue_data->text.data = NULL;
    equeue_data->text.link = NULL;

    equeue_data->dxflat = NULL;

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
int
Mylene1f4_fast_equeue(void *context, void *equeue, unsigned size, void *frame4)
{
    struct equeue_type *equeue_data;

    equeue_data = equeue;

    if (0) {
    } else {
	char *data;

	data = frame4(frame4)->a112.data.text.text;

	data[size] = 0;

	equeue_data->bits = 0;
	equeue_data->rate = data;
	equeue_data->name = NULL;

# if __ENABLE_CHANNEL_SERVER__
	equeue_data->channel = frame4(frame4)->channel_up;
	equeue_data->client = frame4(frame4)->client_up;
# endif				/* __ENABLE_CHANNEL_SERVER__ */

	fast_equeue(equeue_data);

	equeue_data->major = ~0;
	equeue_data->minor = ~0;
    }

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
int
Mylene1f4_link_equeue(void *iqueue, char *logique, const char **title)
{
    struct iqueue_type *iqueue_data;

    iqueue_data = iqueue;

    if (~(iqueue_data->lqueue | 1)) {
	struct equeue_type *equeue_data;

	equeue_data = (struct equeue_type *)
	    malloc(sizeof(struct equeue_type));
	if (!equeue_data) {
	    iqueue_data->lqueue = ~0 ^ 0;
	} else {
	    const char *name;
	    struct equeue_type *tail_equeue;

	    name = *title;
	    if (name) {
		*title = NULL;
	    }

	    equeue_data->bits = Mylene1f4_EXTERN_LOGIC;
	    equeue_data->rate = logique;
	    equeue_data->name = (char *) name;
	    equeue_data->equeue_data = NULL;

# if __ENABLE_CHANNEL_SERVER__
	    equeue_data->client = 0;
# endif				/* __ENABLE_CHANNEL_SERVER__ */

	    fast_equeue(equeue_data);

#if 0
	    /*
	     * for some reason _major_ and _minor_ are set in
	     * equeue.c._init_equeue
	     */
	    equeue_data->major = ?;
	    equeue_data->minor = ?;
#endif				/* 0 */

	    tail_equeue = iqueue_data->tail_equeue;

	    iqueue_data->tail_equeue = equeue_data;

	    iqueue_data->lqueue++;

	    if (tail_equeue) {
		tail_equeue->equeue_data = equeue_data;
	    } else {
		iqueue_data->head_equeue = equeue_data;
	    }
	}
    }

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
int
Mylene1f4_pick_equeue(void *context, void **equeue, unsigned size,
		      void *frame4)
{
    int status;
    struct equeue_type *equeue_data;

    equeue_data = (struct equeue_type *) malloc(sizeof(struct equeue_type));
    if (!equeue_data) {
	status = 1;
    } else {
	char *data;
	time_t now;

	status = 0;

	data = frame4(frame4)->a112.data.text.text;

	data[size] = 0;

	equeue_data->bits = 0;
	equeue_data->rate = data;
	equeue_data->name = frame4(frame4)->dana.name;

# if __ENABLE_CHANNEL_SERVER__
	equeue_data->channel = frame4(frame4)->channel_up;
	equeue_data->client = frame4(frame4)->client_up;
# endif				/* __ENABLE_CHANNEL_SERVER__ */

	fast_equeue(equeue_data);

	Mylene1f4_init_moon(context, equeue_data);

	time(&now);

	if (now != frame4(frame4)->dana.last) {
	    frame4(frame4)->dana.last = now;

	    equeue_data->minor = 0;

	    frame4(frame4)->dana.clip = 1;
	} else {
	    unsigned clip;

	    clip = frame4(frame4)->dana.clip;

	    equeue_data->minor = clip;

	    clip++;

	    frame4(frame4)->dana.clip = clip;
	}

	equeue_data->major = now - BECCA(context).tv_sec;

	frame4(frame4)->dana.name = NULL;

	*equeue = equeue_data;
    }

    return status;
}
#endif				/* __ENABLE_EQUEUE__ */
