/*
 * equeue3.c
 * Copyright (C) 2013, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#if __ENABLE_EQUEUE__
# include <aime.h>
# include <stddef.h>
# include <stdlib.h>
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# include <access.h>
# include <excess4.h>
# include <excess7.h>
# include <inter.h>
# include <types.h>
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define e4text(context) \
    ((struct e4text_type *) Frame4((context))->lxdeck)
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define Frame4(context) \
    ((struct frame4_type *) &Frame7((context))->_1.frame4)
# define Frame7(context) \
    ((struct frame7_type *) WINDOW((context)).server.window)
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define equeue(equeue) \
    ((struct equeue_type *) (equeue))
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
static int high_equeue(void *);
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
static int
high_equeue(void *dxflat)
{
    struct x1f4_dxflat_type *dxflat_data;

    dxflat_data = dxflat;
    dxflat_data->call--;
    if (dxflat_data->call) {
    } else {
	struct equeue_type *equeue_data;

	equeue_data = dxflat_data->data;
	free(dxflat_data);
	if (equeue_data) {
	    equeue_data->dxflat = NULL;
	}
    }

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
int
Mylene1f4_call_equeue(void *dxflat)
{
    struct x1f4_dxflat_type *dxflat_data;

    dxflat_data = dxflat;
    dxflat_data->call--;
    if (dxflat_data->call) {
    } else {
	struct equeue_type *equeue_data;

	equeue_data = dxflat_data->data;
	if (equeue_data) {
	    equeue_data->dxflat = NULL;
	}

	free(dxflat);
    }

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
int
Mylene1f4_high_equeue(void *context, void *equeue, void **exflat)
{
    int status;
    void *dxflat;

    status = Mylene1f4_side_equeue(equeue, &dxflat);
    if (status) {
    } else {
	struct x1f4_indexset_type *indexset_data;
	void **high, *none;

	indexset_data = e4text(context)->indexset;

	((struct x1f4_dxflat_type *) dxflat)->call++;

	status = indexset_data->autolink_set.pick
	    (indexset_data->autolink_set.data, &high, &high_equeue, 1, &none);
	if (status) {
	    Mylene1f4_call_equeue(dxflat);
	} else {
	    *high = dxflat;
	    if (1) {
		*exflat = dxflat;
	    }
	}
    }

    return status;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
int
Mylene1f4_side_equeue(void *equeue, void **exflat)
{
    int status;
    void *dxflat;

    dxflat = equeue(equeue)->dxflat;
    if (dxflat) {
	*exflat = dxflat;
	status = 0;
    } else {
	dxflat = malloc(sizeof(struct x1f4_dxflat_type));
	if (dxflat) {
	    struct x1f4_dxflat_type *dxflat_data;

	    equeue(equeue)->dxflat = dxflat;

	    dxflat_data = dxflat;

	    *exflat = dxflat;

	    dxflat_data->call = 0;
	    dxflat_data->data = equeue;

	    status = 0;
	} else {
	    status = -1;
	}
    }

    return status;
}
#endif				/* __ENABLE_EQUEUE__ */
