/*
 * excess4.h
 * Copyright (C) 2005-2014, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __Mylene1f4_EXCESS4_H__
#define __Mylene1f4_EXCESS4_H__

#include <config.h>

#if __ENABLE_CONTROLLING_SERVER__

#if __ENABLE_EQUEUE__
# include <aime.h>
#endif				/* __ENABLE_EQUEUE__ */
#include <time.h>

#include <types.h>

#define Mylene1f4_DEUX_Mylene		1
#define Mylene1f4_EXIT_Mylene		2
#define Mylene1f4_JUMP_Mylene		3
#define Mylene1f4_LINE_Mylene		4
#define Mylene1f4_SKIP_Mylene		5

#define ADVANCE_MISS			5
#define ADVANCE_POST			2
#define ADVANCE_SIGN			1
#define ADVANCE_TEXT			3
#define ADVANCE_TIME			4

#if __ENABLE_EQUEUE__
# define Mylene1f4_AIME_LINKED		(1 << 0)
#endif				/* __ENABLE_EQUEUE__ */
# if __REFLEX_SELECT__ == __DOUBLE_SELECT__
# define Mylene1f4_AIME_TARGET		(1 << 1)
# endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */
#if __EDITABLE_PLAYLIST__
# define Mylene1f4_FILE_ERASED		(1 << 2)
#endif				/* __EDITABLE_PLAYLIST__ */
#if 1
# define Mylene1f4_FREE_CLIENT		(1 << 3)
#endif				/* 1 */
#if __NONBLOCKING_CLIENT_TRANSFER__
# define Mylene1f4_LOCK_CLIENT		(1 << 4)
#endif				/* __NONBLOCKING_CLIENT_TRANSFER__ */

#if __ENABLE_EQUEUE__
# define Mylene1f4_AIME_FAILED		(1 << 0)
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
typedef struct a1text_type {
    unsigned count;
    void *operators, *prefixing;
} a1text_type;
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
typedef struct e4text_type {
    void *e2line, *e4deck, *indexset;
} e4text_type;
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_CHANNEL_SERVER__
typedef struct every4_type {
    int (*miss_back) (void *, const char *, unsigned),
	(*pipe_back) (void *, const char *, unsigned);
} every4_type;
#endif				/* __ENABLE_CHANNEL_SERVER__ */

typedef struct frame4_type {
    int client, clip;
#if __ENABLE_EQUEUE__
    int (*logic) (void *);
#endif				/* __ENABLE_EQUEUE__ */
    int (*play) (void *), server, (*trans) (void *);
    struct {
	int (*const *ever) (void *, unsigned);
	union {
	    struct {
		union {
		    struct {
			unsigned deck;
		    } ever;
		} data;
		unsigned deck;
	    } alia;
	    struct {
		union {
		    struct {
			unsigned deck;
		    } ever;
		} data;
		unsigned post, sign;
	    } mode;
	} aime;
	union {
	    struct {
		unsigned deck;
	    } ever;
	    struct {
		unsigned x1st, x2nd, x3rd;
	    } near;
	    struct {
		unsigned deck;
	    } sign;
	    struct {
		char *data, *text;
		unsigned size;
	    } text;
	} data;
	unsigned deck;
    } a112;
    struct {
	struct {
	    char *data;
	    unsigned size;
	} slack, slide;
    } back;
#if __ENABLE_EQUEUE__
    struct {
	char *name;
	int flat;
	time_t last;
	unsigned clip;
	struct x1f4_track_type *eport, plain, track;
	void *eclass, *equeue;
    } dana;
#endif				/* __ENABLE_EQUEUE__ */
    struct {
	unsigned last, post, sign;
    } i144;
#if __ENABLE_EQUEUE__
    struct {
	unsigned down, size;
	void *states;
    } line;
#endif				/* __ENABLE_EQUEUE__ */
    struct {
	unsigned back, deck;
    } next;
    struct {
	struct {
	    char *data;
	    unsigned size;
	} slack;
	struct string_type album, lbase, lpath, match, notes, title;
	unsigned load_order;
    } text;
#if __ENABLE_CHANNEL_SERVER__
    struct every4_type every4;
#endif				/* __ENABLE_CHANNEL_SERVER__ */
#if __ENABLE_EQUEUE__
    struct iqueue_type iqueue;
#endif				/* __ENABLE_EQUEUE__ */
#if __ENABLE_EQUEUE__
    struct stripe_type *clip_stripe, *play_stripe;
#endif				/* __ENABLE_EQUEUE__ */
    union {
	struct extime_type time;
	unsigned page;
    } pickup;
    unsigned already;
#if __ENABLE_CHANNEL_SERVER__
    unsigned channel, channel_up, client_id, client_up;
#endif				/* __ENABLE_CHANNEL_SERVER__ */
    unsigned flags, index;
#if __ENABLE_EQUEUE__
    unsigned instant;
#endif				/* __ENABLE_EQUEUE__ */
#if __ENABLE_FQUEUE__
    unsigned link;
#endif				/* __ENABLE_FQUEUE__ */
    unsigned progress, request, skipped, select, vertige;
#if __EDITABLE_PLAYLIST__
    unsigned weave;
#endif				/* __EDITABLE_PLAYLIST__ */
#if __ENABLE_EQUEUE__
    void *a1text;
#endif				/* __ENABLE_EQUEUE__ */
#if __ENABLE_EQUEUE__
    void *c1text;
#endif				/* __ENABLE_EQUEUE__ */
    void *context;
#if __ENABLE_EQUEUE__
    void *e1text;
#endif				/* __ENABLE_EQUEUE__ */
#if __ENABLE_FILTER__
    void *e4deck;
#endif				/* __ENABLE_FILTER__ */
#if __ENABLE_EQUEUE__
    void *i1text, *lxdeck;
#endif				/* __ENABLE_EQUEUE__ */
    void *progress1, *progress2, *progress3;
} frame4_type;

#endif				/* __ENABLE_CONTROLLING_SERVER__ */

#endif				/* __Mylene1f4_EXCESS4_H__ */
