/*
 * excess7s.c
 * Copyright (C) 2005-2008, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#if __ENABLE_CONTROLLING_SERVER__

#include <unistd.h>

#include <sys/select.h>
#include <sys/time.h>
#include <sys/types.h>

#include <access.h>
#include <excess4.h>
#include <excess7.h>
#include <inter.h>

#define Frame4(context) \
    ((struct frame4_type *) &Frame7((context))->_1.frame4)
#define Frame7(context) \
    ((struct frame7_type *) WINDOW((context)).server.window)

static int pipe_clip(void *, void *);
static int send_back(void *);

const struct class7_type _Mylene1f4_class7 = {
/* *INDENT-OFF* */
    pipe_clip
/* *INDENT-ON* */
};

static int
pipe_clip(void *context, void *fd_set_1_select)
{
    int status = 0;

    do {
	{
	    int fd_1;

	    fd_1 = Mylene2ND(context);
	    if (FD_ISSET(fd_1, (fd_set *) fd_set_1_select)) {
		status = Mylene1f4_push_mylene0fa(context);
		if (status) {
		    break;
		}
	    }
	}
	{
	    int client;

	    client = Frame4(context)->client;
	    if (client != -1) {
		if (FD_ISSET(client, (fd_set *) fd_set_1_select)) {
		    status = send_back(context);
		    if (status) {
			break;
		    }
		}
	    }
	}
    } while (0);

    return status;
}


static int
send_back(void *context)
{
    char *data;
    struct frame4_type *frame4_data;

    frame4_data = Frame4(context);

    data = frame4_data->back.slack.data;
    if (data) {
	int status;

#if __NONBLOCKING_CLIENT_TRANSFER__
	if (frame4_data->flags & Mylene1f4_LOCK_CLIENT) {
#endif				/* __NONBLOCKING_CLIENT_TRANSFER__ */
	    data = frame4_data->back.slide.data;
	    status = write(frame4_data->client, data, 1);
	    if (status != 1) {
		Mylene1f4_lose_e3e8(context);
	    } else {
		frame4_data->back.slide.data = data + 1;
		frame4_data->back.slide.size--;
	    }
#if __NONBLOCKING_CLIENT_TRANSFER__
	} else {
	    unsigned miss, size;

	    size = frame4_data->back.slide.size;
	    miss = size;
	    if (512 < miss) {
		miss = 512;
	    }
	    data = frame4_data->back.slide.data;
	    status = write(frame4_data->client, data, miss);
	    if (status < 0) {
		Mylene1f4_lose_e3e8(context);
	    } else {
		frame4_data->back.slide.data = data + status;
		frame4_data->back.slide.size = size - status;
	    }
	}
#endif				/* __NONBLOCKING_CLIENT_TRANSFER__ */
    }

    return 0;
}

#endif				/* __ENABLE_CONTROLLING_SERVER__ */
