/*
 * extent.c
 * Copyright (C) 2007-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#if __ENABLE_EQUEUE__
# include <stddef.h>
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# include <inter.h>
# include <types.h>
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
int
Mylene1f4_fini_extent(void *context, void *address)
{
    int status;
    struct stripe_type *extend_data;

    extend_data = *(struct stripe_type **) address;
    if (extend_data) {
	status = Mylene1f4_fini_iqueue
	    (context, extend_data->iqueue.head_equeue, NULL);
    } else {
	status = 0;
    }

    return status;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
int
Mylene1f4_init_extent(void *context, void *address)
{
    *(struct stripe_type **) address = NULL;

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */
