/*
 * filter.c
 * Copyright (C) 2006-2014, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * TODO
 *
 * fix the _Mylene1f4_aime_2_f usage
 */

#include <config.h>

#if __ENABLE_FILTER__
# include <aime.h>
# if defined HAVE_LIBLEWD
#  include <lewd.h>
# endif				/* HAVE_LIBLEWD */
# if defined HAVE_LIBx1f4l0
#  include <libx1f4l0.h>
# endif				/* HAVE_LIBx1f4l0 */
# include <stddef.h>
# include <stdio.h>
# include <stdlib.h>
# include <string.h>
#endif				/* __ENABLE_FILTER__ */

#if __ENABLE_FILTER__
# include <access.h>
# include <aime1.h>
# if !defined HAVE_LIBLEWD
#  include <basename.h>
#  include <cards.h>
# endif				/* !HAVE_LIBLEWD */
# include <defs.h>
# include <inter.h>
# if !defined HAVE_LIBLEWD
#  include <lintegral.n-fb.h>
# endif				/* !HAVE_LIBLEWD */
# include <types.h>
# if !defined HAVE_LIBLEWD
#  include <vkeylook-l.h>
#  include <vtkey.h>
# endif				/* !HAVE_LIBLEWD */
#endif				/* __ENABLE_FILTER__ */

#if __ENABLE_FILTER__
# define MAKE_SINGLE(a, b)		a
#endif				/* __ENABLE_FILTER__ */

#if __ENABLE_FILTER__
# define I_MODE(i)			(*((X1f4_E4_C_MODE *) (i)))
# define I_TEXT(t)			(*((X1f4_E4_C_TEXT *) (t)))
#endif				/* __ENABLE_FILTER__ */

#if __ENABLE_FILTER__
# define g10xx_t_t			nonsense_080104_1
#endif				/* __ENABLE_FILTER__ */

#if __ENABLE_FILTER__
#  define NON_count \
    (sizeof(NON_variables) / sizeof(struct x1f4_variable_type) - 1)
#endif				/* __ENABLE_FILTER__ */

#if __ENABLE_FILTER__
# define l_MODE(output, e) \
    {									      \
	X1f4_E4_C_MODE *l;						      \
									      \
	l = (output);							      \
	*l = (e);							      \
    }
#endif				/* __ENABLE_FILTER__ */

#if __ENABLE_FILTER__
# define l_TEXT(output, e) \
    {									      \
	X1f4_E4_C_TEXT *l;						      \
									      \
	l = (output);							      \
	*l = (e);							      \
    }
#endif				/* __ENABLE_FILTER__ */

#if __ENABLE_FILTER__
typedef struct filter_state {
    unsigned size;
    void *functions, *list, *lxtext, *non_state, *operators, *prefixing,
	*variables;
} filter_state;
#endif				/* __ENABLE_FILTER__ */

#if __ENABLE_FILTER__
typedef struct node_type {
    struct node_type *node_data;
} node_type;
#endif				/* __ENABLE_FILTER__ */

#if __ENABLE_FILTER__
typedef struct reflex_type {
    const struct x1f4_variable_type *variable_data;
    const struct x1f4_vkeytree_type *variable_tree;
    void **state;
} reflex_type;
#endif				/* __ENABLE_FILTER__ */

#if __ENABLE_FILTER__
typedef union state_type {
    X1f4_E4_C_MODE mode;
    X1f4_E4_C_REAL real;
    X1f4_E4_C_TEXT text;
} state_type;
#endif				/* __ENABLE_FILTER__ */

#if __ENABLE_FILTER__
extern int (*const _Mylene1f4_aime_2_f[])
    (const void *, const struct x1f4_function_type *, void **);
#endif				/* __ENABLE_FILTER__ */

#if __ENABLE_FILTER__
static int add_set(struct x1f4_vkeytree_type **,
		   const struct x1f4_function_type *);
static int aime_filter(void *, const char *, void **, int);
static int c10xx_m__(void *, void *, void **);
static int c11xx_m__(void *, void *, void **);
static int c12xx_t__(void *, void *, void **);
static int c13xx_t__(void *, void *, void **);
static int c14xx_t__(void *, void *, void **);
static int c15xx_t__(void *, void *, void **);
static int c17xx_t__(void *, void *, void **);
static int c19xx_t__(void *, void *, void **);
static int free_text(void *, void *);
static int init_filter(struct filter_state **, void *);
static int init_functions(struct x1f4_attributes_type *,
			  struct filter_state *);
static int init_procedure(void **, const char *, void *, int);
static int init_sequences(struct x1f4_attributes_type *,
			  struct filter_state *);
static int init_text(struct filter_state *);
static int init_variables(struct x1f4_attributes_type *,
			  struct filter_state *);
static int line_text(struct filter_state *);
static int link_operators(void *, const struct x1f4_operator_type **,
			  unsigned);
static int link_text(void *, void **, unsigned);
static int list_text(void *, const void *);
static int mode_text(void *, void **, unsigned);
static int nonfield_070907__(void *, void *);
static int nonfield_070917__(void *, void *, unsigned, unsigned);
static int nonsense_070917_0(void *, void *, void **);
static int nonsense_070917_1(void *, void *, void **);
static int nonsense_070917_2(void *, void *, void **);
static int nonsense_070917_3(void *, void *, void **);
static int nonsense_070917_4(void *, void *, void **);
static int nonsense_070917_5(void *, void *, void **);
static int nonsense_070917_6(void *, void *, void **);
static int nonsense_070924_0(void *, void *, void **);
static int nonsense_070925_0(void *, void *, void **);
static int nonfield_071007__(void *, void *, unsigned);
static int nonsense_071009_0(void *, void *, void **);
static int nonsense_080104_1(void *, void *, void **);
static int nonsense_080117_0(void *, void *, void **);
static int nonsense_090607_0(void *, void *, void **);
static int select_function(const char *, unsigned, const void *,
			   const struct x1f4_function_type **);
static int select_variable(const char *, unsigned, const void *,
			   const struct x1f4_variable_type **, void **);
#endif				/* __ENABLE_FILTER__ */

#if __ENABLE_FILTER__
static void dump_functions(void);
static void dump_operators(int);
static void dump_prefixing(void);
static void dump_selection(void);
static void fini_filter(struct filter_state *);
static void fini_procedure(void *);
static void fini_text(struct filter_state *);
static void init_icontexts(void *, struct x1f4_attributes_type *,
			   struct reflex_type *, struct filter_state *);
static void init_operators(void *, struct x1f4_attributes_type *,
			   struct filter_state *);
static void init_prefixing(void *, struct x1f4_attributes_type *,
			   struct filter_state *);
static void list_0011(void);
static void match_abuse(void *, void *, char *, unsigned, void *);
static void match_acide(void *, void *, char *, unsigned, unsigned);
static void match_class(void *, void *, char *, unsigned);
static void match_count(void *, void *, void *, unsigned);
static void match_depth(void *, void *, char *, unsigned, unsigned, void *);
static void match_elide(void *, void *, char *, unsigned);
static void match_empty(void *);
static void match_field(void *, void *, void *, unsigned);
static void match_frame(void *, void *, void *, unsigned);
static void match_glass(void *, void *, char *, unsigned, unsigned);
static void match_logic(void *, void *, void *);
static void stat_failure(void *, const char *, void *);
#endif				/* __ENABLE_FILTER__ */

#if __ENABLE_FILTER__
static const int c_____m__[] = {
/* *INDENT-OFF* */
    X1f4_E4_MODE
/* *INDENT-ON* */
}, c_____t__[] = {
/* *INDENT-OFF* */
    X1f4_E4_TEXT
/* *INDENT-ON* */
}, c_____t_m[] = {
/* *INDENT-OFF* */
    X1f4_E4_TEXT,
    X1f4_E4_MODE
/* *INDENT-ON* */
}, c_____t_t[] = {
/* *INDENT-OFF* */
    X1f4_E4_TEXT,
    X1f4_E4_TEXT
/* *INDENT-ON* */
}, c___t_m_m[] = {
/* *INDENT-OFF* */
    X1f4_E4_TEXT,
    X1f4_E4_MODE,
    X1f4_E4_MODE
/* *INDENT-ON* */
}, c___t_t_t[] = {
/* *INDENT-OFF* */
    X1f4_E4_TEXT,
    X1f4_E4_TEXT,
    X1f4_E4_TEXT
/* *INDENT-ON* */
}, c_m_m_m_m[] = {
/* *INDENT-OFF* */
    X1f4_E4_MODE,
    X1f4_E4_MODE,
    X1f4_E4_MODE,
    X1f4_E4_MODE
/* *INDENT-ON* */
}, c_t_t_t_t[] = {
/* *INDENT-OFF* */
    X1f4_E4_TEXT,
    X1f4_E4_TEXT,
    X1f4_E4_TEXT,
    X1f4_E4_TEXT
/* *INDENT-ON* */
};
#endif				/* __ENABLE_FILTER__ */

#if __ENABLE_FILTER__
const struct x1f4_function_type _Mylene1f4_filter_F__[] = {
/* *INDENT-OFF* */
    {	"album",		nonsense_070917_0,
	X1f4_E4_TEXT,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						5			},
    {	"artist",		nonsense_070917_1,
	X1f4_E4_TEXT,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						6			},
    {	"file",			nonsense_070917_6,
	X1f4_E4_TEXT,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						4			},
    {	"comment",		nonsense_071009_0,
	X1f4_E4_TEXT,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						7			},
    {	"current",		nonsense_070917_4,
	X1f4_E4_MODE,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						7			},
    {	"original",		nonsense_070917_3,
	X1f4_E4_MODE,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						8			},
    {	"path",			nonsense_070917_5,
	X1f4_E4_TEXT,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						4			},
    {	"title",		nonsense_070917_2,
	X1f4_E4_TEXT,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						5			},
    {	NULL,			NULL,
	0,			NULL,		0,
	0,					1			}
/* *INDENT-ON* */
}, _Mylene1f4_filter_N__[] = {
/* *INDENT-OFF* */
    {	"advance",		nonsense_070925_0,
	X1f4_E4_MODE,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						7			},
    {	"clip",			nonsense_080117_0,
	X1f4_E4_MODE,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						4			},
    {	"play",			nonsense_070924_0,
	X1f4_E4_MODE,		NULL,		0,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK | M1f4_L7_TEXT_LINK,
						4			},
    {	NULL,			NULL,
	0,			NULL,		0,
	0,					1			}
/* *INDENT-ON* */
}, _Mylene1f4_filter_U__[] = {
/* *INDENT-OFF* */
    {	"n_bfxa",		nonsense_090607_0,
	X1f4_E4_MODE,		c_m_m_m_m,	4,
	0,					6			},
    {	NULL,			NULL,
	0,			NULL,		0,
	0,					1			}
/* *INDENT-ON* */
};
#endif				/* __ENABLE_FILTER__ */

#if __ENABLE_FILTER__
static const char *empty_string = "";
static struct x1f4_linetext_type a10xx_m__ = {
/* *INDENT-OFF* */
    {	MAKE_SINGLE("+", " "),  c10xx_m__,
	X1f4_E4_TEXT,		c_____m__,	1,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,	1		},
    NULL
/* *INDENT-ON* */
}, a10xx_t_t = {
/* *INDENT-OFF* */
    {	MAKE_SINGLE("+", " "),  g10xx_t_t,
	X1f4_E4_TEXT,		c_____t_t,	2,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,	1		},
    NULL
/* *INDENT-ON* */
}, a11xx_m__ = {
/* *INDENT-OFF* */
    {	MAKE_SINGLE("+", " "),  c11xx_m__,
	X1f4_E4_TEXT,		c_____m__,	1,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,	1		},
    NULL
/* *INDENT-ON* */
}, a12xx_t__ = {
/* *INDENT-OFF* */
    {	MAKE_SINGLE("+", " "),  c12xx_t__,
	X1f4_E4_TEXT,		c_____t__,	1,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,	1		},
    NULL
/* *INDENT-ON* */
}, a13xx_t__ = {
/* *INDENT-OFF* */
    {	MAKE_SINGLE("+", " "),  c13xx_t__,
	X1f4_E4_TEXT,		c_____t__,	1,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,	1		},
    NULL
/* *INDENT-ON* */
}, a14xx_t__ = {
/* *INDENT-OFF* */
    {	MAKE_SINGLE("+", " "),  c14xx_t__,
	X1f4_E4_TEXT,		c_____t__,	1,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,	1		},
    NULL
/* *INDENT-ON* */
}, a15xx_t__ = {
/* *INDENT-OFF* */
    {	MAKE_SINGLE("+", " "),  c15xx_t__,
	X1f4_E4_TEXT,		c_____t__,	1,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,	1		},
    NULL
/* *INDENT-ON* */
}, a17xx_t__ = {
/* *INDENT-OFF* */
    {	MAKE_SINGLE("+", " "),  c17xx_t__,
	X1f4_E4_TEXT,		c_____t__,	1,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,	1		},
    NULL
/* *INDENT-ON* */
}, a19xx_t__ = {
/* *INDENT-OFF* */
    {	MAKE_SINGLE("+", " "),  c19xx_t__,
	X1f4_E4_TEXT,		c_____t__,	1,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,	1		},
    NULL
/* *INDENT-ON* */
};
static const struct x1f4_2ndscope_type d10xx_m__[] = {
/* *INDENT-OFF* */
    {	X1f4_E4_CALL_LINK,	&a10xx_m__			}
/* *INDENT-ON* */
}, d10xx_t_t[] = {
/* *INDENT-OFF* */
    {	X1f4_E4_CALL_LINK,	&a10xx_t_t			}
/* *INDENT-ON* */
}, d11xx_m__[] = {
/* *INDENT-OFF* */
    {	X1f4_E4_CALL_LINK,	&a11xx_m__			}
/* *INDENT-ON* */
}, d12xx_t__[] = {
/* *INDENT-OFF* */
    {	X1f4_E4_CALL_LINK,	&a12xx_t__			}
/* *INDENT-ON* */
}, d13xx_t__[] = {
/* *INDENT-OFF* */
    {	X1f4_E4_CALL_LINK,	&a13xx_t__			}
/* *INDENT-ON* */
}, d14xx_t__[] = {
/* *INDENT-OFF* */
    {	X1f4_E4_CALL_LINK,	&a14xx_t__			}
/* *INDENT-ON* */
}, d15xx_t__[] = {
/* *INDENT-OFF* */
    {	X1f4_E4_CALL_LINK,	&a15xx_t__			}
/* *INDENT-ON* */
}, d17xx_t__[] = {
/* *INDENT-OFF* */
    {	X1f4_E4_CALL_LINK,	&a17xx_t__			}
/* *INDENT-ON* */
}, d19xx_t__[] = {
/* *INDENT-OFF* */
    {	X1f4_E4_CALL_LINK,	&a19xx_t__			}
/* *INDENT-ON* */
};
static const struct x1f4_function_type *NON_sets[] = {
/* *INDENT-OFF* */
    _Mylene1f4_filter_F__,
    _Mylene1f4_filter_N__,
    _Mylene1f4_filter_U__,
    NULL
/* *INDENT-ON* */
};
static const struct x1f4_operator_type e10xx_m__[] = {
/* *INDENT-OFF* */
    {	MAKE_SINGLE("#", " "),  NULL,		0210,
	X1f4_E4_MODE,		c_____m__,
	X1f4_E4_E2ND_LINK | X1f4_E4_KEEP_CALL,	1,
	NULL,			d10xx_m__			}
/* *INDENT-ON* */
}, e11xx_m__[] = {
/* *INDENT-OFF* */
    {	MAKE_SINGLE("$", " "),  NULL,		0210,
	X1f4_E4_MODE,		c_____m__,
	X1f4_E4_E2ND_LINK | X1f4_E4_KEEP_CALL,	1,
	NULL,			d11xx_m__			}
/* *INDENT-ON* */
}, e12xx_t__[] = {
/* *INDENT-OFF* */
    {	MAKE_SINGLE("%", " "),  NULL,		0210,
	X1f4_E4_MODE,		c_____t__,
	X1f4_E4_E2ND_LINK | X1f4_E4_KEEP_CALL,	1,
	NULL,			d12xx_t__			}
/* *INDENT-ON* */
}, e13xx_t__[] = {
/* *INDENT-OFF* */
    {	MAKE_SINGLE("^", " "),  NULL,		0210,
	X1f4_E4_MODE,		c_____t__,
	X1f4_E4_E2ND_LINK | X1f4_E4_KEEP_CALL,	1,
	NULL,			d13xx_t__			}
/* *INDENT-ON* */
}, e14xx_t__[] = {
/* *INDENT-OFF* */
    {	MAKE_SINGLE("&", " "),  NULL,		0210,
	X1f4_E4_MODE,		c_____t__,
	X1f4_E4_E2ND_LINK | X1f4_E4_KEEP_CALL,	1,
	NULL,			d14xx_t__			}
/* *INDENT-ON* */
}, e15xx_t__[] = {
/* *INDENT-OFF* */
    {	MAKE_SINGLE("~", " "),  NULL,		0210,
	X1f4_E4_MODE,		c_____t__,
	X1f4_E4_E2ND_LINK | X1f4_E4_KEEP_CALL,	1,
	NULL,			d15xx_t__			}
/* *INDENT-ON* */
}, e17xx_t__[] = {
/* *INDENT-OFF* */
    {	MAKE_SINGLE("@", " "),  NULL,		0210,
	X1f4_E4_MODE,		c_____t__,
	X1f4_E4_E2ND_LINK | X1f4_E4_KEEP_CALL,	1,
	NULL,			d17xx_t__			}
/* *INDENT-ON* */
}, e19xx_t__[] = {
/* *INDENT-OFF* */
    {	MAKE_SINGLE("|", " "),  NULL,		0210,
	X1f4_E4_MODE,		c_____t__,
	X1f4_E4_E2ND_LINK | X1f4_E4_KEEP_CALL,	1,
	NULL,			d19xx_t__			}
/* *INDENT-ON* */
}, f10xx_t_t[] = {
/* *INDENT-OFF* */
    {	MAKE_SINGLE("+", " "),  NULL,		0230,
	X1f4_E4_TEXT,		c_____t_t,
	X1f4_E4_E2ND_LINK | X1f4_E4_KEEP_CALL,	1,
	NULL,			d10xx_t_t			}
/* *INDENT-ON* */
};
static const struct x1f4_variable_type NON_variables[] = {
/* *INDENT-OFF* */
    {	"Mylene1f4",	X1f4_E4_TEXT,	X1f4_E4_READ_ONLY,	9	},
    {	NULL,		0,		0,			0	}
/* *INDENT-ON* */
};
#endif				/* __ENABLE_FILTER__ */

#if __ENABLE_FILTER__
const struct x1f4_operator_type *_Mylene1f4_filter_B[] = {
/* *INDENT-OFF* */
    f10xx_t_t,
    NULL
/* *INDENT-ON* */
}, *_Mylene1f4_filter_I[] = {
/* *INDENT-OFF* */
    e10xx_m__,
    e11xx_m__,
    e12xx_t__,
    e13xx_t__,
    e14xx_t__,
    e15xx_t__,
    e17xx_t__,
    e19xx_t__,
    NULL
/* *INDENT-ON* */
};
#endif				/* __ENABLE_FILTER__ */

#if __ENABLE_FILTER__
static int
add_set(struct x1f4_vkeytree_type **root,
	const struct x1f4_function_type *function_data)
{
    const char *name;
    int status = 0;

    name = function_data->name;
    while (name) {
	status = x1f4_make_vtkeynode(root, name, function_data);
	if (status) {
	    status = X1f4_E4_ALLOC_ERROR;
	    break;
	} else {
	    function_data++;
	    name = function_data->name;
	}
    }

    return status;
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static int
aime_filter(void *context, const char *specification, void **c_filter,
	    int do_complain)
{
    int status;
    void *expression;

    status = init_procedure(&expression, specification, context, do_complain);
    if (status) {
    } else {
	if (!expression) {
	    *c_filter = NULL;
	} else {
	    int type;

	    type = x1f4_type_expression(expression);
	    if (type != X1f4_E4_MODE) {
		fini_procedure(expression);
		status = 1;
		if (do_complain) {
		    Mylene1f4_fprintf_error
			(context,
			 "%s: filter (`%s') does not evaluate integral\n",
			 Mylene1f4(context), specification);
		}
	    } else {
		*c_filter = expression;
	    }
	}
    }

    return status;
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static int
c10xx_m__(void *context, void *output, void **input)
{
    X1f4_E4_C_MODE mode;

    if (!(FLAGS(context) & Mylene1f4_LOCAL_LIST)) {
	mode = 0;
    } else {
	unsigned index;

	Mylene1f4_fix_index(context, &index);
	mode = (X1f4_E4_C_MODE) index == I_MODE(input[0]);
    }

    l_MODE(output, mode);

    return 0;
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static int
c11xx_m__(void *context, void *output, void **input)
{
    X1f4_E4_C_MODE mode;

    if (!(FLAGS(context) & Mylene1f4_LOCAL_LIST)) {
	mode = 0;
    } else {
	mode = (X1f4_E4_C_MODE) EXCESS(context).e1.list87.index
	    == I_MODE(input[0]);
    }

    l_MODE(output, mode);

    return 0;
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static int
c12xx_t__(void *context, void *output, void **input)
{
    if (!ID3X(context)) {
	match_empty(output);
    } else if (ID3T(context) == Mylene1f4_MERGED_ID3TAG) {
	match_field(context, output, input, 0077);
    } else {
	match_frame(context, output, input, Mylene1f4_ALBUM_FIELD);
    }

    return 0;
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static int
c13xx_t__(void *context, void *output, void **input)
{
    if (!ID3X(context)) {
	match_empty(output);
    } else if (ID3T(context) == Mylene1f4_MERGED_ID3TAG) {
	match_field(context, output, input, 0041);
    } else {
	match_frame(context, output, input, Mylene1f4_MATCH_FIELD);
    }

    return 0;
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static int
c14xx_t__(void *context, void *output, void **input)
{
    if (!ID3X(context)) {
	match_empty(output);
    } else if (ID3T(context) == Mylene1f4_MERGED_ID3TAG) {
	match_field(context, output, input, 0003);
    } else {
	match_frame(context, output, input, Mylene1f4_TITLE_FIELD);
    }

    return 0;
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static int
c15xx_t__(void *context, void *output, void **input)
{
    match_logic(x1f4_basename(SOURCE(context)._.s1.path), output, input);

    return 0;
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static int
c17xx_t__(void *context, void *output, void **input)
{
    match_logic((char *) SOURCE(context)._.s1.path, output, input);

    return 0;
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static int
c19xx_t__(void *context, void *output, void **input)
{
    if (!ID3X(context)) {
	match_empty(output);
    } else if (ID3T(context) == Mylene1f4_MERGED_ID3TAG) {
	match_field(context, output, input, 0141);
    } else {
	match_frame(context, output, input, Mylene1f4_NOTES_FIELD);
    }

    return 0;
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static int
free_text(void *filter, void *data)
{
    return 0;
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static int
init_filter(struct filter_state **filter, void *context)
{
    int status;
    struct filter_state *filter_data;

    filter_data = (struct filter_state *)
	malloc(sizeof(struct filter_state) + 30 + 1 + 30 + 1 + 30 + 1 + 30
	       + 1);
    if (!filter_data) {
	status = -1;
    } else {
	void **state;

	state = (void **)
	    malloc((sizeof(void *) + sizeof(union state_type)) * NON_count);
	if (!state) {
	    free(filter_data);

	    status = -1;
	} else {
	    status = init_text(filter_data);
	    if (status) {
		free(state);
		free(filter_data);
	    } else {
		filter_data->non_state = state;

		filter_data->functions = NULL;
		filter_data->operators = NULL;
		filter_data->prefixing = NULL;
		filter_data->variables = NULL;

		{
		    union state_type *state_data;
		    unsigned count;

		    count = NON_count;
		    state_data = (union state_type *) (state + count);
		    for (; count; count--) {
			*state++ = state_data++;
		    }
		}

		state -= NON_count;

		l_TEXT(*state, (char *) Mylene1f4(context));

		*filter = filter_data;
	    }
	}
    }

    return status;
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static int
init_functions(struct x1f4_attributes_type *attributes_data,
	       struct filter_state *filter_data)
{
    int status;

    if (filter_data->functions) {
	status = 0;
    } else {
	status = Mylene1f4_miss_filter(&filter_data->functions, NON_sets);
	if (status) {
	} else {
	    status = line_text(filter_data);
	    if (status) {
		x1f4_free_vtkeydata(filter_data->functions);
	    }
	}
    }

    return status;
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static int
init_procedure(void **expression, const char *string, void *context,
	       int do_complain)
{
    int status = 0;
    struct filter_state *filter_data;

    filter_data = FILTER(context);
    if (filter_data) {
    } else {
	status = init_filter(&filter_data, context);
	if (status) {
	} else {
	    FILTER(context) = filter_data;
	}
    }
    if (filter_data) {
	struct reflex_type reflex;
	struct x1f4_attributes_type attributes;

	init_icontexts(context, &attributes, &reflex, filter_data);

	status = init_sequences(&attributes, filter_data);
	if (!status) {
	    attributes.terminator = 0;
	    if (!do_complain) {
		status = x1f4_iNit_expression
		    (expression, string, 0, &attributes);
	    } else {
		struct x1f4_eerecord_type eerecord;

		attributes.bcollect_set.eerecord_data = &eerecord;

		status = x1f4_iNit_expression
		    (expression, string, X1f4_E4_BCOLLECT, &attributes);
		if (status) {
		    if (do_complain) {
			stat_failure(context, string, &eerecord);
		    }
		}
	    }
	    if (status) {
	    } else {
		if (*expression) {
		    if (E4LINE(context) & 1) {
			x1f4_line_expression(*expression);
		    }
		}
	    }
	}
    }

    return status;
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static int
init_sequences(struct x1f4_attributes_type *attributes_data,
	       struct filter_state *filter_data)
{
    int status = 1;

    if (init_functions(attributes_data, filter_data)) {
    } else {
	if (init_variables(attributes_data, filter_data)) {
	} else {
	    status = 0;
	}
    }

    return status;
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static int
init_text(struct filter_state *filter_data)
{
    int status;
    struct x1f4_lxtext_type lxnone;
    void *lxtext;

    lxnone.autolink_set.data = filter_data;

    lxnone.autolink_set.free = free_text;
    lxnone.autolink_set.link = link_text;
    lxnone.autolink_set.mode = mode_text;

    status = x1f4_init_lxtext(&lxtext, 0, &lxnone);
    if (status) {
    } else {
	filter_data->lxtext = lxtext;
    }

    return status;
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static int
init_variables(struct x1f4_attributes_type *attributes_data,
	       struct filter_state *filter_data)
{
    int status;
    struct reflex_type *reflex_data;

    reflex_data = (void *) attributes_data->variable_set.context;
    if (filter_data->variables) {
	reflex_data->variable_tree = filter_data->variables;
	status = 0;
    } else {
	struct x1f4_vkeytree_type *root;
	const struct x1f4_variable_type *variable_data;

	variable_data = reflex_data->variable_data;

	status = x1f4_make_vtkeyroot
	    (&root, variable_data->name, variable_data);
	if (status) {
	    status = X1f4_E4_ALLOC_ERROR;
	} else {
	    variable_data++;
	    while (variable_data->name) {
		status = x1f4_make_vtkeynode
		    (&root, variable_data->name, variable_data);
		if (status) {
		    status = X1f4_E4_ALLOC_ERROR;
		    break;
		} else {
		    variable_data++;
		}
	    }
	}

	if (status) {
	    x1f4_free_vtkeydata(root);
	} else {
	    ((struct reflex_type *)
	     attributes_data->variable_set.context)->variable_tree = root;
	    filter_data->variables = root;
	}
    }

    return status;
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static int
line_text(struct filter_state *filter_data)
{
    const struct x1f4_function_type *function_data;
    const struct x1f4_linetext_type *linetext_data;
    struct x1f4_vkeytree_type **root;
    const char *name;
    int status = 0;

    root = (void *) &filter_data->functions;

    x1f4_fset_lxtext(filter_data->lxtext, &linetext_data);

    function_data = &linetext_data->function;
    name = function_data->name;
    while (name) {
	status = x1f4_make_vtkeynode(root, name, function_data);
	if (status) {
	    status = X1f4_E4_ALLOC_ERROR;
	    break;
	} else {
	    linetext_data++;
	    function_data = &linetext_data->function;
	    name = function_data->name;
	}
    }

    return status;
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static int
link_operators(void *context, const struct x1f4_operator_type **operator,
	       unsigned count)
{
    for (; count; count--) {
	const struct x1f4_2ndscope_type *endscope_data;
	struct x1f4_linetext_type *linetext_data;

	endscope_data = (*operator)->extension2;
	linetext_data = (void *) endscope_data->line;

	linetext_data->context = context;

	operator++;
    }

    return 0;
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static int
link_text(void *filter, void **data, unsigned size)
{
    int status;
    struct filter_state *filter_data;
    unsigned miss;

    filter_data = filter;

    miss = filter_data->size;
    if (miss < size) {
	status = -1;
    } else {
	struct node_type *node_data;

	node_data = malloc(sizeof(struct node_type) + size);
	if (!node_data) {
	    status = -1;
	} else {
	    status = 0;

	    node_data->node_data = filter_data->list;

	    filter_data->size = miss - size;

	    filter_data->list = node_data;

	    *data = node_data + 1;
	}
    }

    return status;
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static int
list_text(void *context, const void *text)
{
    const char *name;
    const struct x1f4_linetext_type *linetext_data;

    linetext_data = text;

    name = linetext_data->function.name;
    while (name) {
	x1f4_print_htfunction
	    (stdout, &linetext_data->function, "    ", NULL,
	     Mylene1f4_look_aime);
	linetext_data++;
	name = linetext_data->function.name;
    }

    return 0;
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static int
mode_text(void *filter, void **data, unsigned size)
{
    return -1;
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static int
nonfield_070907__(void *context, void *output)
{
    l_TEXT(output, (X1f4_E4_C_TEXT) empty_string);

    return 0;
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static int
nonfield_070917__(void *context, void *output, unsigned source,
		  unsigned target)
{
    const char *id3x;
    char *text;
    unsigned size = 30;

    text = (char *) ((struct filter_state *) FILTER(context) + 1) + target;

    id3x = ID3X(context);
    id3x += source;
    Mylene1f4_shrink_field(&id3x, &size);
    memcpy(text, id3x, size);
    text[size] = 0;

    l_TEXT(output, text);

    return 0;
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static int
nonsense_070917_0(void *context, void *output, void **input)
{
    int status;

    if (!ID3X(context)) {
	status = nonfield_070907__(context, output);
    } else if (ID3T(context) == Mylene1f4_MERGED_ID3TAG) {
	status = nonfield_070917__(context, output, 0077, (30 + 1) * 0);
    } else {
	status = nonfield_071007__(context, output, Mylene1f4_ALBUM_FIELD);
    }

    return status;
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static int
nonsense_070917_1(void *context, void *output, void **input)
{
    int status;

    if (!ID3X(context)) {
	status = nonfield_070907__(context, output);
    } else if (ID3T(context) == Mylene1f4_MERGED_ID3TAG) {
	status = nonfield_070917__(context, output, 0041, (30 + 1) * 1);
    } else {
	status = nonfield_071007__(context, output, Mylene1f4_MATCH_FIELD);
    }

    return status;
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static int
nonsense_070917_2(void *context, void *output, void **input)
{
    int status;

    if (!ID3X(context)) {
	status = nonfield_070907__(context, output);
    } else if (ID3T(context) == Mylene1f4_MERGED_ID3TAG) {
	status = nonfield_070917__(context, output, 0003, (30 + 1) * 2);
    } else {
	status = nonfield_071007__(context, output, Mylene1f4_TITLE_FIELD);
    }

    return status;
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static int
nonsense_070917_3(void *context, void *output, void **input)
{
    unsigned index;

    if (FLAGS(context) & Mylene1f4_LOCAL_LIST) {
	index = EXCESS(context).e1.list87.index;
    } else {
	index = 0;
    }

    l_MODE(output, index);

    return 0;
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static int
nonsense_070917_4(void *context, void *output, void **input)
{
    unsigned index;

    if (FLAGS(context) & Mylene1f4_LOCAL_LIST) {
	Mylene1f4_fix_index(context, &index);
    } else {
	index = 0;
    }

    l_MODE(output, index);

    return 0;
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static int
nonsense_070917_5(void *context, void *output, void **input)
{
    l_TEXT(output, (char *) SOURCE(context)._.s1.path);

    return 0;
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static int
nonsense_070917_6(void *context, void *output, void **input)
{
    l_TEXT(output, x1f4_basename(SOURCE(context)._.s1.path));

    return 0;
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static int
nonsense_070924_0(void *context, void *output, void **input)
{
    l_MODE(output, PLAY(context));

    return 0;
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static int
nonsense_070925_0(void *context, void *output, void **input)
{
    if (FLAGS(context) & Mylene1f4_LOCAL_LIST) {
	l_MODE(output, EXCESS(context).e1.list87.count);
    } else {
	l_MODE(output, 1);
    }

    return 0;
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static int
nonfield_071007__(void *context, void *output, unsigned source)
{
    l_TEXT(output, ((struct id3tag_type *) ID3X(context))->data[source]);

    return 0;
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static int
nonsense_071009_0(void *context, void *output, void **input)
{
    int status;

    if (!ID3X(context)) {
	status = nonfield_070907__(context, output);
    } else if (ID3T(context) == Mylene1f4_MERGED_ID3TAG) {
	status = nonfield_070917__(context, output, 0141, (30 + 1) * 3);
    } else {
	status = nonfield_071007__(context, output, Mylene1f4_NOTES_FIELD);
    }

    return status;
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static int
nonsense_080104_1(void *context, void *output, void **input)
{
    char *head, *tail;
    int status;
    unsigned base, half;
    void *data;

    head = I_TEXT(input[0]);
    tail = I_TEXT(input[1]);

    base = strlen(head);
    half = strlen(tail);

    status = link_text(FILTER(context), &data, base + half + 1);
    if (status) {
    } else {
	char *text;

	text = data;

	l_TEXT(output, text);

	memcpy(text, head, base);
	text += base;
	memcpy(text, tail, half + 1);
    }

    return status;
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static int
nonsense_080117_0(void *context, void *output, void **input)
{
    l_MODE(output, CLIP(context));

    return 0;
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static int
nonsense_090607_0(void *context, void *output, void **input)
{
    X1f4_E4_C_MODE b;
    int status;

    b = I_MODE(input[0]);
    if (b < 0) {
	status = 1;
    } else {
	X1f4_E4_C_MODE f;

	f = I_MODE(input[1]);
	if (f < 0) {
	    status = 1;
	} else {
	    X1f4_E4_C_MODE x;

	    x = I_MODE(input[2]);
	    if (x < 2) {
		status = 1;
	    } else {
		if (36 < x) {
		    status = 1;
		} else {
		    unsigned size = 0;

		    status = 0;

		    x1f4_nprint_fblintegral(&size, f, b, x, I_MODE(input[3]));
		    l_MODE(output, size);
		}
	    }
	}
    }

    return status;
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static int
select_function(const char *f, unsigned length, const void *context,
		const struct x1f4_function_type **function)
{
    int status = X1f4_E4_PARSE_ERROR;
    struct filter_state *filter_data;
    const void *key;

    filter_data = FILTER(context);

    if (x1f4_look_vtkey_l(f, length, filter_data->functions, &key)) {
    } else {
	status = 0;
	*function = key;
    }

    return status;
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static int
select_variable(const char *f, unsigned length, const void *context,
		const struct x1f4_variable_type **variable, void **state)
{
    int status = X1f4_E4_PARSE_ERROR;
    const struct reflex_type *reflex_data;

    reflex_data = context;
    if (reflex_data->variable_tree) {
	const void *key;

	if (!x1f4_look_vtkey_l(f, length, reflex_data->variable_tree, &key)) {
	    status = 0;
	    *state = reflex_data->state
		[(struct x1f4_variable_type *) key
		 - reflex_data->variable_data];
	    *variable = key;
	}
    }

    return status;
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static void
dump_functions(void)
{
    puts("\
Math and text functions:");
    x1f4_print_hfunctions(stdout, x1f4_e4_defaults, "    ");
    puts("\n\
Text functions:");
    list_0011();
    puts("\n\
Text functions (continued):");
    x1f4_print_hfunctions(stdout, _Mylene1f4_filter_U__, "    ");
    puts("\n\
File attributes retrieving functions:");
    x1f4_print_hfunctions(stdout, _Mylene1f4_filter_F__, "    ");
    puts("\n\
State retrieving functions:");
    x1f4_print_hfunctions(stdout, _Mylene1f4_filter_N__, "    ");
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static void
dump_operators(int head)
{
    const struct x1f4_operator_type *const *operator2s;

    x1f4_llink_operator2s(&operator2s);
    x1f4_print_boperators(stdout, operator2s, head);
    x1f4_print_boperators(stdout, _Mylene1f4_filter_B, 0);
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static void
dump_prefixing(void)
{
    const struct x1f4_operator_type *const *operator1s;

    x1f4_llink_operator1s(&operator1s);
    x1f4_print_operators(stdout, operator1s, 1);
    x1f4_print_operators(stdout, _Mylene1f4_filter_I, 1);
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static void
dump_selection(void)
{
    puts("\
    mode ~<text-expression>\n\
	!match(<text-expression>, basename())\n\
    mode @<text-expression>\n\
	!match(<text-expression>, path())\n\
    mode #<mode-expression>\n\
	<mode-expression> == current()\n\
    mode $<mode-expression>\n\
	<mode-expression> == initial()\n\
    mode %<text-expression>\n\
	!match(<text-expression>, album())\n\
    mode ^<text-expression>\n\
	!match(<text-expression>, artist())\n\
    mode &<text-expression>\n\
	!match(<text-expression>, title())\n\
    mode |<text-expression>\n\
	!match(<text-expression>, comment())");
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static void
fini_filter(struct filter_state *filter_data)
{
    void *data;

    data = filter_data->non_state;
    if (data) {
	free(data);
    }
    data = filter_data->functions;
    if (data) {
	x1f4_free_vtkeydata(data);
    }
    data = filter_data->operators;
    if (data) {
	free(data);
    }
    data = filter_data->variables;
    if (data) {
	x1f4_free_vtkeydata(data);
    }

    fini_text(filter_data);

    free(filter_data);
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static void
fini_procedure(void *expression)
{
    x1f4_fini_expression(&expression);
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static void
fini_text(struct filter_state *filter_data)
{
    x1f4_fini_lxtext(&filter_data->lxtext);
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static void
init_icontexts(void *context, struct x1f4_attributes_type *attributes_data,
	       struct reflex_type *reflex_data,
	       struct filter_state *filter_data)
{
    reflex_data->state = filter_data->non_state;
    reflex_data->variable_data = NON_variables;

    attributes_data->function_set.fix = _Mylene1f4_aime_2_f[0];
    attributes_data->function_set.get = select_function;
    attributes_data->function_set.context = context;
    x1f4_llink_operator1s(&attributes_data->operator1s);
    x1f4_llink_operator2s(&attributes_data->operator2s);
    attributes_data->variable_set.get = select_variable;
    attributes_data->variable_set.context = reflex_data;

    init_operators(context, attributes_data, filter_data);
    init_prefixing(context, attributes_data, filter_data);
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static void
init_operators(void *context, struct x1f4_attributes_type *attributes_data,
	       struct filter_state *filter_data)
{
    const struct x1f4_operator_type **operators;

    operators = filter_data->operators;
    if (operators) {
	attributes_data->operator2s = operators;
    } else {
	const struct x1f4_operator_type *const *operAtors, *const *operatOrs;
	unsigned count;

	operAtors = attributes_data->operator2s;

	operatOrs = operAtors;
	while (*operatOrs) {
	    operatOrs++;
	}

	count = operatOrs - operAtors;
	operators = (const struct x1f4_operator_type **) malloc
	    (sizeof(const struct x1f4_operator_type *) * (1 + count + 1));
	if (operators) {
	    attributes_data->operator2s = operators;

	    filter_data->operators = operators;

	    memcpy(operators, _Mylene1f4_filter_B,
		   sizeof(const struct x1f4_operator_type *));
	    operators += 1;
	    memcpy(operators, operAtors,
		   sizeof(const struct x1f4_operator_type *) * (count + 1));

	    link_operators(context, _Mylene1f4_filter_B, 1);
	}
    }
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static void
init_prefixing(void *context, struct x1f4_attributes_type *attributes_data,
	       struct filter_state *filter_data)
{
    const struct x1f4_operator_type **operators;

    operators = filter_data->prefixing;
    if (operators) {
	attributes_data->operator1s = operators;
    } else {
	const struct x1f4_operator_type *const *operAtors, *const *operatOrs;
	unsigned count;

	operAtors = attributes_data->operator1s;

	operatOrs = operAtors;
	while (*operatOrs) {
	    operatOrs++;
	}

	count = operatOrs - operAtors;
	operators = (const struct x1f4_operator_type **) malloc
	    (sizeof(const struct x1f4_operator_type *) * (8 + count + 1));
	if (operators) {
	    attributes_data->operator1s = operators;

	    filter_data->prefixing = operators;

	    memcpy(operators, _Mylene1f4_filter_I,
		   sizeof(const struct x1f4_operator_type *) << 3);
	    operators += 8;
	    memcpy(operators, operAtors,
		   sizeof(const struct x1f4_operator_type *) * (count + 1));

	    link_operators(context, _Mylene1f4_filter_I, 8);
	}
    }
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static void
list_0011(void)
{
    int status;
    struct x1f4_lxtext_type lxnone;
    void *lxtext;

    status = x1f4_init_lxtext(&lxtext, 0, &lxnone);
    if (!status) {
	const struct x1f4_linetext_type *linetext_data;

	x1f4_fset_lxtext(lxtext, &linetext_data);
	list_text(NULL, linetext_data);

	status = x1f4_fini_lxtext(&lxtext);
    }
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static void
match_abuse(void *context, void *output, char *major, unsigned bytes,
	    void *abuse)
{
    X1f4_E4_C_MODE *mode;
    const char *minor;
    unsigned count = 30;

    minor = context;
    Mylene1f4_shrink_field(&minor, &count);
    mode = output;
    *mode = !x1f4_match_cards(major, bytes, minor, count, abuse);
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static void
match_acide(void *context, void *output, char *major, unsigned bytes,
	    unsigned scope)
{
    char *elide;

    elide = (char *) malloc(bytes);
    if (!elide) {
	X1f4_E4_C_MODE *mode;

	mode = output;
	*mode = 0;
    } else {
	match_depth(context, output, major, bytes, scope, elide);
	free(elide);
    }
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static void
match_class(void *context, void *output, char *major, unsigned bytes)
{
    char class[512];

    match_abuse(context, output, major, bytes, class);
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static void
match_count(void *context, void *output, void *input, unsigned scope)
{
    X1f4_E4_C_MODE mode;

    if (1) {
	char *major;
	unsigned bytes;

	major = I_TEXT(((void **) input)[0]);
	bytes = strlen(major);
	if (!(512 < bytes)) {
	    match_glass(context, &mode, major, bytes, scope);
	} else {
	    match_acide(context, &mode, major, bytes, scope);
	}
    }

    l_MODE(output, mode);
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static void
match_depth(void *context, void *output, char *major, unsigned bytes,
	    unsigned scope, void *abuse)
{
    X1f4_E4_C_MODE *mode;
    const char *minor;
    unsigned count;

    minor = context;
    count = scope;
    mode = output;
    *mode = !x1f4_match_cards(major, bytes, minor, count, abuse);
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static void
match_elide(void *context, void *output, char *major, unsigned bytes)
{
    char *elide;

    elide = (char *) malloc(bytes);
    if (!elide) {
	X1f4_E4_C_MODE *mode;

	mode = output;
	*mode = 0;
    } else {
	match_abuse(context, output, major, bytes, elide);
	free(elide);
    }
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static void
match_empty(void *output)
{
    l_MODE(output, 0);
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static void
match_field(void *context, void *output, void *input, unsigned scope)
{
    X1f4_E4_C_MODE mode;
    char *id3x, *major;
    unsigned bytes;

    id3x = ID3X(context);
    major = I_TEXT(((void **) input)[0]);
    bytes = strlen(major);
    if (!(512 < bytes)) {
	match_class(id3x + scope, &mode, major, bytes);
    } else {
	match_elide(id3x + scope, &mode, major, bytes);
    }

    l_MODE(output, mode);
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static void
match_frame(void *context, void *output, void *input, unsigned scope)
{
    struct id3tag_type *id3tag_data;

    id3tag_data = ID3X(context);
    match_count
	(id3tag_data->data[scope], output, input, id3tag_data->size[scope]);
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static void
match_glass(void *context, void *output, char *major, unsigned bytes,
	    unsigned scope)
{
    char class[512];

    match_depth(context, output, major, bytes, scope, class);
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static void
match_logic(void *context, void *output, void *input)
{
    match_count(context, output, input, strlen(context));
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
static void
stat_failure(void *context, const char *string, void *eerecord)
{
    Mylene1f4_fprintf_error
	(context, "%s: cannot parse filter specification: `%s'\n",
	 Mylene1f4(context), string);
    Mylene1f4_fprintf_error(context, "%s: ", Mylene1f4(context));
    x1f4_stat_expression(context, Mylene1f4_fprintc_error, eerecord, NULL);
    Mylene1f4_fprintf_error(context, "\n");
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
int
Mylene1f4_aime_filter(void *context, const char *specification,
		      void **c_filter)
{
    return aime_filter(context, specification, c_filter, 1);
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
int
Mylene1f4_count_filter(void *context, void *filter, unsigned *put)
{
    x1f4_nprint_expression(put, filter, 0);

    return 0;
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
int
Mylene1f4_clear_filter(void *context)
{
    {
	struct filter_state *filter_data;

	filter_data = FILTER(context);
	if (filter_data) {
	    fini_filter(filter_data);

	    FILTER(context) = NULL;
	}
    }

    return 0;
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
int
Mylene1f4_dump_filter(int mode)
{
    if (mode == 030) {
	dump_prefixing();
    } else if (mode == 031) {
	dump_operators(0);
    } else if (mode == 036) {
	dump_functions();
    } else if (mode == 037) {
	dump_selection();
    } else {
	dump_operators(1);
    }

    return 0;
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
int
Mylene1f4_fini_filter(void *context, void **c_filter)
{
    fini_procedure(*c_filter);

    *c_filter = NULL;

    return 0;
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
int
Mylene1f4_init_filter(void *context, const char *specification,
		      void **c_filter, int do_complain)
{
    return aime_filter(context, specification, c_filter, do_complain);
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_EQUEUE__
int
Mylene1f4_line_filter(void *context)
{
    int status;

    if (FILTER(context)) {
	status = 0;
    } else {
	status = init_filter
	    ((struct filter_state **) (void *) &FILTER(context), context);
    }

    return status;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_FILTER__
int
Mylene1f4_miss_filter(void **filter, void *miss_sets)
{
    int status;
    const struct x1f4_function_type *function_data;
    struct x1f4_vkeytree_type *root;

    function_data = x1f4_e4_defaults;
    status = x1f4_make_vtkeyroot(&root, function_data->name, function_data);
    if (status) {
	status = X1f4_E4_ALLOC_ERROR;
    } else {
	function_data++;
	status = add_set(&root, function_data);
	if (!status) {
	    const struct x1f4_function_type **sets;

	    sets = miss_sets;

	    function_data = *sets;
	    while (function_data) {
		status = add_set(&root, function_data);
		if (status) {
		    break;
		} else {
		    sets++;
		    function_data = *sets;
		}
	    }
	}
    }

    if (!status) {
	*filter = root;
    } else {
	x1f4_free_vtkeydata(root);
    }

    return status;
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
int
Mylene1f4_print_filter(void *context, void *filter, void *data,
		       int (*this) (void *, const char *, unsigned))
{
    x1f4_vprint_expression(data, this, filter, 0);

    return 0;
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
int
Mylene1f4_set_filter(void *context, void *filter, int *expect)
{
    int status;
    struct filter_state *filter_data;
    union state_type output;

    filter_data = FILTER(context);

    filter_data->list = NULL;
    filter_data->size = 1 << 16;

    status = x1f4_link_expression(filter, &output);
    if (!status) {
	*expect = *(X1f4_E4_C_MODE *) &output;
    }

    if (1) {
	struct node_type *node_data;

	node_data = filter_data->list;
	while (node_data) {
	    struct node_type *miss_node;

	    miss_node = node_data->node_data;
	    free(node_data);
	    node_data = miss_node;
	}
    }

    return status;
}
#endif				/* __ENABLE_FILTER__ */


#if __ENABLE_FILTER__
int
Mylene1f4_setup_filter(void *context)
{
    FILTER(context) = NULL;

    return 0;
}
#endif				/* __ENABLE_FILTER__ */
