/*
 * format.h
 * Copyright (C) 2005-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __Mylene1f4_FORMAT_H__
#define __Mylene1f4_FORMAT_H__

#include <config.h>

#define __DUMMY_INDEX__			1

#if __ENABLE_CONTROLLING_SERVER__ && __ENABLE_EQUEUE__
# undef __DUMMY_INDEX__
# define __DUMMY_INDEX__		0
#endif				/* __ENABLE_CONTROLLING_SERVER__ && __ENA... */

#if __ENABLE_MPEG_EQUALIZER__
# undef __DUMMY_INDEX__
# define __DUMMY_INDEX__		0
#endif				/* __ENABLE_MPEG_EQUALIZER__ */

#if 1
# undef __DUMMY_INDEX__
# define __DUMMY_INDEX__		0
#endif				/* 1 */

#if 1
# define __DUMMY_RESET__		1
#endif				/* 1 */

#define A52A_SCAN			0
#define INFO_SCAN			1
#define LOOK_SCAN			2
#define LPCM_SCAN			0
#define M66A_SCAN			0
#define MDEV_SCAN			2
#define MPEG_SCAN			0
#define NSSP_SCAN			0
#define RAIL_SCAN			0
#define STAT_SCAN			0
#define USER_SCAN			2

#define TIME_SCAN			2

#if __ENABLE_MPEG_EQUALIZER__
# define BAND_SCAN			0
#endif				/* __ENABLE_MPEG_EQUALIZER__ */

#if __ENABLE_CONTROLLING_SERVER__ && __ENABLE_EQUEUE__
# define LIST_SCAN			2
# define RACK_SCAN			1
# define TEXT_SCAN			0
#endif				/* __ENABLE_CONTROLLING_SERVER__ && __ENA... */

#define KSCANS_STRIDE			3

typedef struct fttime_type {
    unsigned second_a, second_f, second_l;
    time_t time;
} fttime_type;

typedef struct ksscan_type {
    struct atom_type *atom_data;
    struct ksscan_type *parent_ksscan, *previous_ksscan;
    unsigned scope;
    void *data[KSCANS_STRIDE];
#if !__DUMMY_INDEX__
    void (*index___) (void *, unsigned);
#endif				/* !__DUMMY_INDEX__ */
} ksscan_type;

#endif				/* __Mylene1f4_FORMAT_H__ */
