/*
 * format4.c
 * Copyright (C) 2006-2011, 2014, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#if defined HAVE_LIBLEWD
# include <lewd.h>
#endif				/* HAVE_LIBLEWD */
#include <stddef.h>
#if __ENABLE_CONTROLLING_SERVER__ && __ENABLE_EQUEUE__
# include <stdlib.h>
# include <string.h>
#endif				/* __ENABLE_CONTROLLING_SERVER__ && __ENA... */

#if __ENABLE_CONTROLLING_SERVER__
# include <access.h>
# include <defs.h>
# include <excess4.h>
# include <excess7.h>
#endif				/* __ENABLE_CONTROLLING_SERVER__ */
#if __ENABLE_CONTROLLING_SERVER__ && __ENABLE_EQUEUE__
# include <format.h>
#endif				/* __ENABLE_CONTROLLING_SERVER__ && __ENA... */
#if __ENABLE_CONTROLLING_SERVER__
# include <inter.h>
#endif				/* __ENABLE_CONTROLLING_SERVER__ */
#if !defined HAVE_LIBLEWD
# include <printf.h>
#endif				/* !HAVE_LIBLEWD */

#if __ENABLE_CONTROLLING_SERVER__ && __ENABLE_EQUEUE__
# define equeue(equeue) \
    ((struct equeue_type *) (equeue))
#endif				/* __ENABLE_CONTROLLING_SERVER__ && __ENA... */

#if __ENABLE_CONTROLLING_SERVER__
# define Frame4(context) \
    ((struct frame4_type *) &Frame7((context))->_1.frame4)
# define Frame7(context) \
    ((struct frame7_type *) WINDOW((context)).server.window)
#endif				/* __ENABLE_CONTROLLING_SERVER__ */

#if __ENABLE_CONTROLLING_SERVER__
# define COUNT_C_			count_C_
# define COUNT_a_			count_a_
#else
# define COUNT_C_			count__0
# define COUNT_a_			count__0
#endif				/* __ENABLE_CONTROLLING_SERVER__ */

#if __ENABLE_CONTROLLING_SERVER__ && __ENABLE_EQUEUE__
# define COUNT_Mi			count_Mi
# define COUNT_Mj			count_Mj
# define COUNT_q_			count_q_
# define COUNT_e_			count_e_
# define COUNT_ie			count_ie
# define COUNT_l4			count_l4
# define COUNT_mi			count_mi
# define COUNT_mj			count_mj
# define COUNT_p3			count_p3
# define COUNT_p4			count_p4
# define COUNT_q3			count_q3
# define COUNT_sg			count_sg
# define COUNT_sh			count_sh
# define COUNT_t1			count_t1
# define COUNT_t2			count_t2
# define COUNT_te			count_te
# define COUNT_tf			count_tf
# define COUNT_x_			count_x_
#else
# define COUNT_Mi			count__0
# define COUNT_Mj			count__0
# define COUNT_q_			count__1
# define COUNT_e_			count__0
# define COUNT_ie			count__0
# define COUNT_l4			count__1
# define COUNT_mi			count__0
# define COUNT_mj			count__0
# define COUNT_p3			count__1
# define COUNT_p4			count__0
# define COUNT_q3			count__1
# define COUNT_sg			count__0
# define COUNT_sh			count__0
# define COUNT_t1			count__0
# define COUNT_t2			count__0
# define COUNT_te			count__0
# define COUNT_tf			count__0
# define COUNT_x_			count__0
#endif				/* __ENABLE_CONTROLLING_SERVER__ && __ENA... */

#if __ENABLE_CONTROLLING_SERVER__
# define PRINT_C_			print_C_
# define PRINT_a_			print_a_
#else
# define PRINT_C_			print__0
# define PRINT_a_			print__0
#endif				/* __ENABLE_CONTROLLING_SERVER__ */

#if __ENABLE_CONTROLLING_SERVER__ && __ENABLE_EQUEUE__
# define PRINT_Mi			print_Mi
# define PRINT_Mj			print_Mj
# define PRINT_ie			print_ie
# define PRINT_l4			print_l4
# define PRINT_mi			print_mi
# define PRINT_mj			print_mj
# define PRINT_sg			print_sg
# define PRINT_sh			print_sh
# define PRINT_t2			print_t2
# define PRINT_tf			print_tf
#else
# define PRINT_Mi			print__0
# define PRINT_Mj			print__0
# define PRINT_ie			print__0
# define PRINT_l4			print__0
# define PRINT_mi			print__0
# define PRINT_mj			print__0
# define PRINT_sg			print__0
# define PRINT_sh			print__0
# define PRINT_t2			print__0
# define PRINT_tf			print__0
#endif				/* __ENABLE_CONTROLLING_SERVER__ && __ENA... */

#if __ENABLE_CONTROLLING_SERVER__ && __ENABLE_EQUEUE__
# define __NEED_INDEX_____		1
#else
# define __NEED_INDEX_____		0
#endif				/* __ENABLE_CONTROLLING_SERVER__ && __ENA... */

#if !__ENABLE_CONTROLLING_SERVER__
# define __NEED_MISS_DIRECTION__	1
#elif !__ENABLE_EQUEUE__
# define __NEED_MISS_DIRECTION__	1
#else
# define __NEED_MISS_DIRECTION__	0
#endif				/* !__ENABLE_CONTROLLING_SERVER__ */

#if __ENABLE_CONTROLLING_SERVER__
# define count_digits			Mylene1f4_count_digits
#endif				/* __ENABLE_CONTROLLING_SERVER__ */

#if __ENABLE_CONTROLLING_SERVER__
# define print_cardinal			Mylene1f4_print_cardinal
#endif				/* __ENABLE_CONTROLLING_SERVER__ */

#if __ENABLE_CONTROLLING_SERVER__
# define RUN_SSTRING(printer) \
    (((struct printer_state *) (printer))->run_sstring)
# define RUN_ZSTRING(printer) \
    (((struct printer_state *) (printer))->run_zstring)
#endif				/* __ENABLE_CONTROLLING_SERVER__ */

#if __ENABLE_CONTROLLING_SERVER__
# define Context(printer) \
    (((struct printer_state *) (printer))->context)
#endif				/* __ENABLE_CONTROLLING_SERVER__ */

#if __ENABLE_CONTROLLING_SERVER__ && __ENABLE_EQUEUE__
# define SCOPE(printer) \
    ((struct ksscan_type *) ((struct printer_state *) (printer))->scope)
#endif				/* __ENABLE_CONTROLLING_SERVER__ && __ENA... */

#if __ENABLE_CONTROLLING_SERVER__ && __ENABLE_EQUEUE__
# define TYPE_K(printer, index, type) \
    ((type *) SCOPE((printer))->data[(index)])
#endif				/* __ENABLE_CONTROLLING_SERVER__ && __ENA... */

#if __ENABLE_CONTROLLING_SERVER__ && __ENABLE_EQUEUE__
# define K_LIST(printer) \
    TYPE_K(printer, LIST_SCAN, struct equeue_type)
# define K_RACK(printer) \
    TYPE_K(printer, RACK_SCAN, struct rack_type)
# define K_TEXT(printer) \
    TYPE_K(printer, TEXT_SCAN, struct iqueue_type)
#endif				/* __ENABLE_CONTROLLING_SERVER__ && __ENA... */

#if __ENABLE_CONTROLLING_SERVER__ && __ENABLE_EQUEUE__
typedef struct rack_type {
    unsigned index;
} rack_type;
#endif				/* __ENABLE_CONTROLLING_SERVER__ && __ENA... */

#if __ENABLE_CONTROLLING_SERVER__
static unsigned count_C_(void *, unsigned);
#endif				/* __ENABLE_CONTROLLING_SERVER__ */
#if __ENABLE_CONTROLLING_SERVER__ && __ENABLE_EQUEUE__
static unsigned count_Mi(void *, unsigned);
static unsigned count_Mj(void *, unsigned);
#endif				/* __ENABLE_CONTROLLING_SERVER__ && __ENA... */
#if __NEED_MISS_DIRECTION__
static unsigned count__0(void *, unsigned);
#endif				/* __NEED_MISS_DIRECTION__ */
static unsigned count__1(void *, unsigned);
#if __ENABLE_CONTROLLING_SERVER__
static unsigned count_a_(void *, unsigned);
#endif				/* __ENABLE_CONTROLLING_SERVER__ */
#if __ENABLE_CONTROLLING_SERVER__ && __ENABLE_EQUEUE__
static unsigned count_e_(void *, unsigned);
static unsigned count_ie(void *, unsigned);
static unsigned count_l4(void *, unsigned);
static unsigned count_mi(void *, unsigned);
static unsigned count_mj(void *, unsigned);
static unsigned count_p3(void *, unsigned);
static unsigned count_p4(void *, unsigned);
static unsigned count_q3(void *, unsigned);
static unsigned count_q_(void *, unsigned);
static unsigned count_sg(void *, unsigned);
static unsigned count_sh(void *, unsigned);
static unsigned count_t1(void *, unsigned);
static unsigned count_t2(void *, unsigned);
static unsigned count_te(void *, unsigned);
static unsigned count_tf(void *, unsigned);
static unsigned count_x_(void *, unsigned);
static unsigned scale_p4(void *);
static unsigned shift_p4(void *);
#endif				/* __ENABLE_CONTROLLING_SERVER__ && __ENA... */

#if __NEED_INDEX_____
static void index___(void *, unsigned);
#endif				/* __NEED_INDEX_____ */
#if __ENABLE_CONTROLLING_SERVER__ && __ENABLE_EQUEUE__
static void index_p4(void *, unsigned);
#endif				/* __ENABLE_CONTROLLING_SERVER__ && __ENA... */
#if __ENABLE_CONTROLLING_SERVER__
static void print_C_(void *, unsigned);
#endif				/* __ENABLE_CONTROLLING_SERVER__ */
#if __ENABLE_CONTROLLING_SERVER__ && __ENABLE_EQUEUE__
static void print_Mi(void *, unsigned);
static void print_Mj(void *, unsigned);
#endif				/* __ENABLE_CONTROLLING_SERVER__ && __ENA... */
#if __NEED_MISS_DIRECTION__
static void print__0(void *, unsigned);
#endif				/* __NEED_MISS_DIRECTION__ */
#if __ENABLE_CONTROLLING_SERVER__
static void print_a_(void *, unsigned);
#endif				/* __ENABLE_CONTROLLING_SERVER__ */
#if __ENABLE_CONTROLLING_SERVER__ && __ENABLE_EQUEUE__
static void print_ie(void *, unsigned);
static void print_l4(void *, unsigned);
static void print_mi(void *, unsigned);
static void print_mj(void *, unsigned);
static void print_sg(void *, unsigned);
static void print_sh(void *, unsigned);
static void print_t2(void *, unsigned);
static void print_tf(void *, unsigned);
#endif				/* __ENABLE_CONTROLLING_SERVER__ && __ENA... */

static const struct x1f4_efield_type tcz_fields[] = {
/* *INDENT-OFF* */
    {	NULL,
	NULL,		NULL,		0,
	0000,		NULL					}
/* *INDENT-ON* */
}, tcj_fields[] = {
/* *INDENT-OFF* */
    {	"major",
	NULL,		COUNT_Mj,	0,
	0115,		PRINT_Mj				},
    {	"minor",
	NULL,		COUNT_mj,	0,
	0155,		PRINT_mj				},
    {	NULL,
	NULL,		NULL,		0,
	0000,		NULL					}
/* *INDENT-ON* */
}, tci_fields[] = {
/* *INDENT-OFF* */
    {	"major",
	NULL,		COUNT_Mi,	0,
	0115,		PRINT_Mi				},
    {	"minor",
	NULL,		COUNT_mi,	0,
	0155,		PRINT_mi				},
    {	NULL,
	NULL,		NULL,		0,
	0000,		NULL					}
/* *INDENT-ON* */
}, tch_fields[] = {
/* *INDENT-OFF* */
    {	"allocated size",
	NULL,		COUNT_sh,	0,
	0163,		PRINT_sh				},
    {	NULL,
	NULL,		NULL,		0,
	0000,		NULL					}
/* *INDENT-ON* */
}, tcg_fields[] = {
/* *INDENT-OFF* */
    {	"allocated size",
	NULL,		COUNT_sg,	0,
	0163,		PRINT_sg				},
    {	NULL,
	NULL,		NULL,		0,
	0000,		NULL					}
/* *INDENT-ON* */
}, tcf_fields[] = {
/* *INDENT-OFF* */
    {	"text",
	NULL,		COUNT_tf,	0,
	0164,		PRINT_tf				},
    {	NULL,
	NULL,		NULL,		0,
	0000,		NULL					}
/* *INDENT-ON* */
}, tce_fields[] = {
/* *INDENT-OFF* */
    {	"id",
	tci_fields,	count__1,	0,
	0144,		NULL					},
    {	"index",
	NULL,		COUNT_ie,	0,
	0151,		PRINT_ie				},
    {	"memory statistics",
	tcg_fields,	count__1,	0,
	0155,		NULL					},
    {	"title",
	tcf_fields,	COUNT_te,	0,
	0164,		NULL					},
    {	NULL,
	NULL,		NULL,		0,
	0000,		NULL					}
/* *INDENT-ON* */
}, tc4_fields[] = {
/* *INDENT-OFF* */
    {	"length",
	NULL,		COUNT_l4,	0,
	0154,		PRINT_l4				},
    {	"program",
	tce_fields,	COUNT_p4,	X1f4_FORMAT_ITERATE,
	0160,		NULL					},
    {	NULL,
	NULL,		NULL,		0,
	0000,		NULL					}
/* *INDENT-ON* */
}, tc3_fields[] = {
/* *INDENT-OFF* */
    {	"file play back start execution list",
	tc4_fields,	COUNT_p3,	0,
	0160,		NULL					},
    {	"file play back finish execution list",
	tc4_fields,	COUNT_q3,	0,
	0161,		NULL					},
    {	NULL,
	NULL,		NULL,		0,
	0000,		NULL					}
/* *INDENT-ON* */
}, tc2_fields[] = {
/* *INDENT-OFF* */
    {	"text",
	NULL,		COUNT_t2,	0,
	0164,		PRINT_t2				},
    {	NULL,
	NULL,		NULL,		0,
	0000,		NULL					}
/* *INDENT-ON* */
}, tc1_fields[] = {
/* *INDENT-OFF* */
    {	"id",
	tcj_fields,	count__1,	0,
	0144,		NULL					},
    {	"memory statistics",
	tch_fields,	count__1,	0,
	0155,		NULL					},
    {	"title",
	tc2_fields,	COUNT_t1,	0,
	0164,		NULL					},
    {	NULL,
	NULL,		NULL,		0,
	0000,		NULL					}
/* *INDENT-ON* */
};

const struct x1f4_efield_type _Mylene1f4_format4_0[] = {
/* *INDENT-OFF* */
    {	"cycling",
	NULL,		COUNT_C_,	0,
	0103,		PRINT_C_				},
    {	"repeat count",
	NULL,		COUNT_a_,	0,
	0141,		PRINT_a_				},
    {	"program execution",
	tcz_fields,	COUNT_e_,	0,
	0145,		NULL					},
    {	"programs execution queue",
	tc4_fields,	COUNT_q_,	0,
	0161,		NULL					},
    {	"context programs execution lists",
	tc3_fields,	count__1,	0,
	0164,		NULL					},
    {	"running program",
	tc1_fields,	COUNT_x_,	0,
	0170,		NULL					},
    {	NULL,
	NULL,		NULL,		0,
	0,		NULL					}
/* *INDENT-ON* */
};

#if __ENABLE_CONTROLLING_SERVER__
static unsigned
count_C_(void *printer, unsigned flags)
{
    unsigned vertige;

    vertige = Frame4(Context(printer))->vertige;
    if (!vertige) {
	vertige = 3;
    } else if (vertige == 1) {
	vertige = 2;
    } else {
	vertige = count_digits(flags, vertige >> 1);
    }

    return vertige;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__ && __ENABLE_EQUEUE__
static unsigned
count_Mi(void *printer, unsigned flags)
{
    return count_digits(flags, K_LIST(printer)->major);
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ && __ENA... */


#if __ENABLE_CONTROLLING_SERVER__ && __ENABLE_EQUEUE__
static unsigned
count_Mj(void *printer, unsigned flags)
{
    return count_digits
	(flags, equeue(Frame4(Context(printer))->dana.eclass)->major);
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ && __ENA... */


#if __NEED_MISS_DIRECTION__
static unsigned
count__0(void *printer, unsigned flags)
{
    return 0;
}
#endif				/* __NEED_MISS_DIRECTION__ */


static unsigned
count__1(void *printer, unsigned flags)
{
    return 1;
}


#if __ENABLE_CONTROLLING_SERVER__
static unsigned
count_a_(void *printer, unsigned flags)
{
    return count_digits(flags, Frame4(Context(printer))->already);
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__ && __ENABLE_EQUEUE__
static unsigned
count_e_(void *printer, unsigned flags)
{
    return !Frame4(Context(printer))->logic ? 0 : 1;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ && __ENA... */


#if __ENABLE_CONTROLLING_SERVER__ && __ENABLE_EQUEUE__
static unsigned
count_ie(void *printer, unsigned flags)
{
    return count_digits(flags, K_RACK(printer)->index);
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ && __ENA... */


#if __ENABLE_CONTROLLING_SERVER__ && __ENABLE_EQUEUE__
static unsigned
count_l4(void *printer, unsigned flags)
{
    struct iqueue_type *iqueue_data;
    unsigned count;

    iqueue_data = K_TEXT(printer);
    if (!iqueue_data) {
	count = 1;
    } else {
	count = count_digits(flags, iqueue_data->lqueue);
    }

    return count;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ && __ENA... */


#if __ENABLE_CONTROLLING_SERVER__ && __ENABLE_EQUEUE__
static unsigned
count_mi(void *printer, unsigned flags)
{
    return count_digits(flags, K_LIST(printer)->minor);
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ && __ENA... */


#if __ENABLE_CONTROLLING_SERVER__ && __ENABLE_EQUEUE__
static unsigned
count_mj(void *printer, unsigned flags)
{
    return count_digits
	(flags, equeue(Frame4(Context(printer))->dana.eclass)->minor);
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ && __ENA... */


#if __ENABLE_CONTROLLING_SERVER__ && __ENABLE_EQUEUE__
static unsigned
count_p3(void *printer, unsigned flags)
{
    struct stripe_type *stripe_data;

    stripe_data = Frame4(Context(printer))->play_stripe;
    if (!stripe_data) {
	SCOPE(printer)->data[TEXT_SCAN] = NULL;
    } else {
	SCOPE(printer)->data[TEXT_SCAN] = &stripe_data->iqueue;
    }

    return 1;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ && __ENA... */


#if __ENABLE_CONTROLLING_SERVER__ && __ENABLE_EQUEUE__
static unsigned
count_p4(void *printer, unsigned flags)
{
    struct iqueue_type *iqueue_data;
    unsigned count;

    iqueue_data = K_TEXT(printer);
    if (!iqueue_data) {
	count = 0;
    } else {
	unsigned lqueue;

	lqueue = iqueue_data->lqueue;
	if (!lqueue) {
	    count = 0;
	} else {
	    if (flags & X1f4_FORMAT_UNINDEXED) {
		count = scale_p4(printer);
	    } else {
		if (shift_p4(printer)) {
		    count = 0;

		    SCOPE(printer)->index___ = index___;
		} else {
		    if (flags & X1f4_FORMAT_INDEXED) {
			SCOPE(printer)->index___ = index_p4;
		    } else {
			index_p4(printer, 0);
		    }

		    count = lqueue;
		}
	    }
	}
    }

    return count;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ && __ENA... */


#if __ENABLE_CONTROLLING_SERVER__ && __ENABLE_EQUEUE__
static unsigned
count_q3(void *printer, unsigned flags)
{
    struct stripe_type *stripe_data;

    stripe_data = Frame4(Context(printer))->clip_stripe;
    if (!stripe_data) {
	SCOPE(printer)->data[TEXT_SCAN] = NULL;
    } else {
	SCOPE(printer)->data[TEXT_SCAN] = &stripe_data->iqueue;
    }

    return 1;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ && __ENA... */


#if __ENABLE_CONTROLLING_SERVER__ && __ENABLE_EQUEUE__
static unsigned
count_q_(void *printer, unsigned flags)
{
    SCOPE(printer)->data[TEXT_SCAN] = &Frame4(Context(printer))->iqueue;

    return 1;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ && __ENA... */


#if __ENABLE_CONTROLLING_SERVER__ && __ENABLE_EQUEUE__
static unsigned
count_sg(void *printer, unsigned flags)
{
    return count_digits
	(flags,
	 WINDOW(Context(printer)).server.equeue_size
	 - K_LIST(printer)->moon.size);
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ && __ENA... */


#if __ENABLE_CONTROLLING_SERVER__ && __ENABLE_EQUEUE__
static unsigned
count_sh(void *printer, unsigned flags)
{
    void *context;

    context = Context(printer);

    return count_digits
	(flags,
	 WINDOW(context).server.equeue_size
	 - equeue(Frame4(context)->dana.eclass)->moon.size);
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ && __ENA... */


#if __ENABLE_CONTROLLING_SERVER__ && __ENABLE_EQUEUE__
static unsigned
count_t1(void *printer, unsigned flags)
{
    struct equeue_type *equeue_data;

    equeue_data = Frame4(Context(printer))->dana.eclass;
    return !equeue_data->name ? 0 : 1;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ && __ENA... */


#if __ENABLE_CONTROLLING_SERVER__ && __ENABLE_EQUEUE__
static unsigned
count_t2(void *printer, unsigned flags)
{
    struct equeue_type *equeue_data;

    equeue_data = Frame4(Context(printer))->dana.eclass;
    return strlen(equeue_data->name);
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ && __ENA... */


#if __ENABLE_CONTROLLING_SERVER__ && __ENABLE_EQUEUE__
static unsigned
count_te(void *printer, unsigned flags)
{
    return !K_LIST(printer)->name ? 0 : 1;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ && __ENA... */


#if __ENABLE_CONTROLLING_SERVER__ && __ENABLE_EQUEUE__
static unsigned
count_tf(void *printer, unsigned flags)
{
    return strlen(K_LIST(printer)->name);
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ && __ENA... */


#if __ENABLE_CONTROLLING_SERVER__ && __ENABLE_EQUEUE__
static unsigned
count_x_(void *printer, unsigned flags)
{
    return !(Frame4(Context(printer))->flags & Mylene1f4_AIME_LINKED) ? 0 : 1;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ && __ENA... */


#if __ENABLE_CONTROLLING_SERVER__ && __ENABLE_EQUEUE__
static unsigned
scale_p4(void *printer)
{
    free(SCOPE(printer)->data[RACK_SCAN]);

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ && __ENA... */


#if __ENABLE_CONTROLLING_SERVER__ && __ENABLE_EQUEUE__
static unsigned
shift_p4(void *printer)
{
    struct rack_type *rack_data;
    unsigned count;

    rack_data = (struct rack_type *) malloc(sizeof(struct rack_type));
    if (!rack_data) {
	count = ~0;
    } else {
	count = 0;

	rack_data->index = ~0;

	SCOPE(printer)->data[RACK_SCAN] = rack_data;
    }

    return count;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ && __ENA... */


#if __NEED_INDEX_____
static void
index___(void *printer, unsigned index)
{
}
#endif				/* __NEED_INDEX_____ */


#if __ENABLE_CONTROLLING_SERVER__ && __ENABLE_EQUEUE__
static void
index_p4(void *printer, unsigned index)
{
    struct equeue_type *equeue_data;
    unsigned class;

    class = K_RACK(printer)->index;
    K_RACK(printer)->index = index;

    if (!~class) {
	equeue_data = K_TEXT(printer)->head_equeue;
    } else {
	if (index < class) {
	    equeue_data = K_TEXT(printer)->head_equeue;
	} else {
	    equeue_data = SCOPE(printer)->data[LIST_SCAN];
	    index -= class;
	}
    }

    while (index) {
	index--;
	equeue_data = equeue_data->equeue_data;
    }

    SCOPE(printer)->data[LIST_SCAN] = equeue_data;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ && __ENA... */


#if __ENABLE_CONTROLLING_SERVER__
static void
print_C_(void *printer, unsigned flags)
{
    unsigned vertige;

    vertige = Frame4(Context(printer))->vertige;
    if (!vertige) {
	RUN_SSTRING(printer) (printer, "off", 3);
    } else if (vertige == 1) {
	RUN_SSTRING(printer) (printer, "on", 2);
    } else {
	print_cardinal(printer, flags, vertige >> 1);
    }
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__ && __ENABLE_EQUEUE__
static void
print_Mi(void *printer, unsigned flags)
{
    print_cardinal(printer, flags, K_LIST(printer)->major);
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ && __ENA... */


#if __ENABLE_CONTROLLING_SERVER__ && __ENABLE_EQUEUE__
static void
print_Mj(void *printer, unsigned flags)
{
    print_cardinal
	(printer, flags, equeue(Frame4(Context(printer))->dana.eclass)->major);
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ && __ENA... */


#if __NEED_MISS_DIRECTION__
static void
print__0(void *printer, unsigned flags)
{
}
#endif				/* __NEED_MISS_DIRECTION__ */


#if __ENABLE_CONTROLLING_SERVER__
static void
print_a_(void *printer, unsigned flags)
{
    print_cardinal(printer, flags, Frame4(Context(printer))->already);
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__ && __ENABLE_EQUEUE__
static void
print_ie(void *printer, unsigned flags)
{
    print_cardinal(printer, flags, K_RACK(printer)->index);
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ && __ENA... */


#if __ENABLE_CONTROLLING_SERVER__ && __ENABLE_EQUEUE__
static void
print_l4(void *printer, unsigned flags)
{
    struct iqueue_type *iqueue_data;

    iqueue_data = K_TEXT(printer);
    if (!iqueue_data) {
	RUN_SSTRING(printer) (printer, "0", 1);
    } else {
	print_cardinal(printer, flags, iqueue_data->lqueue);
    }
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ && __ENA... */


#if __ENABLE_CONTROLLING_SERVER__ && __ENABLE_EQUEUE__
static void
print_mi(void *printer, unsigned flags)
{
    print_cardinal(printer, flags, K_LIST(printer)->minor);
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ && __ENA... */


#if __ENABLE_CONTROLLING_SERVER__ && __ENABLE_EQUEUE__
static void
print_mj(void *printer, unsigned flags)
{
    print_cardinal
	(printer, flags, equeue(Frame4(Context(printer))->dana.eclass)->minor);
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ && __ENA... */


#if __ENABLE_CONTROLLING_SERVER__ && __ENABLE_EQUEUE__
static void
print_sg(void *printer, unsigned flags)
{
    print_cardinal
	(printer, flags,
	 WINDOW(Context(printer)).server.equeue_size
	 - K_LIST(printer)->moon.size);
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ && __ENA... */


#if __ENABLE_CONTROLLING_SERVER__ && __ENABLE_EQUEUE__
static void
print_sh(void *printer, unsigned flags)
{
    void *context;

    context = Context(printer);
    print_cardinal
	(printer, flags,
	 WINDOW(context).server.equeue_size
	 - equeue(Frame4(context)->dana.eclass)->moon.size);
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ && __ENA... */


#if __ENABLE_CONTROLLING_SERVER__ && __ENABLE_EQUEUE__
static void
print_t2(void *printer, unsigned flags)
{
    struct equeue_type *equeue_data;

    equeue_data = Frame4(Context(printer))->dana.eclass;
    RUN_ZSTRING(printer) (printer, equeue_data->name);
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ && __ENA... */


#if __ENABLE_CONTROLLING_SERVER__ && __ENABLE_EQUEUE__
static void
print_tf(void *printer, unsigned flags)
{
    RUN_ZSTRING(printer) (printer, K_LIST(printer)->name);
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ && __ENA... */
