/*
 * formatr.c
 * Copyright (C) 2007-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#if defined HAVE_LIBLEWD
# include <lewd.h>
#endif				/* HAVE_LIBLEWD */

#include <access.h>
#if !defined HAVE_LIBLEWD
# include <float.n-p.h>
# include <float.v-p.h>
# include <printf.h>
#endif				/* !HAVE_LIBLEWD */

#define x1f4_detail_format		x1f4_detail_format6

#define RUN_SSTRING(printer) \
    (((struct printer_state *) (printer))->run_sstring)

int
Mylene1f4_count_real(void *printer, unsigned flags, double real)
{
    unsigned count = 0, digits = 3, extent = 0;

    if (flags & X1f4_FORMAT_DETAILED) {
	unsigned *list, size;

	x1f4_detail_format
	    (((struct printer_state *) printer)->format, &size, &list);
	if (size) {
	    extent = list[0];
	    size--;
	    if (size) {
		digits = list[1];
	    }
	}
    }

    x1f4_nprint_pfloat(&count, extent, digits, real);

    return count;
}


int
Mylene1f4_print_real(void *printer, unsigned flags, double real)
{
    int status;
    unsigned digits = 3, extent = 0;

    if (flags & X1f4_FORMAT_DETAILED) {
	unsigned *list, size;

	x1f4_detail_format
	    (((struct printer_state *) printer)->format, &size, &list);
	if (size) {
	    extent = list[0];
	    size--;
	    if (size) {
		digits = list[1];
	    }
	}
    }

    status = x1f4_vprint_pfloat
	(printer, RUN_SSTRING(printer), extent, digits, real);

    return status;
}
