/*
 * inter.h
 * Copyright (C) 2005-2014, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __Mylene1f4_INTER_H__
#define __Mylene1f4_INTER_H__

#include <config.h>

#include <sys/types.h>

#if __LINK_CELL_LOADER__
extern int Mylene1f4_66c0_1f42(void *, int *);
#endif				/* __LINK_CELL_LOADER__ */
#if __ENABLE_MPEG_EQUALIZER__
extern int Mylene1f4_add_mode(void *, double);
#endif				/* __ENABLE_MPEG_EQUALIZER__ */
extern int Mylene1f4_advance_system(void *, unsigned *);
#if __ENABLE_FILTER__
extern int Mylene1f4_aime_filter(void *, const char *, void **);
#endif				/* __ENABLE_FILTER__ */
extern int Mylene1f4_aime_format(void *, const char *, const char *, void **);
#if __ENABLE_MPEG_EQUALIZER__
extern int Mylene1f4_air_mode(void *);
#endif				/* __ENABLE_MPEG_EQUALIZER__ */
extern int Mylene1f4_air_signals(void);
extern int Mylene1f4_all_signals
    (const char *, void (*) (void), void (*) (void));
#if __ENABLE_CHANNEL_EQUEUE__
extern int Mylene1f4_away_aime(void *);
#endif				/* __ENABLE_CHANNEL_EQUEUE__ */
#if __ENABLE_CHANNEL_EQUEUE__
extern int Mylene1f4_away_equeue(void *);
#endif				/* __ENABLE_CHANNEL_EQUEUE__ */
#if __ENABLE_EQUEUE__
extern int Mylene1f4_back_aime(void *);
#endif				/* __ENABLE_EQUEUE__ */
extern int Mylene1f4_back_list(void *, void **, unsigned);
#if __ENABLE_SEEK_WINDOW__
extern int Mylene1f4_back_socket(void *, void *, void *);
#endif				/* __ENABLE_SEEK_WINDOW__ */
#if __ENABLE_EQUEUE__
extern int Mylene1f4_blue_equeue(void *, void *);
#endif				/* __ENABLE_EQUEUE__ */
#if __ENABLE_EQUEUE__
extern int Mylene1f4_break_aime(void *);
#endif				/* __ENABLE_EQUEUE__ */
#if __ENABLE_EQUEUE__
extern int Mylene1f4_call_equeue(void *);
#endif				/* __ENABLE_EQUEUE__ */
#if __ENABLE_CHANNEL_EQUEUE__
extern int Mylene1f4_case_aime(void *, unsigned);
#endif				/* __ENABLE_CHANNEL_EQUEUE__ */
#if __ENABLE_CHANNEL_EQUEUE__
extern int Mylene1f4_case_back(void *, const char *, unsigned);
#endif				/* __ENABLE_CHANNEL_EQUEUE__ */
#if __ENABLE_CHANNEL_EQUEUE__
extern int Mylene1f4_case_equeue(void *, unsigned);
#endif				/* __ENABLE_CHANNEL_EQUEUE__ */
extern int Mylene1f4_case_list(void *, int *, unsigned, void *);
#if __LINK_CELL_LOADER__
extern int Mylene1f4_ceil_1f42(void *, void **);
#endif				/* __LINK_CELL_LOADER__ */
#if __ENABLE_EQUEUE__
extern int Mylene1f4_ceil_aime(void *, const char *);
#endif				/* __ENABLE_EQUEUE__ */
extern int Mylene1f4_ceil_list(void *, int *, unsigned, void *);
#if __ENABLE_EQUEUE__
extern int Mylene1f4_cell_aime(void *);
#endif				/* __ENABLE_EQUEUE__ */
#if __ENABLE_EQUEUE__
extern int Mylene1f4_class_aime(void *);
#endif				/* __ENABLE_EQUEUE__ */
extern int Mylene1f4_class_string(void *, const char *, unsigned);
#if __ENABLE_EQUEUE__
extern int Mylene1f4_clear_aime(void *);
#endif				/* __ENABLE_EQUEUE__ */
#if __ENABLE_FILTER__
extern int Mylene1f4_clear_filter(void *);
#endif				/* __ENABLE_FILTER__ */
extern int Mylene1f4_clear_format(void *);
extern int Mylene1f4_clear_output(void *);
extern int Mylene1f4_clear_system(void *);
#if __LINK_CELL_LOADER__
extern int Mylene1f4_clip_cell(void *, unsigned);
#endif				/* __LINK_CELL_LOADER__ */
extern int Mylene1f4_clip_list(void *, int *, int, unsigned);
extern int Mylene1f4_clip_lpcm(void *, unsigned);
extern int Mylene1f4_clip_mpeg(void *, unsigned);
extern int Mylene1f4_clip_source(void *);
extern int Mylene1f4_close_connections(void *);
extern int Mylene1f4_close_file(void *, void *);
#if __ENABLE_x00696e6b__
extern int Mylene1f4_code_time(unsigned char *);
#endif				/* __ENABLE_x00696e6b__ */
extern int Mylene1f4_copy_1f42(void *, void *);
#if __LINK_CELL_LOADER__
extern int Mylene1f4_copy_cell(void *, void *);
#endif				/* __LINK_CELL_LOADER__ */
extern int Mylene1f4_copy_lpcm(void *, void *);
extern int Mylene1f4_copy_mpeg(void *, void *);
extern int Mylene1f4_count_digits(unsigned, unsigned);
#if __ENABLE_FILTER__
extern int Mylene1f4_count_filter(void *, void *, unsigned *);
#endif				/* __ENABLE_FILTER__ */
extern int Mylene1f4_count_pdigits(unsigned, void *);
extern int Mylene1f4_count_real(void *, unsigned, double);
#if __ENABLE_MPEG_EQUALIZER__
extern int Mylene1f4_day_mode(void *);
#endif				/* __ENABLE_MPEG_EQUALIZER__ */
#if __ENABLE_EQUEUE__
extern int Mylene1f4_deck_alia(void *, unsigned);
#endif				/* __ENABLE_EQUEUE__ */
#if __ENABLE_EQUEUE__
extern int Mylene1f4_deck_equeue(void *, void *);
#endif				/* __ENABLE_EQUEUE__ */
extern int Mylene1f4_deck_list(void *, int *, int *);
#if __WAIT_VIOLET__
extern int Mylene1f4_deque_violet(void *, void *);
#endif				/* __WAIT_VIOLET__ */
#if __ENABLE_EQUEUE__
extern int Mylene1f4_detail_aime(void *, int);
#endif				/* __ENABLE_EQUEUE__ */
extern int Mylene1f4_deux_mylene0fa(void *);
extern int Mylene1f4_dump_1f42(void *, void *, unsigned *, void **);
#if __LINK_CELL_LOADER__
extern int Mylene1f4_dump_cell(void *, void *, unsigned *, void **);
#endif				/* __LINK_CELL_LOADER__ */
#if __ENABLE_FILTER__
extern int Mylene1f4_dump_filter(int);
#endif				/* __ENABLE_FILTER__ */
extern int Mylene1f4_dump_format(int);
extern int Mylene1f4_dump_list(void *);
extern int Mylene1f4_dump_lpcm(void *, void *, unsigned *, void **);
extern int Mylene1f4_dump_mpeg(void *, void *, unsigned *, void **);
#if __NONBLOCKING_CLIENT_TRANSFER__
extern int Mylene1f4_edge_e3e8(void *, char **, unsigned *);
#endif				/* __NONBLOCKING_CLIENT_TRANSFER__ */
#if __ENABLE_x1f4LANES__
extern int Mylene1f4_ever_lanes(void *);
#endif				/* __ENABLE_x1f4LANES__ */
extern int Mylene1f4_extend_system(void *, unsigned);
#if __ENABLE_EQUEUE__
extern int Mylene1f4_fail_aime(void *, void *);
#endif				/* __ENABLE_EQUEUE__ */
#if __ENABLE_EQUEUE__
extern int Mylene1f4_fast_aime(void *, void *);
#endif				/* __ENABLE_EQUEUE__ */
#if __ENABLE_EQUEUE__
extern int Mylene1f4_fast_alia(void *, unsigned, void *);
#endif				/* __ENABLE_EQUEUE__ */
#if __ENABLE_CONTROLLING_SERVER__
extern int Mylene1f4_fast_back(void *, unsigned);
#endif				/* __ENABLE_CONTROLLING_SERVER__ */
#if __ENABLE_EQUEUE__
extern int Mylene1f4_fast_e4lx(void *, void *, int *, void *);
#endif				/* __ENABLE_EQUEUE__ */
#if __ENABLE_EQUEUE__
extern int Mylene1f4_fast_equeue(void *, void *, unsigned, void *);
#endif				/* __ENABLE_EQUEUE__ */
extern int Mylene1f4_fast_list(void *);
extern int Mylene1f4_find_sequel(void *, unsigned, void **);
#if __ENABLE_EQUEUE__
extern int Mylene1f4_fini_aime(void *, void *);
#endif				/* __ENABLE_EQUEUE__ */
#if __ENABLE_EQUEUE__
extern int Mylene1f4_fini_equeue(void *);
#endif				/* __ENABLE_EQUEUE__ */
#if __ENABLE_EQUEUE__
extern int Mylene1f4_fini_extent(void *, void *);
#endif				/* __ENABLE_EQUEUE__ */
#if __ENABLE_FILTER__
extern int Mylene1f4_fini_filter(void *, void **);
#endif				/* __ENABLE_FILTER__ */
extern int Mylene1f4_fini_format(void *, void **);
#if __ENABLE_EQUEUE__
extern int Mylene1f4_fini_iqueue(void *, void *, void *);
#endif				/* __ENABLE_EQUEUE__ */
#if __ENABLE_x1f4LANES__
extern int Mylene1f4_fini_lanes(void *);
#endif				/* __ENABLE_x1f4LANES__ */
extern int Mylene1f4_fini_link(void *);
extern int Mylene1f4_fini_list(void *);
#if __ENABLE_EQUEUE__
extern int Mylene1f4_fini_moon(void *, void *);
#endif				/* __ENABLE_EQUEUE__ */
extern int Mylene1f4_fini_mylene0fa(void *);
extern int Mylene1f4_fini_output(void *);
#if __ENABLE_SEEK_WINDOW__
extern int Mylene1f4_fini_socket(void **);
#endif				/* __ENABLE_SEEK_WINDOW__ */
extern int Mylene1f4_fini_source(void *);
extern int Mylene1f4_fit_system(void *, void *);
extern int Mylene1f4_fix_index(void *, unsigned *);
#if __ENABLE_MPEG_EQUALIZER__
extern int Mylene1f4_fix_mode(void *, unsigned, double);
#endif				/* __ENABLE_MPEG_EQUALIZER__ */
extern int Mylene1f4_fix_record(void *, int (*) (void *));
extern int Mylene1f4_fix_start(void *, unsigned *);
extern int Mylene1f4_fix_system(void *, unsigned);
#if __ENABLE_EQUEUE__
extern int Mylene1f4_flat_e4lx(void *);
#endif				/* __ENABLE_EQUEUE__ */
#if __ENABLE_EQUEUE__
extern int Mylene1f4_flat_equeue(void *, void *);
#endif				/* __ENABLE_EQUEUE__ */
extern int Mylene1f4_flat_list(void *);
extern int Mylene1f4_flat_system(void *);
extern int Mylene1f4_fprintc_error(void *, const char *, unsigned);
extern int Mylene1f4_fprintf_error(void *, const char *, ...);
extern int Mylene1f4_fprintf_offset(void *, void *);
#if __ENABLE_EQUEUE__
extern int Mylene1f4_free_equeue(void *, void *);
#endif				/* __ENABLE_EQUEUE__ */
#if __ENABLE_EQUEUE__
extern int Mylene1f4_free_moon(void *, void *);
#endif				/* __ENABLE_EQUEUE__ */
extern int Mylene1f4_free_mylene0fa(void *);
extern int Mylene1f4_get_record(void *, int (*) (void *));
extern int Mylene1f4_get_system(void *);
extern int Mylene1f4_half_list(void *);
extern int Mylene1f4_head_list(void *, unsigned);
extern int Mylene1f4_head_system(void *, unsigned *);
#if __ENABLE_EQUEUE__
extern int Mylene1f4_high_equeue(void *, void *, void **);
#endif				/* __ENABLE_EQUEUE__ */
#if __ENABLE_EQUEUE__
extern int Mylene1f4_init_equeue(void *);
#endif				/* __ENABLE_EQUEUE__ */
#if __ENABLE_EQUEUE__
extern int Mylene1f4_init_extent(void *, void *);
#endif				/* __ENABLE_EQUEUE__ */
#if __ENABLE_FILTER__
extern int Mylene1f4_init_filter(void *, const char *, void **, int);
#endif				/* __ENABLE_FILTER__ */
extern int Mylene1f4_init_format(void *, const char *, void **);
#if __ENABLE_x1f4LANES__
extern int Mylene1f4_init_lanes(void *, int *);
#endif				/* __ENABLE_x1f4LANES__ */
extern int Mylene1f4_init_link(void *, unsigned);
extern int Mylene1f4_init_list(void *, int , char **, int);
#if __ENABLE_EQUEUE__
extern int Mylene1f4_init_moon(void *, void *);
#endif				/* __ENABLE_EQUEUE__ */
extern int Mylene1f4_init_mylene0fa(void *);
extern int Mylene1f4_init_output
    (void *, const char *, const char *, const char *);
#if __ENABLE_SEEK_WINDOW__
extern int Mylene1f4_init_socket(void *, void **, void *);
#endif				/* __ENABLE_SEEK_WINDOW__ */
extern int Mylene1f4_init_source(void *);
extern int Mylene1f4_kill_mylene0fa(void *);
#if __ENABLE_TAGGED_LIST__
extern int Mylene1f4_land_list
    (void *, unsigned, unsigned, unsigned, unsigned, unsigned, void *);
#endif				/* __ENABLE_TAGGED_LIST__ */
#if __ENABLE_CHANNEL_SERVER__
extern int Mylene1f4_lane_back(void *, unsigned);
#endif				/* __ENABLE_CHANNEL_SERVER__ */
#if __ENABLE_EQUEUE__
extern int Mylene1f4_line_aime(void **, void *, void *, void *);
#endif				/* __ENABLE_EQUEUE__ */
#if __ENABLE_EQUEUE__
extern int Mylene1f4_line_alia(void *, unsigned);
#endif				/* __ENABLE_EQUEUE__ */
#if __ENABLE_EQUEUE__
extern int Mylene1f4_line_e4lx(void *);
#endif				/* __ENABLE_EQUEUE__ */
#if __ENABLE_EQUEUE__
extern int Mylene1f4_line_equeue(void *, void *);
#endif				/* __ENABLE_EQUEUE__ */
#if __ENABLE_EQUEUE__
extern int Mylene1f4_line_filter(void *);
#endif				/* __ENABLE_EQUEUE__ */
#if __RESTART_Mylene0fa__
extern int Mylene1f4_line_link(void *, unsigned, unsigned);
#endif				/* __RESTART_Mylene0fa__ */
#if __ENABLE_TAGGED_LIST__
extern int Mylene1f4_line_list(void *, unsigned, unsigned, unsigned, void *);
#endif				/* __ENABLE_TAGGED_LIST__ */
extern int Mylene1f4_line_reference(void *, unsigned *);
extern int Mylene1f4_line_source(void *);
extern int Mylene1f4_line_system(void *);
#if __ENABLE_EQUEUE__
extern int Mylene1f4_link_aime(void *);
#endif				/* __ENABLE_EQUEUE__ */
extern int Mylene1f4_link_e3e8(void *);
#if __ENABLE_EQUEUE__
extern int Mylene1f4_link_equeue(void *, char *, const char **);
#endif				/* __ENABLE_EQUEUE__ */
extern int Mylene1f4_link_list(void *, unsigned, unsigned, void *);
#if __ENABLE_EQUEUE__
extern int Mylene1f4_link_moon(void *, void **, unsigned);
#endif				/* __ENABLE_EQUEUE__ */
#if __ENABLE_EQUEUE__
extern int Mylene1f4_link_note
    (void *, unsigned, unsigned, unsigned, const char *);
#endif				/* __ENABLE_EQUEUE__ */
#if __ENABLE_TAGGED_LIST__
extern int Mylene1f4_link_source(void *);
#endif				/* __ENABLE_TAGGED_LIST__ */
extern int Mylene1f4_link_stream(void *);
extern int Mylene1f4_link_system(void *);
#if __ENABLE_EQUEUE__
extern int Mylene1f4_list_sets(void *, const void *, unsigned);
#endif				/* __ENABLE_EQUEUE__ */
extern int Mylene1f4_load_1f42(void *, void *, unsigned *, void **);
#if __LINK_CELL_LOADER__
extern int Mylene1f4_load_cell(void *, void *, unsigned *, void **);
#endif				/* __LINK_CELL_LOADER__ */
extern int Mylene1f4_load_lpcm(void *, void *, unsigned *, void **);
extern int Mylene1f4_load_mpeg(void *, void *, unsigned *, void **);
#if __ENABLE_CONTROLLING_SERVER__
extern int Mylene1f4_lock_i144(void *, unsigned, unsigned, unsigned);
#endif				/* __ENABLE_CONTROLLING_SERVER__ */
extern int Mylene1f4_lock_list(void *, void **, unsigned);
#if __ENABLE_EQUEUE__
extern int Mylene1f4_look_aime(const void *, int, const char **, unsigned *);
#endif				/* __ENABLE_EQUEUE__ */
#if __ENABLE_CONTROLLING_SERVER__
extern int Mylene1f4_look_alia(void *, unsigned);
#endif				/* __ENABLE_CONTROLLING_SERVER__ */
#if __ENABLE_EQUEUE__
extern int Mylene1f4_lose_aime(void *);
#endif				/* __ENABLE_EQUEUE__ */
extern int Mylene1f4_lose_e3e8(void *);
#if __ENABLE_EQUEUE__
extern int Mylene1f4_lose_equeue(void *);
#endif				/* __ENABLE_EQUEUE__ */
extern int Mylene1f4_lose_mylene0fa(void *);
extern int Mylene1f4_make_link(void *);
#if __WAIT_VIOLET__
extern int Mylene1f4_merge_violet(void *, void *, int);
#endif				/* __WAIT_VIOLET__ */
#if __ENABLE_EQUEUE__
extern int Mylene1f4_miss_aime(void *);
#endif				/* __ENABLE_EQUEUE__ */
#if __ENABLE_CONTROLLING_SERVER__
extern int Mylene1f4_miss_back(void *, const char *, unsigned);
#endif				/* __ENABLE_CONTROLLING_SERVER__ */
#if __ENABLE_EQUEUE__
extern int Mylene1f4_miss_equeue(void *, unsigned);
#endif				/* __ENABLE_EQUEUE__ */
#if __ENABLE_FILTER__
extern int Mylene1f4_miss_filter(void **, void *);
#endif				/* __ENABLE_FILTER__ */
#if __ENABLE_EQUEUE__
extern int Mylene1f4_miss_iqueue(void *, void *, unsigned);
#endif				/* __ENABLE_EQUEUE__ */
#if __ENABLE_x1f4LANES__
extern int Mylene1f4_miss_lanes(void *, unsigned *);
#endif				/* __ENABLE_x1f4LANES__ */
extern int Mylene1f4_miss_wait(void *, unsigned, unsigned *);
#if __ENABLE_EQUEUE__
extern int Mylene1f4_mode_moon(void *, void **, unsigned);
#endif				/* __ENABLE_EQUEUE__ */
#if __ENABLE_EQUEUE__
extern int Mylene1f4_move_equeue(void *, unsigned, unsigned);
#endif				/* __ENABLE_EQUEUE__ */
#if __ENABLE_MPEG_EQUALIZER__
extern int Mylene1f4_nay_mode(void *);
#endif				/* __ENABLE_MPEG_EQUALIZER__ */
#if __ENABLE_EQUEUE_SERVER__
extern int Mylene1f4_near_call(void *);
#endif				/* __ENABLE_EQUEUE_SERVER__ */
#if __ENABLE_CONTROLLING_SERVER__
extern int Mylene1f4_near_flat(void *, char *, unsigned);
#endif				/* __ENABLE_CONTROLLING_SERVER__ */
#if __ENABLE_EQUEUE_SERVER__
extern int Mylene1f4_near_list(void *, unsigned);
#endif				/* __ENABLE_EQUEUE_SERVER__ */
extern int Mylene1f4_near_miss(void *);
#if __ENABLE_EQUEUE__
extern int Mylene1f4_near_moon(void *);
#endif				/* __ENABLE_EQUEUE__ */
#if __ENABLE_EQUEUE_SERVER__
extern int Mylene1f4_near_post(void *, unsigned, unsigned, unsigned);
#endif				/* __ENABLE_EQUEUE_SERVER__ */
#if __ENABLE_EDIT_SERVER__
extern int Mylene1f4_near_seek(void *, unsigned, char *);
#endif				/* __ENABLE_EDIT_SERVER__ */
#if __ENABLE_CONTROLLING_SERVER__
extern int Mylene1f4_near_side(void *, unsigned);
#endif				/* __ENABLE_CONTROLLING_SERVER__ */
#if __ENABLE_CONTROLLING_SERVER__
extern int Mylene1f4_near_slip(void *, char *);
#endif				/* __ENABLE_CONTROLLING_SERVER__ */
extern int Mylene1f4_near_system(void *);
#if __LINK_CELL_LOADER__
extern int Mylene1f4_node_cell(void *, const void **);
#endif				/* __LINK_CELL_LOADER__ */
extern int Mylene1f4_node_lpcm(void *, const void **);
extern int Mylene1f4_node_mpeg(void *, const void **);
extern int Mylene1f4_open_file(void *, void *);
#if __ENABLE_MPEG_EQUALIZER__
extern int Mylene1f4_parse_amplification(void *, const char *);
#endif				/* __ENABLE_MPEG_EQUALIZER__ */
extern int Mylene1f4_parse_cardinal
    (void *, const char *, const char *, unsigned *);
extern int Mylene1f4_parse_ctreekey
    (void *, const char *, const void *, const char *, unsigned *);
#if __ENABLE_MPEG_EQUALIZER__
extern int Mylene1f4_parse_frequencies(void *, const char *);
#endif				/* __ENABLE_MPEG_EQUALIZER__ */
extern int Mylene1f4_parse_integral(void *, const char *, const char *, int *);
#if __ENABLE_MPEG_EQUALIZER__
extern int Mylene1f4_parse_levels(void *, const char *);
#endif				/* __ENABLE_MPEG_EQUALIZER__ */
extern int Mylene1f4_parse_positive
    (void *, const char *, const char *, unsigned *);
extern int Mylene1f4_parse_real(void *, const char *, const char *, double *);
extern int Mylene1f4_parse_time(void *, const char *, const char *, void *);
extern int Mylene1f4_parse_vtreekey
    (void *, const char *, const void *, const char *, const void **);
#if __ENABLE_EQUEUE__
extern int Mylene1f4_pick_aime(void *, void *, void *);
#endif				/* __ENABLE_EQUEUE__ */
#if __ENABLE_EQUEUE__
extern int Mylene1f4_pick_equeue(void *, void **, unsigned, void *);
#endif				/* __ENABLE_EQUEUE__ */
#if __ENABLE_EQUEUE__
extern int Mylene1f4_pick_note(void *, unsigned, unsigned, void **);
#endif				/* __ENABLE_EQUEUE__ */
#if __ENABLE_CONTROLLING_SERVER__
extern int Mylene1f4_pipe_back(void *, const char *, unsigned);
#endif				/* __ENABLE_CONTROLLING_SERVER__ */
#if __ENABLE_EQUEUE__
extern int Mylene1f4_port_aime(void *, void *, int);
#endif				/* __ENABLE_EQUEUE__ */
#if __ENABLE_EQUEUE__
extern int Mylene1f4_port_moon(void *, void *, void *);
#endif				/* __ENABLE_EQUEUE__ */
extern int Mylene1f4_post_list
    (void *, unsigned, unsigned, unsigned, unsigned, void *);
extern int Mylene1f4_post_time(void *, unsigned);
extern int Mylene1f4_print_cardinal(void *, unsigned, unsigned);
#if __ENABLE_FILTER__
extern int Mylene1f4_print_filter
    (void *, void *, void *, int (*) (void *, const char *, unsigned));
#endif				/* __ENABLE_FILTER__ */
extern int Mylene1f4_print_pcardinal(void *, unsigned, void *);
extern int Mylene1f4_print_real(void *, unsigned, double);
#if __ENABLE_EQUEUE__
extern int Mylene1f4_push_aime(void *);
#endif				/* __ENABLE_EQUEUE__ */
#if __ENABLE_EQUEUE__
extern int Mylene1f4_push_alia(void *, unsigned, unsigned);
#endif				/* __ENABLE_EQUEUE__ */
#if __ENABLE_EQUEUE__
extern int Mylene1f4_push_equeue(void *, unsigned);
#endif				/* __ENABLE_EQUEUE__ */
#if defined __ENABLE_x1f4LANES__
extern int Mylene1f4_push_lanes(void *);
#endif				/* __ENABLE_x1f4LANES__ */
extern int Mylene1f4_push_list(void *, unsigned, unsigned, void *);
extern int Mylene1f4_push_mylene0fa(void *);
#if __WAIT_VIOLET__
extern int Mylene1f4_queue_violet(void *, void *);
#endif				/* __WAIT_VIOLET__ */
extern int Mylene1f4_rack_stripe(void *, int, unsigned);
extern int Mylene1f4_rail_system(void *);
extern int Mylene1f4_read_e0fa(void *, int);
extern int Mylene1f4_read_file(void *, void *, void *, unsigned);
extern int Mylene1f4_read_list(void *, const char *, int);
extern int Mylene1f4_remove_sequel(void *, unsigned);
#if __ENABLE_EQUEUE__
extern int Mylene1f4_reset_aime(void *);
#endif				/* __ENABLE_EQUEUE__ */
extern int Mylene1f4_reset_system(void *);
extern int Mylene1f4_run_excess0(void *);
extern int Mylene1f4_run_excess2(void *);
extern int Mylene1f4_run_excess3(void *);
#if __ENABLE_CONTROLLING_SERVER__
extern int Mylene1f4_run_excess7(void *);
#endif				/* __ENABLE_CONTROLLING_SERVER__ */
#if __ENABLE_x1f4LANES__
extern int Mylene1f4_run_excessb(void *);
#endif				/* __ENABLE_x1f4LANES__ */
#if __ENABLE_x1f4LANES__
extern int Mylene1f4_send_lanes(void *, unsigned, void *);
extern int Mylene1f4_sync_lanes(void *, unsigned *, int (*) (void *));
#endif				/* __ENABLE_x1f4LANES__ */
extern int Mylene1f4_run_format(void *, void *);
#if __ENABLE_EQUEUE__
extern int Mylene1f4_sand_equeue(void *, void *);
#endif				/* __ENABLE_EQUEUE__ */
extern int Mylene1f4_sand_list(void *);
extern int Mylene1f4_scale_track(void *);
extern int Mylene1f4_seek_file(void *, void *, int, int);
extern int Mylene1f4_seek_list(void *, unsigned);
#if __ENABLE_SEEK_WINDOW__
extern int Mylene1f4_seek_socket(void *, unsigned *, void **);
#endif				/* __ENABLE_SEEK_WINDOW__ */
extern int Mylene1f4_seek_stream(void *, unsigned, unsigned, void *, void *);
extern int Mylene1f4_seek_system(void *, unsigned, unsigned, void *, void *);
extern int Mylene1f4_send_mylene0fa(void *, int, void *);
#if __ENABLE_FILTER__
extern int Mylene1f4_set_filter(void *, void *, int *);
#endif				/* __ENABLE_FILTER__ */
extern int Mylene1f4_set_format(void *, void *, void *);
#if __ENABLE_MPEG_EQUALIZER__
extern int Mylene1f4_set_mode(void *, unsigned, double);
#endif				/* __ENABLE_MPEG_EQUALIZER__ */
extern int Mylene1f4_set_record(void *, int (*) (void *), void *);
extern int Mylene1f4_set_system(void *, void *);
#if __ENABLE_EQUEUE__
extern int Mylene1f4_setup_aime(void *);
#endif				/* __ENABLE_EQUEUE__ */
#if __ENABLE_FILTER__
extern int Mylene1f4_setup_filter(void *);
#endif				/* __ENABLE_FILTER__ */
extern int Mylene1f4_setup_format(void *);
extern int Mylene1f4_setup_output(void *);
extern int Mylene1f4_shell_string(void *, const char *, unsigned);
extern int Mylene1f4_shift_track(void *);
extern int Mylene1f4_shrink_field(const char **, unsigned *);
#if __ENABLE_EQUEUE__
extern int Mylene1f4_side_equeue(void *, void **);
#endif				/* __ENABLE_EQUEUE__ */
#if __ENABLE_CHANNEL_SERVER__
extern int Mylene1f4_slip_back(void *, const char *, unsigned);
#endif				/* __ENABLE_CHANNEL_SERVER__ */
#if __ENABLE_EQUEUE__
extern int Mylene1f4_slip_equeue(void *, int, unsigned);
#endif				/* __ENABLE_EQUEUE__ */
extern int Mylene1f4_slip_list(void *);
#if __ENABLE_MPEG_EQUALIZER__
extern int Mylene1f4_sort_bands(void *, unsigned);
#endif				/* __ENABLE_MPEG_EQUALIZER__ */
#if __ENABLE_EQUEUE__
extern int Mylene1f4_stat_aime(void *, char *, char *, int, int, void *);
#endif				/* __ENABLE_EQUEUE__ */
extern int Mylene1f4_stat_exit(void *, int);
extern int Mylene1f4_stat_source(void *);
extern int Mylene1f4_stat_system(void *, void *);
extern int Mylene1f4_strip_graphique(void *, void *);
#if __ENABLE_EQUEUE__
extern int Mylene1f4_swap_equeue(void *, int, unsigned, int, unsigned);
#endif				/* __ENABLE_EQUEUE__ */
#if __ENABLE_FILTER__
extern int Mylene1f4_swap_filter(void *, void *);
#endif				/* __ENABLE_FILTER__ */
extern int Mylene1f4_swap_graphique(void *, void *);
#if __ENABLE_CONTROLLING_SERVER__
extern int Mylene1f4_swap_last(void *, unsigned);
#endif				/* __ENABLE_CONTROLLING_SERVER__ */
#if __ENABLE_CONTROLLING_SERVER__
extern int Mylene1f4_swap_progress(void *, void *, void *);
#endif				/* __ENABLE_CONTROLLING_SERVER__ */
extern int Mylene1f4_sync_mylene0fa(void *);
extern int Mylene1f4_tail_list(void *, unsigned);
#if __ENABLE_MPEG_EQUALIZER__
extern int Mylene1f4_tee_mode(void *);
#endif				/* __ENABLE_MPEG_EQUALIZER__ */
extern int Mylene1f4_tell_file(void *, void *, unsigned *);
#if __ENABLE_CHANNEL_SERVER__
extern int Mylene1f4_text_back(void *, const char *, unsigned);
#endif				/* __ENABLE_CHANNEL_SERVER__ */
#if __ENABLE_EQUEUE__
extern int Mylene1f4_track_aime(void *);
#endif				/* __ENABLE_EQUEUE__ */
#if __ENABLE_EQUEUE__
extern int Mylene1f4_trap_equeue(void *, void *);
#endif				/* __ENABLE_EQUEUE__ */
extern int Mylene1f4_try_signals(int, char **);
extern int Mylene1f4_try_system(void *, void *);
#if __LINK_CELL_LOADER__
extern int Mylene1f4_type_cell(void *, void *);
#endif				/* __LINK_CELL_LOADER__ */
extern int Mylene1f4_type_lpcm(void *, void *);
extern int Mylene1f4_type_mpeg(void *, void *);
extern int Mylene1f4_vprintf_offset
    (void *, int (*) (void *, const char *, unsigned), unsigned, unsigned,
     unsigned, void *);
extern int Mylene1f4_wait_mylene0fa(void *, int *);
extern int Mylene1f4_wait_second(void *, pid_t *);
#if __ENABLE_MPEG_EQUALIZER__
extern int Mylene1f4_way_mode(void *, void **, unsigned, void *);
#endif				/* __ENABLE_MPEG_EQUALIZER__ */
#if __ENABLE_EQUEUE__
extern int Mylene1f4_wind_aime(void *);
#endif				/* __ENABLE_EQUEUE__ */
#if __ENABLE_EQUEUE__
extern int Mylene1f4_wind_e4lx(void *);
#endif				/* __ENABLE_EQUEUE__ */
#if __ENABLE_TAGGED_LIST__
extern int Mylene1f4_wind_list(void *, void *);
#endif				/* __ENABLE_TAGGED_LIST__ */
extern int Mylene1f4_yway_mylene0fa(void *, int);
#if __ENABLE_EQUEUE__
extern int Mylene1f4_xset_aime(void *);
#endif				/* __ENABLE_EQUEUE__ */
#if __ENABLE_EQUEUE__
extern int Mylene1f4_xset_e4lx(void *);
#endif				/* __ENABLE_EQUEUE__ */

#endif				/* __Mylene1f4_INTER_H__ */
