/*
 * iqueue.c
 * Copyright (C) 2007, 2008, 2009, 2010, 2013, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#if __ENABLE_EQUEUE__
# include <aime.h>
# include <stddef.h>
# include <stdlib.h>
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# include <defs.h>
# include <inter.h>
# include <types.h>
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
int
Mylene1f4_fini_iqueue(void *context, void *equeue, void *iqueue)
{
    struct equeue_type *equeue_link = NULL, *head_equeue = NULL;
    unsigned lqueue = 0;

    while (equeue) {
	struct equeue_type *equeue_slip;

	equeue_slip = equeue;

	equeue = equeue_slip->equeue_data;

	if (equeue_slip->bits & Mylene1f4_EXTERN_LOGIC) {
	    Mylene1f4_line_equeue(context, equeue_slip);
	    if (head_equeue) {
	    } else {
		head_equeue = equeue_slip;
	    }
	    equeue_link = equeue_slip;
	    lqueue++;
	} else {
	    Mylene1f4_deck_equeue(context, equeue_slip);
	    if (equeue_link) {
		equeue_link->equeue_data = equeue;
	    }
	}
    }

    if (iqueue) {
	struct iqueue_type *iqueue_data;

	iqueue_data = iqueue;
	if (lqueue) {
	    iqueue_data->head_equeue = head_equeue;
	    iqueue_data->lqueue = lqueue;
	    iqueue_data->tail_equeue = equeue_link;
	} else {
	    iqueue_data->head_equeue = NULL;
	    iqueue_data->lqueue = 0;
	    iqueue_data->tail_equeue = NULL;
	}
    }

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
int
Mylene1f4_miss_iqueue(void *context, void *iqueue, unsigned delete)
{
    struct equeue_type *equeue_data;
    struct iqueue_type *iqueue_data;
    unsigned lqueue;

    iqueue_data = iqueue;

    lqueue = iqueue_data->lqueue;

    lqueue--;

    iqueue_data->lqueue = lqueue;

    equeue_data = iqueue_data->head_equeue;

    if (delete) {
	{
	    unsigned i;

	    i = delete - 1;
	    for (; i; i--) {
		equeue_data = equeue_data->equeue_data;
	    }
	}

	{
	    struct equeue_type *equeue_link;

	    equeue_link = equeue_data->equeue_data;

	    {
		struct equeue_type *equeue_ceil;

		equeue_ceil = equeue_link->equeue_data;

		if (equeue_ceil) {
		    equeue_data->equeue_data = equeue_ceil;
		} else {
		    equeue_data->equeue_data = NULL;
		    iqueue_data->tail_equeue = equeue_data;
		}
	    }

	    Mylene1f4_free_equeue(context, equeue_link);
	}
    } else {
	struct equeue_type *equeue_ceil;

	equeue_ceil = equeue_data->equeue_data;

	iqueue_data->head_equeue = equeue_ceil;

	Mylene1f4_free_equeue(context, equeue_data);
    }

    return 0;
}
#endif				/* __ENABLE_EQUEUE__ */
