/*
 * lpcm.c
 * Copyright (C) 2007-2008, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * TODO
 *
 *.back_lpcm and head_lpcm for non 1f42 targets
 *.20bit/24bit tracks
 *.S16_BE Mylene1f4 -> Mylene0fa -> libx1f4i2 -> libxaudio
 *.am I psychotic or am I hearing some weird noises at Fuck Them All start?
 */

#include <config.h>

#include <e1f4.h>
#include <errno.h>
#if __ENABLE_x00696e6b__
# include <math.h>
#endif				/* __ENABLE_x00696e6b__ */
#include <setjmp.h>
#include <stdlib.h>
#include <string.h>

#include <1f44.h>
#include <access.h>
#include <c213.h>
#include <defs.h>
#include <inter.h>
#include <types.h>

#define false(e)			0
#define true(e)				1

#define FAILED_1f42			(Mylene1f4__ERROR + 0x00)

#define S16_CLASS			0
#define S20_CLASS			1
#define S24_CLASS			2

#define __LINE_S16_MODEL__		0
#define __RAIL_S16_MODEL__		1

#define __COPY_S16_MODEL__		2
#define __SLIP_S16_MODEL__		3

#define __HERE_S16_MODEL__		__LINE_S16_MODEL__

#if __HERE_S16_MODEL__ == __RAIL_S16_MODEL__
# if WORDS_BIGENDIAN
#  define __LINK_S16_MODEL__		__COPY_S16_MODEL__
# else
#  define __LINK_S16_MODEL__		__RAIL_S16_MODEL__
# endif				/* WORDS_BIGENDIAN */
#else
# if WORDS_BIGENDIAN
#  define __LINK_S16_MODEL__		__SLIP_S16_MODEL__
# else
#  define __LINK_S16_MODEL__		__LINE_S16_MODEL__
# endif				/* WORDS_BIGENDIAN */
#endif				/* __HERE_S16_MODEL__ == __RAIL_S16_MODEL__ */

#define ____HERE_S16_MODEL__		__HERE_S16_MODEL__
#define ____LINK_S16_MODEL__		__LINK_S16_MODEL__

#if SIZEOF_UNSIGNED_LONG == 8
# define LINE_S16_DOWN			0xff00ff00ff00ff00
# define LINE_S16_LEFT			0x00ff00ff00ff00ff
#else
# define LINE_S16_DOWN			0xff00ff00
# define LINE_S16_LEFT			0x00ff00ff
#endif				/* SIZEOF_UNSIGNED_LONG == 8 */

#if SIZEOF_UNSIGNED_LONG == 8
# define LINE_S16_MASK			7
# define LINE_S16_RANK			3
# define LINE_S16_SIZE			8
#else
# define LINE_S16_MASK			3
# define LINE_S16_RANK			2
# define LINE_S16_SIZE			4
#endif				/* SIZEOF_UNSIGNED_LONG == 8 */

#undef SIZE

#define BUFFER(e1f4) \
    (((struct Mylene1f4_whatever_type *) (e1f4))->buffer)
#define MINIMUM_USEFUL_SIZE(e1f4) \
    (((struct Mylene1f4_whatever_type *) (e1f4))->minimum_useful_size)
#define PRIVATE(e1f4) \
    (((struct Mylene1f4_whatever_type *) (e1f4))->private)
#define SIZE(e1f4) \
    (((struct Mylene1f4_whatever_type *) (e1f4))->size)

#define PRIVATE__(whatever, member) \
    (((struct stream_type *) whatever)->member)
#define PRIVATE_A(whatever, member) \
    PRIVATE__(PRIVATE(whatever), member)

#define Private__(whatever, member) \
    (((struct inter6_type *) PRIVATE_A(whatever, loader))->member)

#define e1f4(what) \
    ((struct Mylene1f4_whatever_type *) (what))

#define Source(source) \
    ((struct source_type *) (source))->_

#define class(audio) \
    (((struct inter6_type *) PRIVATE_A((audio), loader))->class)
#undef class
#define class(audio)			S16_CLASS

#if __ENABLE_x00696e6b__
# define SET_CARDINAL(buffer, base, card) \
    {									      \
	(buffer)[(base) + 0] = (card) >> 030;				      \
	(buffer)[(base) + 1] = (card) >> 020;				      \
	(buffer)[(base) + 2] = (card) >> 010;				      \
	(buffer)[(base) + 3] = (card) >> 000;				      \
    }
#endif				/* __ENABLE_x00696e6b__ */

#if __ENABLE_x00696e6b__
# define SET_CARDiNAL(buffer, base, card) \
    {									      \
	unsigned cardinal;						      \
									      \
	cardinal = card;						      \
	SET_CARDINAL(buffer, base, cardinal);				      \
    }
#endif				/* __ENABLE_x00696e6b__ */

typedef struct audio6_type {
    struct Mylene1f4_whatever_type e1f4;
} audio6_type;

typedef struct inter6_type {
    int (*seek) (void *, unsigned, unsigned, void *, void *);
    struct audio6_type *audio6_data;
    struct socket_type socket;
    void *context, *xepcm1;
} inter6_type;

static int back_lpcm(void *);
static int deck_lpcm(void *, void *);
static int ever_lpcm(void *);
static int fini_epcm(void *, struct inter6_type *);
static int fini_lpcm(void *, unsigned, void **);
static int flow_lpcm(void *, void *);
static int head_lpcm(void *);
static int init_epcm(void *, void *, struct inter6_type *);
static int init_lpcm(void *, unsigned, void **);
static int link_lpcm(void *);
#if __ENABLE_x00696e6b__
static int lock_lpcm(void *, unsigned char *, unsigned);
#endif				/* __ENABLE_x00696e6b__ */
#if __EXPAND_x1f42MAPS__
static int plug_lpcm(void *, void **);
#endif				/* __ENABLE_x00696e6b__ */
static int seek_1f42(void **, void *, void *);
static int seek_lpcm(void *);
static int set_output(void *);
static int skip_lpcm(void *);
static int stat_1f44(void *, const char *);
static int type_lpcm(void *, void *);

static void page_lock(void *, struct inter6_type *);
static void stat_device(void *, void *);
static void stat_failure(void *, int);

static const struct target_type data_target = {
/* *INDENT-OFF* */
    back_lpcm,
    deck_lpcm,
    ever_lpcm,
#if __ENABLE_FAST_INTER__
    NULL,
#endif				/* __ENABLE_FAST_INTER__ */
    fini_lpcm,
    flow_lpcm,
    head_lpcm,
    init_lpcm,
#if __ENABLE_x00696e6b__
    NULL,
#endif				/* __ENABLE_x00696e6b__ */
    link_lpcm,
#if __ENABLE_x00696e6b__
    lock_lpcm,
#endif				/* __ENABLE_x00696e6b__ */
#if __EXPAND_x1f42MAPS__
    plug_lpcm,
#endif				/* __ENABLE_x00696e6b__ */
    seek_lpcm,
    skip_lpcm,
#if !__LINK_CELL_LOADER__
    type_lpcm
#else
    type_lpcm,
    NULL
#endif				/* !__LINK_CELL_LOADER__ */
/* *INDENT-ON* */
};

static int
back_lpcm(void *e1f4_audio)
{
    /*
     * system.data.epcm.linger should be cleared if in use
     */

    return -1;
}


static int
deck_lpcm(void *e1f4_audio, void *deck)
{
    int status;

    {
	status = Private__(e1f4_audio, seek)
	    (e1f4_audio, 0, SIZE(e1f4_audio), deck, NULL);
    }

    return status;
}


static int
ever_lpcm(void *e1f4_audio)
{
    int status;

    if ((status = setjmp(PRIVATE_A(e1f4_audio, env)))) {
	int do_stat = 1;

	if (false(!~PRIVATE_A(e1f4_audio, clip))) {
	} else {
	}
	if (status) {
	    if (do_stat) {
		if (1) {
		    stat_failure(e1f4_audio, status);
		}
	    }

	    status = 1;
	}
    } else {
	void *context;

	context = PRIVATE_A(e1f4_audio, context);

	do {
	    struct inter6_type *inter6_data;

	    inter6_data = PRIVATE_A(e1f4_audio, loader);
	    if (inter6_data->socket.call) {
		if (REFERENCE(context) == inter6_data->socket.page) {
		    page_lock(e1f4_audio, inter6_data);
		}
	    }

#if __HERE_S16_MODEL__ == __RAIL_S16_MODEL__
	    if (SIZE(e1f4_audio) < MINIMUM_USEFUL_SIZE(e1f4_audio)) {
#endif				/* __HERE_S16_MODEL__ == __RAIL_S16_MODEL__ */
		e1f4(e1f4_audio)->correct_underflow(e1f4_audio);
#if __HERE_S16_MODEL__ == __RAIL_S16_MODEL__
	    }
#endif				/* __HERE_S16_MODEL__ == __RAIL_S16_MODEL__ */

#if __HERE_S16_MODEL__ == __RAIL_S16_MODEL__
	    {
		unsigned linear;

		linear = RELEASE(context);

		BUFFER(e1f4_audio) += linear;
		SIZE(e1f4_audio) -= linear;
	    }
#endif				/* __HERE_S16_MODEL__ == __RAIL_S16_MODEL__ */
	} while (0);
    }

    return status;
}


static int
fini_lpcm(void *loader, unsigned index, void **storage)
{
    return 0;
}


static int
fini_epcm(void *context, struct inter6_type *inter6_data)
{
    struct audio6_type *audio6_data;
    struct stream_type *stream_data;

    audio6_data = inter6_data->audio6_data;

    stream_data = audio6_data->e1f4.private;

    Mylene1f4_remove_sequel(context, Mylene1f4_XEPCM1_SEQUEL);

    {
	void *data;

	data = stream_data->data;
	if (data) {
	    free(data);
	}
    }

    if (stream_data->system) {
	Mylene1f4_get_system(&audio6_data->e1f4);
    }

    free(audio6_data);

    return 0;
}


static int
flow_lpcm(void *e1f4_audio, void *flow)
{
    int status;

    {
	lcard_type stream;

	status = Private__(e1f4_audio, seek)
	    (e1f4_audio, 0, SIZE(e1f4_audio), &stream, NULL);
	if (!status) {
	    lcard_type offset, *output;
	    struct source_type *source_data;

	    source_data = PRIVATE_A(e1f4_audio, source);
	    LCARD_SET_CARD2(offset, source_data->_.s2.size);
	    LCARD_SUBTRACT_CARD2(offset, stream);
	    output = flow;
	    LCARD_SET_CARD2(*output, offset);
	}
    }

    return status;
}


static int
head_lpcm(void *e1f4_audio)
{
    return -1;
}


static int
init_epcm(void *context, void *source, struct inter6_type *inter6_data)
{
    struct audio6_type *audio6_data;
    int status;

    if (!(audio6_data = (struct audio6_type *)
	  malloc(sizeof(struct audio6_type)
		 + ALIGN_AMALLOC(sizeof(struct stream_type))
		 + ALIGN_AMALLOC(sizeof(sequel_type))
		 + ALIGN_AMALLOC(sizeof(xepcm1_type))))) {
	Mylene1f4_fprintf_error
	    (context, "%s: %s\n", Mylene1f4(context), strerror(errno));

	status = -1;
    } else {
	struct sequel_type *sequel_data;
	struct stream_type *stream_data;
	struct xepcm1_type *xepcm1_data;
	struct x1f440_type *x1f440_data;

	status = 0;

	stream_data = (struct stream_type *) (audio6_data + 1);
	stream_data = (struct stream_type *) ALIGN_ABUFFER(stream_data);

	sequel_data = (struct sequel_type *) (stream_data + 1);
	sequel_data = (struct sequel_type *) ALIGN_ABUFFER(sequel_data);

	xepcm1_data = (struct xepcm1_type *) (sequel_data + 1);
	xepcm1_data = (struct xepcm1_type *) ALIGN_ABUFFER(xepcm1_data);

	x1f440_data = (struct x1f440_type *) (xepcm1_data + 1);
	x1f440_data = (struct x1f440_type *) ALIGN_ZBUFFER(x1f440_data);

	audio6_data->e1f4.private = stream_data;

	stream_data->context = context;
	stream_data->data = NULL;
	stream_data->loader = inter6_data;
	stream_data->size = 0;
	stream_data->system = NULL;

	{
	    audio6_data->e1f4.buffer = NULL;
	    audio6_data->e1f4.size = 0;
	}

	{
	    struct x1f42a_type *x1f42a_data;

	    x1f42a_data = X1f42(context);
	    if (0) {
	    } else {
		stream_data->audio_id = x1f42a_data->audio_id;

		stream_data->source = source;
		stream_data->e66c = Source(source).s2.e66c;

		{
		    void *e1f4_audio;

		    e1f4_audio = &audio6_data->e1f4;
		    if (1) {
			status = Mylene1f4_fix_system(e1f4_audio, 13818);
		    } else {
		    }
		}
	    }
	}
	if (status) {
	    free(audio6_data);
	} else {
	    {
		inter6_data->socket.call = NULL;
	    }

	    {
		inter6_data->xepcm1 = xepcm1_data;
	    }

	    {
		inter6_data->audio6_data = audio6_data;
	    }

	    sequel_data->sequel_data = SEQUEL(context);
	    SEQUEL(context) = sequel_data;
	    sequel_data->code = Mylene1f4_XEPCM1_SEQUEL;
	    sequel_data->data = xepcm1_data;

	    xepcm1_data->audio_id = stream_data->audio_id;

	    if (0) {
	    } else {
		inter6_data->seek = Mylene1f4_seek_system;
	    }
	}
    }

    return status;
}


static int
init_lpcm(void *loader, unsigned index, void **storage)
{
    struct audio6_type *audio6_data;
    struct inter6_type *inter6_data;
    struct stream_type *stream_data;
    void *context;

    inter6_data = loader;

    audio6_data = inter6_data->audio6_data;

    context = inter6_data->context;

    stream_data = audio6_data->e1f4.private;

    stream_data->clip = ~0;

    HEAD(context) = 0;
    TAIL(context) = ~0;

    *storage = &audio6_data->e1f4;

    return 0;
}


static int
link_lpcm(void *e1f4_audio)
{
    int status;

    if ((status = setjmp(PRIVATE_A(e1f4_audio, env)))) {
	int do_stat = 1;

	if (false(!~PRIVATE_A(e1f4_audio, clip))) {
	} else {
	}
	if (status) {
	    if (do_stat) {
		if (1) {
		    stat_failure(e1f4_audio, status);
		}
	    }

	    status = 1;
	}
    } else {
	void *context;

	context = PRIVATE_A(e1f4_audio, context);

	do {
	    struct inter6_type *inter6_data;
#if ____HERE_S16_MODEL__ == __LINE_S16_MODEL__
	    unsigned char *output;
#endif				/* ____HERE_S16_MODEL__ == __LINE_S16_MOD... */

	    inter6_data = PRIVATE_A(e1f4_audio, loader);
	    if (inter6_data->socket.call) {
		if (REFERENCE(context) == inter6_data->socket.page) {
		    page_lock(e1f4_audio, inter6_data);
		}
	    }

#if ____HERE_S16_MODEL__ == __LINE_S16_MODEL__
	    output = AUDIO(context) + C1f4(context);
#endif				/* ____HERE_S16_MODEL__ == __LINE_S16_MOD... */

#if ____HERE_S16_MODEL__ == __LINE_S16_MODEL__
	    BUFFER(e1f4_audio) = output;
#endif				/* ____HERE_S16_MODEL__ == __LINE_S16_MOD... */

#if ____HERE_S16_MODEL__ == __RAIL_S16_MODEL__
	    if (SIZE(e1f4_audio) < MINIMUM_USEFUL_SIZE(e1f4_audio)) {
#endif				/* ____HERE_S16_MODEL__ == __RAIL_S16_MOD... */
		e1f4(e1f4_audio)->correct_underflow(e1f4_audio);
#if ____HERE_S16_MODEL__ == __RAIL_S16_MODEL__
	    }
#endif				/* ____HERE_S16_MODEL__ == __RAIL_S16_MOD... */

	    {
#if ____LINK_S16_MODEL__ == __RAIL_S16_MODEL__
		unsigned i;
#elif __LINK_S16_MODEL__ == __LINE_S16_MODEL__
		unsigned i;
#endif				/* ____LINK_S16_MODEL__ == __RAIL_S16_MOD... */
		unsigned linear;
#if ____HERE_S16_MODEL__ == __RAIL_S16_MODEL__
		unsigned char *output, *stream;
#endif				/* ____HERE_S16_MODEL__ == __RAIL_S16_MOD... */

#if ____HERE_S16_MODEL__ == __RAIL_S16_MODEL__
		output = AUDIO(context) + C1f4(context);
		stream = BUFFER(e1f4_audio);
#endif				/* ____HERE_S16_MODEL__ == __RAIL_S16_MOD... */

		linear = RELEASE(context);

		SIZE(e1f4_audio) -= linear;

#if ____LINK_S16_MODEL__ == __RAIL_S16_MODEL__
		linear >>= 1;
#elif __LINK_S16_MODEL__ == __LINE_S16_MODEL__
		linear >>= 1;
#endif				/* ____LINK_S16_MODEL__ == __RAIL_S16_MOD... */

#if ____LINK_S16_MODEL__ == __RAIL_S16_MODEL__
		i = linear >> 2;
#endif				/* ____LINK_S16_MODEL__ == __RAIL_S16_MOD... */

#if ____LINK_S16_MODEL__ == __COPY_S16_MODEL__
		memcpy(output, stream, linear);
		stream += linear;
#elif __LINK_S16_MODEL__ == __LINE_S16_MODEL__
# define LINE_S_DOWN			LINE_S16_DOWN
# define LINE_S_LEFT			LINE_S16_LEFT

		if ((integral_q) output & 1) {
		    i = linear >> 2;
		    for (; i; i--) {
			unsigned char output_1_;

			output_1_ = output[0];
			output[0] = output[1];
			output[1] = output_1_;
			output += 2;
			output_1_ = output[0];
			output[0] = output[1];
			output[1] = output_1_;
			output += 2;
			output_1_ = output[0];
			output[0] = output[1];
			output[1] = output_1_;
			output += 2;
			output_1_ = output[0];
			output[0] = output[1];
			output[1] = output_1_;
			output += 2;
		    }
		    i = linear & 3;
		    for (; i; i--) {
			unsigned char output_1_;

			output_1_ = output[0];
			output[0] = output[1];
			output[1] = output_1_;
			output += 2;
		    }
		} else {
		    unsigned long *v;

		    i = (LINE_S16_SIZE - ((integral_q) output & LINE_S16_MASK))
			& LINE_S16_MASK;
		    i >>= 1;
		    linear -= i;
		    for (; i; i--) {
			unsigned char output_1_;

			output_1_ = output[0];
			output[0] = output[1];
			output[1] = output_1_;
			output += 2;
		    }
		    v = (unsigned long *) output;
		    i = linear >> (LINE_S16_RANK - 1 + 2);
		    for (; i; i--) {
			unsigned long c;

			c = *v;
			*v++ = (c & LINE_S_DOWN) >> 8 | (c & LINE_S_LEFT) << 8;
			c = *v;
			*v++ = (c & LINE_S_DOWN) >> 8 | (c & LINE_S_LEFT) << 8;
			c = *v;
			*v++ = (c & LINE_S_DOWN) >> 8 | (c & LINE_S_LEFT) << 8;
			c = *v;
			*v++ = (c & LINE_S_DOWN) >> 8 | (c & LINE_S_LEFT) << 8;
		    }
		    i = linear >> (LINE_S16_RANK - 1) & 3;
		    for (; i; i--) {
			unsigned long c;

			c = *v;
			*v++ = (c & LINE_S_DOWN) >> 8 | (c & LINE_S_LEFT) << 8;
		    }
		    output = (unsigned char *) v;
		    i = linear & (LINE_S16_MASK >> 1);
		    for (; i; i--) {
			unsigned char output_1_;

			output_1_ = output[0];
			output[0] = output[1];
			output[1] = output_1_;
			output += 2;
		    }
		}

# undef LINE_S_DOWN
# undef LINE_S_LEFT
#elif __LINK_S16_MODEL__ == __RAIL_S16_MODEL__
		if (1) {
		    for (; i; i--) {
			*output++ = stream[1];
			*output++ = stream[0];
			stream += 2;
			*output++ = stream[1];
			*output++ = stream[0];
			stream += 2;
			*output++ = stream[1];
			*output++ = stream[0];
			stream += 2;
			*output++ = stream[1];
			*output++ = stream[0];
			stream += 2;
		    }
		    i = linear & 3;
		    for (; i; i--) {
			*output++ = stream[1];
			*output++ = stream[0];
			stream += 2;
		    }
		}
#else
#endif				/* ____LINK_S16_MODEL__ == __COPY_S16_MOD... */

#if ____HERE_S16_MODEL__ == __RAIL_S16_MODEL__
		BUFFER(e1f4_audio) = stream;
#endif				/* ____HERE_S16_MODEL__ == __RAIL_S16_MOD... */
	    }
	} while (0);
    }

    return status;
}


#if __ENABLE_x00696e6b__
static int
lock_lpcm(void *context, unsigned char *buffer, unsigned reference)
{
    double fractional, integral;
    struct sequel_type *sequel_data;
    struct xepcm1_type *xepcm1_data;

    Mylene1f4_find_sequel
	(context, Mylene1f4_XEPCM1_SEQUEL, (void *) &sequel_data);
    xepcm1_data = sequel_data->data;
    fractional = modf
	((double) reference * xepcm1_data->frame_rate_d
	 / xepcm1_data->frame_rate_n, &integral);
    SET_CARDiNAL(buffer, 0, (unsigned) integral);
    SET_CARDiNAL(buffer, 4, (unsigned) (fractional * 1000000));

    return 0;
}
#endif				/* __ENABLE_x00696e6b__ */


#if __EXPAND_x1f42MAPS__
static int
plug_lpcm(void *loader, void **socket)
{
    struct inter6_type *inter6_data;

    inter6_data = loader;

    *socket = &inter6_data->socket;

    return 0;
}
#endif				/* __ENABLE_x00696e6b__ */


static int
seek_1f42(void **loader, void *source, void *e1f4_audio)
{
    int status = 0;
    void **glass;

    glass = *loader;
    if (true(glass)) {
	struct device_type *device_data;

	device_data = glass[1];
	if (true(device_data)) {
	    int (*seek) (void *, void *, unsigned, void *);

	    seek = device_data->seek;
	    if (true(seek)) {
#define level				1

		lcard_type cleavage[1];

		status = seek(glass[0], source, level, cleavage);
		if (!status) {
		    if (level) {
			Mylene1f4_set_system(e1f4_audio, cleavage);
		    }
		}

#undef level
	    }
	}
    }

    return status;
}


static int
seek_lpcm(void *e1f4_audio)
{
    if (class(e1f4_audio) == S16_CLASS) {
#if __HERE_S16_MODEL__ == __LINE_S16_MODEL__
	Mylene1f4_line_system(e1f4_audio);
#endif				/* __HERE_S16_MODEL__ == __LINE_S16_MODEL__ */
    }

    return 0;
}


static int
set_output(void *e1f4_audio)
{
    int status;

    if ((status = setjmp(PRIVATE_A(e1f4_audio, env)))) {
	if (status == Mylene1f4_NEAR_FAILURE) {
	    status = FAILED_1f42;
	}

	stat_failure(e1f4_audio, status);

	status = 1;
    } else {
	unsigned header, sampling_frequency;

	Mylene1f4_near_system(e1f4_audio);

	Mylene1f4_head_system(e1f4_audio, &header);

	switch ((header >> 4) & 3) {
	case 0:
	    sampling_frequency = 48000;
	    break;
	case 1:
	    sampling_frequency = 96000;
	    break;
	case 2:
	    sampling_frequency = 44100;
	    break;
	default:
	    sampling_frequency = 32000;
	}

	switch ((header >> 6) & 3) {
	case 0:
	    break;
	default:
	    longjmp(PRIVATE_A(e1f4_audio, env), FAILED_1f42);
	}

	switch (header & 7) {
	case 1:
	    break;
	default:
	    longjmp(PRIVATE_A(e1f4_audio, env), FAILED_1f42);
	}

	{
	    struct x1f42a_type *x1f42a_data;
	    void *context;

	    context = PRIVATE_A(e1f4_audio, context);

	    x1f42a_data = X1f42(context);

	    {
		SAMPLING(context) = sampling_frequency;
		CHANNELS(context) = 2;
	    }

	    {
		unsigned release_size;

		release_size = sampling_frequency * x1f42a_data->frame_rate_d;
		if (release_size % x1f42a_data->frame_rate_n) {
		    longjmp(PRIVATE_A(e1f4_audio, env), FAILED_1f42);
		} else {
		    release_size /= x1f42a_data->frame_rate_n;
		    release_size <<= 2;
		}

		RELEASE(context) = release_size;

		if (1) {
		    Mylene1f4_clear_system(e1f4_audio);
		}

		if (class(e1f4_audio) == S16_CLASS) {
#if __HERE_S16_MODEL__ == __LINE_S16_MODEL__
		    Mylene1f4_line_system(e1f4_audio);
#else
		    Mylene1f4_rail_system(e1f4_audio);
#endif				/* __HERE_S16_MODEL__ == __LINE_S16_MODEL__ */

#if __HERE_S16_MODEL__ == __LINE_S16_MODEL__
		    Mylene1f4_reset_system(e1f4_audio);
#endif				/* __HERE_S16_MODEL__ == __LINE_S16_MODEL__ */
		}

		if (1) {
		    MINIMUM_USEFUL_SIZE(e1f4_audio) = release_size;
		}
	    }

	    {
		struct sequel_type *sequel_data;
		struct xepcm1_type *xepcm1_data;

		Mylene1f4_find_sequel
		    (context, Mylene1f4_XEPCM1_SEQUEL, (void *) &sequel_data);
		xepcm1_data = sequel_data->data;
		xepcm1_data->frame_rate_d = x1f42a_data->frame_rate_d;
		xepcm1_data->frame_rate_n = x1f42a_data->frame_rate_n;
	    }
	}
    }

    return status;
}


static int
skip_lpcm(void *e1f4_audio)
{
    if (class(e1f4_audio) == S16_CLASS) {
#if __HERE_S16_MODEL__ == __LINE_S16_MODEL__
	Mylene1f4_flat_system(e1f4_audio);
#endif				/* __HERE_S16_MODEL__ == __LINE_S16_MODEL__ */
    }

    return 0;
}


static int
stat_1f44(void *context, const char *none)
{
    Mylene1f4_fprintf_error(context, "%s", none);

    return 0;
}


static int
type_lpcm(void *loader, void *target)
{
    struct target_type *target_data;

    target_data = target;
    *target_data = data_target;

    return 0;
}


static void
page_lock(void *e1f4_audio, struct inter6_type *inter6_data)
{
    lcard_type stream, system;

    if (Private__(e1f4_audio, seek)
	(e1f4_audio, 0, SIZE(e1f4_audio), &stream, &system)) {
	/*
	 * stupid, but I'll ignore the seek errors...
	 *
	 * ... and that's perhaps less than smart especially considering that
	 * the internal (re)mapper that commanded the seek information should
	 * probably be informed 'bout seek failure.
	 *
	 * FEATURES
	 */
    } else {
	inter6_data->socket.call
	    (inter6_data->socket.back, 0, &stream, &system);
    }
}


static void
stat_device(void *e1f4_audio, void *context)
{
    lcard_type offset;

    Mylene1f4_fprintf_error(context, " in ");
    Mylene1f4_stat_source(context);
    if (!flow_lpcm(e1f4_audio, &offset)) {
	Mylene1f4_fprintf_error(context, " at ");
	Mylene1f4_fprintf_offset(context, &offset);
    }
}


static void
stat_failure(void *e1f4_audio, int error)
{
    void *context;

    context = PRIVATE_A(e1f4_audio, context);

    Mylene1f4_fprintf_error(context, "%s: ", Mylene1f4(context));
    if (error == FAILED_1f42) {
	Mylene1f4_fprintf_error(context, "bad ");
	Mylene1f4_stat_source(context);
	Mylene1f4_fprintf_error(context, " 1f42 stream map\n");
    } else if (error == Mylene1f4_ADVANCE_FAILURE) {
	Mylene1f4_fprintf_error(context, "bad ");
	Mylene1f4_stat_source(context);
	Mylene1f4_fprintf_error
	    (context, " 1f42 stream map packet access frame record\n");
    } else if (error == Mylene1f4_CHANGED_HEADER) {
	Mylene1f4_fprintf_error(context, "the track packet header in ");
	Mylene1f4_stat_source(context);
	Mylene1f4_fprintf_error
	    (context, " changed beyond my abilities to reset audio output\n");
    } else if (error == Mylene1f4_MALLOC_FAILURE) {
	Mylene1f4_fprintf_error(context, "%s\n", strerror(errno));
    } else if (error == Mylene1f4_SYSTEM_FAILURE) {
	Mylene1f4_fprintf_error(context, "system parse error");
	stat_device(e1f4_audio, context);
	Mylene1f4_stat_system(e1f4_audio, context);
	Mylene1f4_fprintf_error(context, "\n");
    } else if (error == Mylene1f4_UNEXPECTED_EOF) {
	Mylene1f4_fprintf_error(context, "unexpected EOF");
	stat_device(e1f4_audio, context);
	Mylene1f4_fprintf_error(context, "\n");
    } else if (error == Mylene1f4_UNEXPECTED_EOS) {
	Mylene1f4_fprintf_error(context, "unexpected EOS");
	stat_device(e1f4_audio, context);
	Mylene1f4_fprintf_error(context, "\n");
    } else if (error == Mylene1f4_UNEXPECTED_LENGTH) {
	Mylene1f4_fprintf_error(context, "unexpected packet length");
	stat_device(e1f4_audio, context);
	Mylene1f4_fprintf_error(context, "\n");
    } else if (error == Mylene1f4_e66c_ERROR) {
	seek_1f44_stat
	    (PRIVATE_A(e1f4_audio, e66c), SOURCE(context)._.s1.path, context,
	     stat_1f44);
	Mylene1f4_fprintf_error(context, "\n");
    }
}


int
Mylene1f4_clip_lpcm(void *loader, unsigned clip)
{
    struct audio6_type *audio6_data;
    struct inter6_type *inter6_data;

    inter6_data = loader;

    audio6_data = inter6_data->audio6_data;

    ((struct stream_type *) audio6_data->e1f4.private)->clip = clip;

    return 0;
}


int
Mylene1f4_copy_lpcm(void *context, void *target)
{
    struct target_type *target_data;

    target_data = target;
    *target_data = data_target;

    return 0;
}


int
Mylene1f4_dump_lpcm(void *context, void *source, unsigned *count,
		    void **loader)
{
    int status;
    struct inter6_type *inter6_data;

    inter6_data = *loader;
    status = fini_epcm(context, inter6_data);
    free(inter6_data);

    return status;
}


int
Mylene1f4_load_lpcm(void *context, void *source, unsigned *count,
		    void **loader)
{
    int status;
    struct inter6_type *inter6_data;

    inter6_data = (struct inter6_type *) malloc(sizeof(struct inter6_type));
    if (!inter6_data) {
	Mylene1f4_fprintf_error
	    (context, "%s: %s\n", Mylene1f4(context), strerror(errno));

	status = -1;
    } else {
	status = init_epcm(context, source, inter6_data);
	if (status) {
	    free(inter6_data);
	} else {
	    void *e1f4_audio;

	    e1f4_audio = &inter6_data->audio6_data->e1f4;

	    if (1) {
		status = seek_1f42(loader, source, e1f4_audio);
	    }
	    if (!status) {
		do {
		    status = set_output(e1f4_audio);
		    if (!status) {
			status = seek_1f42(loader, source, e1f4_audio);
		    }
		} while (0);
	    }
	    if (status) {
		fini_epcm(context, inter6_data);
		free(inter6_data);
	    } else {
		*count = 1;
		*loader = inter6_data;

		inter6_data->context = context;
	    }
	}
    }

    return status;
}


int
Mylene1f4_node_lpcm(void *context, const void **address)
{
    *address = &data_target;

    return 0;
}


int
Mylene1f4_type_lpcm(void *loader, void *target)
{
    return type_lpcm(loader, target);
}
