/*
 * misca.c
 * Copyright (C) 2007-2012, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#if __ENABLE_EQUEUE__
# include <aime.h>
# include <stddef.h>
# include <stdio.h>
# include <stdlib.h>
# include <string.h>
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# include <aime1.h>
# include <inter.h>
# include <types.h>
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define M500_L7_DECK			Mylene1f4_L7_DECK
# define M500_L7_LIST			Mylene1f4_L7_LIST
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
# define __USE_x1f4_print_htfunction__	1
#endif				/* __ENABLE_EQUEUE__ */

#if __ENABLE_EQUEUE__
int
Mylene1f4_list_sets(void *null_context, const void *sets, unsigned count)
{
    int status;
    const struct x1f4_function_type **list;

    list = (const struct x1f4_function_type **)
	malloc(sizeof(const struct x1f4_function_type *) * count);
    if (!list) {
	status = -1;
    } else {
# if !__USE_x1f4_print_htfunction__
	struct x1f4_function_type pair[2];
# endif				/* !__USE_x1f4_print_htfunction__ */

	status = 0;

# if !__USE_x1f4_print_htfunction__
	pair[1].name = NULL;
# endif				/* !__USE_x1f4_print_htfunction__ */

	memcpy(list, sets, sizeof(const struct x1f4_function_type *) * count);

	while (1) {
	    const char *ceil = NULL;
	    const struct x1f4_function_type **pick = NULL;
	    unsigned i, miss = 0;

	    i = count;
	    while (i) {
		const char *name;
		const struct x1f4_function_type *function_data;

		i--;

		function_data = *list;

		name = function_data->name;
		if (!name) {
		    memmove(list, list + 1,
			    sizeof(const struct x1f4_function_type *) * i);

		    count--;
		} else {
		    unsigned size;

		    size = strlen(name);

		    if (!ceil) {
			ceil = name;
			miss = size;
			pick = list;
		    } else {
			int diff;

			diff = memcmp(name, ceil, miss < size ? miss : size);
			if (diff < 0) {
			    ceil = name;
			    miss = size;
			    pick = list;
			} else {
			    if (!diff) {
				if (miss < size) {
				    ceil = name;
				    miss = size;
				    pick = list;
				}
			    }
			}
		    }

		    list++;
		}
	    }

	    if (!count) {
		break;
	    } else {
		const struct x1f4_function_type *function_data;

		list -= count;

		function_data = *pick;

		*pick = function_data + 1;

# if !__USE_x1f4_print_htfunction__
		pair[0] = *function_data;
# endif				/* !__USE_x1f4_print_htfunction__ */

# if !__USE_x1f4_print_htfunction__
		x1f4_print_htfunctions
		    (stdout, pair, "    ", NULL, Mylene1f4_look_aime);
# else
		x1f4_print_htfunction
		    (stdout, function_data, "    ", NULL, Mylene1f4_look_aime);
# endif				/* !__USE_x1f4_print_htfunction__ */
	    }
	}

	free(list);
    }

    return status;
}
#endif				/* __ENABLE_EQUEUE__ */


#if __ENABLE_EQUEUE__
int
Mylene1f4_look_aime(const void *none, int type, const char **name,
		    unsigned *size)
{
    int delete = 0;

    switch (type) {
    case M500_L7_DECK:
	*name = "Deck";
	*size = 4;
	break;
    default:
	delete = 1;
    }

    return delete;
}
#endif				/* __ENABLE_EQUEUE__ */
