/*
 * miscr.c
 * Copyright (C) 2007-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#if defined HAVE_LIBLEWD
# include <lewd.h>
#endif				/* HAVE_LIBLEWD */
#include <stddef.h>

#include <access.h>
#include <inter.h>
#if !defined HAVE_LIBLEWD
# include <real.h>
#endif				/* !HAVE_LIBLEWD */

int
Mylene1f4_parse_real(void *context, const char *text,
		     const char *specification, double *c_real)
{
    double real;
    int status;

    status = x1f4_parse_real(&real, specification, NULL);
    if (status) {
	Mylene1f4_fprintf_error
	    (context, "%s: cannot parse %s specification: `%s'\n",
	     Mylene1f4(context), text, specification);
    } else {
	*c_real = real;
    }

    return status;
}
