/*
 * mpeg.h
 * Copyright (C) 2004-2007, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __Mylene1f4_MPEG_H__
#define __Mylene1f4_MPEG_H__

#include <lcard.h>

/*
 * if record order is set to the base-2 logarithm of any power of 2 greater or
 * equal to the audio maximum minimum useful size setting offset in a system
 * embedded audio stream can be guaranteed.  yet, since setting offset in a
 * system embedded audio stream can fail a more efficient approach can be taken
 */
#define RECORD_ORDER			5

#define RECORD_MASK			((unsigned) (RECORD_SIZE - 1))
#define RECORD_SIZE			((unsigned) (1 << RECORD_ORDER))

typedef struct packet_type {
    lcard_type file_offset;
    unsigned data_size, header_length;
} packet_type;

#endif				/* __Mylene1f4_MPEG_H__ */
