/*
 * near.c
 * Copyright (C) 2005-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#include <access.h>
#include <defs.h>
#if __ENABLE_EQUEUE_SERVER__
# include <excess4.h>
# include <excess7.h>
#endif				/* __ENABLE_EQUEUE_SERVER__ */
#include <inter.h>

#if __ENABLE_EQUEUE_SERVER__
# define Frame4(context) \
    ((struct frame4_type *) &Frame7((context))->_1.frame4)
# define Frame7(context) \
    ((struct frame7_type *) WINDOW((context)).server.window)
#endif				/* __ENABLE_EQUEUE_SERVER__ */

#if __ENABLE_EQUEUE_SERVER__
int
Mylene1f4_near_call(void *context)
{
    Mylene1f4_fprintf_error
	(context, "%s: will not add program", Mylene1f4(context));
    if (Frame4(context)->dana.name) {
	Mylene1f4_fprintf_error(context, " `%s'", Frame4(context)->dana.name);
    }
    Mylene1f4_fprintf_error
	(context, " in the execution queue for the limit of queue length (%u"
	 ") has been reached\n", WINDOW(context).server.queue_length);

    return 0;
}
#endif				/* __ENABLE_EQUEUE_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
int
Mylene1f4_near_flat(void *context, char *data, unsigned class)
{
    if (WINDOW(context).server.setup & Mylene1f4_FUSSY_OUTPUT) {
	Mylene1f4_fprintf_error
	    (context, "%s: cannot parse progress%d specification: `%s'\n",
	     Mylene1f4(context), class & 3, data);
    }

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_EQUEUE_SERVER__
int
Mylene1f4_near_list(void *context, unsigned slip)
{
    Mylene1f4_fprintf_error
	(context, "%s: will not add program", Mylene1f4(context));
    if (Frame4(context)->dana.name) {
	Mylene1f4_fprintf_error(context, " `%s'", Frame4(context)->dana.name);
    }
    Mylene1f4_fprintf_error(context, " in the play ");
    if (slip == 0x5c) {
	Mylene1f4_fprintf_error(context, "start");
    } else {
	Mylene1f4_fprintf_error(context, "finish");
    }
    Mylene1f4_fprintf_error
	(context, " execution list for the limit of list length (%u) has bee"
	 "n reached\n", WINDOW(context).server.context_length);

    return 0;
}
#endif				/* __ENABLE_EQUEUE_SERVER__ */


#if __ENABLE_EQUEUE_SERVER__
int
Mylene1f4_near_moon(void *context)
{
    Mylene1f4_fprintf_error
	(context, "%s: will not allocate memory for program",
	 Mylene1f4(context));
# if 0
    /*
     * this will work for execution queue programs only
     */
    if (Frame4(context)->dana.this) {
	Mylene1f4_fprintf_error(context, " `%s'", Frame4(context)->dana.this);
    }
# endif				/* 0 */
    Mylene1f4_fprintf_error
	(context, " for the memory allocation limit for programs (%u) has be"
	 "en reached\n", WINDOW(context).server.equeue_size);

    return 0;
}
#endif				/* __ENABLE_EQUEUE_SERVER__ */


#if __ENABLE_EQUEUE_SERVER__
int
Mylene1f4_near_post(void *context, unsigned post, unsigned sign, unsigned tail)
{
    Mylene1f4_fprintf_error
	(context, "%s: out of limits (%d .. %d) insertion request (%d)\n",
	 Mylene1f4(context), -(int) tail - 1, tail,
	 sign ? -(int) post : (int) post);

    return 0;
}
#endif				/* __ENABLE_EQUEUE_SERVER__ */


#if __ENABLE_EDIT_SERVER__
int
Mylene1f4_near_seek(void *context, unsigned size, char *data)
{
    Mylene1f4_fprintf_error
	(context, "%s: will not add file `%.*s' in the play list for the lim"
	 "it of play list length (%u) has been reached\n", Mylene1f4(context),
	 (int) size, data, WINDOW(context).server.list_length);

    return 0;
}
#endif				/* __ENABLE_EDIT_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
int
Mylene1f4_near_side(void *context, unsigned size)
{
    Mylene1f4_fprintf_error
	(context, "%s: will shut down client for request size (%u) exceeds t"
	 "ransfer limit (%u)\n", Mylene1f4(context), size,
	 WINDOW(context).server.transfer);

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */


#if __ENABLE_CONTROLLING_SERVER__
int
Mylene1f4_near_slip(void *context, char *data)
{
    if (WINDOW(context).server.setup & Mylene1f4_FUSSY_FORMAT) {
	Mylene1f4_fprintf_error
	    (context, "%s: cannot parse format specification: `%s'\n",
	     Mylene1f4(context), data);
    }

    return 0;
}
#endif				/* __ENABLE_CONTROLLING_SERVER__ */
