/*
 * output.c
 * Copyright (C) 2005-2007, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <access.h>
#include <inter.h>

int
Mylene1f4_clear_output(void *context)
{
    return Mylene1f4_clear_format(context);
}


int
Mylene1f4_fini_output(void *context)
{
    if (PROGRESS3(context)) {
	Mylene1f4_fini_format(context, &PROGRESS3(context));
    }
    if (PROGRESS2(context)) {
	Mylene1f4_fini_format(context, &PROGRESS2(context));
    }
    if (PROGRESS1(context)) {
	Mylene1f4_fini_format(context, &PROGRESS1(context));
    }

    return 0;
}


int
Mylene1f4_init_output(void *context, const char *progress1_specs,
		      const char *progress2_specs, const char *progress3_specs)
{
    int status = 0;

    do {
	if (progress1_specs) {
	    status = Mylene1f4_aime_format
		(context, "progress1", progress1_specs, &PROGRESS1(context));
	    if (status) {
		break;
	    }
	}

	if (progress2_specs) {
	    status = Mylene1f4_aime_format
		(context, "progress2", progress2_specs, &PROGRESS2(context));
	    if (status) {
		break;
	    }
	}

	if (progress3_specs) {
	    status = Mylene1f4_aime_format
		(context, "progress3", progress3_specs, &PROGRESS3(context));
	    if (status) {
		break;
	    }
	}
    } while (0);

    if (status) {
	Mylene1f4_fini_output(context);
    }

    return status;
}


int
Mylene1f4_setup_output(void *context)
{
    return Mylene1f4_setup_format(context);
}
