/*
 * stripe.c
 * Copyright (C) 2003-2008, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e1f4.h>
#include <setjmp.h>

#include <defs.h>
#include <types.h>

#define PRIVATE(e1f4) \
    (((struct Mylene1f4_whatever_type *) (e1f4))->private)

#define PRIVATE__(whatever, member) \
    (((struct stream_type *) whatever)->member)
#define PRIVATE_A(whatever, member) \
    PRIVATE__(PRIVATE(whatever), member)

int
Mylene1f4_rack_stripe(void *stream, int read, unsigned size)
{
    if (read == -1) {
	longjmp(PRIVATE_A(stream, env), Mylene1f4_e66c_ERROR);
    } else if (read != (int) size) {
	longjmp(PRIVATE_A(stream, env), Mylene1f4_UNEXPECTED_EOF);
    }

    return -1;
}
