/*
 * system.h
 * Copyright (C) 2003-2008, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __Mylene1f4_SYSTEM_H__
#define __Mylene1f4_SYSTEM_H__

/*
 * TODO
 *
 *.get storage out of system_type definition
 */

#include <h262.h>

#include <1f44.h>
#include <lcard.h>
#include <mpeg.h>

typedef struct system_type {
    lcard_type advance;
    struct packet_type *packet_data;
    struct seek_1f44_type *e66c;
    union {
	struct {
	    unsigned header, linger;
	} epcm;
    } data;
    unsigned excess, offset, packet_data_size, packet_index, storage[256];
    void (*pack_header) (seek_h262_system_type),
	(*packet) (seek_h262_system_type), *stream;
} system_type;

#endif				/* __Mylene1f4_SYSTEM_H__ */
