/*
 * tables.c
 * Copyright (C) 2003-2004, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e1f4.h>
#include <math.h>

extern Mylene1f4_real III_break_0[], III_break_1[];

void
III_init_tables(void)
{
    int i = 0;

    for (; i < 8207; i++) {
	III_break_0[i] = pow(i, (double) 4 / 3);
    }
    for (i = -256; i < 122; i++) {
	III_break_1[i + 256] =
	    pow((double) 2.0, -0.25 * (double) (i + 210));
    }
}
