/*
 * violet.c
 * Copyright (C) 2005-2008, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#if __WAIT_VIOLET__

#include <sys/types.h>
#include <sys/wait.h>

#include <access.h>

int
Mylene1f4_deque_violet(void *context, void *violet)
{
    struct violet_type *miss_violet;

    miss_violet = VIOLET(context);
    if (miss_violet == violet) {
	VIOLET(context) = miss_violet->violet_data;
    } else {
	struct violet_type *here_violet;

	here_violet = miss_violet->violet_data;
	while (here_violet) {
	    if (here_violet == violet) {
		miss_violet->violet_data = here_violet->violet_data;
		break;
	    } else {
		miss_violet = here_violet;
		here_violet = here_violet->violet_data;
	    }
	}
    }

    return 0;
}


int
Mylene1f4_merge_violet(void *context, void *fix, int record)
{
    int status = 0;
    pid_t clip;

    clip = *(pid_t *) fix;
    if (0 < clip) {
	struct violet_type *violet_data;

	violet_data = VIOLET(context);
	while (violet_data) {
	    if (violet_data->wait == clip) {
		status = violet_data->clip(violet_data->data, record);
		break;
	    } else {
		violet_data = violet_data->violet_data;
	    }
	}
    }

    return status;
}


int
Mylene1f4_queue_violet(void *context, void *violet)
{
    ((struct violet_type *) violet)->violet_data = VIOLET(context);

    VIOLET(context) = violet;

    return 0;
}

#endif				/* __WAIT_VIOLET__ */
