/*
 * wait.c
 * Copyright (C) 2005-2007, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#include <access.h>

int
Mylene1f4_miss_wait(void *context, unsigned count, unsigned *wait_l)
{
# if SIZEOF_UNSIGNED_LONG == 8
    unsigned long wait;

    wait = RELEASE(context) * count;
    wait *= 1000000;
    wait /= (SAMPLING(context) * CHANNELS(context) << 1);
# else
    double wait;

    wait = RELEASE(context) * count;
    wait /= (SAMPLING(context) * CHANNELS(context) << 1);
    wait *= 1000000;
# endif					/* SIZEOF_UNSIGNED_LONG == 8 */
    {
	unsigned wait_d;

	wait_d = wait;
	if (131072 < wait_d) {
	    wait_d = 131072;
	}

	*wait_l = wait_d;
    }

    return 0;
}
