/*
 * access.h
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __Mylene200_ACCESS_H__
#define __Mylene200_ACCESS_H__

#include <config.h>

#include <state.h>

#define ATTEMPTS(context)		ACCESS((context), attempts)
#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
# define BREAK6(context)		ACCESS((context), head_thread)
# define BREAK7(context)		ACCESS((context), tail_thread)
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */
#define CLASS9(context)			ACCESS((context), last_window)
#define CLIENT(context)			ACCESS((context), client_data)
#define DATA(context)			ACCESS((context), data)
#define E1f4(context)			ACCESS((context), e1f4_id)
#define E200(context)			ACCESS((context), e200_id)
#define EPRINTF(context)		ACCESS((context), printf_error)
#define FLAGS(context)			ACCESS((context), flags)
#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
# define JUDITH(context)		ACCESS((context), miss_thread)
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */
#define MISS(context)			ACCESS((context), miss)
#define MODE(context)			ACCESS((context), mode)
#define Mylene200(context)		ACCESS((context), Mylene200)
#define NASSA5(context)			ACCESS((context), last_client)
#define NFDS(context)			ACCESS((context), nfds)
#if __NONBLOCKING_REFLEX_TRANSFER__
# define READ(context)			ACCESS((context), read)
#endif				/* __NONBLOCKING_REFLEX_TRANSFER__ */
#define RECORD(context)			ACCESS((context), record_data)
#define REFLEX(context)			ACCESS((context), reflex)
#if __NONBLOCKING_REFLEX_TRANSFER__
# define SEND(context)			ACCESS((context), send)
#endif				/* __NONBLOCKING_REFLEX_TRANSFER__ */
#define SERVER(context)			ACCESS((context), server)
#define SET_0(context)			ACCESS((context), set_0)
#define SET_1(context)			ACCESS((context), set_1)
#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
# define SHREWS(context)		ACCESS((context), shrews)
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */
#define STOYA6(context)			ACCESS((context), last_stripe)
#define STOYA7(context)			ACCESS((context), swap_stripe)
#define STRIPE(context)			ACCESS((context), stripe_data)
#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
# define THREAD(context)		ACCESS((context), thread_data)
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */
#define TIMEOUT(context)		ACCESS((context), timeout)
#define WINDOW(context)			ACCESS((context), window_data)

#define ACCESS(context, member)		(CONTEXT(context)->member)

#define CONTEXT(context)		((struct context_state *) (context))

#endif				/* __Mylene200_ACCESS_H__ */
