/*
 * config.h
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __Mylene200_CONFIG_H__
#define __Mylene200_CONFIG_H__

#include <autoconfig.h>

#define __USE_SHUTDOWN__		1

#define __NONBLOCKING_CLIENT_TRANSFER__	1

#define __NONBLOCKING_REFLEX_TRANSFER__	1

#define __DOUBLE_SELECT__		0
#define __SINGLE_SELECT__		1

#define __REFLEX_SELECT__		__DOUBLE_SELECT__

#define __ENABLE_DEBUG__		0

#if !__ENABLE_DEBUG__
# define __ENABLE_CHANNEL_DEBUG__	0
#elif __REFLEX_SELECT__ != __DOUBLE_SELECT__
# define __ENABLE_CHANNEL_DEBUG__	0
#else
# define __ENABLE_CHANNEL_DEBUG__	1
#endif				/* !__ENABLE_DEBUG__ */

#define MIRROR_SIZE			3072

#define STRIPE_SIZE			3072

#endif				/* __Mylene200_CONFIG_H__ */
