/*
 * defs.h
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __Mylene200_DEFS_H__
#define __Mylene200_DEFS_H__

#include <config.h>

/*
 * client flag definitions
 */
#if __NONBLOCKING_CLIENT_TRANSFER__
# define Mylene200_LOCK_CLIENT		(1L << 0x0)
#endif				/* __NONBLOCKING_CLIENT_TRANSFER__ */
#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
# define Mylene200_MIND_CLIENT		(1L << 0x1)
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */

/*
 * flag definitions (Mylene1f4 server definitions)
 */
#define Mylene200_e1f4_INET		(1L << 0x0)
#define Mylene200_e1f4_UNIX		(1L << 0x1)

/*
 * flag definitions (continued, Mylene200 server definitions)
 */
#define Mylene200_e200_INET		(1L << 0x2)
#define Mylene200_e200_UNIX		(1L << 0x3)

/*
 * flag definitions (continued, ...)
 */
#define Mylene200_REUSE_RECORD		(1L << 0x4)

/*
 * flag definitions (continued, ...)
 */
#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
# define Mylene200_MISS_SHREWS		(1L << 0x5)
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */

/*
 * flag definitions (concluded, Mylene1f4 server transfer definitions)
 */
#if __NONBLOCKING_REFLEX_TRANSFER__
# define Mylene200_LOCK_REFLEX		(1L << 0x6)
#endif				/* __NONBLOCKING_REFLEX_TRANSFER__ */

#endif				/* __Mylene200_DEFS_H__ */
