/*
 * inter.h
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __Mylene200_INTER_H__
#define __Mylene200_INTER_H__

#include <config.h>

#if __ENABLE_DEBUG__
# define Mylene200_type_debug		Mylene200_fprintf_error
#endif				/* __ENABLE_DEBUG__ */

#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
extern int Mylene200_0576_thread(void *, void *);
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */
extern int Mylene200_air_signals(void);
extern int Mylene200_all_signals
    (const char *, void (*) (void), void (*) (void));
extern int Mylene200_back_client(void *, void *, unsigned, void *);
extern int Mylene200_deck_client(void *, void *);
#if __ENABLE_CHANNEL_DEBUG__
extern int Mylene200_dump_channels(void *);
#endif				/* __ENABLE_CHANNEL_DEBUG__ */
#if __ENABLE_DEBUG__
extern int Mylene200_dump_clients(void *);
#endif				/* __ENABLE_DEBUG__ */
extern int Mylene200_fail_client(void *, void *);
extern int Mylene200_fail_reflex(void *);
#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
extern int Mylene200_fast_thread(void *, void *);
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */
extern int Mylene200_fini_reflex(void *);
extern int Mylene200_fini_server(void *);
extern int Mylene200_flat_reflex(void *);
#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
extern int Mylene200_flat_thread(void *, void *, unsigned);
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */
extern int Mylene200_fprintf_error(void *, const char *, ...);
extern int Mylene200_free_client(void *, void *);
extern int Mylene200_get_record(void *, int (*) (void *));
extern int Mylene200_head_client(void *, void *);
extern int Mylene200_init_reflex(void *);
extern int Mylene200_init_server(void *);
extern int Mylene200_land_client(void *, void *);
extern int Mylene200_land_reflex(void *);
extern int Mylene200_lead_client(void *, void *);
extern int Mylene200_line_client
    (void *, void **, unsigned *, unsigned, void *);
extern int Mylene200_line_reflex(void *);
extern int Mylene200_line_server(void *);
#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
extern int Mylene200_line_thread(void *, void *, unsigned);
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */
extern int Mylene200_link_client(void *, int, void **);
extern int Mylene200_lock_reflex(void *, unsigned, void *);
#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
extern int Mylene200_lock_thread(void *, void *, void *);
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */
extern int Mylene200_lose_client(void *, void *);
extern int Mylene200_lose_server(void *);
extern int Mylene200_lose_reflex(void *);
#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
extern int Mylene200_lose_thread(void *, void **, unsigned);
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */
#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
extern int Mylene200_mind_thread(void *, void *);
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */
extern int Mylene200_miss_client(void *, void *);
extern int Mylene200_miss_reflex(void *);
#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
extern int Mylene200_miss_thread(void *);
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */
extern int Mylene200_moon_client(void *, void *);
extern int Mylene200_parse_cardinal
    (void *, const char *, const char *, unsigned *);
#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
extern int Mylene200_peek_thread(void *, void **, unsigned);
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */
extern int Mylene200_post_client(void *, void *);
#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
extern int Mylene200_post_thread(void *, void *);
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */
extern int Mylene200_push_client(void *, void *, unsigned, void *);
extern int Mylene200_push_reflex(void *, unsigned, void *);
#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
extern int Mylene200_push_thread(void *, void *);
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */
#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
extern int Mylene200_rail_thread(void *);
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */
extern int Mylene200_read_client(void *, void *, void *, unsigned, unsigned *);
extern int Mylene200_read_reflex(void *);
extern int Mylene200_sand_client(void *, void *, unsigned);
extern int Mylene200_sand_reflex(void *, unsigned);
extern int Mylene200_seek_client(void *, void *);
extern int Mylene200_set_record(void *, int (*) (void *), void *);
extern int Mylene200_stat_system(void *);
extern int Mylene200_try_signals(int, char **);
#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
extern int Mylene200_wave_thread(void *);
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */

#endif				/* __Mylene200_INTER_H__ */
