/*
 * misc.c
 * Copyright (C) 2005-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#include <errno.h>
#if defined HAVE_LIBLEWD
# include <lewd.h>
#endif				/* HAVE_LIBLEWD */
#include <stdarg.h>
#include <string.h>

#include <access.h>
#if !defined HAVE_LIBLEWD
# include <cardinal-wx.h>
#endif				/* !HAVE_LIBLEWD */

int
Mylene200_fprintf_error(void *context, const char *format, ...)
{
    va_list ap;

    va_start(ap, format);
    EPRINTF(context) (context, format, ap);
    va_end(ap);

    return 0;
}


int
Mylene200_parse_cardinal(void *context, const char *text,
			 const char *specification, unsigned *c_cardinal)
{
    int status;
    unsigned cardinal;

    status = x1f4_parse_wxcardinal(&cardinal, specification, NULL, 0);
    if (status) {
	Mylene200_fprintf_error
	    (context, "%s: cannot parse %s specification: `%s'\n",
	     Mylene200(context), text, specification);
    } else {
	*c_cardinal = cardinal;
    }

    return status;
}


int
Mylene200_stat_system(void *context)
{
    Mylene200_fprintf_error
	(context, "%s: %s\n", Mylene200(context), strerror(errno));

    return 0;
}
