/*
 * record.c
 * Copyright (C) 2006-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>
#include <stdlib.h>

#include <access.h>
#include <types.h>

int
Mylene200_get_record(void *context, int (*data) (void *))
{
    int status = 1;
    struct record_type *last_record = NULL, *record_data;

    record_data = RECORD(context);
    while (record_data) {
	if (record_data->data == data) {
	    if (last_record) {
		last_record->record_data = record_data->record_data;
	    } else {
		RECORD(context) = record_data->record_data;
	    }

	    free(record_data);

	    status = 0;

	    break;
	}

	last_record = record_data;
	record_data = record_data->record_data;
    }

    return status;
}


int
Mylene200_set_record(void *context, int (*data) (void *), void *text)
{
    int status = 0;
    struct record_type *record_data;

    record_data = (struct record_type *) malloc(sizeof(struct record_type));
    if (!record_data) {
	status = -1;
    } else {
	record_data->data = data;
	record_data->text = text;

	record_data->record_data = RECORD(context);

	RECORD(context) = record_data;
    }

    return status;
}
