/*
 * sa6.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#include <unistd.h>

#if __USE_SHUTDOWN__
# include <sys/socket.h>
#endif				/* __USE_SHUTDOWN__ */

#include <access.h>
#include <defs.h>
#include <inter.h>

int
Mylene200_fini_server(void *context)
{
    int server, status;

    server = SERVER(context);

    if (FLAGS(context) & Mylene200_e200_UNIX) {
	unlink(E200(context));

	Mylene200_get_record(context, Mylene200_lose_server);
    }

#if __USE_SHUTDOWN__
    shutdown(server, SHUT_RDWR);
#endif				/* __USE_SHUTDOWN__ */
    status = close(server);

    return status;
}
