/*
 * sc2.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#include <stddef.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include <sys/select.h>
#include <sys/time.h>
#include <sys/types.h>

#include <access.h>
#include <inter.h>
#include <types.h>

int
Mylene200_push_reflex(void *context, unsigned size, void *data)
{
    int status;

    do {
	struct stripe_type *stripe_data;

	stripe_data = STOYA6(context);
	if (!stripe_data) {
	    stripe_data = STOYA7(context);
	    if (stripe_data) {
		STOYA7(context) = NULL;
	    } else {
		stripe_data = (struct stripe_type *)
		    malloc(sizeof(struct stripe_type) + STRIPE_SIZE);
	    }
	    if (!stripe_data) {
		Mylene200_stat_system(context);
		status = -1;
		break;
	    } else {
		unsigned miss;

		STOYA6(context) = stripe_data;
		STRIPE(context) = stripe_data;

		miss = size;
		if (STRIPE_SIZE < miss) {
		    miss = STRIPE_SIZE;
		}

		size -= miss;

		stripe_data->data = stripe_data + 1;
		stripe_data->size = miss;
		stripe_data->stripe_data = NULL;

		memcpy(stripe_data + 1, data, miss);

		data = (char *) data + miss;

		FD_SET(REFLEX(context), &SET_1(context));
	    }
	} else {
	    unsigned dana, less;

	    less = stripe_data->size;

	    dana = STRIPE_SIZE - less;
	    if (dana) {
		unsigned miss, post;
		void *link;

		miss = size;
		if (dana < miss) {
		    miss = dana;
		}

		link = stripe_data->data;

		post = (char *) link - (char *) (stripe_data + 1);
		post = STRIPE_SIZE - less - post;
		if (post < miss) {
		    stripe_data->data = stripe_data + 1;

		    memmove(stripe_data + 1, link, less);

		    link = stripe_data + 1;
		}

		size -= miss;

		stripe_data->size = less + miss;

		memcpy((char *) link + less, data, miss);

		data = (char *) data + miss;
	    }
	}

	status = 0;

	while (size) {
	    stripe_data = STOYA7(context);
	    if (stripe_data) {
		STOYA7(context) = NULL;
	    } else {
		stripe_data = (struct stripe_type *)
		    malloc(sizeof(struct stripe_type) + STRIPE_SIZE);
	    }
	    if (!stripe_data) {
		Mylene200_stat_system(context);
		status = -1;
		break;
	    } else {
		unsigned miss;

		STOYA6(context)->stripe_data = stripe_data;

		STOYA6(context) = stripe_data;

		miss = size;
		if (STRIPE_SIZE < miss) {
		    miss = STRIPE_SIZE;
		}

		size -= miss;

		stripe_data->data = stripe_data + 1;
		stripe_data->size = miss;
		stripe_data->stripe_data = NULL;

		memcpy(stripe_data + 1, data, miss);

		data = (char *) data + miss;
	    }
	}
    } while (0);

    return status;
}
