/*
 * sc4.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#include <stddef.h>
#include <stdlib.h>

#include <access.h>
#include <inter.h>
#include <types.h>

#define client(client) \
    ((struct client_type *) (client))

int
Mylene200_lock_reflex(void *context, unsigned type, void *client)
{
    int status;
    struct window_type *window_data;

    window_data = (struct window_type *) malloc(sizeof(struct window_type));
    if (!window_data) {
	Mylene200_stat_system(context);
	status = -1;
    } else {
	struct window_type *last_window;

	status = 0;

	window_data->client_data = client;
	window_data->type = type;
	window_data->last_window = NULL;
	window_data->window_data = NULL;

	if (!client) {
	    window_data->miss_window = NULL;
	} else {
	    struct window_type *miss_window;

	    miss_window = client(client)->window;
	    if (miss_window) {
		miss_window->last_window = window_data;
	    }

	    client(client)->window = window_data;

	    window_data->miss_window = miss_window;
	}

	last_window = CLASS9(context);

	CLASS9(context) = window_data;

	if (!last_window) {
	    WINDOW(context) = window_data;

	    Mylene200_line_reflex(context);
	} else {
	    last_window->window_data = window_data;
	}
    }

    return status;
}
