/*
 * sc7.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#include <errno.h>
#include <unistd.h>

#include <access.h>
#include <inter.h>

int
Mylene200_read_reflex(void *context)
{
    char data[1];
    int status;

    status = read(REFLEX(context), data, 1);
    if (status == -1) {
	if (errno == EINTR) {
	    status = 0;
	} else {
	    Mylene200_land_reflex(context);
	}
    } else {
	if (!status) {
	    status = -1;
	    Mylene200_miss_reflex(context);
	} else {
	    status = MISS(context) (context, data);
	}
    }

    return status;
}
