/*
 * se1.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
# include <stddef.h>
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */
#include <string.h>

#include <defs.h>
#include <inter.h>
#include <types.h>

#define client(client) \
    ((struct client_type *) (client))

#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
static int fast_down(void *, void *);
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */
#if __NONBLOCKING_CLIENT_TRANSFER__
static int head_down(void *, void *);
#endif				/* __NONBLOCKING_CLIENT_TRANSFER__ */
static int lead_down(void *, void *);

static const char slippingaway____[] = "slippingaway\0\0\0\0";

#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
static int
fast_down(void *context, void *client)
{
    char data[1];
    int status;
    unsigned size;

    status = Mylene200_read_client(context, client, data, 1, &size);
    if (status) {
    } else {
	if (size) {
	    if (((unsigned char *) data)[0] & ~1) {
		status = Mylene200_head_client(context, client);
	    } else {
		if (0) {
		} else {
		    Mylene200_seek_client(context, client);
		}
		if (data[0]) {
		    client(client)->bits |= Mylene200_MIND_CLIENT;
		    client(client)->delete = NULL;
		    client(client)->post = 1;
		    client(client)->shrews = NULL;
		}
	    }
	}
    }

    return status;
}
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */


#if __NONBLOCKING_CLIENT_TRANSFER__
static int
head_down(void *context, void *client)
{
    char data[16];
    int status;
    unsigned miss, size;

    miss = client(client)->data.lead.size;

    status = Mylene200_read_client(context, client, data, miss, &size);
    if (status) {
    } else {
	if (size) {
	    const char *text;

	    text = client(client)->data.lead.data;
	    if (memcmp(data, text, size)) {
		status = Mylene200_head_client(context, client);
	    } else {
		miss -= size;
		if (miss) {
		    client(client)->data.lead.size = miss;
		    client(client)->data.lead.data = text + size;
		} else {
# if __REFLEX_SELECT__ == __SINGLE_SELECT__
		    Mylene200_seek_client(context, client);
# elif __REFLEX_SELECT__ == __DOUBLE_SELECT__
		    client(client)->read = fast_down;
# endif				/* __REFLEX_SELECT__ == __SINGLE_SELECT__ */
		}
	    }
	}
    }

    return status;
}
#endif				/* __NONBLOCKING_CLIENT_TRANSFER__ */


static int
lead_down(void *context, void *client)
{
    char data[1];
    int status;
    unsigned size;

    status = Mylene200_read_client(context, client, data, 1, &size);
    if (status) {
    } else {
	if (size) {
	    const char *text;

	    text = client(client)->data.lead.data;
	    if (data[0] != text[0]) {
		status = Mylene200_head_client(context, client);
	    } else {
		unsigned miss;

		miss = client(client)->data.lead.size;
		miss--;
		if (miss) {
		    client(client)->data.lead.size = miss;
		    client(client)->data.lead.data = text + 1;
		} else {
#if __REFLEX_SELECT__ == __SINGLE_SELECT__
		    Mylene200_seek_client(context, client);
#elif __REFLEX_SELECT__ == __DOUBLE_SELECT__
		    client(client)->read = fast_down;
#endif				/* __REFLEX_SELECT__ == __SINGLE_SELECT__ */
		}
	    }
	}
    }

    return status;
}


int
Mylene200_lead_client(void *context, void *client)
{
    client(client)->data.lead.data = slippingaway____;
#if __REFLEX_SELECT__ == __SINGLE_SELECT__
    client(client)->data.lead.size = 16;
#elif __REFLEX_SELECT__ == __DOUBLE_SELECT__
    client(client)->data.lead.size = 15;
#endif				/* __REFLEX_SELECT__ == __SINGLE_SELECT__ */
#if __NONBLOCKING_CLIENT_TRANSFER__
    if (client(client)->bits & Mylene200_LOCK_CLIENT) {
#endif				/* __NONBLOCKING_CLIENT_TRANSFER__ */
	client(client)->read = lead_down;
#if __NONBLOCKING_CLIENT_TRANSFER__
    } else {
	client(client)->read = head_down;
    }
#endif				/* __NONBLOCKING_CLIENT_TRANSFER__ */

    return 0;
}
