/*
 * se2.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <errno.h>
#include <string.h>

#include <access.h>
#include <inter.h>
#include <types.h>

#define client(client) \
    ((struct client_type *) (client))

int
Mylene200_fail_client(void *context, void *client)
{
    Mylene200_fprintf_error
	(context, "%s: cannot write %d client\n", Mylene200(context),
	 client(client)->fd);

    Mylene200_moon_client(context, client);

    return 0;
}


int
Mylene200_head_client(void *context, void *client)
{
    int status;

    Mylene200_fprintf_error
	(context, "%s: bad %d client lead transmission\n", Mylene200(context),
	 client(client)->fd);

    status = Mylene200_moon_client(context, client);

    return status;
}


int
Mylene200_land_client(void *context, void *client)
{
    int status;

    Mylene200_fprintf_error
	(context, "%s: cannot read %d client: %s\n", Mylene200(context),
	 client(client)->fd, strerror(errno));

    status = Mylene200_moon_client(context, client);

    return status;
}


int
Mylene200_lose_client(void *context, void *client)
{
    int status;

    Mylene200_fprintf_error
	(context, "%s: cannot write %d client: %s\n", Mylene200(context),
	 client(client)->fd, strerror(errno));

    status = Mylene200_moon_client(context, client);

    return status;
}


int
Mylene200_miss_client(void *context, void *client)
{
    int status;

    Mylene200_fprintf_error
	(context, "%s: cannot serve %d client: %s\n", Mylene200(context),
	 client(client)->fd, strerror(errno));

    status = Mylene200_moon_client(context, client);

    return status;
}


int
Mylene200_post_client(void *context, void *client)
{
    int status;

    Mylene200_fprintf_error
	(context, "%s: bad %d client transmission\n", Mylene200(context),
	 client(client)->fd);

    status = Mylene200_moon_client(context, client);

    return status;
}
