/*
 * se6.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <errno.h>
#include <unistd.h>

#include <access.h>
#include <inter.h>
#include <types.h>

#define client(client) \
    ((struct client_type *) (client))

int
Mylene200_read_client(void *context, void *client, void *data, unsigned miss,
		      unsigned *size)
{
    int status;

    status = read(client(client)->fd, data, miss);
    if (status == -1) {
	if (errno == EINTR) {
	    *size = 0;
	    status = 0;
	} else {
	    status = Mylene200_land_client(context, client);
	    if (status) {
	    } else {
		*size = 0;
	    }
	}
    } else {
	if (!status) {
#if __ENABLE_DEBUG__
	    Mylene200_type_debug
		(context, " ** lost client    %d\n", client(client)->fd);
#endif				/* __ENABLE_DEBUG__ */

	    status = Mylene200_moon_client(context, client);
	    if (status) {
	    } else {
		*size = 0;
	    }
	} else {
	    *size = status;
	    status = 0;
	}
    }

    return status;
}
