/*
 * ss7.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
# include <stddef.h>
# include <stdlib.h>
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */

#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
# include <access.h>
# include <inter.h>
# include <types.h>
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */

#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
int
Mylene200_wave_thread(void *context)
{
    struct thread_type *fast_thread, *miss_thread, *post_thread, *thread_data;

    thread_data = BREAK6(context);

    fast_thread = thread_data->fast_thread;
    post_thread = thread_data->thread_data;
    if (!fast_thread) {
	if (!post_thread) {
	    THREAD(context) = NULL;
	} else {
	    THREAD(context) = post_thread;
	    post_thread->fast_thread = NULL;
	}
    } else {
	if (!post_thread) {
	    fast_thread->thread_data = NULL;
	} else {
	    fast_thread->thread_data = post_thread;
	    post_thread->fast_thread = fast_thread;
	}
    }

    miss_thread = thread_data->miss_thread;

    free(thread_data);

    if (!miss_thread) {
	BREAK6(context) = NULL;
	BREAK7(context) = NULL;
    } else {
	BREAK6(context) = miss_thread;
    }

# if __ENABLE_DEBUG__
    Mylene200_type_debug(context, " -- [thread deleted]\n");
    Mylene200_dump_channels(context);
# endif				/* __ENABLE_DEBUG__ */

    return 0;
}
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */
