/*
 * state.h
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __Mylene200_STATE_H__
#define __Mylene200_STATE_H__

#include <config.h>

#include <stdarg.h>
#include <stdio.h>
#include <unistd.h>

#include <sys/time.h>
#include <sys/types.h>

#include <types.h>

typedef struct context_state {
    FILE *progress;
    const char *Mylene200, *e1f4_id, *e200_id, *mode;
    fd_set set_0, set_1;
    int do_clear, (*miss) (void *, void *), nfds;
#if __NONBLOCKING_REFLEX_TRANSFER__
    int (*read) (void *);
#endif				/* __NONBLOCKING_REFLEX_TRANSFER__ */
    int reflex;
#if __NONBLOCKING_REFLEX_TRANSFER__
    int (*send) (void *);
#endif				/* __NONBLOCKING_REFLEX_TRANSFER__ */
    int server;
    struct {
	int (*miss) (void *);
	union {
	    unsigned deck, miss;
	} data;
    } data;
    struct client_type *client_data, *last_client;
    struct record_type *record_data;
    struct stripe_type *stripe_data, *last_stripe, *swap_stripe;
#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
    struct thread_type *head_thread, *miss_thread, *tail_thread, *thread_data;
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */
#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
    struct window_type shrews;
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */
    struct window_type *window_data, *last_window;
    unsigned attempts, flags, timeout;
    void (*printf_error) (void *, const char *, va_list ap);
} context_state;

#endif				/* __Mylene200_STATE_H__ */
