/*
 * su5.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#if __ENABLE_CHANNEL_DEBUG__
# include <access.h>
# include <inter.h>
# include <types.h>
#endif				/* __ENABLE_CHANNEL_DEBUG__ */

#if __ENABLE_CHANNEL_DEBUG__
static int dump_thread(void *, struct thread_type *);
#endif				/* __ENABLE_CHANNEL_DEBUG__ */

#if __ENABLE_CHANNEL_DEBUG__
static int
dump_thread(void *context, struct thread_type *thread_data)
{
    Mylene200_type_debug
	(context, "     --  %7ux %7uc\n", thread_data->deck,
	 thread_data->miss);

    return 0;
}
#endif				/* __ENABLE_CHANNEL_DEBUG__ */


#if __ENABLE_CHANNEL_DEBUG__
int
Mylene200_dump_channels(void *context)
{
    struct thread_type *thread_data;

    Mylene200_type_debug(context, "     -- Mylene threads\n");
    thread_data = THREAD(context);
    while (thread_data) {
	dump_thread(context, thread_data);
	thread_data = thread_data->thread_data;
    }

    Mylene200_type_debug(context, "     -- closed threads\n");
    thread_data = BREAK6(context);
    while (thread_data) {
	dump_thread(context, thread_data);
	thread_data = thread_data->miss_thread;
    }

    return 0;
}
#endif				/* __ENABLE_CHANNEL_DEBUG__ */
