/*
 * su6.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#if __ENABLE_DEBUG__
# include <access.h>
# include <inter.h>
# include <types.h>
#endif				/* __ENABLE_DEBUG__ */

#if __ENABLE_DEBUG__
static int dump_client(void *, struct client_type *);
#endif				/* __ENABLE_DEBUG__ */

#if __ENABLE_DEBUG__
static int
dump_client(void *context, struct client_type *client_data)
{
    Mylene200_type_debug(context, "     **  ");
    if (client_data == CLIENT(context)) {
	Mylene200_type_debug(context, "C");
    } else {
	Mylene200_type_debug(context, " ");
    }
    if (client_data == NASSA5(context)) {
	Mylene200_type_debug(context, "N");
    } else {
	Mylene200_type_debug(context, " ");
    }
    Mylene200_type_debug(context, "  %7d\n", client_data->fd);

    return 0;
}
#endif				/* __ENABLE_DEBUG__ */


#if __ENABLE_DEBUG__
int
Mylene200_dump_clients(void *context)
{
    struct client_type *client_data;

    Mylene200_type_debug(context, "     ** Mylene clients\n");
    client_data = CLIENT(context);
    while (client_data) {
	dump_client(context, client_data);
	client_data = client_data->client_data;
    }

    return 0;
}
#endif				/* __ENABLE_DEBUG__ */
