/*
 * types.h
 * Copyright (C) 2008-2012, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __Mylene200_TYPES_H__
#define __Mylene200_TYPES_H__

#include <config.h>

typedef struct client_type {
    int fd, (*read) (void *, void *), (*send) (void *, void *);
    struct client_type *client_data, *client_miss;
    union {
	struct {
	    const char *data;
	    unsigned size;
	} lead;
	struct {
	    union {
		struct {
		    int (*miss) (void *, void *);
		    union {
			struct {
			    union {
				struct {
				    unsigned deck;
				} miss;
			    } data;
			    unsigned char byte;
			} byte;
			struct {
			    union {
				struct {
				    unsigned deck;
				} nine;
				struct {
				    unsigned deck, sign;
				} slip;
			    } data;
			    unsigned deck;
			} sign;
			struct {
			    union {
				struct {
				    unsigned char byte;
				} mode;
				struct {
				    unsigned char byte;
				    unsigned deck, sign;
				} nine;
				struct {
				    unsigned call, deck;
				} pair;
				struct {
				    unsigned deck, sign;
				} slip;
			    } data;
			    unsigned miss;
			    void *slip;
			} text;
			struct {
			    unsigned post, s1st, s2nd, s3rd;
			} time;
		    } data;
		    unsigned deck;
		} ceil;
	    } data;
	    unsigned char deck;
	} miss;
    } data;
    unsigned bits, name;
#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
    unsigned post;
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */
    unsigned size;
#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
    void *delete;
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */
    void *mirror, *qtitle;
#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
    void *shrews;
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */
    void *stoya6, *stoya7, *stripe, *window;
} client_type;

typedef struct record_type {
    int (*data) (void *);
    struct record_type *record_data;
    void *text;
} record_type;

typedef struct stripe_type {
    struct stripe_type *stripe_data;
    unsigned size;
    void *data;
} stripe_type;

#if __REFLEX_SELECT__ == __DOUBLE_SELECT__
typedef struct thread_type {
    struct client_type *client_data;
    struct thread_type *fast_thread, *last_thread, *miss_thread, *thread_data;
    unsigned deck, miss;
} thread_type;
#endif				/* __REFLEX_SELECT__ == __DOUBLE_SELECT__ */

typedef struct window_type {
    struct client_type *client_data;
    struct window_type *last_window, *miss_window, *window_data;
    unsigned type;
} window_type;

#endif				/* __Mylene200_TYPES_H__ */
