/*
 * e4-file.h
 * Copyright (C) 2006, 2007, 2008, 2009, 2013, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_e4_FILE_H__
#define __LIBx1f4_e4_FILE_H__

#include <e4-config.h>

#include <e4-types.h>

#if __RECORD_POST__
#else
#endif				/* __RECORD_POST__ */

#if __RECORD_POST__
#else
#endif				/* __RECORD_POST__ */

#if __RECORD_POST__
# define break_e1(atom_data, post_data, context, Cx, Dx, status) \
    {									      \
	struct e4_odb2_type *odb2_data;					      \
	const struct e4_odbx_type *odbx_data;				      \
	struct e4_post_type swap_state;					      \
	void *input[2];							      \
									      \
	odb2_data = (atom_data)->odb2._2nd;				      \
									      \
	input[1] = Dx##_post((atom_data), (post_data), 1, 1);		      \
	Cx##_back((post_data));						      \
	input[0] = Cx##_post((atom_data), (post_data), 0, 1);		      \
	odbx_data = odb2_data->odbx_data;				      \
	(status) = odbx_data->odbx(&swap_state.data, input);		      \
	if ((status)) {							      \
	} else {							      \
	    (post_data)->data = swap_state.data;			      \
	    (post_data)->flat.address = &(post_data)->data;		      \
	}								      \
    }
#else
#endif				/* __RECORD_POST__ */

#if __RECORD_POST__
# define break_e2(atom_data, post_data, context, Bx, Cx, Dx, status) \
    {									      \
	struct e4_odb2_type *odb2_data;					      \
	const struct e4_odbx_type *odbx_data;				      \
	struct e4_post_type swap_state;					      \
	void *input[2];							      \
									      \
	odb2_data = (atom_data)->odb2._2nd;				      \
									      \
	input[1] = Dx##_post((atom_data), (post_data), 2, 2);		      \
	Cx##_back((post_data));						      \
	input[0] = Cx##_post((atom_data), (post_data), 1, 2);		      \
	odbx_data = odb2_data->odbx_data;				      \
	(status) = odbx_data->odbx(&swap_state.data, input);		      \
	if ((status)) {							      \
	} else {							      \
	    struct e4_post_type miss_state;				      \
									      \
	    odb2_data = odb2_data->odb2_data;				      \
									      \
	    input[1] = &swap_state.data;				      \
	    Bx##_back((post_data));					      \
	    input[0] = Bx##_post((atom_data), (post_data), 0, 2);	      \
	    odbx_data = odb2_data->odbx_data;				      \
	    (status) = odbx_data->odbx(&miss_state.data, input);	      \
	    if ((status)) {						      \
	    } else {							      \
		(post_data)->data = miss_state.data;			      \
		(post_data)->flat.address = &(post_data)->data;		      \
	    }								      \
	}								      \
    }
#else
#endif				/* __RECORD_POST__ */

#if __RECORD_POST__
# define break_e3(atom_data, post_data, context, Ax, Bx, Cx, Dx, status) \
    {									      \
	struct e4_odb2_type *odb2_data;					      \
	const struct e4_odbx_type *odbx_data;				      \
	struct e4_post_type swap_state;					      \
	void *input[2];							      \
									      \
	odb2_data = (atom_data)->odb2._2nd;				      \
									      \
	input[1] = Dx##_post((atom_data), (post_data), 3, 3);		      \
	Cx##_back((post_data));						      \
	input[0] = Cx##_post((atom_data), (post_data), 2, 3);		      \
	odbx_data = odb2_data->odbx_data;				      \
	(status) = odbx_data->odbx(&swap_state.data, input);		      \
	if ((status)) {							      \
	} else {							      \
	    struct e4_post_type miss_state;				      \
									      \
	    odb2_data = odb2_data->odb2_data;				      \
									      \
	    input[1] = &swap_state.data;				      \
	    Bx##_back((post_data));					      \
	    input[0] = Bx##_post((atom_data), (post_data), 1, 3);	      \
	    odbx_data = odb2_data->odbx_data;				      \
	    (status) = odbx_data->odbx(&miss_state.data, input);	      \
	    if ((status)) {						      \
	    } else {							      \
		odb2_data = odb2_data->odb2_data;			      \
									      \
		input[1] = &miss_state.data;				      \
		Ax##_back((post_data));					      \
		input[0] = Ax##_post((atom_data), (post_data), 0, 3);	      \
		odbx_data = odb2_data->odbx_data;			      \
		(status) = odbx_data->odbx(&swap_state.data, input);	      \
		if ((status)) {						      \
		} else {						      \
		    (post_data)->data = swap_state.data;		      \
		    (post_data)->flat.address = &(post_data)->data;	      \
		}							      \
	    }								      \
	}								      \
    }
#else
#endif				/* __RECORD_POST__ */

#if __RECORD_POST__
# define break_ea(atom_data, post_data, context, Bx, Cx, Dx, status) \
    {									      \
	odb2_data = (atom_data)->odb2._2nd;				      \
									      \
	input[1] = Cx##_post((atom_data), (post_data), 1, 1);		      \
	Bx##_back((post_data));						      \
	input[0] = Bx##_post((atom_data), (post_data), 0, 1);		      \
	odbx_data = odb2_data->odbx_data;				      \
	(status) = odbx_data->odbx(&swap_state.data, input);		      \
    }
#else
#endif				/* __RECORD_POST__ */

#if __RECORD_POST__
# define break_eb(atom_data, post_data, context, Cx, Dx, status) \
    {									      \
	struct e4_post_type miss_state;					      \
									      \
	odb2_data = (atom_data)->odb2._2nd;				      \
									      \
	input[1] = Dx##_post((atom_data), (post_data), 2, 2);		      \
	(post_data)--;							      \
	input[0] = &swap_state.data;					      \
	odbx_data = odb2_data->odbx_data;				      \
	(status) = odbx_data->odbx(&miss_state.data, input);		      \
	if ((status)) {							      \
	} else {							      \
	    (post_data)->data = miss_state.data;			      \
	    (post_data)->flat.address = &(post_data)->data;		      \
	}								      \
    }
#else
#endif				/* __RECORD_POST__ */

#if __RECORD_POST__
# define break_ec(atom_data, post_data, context, Ax, Bx, Cx, Dx, status) \
    {									      \
	odb2_data = (atom_data)->odb2._2nd;				      \
									      \
	input[1] = Cx##_post((atom_data), (post_data), 2, 2);		      \
	Bx##_back((post_data));						      \
	input[0] = Bx##_post((atom_data), (post_data), 1, 2);		      \
	odbx_data = odb2_data->odbx_data;				      \
	(status) = odbx_data->odbx(&swap_state.data, input);		      \
    }
#else
#endif				/* __RECORD_POST__ */

#if __RECORD_POST__
# define break_ed(atom_data, post_data, context, Ax, Cx, Dx, status) \
    {									      \
	struct e4_post_type miss_state;					      \
									      \
	odb2_data = (atom_data)->odb2._2nd;				      \
									      \
	input[1] = Dx##_post((atom_data), (post_data), 3, 3);		      \
	Cx##_back((post_data));						      \
	input[0] = &swap_state.data;					      \
	odbx_data = odb2_data->odbx_data;				      \
	(status) = odbx_data->odbx(&miss_state.data, input);		      \
	if ((status)) {							      \
	} else {							      \
	    odb2_data = odb2_data->odb2_data;				      \
									      \
	    input[1] = &miss_state.data;				      \
	    Ax##_back((post_data));					      \
	    input[0] = Ax##_post((atom_data), (post_data), 0, 3);	      \
	    odbx_data = odb2_data->odbx_data;				      \
	    (status) = odbx_data->odbx(&swap_state.data, input);	      \
	    if ((status)) {						      \
	    } else {							      \
		(post_data)->data = swap_state.data;			      \
		(post_data)->flat.address = &(post_data)->data;		      \
	    }								      \
	}								      \
    }
#else
#endif				/* __RECORD_POST__ */

#if __RECORD_POST__
# define break_ee(atom_data, post_data, context, Ax, Bx, Cx, Dx, status) \
    {									      \
	struct e4_post_type miss_state;					      \
									      \
	odb2_data = (atom_data)->odb2._2nd;				      \
									      \
	input[1] = Cx##_post((atom_data), (post_data), 2, 2);		      \
	Bx##_back((post_data));						      \
	input[0] = Bx##_post((atom_data), (post_data), 1, 2);		      \
	odbx_data = odb2_data->odbx_data;				      \
	(status) = odbx_data->odbx(&miss_state.data, input);		      \
	if ((status)) {							      \
	} else {							      \
	    odb2_data = odb2_data->odb2_data;				      \
									      \
	    input[1] = &miss_state.data;				      \
	    Ax##_back((post_data));					      \
	    input[0] = Ax##_post((atom_data), (post_data), 0, 2);	      \
	    odbx_data = odb2_data->odbx_data;				      \
	    (status) = odbx_data->odbx(&swap_state.data, input); 	      \
	}								      \
    }
#else
#endif				/* __RECORD_POST__ */

#if __RECORD_POST__
# define break_ef(atom_data, post_data, context, Ax, Cx, Dx, status) \
    {									      \
	struct e4_post_type miss_state;					      \
									      \
	odb2_data = (atom_data)->odb2._2nd;				      \
									      \
	input[1] = Dx##_post((atom_data), (post_data), 3, 3);		      \
	Cx##_back((post_data));						      \
	input[0] = &swap_state.data;					      \
	odbx_data = odb2_data->odbx_data;				      \
	(status) = odbx_data->odbx(&miss_state.data, input);		      \
	if ((status)) {							      \
	} else {							      \
	    (post_data)->data = miss_state.data;			      \
	    (post_data)->flat.address = &(post_data)->data;		      \
	}								      \
    }
#else
#endif				/* __RECORD_POST__ */

#if __RECORD_POST__
# define break_eg(atom_data, post_data, context, Ax, Bx, Cx, Dx, status) \
    {									      \
	odb2_data = (atom_data)->odb2._2nd;				      \
									      \
	input[1] = Bx##_post((atom_data), (post_data), 1, 1);		      \
	Ax##_back((post_data));						      \
	input[0] = Ax##_post((atom_data), (post_data), 0, 1);		      \
	odbx_data = odb2_data->odbx_data;				      \
	(status) = odbx_data->odbx(&swap_state.data, input);		      \
    }
#else
#endif				/* __RECORD_POST__ */

#if __RECORD_POST__
# define break_eh(atom_data, post_data, context, Ax, Cx, Dx, status) \
    {									      \
	struct e4_post_type miss_state;					      \
									      \
	odb2_data = (atom_data)->odb2._2nd;				      \
									      \
	input[1] = Dx##_post((atom_data), (post_data), 3, 3);		      \
	Cx##_back((post_data));						      \
	input[0] = Cx##_post((atom_data), (post_data), 2, 3);		      \
	odbx_data = odb2_data->odbx_data;				      \
	(status) = odbx_data->odbx(&miss_state.data, input);		      \
	if ((status)) {							      \
	} else {							      \
	    struct e4_post_type slip_state;				      \
									      \
	    odb2_data = odb2_data->odb2_data;				      \
									      \
	    input[1] = &miss_state.data;				      \
	    (post_data)--;						      \
	    input[0] = &swap_state.data;				      \
	    odbx_data = odb2_data->odbx_data;				      \
	    (status) = odbx_data->odbx(&slip_state.data, input);	      \
	    if ((status)) {						      \
	    } else {							      \
		(post_data)->data = slip_state.data;			      \
		(post_data)->flat.address = &(post_data)->data;		      \
	    }								      \
	}								      \
    }
#else
#endif				/* __RECORD_POST__ */

#if __RECORD_POST__
# define break_ei(atom_data, post_data, context, Ax, Bx, Cx, Dx, status) \
    {									      \
	odb2_data = (atom_data)->odb2._2nd;				      \
									      \
	input[1] = Bx##_post((atom_data), (post_data), 1, 1);		      \
	Ax##_back((post_data));						      \
	input[0] = Ax##_post((atom_data), (post_data), 0, 1);		      \
	odbx_data = odb2_data->odbx_data;				      \
	(status) = odbx_data->odbx(&swap_state.data, input);		      \
    }
#else
#endif				/* __RECORD_POST__ */

#if __RECORD_POST__
# define break_ej(atom_data, post_data, context, Ax, Bx, Cx, Dx, status) \
    {									      \
	odb2_data = (atom_data)->odb2._2nd;				      \
									      \
	input[1] = Cx##_post((atom_data), (post_data), 2, 2);		      \
	(post_data)--;							      \
	input[0] = &swap_state.data;					      \
	odbx_data = odb2_data->odbx_data;				      \
	(status) = odbx_data->odbx(&miss_state.data, input);		      \
    }
#else
#endif				/* __RECORD_POST__ */

#if __RECORD_POST__
# define break_ek(atom_data, post_data, context, Cx, Dx, status) \
    {									      \
	odb2_data = (atom_data)->odb2._2nd;				      \
									      \
	input[1] = Dx##_post((atom_data), (post_data), 3, 3);		      \
	(post_data)--;							      \
	input[0] = &miss_state.data;					      \
	odbx_data = odb2_data->odbx_data;				      \
	(status) = odbx_data->odbx(&swap_state.data, input);		      \
	if ((status)) {							      \
	} else {							      \
	    (post_data)->data = swap_state.data;			      \
	    (post_data)->flat.address = &(post_data)->data;		      \
	}								      \
    }
#else
#endif				/* __RECORD_POST__ */

#if __RECORD_POST__
# define break_decls \
    struct e4_odb2_type *odb2_data;					      \
    const struct e4_odbx_type *odbx_data;				      \
    struct e4_post_type swap_state;					      \
    void *input[2];
#else
#endif				/* __RECORD_POST__ */

#if __RECORD_POST__
# define class_decls \
    struct e4_odb2_type *odb2_data;					      \
    const struct e4_odbx_type *odbx_data;				      \
    struct e4_post_type miss_state, swap_state;				      \
    void *input[2];
#else
#endif				/* __RECORD_POST__ */

#endif				/* __LIBx1f4_e4_FILE_H__ */
