/*
 * e4-flat.h
 * Copyright (C) 2006-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_e4_FLAT_H__
#define __LIBx1f4_e4_FLAT_H__

#include <e4-config.h>

#include <e4-types.h>

#if __RECORD_POST__
# define flat_0001(hack_data, post_data, list, context, Cx, Dx) \
    int status;								      \
    struct e4_atom_type *atom_data;					      \
									      \
    atom_data = ((struct e4_hack_type *) hack_data)->atoms;		      \
									      \
    Cx##_load(atom_data, post_data, list, context, status);		      \
    if (Cx##_test(status)) {						      \
    } else {								      \
	atom_data++;							      \
									      \
	Cx##_miss(post_data);						      \
									      \
	Dx##_load(atom_data, post_data, list, context, status);		      \
	if (Dx##_test(status)) {					      \
	} else {							      \
	    break_e1(atom_data, post_data, context, Cx, Dx, status);	      \
	}								      \
    }									      \
									      \
    return status;
#else
#endif				/* __RECORD_POST__ */

#if __RECORD_POST__
# define flat_0002(hack_data, post_data, list, context, Bx, Cx, Dx) \
    int status;								      \
    struct e4_atom_type *atom_data;					      \
									      \
    atom_data = ((struct e4_hack_type *) hack_data)->atoms;		      \
									      \
    Bx##_load(atom_data, post_data, list, context, status);		      \
    if (Bx##_test(status)) {						      \
    } else {								      \
	atom_data++;							      \
									      \
	Bx##_miss(post_data);						      \
									      \
	Cx##_load(atom_data, post_data, list, context, status);		      \
	if (Cx##_test(status)) {					      \
	} else {							      \
	    atom_data++;						      \
									      \
	    Cx##_miss(post_data);					      \
									      \
	    Dx##_load(atom_data, post_data, list, context, status);	      \
	    if (Dx##_test(status)) {					      \
	    } else {							      \
		break_e2(atom_data, post_data, context, Bx, Cx, Dx, status);  \
	    }								      \
	}								      \
    }									      \
									      \
    return status;
#else
#endif				/* __RECORD_POST__ */

#if __RECORD_POST__
# define flat_0003(hack_data, post_data, list, context, Ax, Bx, Cx, Dx) \
    int status;								      \
    struct e4_atom_type *atom_data;					      \
									      \
    atom_data = ((struct e4_hack_type *) hack_data)->atoms;		      \
									      \
    Ax##_load(atom_data, post_data, list, context, status);		      \
    if (Ax##_test(status)) {						      \
    } else {								      \
	atom_data++;							      \
									      \
	Ax##_miss(post_data);						      \
									      \
	Bx##_load(atom_data, post_data, list, context, status);		      \
	if (Bx##_test(status)) {					      \
	} else {							      \
	    atom_data++;						      \
									      \
	    Bx##_miss(post_data);					      \
									      \
	    Cx##_load(atom_data, post_data, list, context, status);	      \
	    if (Cx##_test(status)) {					      \
	    } else {							      \
		atom_data++;						      \
									      \
		Cx##_miss(post_data);					      \
									      \
		Dx##_load(atom_data, post_data, list, context, status);	      \
		if (Dx##_test(status)) {				      \
		} else {						      \
		    break_e3(atom_data, post_data, context, Ax, Bx, Cx, Dx,   \
			     status);					      \
		}							      \
	    }								      \
	}								      \
    }									      \
									      \
    return status;
#else
#endif				/* __RECORD_POST__ */

#if __RECORD_POST__
# define flat_0011(hack_data, post_data, list, context, Bx, Cx, Dx) \
    int status;								      \
    struct e4_atom_type *atom_data;					      \
									      \
    atom_data = ((struct e4_hack_type *) hack_data)->atoms;		      \
									      \
    Bx##_load(atom_data, post_data, list, context, status);		      \
    if (Bx##_test(status)) {						      \
    } else {								      \
	atom_data++;							      \
									      \
	Bx##_miss(post_data);						      \
									      \
	Cx##_load(atom_data, post_data, list, context, status);		      \
	if (Cx##_test(status)) {					      \
	} else {							      \
	    break_decls;						      \
									      \
	    break_ea(atom_data, post_data, context, Bx, Cx, Dx, status);      \
	    if (status) {						      \
	    } else {							      \
		atom_data++;						      \
									      \
		(post_data)++;						      \
									      \
		Dx##_load(atom_data, post_data, list, context, status);	      \
		if (Dx##_test(status)) {				      \
		} else {						      \
		    break_eb(atom_data, post_data, context, Cx, Dx, status);  \
		}							      \
	    }								      \
	}								      \
    }									      \
									      \
    return status;
#else
#endif				/* __RECORD_POST__ */

#if __RECORD_POST__
# define flat_0012(hack_data, post_data, list, context, Ax, Bx, Cx, Dx) \
    int status;								      \
    struct e4_atom_type *atom_data;					      \
									      \
    atom_data = ((struct e4_hack_type *) hack_data)->atoms;		      \
									      \
    Ax##_load(atom_data, post_data, list, context, status);		      \
    if (Ax##_test(status)) {						      \
    } else {								      \
	atom_data++;							      \
									      \
	Ax##_miss(post_data);						      \
									      \
	Bx##_load(atom_data, post_data, list, context, status);		      \
	if (Bx##_test(status)) {					      \
	} else {							      \
	    atom_data++;						      \
									      \
	    Bx##_miss(post_data);					      \
									      \
	    Cx##_load(atom_data, post_data, list, context, status);	      \
	    if (Cx##_test(status)) {					      \
	    } else {							      \
		break_decls;						      \
									      \
		break_ec(atom_data, post_data, context, Ax, Bx, Cx, Dx,	      \
			 status);					      \
		if (status) {						      \
		} else {						      \
		    atom_data++;					      \
									      \
		    Cx##_miss(post_data);				      \
									      \
		    Dx##_load(atom_data, post_data, list, context, status);   \
		    if (Dx##_test(status)) {				      \
		    } else {						      \
			break_ed(atom_data, post_data, context, Ax, Cx, Dx,   \
				 status);				      \
		    }							      \
		}							      \
	    }								      \
	}								      \
    }									      \
									      \
    return status;
#else
#endif				/* __RECORD_POST__ */

#if __RECORD_POST__
# define flat_0021(hack_data, post_data, list, context, Ax, Bx, Cx, Dx) \
    int status;								      \
    struct e4_atom_type *atom_data;					      \
									      \
    atom_data = ((struct e4_hack_type *) hack_data)->atoms;		      \
									      \
    Ax##_load(atom_data, post_data, list, context, status);		      \
    if (Ax##_test(status)) {						      \
    } else {								      \
	atom_data++;							      \
									      \
	Ax##_miss(post_data);						      \
									      \
	Bx##_load(atom_data, post_data, list, context, status);		      \
	if (Bx##_test(status)) {					      \
	} else {							      \
	    atom_data++;						      \
									      \
	    Bx##_miss(post_data);					      \
									      \
	    Cx##_load(atom_data, post_data, list, context, status);	      \
	    if (Cx##_test(status)) {					      \
	    } else {							      \
		break_decls;						      \
									      \
		break_ee(atom_data, post_data, context, Ax, Bx, Cx, Dx,	      \
			 status);					      \
		if (status) {						      \
		} else {						      \
		    atom_data++;					      \
									      \
		    Cx##_miss(post_data);				      \
									      \
		    Dx##_load(atom_data, post_data, list, context, status);   \
		    if (Dx##_test(status)) {				      \
		    } else {						      \
			break_ef(atom_data, post_data, context, Ax, Cx, Dx,   \
				 status);				      \
		    }							      \
		}							      \
	    }								      \
	}								      \
    }									      \
									      \
    return status;
#else
#endif				/* __RECORD_POST__ */

#if __RECORD_POST__
# define flat_0102(hack_data, post_data, list, context, Ax, Bx, Cx, Dx) \
    int status;								      \
    struct e4_atom_type *atom_data;					      \
									      \
    atom_data = ((struct e4_hack_type *) hack_data)->atoms;		      \
									      \
    Ax##_load(atom_data, post_data, list, context, status);		      \
    if (Ax##_test(status)) {						      \
    } else {								      \
	atom_data++;							      \
									      \
	Ax##_miss(post_data);						      \
									      \
	Bx##_load(atom_data, post_data, list, context, status);		      \
	if (Bx##_test(status)) {					      \
	} else {							      \
	    break_decls;						      \
									      \
	    break_eg(atom_data, post_data, context, Ax, Bx, Cx, Dx, status);  \
	    if (status) {						      \
	    } else {							      \
		atom_data++;						      \
									      \
		(post_data)++;						      \
									      \
		Cx##_load(atom_data, post_data, list, context, status);	      \
		if (Cx##_test(status)) {				      \
		} else {						      \
		    atom_data++;					      \
									      \
		    Cx##_miss(post_data);				      \
									      \
		    Dx##_load(atom_data, post_data, list, context, status);   \
		    if (Dx##_test(status)) {				      \
		    } else {						      \
			break_eh(atom_data, post_data, context, Ax, Cx, Dx,   \
				 status);				      \
		    }							      \
		}							      \
	    }								      \
	}								      \
    }									      \
									      \
    return status;
#else
#endif				/* __RECORD_POST__ */

#if __RECORD_POST__
# define flat_0111(hack_data, post_data, list, context, Ax, Bx, Cx, Dx) \
    int status;								      \
    struct e4_atom_type *atom_data;					      \
									      \
    atom_data = ((struct e4_hack_type *) hack_data)->atoms;		      \
									      \
    Ax##_load(atom_data, post_data, list, context, status);		      \
    if (Ax##_test(status)) {						      \
    } else {								      \
	atom_data++;							      \
									      \
	Ax##_miss(post_data);						      \
									      \
	Bx##_load(atom_data, post_data, list, context, status);		      \
	if (Bx##_test(status)) {					      \
	} else {							      \
	    class_decls;						      \
									      \
	    break_ei(atom_data, post_data, context, Ax, Bx, Cx, Dx, status);  \
	    if (status) {						      \
	    } else {							      \
		atom_data++;						      \
									      \
		(post_data)++;						      \
									      \
		Cx##_load(atom_data, post_data, list, context, status);	      \
		if (Cx##_test(status)) {				      \
		} else {						      \
		    break_ej(atom_data, post_data, context, Ax, Bx, Cx, Dx,   \
			     status);					      \
		    if (status) {					      \
		    } else {						      \
			atom_data++;					      \
									      \
			(post_data)++;					      \
									      \
			Dx##_load(atom_data, post_data, list, context,	      \
				  status);				      \
			if (Dx##_test(status)) {			      \
			} else {					      \
			    break_ek(atom_data, post_data, context, Cx, Dx,   \
				     status);				      \
			}						      \
		    }							      \
		}							      \
	    }								      \
	}								      \
    }									      \
									      \
    return status;

#else
#endif				/* __RECORD_POST__ */

#endif				/* __LIBx1f4_e4_FLAT_H__ */
