/*
 * file-defs.h
 * Copyright (C) 2008-2010, 2013, 2014, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_file_defs_H__
#define __LIBx1f4_file_defs_H__

/*
 * buffer size definitions
 */
#define EVER_MAX			(1 << 013)
#define LINE_MAX			(1 << 011)

/*
 * error definitions
 */
#define CALL_CLASS			-129
#define FINE_CLASS			-130
#define FREE_CLASS			-131
#define HALF_CLASS			-132
#define KATE_CLASS			-133
#define LINK_CLASS			-134
#define LOSE_CLASS			-135
#define MODE_CLASS			-136
#define OPEN_CLASS			-137
#define OVER_CLASS			-138
#define PEEP_CLASS			-139
#define PUSH_CLASS			-140
#define READ_CLASS			-141
#define SEEK_CLASS			-142
#define TYPE_CLASS			-143
#define ZERO_CLASS			-144

/*
 * file definitions
 */
#define LINE_TRAP			(1 << 000)

/*
 * news definitions
 */
#define ZERO_NEWS			(1 << 000)

/*
 * node size definitions
 */
#define CALL_SIZE			(1 << 014)

/*
 * not used for returns, still used ****_CLASS definitions
 */
#if 0
# undef DONE_CLASS
# undef MISS_CLASS
#endif				/* 0 */

#endif				/* __LIBx1f4_file_defs_H__ */
