/*
 * lxcast-fold.h
 * Copyright (C) 2014, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_lxcast_fold_H__
#define __LIBx1f4_lxcast_fold_H__

#define EVER_COPY(___T) \
    {									      \
	X1f4_E4_C_##___T iran;						      \
	int status = 0;							      \
	struct dxcast_type *object_data;				      \
									      \
	object_data = I_USER(input[1]);					      \
									      \
	switch (object_data->type) {					      \
	case X1f4_E4_BILL:						      \
	    iran = I_BILL(&object_data->data);				      \
	    break;							      \
	case X1f4_E4_MODE:						      \
	    iran = I_MODE(&object_data->data);				      \
	    break;							      \
	case X1f4_E4_REAL:						      \
	    iran = I_REAL(&object_data->data);				      \
	    break;							      \
	default:							      \
	    status = 1;							      \
	}								      \
									      \
	if (status) {							      \
	    status = _libx1f4i0_lxcast_stat_luck			      \
		(context, 1, object_data->type, X1f4_E4_##___T);	      \
	} else {							      \
	    l_##___T(iran, input[0]);					      \
	    l_##___T(iran, output);					      \
	}								      \
									      \
	return status;							      \
    }

#define EVER_FOLD(___O, ___T) \
    {									      \
	X1f4_E4_C_##___T iran;						      \
	int status = 0;							      \
	struct dxcast_type *object_data;				      \
									      \
	object_data = I_USER(input[1]);					      \
									      \
	iran = I_##___T(input[0]);					      \
									      \
	switch (object_data->type) {					      \
	case X1f4_E4_BILL:						      \
	    iran ___O I_BILL(&object_data->data);			      \
	    break;							      \
	case X1f4_E4_MODE:						      \
	    iran ___O I_MODE(&object_data->data);			      \
	    break;							      \
	case X1f4_E4_REAL:						      \
	    iran ___O I_REAL(&object_data->data);			      \
	    break;							      \
	default:							      \
	    status = 1;							      \
	}								      \
									      \
	if (status) {							      \
	    status = _libx1f4i0_lxcast_stat_luck			      \
		(context, 2, object_data->type, X1f4_E4_##___T);	      \
	} else {							      \
	    l_##___T(iran, input[0]);					      \
	    l_##___T(iran, output);					      \
	}								      \
									      \
	return status;							      \
    }

#define EVER_LONG(___O, ___T) \
    {									      \
	X1f4_E4_C_##___T iran;						      \
	int status = 0;							      \
	struct dxcast_type *object_data;				      \
									      \
	object_data = I_USER(input[1]);					      \
									      \
	iran = I_##___T(input[0]);					      \
									      \
	switch (object_data->type) {					      \
	case X1f4_E4_BILL:						      \
	    iran ___O I_BILL(&object_data->data);			      \
	    break;							      \
	case X1f4_E4_MODE:						      \
	    iran ___O I_MODE(&object_data->data);			      \
	    break;							      \
	default:							      \
	    status = 1;							      \
	}								      \
									      \
	if (status) {							      \
	    status = _libx1f4i0_lxcast_stat_luck			      \
		(context, 1, object_data->type, X1f4_E4_##___T);	      \
	} else {							      \
	    l_##___T(iran, input[0]);					      \
	    l_##___T(iran, output);					      \
	}								      \
									      \
	return status;							      \
    }

#endif				/* __LIBx1f4_lxcast_fold_H__ */
