/*
 * lxdecq-defs.h
 * Copyright (C) 2008-2014, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_lxdecq_defs_H__
#define __LIBx1f4_lxdecq_defs_H__

#include <nt.h>

/*
 * error definitions
 */
#define FREE_ERROR			-2
#define LINK_ERROR			-3
#define MODE_ERROR			-4

/*
 * generation flag definitions
 */
#define AUTOLINK_LINK			(1L << 0)
#define CODELINK_LINK			(1L << 1)
#define EELOOKUP_LINK			(1L << 2)
#define EVERLINK_SLIP			(1L << 3)
#define MISSBAIL_LINK			(1L << 4)
#define RESETNEW_SLIP			(1L << 5)
#define RESOURCE_LINK			(1L << 6)
#define TEXTFLAT_LINK			(1L << 7)

/*
 * node size definitions
 */
#define NODE_SHIFT			3

/*
 * type flag definitions
 */
#define FLAT_REFLEX			X1f4_LX_FLAT_REFLEX
#define LINK_ACCESS			X1f4_LX_LINK_ACCESS
#define POST_ACCESS			X1f4_LX_POST_ACCESS

/*
 * unused type flag definitions
 */
#define MAY_INCLUDE			(1L << 3)

#endif				/* __LIBx1f4_lxdecq_defs_H__ */
