/*
 * config.h
 * Copyright (C) 2006-2008, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __LIBx1f4i2_CONFIG_H__
#define __LIBx1f4i2_CONFIG_H__

#include <autoconfig.h>

#if defined HAVE_ENDIAN_H
# include <endian.h>
#endif				/* HAVE_ENDIAN_H */

#if defined HAVE_ENDIAN_H
# if __BYTE_ORDER == __BIG_ENDIAN
#  define WORDS_BIGENDIAN		1
# endif				/* __BYTE_ORDER == __BIG_ENDIAN */
#endif				/* HAVE_ENDIAN_H */

#if !defined WORDS_BIGENDIAN
# define WORDS_BIGENDIAN		0
#endif				/* !WORDS_BIGENDIAN */

#define __PREFER_REAL_ACCELERATION__	0

#if __PREFER_REAL_ACCELERATION__ == 1
# define __REAL_ACCELERATION__		1
#elif 7 < SIZEOF_UNSIGNED_LONG
# define __REAL_ACCELERATION__		0
#elif !defined SIZEOF_UNSIGNED_LONG_LONG
# define __REAL_ACCELERATION__		1
#elif SIZEOF_UNSIGNED_LONG_LONG < 8
# define __REAL_ACCELERATION__		1
#else
# define __REAL_ACCELERATION__		0
#endif				/* __PREFER_REAL_ACCELERATION__ == 1 */

#endif				/* __LIBx1f4i2_CONFIG_H__ */
