/*
 * defs.h
 * Copyright (C) 2006-2008, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __LIBx1f4i2_DEFS_H__
#define __LIBx1f4i2_DEFS_H__

#include <config.h>

/*
 * block definitions
 */
#define BLOCK_SIZE			4096

/*
 * class definitions (values used)
 */
#define S010_CLASS			0x00000040
#define S16B_CLASS			0x00000020
#define S16L_CLASS			0x00000010
#define U010_CLASS			0x00000008
#define U16B_CLASS			0x00000100
#define U16L_CLASS			0x00000080

/*
 * class definitions (continued)
 */
#if WORDS_BIGENDIAN
# define S16N_CLASS			S16B_CLASS
# define U16N_CLASS			U16B_CLASS
#else
# define S16N_CLASS			S16L_CLASS
# define U16N_CLASS			U16L_CLASS
#endif				/* WORDS_BIGENDIAN */

/*
 * error definitions
 */
#define MISS_ERROR			-1

/*
 * error definitions (continued)
 */
#define SELF_SHIFT			1

#endif				/* __LIBx1f4i2_DEFS_H__ */
