/*
 * _1f4i2.o.c
 * Copyright (C) 2014, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <errno.h>

#include <alsa/asoundlib.h>

#include <defs.h>
#include <types.h>

int
_1f4_long_xaudio(void *xaudio, int status)
{
    do {
	void *asound;

	asound = ((struct xaudio_type *) xaudio)->asound;

	if (status == -EBADFD) {
	    /*
	     * this cure is undocumented.  can't find a documented cure.
	     * snd_pcm_recover does not try to cure -EBADFD at this time.
	     */
	    if (snd_pcm_state(asound) == SND_PCM_STATE_SETUP) {
		if (snd_pcm_prepare(asound)) {
		} else {
		    if (snd_pcm_state(asound) == SND_PCM_STATE_PREPARED) {
			status = 0;
			if (1) {
			    break;
			}
		    }
		}
	    }
	}

	status = snd_pcm_recover(asound, status, 1);
    } while (0);

    return status;
}
