/*
 * _1f4i2.r.c
 * Copyright (C) 2006-2008, 2014, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <alsa/asoundlib.h>

#include <defs.h>
#include <inter.h>
#include <types.h>

int
_1f4_mind_xaudio(void *xaudio, unsigned *loss)
{
    int status;

    do {
	snd_pcm_t *asound;
	struct xaudio_type *xaudio_data;
	unsigned delay = 0;

	xaudio_data = xaudio;

	asound = xaudio_data->asound;

	if (snd_pcm_state(asound) == SND_PCM_STATE_RUNNING) {
	    snd_pcm_sframes_t frames;

	    status = snd_pcm_delay(asound, &frames);
	    if (status < 0) {
		status = snd_pcm_recover(asound, status, 1);
		if (status) {
		} else {
		    status = snd_pcm_delay(asound, &frames);
		}

		if (status < 0) {
		    status = _1f4_fail_xaudio(xaudio, status, DATE_ERROR);
		    if (1) {
			break;
		    }
		} else {
		    delay = frames;
		}
	    } else {
		delay = frames;
	    }

	    delay *= xaudio_data->copy;

	    xaudio_data->missed = delay;
	} else {
	    delay = xaudio_data->missed;
	}

	status = 0;

	*loss = delay;
    } while (0);

    return status;
}
