/*
 * class.h
 * Copyright (C) 2007-2008, 2014, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4i2_CLASS_H__
#define __LIBx1f4i2_CLASS_H__

#include <alsa/asoundlib.h>

#include <defs.h>

#define FIX_CLASS(sound_class, sample_size, audio_class) \
    switch ((audio_class)) {						      \
    case S010_CLASS:							      \
	(sample_size) = 1;						      \
	(sound_class) = SND_PCM_FORMAT_S8;				      \
	break;								      \
    case S16B_CLASS:							      \
	(sample_size) = 2;						      \
	(sound_class) = SND_PCM_FORMAT_S16_BE;				      \
	break;								      \
    case S16L_CLASS:							      \
	(sample_size) = 2;						      \
	(sound_class) = SND_PCM_FORMAT_S16_LE;				      \
	break;								      \
    case U010_CLASS:							      \
	(sample_size) = 1;						      \
	(sound_class) = SND_PCM_FORMAT_U8;				      \
	break;								      \
    case U16B_CLASS:							      \
	(sample_size) = 2;						      \
	(sound_class) = SND_PCM_FORMAT_U16_BE;				      \
	break;								      \
    case U16L_CLASS:							      \
	(sample_size) = 2;						      \
	(sound_class) = SND_PCM_FORMAT_U16_LE;				      \
	break;								      \
    default:								      \
	(sample_size) = 0;						      \
	(sound_class) = SND_PCM_FORMAT_UNKNOWN;				      \
    }

#endif				/* __LIBx1f4i2_CLASS_H__ */
