/*
 * defs.h
 * Copyright (C) 2006-2008, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4i2_DEFS_H__
#define __LIBx1f4i2_DEFS_H__

#include <config.h>

/*
 * class definitions (values used)
 */
#define S010_CLASS			0x00000040
#define S16B_CLASS			0x00000020
#define S16L_CLASS			0x00000010
#define U010_CLASS			0x00000008
#define U16B_CLASS			0x00000100
#define U16L_CLASS			0x00000080

/*
 * class definitions (continued)
 */
#if WORDS_BIGENDIAN
# define S16N_CLASS			S16B_CLASS
# define U16N_CLASS			U16B_CLASS
#else
# define S16N_CLASS			S16L_CLASS
# define U16N_CLASS			U16L_CLASS
#endif				/* WORDS_BIGENDIAN */

/*
 * error definitions
 */
#define ALSA_ERROR			-144
#define COPY_ERROR			-145
#define DATE_ERROR			-146
#define DROP_ERROR			-147
#define EVEN_ERROR			-148
#define HUSH_ERROR			-149
#define LINK_ERROR			-150
#define LOCK_ERROR			-151
#define LOSE_ERROR			-152
#define MISS_ERROR			-153
#define NEAR_ERROR			-154
#define OPEN_ERROR			-155
#define PLAN_ERROR			-156
#define POLL_ERROR			-157
#define PUSH_ERROR			-158
#define RATE_ERROR			-159
#define REND_ERROR			-160
#define RESS_ERROR			-161
#define RULE_ERROR			-162
#define SIZE_ERROR			-163
#define TRIP_ERROR			-164
#define TYPE_ERROR			-165
#define UNIT_ERROR			-166
#define WAIT_ERROR			-167

/*
 * error definitions (continued)
 */
//rem
#define SELF_SHIFT			1

#endif				/* __LIBx1f4i2_DEFS_H__ */
