/*
 * trace.h
 * Copyright (C) 2005-2007, 2014, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4i2_TRACE_H__
#define __LIBx1f4i2_TRACE_H__

#define __DO_TRACE__			0

#if __DO_TRACE__
# include <stdio.h>
#endif				/* __DO_TRACE__ */

#if __DO_TRACE__
#else
# define METHOD_ENTER()
# define METHOD_LEAVE(S)
#endif				/* __DO_TRACE__ */

#if __DO_TRACE__
# define METHOD_ENTER() \
    fprintf(stderr, "%s\n", __FUNCTION__);
#endif				/* __DO_TRACE__ */

#if __DO_TRACE__
# define METHOD_LEAVE(___S) \
    fprintf(stderr, "%s is %d\n", __FUNCTION__, (___S));
#endif				/* __DO_TRACE__ */

#endif				/* __LIBx1f4i2_TRACE_H__ */
