/*
 * x1f4i2.0.c
 * Copyright (C) 2005-2008, 2014, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <inter.h>
#include <trace.h>
#include <types.h>

int
x1f4_init_xaudio(void **xaudio, const char *dsp,
		 struct aerror_type *aerror_data, unsigned rate,
		 unsigned channels, unsigned format, unsigned flags)
{
    int status;
    void *xsound;

    METHOD_ENTER();

    status = x1f4_open_xaudio(&xsound, dsp, aerror_data);
    if (status) {
    } else {
	status = x1f4_mode_xaudio(xsound, rate, channels, format, flags);
	if (status) {
	    x1f4_lose_xaudio(&xsound);
	} else {
	    *xaudio = xsound;
	}
    }

    METHOD_LEAVE(status);

    return status;
}
