/*
 * x1f4i2.d.c
 * Copyright (C) 2006-2007, 2014, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stdlib.h>

#include <alsa/asoundlib.h>

#include <defs.h>
#include <inter.h>
#include <trace.h>
#include <types.h>

int
x1f4_lose_xaudio(void **xaudio)
{
    int status;
    struct xaudio_type *xaudio_data;

    METHOD_ENTER();

    xaudio_data = *xaudio;

    free(xaudio_data->dsound);

    status = snd_pcm_close(xaudio_data->asound);
    if (status) {
	status = _1f4_fail_xaudio(xaudio_data, status, LOSE_ERROR);
    }

    free(xaudio_data);

    METHOD_LEAVE(status);

    return status;
}
