/*
 * class.h
 * Copyright (C) 2007-2008, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4i2_CLASS_H__
#define __LIBx1f4i2_CLASS_H__

#include <libxaudio.h>

#include <config.h>
#include <defs.h>

#if 0
# define __MATCH_CLASS__		1
#elif S010_CLASS != LIBxaudio_S010_CLASS
# define __MATCH_CLASS__		1
#elif S16B_CLASS != LIBxaudio_S16B_CLASS
# define __MATCH_CLASS__		1
#elif S16L_CLASS != LIBxaudio_S16L_CLASS
# define __MATCH_CLASS__		1
#elif U010_CLASS != LIBxaudio_U010_CLASS
# define __MATCH_CLASS__		1
#elif U16B_CLASS != LIBxaudio_U16B_CLASS
# define __MATCH_CLASS__		1
#elif U16L_CLASS != LIBxaudio_U16L_CLASS
# define __MATCH_CLASS__		1
#else
# define __MATCH_CLASS__		0
#endif				/* 0 */

#if !__MATCH_CLASS__
# define FIX_CLASS(sound_class, audio_class) \
    (sound_class) = (audio_class)
#else
# define FIX_CLASS(sound_class, audio_class) \
    if ((audio_class) == S010_CLASS) {					      \
	(sound_class) = LIBxaudio_S010_CLASS;				      \
    } else if ((audio_class) == S16B_CLASS) {				      \
	(sound_class) = LIBxaudio_S16B_CLASS;				      \
    } else if ((audio_class) == S16L_CLASS) {				      \
	(sound_class) = LIBxaudio_S16L_CLASS;				      \
    } else if ((audio_class) == S16N_CLASS) {				      \
	(sound_class) = LIBxaudio_S16N_CLASS;				      \
    } else if ((audio_class) == U010_CLASS) {				      \
	(sound_class) = LIBxaudio_U010_CLASS;				      \
    } else if ((audio_class) == U16B_CLASS) {				      \
	(sound_class) = LIBxaudio_U16B_CLASS;				      \
    } else if ((audio_class) == U16L_CLASS) {				      \
	(sound_class) = LIBxaudio_U16L_CLASS;				      \
    } else if ((audio_class) == U16N_CLASS) {				      \
	(sound_class) = LIBxaudio_U16N_CLASS;				      \
    }
#endif				/* !__MATCH_CLASS__ */

#endif				/* __LIBx1f4i2_CLASS_H__ */
