/*
 * x1f4i2.b.c
 * Copyright (C) 2006-2007, 2014, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <libxaudio.h>
#include <stdlib.h>

#include <defs.h>
#include <types.h>

int
x1f4_open_xaudio(void **xaudio, const char *dsp,
		 struct aerror_type *aerror_data)
{
    int status;
    struct xaudio_type *xaudio_data;

    xaudio_data = (struct xaudio_type *) malloc(sizeof(struct xaudio_type));
    if (!xaudio_data) {
	status = MISS_ERROR;
    } else {
	status = libxaudio_open_xaudio(&xaudio_data->xaudio, dsp);
	if (status) {
	    status <<= SELF_SHIFT;

	    free(xaudio_data);
	} else {
	    *xaudio = xaudio_data;
	}
    }

    return status;
}
