/*
 * x1f4i2.h.c
 * Copyright (C) 2006-2007, 2014, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <errno.h>
#include <libxaudio.h>
#include <stdio.h>
#include <string.h>

#include <defs.h>
#include <types.h>

int
x1f4_file_xaudio(void *file, int condition, const char *dsp,
		 struct aerror_type *aerror_data)
{
    switch (condition) {
    case MISS_ERROR:
	fprintf(file, "%s", strerror(errno));
	break;
    default:
	libxaudio_file_xaudio(file, condition >> SELF_SHIFT, dsp);
    }

    return -1;
}
