/*
 * x1f4i2.q.c
 * Copyright (C) 2007-2008, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <libxaudio.h>

#include <class.h>
#include <defs.h>
#include <types.h>

int
x1f4_list_xaudio(void *xaudio, unsigned *query)
{
    int status;
    struct xaudio_type *xaudio_data;

    xaudio_data = xaudio;

    status = libxaudio_list_xaudio(xaudio_data->xaudio, query);
    if (status) {
	status <<= SELF_SHIFT;
    } else {
#if __MATCH_CLASS__
	unsigned shift = 0, trans;

	trans = *query;

	if (trans & LIBxaudio_S010_CLASS) {
	    shift |= S010_CLASS;
	}
	if (trans & LIBxaudio_S16B_CLASS) {
	    shift |= S16B_CLASS;
	}
	if (trans & LIBxaudio_S16L_CLASS) {
	    shift |= S16L_CLASS;
	}
	if (trans & LIBxaudio_U010_CLASS) {
	    shift |= U010_CLASS;
	}
	if (trans & LIBxaudio_U16B_CLASS) {
	    shift |= U16B_CLASS;
	}
	if (trans & LIBxaudio_U16L_CLASS) {
	    shift |= U16L_CLASS;
	}

	*query = shift;
#endif				/* __MATCH_CLASS__ */
    }

    return status;
}
