/*
 * class.h
 * Copyright (C) 2007-2008, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __LIBxaudio_CLASS_H__
#define __LIBxaudio_CLASS_H__

#include <sys/soundcard.h>

#include <config.h>
#include <defs.h>

#if 1
# undef AFMT_S16_NE
# undef AFMT_U16_NE
#endif				/* 1 */

#if WORDS_BIGENDIAN
# define AFMT_S16_NE			AFMT_S16_BE
# define AFMT_U16_NE			AFMT_U16_BE
#else
# define AFMT_S16_NE			AFMT_S16_LE
# define AFMT_U16_NE			AFMT_U16_LE
#endif				/* WORDS_BIGENDIAN */

#if 0
# define __MATCH_CLASS__		1
#elif S010_CLASS != AFMT_S8
# define __MATCH_CLASS__		1
#elif S16B_CLASS != AFMT_S16_BE
# define __MATCH_CLASS__		1
#elif S16L_CLASS != AFMT_S16_LE
# define __MATCH_CLASS__		1
#elif U010_CLASS != AFMT_U8
# define __MATCH_CLASS__		1
#elif U16B_CLASS != AFMT_U16_BE
# define __MATCH_CLASS__		1
#elif U16L_CLASS != AFMT_U16_LE
# define __MATCH_CLASS__		1
#else
# define __MATCH_CLASS__		0
#endif				/* 0 */

#if !__MATCH_CLASS__
# define FIX_CLASS(sound_class, audio_class) \
    (sound_class) = (audio_class)
#else
# define FIX_CLASS(sound_class, audio_class) \
    if ((audio_class) == S010_CLASS) {					      \
	(sound_class) = AFMT_S8;					      \
    } else if ((audio_class) == S16B_CLASS) {				      \
	(sound_class) = AFMT_S16_BE;					      \
    } else if ((audio_class) == S16L_CLASS) {				      \
	(sound_class) = AFMT_S16_LE;					      \
    } else if ((audio_class) == S16N_CLASS) {				      \
	(sound_class) = AFMT_S16_NE;					      \
    } else if ((audio_class) == U010_CLASS) {				      \
	(sound_class) = AFMT_U8;					      \
    } else if ((audio_class) == U16B_CLASS) {				      \
	(sound_class) = AFMT_U16_BE;					      \
    } else if ((audio_class) == U16L_CLASS) {				      \
	(sound_class) = AFMT_U16_LE;					      \
    } else if ((audio_class) == U16N_CLASS) {				      \
	(sound_class) = AFMT_U16_NE;					      \
    }
#endif				/* !__MATCH_CLASS__ */

#endif				/* __LIBxaudio_CLASS_H__ */
