/*
 * defs.h
 * Copyright (C) 2005-2008, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __LIBxaudio_DEFS_H__
#define __LIBxaudio_DEFS_H__

#include <config.h>

/*
 * class definitions (values used)
 */
#define S010_CLASS			0x00000040
#define S16B_CLASS			0x00000020
#define S16L_CLASS			0x00000010
#define U010_CLASS			0x00000008
#define U16B_CLASS			0x00000100
#define U16L_CLASS			0x00000080

/*
 * class definitions (continued)
 */
#if WORDS_BIGENDIAN
# define S16N_CLASS			S16B_CLASS
# define U16N_CLASS			U16B_CLASS
#else
# define S16N_CLASS			S16L_CLASS
# define U16N_CLASS			U16L_CLASS
#endif				/* WORDS_BIGENDIAN */

/*
 * error definitions
 */
#define USED_ERROR			-1

/*
 * error definitions
 */
#define DSP0_ERROR			-2
#define DSPB_ERROR			-3
#define DSPC_ERROR			-4
#define DSPF_ERROR			-5
#define DSPO_ERROR			-6
#define DSPQ_ERROR			-7
#define DSPS_ERROR			-8
#define DSPV_ERROR			-9
#define DSPX_ERROR			-10
#define DSPY_ERROR			-11
#define LOSE_ERROR			-12
#define MISS_ERROR			-13
#define OPEN_ERROR			-14

#endif				/* __LIBxaudio_DEFS_H__ */
