/*
 * xaudio.2.c
 * Copyright (C) 2005-2008, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <unistd.h>

#include <sys/ioctl.h>
#include <sys/soundcard.h>

#include <defs.h>
#include <types.h>

static int play_xaudio(struct xaudio_type *, void *, unsigned, unsigned *);

static int
play_xaudio(struct xaudio_type *xaudio_data, void *data, unsigned size,
	    unsigned *delay)
{
    int fd, status;

    fd = xaudio_data->fd;

    while (1) {
	struct audio_buf_info info;

	if (ioctl(fd, SNDCTL_DSP_GETOSPACE, &info) == -1) {
	    status = DSPO_ERROR;
	    break;
	} else {
	    if (1 < info.fragments) {
		unsigned max;

		max = info.fragments - 1;
		max *= info.fragsize;
		if (max < size) {
		    size = max;
		}

#if 0
		*delay = (info.fragstotal - info.fragments) * info.fragsize;
#else
		*delay = info.fragstotal * info.fragsize - info.bytes;
#endif				/* 0 */

		size /= xaudio_data->outburst;
		status = write(fd, data, size * xaudio_data->outburst);

		break;
	    }
	}

	usleep(xaudio_data->sleep);
    }

    return status;
}


int
libxaudio_plAy_xaudio(void *xaudio, void *data, unsigned size, unsigned *delay)
{
    int status;

    status = play_xaudio(xaudio, data, size, delay);

    return status;
}
