/*
 * xaudio.7.c
 * Copyright (C) 2006-2007, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <stdlib.h>
#include <unistd.h>

#include <sys/ioctl.h>
#include <sys/soundcard.h>

#include <defs.h>
#include <types.h>

static int xset_xaudio(struct xaudio_type *, unsigned *);

static int
xset_xaudio(struct xaudio_type *xaudio_data, unsigned *delay)
{
    int fd, status;
    struct audio_buf_info info;

    fd = xaudio_data->fd;

    if (ioctl(fd, SNDCTL_DSP_GETOSPACE, &info) != -1) {
	*delay = info.fragstotal * info.fragsize - info.bytes;
    } else {
	*delay = 0;
    }

#if defined SNDCTL_DSP_RESET
    status = ioctl(fd, SNDCTL_DSP_RESET, NULL);
    if (status) {
	status = DSPX_ERROR;
    }
#else
    status = 0;
#endif				/* SNDCTL_DSP_RESET */

    return status;
}


int
libxaudio_xset_xaudio(void *xaudio, unsigned *delay)
{
    return xset_xaudio(xaudio, delay);
}
