/*
 * xaudio.d.c
 * Copyright (C) 2005-2007, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <stdlib.h>
#include <unistd.h>

#include <defs.h>
#include <types.h>

static int lose_xaudio(struct xaudio_type *);

static int
lose_xaudio(struct xaudio_type *xaudio_data)
{
    int status;

    status = close(xaudio_data->fd);
    if (status) {
	status = LOSE_ERROR;
    }

    return status;
}


int
libxaudio_lose_xaudio(void **xaudio)
{
    int status;
    struct xaudio_type *xaudio_data;

    xaudio_data = *xaudio;

    status = lose_xaudio(xaudio_data);
    free(xaudio_data);

    return status;
}
