/*
 * xaudio.q.c
 * Copyright (C) 2007-2008, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <sys/ioctl.h>
#include <sys/soundcard.h>

#include <class.h>
#include <defs.h>
#include <types.h>

static int mean_xaudio(struct xaudio_type *, unsigned *);

static int
mean_xaudio(struct xaudio_type *xaudio_data, unsigned *query)
{
    int status, trans;

    if (ioctl(xaudio_data->fd, SNDCTL_DSP_GETFMTS, &trans) == -1) {
	status = DSPQ_ERROR;
    } else {
	status = 0;

#if !__MATCH_CLASS__
	*query = trans;
#else
	{
	    unsigned shift = 0;

	    if (trans & AFMT_S16_BE) {
		shift |= S16B_CLASS;
	    }
	    if (trans & AFMT_S16_LE) {
		shift |= S16L_CLASS;
	    }
	    if (trans & AFMT_S8) {
		shift |= S010_CLASS;
	    }
	    if (trans & AFMT_U16_BE) {
		shift |= U16B_CLASS;
	    }
	    if (trans & AFMT_U16_LE) {
		shift |= U16L_CLASS;
	    }
	    if (trans & AFMT_U8) {
		shift |= U010_CLASS;
	    }

	    *query = shift;
	}
#endif				/* !__MATCH_CLASS__ */
    }

    return status;
}


int
libxaudio_list_xaudio(void *xaudio, unsigned *query)
{
    int status;

    status = mean_xaudio(xaudio, query);

    return status;
}
