/*
 * e1f4.1.c
 * Copyright (C) 2003, 2004  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e1f4.0.h>
#include <e1f4.1.h>
#include <e1f4.3.h>

void
Mylene1f4_find_audio(struct Mylene1f4_audio *audio)
{
    while (1) {
	unsigned header;

	if (audio->size < 4) {
	    audio->minimum_useful_size = 4;
	    Mylene1f4_correct_underflow(audio);
	}
	header = *(unsigned *) audio->buffer;
#if WORDS_BIGENDIAN
	if ((header & 0xfff00000) != 0xfff00000 || !(header & 0x00060000)
	    || (header & 0x00000c00) == 0x00000c00 || !(header & 0x0000f000)
	    || (header & 0x0000f000) == 0x0000f000) {
	} else {
	    break;
	}
#else
	if ((header & 0x0000f0ff) != 0x0000f0ff || !(header & 0x00000600)
	    || (header & 0x000c0000) == 0x000c0000 || !(header & 0x00f00000)
	    || (header & 0x00f00000) == 0x00f00000) {
	} else {
	    break;
	}
#endif				/* WORDS_BIGENDIAN */
	audio->buffer++;
	audio->size--;
    }
}
