/*
 * e1f4.2.11172.c
 * Copyright (C) 2003, 2004, 2005, 2006, 2007, 2008  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e1f4.1.h>
#include <e1f4.3.h>
#include <e1f4.4.h>
#include <e1f4.a.h>

#define __RUN_FUTILE__			0

extern Mylene1f4_real _Mylene1f4_table_3_B_1___[][64];
extern unsigned *_Mylene1f4_table_3_B_4___[];
extern const unsigned _Mylene1f4_table_3_B_2x_3[],
    _Mylene1f4_table_3_B_2x_5[], _Mylene1f4_table_3_B_2x_6[][4],
    _Mylene1f4_table_3_B_2x_7[][32], _Mylene1f4_table_select_0[][16],
    _Mylene1f4_table_select_1[][16];

static void audio_data_2(struct Mylene1f4_audio *);
static void audio_data_6(struct Mylene1f4_audio *);
static void audio_data_e(struct Mylene1f4_audio *);
static void audio_data_g(struct Mylene1f4_audio *);

void (* _Mylene1f4_4294967291_audio_data__II[]) (struct Mylene1f4_audio *) =
{
/* *INDENT-OFF* */
    audio_data_2, audio_data_6, audio_data_2, audio_data_e, audio_data_g
/* *INDENT-ON* */
};

static void
audio_data_2(struct Mylene1f4_audio *audio)
{
    /*
     * if (mode == single_channel) {                                    
     *     for (sb = 0; sb < sblimit; sb++) {                           
     *         allocation[sb]                                     2..4  uimsbf
     *     }                                                            
     *     for (sb = 0; sb < sblimit; sb++) {                           
     *         if (allocation[sb] != 0) {                               
     *             scfsi[sb]                                         2  bslbf
     *         }                                                        
     *     }                                                            
     *     for (sb = 0; sb < sblimit; sb++) {                           
     *         if (allocation[sb] != 0) {                               
     *             if (scfsi[sb] == 0) {                                
     *                 scalefactor[sb][0]                            6  uimsbf
     *                 scalefactor[sb][1]                            6  uimsbf
     *                 scalefactor[sb][2]                            6  uimsbf
     *             }                                                    
     *             if (scfsi[sb] == 1 || scfsi[sb] == 3) {              
     *                 scalefactor[sb][0]                            6  uimsbf
     *                 scalefactor[sb][2]                            6  uimsbf
     *             }                                                    
     *             if (scfsi[sb] == 2) {                                
     *                 scalefactor[sb][0]                            6  uimsbf
     *             }                                                    
     *         }                                                        
     *         for (gr = 0; gr < 12; gr++) {                            
     *             for (sb = 0; sb < sblimit; sb++) {                   
     *                 if (allocation[sb] != 0) {                       
     *                     if (grouping[sb]) {                          
     *                         samplecode[sb][gr]                5..10  uimsbf
     *                     } else {                                     
     *                         for (s = 0; s < 3; s++) {                
     *                             sample[sb][3 * gr + s]        2..16  uimsbf
     *                         }                                        
     *                     }                                            
     *                 }                                                
     *             }                                                    
     *         }                                                        
     *     }                                                            
     * }                                                                
     * if (mode == stereo || mode == dual_channel) {                    
     *     for (sb = 0; sb < sblimit; sb++) {                           
     *         for (ch = 0; ch < 2; ch++) {                             
     *             allocation[ch][sb]                             2..4  uimsbf
     *         }                                                        
     *     }                                                            
     *     for (sb = 0; sb < sblimit; sb++) {                           
     *         for (ch = 0; ch < 2; ch++) {                             
     *             if (allocation[ch][sb] != 0) {                       
     *                 scfsi[ch][sb]                                 2  bslbf
     *             }                                                    
     *         }                                                        
     *     }                                                            
     *     for (sb = 0; sb < sblimit; sb++) {                           
     *         for (ch = 0; ch < 2; ch++) {                             
     *             if (allocation[ch][sb] != 0) {                       
     *                 if (scfsi[ch][sb] == 0) {                        
     *                     scalefactor[ch][sb][0]                    6  uimsbf
     *                     scalefactor[ch][sb][1]                    6  uimsbf
     *                     scalefactor[ch][sb][2]                    6  uimsbf
     *                 }                                                
     *                 if (scfsi[ch][sb] == 1 || scfsi[ch][sb] == 3) {  
     *                     scalefactor[ch][sb][0]                    6  uimsbf
     *                     scalefactor[ch][sb][2]                    6  uimsbf
     *                 }                                                
     *                 if (scfsi[ch][sb] == 2) {                        
     *                     scalefactor[ch][sb][0]                    6  uimsbf
     *                 }                                                
     *             }                                                    
     *         }                                                        
     *     }                                                            
     *     for (gr = 0; gr < 12; gr++) {                                
     *         for (sb = 0; sb < sblimit; sb++) {                       
     *             for (ch = 0; ch < 2; ch++) {                         
     *                 if (allocation[ch][sb] != 0) {                   
     *                     if (grouping[ch][sb]) {                      
     *                         samplecode[ch][sb][gr]            5..10  uimsbf
     *                     } else {                                     
     *                         for (s = 0; s < 3; s++) {                
     *                             sample[ch][sb][3 * gr + s]    2..16  uimsbf
     *                         }                                        
     *                     }                                            
     *                 }                                                
     *             }                                                    
     *         }                                                        
     *     }                                                            
     * }                                                                
     * if (mode == intensity_stereo) {                                  
     *     for (sb = 0; sb < bound; sb++) {                             
     *         for (ch = 0; ch < 2; ch++) {                             
     *             allocation[ch][sb]                             2..4  uimsbf
     *         }                                                        
     *     }                                                            
     *     for (sb = bound; sb < sblimit; sb++) {                       
     *         allocation[sb]                                     2..4  uimsbf
     *     }                                                            
     *     for (sb = 0; sb < bound; sb++) {                             
     *         for (ch = 0; ch < 2; ch++) {                             
     *             if (allocation[ch][sb] != 0) {                       
     *                 scfsi[ch][sb]                                 2  bslbf
     *             }                                                    
     *         }                                                        
     *     }                                                            
     *     for (sb = bound; sb < sblimit; sb++) {                       
     *         for (ch = 0; ch < 2; ch++) {                             
     *             if (allocation[ch][sb] != 0) {                       
     *                 scfsi[ch][sb]                                 2  bslbf
     *             }                                                    
     *         }                                                        
     *     }                                                            
     *     for (sb = 0; sb < bound; sb++) {                             
     *         for (ch = 0; ch < 2; ch++) {                             
     *             if (allocation[ch][sb] != 0) {                       
     *                 if (scfsi[ch][sb] == 0) {                        
     *                     scalefactor[ch][sb][0]                    6  uimsbf
     *                     scalefactor[ch][sb][1]                    6  uimsbf
     *                     scalefactor[ch][sb][2]                    6  uimsbf
     *                 }                                                
     *                 if (scfsi[ch][sb] == 1 || scfsi[ch][sb] == 3) {  
     *                     scalefactor[ch][sb][0]                    6  uimsbf
     *                     scalefactor[ch][sb][2]                    6  uimsbf
     *                 }                                                
     *                 if (scfsi[ch][sb] == 2) {                        
     *                     scalefactor[ch][sb][0]                    6  uimsbf
     *                 }                                                
     *             }                                                    
     *         }                                                        
     *     }                                                            
     *     for (sb = bound; sb < sblimit; sb++) {                       
     *         for (ch = 0; ch < 2; ch++) {                             
     *             if (allocation[sb] != 0) {                           
     *                 if (scfsi[ch][sb] == 0) {                        
     *                     scalefactor[ch][sb][0]                    6  uimsbf
     *                     scalefactor[ch][sb][1]                    6  uimsbf
     *                     scalefactor[ch][sb][2]                    6  uimsbf
     *                 }                                                
     *                 if (scfsi[ch][sb] == 1 || scfsi[ch][sb] == 3) {  
     *                     scalefactor[ch][sb][0]                    6  uimsbf
     *                     scalefactor[ch][sb][2]                    6  uimsbf
     *                 }                                                
     *                 if (scfsi[ch][sb] == 2) {                        
     *                     scalefactor[ch][sb][0]                    6  uimsbf
     *                 }                                                
     *             }                                                    
     *         }                                                        
     *     }                                                            
     *     for (gr = 0; gr < 12; gr++) {                                
     *         for (sb = 0; sb < bound; sb++) {                         
     *             for (ch = 0; ch < 2; ch++) {                         
     *                 if (allocation[ch][sb] != 0) {                   
     *                     if (grouping[ch][sb]) {                      
     *                         samplecode[ch][sb][gr]            5..10  uimsbf
     *                     } else {                                     
     *                         for (s = 0; s < 3; s++) {                
     *                             sample[ch][sb][3 * gr + s]    2..16  uimsbf
     *                         }                                        
     *                     }                                            
     *                 }                                                
     *             }                                                    
     *         }                                                        
     *         for (sb = bound; sb < sblimit; sb++) {                   
     *             if (allocation[sb] != 0) {                           
     *                 if (grouping[sb]) {                              
     *                     samplecode[sb][gr]                    5..10  uimsbf
     *                 } else {                                         
     *                     for (s = 0; s < 3; s++) {                    
     *                         sample[sb][3 * gr + s]            2..16  uimsbf
     *                     }                                            
     *                 }                                                
     *             }                                                    
     *         }                                                        
     *     }                                                            
     * }                                                                
     */
    Mylene1f4_real fraction[2][4][32];
    unsigned *aeao, allocation[64], *aoaio, cache_buffer, cache_size = 32, i,
	*malevolent, sblimit, scalefactor[0300], scfsi[64], select, size;
    unsigned char *buffer, *output;

    buffer = audio->audio_data_buffer;
    size = audio->audio_data_size;

    select = _Mylene1f4_table_select_1
	[audio->sampling_frequency][audio->bitrate_index];
    malevolent = (unsigned *) _Mylene1f4_table_3_B_2x_6[select];

    aoaio = allocation;
    i = *malevolent++;
    size -= i;
    for (; i; i--) {
	*aoaio++ = *buffer >> 4;
	*aoaio++ = *buffer++ & 017;
    }

    cache_buffer =
	*buffer << 030 | buffer[1] << 020 | buffer[2] << 010 | buffer[3];
    buffer += 4;
    size -= 4;

    for (i = *malevolent++; i; i--) {
	if (cache_size < 6) {
	    cache_buffer = cache_buffer << 030 | *buffer << 020
		| buffer[1] << 010 | buffer[2];
	    buffer += 3;
	    cache_size += 24;
	    size -= 3;
	}
	cache_size -= 3;
	*aoaio++ = (cache_buffer >> cache_size) & 007;
	cache_size -= 3;
	*aoaio++ = (cache_buffer >> cache_size) & 007;
    }
    for (i = *malevolent; i; i--) {
	if (cache_size < 4) {
	    cache_buffer = cache_buffer << 030 | *buffer << 020
		| buffer[1] << 010 | buffer[2];
	    buffer += 3;
	    cache_size += 24;
	    size -= 3;
	}
	cache_size -= 2;
	*aoaio++ = (cache_buffer >> cache_size) & 003;
	cache_size -= 2;
	*aoaio++ = (cache_buffer >> cache_size) & 003;
    }

    sblimit = _Mylene1f4_table_3_B_2x_3[select];

    malevolent = scfsi;
    aoaio = allocation;
    for (i = sblimit << 1; i; i--) {
	if (*aoaio++) {
	    if (cache_size < 2) {
		if (size < 3) {
		    _Mylene1f4_abort_decoding
			((struct Mylene1f4_whatever *) audio,
			 AUDIO_AUDIO_DATA_FAULT);
		}
		cache_buffer = cache_buffer << 030 | *buffer << 020
		    | buffer[1] << 010 | buffer[2];
		buffer += 3;
		cache_size += 24;
		size -= 3;
	    }
	    cache_size -= 2;
	    *malevolent++ = (cache_buffer >> cache_size) & 003;
	}
    }

    malevolent = scfsi;
    aeao = scalefactor;
    aoaio = allocation;
    for (i = sblimit << 1; i; i--) {
	if (*aoaio++) {
	    switch (*malevolent++) {
	    case 0:
		if (cache_size < 18) {
		    if (cache_size == 17) {
			if (!size) {
			    _Mylene1f4_abort_decoding
				((struct Mylene1f4_whatever *) audio,
				 AUDIO_AUDIO_DATA_FAULT);
			}
			cache_buffer = cache_buffer << 010 | *buffer++;
			cache_size += 8;
			size--;
		    } else if (8 < cache_size) {
			if (size < 2) {
			    _Mylene1f4_abort_decoding
				((struct Mylene1f4_whatever *) audio,
				 AUDIO_AUDIO_DATA_FAULT);
			}
			cache_buffer = cache_buffer << 020 | *buffer << 010
			    | buffer[1];
			buffer += 2;
			cache_size += 16;
			size -= 2;
		    } else {
			if (size < 2) {
			    _Mylene1f4_abort_decoding
				((struct Mylene1f4_whatever *) audio,
				 AUDIO_AUDIO_DATA_FAULT);
			}
			cache_buffer = cache_buffer << 030 | *buffer << 020
			    | buffer[1] << 010 | buffer[2];
			buffer += 3;
			cache_size += 24;
			size -= 3;
		    }
		}
		cache_size -= 6;
		*aeao++ = (cache_buffer >> cache_size) & 077;
		cache_size -= 6;
		*aeao++ = (cache_buffer >> cache_size) & 077;
		cache_size -= 6;
		*aeao++ = (cache_buffer >> cache_size) & 077;
		break;
	    case 1:
		if (cache_size < 12) {
		    if (size < 2) {
			_Mylene1f4_abort_decoding
			    ((struct Mylene1f4_whatever *) audio,
			     AUDIO_AUDIO_DATA_FAULT);
		    }
		    cache_buffer = cache_buffer << 020 | *buffer << 010
			| buffer[1];
		    buffer += 2;
		    cache_size += 16;
		    size -= 2;
		}
		cache_size -= 6;
		{
		    unsigned select;

		    select = (cache_buffer >> cache_size) & 077;
		    *aeao++ = select;
		    *aeao++ = select;
		}
		cache_size -= 6;
		*aeao++ = (cache_buffer >> cache_size) & 077;
		break;
	    case 2:
		if (cache_size < 6) {
		    if (size < 3) {
			_Mylene1f4_abort_decoding
			    ((struct Mylene1f4_whatever *) audio,
			     AUDIO_AUDIO_DATA_FAULT);
		    }
		    cache_buffer = cache_buffer << 030 | *buffer << 020
			| buffer[1] << 010 | buffer[2];
		    buffer += 3;
		    cache_size += 24;
		    size -= 3;
		}
		cache_size -= 6;
		{
		    unsigned select;

		    select = (cache_buffer >> cache_size) & 077;
		    *aeao++ = select;
		    *aeao++ = select;
		    *aeao++ = select;
		}
		break;
	    case 3:
		if (cache_size < 12) {
		    if (size < 2) {
			_Mylene1f4_abort_decoding
			    ((struct Mylene1f4_whatever *) audio,
			     AUDIO_AUDIO_DATA_FAULT);
		    }
		    cache_buffer = cache_buffer << 020 | *buffer << 010
			| buffer[1];
		    buffer += 2;
		    cache_size += 16;
		    size -= 2;
		}
		cache_size -= 6;
		*aeao++ = (cache_buffer >> cache_size) & 077;
		cache_size -= 6;
		{
		    unsigned select;

		    select = (cache_buffer >> cache_size) & 077;
		    *aeao++ = select;
		    *aeao++ = select;
		}
	    }
	}
    }

    output = audio->output;
    for (i = 0; i < 12; i++) {
	Mylene1f4_real *aio;
	unsigned j = 0;

	malevolent = (unsigned *) _Mylene1f4_table_3_B_2x_5
	    + audio->layer_data.II.table_3_B_2x_4[select];
	aeao = scalefactor + (i >> 2);
	aio = (Mylene1f4_real *) fraction;
	aoaio = allocation;
	for (; j < sblimit; j++) {
	    unsigned k = 0;

	    for (; k < 2; k++) {
		aio += k << 7;
		if (*aoaio) {
		    unsigned mask, nbits, *une_ideacutee_fixe;

		    une_ideacutee_fixe = malevolent + (*aoaio << 1);
		    mask = une_ideacutee_fixe[1];
		    nbits = *une_ideacutee_fixe;
		    if (mask & 1) {
			Mylene1f4_real multiplier;

			multiplier = _Mylene1f4_table_3_B_1___[nbits][*aeao];
			if (cache_size < nbits) {
			    if (8 < nbits - cache_size) {
				if (size < 2) {
				    _Mylene1f4_class_section(audio, i);
				}
				cache_buffer = cache_buffer << 020
				    | *buffer << 010 | buffer[1];
				buffer += 2;
				cache_size += 16;
				size -= 2;
			    } else {
				if (!size) {
				    _Mylene1f4_class_section(audio, i);
				}
				cache_buffer = cache_buffer << 010 | *buffer++;
				cache_size += 8;
				size--;
			    }
			}
			cache_size -= nbits;
			*aio = (Mylene1f4_real) (int)
			    (((cache_buffer >> cache_size) & mask)
			     - (mask >> 1)) * multiplier;
			if (cache_size < nbits) {
			    if (8 < nbits - cache_size) {
				if (size < 2) {
				    _Mylene1f4_class_section(audio, i);
				}
				cache_buffer = cache_buffer << 020
				    | *buffer << 010 | buffer[1];
				buffer += 2;
				cache_size += 16;
				size -= 2;
			    } else {
				if (!size) {
				    _Mylene1f4_class_section(audio, i);
				}
				cache_buffer = cache_buffer << 010 | *buffer++;
				cache_size += 8;
				size--;
			    }
			}
			cache_size -= nbits;
			aio[32] = (Mylene1f4_real) (int)
			    (((cache_buffer >> cache_size) & mask)
			     - (mask >> 1)) * multiplier;
			if (cache_size < nbits) {
			    if (8 < nbits - cache_size) {
				if (size < 2) {
				    _Mylene1f4_class_section(audio, i);
				}
				cache_buffer = cache_buffer << 020
				    | *buffer << 010 | buffer[1];
				buffer += 2;
				cache_size += 16;
				size -= 2;
			    } else {
				if (!size) {
				    _Mylene1f4_class_section(audio, i);
				}
				cache_buffer = cache_buffer << 010 | *buffer++;
				cache_size += 8;
				size--;
			    }
			}
			cache_size -= nbits;
			aio[64] = (Mylene1f4_real) (int)
			    (((cache_buffer >> cache_size) & mask)
			     - (mask >> 1)) * multiplier;
		    } else {
			Mylene1f4_real *table_3_B_1___;
			unsigned select, *table_3_B_4___;

			if (cache_size < nbits) {
			    if (8 < nbits - cache_size) {
				if (size < 2) {
				    _Mylene1f4_class_section(audio, i);
				}
				cache_buffer = cache_buffer << 020
				    | *buffer << 010 | buffer[1];
				buffer += 2;
				cache_size += 16;
				size -= 2;
			    } else {
				if (!size) {
				    _Mylene1f4_class_section(audio, i);
				}
				cache_buffer = cache_buffer << 010 | *buffer++;
				cache_size += 8;
				size--;
			    }
			}
			cache_size -= nbits;
			select = cache_buffer >> cache_size;
			select = (select & ((1 << nbits) - 1));
			table_3_B_4___ = _Mylene1f4_table_3_B_4___[mask];
			table_3_B_4___ += select + select + select;
			table_3_B_1___ =
			    (Mylene1f4_real *) _Mylene1f4_table_3_B_1___;
			table_3_B_1___ += *aeao;
			*aio = table_3_B_1___[*table_3_B_4___];
			aio[32] = table_3_B_1___[*++table_3_B_4___];
			aio[64] = table_3_B_1___[*++table_3_B_4___];
		    }
		    aeao += 3;
		} else {
		    *aio = 0;
		    aio[32] = 0;
		    aio[64] = 0;
		}
		aoaio++;
	    }
	    aio -= 127;
	    malevolent += *malevolent;
	}

	for (; j < 32; j++) {
	    *aio = 0;
	    aio[0040] = 0;
	    aio[0100] = 0;
	    aio[0200] = 0;
	    aio[0240] = 0;
	    aio[0300] = 0;
	    aio++;
	}

#if !__RUN_FUTILE__
	audio->polyphase_synthesis_1(audio, fraction[0][0], 0, output, 3);
	audio->polyphase_synthesis_1(audio, fraction[1][0], 1, output, 3);
#endif				/* !__RUN_FUTILE__ */

	output += 192 << audio->sample_shift;
    }

    audio->buffer += audio->audio_data_size;
    audio->size -= audio->audio_data_size;
    audio->syncword_offset -= audio->audio_data_size;
}


static void
audio_data_6(struct Mylene1f4_audio *audio)
{
    Mylene1f4_real fraction[2][4][32];
    unsigned *aeao, allocation[64], *aoaio, bound, cache_buffer, cache_size =
	32, i, *malevolent, sblimit, scalefactor[0300], scfsi[64], select, size;
    unsigned char *buffer, *output;

    buffer = audio->audio_data_buffer;
    size = audio->audio_data_size;

    select = _Mylene1f4_table_select_1
	[audio->sampling_frequency][audio->bitrate_index];
    malevolent = (unsigned *) _Mylene1f4_table_3_B_2x_7[select];

    bound = audio->bound;

    aoaio = allocation;
    malevolent += (bound - 4) << 1;
    i = *malevolent++;
    size -= i;
    for (; i; i--) {
	*aoaio++ = *buffer >> 4;
	*aoaio++ = *buffer++ & 017;
    }
    i = *malevolent >> 1;
    size -= i;
    for (; i; i--) {
	unsigned select;

	select = *buffer >> 4;
	*aoaio++ = select;
	*aoaio++ = select;
	select = *buffer++ & 017;
	*aoaio++ = select;
	*aoaio++ = select;
    }

    cache_buffer =
	*buffer << 030 | buffer[1] << 020 | buffer[2] << 010 | buffer[3];
    buffer += 4;
    size -= 4;

    if (*malevolent++ & 1) {
	unsigned select;

	cache_size = 28;
	select = cache_buffer >> 28;
	*aoaio++ = select;
	*aoaio++ = select;
    }
    for (i = *malevolent++; i; i--) {
	if (cache_size < 6) {
	    cache_buffer = cache_buffer << 030 | *buffer << 020
		| buffer[1] << 010 | buffer[2];
	    buffer += 3;
	    cache_size += 24;
	    size -= 3;
	}
	cache_size -= 3;
	*aoaio++ = (cache_buffer >> cache_size) & 007;
	cache_size -= 3;
	*aoaio++ = (cache_buffer >> cache_size) & 007;
    }
    for (i = *malevolent++; i; i--) {
	if (cache_size < 3) {
	    cache_buffer = cache_buffer << 030 | *buffer << 020
		| buffer[1] << 010 | buffer[2];
	    buffer += 3;
	    cache_size += 24;
	    size -= 3;
	}
	cache_size -= 3;
	{
	    unsigned select;

	    select = (cache_buffer >> cache_size) & 007;
	    *aoaio++ = select;
	    *aoaio++ = select;
	}
    }
    for (i = *malevolent++; i; i--) {
	if (cache_size < 4) {
	    cache_buffer = cache_buffer << 030 | *buffer << 020
		| buffer[1] << 010 | buffer[2];
	    buffer += 3;
	    cache_size += 24;
	    size -= 3;
	}
	cache_size -= 2;
	*aoaio++ = (cache_buffer >> cache_size) & 003;
	cache_size -= 2;
	*aoaio++ = (cache_buffer >> cache_size) & 003;
    }
    for (i = *malevolent; i; i--) {
	if (cache_size < 2) {
	    cache_buffer = cache_buffer << 030 | *buffer << 020
		| buffer[1] << 010 | buffer[2];
	    buffer += 3;
	    cache_size += 24;
	    size -= 3;
	}
	cache_size -= 2;
	{
	    unsigned select;

	    select = (cache_buffer >> cache_size) & 003;
	    *aoaio++ = select;
	    *aoaio++ = select;
	}
    }

    sblimit = _Mylene1f4_table_3_B_2x_3[select];

    malevolent = scfsi;
    aoaio = allocation;
    for (i = sblimit << 1; i; i--) {
	if (*aoaio++) {
	    if (cache_size < 2) {
		if (size < 3) {
		    _Mylene1f4_abort_decoding
			((struct Mylene1f4_whatever *) audio,
			 AUDIO_AUDIO_DATA_FAULT);
		}
		cache_buffer = cache_buffer << 030 | *buffer << 020
		    | buffer[1] << 010 | buffer[2];
		buffer += 3;
		cache_size += 24;
		size -= 3;
	    }
	    cache_size -= 2;
	    *malevolent++ = (cache_buffer >> cache_size) & 003;
	}
    }

    malevolent = scfsi;
    aeao = scalefactor;
    aoaio = allocation;
    for (i = sblimit << 1; i; i--) {
	if (*aoaio++) {
	    switch (*malevolent++) {
	    case 0:
		if (cache_size < 18) {
		    if (cache_size == 17) {
			if (!size) {
			    _Mylene1f4_abort_decoding
				((struct Mylene1f4_whatever *) audio,
				 AUDIO_AUDIO_DATA_FAULT);
			}
			cache_buffer = cache_buffer << 010 | *buffer++;
			cache_size += 8;
			size--;
		    } else if (8 < cache_size) {
			if (size < 2) {
			    _Mylene1f4_abort_decoding
				((struct Mylene1f4_whatever *) audio,
				 AUDIO_AUDIO_DATA_FAULT);
			}
			cache_buffer = cache_buffer << 020 | *buffer << 010
			    | buffer[1];
			buffer += 2;
			cache_size += 16;
			size -= 2;
		    } else {
			if (size < 2) {
			    _Mylene1f4_abort_decoding
				((struct Mylene1f4_whatever *) audio,
				 AUDIO_AUDIO_DATA_FAULT);
			}
			cache_buffer = cache_buffer << 030 | *buffer << 020
			    | buffer[1] << 010 | buffer[2];
			buffer += 3;
			cache_size += 24;
			size -= 3;
		    }
		}
		cache_size -= 6;
		*aeao++ = (cache_buffer >> cache_size) & 077;
		cache_size -= 6;
		*aeao++ = (cache_buffer >> cache_size) & 077;
		cache_size -= 6;
		*aeao++ = (cache_buffer >> cache_size) & 077;
		break;
	    case 1:
		if (cache_size < 12) {
		    if (size < 2) {
			_Mylene1f4_abort_decoding
			    ((struct Mylene1f4_whatever *) audio,
			     AUDIO_AUDIO_DATA_FAULT);
		    }
		    cache_buffer = cache_buffer << 020 | *buffer << 010
			| buffer[1];
		    buffer += 2;
		    cache_size += 16;
		    size -= 2;
		}
		cache_size -= 6;
		{
		    unsigned select;

		    select = (cache_buffer >> cache_size) & 077;
		    *aeao++ = select;
		    *aeao++ = select;
		}
		cache_size -= 6;
		*aeao++ = (cache_buffer >> cache_size) & 077;
		break;
	    case 2:
		if (cache_size < 6) {
		    if (size < 3) {
			_Mylene1f4_abort_decoding
			    ((struct Mylene1f4_whatever *) audio,
			     AUDIO_AUDIO_DATA_FAULT);
		    }
		    cache_buffer = cache_buffer << 030 | *buffer << 020
			| buffer[1] << 010 | buffer[2];
		    buffer += 3;
		    cache_size += 24;
		    size -= 3;
		}
		cache_size -= 6;
		{
		    unsigned select;

		    select = (cache_buffer >> cache_size) & 077;
		    *aeao++ = select;
		    *aeao++ = select;
		    *aeao++ = select;
		}
		break;
	    case 3:
		if (cache_size < 12) {
		    if (size < 2) {
			_Mylene1f4_abort_decoding
			    ((struct Mylene1f4_whatever *) audio,
			     AUDIO_AUDIO_DATA_FAULT);
		    }
		    cache_buffer = cache_buffer << 020 | *buffer << 010
			| buffer[1];
		    buffer += 2;
		    cache_size += 16;
		    size -= 2;
		}
		cache_size -= 6;
		*aeao++ = (cache_buffer >> cache_size) & 077;
		cache_size -= 6;
		{
		    unsigned select;

		    select = (cache_buffer >> cache_size) & 077;
		    *aeao++ = select;
		    *aeao++ = select;
		}
	    }
	}
    }

    output = audio->output;
    for (i = 0; i < 12; i++) {
	Mylene1f4_real *aio;
	unsigned j = 0;

	malevolent = (unsigned *) _Mylene1f4_table_3_B_2x_5
	    + audio->layer_data.II.table_3_B_2x_4[select];
	aeao = scalefactor + (i >> 2);
	aio = (Mylene1f4_real *) fraction;
	aoaio = allocation;
	for (; j < bound; j++) {
	    unsigned k = 0;

	    for (; k < 2; k++) {
		aio += k << 7;
		if (*aoaio) {
		    unsigned mask, nbits, *une_ideacutee_fixe;

		    une_ideacutee_fixe = malevolent + (*aoaio << 1);
		    mask = une_ideacutee_fixe[1];
		    nbits = *une_ideacutee_fixe;
		    if (mask & 1) {
			Mylene1f4_real multiplier;

			multiplier = _Mylene1f4_table_3_B_1___[nbits][*aeao];
			if (cache_size < nbits) {
			    if (8 < nbits - cache_size) {
				if (size < 2) {
				    _Mylene1f4_class_section(audio, i);
				}
				cache_buffer = cache_buffer << 020
				    | *buffer << 010 | buffer[1];
				buffer += 2;
				cache_size += 16;
				size -= 2;
			    } else {
				if (!size) {
				    _Mylene1f4_class_section(audio, i);
				}
				cache_buffer = cache_buffer << 010 | *buffer++;
				cache_size += 8;
				size--;
			    }
			}
			cache_size -= nbits;
			*aio = (Mylene1f4_real) (int)
			    (((cache_buffer >> cache_size) & mask)
			     - (mask >> 1)) * multiplier;
			if (cache_size < nbits) {
			    if (8 < nbits - cache_size) {
				if (size < 2) {
				    _Mylene1f4_class_section(audio, i);
				}
				cache_buffer = cache_buffer << 020
				    | *buffer << 010 | buffer[1];
				buffer += 2;
				cache_size += 16;
				size -= 2;
			    } else {
				if (!size) {
				    _Mylene1f4_class_section(audio, i);
				}
				cache_buffer = cache_buffer << 010 | *buffer++;
				cache_size += 8;
				size--;
			    }
			}
			cache_size -= nbits;
			aio[32] = (Mylene1f4_real) (int)
			    (((cache_buffer >> cache_size) & mask)
			     - (mask >> 1)) * multiplier;
			if (cache_size < nbits) {
			    if (8 < nbits - cache_size) {
				if (size < 2) {
				    _Mylene1f4_class_section(audio, i);
				}
				cache_buffer = cache_buffer << 020
				    | *buffer << 010 | buffer[1];
				buffer += 2;
				cache_size += 16;
				size -= 2;
			    } else {
				if (!size) {
				    _Mylene1f4_class_section(audio, i);
				}
				cache_buffer = cache_buffer << 010 | *buffer++;
				cache_size += 8;
				size--;
			    }
			}
			cache_size -= nbits;
			aio[64] = (Mylene1f4_real) (int)
			    (((cache_buffer >> cache_size) & mask)
			     - (mask >> 1)) * multiplier;
		    } else {
			Mylene1f4_real *table_3_B_1___;
			unsigned select, *table_3_B_4___;

			if (cache_size < nbits) {
			    if (8 < nbits - cache_size) {
				if (size < 2) {
				    _Mylene1f4_class_section(audio, i);
				}
				cache_buffer = cache_buffer << 020
				    | *buffer << 010 | buffer[1];
				buffer += 2;
				cache_size += 16;
				size -= 2;
			    } else {
				if (!size) {
				    _Mylene1f4_class_section(audio, i);
				}
				cache_buffer = cache_buffer << 010 | *buffer++;
				cache_size += 8;
				size--;
			    }
			}
			cache_size -= nbits;
			select = cache_buffer >> cache_size;
			select = (select & ((1 << nbits) - 1));
			table_3_B_4___ = _Mylene1f4_table_3_B_4___[mask];
			table_3_B_4___ += select + select + select;
			table_3_B_1___ =
			    (Mylene1f4_real *) _Mylene1f4_table_3_B_1___;
			table_3_B_1___ += *aeao;
			*aio = table_3_B_1___[*table_3_B_4___];
			aio[32] = table_3_B_1___[*++table_3_B_4___];
			aio[64] = table_3_B_1___[*++table_3_B_4___];
		    }
		    aeao += 3;
		} else {
		    *aio = 0;
		    aio[32] = 0;
		    aio[64] = 0;
		}
		aoaio++;
	    }
	    aio -= 127;
	    malevolent += *malevolent;
	}
	for (; j < sblimit; j++) {
	    {
		if (*aoaio) {
		    unsigned mask, nbits, *une_ideacutee_fixe;

		    une_ideacutee_fixe = malevolent + (*aoaio << 1);
		    mask = une_ideacutee_fixe[1];
		    nbits = *une_ideacutee_fixe;
		    if (mask & 1) {
			Mylene1f4_real multiplier;

			multiplier =
			    _Mylene1f4_table_3_B_1___[nbits][*(aeao + 3)];
			if (cache_size < nbits) {
			    if (8 < nbits - cache_size) {
				if (size < 2) {
				    _Mylene1f4_class_section(audio, i);
				}
				cache_buffer = cache_buffer << 020
				    | *buffer << 010 | buffer[1];
				buffer += 2;
				cache_size += 16;
				size -= 2;
			    } else {
				if (!size) {
				    _Mylene1f4_class_section(audio, i);
				}
				cache_buffer = cache_buffer << 010 | *buffer++;
				cache_size += 8;
				size--;
			    }
			}
			cache_size -= nbits;
			aio[128] = (*aio = (Mylene1f4_real) (int)
				    (((cache_buffer >> cache_size) & mask)
				     - (mask >> 1))) * multiplier;
			if (cache_size < nbits) {
			    if (8 < nbits - cache_size) {
				if (size < 2) {
				    _Mylene1f4_class_section(audio, i);
				}
				cache_buffer = cache_buffer << 020
				    | *buffer << 010 | buffer[1];
				buffer += 2;
				cache_size += 16;
				size -= 2;
			    } else {
				if (!size) {
				    _Mylene1f4_class_section(audio, i);
				}
				cache_buffer = cache_buffer << 010 | *buffer++;
				cache_size += 8;
				size--;
			    }
			}
			cache_size -= nbits;
			aio[160] = (aio[32] = (Mylene1f4_real) (int)
				    (((cache_buffer >> cache_size) & mask)
				     - (mask >> 1))) * multiplier;
			if (cache_size < nbits) {
			    if (8 < nbits - cache_size) {
				if (size < 2) {
				    _Mylene1f4_class_section(audio, i);
				}
				cache_buffer = cache_buffer << 020
				    | *buffer << 010 | buffer[1];
				buffer += 2;
				cache_size += 16;
				size -= 2;
			    } else {
				if (!size) {
				    _Mylene1f4_class_section(audio, i);
				}
				cache_buffer = cache_buffer << 010 | *buffer++;
				cache_size += 8;
				size--;
			    }
			}
			cache_size -= nbits;
			aio[192] = (aio[64] = (Mylene1f4_real) (int)
				    (((cache_buffer >> cache_size) & mask)
				     - (mask >> 1))) * multiplier;
			multiplier = _Mylene1f4_table_3_B_1___[nbits][*aeao];
			*aio *= multiplier;
			aio[32] *= multiplier;
			aio[64] *= multiplier;
		    } else {
			Mylene1f4_real *table_3_B_1___;
			unsigned select, *table_3_B_4___;

			if (cache_size < nbits) {
			    if (8 < nbits - cache_size) {
				if (size < 2) {
				    _Mylene1f4_class_section(audio, i);
				}
				cache_buffer = cache_buffer << 020
				    | *buffer << 010 | buffer[1];
				buffer += 2;
				cache_size += 16;
				size -= 2;
			    } else {
				if (!size) {
				    _Mylene1f4_class_section(audio, i);
				}
				cache_buffer = cache_buffer << 010 | *buffer++;
				cache_size += 8;
				size--;
			    }
			}
			cache_size -= nbits;
			select = cache_buffer >> cache_size;
			select = (select & ((1 << nbits) - 1));
			table_3_B_4___ = _Mylene1f4_table_3_B_4___[mask];
			table_3_B_4___ += select + select + select;
			table_3_B_1___ =
			    (Mylene1f4_real *) _Mylene1f4_table_3_B_1___;
			table_3_B_1___ += *aeao;
			*aio = table_3_B_1___[*table_3_B_4___];
			aio[0040] = table_3_B_1___[table_3_B_4___[1]];
			aio[0100] = table_3_B_1___[table_3_B_4___[2]];
			table_3_B_1___ =
			    (Mylene1f4_real *) _Mylene1f4_table_3_B_1___;
			table_3_B_1___ += *(aeao + 3);
			aio[0200] = table_3_B_1___[*table_3_B_4___];
			aio[0240] = table_3_B_1___[table_3_B_4___[1]];
			aio[0300] = table_3_B_1___[table_3_B_4___[2]];
		    }
		    aeao += 6;
		} else {
		    *aio = 0;
		    aio[0040] = 0;
		    aio[0100] = 0;
		    aio[0200] = 0;
		    aio[0240] = 0;
		    aio[0300] = 0;
		}
		aoaio++;
		aoaio++;
	    }
	    aio++;
	    malevolent += *malevolent;
	}

	for (; j < 32; j++) {
	    *aio = 0;
	    aio[0040] = 0;
	    aio[0100] = 0;
	    aio[0200] = 0;
	    aio[0240] = 0;
	    aio[0300] = 0;
	    aio++;
	}

#if !__RUN_FUTILE__
	audio->polyphase_synthesis_1(audio, fraction[0][0], 0, output, 3);
	audio->polyphase_synthesis_1(audio, fraction[1][0], 1, output, 3);
#endif				/* !__RUN_FUTILE__ */

	output += 192 << audio->sample_shift;
    }

    audio->buffer += audio->audio_data_size;
    audio->size -= audio->audio_data_size;
    audio->syncword_offset -= audio->audio_data_size;
}


static void
audio_data_e(struct Mylene1f4_audio *audio)
{
    Mylene1f4_real fraction[1][4][32];
    unsigned *aeao, allocation[32], *aoaio, cache_buffer, cache_size = 32, i,
	*malevolent, sblimit, scalefactor[0140], scfsi[32], select, size;
    unsigned char *buffer, *output;

    buffer = audio->audio_data_buffer;
    size = audio->audio_data_size;

    select = _Mylene1f4_table_select_0
	[audio->sampling_frequency][audio->bitrate_index];
    malevolent = (unsigned *) _Mylene1f4_table_3_B_2x_6[select];

    aoaio = allocation;
    i = *malevolent >> 1;
    size -= i;
    for (; i; i--) {
	*aoaio++ = *buffer >> 4;
	*aoaio++ = *buffer++ & 017;
    }

    cache_buffer =
	*buffer << 030 | buffer[1] << 020 | buffer[2] << 010 | buffer[3];
    buffer += 4;
    size -= 4;

    if (*malevolent++ & 1) {
	cache_size = 28;
	*aoaio++ = cache_buffer >> 28;
    }
    for (i = *malevolent++; i; i--) {
	if (cache_size < 3) {
	    cache_buffer = cache_buffer << 030 | *buffer << 020
		| buffer[1] << 010 | buffer[2];
	    buffer += 3;
	    cache_size += 24;
	    size -= 3;
	}
	cache_size -= 3;
	*aoaio++ = (cache_buffer >> cache_size) & 007;
    }
    for (i = *malevolent; i; i--) {
	if (cache_size < 2) {
	    cache_buffer = cache_buffer << 030 | *buffer << 020
		| buffer[1] << 010 | buffer[2];
	    buffer += 3;
	    cache_size += 24;
	    size -= 3;
	}
	cache_size -= 2;
	*aoaio++ = (cache_buffer >> cache_size) & 003;
    }

    sblimit = _Mylene1f4_table_3_B_2x_3[select];

    malevolent = scfsi;
    aoaio = allocation;
    for (i = sblimit; i; i--) {
	if (*aoaio++) {
	    if (cache_size < 2) {
		if (size < 3) {
		    _Mylene1f4_abort_decoding
			((struct Mylene1f4_whatever *) audio,
			 AUDIO_AUDIO_DATA_FAULT);
		}
		cache_buffer = cache_buffer << 030 | *buffer << 020
		    | buffer[1] << 010 | buffer[2];
		buffer += 3;
		cache_size += 24;
		size -= 3;
	    }
	    cache_size -= 2;
	    *malevolent++ = (cache_buffer >> cache_size) & 003;
	}
    }

    malevolent = scfsi;
    aeao = scalefactor;
    aoaio = allocation;
    for (i = sblimit; i; i--) {
	if (*aoaio++) {
	    switch (*malevolent++) {
	    case 0:
		if (cache_size < 18) {
		    if (cache_size == 17) {
			if (!size) {
			    _Mylene1f4_abort_decoding
				((struct Mylene1f4_whatever *) audio,
				 AUDIO_AUDIO_DATA_FAULT);
			}
			cache_buffer = cache_buffer << 010 | *buffer++;
			cache_size += 8;
			size--;
		    } else if (8 < cache_size) {
			if (size < 2) {
			    _Mylene1f4_abort_decoding
				((struct Mylene1f4_whatever *) audio,
				 AUDIO_AUDIO_DATA_FAULT);
			}
			cache_buffer = cache_buffer << 020 | *buffer << 010
			    | buffer[1];
			buffer += 2;
			cache_size += 16;
			size -= 2;
		    } else {
			if (size < 2) {
			    _Mylene1f4_abort_decoding
				((struct Mylene1f4_whatever *) audio,
				 AUDIO_AUDIO_DATA_FAULT);
			}
			cache_buffer = cache_buffer << 030 | *buffer << 020
			    | buffer[1] << 010 | buffer[2];
			buffer += 3;
			cache_size += 24;
			size -= 3;
		    }
		}
		cache_size -= 6;
		*aeao++ = (cache_buffer >> cache_size) & 077;
		cache_size -= 6;
		*aeao++ = (cache_buffer >> cache_size) & 077;
		cache_size -= 6;
		*aeao++ = (cache_buffer >> cache_size) & 077;
		break;
	    case 1:
		if (cache_size < 12) {
		    if (size < 2) {
			_Mylene1f4_abort_decoding
			    ((struct Mylene1f4_whatever *) audio,
			     AUDIO_AUDIO_DATA_FAULT);
		    }
		    cache_buffer = cache_buffer << 020 | *buffer << 010
			| buffer[1];
		    buffer += 2;
		    cache_size += 16;
		    size -= 2;
		}
		cache_size -= 6;
		{
		    unsigned select;

		    select = (cache_buffer >> cache_size) & 077;
		    *aeao++ = select;
		    *aeao++ = select;
		}
		cache_size -= 6;
		*aeao++ = (cache_buffer >> cache_size) & 077;
		break;
	    case 2:
		if (cache_size < 6) {
		    if (size < 3) {
			_Mylene1f4_abort_decoding
			    ((struct Mylene1f4_whatever *) audio,
			     AUDIO_AUDIO_DATA_FAULT);
		    }
		    cache_buffer = cache_buffer << 030 | *buffer << 020
			| buffer[1] << 010 | buffer[2];
		    buffer += 3;
		    cache_size += 24;
		    size -= 3;
		}
		cache_size -= 6;
		{
		    unsigned select;

		    select = (cache_buffer >> cache_size) & 077;
		    *aeao++ = select;
		    *aeao++ = select;
		    *aeao++ = select;
		}
		break;
	    case 3:
		if (cache_size < 12) {
		    if (size < 2) {
			_Mylene1f4_abort_decoding
			    ((struct Mylene1f4_whatever *) audio,
			     AUDIO_AUDIO_DATA_FAULT);
		    }
		    cache_buffer = cache_buffer << 020 | *buffer << 010
			| buffer[1];
		    buffer += 2;
		    cache_size += 16;
		    size -= 2;
		}
		cache_size -= 6;
		*aeao++ = (cache_buffer >> cache_size) & 077;
		cache_size -= 6;
		{
		    unsigned select;

		    select = (cache_buffer >> cache_size) & 077;
		    *aeao++ = select;
		    *aeao++ = select;
		}
	    }
	}
    }

    output = audio->output;
    for (i = 0; i < 12; i++) {
	Mylene1f4_real *aio;
	unsigned j = 0;

	malevolent = (unsigned *) _Mylene1f4_table_3_B_2x_5
	    + audio->layer_data.II.table_3_B_2x_4[select];
	aeao = scalefactor + (i >> 2);
	aio = (Mylene1f4_real *) fraction;
	aoaio = allocation;
	for (; j < sblimit; j++) {
	    {
		if (*aoaio) {
		    unsigned mask, nbits, *une_ideacutee_fixe;

		    une_ideacutee_fixe = malevolent + (*aoaio << 1);
		    mask = une_ideacutee_fixe[1];
		    nbits = *une_ideacutee_fixe;
		    if (mask & 1) {
			Mylene1f4_real multiplier;

			multiplier = _Mylene1f4_table_3_B_1___[nbits][*aeao];
			if (cache_size < nbits) {
			    if (8 < nbits - cache_size) {
				if (size < 2) {
				    _Mylene1f4_break_section(audio, i);
				}
				cache_buffer = cache_buffer << 020
				    | *buffer << 010 | buffer[1];
				buffer += 2;
				cache_size += 16;
				size -= 2;
			    } else {
				if (!size) {
				    _Mylene1f4_break_section(audio, i);
				}
				cache_buffer = cache_buffer << 010 | *buffer++;
				cache_size += 8;
				size--;
			    }
			}
			cache_size -= nbits;
			*aio = (Mylene1f4_real) (int)
			    (((cache_buffer >> cache_size) & mask)
			     - (mask >> 1)) * multiplier;
			if (cache_size < nbits) {
			    if (8 < nbits - cache_size) {
				if (size < 2) {
				    _Mylene1f4_break_section(audio, i);
				}
				cache_buffer = cache_buffer << 020
				    | *buffer << 010 | buffer[1];
				buffer += 2;
				cache_size += 16;
				size -= 2;
			    } else {
				if (!size) {
				    _Mylene1f4_break_section(audio, i);
				}
				cache_buffer = cache_buffer << 010 | *buffer++;
				cache_size += 8;
				size--;
			    }
			}
			cache_size -= nbits;
			aio[32] = (Mylene1f4_real) (int)
			    (((cache_buffer >> cache_size) & mask)
			     - (mask >> 1)) * multiplier;
			if (cache_size < nbits) {
			    if (8 < nbits - cache_size) {
				if (size < 2) {
				    _Mylene1f4_break_section(audio, i);
				}
				cache_buffer = cache_buffer << 020
				    | *buffer << 010 | buffer[1];
				buffer += 2;
				cache_size += 16;
				size -= 2;
			    } else {
				if (!size) {
				    _Mylene1f4_break_section(audio, i);
				}
				cache_buffer = cache_buffer << 010 | *buffer++;
				cache_size += 8;
				size--;
			    }
			}
			cache_size -= nbits;
			aio[64] = (Mylene1f4_real) (int)
			    (((cache_buffer >> cache_size) & mask)
			     - (mask >> 1)) * multiplier;
		    } else {
			Mylene1f4_real *table_3_B_1___;
			unsigned select, *table_3_B_4___;

			if (cache_size < nbits) {
			    if (8 < nbits - cache_size) {
				if (size < 2) {
				    _Mylene1f4_break_section(audio, i);
				}
				cache_buffer = cache_buffer << 020
				    | *buffer << 010 | buffer[1];
				buffer += 2;
				cache_size += 16;
				size -= 2;
			    } else {
				if (!size) {
				    _Mylene1f4_break_section(audio, i);
				}
				cache_buffer = cache_buffer << 010 | *buffer++;
				cache_size += 8;
				size--;
			    }
			}
			cache_size -= nbits;
			select = cache_buffer >> cache_size;
			select = (select & ((1 << nbits) - 1));
			table_3_B_4___ = _Mylene1f4_table_3_B_4___[mask];
			table_3_B_4___ += select + select + select;
			table_3_B_1___ =
			    (Mylene1f4_real *) _Mylene1f4_table_3_B_1___;
			table_3_B_1___ += *aeao;
			*aio = table_3_B_1___[*table_3_B_4___];
			aio[32] = table_3_B_1___[*++table_3_B_4___];
			aio[64] = table_3_B_1___[*++table_3_B_4___];
		    }
		    aeao += 3;
		} else {
		    *aio = 0;
		    aio[32] = 0;
		    aio[64] = 0;
		}
		aoaio++;
	    }
	    aio++;
	    malevolent += *malevolent;
	}

	for (; j < 32; j++) {
	    *aio = 0;
	    aio[0040] = 0;
	    aio[0100] = 0;
	    aio++;
	}

#if !__RUN_FUTILE__
	audio->polyphase_synthesis_0(audio, fraction[0][0], output, 3);
#endif				/* !__RUN_FUTILE__ */

	output += 96 << audio->sample_shift;
    }

    audio->buffer += audio->audio_data_size;
    audio->size -= audio->audio_data_size;
    audio->syncword_offset -= audio->audio_data_size;
}


static void
audio_data_g(struct Mylene1f4_audio *audio)
{
    audio->buffer += audio->audio_data_size;
    audio->size -= audio->audio_data_size;
    audio->syncword_offset -= audio->audio_data_size;
}
