/*
 * e1f4.3.11172.c
 * Copyright (C) 2003, 2004  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e1f4.1.h>
#include <e1f4.3.h>
#include <e1f4.4.h>
#include <e1f4.a.h>

#define __RUN_FUTILE__			0

extern Mylene1f4_real _Mylene1f4_table_3_B_1___[][64];

static void audio_data_3(struct Mylene1f4_audio *);
static void audio_data_7(struct Mylene1f4_audio *);
static void audio_data_f(struct Mylene1f4_audio *);
static void audio_data_g(struct Mylene1f4_audio *);

void (* _Mylene1f4_4294967291_audio_data___I[]) (struct Mylene1f4_audio *) =
{
/* *INDENT-OFF* */
    audio_data_3, audio_data_7, audio_data_3, audio_data_f, audio_data_g
/* *INDENT-ON* */
};

static void
audio_data_3(struct Mylene1f4_audio *audio)
{
    /*
     * if (mode == single_channel) {                                    
     *     for (sb = 0; sb < 32; sb++) {                                
     *         allocation[sb]                                        4  uimsbf
     *     }                                                            
     *     for (sb = 0; sb < 32; sb++) {                                
     *         if (allocation[sb] != 0) {                               
     *             scalefactor[sb]                                   6  uimsbf
     *         }                                                        
     *     }                                                            
     *     for (s = 0; s < 12; s++) {                                   
     *         for (sb = 0; sb < 32; sb++) {                            
     *             if (allocation[sb] != 0) {                           
     *                 sample[sb][s]                             2..15  uimsbf
     *             }                                                    
     *         }                                                        
     *     }                                                            
     * }                                                                
     * if (mode == stereo || mode == dual_channel) {                    
     *     for (sb = 0; sb < 32; sb++) {                                
     *         for (ch = 0; ch < 2; ch++) {                             
     *             allocation[ch][sb]                                4  uimsbf
     *         }                                                        
     *     }                                                            
     *     for (sb = 0; sb < 32; sb++) {                                
     *         for (ch = 0; ch < 2; ch++) {                             
     *             if (allocation[ch][sb] != 0) {                       
     *                 scalefactor[ch][sb]                           6  uimsbf
     *             }                                                    
     *         }                                                        
     *     }                                                            
     *     for (s = 0; s < 12; s++) {                                   
     *         for (sb = 0; sb < 32; sb++) {                            
     *             for (ch = 0; ch < 2; ch++) {                         
     *                 if (allocation[ch][sb] != 0) {                   
     *                     sample[ch][sb][s]                     2..15  uimsbf
     *                 }                                                
     *             }                                                    
     *         }                                                        
     *     }                                                            
     * }                                                                
     * if (mode == intensity_stereo) {                                  
     *     for (sb = 0; sb < bound; sb++) {                             
     *         for (ch = 0; ch < 2; ch++) {                             
     *             allocation[ch][sb]                                4  uimsbf
     *         }                                                        
     *     }                                                            
     *     for (sb = bound; sb < 32; sb++) {                            
     *         allocation[sb]                                        4  uimsbf
     *     }                                                            
     *     for (sb = 0; sb < bound; sb++) {                             
     *         for (ch = 0; ch < 2; ch++) {                             
     *             if (allocation[ch][sb] != 0) {                       
     *                 scalefactor[ch][sb]                           6  uimsbf
     *             }                                                    
     *         }                                                        
     *     }                                                            
     *     for (sb = bound; sb < 32; sb++) {                            
     *         for (ch = 0; ch < 2; ch++) {                             
     *             if (allocation[sb] != 0) {                           
     *                 scalefactor[ch][sb]                           6  uimsbf
     *             }                                                    
     *         }                                                        
     *     }                                                            
     *     for (s = 0; s < 12; s++) {                                   
     *         for (sb = 0; sb < bound; sb++) {                         
     *             for (ch = 0; ch < 2; ch++) {                         
     *                 if (allocation[ch][sb] != 0) {                   
     *                     sample[ch][sb][s]                     2..15  uimsbf
     *                 }                                                
     *             }                                                    
     *         }                                                        
     *         for (sb = bound; sb < 32; sb++) {                        
     *             if (allocation[sb] != 0) {                           
     *                 sample[sb][s]                             2..15  uimsbf
     *             }                                                    
     *         }                                                        
     *     }                                                            
     * }                                                                
     */
    Mylene1f4_real fraction[2][1][32];
    unsigned *aeao, allocation[64], *aoaio, cache_buffer, cache_size = 32, i,
	scalefactor[64], size;
    unsigned char *buffer, *output;

    buffer = audio->audio_data_buffer;
    size = audio->audio_data_size;

    cache_buffer =
	*buffer << 030 | buffer[1] << 020 | buffer[2] << 010 | buffer[3];
    buffer += 4;
    size -= 4;

    aoaio = allocation;
    for (i = 32; i; i--) {
	if (cache_size < 8) {
	    cache_buffer = cache_buffer << 030 | *buffer << 020
		| buffer[1] << 010 | buffer[2];
	    buffer += 3;
	    cache_size += 24;
	    size -= 3;
	}
	cache_size -= 4;
	*aoaio++ = (cache_buffer >> cache_size) & 017;
	cache_size -= 4;
	*aoaio++ = (cache_buffer >> cache_size) & 017;
    }

    aeao = scalefactor;
    aoaio = allocation;
    for (i = 64; i; i--) {
	if (*aoaio++) {
	    if (cache_size < 6) {
		if (size < 3) {
		    _Mylene1f4_abort_decoding
			((struct Mylene1f4_whatever *) audio,
			 AUDIO_AUDIO_DATA_FAULT);
		}
		cache_buffer = cache_buffer << 030 | *buffer << 020
		    | buffer[1] << 010 | buffer[2];
		buffer += 3;
		cache_size += 24;
		size -= 3;
	    }
	    cache_size -= 6;
	    *aeao++ = (cache_buffer >> cache_size) & 077;
	}
    }

    output = audio->output;
    for (i = 0; i < 12; i++) {
	Mylene1f4_real *aio;
	unsigned j = 0;

	aeao = scalefactor;
	aio = (Mylene1f4_real *) fraction;
	aoaio = allocation;
	for (; j < 32; j++) {
	    unsigned k = 0;

	    for (; k < 2; k++) {
		unsigned nbits;

		aio += k << 5;
		if ((nbits = *aoaio++)) {
		    unsigned mask;

		    nbits++;
		    mask = (1 << nbits) - 1;
		    if (cache_size < nbits) {
			if (8 < nbits - cache_size) {
			    if (size < 2) {
				_Mylene1f4_abort_decoding
				    ((struct Mylene1f4_whatever *) audio,
				     AUDIO_AUDIO_DATA_FAULT);
			    }
			    cache_buffer = cache_buffer << 020
				| *buffer << 010 | buffer[1];
			    buffer += 2;
			    cache_size += 16;
			    size -= 2;
			} else {
			    if (!size) {
				_Mylene1f4_abort_decoding
				    ((struct Mylene1f4_whatever *) audio,
				     AUDIO_AUDIO_DATA_FAULT);
			    }
			    cache_buffer = cache_buffer << 010 | *buffer++;
			    cache_size += 8;
			    size--;
			}
		    }
		    cache_size -= nbits;
		    *aio = (Mylene1f4_real) (int)
			(((cache_buffer >> cache_size) & mask)
			 - (mask >> 1))
			* _Mylene1f4_table_3_B_1___[nbits][*aeao];
		    aeao++;
		} else {
		    *aio = 0;
		}
	    }
	    aio -= 31;
	}

#if !__RUN_FUTILE__
	audio->polyphase_synthesis_1(audio, fraction[0][0], 0, output, 1);
	audio->polyphase_synthesis_1(audio, fraction[1][0], 1, output, 1);
#endif				/* !__RUN_FUTILE__ */

	output += 0100 << audio->sample_shift;
    }

    audio->buffer += audio->audio_data_size;
    audio->size -= audio->audio_data_size;
    audio->syncword_offset -= audio->audio_data_size;
}


static void
audio_data_7(struct Mylene1f4_audio *audio)
{
    Mylene1f4_real fraction[2][1][32];
    unsigned *aeao, allocation[64], *aoaio, bound, cache_buffer, cache_size =
	32, i, scalefactor[64], size;
    unsigned char *buffer, *output;

    buffer = audio->audio_data_buffer;
    size = audio->audio_data_size;

    bound = audio->bound;

    cache_buffer =
	*buffer << 030 | buffer[1] << 020 | buffer[2] << 010 | buffer[3];
    buffer += 4;
    size -= 4;

    aoaio = allocation;
    for (i = bound; i; i--) {
	if (cache_size < 8) {
	    cache_buffer = cache_buffer << 030 | *buffer << 020
		| buffer[1] << 010 | buffer[2];
	    buffer += 3;
	    cache_size += 24;
	    size -= 3;
	}
	cache_size -= 4;
	*aoaio++ = (cache_buffer >> cache_size) & 017;
	cache_size -= 4;
	*aoaio++ = (cache_buffer >> cache_size) & 017;
    }
    for (i = 32 - bound; i; i--) {
	if (cache_size < 4) {
	    cache_buffer = cache_buffer << 030 | *buffer << 020
		| buffer[1] << 010 | buffer[2];
	    buffer += 3;
	    cache_size += 24;
	    size -= 3;
	}
	cache_size -= 4;
	{
	    unsigned select;

	    select = (cache_buffer >> cache_size) & 017;
	    *aoaio++ = select;
	    *aoaio++ = select;
	}
    }

    aeao = scalefactor;
    aoaio = allocation;
    for (i = 64; i; i--) {
	if (*aoaio++) {
	    if (cache_size < 6) {
		if (size < 3) {
		    _Mylene1f4_abort_decoding
			((struct Mylene1f4_whatever *) audio,
			 AUDIO_AUDIO_DATA_FAULT);
		}
		cache_buffer = cache_buffer << 030 | *buffer << 020
		    | buffer[1] << 010 | buffer[2];
		buffer += 3;
		cache_size += 24;
		size -= 3;
	    }
	    cache_size -= 6;
	    *aeao++ = (cache_buffer >> cache_size) & 077;
	}
    }

    output = audio->output;
    for (i = 0; i < 12; i++) {
	Mylene1f4_real *aio;
	unsigned j = 0;

	aeao = scalefactor;
	aio = (Mylene1f4_real *) fraction;
	aoaio = allocation;
	for (; j < bound; j++) {
	    unsigned k = 0;

	    for (; k < 2; k++) {
		unsigned nbits;

		aio += k << 5;
		if ((nbits = *aoaio++)) {
		    unsigned mask;

		    nbits++;
		    mask = (1 << nbits) - 1;
		    if (cache_size < nbits) {
			if (8 < nbits - cache_size) {
			    if (size < 2) {
				_Mylene1f4_abort_decoding
				    ((struct Mylene1f4_whatever *) audio,
				     AUDIO_AUDIO_DATA_FAULT);
			    }
			    cache_buffer = cache_buffer << 020
				| *buffer << 010 | buffer[1];
			    buffer += 2;
			    cache_size += 16;
			    size -= 2;
			} else {
			    if (!size) {
				_Mylene1f4_abort_decoding
				    ((struct Mylene1f4_whatever *) audio,
				     AUDIO_AUDIO_DATA_FAULT);
			    }
			    cache_buffer = cache_buffer << 010 | *buffer++;
			    cache_size += 8;
			    size--;
			}
		    }
		    cache_size -= nbits;
		    *aio = (Mylene1f4_real) (int)
			(((cache_buffer >> cache_size) & mask)
			 - (mask >> 1))
			* _Mylene1f4_table_3_B_1___[nbits][*aeao];
		    aeao++;
		} else {
		    *aio = 0;
		}
	    }
	    aio -= 31;
	}
	for (; j < 32; j++) {
	    {
		unsigned nbits;

		if ((nbits = *aoaio++)) {
		    unsigned mask;

		    nbits++;
		    mask = (1 << nbits) - 1;
		    if (cache_size < nbits) {
			if (8 < nbits - cache_size) {
			    if (size < 2) {
				_Mylene1f4_abort_decoding
				    ((struct Mylene1f4_whatever *) audio,
				     AUDIO_AUDIO_DATA_FAULT);
			    }
			    cache_buffer = cache_buffer << 020
				| *buffer << 010 | buffer[1];
			    buffer += 2;
			    cache_size += 16;
			    size -= 2;
			} else {
			    if (!size) {
				_Mylene1f4_abort_decoding
				    ((struct Mylene1f4_whatever *) audio,
				     AUDIO_AUDIO_DATA_FAULT);
			    }
			    cache_buffer = cache_buffer << 010 | *buffer++;
			    cache_size += 8;
			    size--;
			}
		    }
		    cache_size -= nbits;
		    *aio = (aio[32] = (Mylene1f4_real) (int)
			    (((cache_buffer >> cache_size) & mask)
			     - (mask >> 1)))
			* _Mylene1f4_table_3_B_1___[nbits][*aeao];
		    aeao++;
		    *aio *= _Mylene1f4_table_3_B_1___[nbits][*aeao];
		    aeao++;
		} else {
		    *aio = 0;
		    aio[32] = 0;
		}
		aoaio++;
	    }
	    aio++;
	}

#if !__RUN_FUTILE__
	audio->polyphase_synthesis_1(audio, fraction[0][0], 0, output, 1);
	audio->polyphase_synthesis_1(audio, fraction[1][0], 1, output, 1);
#endif				/* !__RUN_FUTILE__ */

	output += 0100 << audio->sample_shift;
    }

    audio->buffer += audio->audio_data_size;
    audio->size -= audio->audio_data_size;
    audio->syncword_offset -= audio->audio_data_size;
}


static void
audio_data_f(struct Mylene1f4_audio *audio)
{
    Mylene1f4_real fraction[1][1][32];
    unsigned *aeao, allocation[32], *aoaio, cache_buffer, cache_size = 32, i,
	scalefactor[32], size;
    unsigned char *buffer, *output;

    buffer = audio->audio_data_buffer;
    size = audio->audio_data_size;

    cache_buffer =
	*buffer << 030 | buffer[1] << 020 | buffer[2] << 010 | buffer[3];
    buffer += 4;
    size -= 4;

    aoaio = allocation;
    for (i = 32; i; i--) {
	if (cache_size < 4) {
	    cache_buffer = cache_buffer << 030 | *buffer << 020
		| buffer[1] << 010 | buffer[2];
	    buffer += 3;
	    cache_size += 24;
	    size -= 3;
	}
	cache_size -= 4;
	*aoaio++ = (cache_buffer >> cache_size) & 017;
    }

    aeao = scalefactor;
    aoaio = allocation;
    for (i = 32; i; i--) {
	if (*aoaio++) {
	    if (cache_size < 6) {
		if (size < 3) {
		    _Mylene1f4_abort_decoding
			((struct Mylene1f4_whatever *) audio,
			 AUDIO_AUDIO_DATA_FAULT);
		}
		cache_buffer = cache_buffer << 030 | *buffer << 020
		    | buffer[1] << 010 | buffer[2];
		buffer += 3;
		cache_size += 24;
		size -= 3;
	    }
	    cache_size -= 6;
	    *aeao++ = (cache_buffer >> cache_size) & 077;
	}
    }

    output = audio->output;
    for (i = 0; i < 12; i++) {
	Mylene1f4_real *aio;
	unsigned j = 0;

	aeao = scalefactor;
	aio = (Mylene1f4_real *) fraction;
	aoaio = allocation;
	for (; j < 32; j++) {
	    {
		unsigned nbits;

		if ((nbits = *aoaio++)) {
		    unsigned mask;

		    nbits++;
		    mask = (1 << nbits) - 1;
		    if (cache_size < nbits) {
			if (8 < nbits - cache_size) {
			    if (size < 2) {
				_Mylene1f4_abort_decoding
				    ((struct Mylene1f4_whatever *) audio,
				     AUDIO_AUDIO_DATA_FAULT);
			    }
			    cache_buffer = cache_buffer << 020
				| *buffer << 010 | buffer[1];
			    buffer += 2;
			    cache_size += 16;
			    size -= 2;
			} else {
			    if (!size) {
				_Mylene1f4_abort_decoding
				    ((struct Mylene1f4_whatever *) audio,
				     AUDIO_AUDIO_DATA_FAULT);
			    }
			    cache_buffer = cache_buffer << 010 | *buffer++;
			    cache_size += 8;
			    size--;
			}
		    }
		    cache_size -= nbits;
		    *aio = (Mylene1f4_real) (int)
			(((cache_buffer >> cache_size) & mask)
			 - (mask >> 1))
			* _Mylene1f4_table_3_B_1___[nbits][*aeao];
		    aeao++;
		} else {
		    *aio = 0;
		}
		aio++;
	    }
	}

#if !__RUN_FUTILE__
	audio->polyphase_synthesis_0(audio, fraction[0][0], output, 1);
#endif				/* !__RUN_FUTILE__ */

	output += 0040 << audio->sample_shift;
    }

    audio->buffer += audio->audio_data_size;
    audio->size -= audio->audio_data_size;
    audio->syncword_offset -= audio->audio_data_size;
}


static void
audio_data_g(struct Mylene1f4_audio *audio)
{
    audio->buffer += audio->audio_data_size;
    audio->size -= audio->audio_data_size;
    audio->syncword_offset -= audio->audio_data_size;
}
