/*
 * e1f4.3.h
 * Copyright (C) 2003, 2004, 2005, 2006, 2007, 2008  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __Mylene1f4_3_H__
#define __Mylene1f4_3_H__

#include <e1f4.0.h>
#include <e1f4.5.h>

#define mixed_block_flag		switch_point

typedef float Mylene1f4_real;

#if __ENABLE_HEADER_HACK_1__
typedef struct Mylene1f4_header {
    unsigned ID, bitrate_index, copyright, emphasis, layer, mode,
	mode_extension, originalslashhome, padding_bit, private_bit,
	protection_bit, sampling_frequency;
    void *decoder;
} Mylene1f4_header;
#endif				/* __ENABLE_HEADER_HACK_1__ */

typedef struct Mylene1f4_frame {
    unsigned size;
    unsigned char *buffer;
} Mylene1f4_frame;

typedef struct Mylene1f4_granule {
    unsigned big_values, block_type, count1table_select, part2_3_length,
	preflag, region_address1, region_address2, scalefac_compress,
	scalefac_scale, scfsi, switch_point, table_select[3];

    Mylene1f4_real *full_gain[3], *pow2gain;
    unsigned maxb, maxband[3], maxbandl;
} Mylene1f4_granule;

typedef struct Mylene1f4_release {
    unsigned flags;
    unsigned char *samples;
} Mylene1f4_release;

typedef struct Mylene1f4_audio {
    unsigned error, minimum_useful_size, size, syncword_offset;
    unsigned char *buffer;
    void (*abort_decoding) (struct Mylene1f4_audio *),
	(*optimistique_moi) (struct Mylene1f4_audio *), *private;
    struct Mylene1f4_release release;
    union {
	struct {
	    unsigned table_3_B_2x_4[4];
	} II;
	struct {
	    struct Mylene1f4_frame frames[MAX_NFRAMES];
	    unsigned char *data, *head;
	} III;
    } layer_data;
    unsigned audio_data_size, bitrate_index, bound, header, frame_data_size,
	frame_size, last_frame, layer, left_frame, main_data_size, mode,
	mode_extension, sample_shift, sampling_frequency, wrapped_0[2],
	wrapped_1[2];
#if __ENABLE_HEADER_HACK_2__
    unsigned header_change_mask, user_header_change_mask;
#endif				/* __ENABLE_HEADER_HACK_2__ */
    unsigned char *audio_data_buffer, *output;
    void (*ancillary_data) (struct Mylene1f4_audio *),
	(*audio_data[16]) (struct Mylene1f4_audio *),
	(*dct_64) (Mylene1f4_real *, Mylene1f4_real *, Mylene1f4_real *),
	(*do_release) (struct Mylene1f4_audio *, struct Mylene1f4_release *),
	(*error_check) (struct Mylene1f4_audio *), *polyphase_buffer,
	(*polyphase_synthesis_0) (struct Mylene1f4_audio *, Mylene1f4_real *,
				  void *, unsigned),
	(*polyphase_synthesis_1) (struct Mylene1f4_audio *, Mylene1f4_real *,
				  unsigned, void *, unsigned),
	*transform_buffer;
#if __ENABLE_HEADER_HACK_0__
    void (*header_hack_0) (struct Mylene1f4_audio *);
#endif				/* __ENABLE_HEADER_HACK_0__ */
#if __ENABLE_HEADER_HACK_1__
    void (*header_hack_1) (struct Mylene1f4_header *);
#endif				/* __ENABLE_HEADER_HACK_1__ */
#if __ENABLE_HEADER_HACK_2__
    void (*header_hack_2) (struct Mylene1f4_header *);
#endif				/* __ENABLE_HEADER_HACK_2__ */
#if __ENABLE_HEADER_HACK_3__
    void (*header_hack_3) (struct Mylene1f4_header *);
#endif				/* __ENABLE_HEADER_HACK_3__ */
#if __ENABLE_EQUALIZER_0__
    void (*x_equalize_0) (void *, Mylene1f4_real *), *x_equalizer_0;
#endif				/* __ENABLE_EQUALIZER_0__ */
} Mylene1f4_audio;

typedef struct Mylene1f4_whatever {
    unsigned error, minimum_useful_size, size, syncword_offset;
    unsigned char *buffer;
    void (*abort_decoding) (struct Mylene1f4_whatever *),
	(*correct_underflow) (struct Mylene1f4_whatever *), *private;
} Mylene1f4_whatever;

#endif				/* __Mylene1f4_3_H__ */
