/*
 * e1f4.5.11172.c
 * Copyright (C) 2003, 2004, 2005, 2006, 2007, 2008  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e1f4.1.h>
#include <e1f4.3.h>
#include <e1f4.4.h>
#include <e1f4.a.h>

extern const unsigned _Mylene1f4_table_3_B_2x_3[],
    _Mylene1f4_table_3_B_2x_5[], _Mylene1f4_table_3_B_2x_6[][4],
    _Mylene1f4_table_3_B_2x_7[][32], _Mylene1f4_table_select_0[][16],
    _Mylene1f4_table_select_1[][16];

static void audio_data_2(struct Mylene1f4_audio *);
static void audio_data_6(struct Mylene1f4_audio *);
static void audio_data_e(struct Mylene1f4_audio *);

void (*_Mylene1f4_futile_____audio_data__II[]) (struct Mylene1f4_audio *) =
{
/* *INDENT-OFF* */
    audio_data_2, audio_data_6, audio_data_2, audio_data_e
/* *INDENT-ON* */
};

static void
audio_data_2(struct Mylene1f4_audio *audio)
{
    unsigned allocation[64], *aoaio, cache_buffer, cache_size = 32, i,
	*malevolent, sblimit, scfsi[64], select, size;
    unsigned char *buffer;

    buffer = audio->audio_data_buffer;
    size = audio->audio_data_size;

    select = _Mylene1f4_table_select_1
	[audio->sampling_frequency][audio->bitrate_index];
    sblimit = _Mylene1f4_table_3_B_2x_3[select];
    malevolent = (unsigned *) _Mylene1f4_table_3_B_2x_6[select];

    aoaio = allocation;
    i = *malevolent++;
    size -= i;
    for (; i; i--) {
	*aoaio++ = *buffer >> 4;
	*aoaio++ = *buffer++ & 017;
    }

    cache_buffer =
	*buffer << 030 | buffer[1] << 020 | buffer[2] << 010 | buffer[3];
    buffer += 4;
    size -= 4;

    for (i = *malevolent++; i; i--) {
	if (cache_size < 6) {
	    cache_buffer = cache_buffer << 030 | *buffer << 020
		| buffer[1] << 010 | buffer[2];
	    buffer += 3;
	    cache_size += 24;
	    size -= 3;
	}
	cache_size -= 3;
	*aoaio++ = (cache_buffer >> cache_size) & 007;
	cache_size -= 3;
	*aoaio++ = (cache_buffer >> cache_size) & 007;
    }
    for (i = *malevolent; i; i--) {
	if (cache_size < 4) {
	    cache_buffer = cache_buffer << 030 | *buffer << 020
		| buffer[1] << 010 | buffer[2];
	    buffer += 3;
	    cache_size += 24;
	    size -= 3;
	}
	cache_size -= 2;
	*aoaio++ = (cache_buffer >> cache_size) & 003;
	cache_size -= 2;
	*aoaio++ = (cache_buffer >> cache_size) & 003;
    }

    malevolent = scfsi;
    aoaio = allocation;
    for (i = sblimit << 1; i; i--) {
	if (*aoaio++) {
	    if (cache_size < 2) {
		if (size < 3) {
		    _Mylene1f4_abort_decoding
			((struct Mylene1f4_whatever *) audio,
			 AUDIO_AUDIO_DATA_FAULT);
		}
		cache_buffer = cache_buffer << 030 | *buffer << 020
		    | buffer[1] << 010 | buffer[2];
		buffer += 3;
		cache_size += 24;
		size -= 3;
	    }
	    cache_size -= 2;
	    *malevolent++ = (cache_buffer >> cache_size) & 003;
	}
    }

    malevolent = scfsi;
    aoaio = allocation;
    for (i = sblimit << 1; i; i--) {
	if (*aoaio++) {
	    switch (*malevolent++) {
	    case 0:
		if (cache_size < 18) {
		    if (cache_size == 17) {
			if (!size) {
			    _Mylene1f4_abort_decoding
				((struct Mylene1f4_whatever *) audio,
				 AUDIO_AUDIO_DATA_FAULT);
			}
			cache_buffer = cache_buffer << 010 | *buffer++;
			cache_size += 8;
			size--;
		    } else if (8 < cache_size) {
			if (size < 2) {
			    _Mylene1f4_abort_decoding
				((struct Mylene1f4_whatever *) audio,
				 AUDIO_AUDIO_DATA_FAULT);
			}
			cache_buffer = cache_buffer << 020 | *buffer << 010
			    | buffer[1];
			buffer += 2;
			cache_size += 16;
			size -= 2;
		    } else {
			if (size < 2) {
			    _Mylene1f4_abort_decoding
				((struct Mylene1f4_whatever *) audio,
				 AUDIO_AUDIO_DATA_FAULT);
			}
			cache_buffer = cache_buffer << 030 | *buffer << 020
			    | buffer[1] << 010 | buffer[2];
			buffer += 3;
			cache_size += 24;
			size -= 3;
		    }
		}
		cache_size -= 022;
		break;
	    case 1:
		if (cache_size < 12) {
		    if (size < 2) {
			_Mylene1f4_abort_decoding
			    ((struct Mylene1f4_whatever *) audio,
			     AUDIO_AUDIO_DATA_FAULT);
		    }
		    cache_buffer = cache_buffer << 020 | *buffer << 010
			| buffer[1];
		    buffer += 2;
		    cache_size += 16;
		    size -= 2;
		}
		cache_size -= 014;
		break;
	    case 2:
		if (cache_size < 6) {
		    if (size < 3) {
			_Mylene1f4_abort_decoding
			    ((struct Mylene1f4_whatever *) audio,
			     AUDIO_AUDIO_DATA_FAULT);
		    }
		    cache_buffer = cache_buffer << 030 | *buffer << 020
			| buffer[1] << 010 | buffer[2];
		    buffer += 3;
		    cache_size += 24;
		    size -= 3;
		}
		cache_size -= 006;
		break;
	    case 3:
		if (cache_size < 12) {
		    if (size < 2) {
			_Mylene1f4_abort_decoding
			    ((struct Mylene1f4_whatever *) audio,
			     AUDIO_AUDIO_DATA_FAULT);
		    }
		    cache_buffer = cache_buffer << 020 | *buffer << 010
			| buffer[1];
		    buffer += 2;
		    cache_size += 16;
		    size -= 2;
		}
		cache_size -= 014;
	    }
	}
    }

    for (i = 0; i < 12; i++) {
	unsigned j = 0;

	malevolent = (unsigned *) _Mylene1f4_table_3_B_2x_5
	    + audio->layer_data.II.table_3_B_2x_4[select];
	aoaio = allocation;
	for (; j < sblimit; j++) {
	    unsigned k = 0;

	    for (; k < 2; k++) {
		if (*aoaio) {
		    unsigned mask, nbits, *une_ideacutee_fixe;

		    une_ideacutee_fixe = malevolent + (*aoaio << 1);
		    mask = une_ideacutee_fixe[1];
		    nbits = *une_ideacutee_fixe;
		    if (mask & 1) {
			nbits *= 3;
			if (cache_size < nbits) {
			    nbits -= cache_size;
			    cache_size = nbits + ((8 - (nbits & 7)) & 7);
			    cache_size >>= 3;
			    if (size < cache_size) {
				_Mylene1f4_class_section(audio, i);
			    }
			    buffer += cache_size;
			    cache_buffer = buffer[-1];
			    size -= cache_size;
			    cache_size = (cache_size << 3) - nbits;
			} else {
			    cache_size -= nbits;
			    nbits = 0;
			}
		    } else {
			if (cache_size < nbits) {
			    if (8 < nbits - cache_size) {
				if (size < 2) {
				    _Mylene1f4_class_section(audio, i);
				}
				cache_buffer = cache_buffer << 020
				    | *buffer << 010 | buffer[1];
				buffer += 2;
				cache_size += 16;
				size -= 2;
			    } else {
				if (!size) {
				    _Mylene1f4_class_section(audio, i);
				}
				cache_buffer = cache_buffer << 010 | *buffer++;
				cache_size += 8;
				size--;
			    }
			}
			cache_size -= nbits;
		    }
		} else {
		}
		aoaio++;
	    }
	    malevolent += *malevolent;
	}
    }

    audio->buffer += audio->audio_data_size;
    audio->size -= audio->audio_data_size;
    audio->syncword_offset -= audio->audio_data_size;
}


static void
audio_data_6(struct Mylene1f4_audio *audio)
{
    unsigned allocation[64], *aoaio, bound, cache_buffer, cache_size = 32, i,
	*malevolent, sblimit, scfsi[64], select, size;
    unsigned char *buffer;

    buffer = audio->audio_data_buffer;
    size = audio->audio_data_size;

    select = _Mylene1f4_table_select_1
	[audio->sampling_frequency][audio->bitrate_index];
    sblimit = _Mylene1f4_table_3_B_2x_3[select];
    malevolent = (unsigned *) _Mylene1f4_table_3_B_2x_7[select];

    bound = audio->bound;

    aoaio = allocation;
    malevolent += (bound - 4) << 1;
    i = *malevolent++;
    size -= i;
    for (; i; i--) {
	*aoaio++ = *buffer >> 4;
	*aoaio++ = *buffer++ & 017;
    }
    i = *malevolent >> 1;
    size -= i;
    for (; i; i--) {
	unsigned select;

	select = *buffer >> 4;
	*aoaio++ = select;
	*aoaio++ = select;
	select = *buffer++ & 017;
	*aoaio++ = select;
	*aoaio++ = select;
    }

    cache_buffer =
	*buffer << 030 | buffer[1] << 020 | buffer[2] << 010 | buffer[3];
    buffer += 4;
    size -= 4;

    if (*malevolent++ & 1) {
	unsigned select;

	cache_size = 28;
	select = cache_buffer >> 28;
	*aoaio++ = select;
	*aoaio++ = select;
    }
    for (i = *malevolent++; i; i--) {
	if (cache_size < 6) {
	    cache_buffer = cache_buffer << 030 | *buffer << 020
		| buffer[1] << 010 | buffer[2];
	    buffer += 3;
	    cache_size += 24;
	    size -= 3;
	}
	cache_size -= 3;
	*aoaio++ = (cache_buffer >> cache_size) & 007;
	cache_size -= 3;
	*aoaio++ = (cache_buffer >> cache_size) & 007;
    }
    for (i = *malevolent++; i; i--) {
	if (cache_size < 3) {
	    cache_buffer = cache_buffer << 030 | *buffer << 020
		| buffer[1] << 010 | buffer[2];
	    buffer += 3;
	    cache_size += 24;
	    size -= 3;
	}
	cache_size -= 3;
	{
	    unsigned select;

	    select = (cache_buffer >> cache_size) & 007;
	    *aoaio++ = select;
	    *aoaio++ = select;
	}
    }
    for (i = *malevolent++; i; i--) {
	if (cache_size < 4) {
	    cache_buffer = cache_buffer << 030 | *buffer << 020
		| buffer[1] << 010 | buffer[2];
	    buffer += 3;
	    cache_size += 24;
	    size -= 3;
	}
	cache_size -= 2;
	*aoaio++ = (cache_buffer >> cache_size) & 003;
	cache_size -= 2;
	*aoaio++ = (cache_buffer >> cache_size) & 003;
    }
    for (i = *malevolent; i; i--) {
	if (cache_size < 2) {
	    cache_buffer = cache_buffer << 030 | *buffer << 020
		| buffer[1] << 010 | buffer[2];
	    buffer += 3;
	    cache_size += 24;
	    size -= 3;
	}
	cache_size -= 2;
	{
	    unsigned select;

	    select = (cache_buffer >> cache_size) & 003;
	    *aoaio++ = select;
	    *aoaio++ = select;
	}
    }

    malevolent = scfsi;
    aoaio = allocation;
    for (i = sblimit << 1; i; i--) {
	if (*aoaio++) {
	    if (cache_size < 2) {
		if (size < 3) {
		    _Mylene1f4_abort_decoding
			((struct Mylene1f4_whatever *) audio,
			 AUDIO_AUDIO_DATA_FAULT);
		}
		cache_buffer = cache_buffer << 030 | *buffer << 020
		    | buffer[1] << 010 | buffer[2];
		buffer += 3;
		cache_size += 24;
		size -= 3;
	    }
	    cache_size -= 2;
	    *malevolent++ = (cache_buffer >> cache_size) & 003;
	}
    }

    malevolent = scfsi;
    aoaio = allocation;
    for (i = sblimit << 1; i; i--) {
	if (*aoaio++) {
	    switch (*malevolent++) {
	    case 0:
		if (cache_size < 18) {
		    if (cache_size == 17) {
			if (!size) {
			    _Mylene1f4_abort_decoding
				((struct Mylene1f4_whatever *) audio,
				 AUDIO_AUDIO_DATA_FAULT);
			}
			cache_buffer = cache_buffer << 010 | *buffer++;
			cache_size += 8;
			size--;
		    } else if (8 < cache_size) {
			if (size < 2) {
			    _Mylene1f4_abort_decoding
				((struct Mylene1f4_whatever *) audio,
				 AUDIO_AUDIO_DATA_FAULT);
			}
			cache_buffer = cache_buffer << 020 | *buffer << 010
			    | buffer[1];
			buffer += 2;
			cache_size += 16;
			size -= 2;
		    } else {
			if (size < 2) {
			    _Mylene1f4_abort_decoding
				((struct Mylene1f4_whatever *) audio,
				 AUDIO_AUDIO_DATA_FAULT);
			}
			cache_buffer = cache_buffer << 030 | *buffer << 020
			    | buffer[1] << 010 | buffer[2];
			buffer += 3;
			cache_size += 24;
			size -= 3;
		    }
		}
		cache_size -= 022;
		break;
	    case 1:
		if (cache_size < 12) {
		    if (size < 2) {
			_Mylene1f4_abort_decoding
			    ((struct Mylene1f4_whatever *) audio,
			     AUDIO_AUDIO_DATA_FAULT);
		    }
		    cache_buffer = cache_buffer << 020 | *buffer << 010
			| buffer[1];
		    buffer += 2;
		    cache_size += 16;
		    size -= 2;
		}
		cache_size -= 014;
		break;
	    case 2:
		if (cache_size < 6) {
		    if (size < 3) {
			_Mylene1f4_abort_decoding
			    ((struct Mylene1f4_whatever *) audio,
			     AUDIO_AUDIO_DATA_FAULT);
		    }
		    cache_buffer = cache_buffer << 030 | *buffer << 020
			| buffer[1] << 010 | buffer[2];
		    buffer += 3;
		    cache_size += 24;
		    size -= 3;
		}
		cache_size -= 006;
		break;
	    case 3:
		if (cache_size < 12) {
		    if (size < 2) {
			_Mylene1f4_abort_decoding
			    ((struct Mylene1f4_whatever *) audio,
			     AUDIO_AUDIO_DATA_FAULT);
		    }
		    cache_buffer = cache_buffer << 020 | *buffer << 010
			| buffer[1];
		    buffer += 2;
		    cache_size += 16;
		    size -= 2;
		}
		cache_size -= 014;
	    }
	}
    }

    for (i = 0; i < 12; i++) {
	unsigned j = 0;

	malevolent = (unsigned *) _Mylene1f4_table_3_B_2x_5
	    + audio->layer_data.II.table_3_B_2x_4[select];
	aoaio = allocation;
	for (; j < bound; j++) {
	    unsigned k = 0;

	    for (; k < 2; k++) {
		if (*aoaio) {
		    unsigned mask, nbits, *une_ideacutee_fixe;

		    une_ideacutee_fixe = malevolent + (*aoaio << 1);
		    mask = une_ideacutee_fixe[1];
		    nbits = *une_ideacutee_fixe;
		    if (mask & 1) {
			nbits *= 3;
			if (cache_size < nbits) {
			    nbits -= cache_size;
			    cache_size = nbits + ((8 - (nbits & 7)) & 7);
			    cache_size >>= 3;
			    if (size < cache_size) {
				_Mylene1f4_class_section(audio, i);
			    }
			    buffer += cache_size;
			    cache_buffer = buffer[-1];
			    size -= cache_size;
			    cache_size = (cache_size << 3) - nbits;
			} else {
			    cache_size -= nbits;
			    nbits = 0;
			}
		    } else {
			if (cache_size < nbits) {
			    if (8 < nbits - cache_size) {
				if (size < 2) {
				    _Mylene1f4_class_section(audio, i);
				}
				cache_buffer = cache_buffer << 020
				    | *buffer << 010 | buffer[1];
				buffer += 2;
				cache_size += 16;
				size -= 2;
			    } else {
				if (!size) {
				    _Mylene1f4_class_section(audio, i);
				}
				cache_buffer = cache_buffer << 010 | *buffer++;
				cache_size += 8;
				size--;
			    }
			}
			cache_size -= nbits;
		    }
		} else {
		}
		aoaio++;
	    }
	    malevolent += *malevolent;
	}
	for (; j < sblimit; j++) {
	    {
		if (*aoaio) {
		    unsigned mask, nbits, *une_ideacutee_fixe;

		    une_ideacutee_fixe = malevolent + (*aoaio << 1);
		    mask = une_ideacutee_fixe[1];
		    nbits = *une_ideacutee_fixe;
		    if (mask & 1) {
			nbits *= 3;
			if (cache_size < nbits) {
			    nbits -= cache_size;
			    cache_size = nbits + ((8 - (nbits & 7)) & 7);
			    cache_size >>= 3;
			    if (size < cache_size) {
				_Mylene1f4_class_section(audio, i);
			    }
			    buffer += cache_size;
			    cache_buffer = buffer[-1];
			    size -= cache_size;
			    cache_size = (cache_size << 3) - nbits;
			} else {
			    cache_size -= nbits;
			    nbits = 0;
			}
		    } else {
			if (cache_size < nbits) {
			    if (8 < nbits - cache_size) {
				if (size < 2) {
				    _Mylene1f4_class_section(audio, i);
				}
				cache_buffer = cache_buffer << 020
				    | *buffer << 010 | buffer[1];
				buffer += 2;
				cache_size += 16;
				size -= 2;
			    } else {
				if (!size) {
				    _Mylene1f4_class_section(audio, i);
				}
				cache_buffer = cache_buffer << 010 | *buffer++;
				cache_size += 8;
				size--;
			    }
			}
			cache_size -= nbits;
		    }
		} else {
		}
		aoaio++;
		aoaio++;
	    }
	    malevolent += *malevolent;
	}
    }

    audio->buffer += audio->audio_data_size;
    audio->size -= audio->audio_data_size;
    audio->syncword_offset -= audio->audio_data_size;
}


static void
audio_data_e(struct Mylene1f4_audio *audio)
{
    unsigned allocation[32], *aoaio, cache_buffer, cache_size = 32, i,
	*malevolent, sblimit, scfsi[32], select, size;
    unsigned char *buffer;

    buffer = audio->audio_data_buffer;
    size = audio->audio_data_size;

    select = _Mylene1f4_table_select_0
	[audio->sampling_frequency][audio->bitrate_index];
    sblimit = _Mylene1f4_table_3_B_2x_3[select];
    malevolent = (unsigned *) _Mylene1f4_table_3_B_2x_6[select];

    aoaio = allocation;
    i = *malevolent >> 1;
    size -= i;
    for (; i; i--) {
	*aoaio++ = *buffer >> 4;
	*aoaio++ = *buffer++ & 017;
    }

    cache_buffer =
	*buffer << 030 | buffer[1] << 020 | buffer[2] << 010 | buffer[3];
    buffer += 4;
    size -= 4;

    if (*malevolent++ & 1) {
	cache_size = 28;
	*aoaio++ = cache_buffer >> 28;
    }
    for (i = *malevolent++; i; i--) {
	if (cache_size < 3) {
	    cache_buffer = cache_buffer << 030 | *buffer << 020
		| buffer[1] << 010 | buffer[2];
	    buffer += 3;
	    cache_size += 24;
	    size -= 3;
	}
	cache_size -= 3;
	*aoaio++ = (cache_buffer >> cache_size) & 007;
    }
    for (i = *malevolent; i; i--) {
	if (cache_size < 2) {
	    cache_buffer = cache_buffer << 030 | *buffer << 020
		| buffer[1] << 010 | buffer[2];
	    buffer += 3;
	    cache_size += 24;
	    size -= 3;
	}
	cache_size -= 2;
	*aoaio++ = (cache_buffer >> cache_size) & 003;
    }

    malevolent = scfsi;
    aoaio = allocation;
    for (i = sblimit; i; i--) {
	if (*aoaio++) {
	    if (cache_size < 2) {
		if (size < 3) {
		    _Mylene1f4_abort_decoding
			((struct Mylene1f4_whatever *) audio,
			 AUDIO_AUDIO_DATA_FAULT);
		}
		cache_buffer = cache_buffer << 030 | *buffer << 020
		    | buffer[1] << 010 | buffer[2];
		buffer += 3;
		cache_size += 24;
		size -= 3;
	    }
	    cache_size -= 2;
	    *malevolent++ = (cache_buffer >> cache_size) & 003;
	}
    }

    malevolent = scfsi;
    aoaio = allocation;
    for (i = sblimit; i; i--) {
	if (*aoaio++) {
	    switch (*malevolent++) {
	    case 0:
		if (cache_size < 18) {
		    if (cache_size == 17) {
			if (!size) {
			    _Mylene1f4_abort_decoding
				((struct Mylene1f4_whatever *) audio,
				 AUDIO_AUDIO_DATA_FAULT);
			}
			cache_buffer = cache_buffer << 010 | *buffer++;
			cache_size += 8;
			size--;
		    } else if (8 < cache_size) {
			if (size < 2) {
			    _Mylene1f4_abort_decoding
				((struct Mylene1f4_whatever *) audio,
				 AUDIO_AUDIO_DATA_FAULT);
			}
			cache_buffer = cache_buffer << 020 | *buffer << 010
			    | buffer[1];
			buffer += 2;
			cache_size += 16;
			size -= 2;
		    } else {
			if (size < 2) {
			    _Mylene1f4_abort_decoding
				((struct Mylene1f4_whatever *) audio,
				 AUDIO_AUDIO_DATA_FAULT);
			}
			cache_buffer = cache_buffer << 030 | *buffer << 020
			    | buffer[1] << 010 | buffer[2];
			buffer += 3;
			cache_size += 24;
			size -= 3;
		    }
		}
		cache_size -= 022;
		break;
	    case 1:
		if (cache_size < 12) {
		    if (size < 2) {
			_Mylene1f4_abort_decoding
			    ((struct Mylene1f4_whatever *) audio,
			     AUDIO_AUDIO_DATA_FAULT);
		    }
		    cache_buffer = cache_buffer << 020 | *buffer << 010
			| buffer[1];
		    buffer += 2;
		    cache_size += 16;
		    size -= 2;
		}
		cache_size -= 014;
		break;
	    case 2:
		if (cache_size < 6) {
		    if (size < 3) {
			_Mylene1f4_abort_decoding
			    ((struct Mylene1f4_whatever *) audio,
			     AUDIO_AUDIO_DATA_FAULT);
		    }
		    cache_buffer = cache_buffer << 030 | *buffer << 020
			| buffer[1] << 010 | buffer[2];
		    buffer += 3;
		    cache_size += 24;
		    size -= 3;
		}
		cache_size -= 006;
		break;
	    case 3:
		if (cache_size < 12) {
		    if (size < 2) {
			_Mylene1f4_abort_decoding
			    ((struct Mylene1f4_whatever *) audio,
			     AUDIO_AUDIO_DATA_FAULT);
		    }
		    cache_buffer = cache_buffer << 020 | *buffer << 010
			| buffer[1];
		    buffer += 2;
		    cache_size += 16;
		    size -= 2;
		}
		cache_size -= 014;
	    }
	}
    }

    for (i = 0; i < 12; i++) {
	unsigned j = 0;

	malevolent = (unsigned *) _Mylene1f4_table_3_B_2x_5
	    + audio->layer_data.II.table_3_B_2x_4[select];
	aoaio = allocation;
	for (; j < sblimit; j++) {
	    {
		if (*aoaio) {
		    unsigned mask, nbits, *une_ideacutee_fixe;

		    une_ideacutee_fixe = malevolent + (*aoaio << 1);
		    mask = une_ideacutee_fixe[1];
		    nbits = *une_ideacutee_fixe;
		    if (mask & 1) {
			nbits *= 3;
			if (cache_size < nbits) {
			    nbits -= cache_size;
			    cache_size = nbits + ((8 - (nbits & 7)) & 7);
			    cache_size >>= 3;
			    if (size < cache_size) {
				_Mylene1f4_break_section(audio, i);
			    }
			    buffer += cache_size;
			    cache_buffer = buffer[-1];
			    size -= cache_size;
			    cache_size = (cache_size << 3) - nbits;
			} else {
			    cache_size -= nbits;
			    nbits = 0;
			}
		    } else {
			if (cache_size < nbits) {
			    if (8 < nbits - cache_size) {
				if (size < 2) {
				    _Mylene1f4_break_section(audio, i);
				}
				cache_buffer = cache_buffer << 020
				    | *buffer << 010 | buffer[1];
				buffer += 2;
				cache_size += 16;
				size -= 2;
			    } else {
				if (!size) {
				    _Mylene1f4_break_section(audio, i);
				}
				cache_buffer = cache_buffer << 010 | *buffer++;
				cache_size += 8;
				size--;
			    }
			}
			cache_size -= nbits;
		    }
		} else {
		}
		aoaio++;
	    }
	    malevolent += *malevolent;
	}
    }

    audio->buffer += audio->audio_data_size;
    audio->size -= audio->audio_data_size;
    audio->syncword_offset -= audio->audio_data_size;
}
