/*
 * e1f4.6.11172.c
 * Copyright (C) 2003, 2004  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e1f4.1.h>
#include <e1f4.3.h>
#include <e1f4.4.h>
#include <e1f4.a.h>

static void audio_data_3(struct Mylene1f4_audio *);
static void audio_data_7(struct Mylene1f4_audio *);
static void audio_data_f(struct Mylene1f4_audio *);

void (*_Mylene1f4_futile_____audio_data___I[]) (struct Mylene1f4_audio *) =
{
/* *INDENT-OFF* */
    audio_data_3, audio_data_7, audio_data_3, audio_data_f
/* *INDENT-ON* */
};

static void
audio_data_3(struct Mylene1f4_audio *audio)
{
    unsigned allocation[64], *aoaio, cache_buffer, cache_size = 32, i, size;
    unsigned char *buffer;

    buffer = audio->audio_data_buffer;
    size = audio->audio_data_size;

    cache_buffer =
	*buffer << 030 | buffer[1] << 020 | buffer[2] << 010 | buffer[3];
    buffer += 4;
    size -= 4;

    aoaio = allocation;
    for (i = 32; i; i--) {
	if (cache_size < 8) {
	    cache_buffer = cache_buffer << 030 | *buffer << 020
		| buffer[1] << 010 | buffer[2];
	    buffer += 3;
	    cache_size += 24;
	    size -= 3;
	}
	cache_size -= 4;
	*aoaio++ = (cache_buffer >> cache_size) & 017;
	cache_size -= 4;
	*aoaio++ = (cache_buffer >> cache_size) & 017;
    }

    aoaio = allocation;
    for (i = 64; i; i--) {
	if (*aoaio++) {
	    if (cache_size < 6) {
		if (size < 3) {
		    _Mylene1f4_abort_decoding
			((struct Mylene1f4_whatever *) audio,
			 AUDIO_AUDIO_DATA_FAULT);
		}
		cache_buffer = cache_buffer << 030 | *buffer << 020
		    | buffer[1] << 010 | buffer[2];
		buffer += 3;
		cache_size += 24;
		size -= 3;
	    }
	    cache_size -= 6;
	}
    }

    for (i = 0; i < 12; i++) {
	unsigned j = 0;

	aoaio = allocation;
	for (; j < 32; j++) {
	    unsigned k = 0;

	    for (; k < 2; k++) {
		unsigned nbits;

		if ((nbits = *aoaio++)) {
		    nbits++;
		    if (cache_size < nbits) {
			if (8 < nbits - cache_size) {
			    if (size < 2) {
				_Mylene1f4_abort_decoding
				    ((struct Mylene1f4_whatever *) audio,
				     AUDIO_AUDIO_DATA_FAULT);
			    }
			    cache_buffer = cache_buffer << 020
				| *buffer << 010 | buffer[1];
			    buffer += 2;
			    cache_size += 16;
			    size -= 2;
			} else {
			    if (!size) {
				_Mylene1f4_abort_decoding
				    ((struct Mylene1f4_whatever *) audio,
				     AUDIO_AUDIO_DATA_FAULT);
			    }
			    cache_buffer = cache_buffer << 010 | *buffer++;
			    cache_size += 8;
			    size--;
			}
		    }
		    cache_size -= nbits;
		} else {
		}
	    }
	}
    }

    audio->buffer += audio->audio_data_size;
    audio->size -= audio->audio_data_size;
    audio->syncword_offset -= audio->audio_data_size;
}


static void
audio_data_7(struct Mylene1f4_audio *audio)
{
    unsigned allocation[64], *aoaio, bound, cache_buffer, cache_size = 32, i,
	size;
    unsigned char *buffer;

    buffer = audio->audio_data_buffer;
    size = audio->audio_data_size;

    bound = audio->bound;

    cache_buffer =
	*buffer << 030 | buffer[1] << 020 | buffer[2] << 010 | buffer[3];
    buffer += 4;
    size -= 4;

    aoaio = allocation;
    for (i = bound; i; i--) {
	if (cache_size < 8) {
	    cache_buffer = cache_buffer << 030 | *buffer << 020
		| buffer[1] << 010 | buffer[2];
	    buffer += 3;
	    cache_size += 24;
	    size -= 3;
	}
	cache_size -= 4;
	*aoaio++ = (cache_buffer >> cache_size) & 017;
	cache_size -= 4;
	*aoaio++ = (cache_buffer >> cache_size) & 017;
    }
    for (i = 32 - bound; i; i--) {
	if (cache_size < 4) {
	    cache_buffer = cache_buffer << 030 | *buffer << 020
		| buffer[1] << 010 | buffer[2];
	    buffer += 3;
	    cache_size += 24;
	    size -= 3;
	}
	cache_size -= 4;
	{
	    unsigned select;

	    select = (cache_buffer >> cache_size) & 017;
	    *aoaio++ = select;
	    *aoaio++ = select;
	}
    }

    aoaio = allocation;
    for (i = 64; i; i--) {
	if (*aoaio++) {
	    if (cache_size < 6) {
		if (size < 3) {
		    _Mylene1f4_abort_decoding
			((struct Mylene1f4_whatever *) audio,
			 AUDIO_AUDIO_DATA_FAULT);
		}
		cache_buffer = cache_buffer << 030 | *buffer << 020
		    | buffer[1] << 010 | buffer[2];
		buffer += 3;
		cache_size += 24;
		size -= 3;
	    }
	    cache_size -= 6;
	}
    }

    for (i = 0; i < 12; i++) {
	unsigned j = 0;

	aoaio = allocation;
	for (; j < bound; j++) {
	    unsigned k = 0;

	    for (; k < 2; k++) {
		unsigned nbits;

		if ((nbits = *aoaio++)) {
		    nbits++;
		    if (cache_size < nbits) {
			if (8 < nbits - cache_size) {
			    if (size < 2) {
				_Mylene1f4_abort_decoding
				    ((struct Mylene1f4_whatever *) audio,
				     AUDIO_AUDIO_DATA_FAULT);
			    }
			    cache_buffer = cache_buffer << 020
				| *buffer << 010 | buffer[1];
			    buffer += 2;
			    cache_size += 16;
			    size -= 2;
			} else {
			    if (!size) {
				_Mylene1f4_abort_decoding
				    ((struct Mylene1f4_whatever *) audio,
				     AUDIO_AUDIO_DATA_FAULT);
			    }
			    cache_buffer = cache_buffer << 010 | *buffer++;
			    cache_size += 8;
			    size--;
			}
		    }
		    cache_size -= nbits;
		} else {
		}
	    }
	}
	for (; j < 32; j++) {
	    {
		unsigned nbits;

		if ((nbits = *aoaio++)) {
		    nbits++;
		    if (cache_size < nbits) {
			if (8 < nbits - cache_size) {
			    if (size < 2) {
				_Mylene1f4_abort_decoding
				    ((struct Mylene1f4_whatever *) audio,
				     AUDIO_AUDIO_DATA_FAULT);
			    }
			    cache_buffer = cache_buffer << 020
				| *buffer << 010 | buffer[1];
			    buffer += 2;
			    cache_size += 16;
			    size -= 2;
			} else {
			    if (!size) {
				_Mylene1f4_abort_decoding
				    ((struct Mylene1f4_whatever *) audio,
				     AUDIO_AUDIO_DATA_FAULT);
			    }
			    cache_buffer = cache_buffer << 010 | *buffer++;
			    cache_size += 8;
			    size--;
			}
		    }
		    cache_size -= nbits;
		} else {
		}
		aoaio++;
	    }
	}
    }

    audio->buffer += audio->audio_data_size;
    audio->size -= audio->audio_data_size;
    audio->syncword_offset -= audio->audio_data_size;
}


static void
audio_data_f(struct Mylene1f4_audio *audio)
{
    unsigned allocation[32], *aoaio, cache_buffer, cache_size = 32, i, size;
    unsigned char *buffer, *output;

    buffer = audio->audio_data_buffer;
    size = audio->audio_data_size;

    cache_buffer =
	*buffer << 030 | buffer[1] << 020 | buffer[2] << 010 | buffer[3];
    buffer += 4;
    size -= 4;

    aoaio = allocation;
    for (i = 32; i; i--) {
	if (cache_size < 4) {
	    cache_buffer = cache_buffer << 030 | *buffer << 020
		| buffer[1] << 010 | buffer[2];
	    buffer += 3;
	    cache_size += 24;
	    size -= 3;
	}
	cache_size -= 4;
	*aoaio++ = (cache_buffer >> cache_size) & 017;
    }

    aoaio = allocation;
    for (i = 32; i; i--) {
	if (*aoaio++) {
	    if (cache_size < 6) {
		if (size < 3) {
		    _Mylene1f4_abort_decoding
			((struct Mylene1f4_whatever *) audio,
			 AUDIO_AUDIO_DATA_FAULT);
		}
		cache_buffer = cache_buffer << 030 | *buffer << 020
		    | buffer[1] << 010 | buffer[2];
		buffer += 3;
		cache_size += 24;
		size -= 3;
	    }
	    cache_size -= 6;
	}
    }

    output = audio->output;
    for (i = 0; i < 12; i++) {
	unsigned j = 0;

	aoaio = allocation;
	for (; j < 32; j++) {
	    {
		unsigned nbits;

		if ((nbits = *aoaio++)) {
		    nbits++;
		    if (cache_size < nbits) {
			if (8 < nbits - cache_size) {
			    if (size < 2) {
				_Mylene1f4_abort_decoding
				    ((struct Mylene1f4_whatever *) audio,
				     AUDIO_AUDIO_DATA_FAULT);
			    }
			    cache_buffer = cache_buffer << 020
				| *buffer << 010 | buffer[1];
			    buffer += 2;
			    cache_size += 16;
			    size -= 2;
			} else {
			    if (!size) {
				_Mylene1f4_abort_decoding
				    ((struct Mylene1f4_whatever *) audio,
				     AUDIO_AUDIO_DATA_FAULT);
			    }
			    cache_buffer = cache_buffer << 010 | *buffer++;
			    cache_size += 8;
			    size--;
			}
		    }
		    cache_size -= nbits;
		} else {
		}
	    }
	}
    }

    audio->buffer += audio->audio_data_size;
    audio->size -= audio->audio_data_size;
    audio->syncword_offset -= audio->audio_data_size;
}
