/*
 * e1f4.7.11172.c
 * Copyright (C) 2003, 2004, 2005, 2006, 2007, 2008  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e1f4.1.h>
#include <e1f4.2.h>
#include <e1f4.3.h>
#include <e1f4.4.h>
#include <e1f4.5.h>
#include <e1f4.a.h>

#define __RUN_FUTILE__			0

#define BUGGY_FILL_01_3() \
    {									      \
	*aea = 0;							      \
    }

#define BUGGY_FILL___2_() \
    {									      \
	*aea = 0;							      \
	aea[1] = 0;							      \
	aea[2] = 0;							      \
    }

#define RIGHT_STEREO(granule) \
    {									      \
	if (granule[0].maxb < granule[1].maxb) {			      \
	    granule[0].maxb = granule[1].maxb;				      \
	} else {							      \
	    granule[1].maxb = granule[0].maxb;				      \
	}								      \
    }									      \

extern Mylene1f4_real III_break_1[378];
extern Mylene1f4_real _Mylene1f4_break_0[];
extern unsigned _Mylene1f4_table_3_B_7__0[], _Mylene1f4_table_3_B_7__1[],
    *_Mylene1f4_table_3_B_7__2[];
extern const unsigned _Mylene1f4_table_3_B_7__3[], _Mylene1f4_table_3_B_7__4[];
extern const unsigned _Mylene1f4_table_3_B_8x_0[][25];

static void audio_data_0(struct Mylene1f4_audio *);
static void audio_data_1(struct Mylene1f4_audio *);
static void audio_data_d(struct Mylene1f4_audio *);

void (*_Mylene1f4_4294967279_audio_data_III[]) (struct Mylene1f4_audio *) = {
/* *INDENT-OFF* */
    audio_data_1, audio_data_1, audio_data_1, audio_data_d, audio_data_0
/* *INDENT-ON* */
};

static int run_frame(struct Mylene1f4_audio *);

static void optimistique_moi(struct Mylene1f4_audio *, unsigned char **,
			     unsigned *, unsigned *);
static void part2(struct Mylene1f4_audio *, unsigned char **, unsigned *,
		  unsigned *, unsigned *, unsigned *, unsigned *,
		  struct Mylene1f4_granule *, unsigned);

static void
audio_data_0(struct Mylene1f4_audio *audio)
{
    run_frame(audio);
}


static void
audio_data_1(struct Mylene1f4_audio *audio)
{
    /*
     * audio_data()
     */
    /*
     * main_data_begin                                               8  uimsbf
     * if (mode == single_channel) {                                    
     *     private_bits                                              1  bslbf
     * } else {                                                         
     *     private_bits                                              2  bslbf
     * }                                                                
     * for (ch = 0; ch < 2; ch++) {                                     
     *     part2_3_length[ch]                                       12  uimsbf
     *     big_values[ch]                                            9  uimsbf
     *     global_gain[ch]                                           8  uimsbf
     *     scalefac_compress[ch]                                     9  bslbf
     *     window_switching_flag[ch]                                 1  bslbf
     *     if (window_switching_flag[ch]) {                             
     *         block_type[ch]                                        2  bslbf
     *         mixed_block_flag[ch]                                  1  uimsbf
     *         for (region = 0; region < 2; region++) {                 
     *             table_select[ch][region]                          5  bslbf
     *         }                                                        
     *         for (window = 0; window < 3; window++) {                 
     *             subblock_gain[ch][window]                         3  uimsbf
     *         }                                                        
     *     } else {                                                     
     *         for (region = 0; region < 3; region++) {                 
     *             table_select[ch][region]                          5  bslbf
     *         }                                                        
     *         region0_count[ch]                                     4  bslbf
     *         region1_count[ch]                                     3  bslbf
     *     }                                                            
     *     scalefac_scale[ch]                                        1  bslbf
     *     count1table_select[ch]                                    1  bslbf
     * }                                                                
     * main_data()                                                      
     */
    /*
     * main_data()
     */
    /*
     * for (ch = 0; ch < nch; ch++) {                                   
     *     if (window_switching_flag[ch] == 1 && block_type[ch] == 2) { 
     *         if (mixed_block_flag[ch]) {                              
     *             for (sfb = 0; sfb < 8; sfb++) {                      
     *                 scalefac_l[cb][sfb]                        0..4  uimsbf
     *             }                                                    
     *             for (sfb = 3; sfb < 12; sfb++) {                     
     *                 for (window = 0; window < 3; window++) {         
     *                     scalefac_s[cb][sfb][window]            0..5  uimsbf
     *                 }                                                
     *             }                                                    
     *         } else {                                                 
     *             for (sfb = 0; sfb < 12; sfb++) {                     
     *                 for (window = 0; window < 3; window++) {         
     *                     scalefac_s[cb][sfb][window]            0..5  uimsbf
     *                 }                                                
     *             }                                                    
     *         }                                                        
     *     } else {                                                     
     *         for (sfb = 0; sfb < 21; sfb++) {                         
     *             scalefac_l[cb][sfb]                            0..5  uimsbf
     *         }                                                        
     *     }                                                            
     *     Huffmancodebits()                                            
     * }                                                                
     * for (b = 0; b < no_of_ancillary_bits; b++) {                     
     *     ancillary_bit                                             1  bslbf
     * }                                                                
     */
    struct Mylene1f4_granule granule_data[2], *this_granule;
    unsigned cache_buffer = 0, cache_size = 0, frame, joint_stereo_mode = 0,
	sampling_frequency, scalefac[2][39], size;
    unsigned char *buffer;

    if (run_frame(audio)) {
	return;
    }

    if (audio->mode == joint_stereo) {
	joint_stereo_mode = audio->mode_extension;
    }

    buffer = audio->layer_data.III.head;

    sampling_frequency = audio->sampling_frequency + 3;

    granule_data[0].part2_3_length =
	(buffer[0x01] << 6 | buffer[0x02] >> 2) & 4095;
    granule_data[0].big_values =
	(buffer[0x02] << 7 | buffer[0x03] >> 1) & 511;
    granule_data[0].pow2gain = III_break_1 + 256
	- ((buffer[0x03] << 7 | buffer[0x04] >> 1) & 255) + 0;
    granule_data[0].scalefac_compress =
	(buffer[0x04] << 8 | buffer[0x05]) & 511;
    if (buffer[0x06] & 0200) {
	granule_data[0].block_type = (buffer[0x06] >> 5) & 3;
	if (!granule_data[0].block_type) {
	    _Mylene1f4_abort_decoding
		((struct Mylene1f4_whatever *) audio, AUDIO_NULL_BLOCK_TYPE);
	}
	granule_data[0].mixed_block_flag = (~buffer[0x06] >> 4) & 1;
	granule_data[0].table_select[0] =
	    (buffer[0x06] << 1 | buffer[0x07] >> 7) & 31;
	granule_data[0].table_select[1] = (buffer[0x07] >> 2) & 31;
	granule_data[0].table_select[2] = 0;
	granule_data[0].full_gain[0] = granule_data[0].pow2gain
	    + ((buffer[0x07] << 4 | buffer[0x08] >> 4) & 56);
	granule_data[0].full_gain[1] = granule_data[0].pow2gain
	    + ((buffer[0x08] >> 1) & 56);
	granule_data[0].full_gain[2] = granule_data[0].pow2gain
	    + ((buffer[0x08] << 2) & 56);
	granule_data[0].region_address1 =
	    granule_data[0].block_type == 2 ? 18 : 27;
	granule_data[0].region_address2 = 288;
    } else {
	granule_data[0].block_type = 0;
	granule_data[0].table_select[0] = (buffer[0x06] >> 2) & 31;
	granule_data[0].table_select[1] =
	    (buffer[0x06] << 3 | buffer[0x07] >> 5) & 31;
	granule_data[0].table_select[2] = buffer[0x07] & 31;
	{
	    unsigned bull, shit;

	    bull = buffer[0x08] >> 4;
	    shit = (buffer[0x08] >> 1) & 7;
	    granule_data[0].region_address1 =
		_Mylene1f4_table_3_B_8x_0[sampling_frequency][bull + 1] >> 1;
	    granule_data[0].region_address2 =
		_Mylene1f4_table_3_B_8x_0[sampling_frequency]
		[bull + 1 + shit + 1] >> 1;
	}
	granule_data[0].mixed_block_flag = 0;
    }
    granule_data[0].scalefac_scale = buffer[0x08] & 1;
    granule_data[0].count1table_select = (buffer[0x09] >> 7) & 1;
    granule_data[1].part2_3_length =
	(buffer[0x09] << 5 | buffer[0x0a] >> 3) & 4095;
    granule_data[1].big_values =
	(buffer[0x0a] << 6 | buffer[0x0b] >> 2) & 511;
    granule_data[1].pow2gain = III_break_1 + 256
	- ((buffer[0x0b] << 6 | buffer[0x0c] >> 2) & 255) + 0;
    granule_data[1].scalefac_compress =
	(buffer[0x0c] << 7 | buffer[0x0d] >> 1) & 511;
    if (buffer[0x0d] & 0001) {
	granule_data[1].block_type = (buffer[0x0e] >> 6) & 3;
	if (!granule_data[1].block_type) {
	    _Mylene1f4_abort_decoding
		((struct Mylene1f4_whatever *) audio, AUDIO_NULL_BLOCK_TYPE);
	}
	granule_data[1].mixed_block_flag = (~buffer[0x0e] >> 5) & 1;
	granule_data[1].table_select[0] = buffer[0x0e] & 31;
	granule_data[1].table_select[1] = buffer[0x0f] >> 3;
	granule_data[1].table_select[2] = 0;
	granule_data[1].full_gain[0] = granule_data[1].pow2gain
	    + ((buffer[0x0f] << 3) & 56);
	granule_data[1].full_gain[1] = granule_data[1].pow2gain
	    + ((buffer[0x10] >> 2) & 56);
	granule_data[1].full_gain[2] = granule_data[1].pow2gain
	    + ((buffer[0x10] << 1) & 56);
	granule_data[1].region_address1 =
	    granule_data[1].block_type == 2 ? 18 : 27;
	granule_data[1].region_address2 = 288;
    } else {
	granule_data[1].block_type = 0;
	granule_data[1].table_select[0] = buffer[0x0e] >> 3;
	granule_data[1].table_select[1] =
	    (buffer[0x0e] << 2 | buffer[0x0f] >> 6) & 31;
	granule_data[1].table_select[2] = (buffer[0x0f] >> 1) & 31;
	{
	    unsigned bull, shit;

	    bull = (buffer[0x0f] << 3 | buffer[0x10] >> 5) & 15;
	    shit = (buffer[0x10] >> 2) & 7;
	    granule_data[1].region_address1 =
		_Mylene1f4_table_3_B_8x_0[sampling_frequency][bull + 1] >> 1;
	    granule_data[1].region_address2 =
		_Mylene1f4_table_3_B_8x_0[sampling_frequency]
		[bull + 1 + shit + 1] >> 1;
	}
	granule_data[1].mixed_block_flag = 0;
    }
    granule_data[1].scalefac_scale = (buffer[0x10] >> 1) & 1;
    granule_data[1].count1table_select = buffer[0x10] & 1;

    RESTORE_FRAME(audio->last_frame);

    frame = audio->left_frame;

    buffer = audio->layer_data.III.data;
    size = audio->layer_data.III.frames[frame].size;

    this_granule = (struct Mylene1f4_granule *) granule_data;
    {
	Mylene1f4_real hybrid_in[2][576], hybrid_out[2][576];

	part2(audio, &buffer, &size, &frame, &cache_buffer, &cache_size,
	      scalefac[0], this_granule, 0);
	_Mylene1f4_part3(audio, &buffer, &size, &frame, &cache_buffer,
			 &cache_size, scalefac[0], hybrid_in[0], this_granule,
			 sampling_frequency);
	part2(audio, &buffer, &size, &frame, &cache_buffer, &cache_size,
	      scalefac[1], this_granule + 1, audio->mode_extension & 1);
	_Mylene1f4_part3(audio, &buffer, &size, &frame, &cache_buffer,
			 &cache_size, scalefac[1], hybrid_in[1],
			 this_granule + 1, sampling_frequency);

	if (joint_stereo_mode) {
	    if (joint_stereo_mode & 2) {
#if !__RUN_FUTILE__
		_Mylene1f4_ms_stereo(hybrid_in[0], this_granule);
#endif				/* !__RUN_FUTILE__ */
	    }
	    if (joint_stereo_mode & 1) {
#if !__RUN_FUTILE__
		_Mylene1f4_intensity_stereo
		    (hybrid_in[0], scalefac[1], this_granule + 1,
		     sampling_frequency, joint_stereo_mode & 2, 1);
#endif				/* !__RUN_FUTILE__ */
	    }
	    RIGHT_STEREO(this_granule);
	}

#if !__RUN_FUTILE__
	_Mylene1f4_do_time(audio, hybrid_in[0], hybrid_out[0], 0, this_granule);
	_Mylene1f4_do_time
	    (audio, hybrid_in[1], hybrid_out[1], 1, this_granule + 1);
#endif				/* !__RUN_FUTILE__ */

	{
	    unsigned char *output;

	    output = audio->output;
#if !__RUN_FUTILE__
	    audio->polyphase_synthesis_1(audio, hybrid_out[0], 0, output, 18);
	    audio->polyphase_synthesis_1(audio, hybrid_out[1], 1, output, 18);
#endif				/* !__RUN_FUTILE__ */
	}
    }

    ADVANCE_FRAME(audio->last_frame);
}


static void
audio_data_d(struct Mylene1f4_audio *audio)
{
    struct Mylene1f4_granule granule_data, *this_granule;
    unsigned cache_buffer = 0, cache_size = 0, frame, scalefac[39], size;
    unsigned char *buffer;

    if (run_frame(audio)) {
	return;
    }

    buffer = audio->layer_data.III.head;

    granule_data.part2_3_length =
	(buffer[0x01] << 5 | buffer[0x02] >> 3) & 4095;
    granule_data.big_values =
	(buffer[0x02] << 6 | buffer[0x03] >> 2) & 511;
    granule_data.pow2gain = III_break_1 + 256
	- ((buffer[0x03] << 6 | buffer[0x04] >> 2) & 255) + 0;
    granule_data.scalefac_compress =
	(buffer[0x04] << 7 | buffer[0x05] >> 1) & 511;
    if (buffer[0x05] & 0001) {
	granule_data.block_type = (buffer[0x06] >> 6) & 3;
	if (!granule_data.block_type) {
	    _Mylene1f4_abort_decoding
		((struct Mylene1f4_whatever *) audio, AUDIO_NULL_BLOCK_TYPE);
	}
	granule_data.mixed_block_flag = (~buffer[0x06] >> 5) & 1;
	granule_data.table_select[0] = buffer[0x06] & 31;
	granule_data.table_select[1] = buffer[0x07] >> 3;
	granule_data.table_select[2] = 0;
	granule_data.full_gain[0] = granule_data.pow2gain
	    + ((buffer[0x07] << 3) & 56);
	granule_data.full_gain[1] = granule_data.pow2gain
	    + ((buffer[0x08] >> 2) & 56);
	granule_data.full_gain[2] = granule_data.pow2gain
	    + ((buffer[0x08] << 1) & 56);
	granule_data.region_address1 =
	    granule_data.block_type == 2 ? 18 : 27;
	granule_data.region_address2 = 288;
    } else {
	granule_data.block_type = 0;
	granule_data.table_select[0] = buffer[0x06] >> 3;
	granule_data.table_select[1] =
	    (buffer[0x06] << 2 | buffer[0x07] >> 6) & 31;
	granule_data.table_select[2] = (buffer[0x07] >> 1) & 31;
	{
	    unsigned bull, shit;

	    bull = (buffer[0x07] << 3 | buffer[0x08] >> 5) & 15;
	    shit = (buffer[0x08] >> 2) & 7;
	    granule_data.region_address1 =
		_Mylene1f4_table_3_B_8x_0[audio->sampling_frequency + 3]
		[bull + 1] >> 1;
	    granule_data.region_address2 =
		_Mylene1f4_table_3_B_8x_0[audio->sampling_frequency + 3]
		[bull + 1 + shit + 1] >> 1;
	}
	granule_data.mixed_block_flag = 0;
    }
    granule_data.scalefac_scale = (buffer[0x08] >> 1) & 1;
    granule_data.count1table_select = buffer[0x08] & 1;

    RESTORE_FRAME(audio->last_frame);

    frame = audio->left_frame;

    buffer = audio->layer_data.III.data;
    size = audio->layer_data.III.frames[frame].size;

    this_granule = (struct Mylene1f4_granule *) &granule_data;
    {
	Mylene1f4_real hybrid_in[576], hybrid_out[576];

        part2(audio, &buffer, &size, &frame, &cache_buffer, &cache_size,
	      scalefac, this_granule, 0);
	_Mylene1f4_part3(audio, &buffer, &size, &frame, &cache_buffer,
			 &cache_size, scalefac, hybrid_in, this_granule,
			 audio->sampling_frequency + 3);

#if !__RUN_FUTILE__
	_Mylene1f4_do_time(audio, hybrid_in, hybrid_out, 0, this_granule);
#endif				/* !__RUN_FUTILE__ */

#if !__RUN_FUTILE__
	audio->polyphase_synthesis_0(audio, hybrid_out, audio->output, 18);
#endif				/* !__RUN_FUTILE__ */
    }

    ADVANCE_FRAME(audio->last_frame);
}


static int
run_frame(struct Mylene1f4_audio *audio)
{
    struct Mylene1f4_frame *frames;
    unsigned audio_data_size, frame;
    unsigned char *buffer;

    audio_data_size = audio->frame_data_size;
    buffer = audio->buffer + (audio->syncword_offset - audio_data_size);

    audio->layer_data.III.head = buffer;

    frames = audio->layer_data.III.frames;

    frame = audio->last_frame;

    if (audio->mode == single_channel) {
	audio_data_size -= 9;
	frames[frame].buffer = buffer + 9;
    } else {
	audio_data_size -= 17;
	frames[frame].buffer = buffer + 17;
    }
    frames[frame].size = audio_data_size;

    ADVANCE_FRAME(frame);
    audio->last_frame = frame;

    {
	unsigned swap;

	swap = audio_data_size;
	audio_data_size = audio->frame_size;
	audio->frame_size = swap;
    }
    {
	unsigned main_data_begin;

	main_data_begin = *buffer;
	if (audio_data_size < main_data_begin) {
	    _Mylene1f4_abort_decoding((struct Mylene1f4_whatever *) audio,
				      AUDIO_INVALID_BACKWARD_SEEK);

	    audio->frame_size += audio_data_size;

	    return 1;
	}
	audio_data_size -= main_data_begin;
	audio->frame_size += main_data_begin;
    }

    frame = audio->left_frame;

    while (audio_data_size) {
	struct Mylene1f4_frame *frame_data;

	frame_data = frames + frame;
	if (audio_data_size < frame_data->size) {
	    frame_data->buffer += audio_data_size;
	    frame_data->size -= audio_data_size;
	    audio_data_size = 0;
	} else {
	    audio_data_size -= frame_data->size;
	    ADVANCE_FRAME(frame);
	}
    }

    audio->left_frame = frame;

    buffer = frames[frame].buffer;

    audio->layer_data.III.data = buffer;

    audio->syncword_offset -= buffer - audio->buffer;
    if (audio->syncword_offset < audio->frame_data_size) {
	buffer += audio->syncword_offset;
	buffer -= audio->frame_data_size;
	audio->syncword_offset = audio->frame_data_size;
    }
    audio->size -= buffer - audio->buffer;
    audio->buffer = buffer;

    return 0;
}


static void
optimistique_moi(struct Mylene1f4_audio *audio, unsigned char **buffer,
		 unsigned *size, unsigned *frame)
{
    unsigned this_frame;

    this_frame = *frame;
    if (this_frame == audio->last_frame) {
	_Mylene1f4_abort_decoding
	    ((struct Mylene1f4_whatever *) audio, AUDIO_AUDIO_DATA_FAULT);
    } else {
	struct Mylene1f4_frame *frame_data;

	ADVANCE_FRAME(this_frame);
	*frame = this_frame;
	frame_data = audio->layer_data.III.frames + this_frame;
	*buffer = frame_data->buffer;
	*size = frame_data->size;
    }
}


static void
part2(struct Mylene1f4_audio *audio, unsigned char **buffer_in_out,
      unsigned *size_in_out, unsigned *frame, unsigned *cache_buffer_in_out,
      unsigned *cache_size_in_out, unsigned *scalefac,
      struct Mylene1f4_granule *granule, unsigned composite)
{
    unsigned *aea, cache_buffer, cache_size, part2_length,
	scalefac_compress, size;
    unsigned char *buffer;

    aea = scalefac;
    buffer = *buffer_in_out;
    cache_buffer = *cache_buffer_in_out;
    cache_size = *cache_size_in_out;
    size = *size_in_out;

    scalefac_compress = granule->scalefac_compress;

    if (composite) {
	scalefac_compress >>= 1;
	if (scalefac_compress < 180) {
	    unsigned slen1, slen2, slen3;

	    slen1 = scalefac_compress / 36;
	    slen2 = (scalefac_compress % 36) / 6;
	    slen3 = scalefac_compress % 6;
	    if (granule->block_type == 2) {
		unsigned i, mask;

		mask = (1 << slen1) - 1;
		i = 8 + (granule->mixed_block_flag << 2);
		part2_length = i * slen1;
		for (; i; i--) {
		    if (cache_size < slen1) {
			if (!size) {
			    optimistique_moi(audio, &buffer, &size, frame);
			}
			cache_buffer <<= 8;
			cache_buffer |= *buffer++;
			cache_size += 8;
			size--;
		    }
		    cache_size -= slen1;
		    *aea++ = (cache_buffer >> cache_size) & mask;
		}
		mask = (1 << slen2) - 1;
		i = 15 - granule->mixed_block_flag * 3;
		part2_length += i * slen2;
		for (; i; i--) {
		    if (cache_size < slen2) {
			if (!size) {
			    optimistique_moi(audio, &buffer, &size, frame);
			}
			cache_buffer <<= 8;
			cache_buffer |= *buffer++;
			cache_size += 8;
			size--;
		    }
		    cache_size -= slen2;
		    *aea++ = (cache_buffer >> cache_size) & mask;
		}
		mask = (1 << slen3) - 1;
		part2_length += 12 * slen3;
		for (i = 12; i; i--) {
		    if (cache_size < slen3) {
			if (!size) {
			    optimistique_moi(audio, &buffer, &size, frame);
			}
			cache_buffer <<= 8;
			cache_buffer |= *buffer++;
			cache_size += 8;
			size--;
		    }
		    cache_size -= slen3;
		    *aea++ = (cache_buffer >> cache_size) & mask;
		}

		BUGGY_FILL___2_();
	    } else {
		unsigned i = 7, mask;

		mask = (1 << slen1) - 1;
		part2_length = 7 * slen1;
		for (; i; i--) {
		    if (cache_size < slen1) {
			if (!size) {
			    optimistique_moi(audio, &buffer, &size, frame);
			}
			cache_buffer <<= 8;
			cache_buffer |= *buffer++;
			cache_size += 8;
			size--;
		    }
		    cache_size -= slen1;
		    *aea++ = (cache_buffer >> cache_size) & mask;
		}
		mask = (1 << slen2) - 1;
		part2_length += 7 * slen2;
		for (i = 7; i; i--) {
		    if (cache_size < slen2) {
			if (!size) {
			    optimistique_moi(audio, &buffer, &size, frame);
			}
			cache_buffer <<= 8;
			cache_buffer |= *buffer++;
			cache_size += 8;
			size--;
		    }
		    cache_size -= slen2;
		    *aea++ = (cache_buffer >> cache_size) & mask;
		}
		mask = (1 << slen3) - 1;
		part2_length += 7 * slen3;
		for (i = 7; i; i--) {
		    if (cache_size < slen3) {
			if (!size) {
			    optimistique_moi(audio, &buffer, &size, frame);
			}
			cache_buffer <<= 8;
			cache_buffer |= *buffer++;
			cache_size += 8;
			size--;
		    }
		    cache_size -= slen3;
		    *aea++ = (cache_buffer >> cache_size) & mask;
		}

		BUGGY_FILL_01_3();
	    }
	} else if (scalefac_compress < 500) {
	    unsigned slen1, slen2, slen3;

	    scalefac_compress -= 180;
	    slen1 = (scalefac_compress & 63) >> 4;
	    slen2 = (scalefac_compress & 15) >> 2;
	    slen3 = scalefac_compress & 3;
	    if (granule->block_type == 2) {
		unsigned i, mask;

		mask = (1 << slen1) - 1;
		i = 8 + (granule->mixed_block_flag << 2);
		part2_length = i * slen1;
		for (; i; i--) {
		    if (cache_size < slen1) {
			if (!size) {
			    optimistique_moi(audio, &buffer, &size, frame);
			}
			cache_buffer <<= 8;
			cache_buffer |= *buffer++;
			cache_size += 8;
			size--;
		    }
		    cache_size -= slen1;
		    *aea++ = (cache_buffer >> cache_size) & mask;
		}
		mask = (1 << slen2) - 1;
		i = 12 - granule->mixed_block_flag * 3;
		part2_length += i * slen2;
		for (; i; i--) {
		    if (cache_size < slen2) {
			if (!size) {
			    optimistique_moi(audio, &buffer, &size, frame);
			}
			cache_buffer <<= 8;
			cache_buffer |= *buffer++;
			cache_size += 8;
			size--;
		    }
		    cache_size -= slen2;
		    *aea++ = (cache_buffer >> cache_size) & mask;
		}
		mask = (1 << slen3) - 1;
		part2_length += 9 * slen3;
		for (i = 9; i; i--) {
		    if (cache_size < slen3) {
			if (!size) {
			    optimistique_moi(audio, &buffer, &size, frame);
			}
			cache_buffer <<= 8;
			cache_buffer |= *buffer++;
			cache_size += 8;
			size--;
		    }
		    cache_size -= slen3;
		    *aea++ = (cache_buffer >> cache_size) & mask;
		}
		*aea++ = 0;
		*aea++ = 0;
		*aea++ = 0;
		*aea++ = 0;
		*aea++ = 0;
		*aea++ = 0;

		BUGGY_FILL___2_();
	    } else {
		unsigned i = 6, mask;

		mask = (1 << slen1) - 1;
		part2_length = 6 * slen1;
		for (; i; i--) {
		    if (cache_size < slen1) {
			if (!size) {
			    optimistique_moi(audio, &buffer, &size, frame);
			}
			cache_buffer <<= 8;
			cache_buffer |= *buffer++;
			cache_size += 8;
			size--;
		    }
		    cache_size -= slen1;
		    *aea++ = (cache_buffer >> cache_size) & mask;
		}
		mask = (1 << slen2) - 1;
		part2_length += 6 * slen2;
		for (i = 6; i; i--) {
		    if (cache_size < slen2) {
			if (!size) {
			    optimistique_moi(audio, &buffer, &size, frame);
			}
			cache_buffer <<= 8;
			cache_buffer |= *buffer++;
			cache_size += 8;
			size--;
		    }
		    cache_size -= slen2;
		    *aea++ = (cache_buffer >> cache_size) & mask;
		}
		mask = (1 << slen3) - 1;
		part2_length += 6 * slen3;
		for (i = 6; i; i--) {
		    if (cache_size < slen3) {
			if (!size) {
			    optimistique_moi(audio, &buffer, &size, frame);
			}
			cache_buffer <<= 8;
			cache_buffer |= *buffer++;
			cache_size += 8;
			size--;
		    }
		    cache_size -= slen3;
		    *aea++ = (cache_buffer >> cache_size) & mask;
		}
		*aea++ = 0;
		*aea++ = 0;
		*aea++ = 0;

		BUGGY_FILL_01_3();
	    }
	} else {
	    unsigned slen1, slen2;

	    scalefac_compress -= 244;
	    slen1 = scalefac_compress / 3;
	    slen2 = scalefac_compress % 3;
	    if (granule->block_type == 2) {
		unsigned i, mask;

		mask = (1 << slen1) - 1;
		i = 8 + granule->mixed_block_flag * 7;
		part2_length = i * slen1;
		for (; i; i--) {
		    if (cache_size < slen1) {
			if (!size) {
			    optimistique_moi(audio, &buffer, &size, frame);
			}
			cache_buffer <<= 8;
			cache_buffer |= *buffer++;
			cache_size += 8;
			size--;
		    }
		    cache_size -= slen1;
		    *aea++ = (cache_buffer >> cache_size) & mask;
		}
		mask = (1 << slen2) - 1;
		i = 18 - granule->mixed_block_flag * 6;
		part2_length += i * slen2;
		for (; i; i--) {
		    if (cache_size < slen2) {
			if (!size) {
			    optimistique_moi(audio, &buffer, &size, frame);
			}
			cache_buffer <<= 8;
			cache_buffer |= *buffer++;
			cache_size += 8;
			size--;
		    }
		    cache_size -= slen2;
		    *aea++ = (cache_buffer >> cache_size) & mask;
		}
		*aea++ = 0;
		*aea++ = 0;
		*aea++ = 0;
		*aea++ = 0;
		*aea++ = 0;
		*aea++ = 0;
		*aea++ = 0;
		*aea++ = 0;
		*aea++ = 0;

		BUGGY_FILL___2_();
	    } else {
		unsigned i = 8, mask;

		mask = (1 << slen1) - 1;
		part2_length = 8 * slen1;
		for (; i; i--) {
		    if (cache_size < slen1) {
			if (!size) {
			    optimistique_moi(audio, &buffer, &size, frame);
			}
			cache_buffer <<= 8;
			cache_buffer |= *buffer++;
			cache_size += 8;
			size--;
		    }
		    cache_size -= slen1;
		    *aea++ = (cache_buffer >> cache_size) & mask;
		}
		mask = (1 << slen2) - 1;
		part2_length += 8 * slen2;
		for (i = 8; i; i--) {
		    if (cache_size < slen2) {
			if (!size) {
			    optimistique_moi(audio, &buffer, &size, frame);
			}
			cache_buffer <<= 8;
			cache_buffer |= *buffer++;
			cache_size += 8;
			size--;
		    }
		    cache_size -= slen2;
		    *aea++ = (cache_buffer >> cache_size) & mask;
		}
		*aea++ = 0;
		*aea++ = 0;
		*aea++ = 0;
		*aea++ = 0;
		*aea++ = 0;

		BUGGY_FILL_01_3();
	    }
	}

	granule->preflag = 0;
    } else {
	if (scalefac_compress < 400) {
	    unsigned slen1, slen2, slen3, slen4;

	    slen1 = (scalefac_compress >> 4) / 5;
	    slen2 = (scalefac_compress >> 4) % 5;
	    slen3 = (scalefac_compress & 15) >> 2;
	    slen4 = scalefac_compress & 3;
	    if (granule->block_type == 2) {
		unsigned i, mask;

		mask = (1 << slen1) - 1;
		i = 8 + granule->mixed_block_flag;
		part2_length = i * slen1;
		for (; i; i--) {
		    if (cache_size < slen1) {
			if (!size) {
			    optimistique_moi(audio, &buffer, &size, frame);
			}
			cache_buffer <<= 8;
			cache_buffer |= *buffer++;
			cache_size += 8;
			size--;
		    }
		    cache_size -= slen1;
		    *aea++ = (cache_buffer >> cache_size) & mask;
		}
		mask = (1 << slen2) - 1;
		part2_length += 9 * slen2;
		for (i = 9; i; i--) {
		    if (cache_size < slen2) {
			if (!size) {
			    optimistique_moi(audio, &buffer, &size, frame);
			}
			cache_buffer <<= 8;
			cache_buffer |= *buffer++;
			cache_size += 8;
			size--;
		    }
		    cache_size -= slen2;
		    *aea++ = (cache_buffer >> cache_size) & mask;
		}
		mask = (1 << slen3) - 1;
		part2_length += 9 * slen3;
		for (i = 9; i; i--) {
		    if (cache_size < slen3) {
			if (!size) {
			    optimistique_moi(audio, &buffer, &size, frame);
			}
			cache_buffer <<= 8;
			cache_buffer |= *buffer++;
			cache_size += 8;
			size--;
		    }
		    cache_size -= slen3;
		    *aea++ = (cache_buffer >> cache_size) & mask;
		}
		mask = (1 << slen4) - 1;
		part2_length += 9 * slen4;
		for (i = 9; i; i--) {
		    if (cache_size < slen4) {
			if (!size) {
			    optimistique_moi(audio, &buffer, &size, frame);
			}
			cache_buffer <<= 8;
			cache_buffer |= *buffer++;
			cache_size += 8;
			size--;
		    }
		    cache_size -= slen4;
		    *aea++ = (cache_buffer >> cache_size) & mask;
		}

		BUGGY_FILL___2_();
	    } else {
		unsigned i = 6, mask;

		mask = (1 << slen1) - 1;
		part2_length = 6 * slen1;
		for (; i; i--) {
		    if (cache_size < slen1) {
			if (!size) {
			    optimistique_moi(audio, &buffer, &size, frame);
			}
			cache_buffer <<= 8;
			cache_buffer |= *buffer++;
			cache_size += 8;
			size--;
		    }
		    cache_size -= slen1;
		    *aea++ = (cache_buffer >> cache_size) & mask;
		}
		mask = (1 << slen2) - 1;
		part2_length += 5 * slen2;
		for (i = 5; i; i--) {
		    if (cache_size < slen2) {
			if (!size) {
			    optimistique_moi(audio, &buffer, &size, frame);
			}
			cache_buffer <<= 8;
			cache_buffer |= *buffer++;
			cache_size += 8;
			size--;
		    }
		    cache_size -= slen2;
		    *aea++ = (cache_buffer >> cache_size) & mask;
		}
		mask = (1 << slen3) - 1;
		part2_length += 5 * slen3;
		for (i = 5; i; i--) {
		    if (cache_size < slen3) {
			if (!size) {
			    optimistique_moi(audio, &buffer, &size, frame);
			}
			cache_buffer <<= 8;
			cache_buffer |= *buffer++;
			cache_size += 8;
			size--;
		    }
		    cache_size -= slen3;
		    *aea++ = (cache_buffer >> cache_size) & mask;
		}
		mask = (1 << slen4) - 1;
		part2_length += 5 * slen4;
		for (i = 5; i; i--) {
		    if (cache_size < slen4) {
			if (!size) {
			    optimistique_moi(audio, &buffer, &size, frame);
			}
			cache_buffer <<= 8;
			cache_buffer |= *buffer++;
			cache_size += 8;
			size--;
		    }
		    cache_size -= slen4;
		    *aea++ = (cache_buffer >> cache_size) & mask;
		}

		BUGGY_FILL_01_3();
	    }

	    granule->preflag = 0;
	} else if (scalefac_compress < 500) {
	    unsigned slen1, slen2, slen3;

	    scalefac_compress -= 400;
	    slen1 = (scalefac_compress >> 2) / 5;
	    slen2 = (scalefac_compress >> 2) % 5;
	    slen3 = scalefac_compress & 3;
	    if (granule->block_type == 2) {
		unsigned i, mask;

		mask = (1 << slen1) - 1;
		i = 8 + granule->mixed_block_flag;
		part2_length = i * slen1;
		for (; i; i--) {
		    if (cache_size < slen1) {
			if (!size) {
			    optimistique_moi(audio, &buffer, &size, frame);
			}
			cache_buffer <<= 8;
			cache_buffer |= *buffer++;
			cache_size += 8;
			size--;
		    }
		    cache_size -= slen1;
		    *aea++ = (cache_buffer >> cache_size) & mask;
		}
		mask = (1 << slen2) - 1;
		part2_length += 9 * slen2;
		for (i = 9; i; i--) {
		    if (cache_size < slen2) {
			if (!size) {
			    optimistique_moi(audio, &buffer, &size, frame);
			}
			cache_buffer <<= 8;
			cache_buffer |= *buffer++;
			cache_size += 8;
			size--;
		    }
		    cache_size -= slen2;
		    *aea++ = (cache_buffer >> cache_size) & mask;
		}
		mask = (1 << slen3) - 1;
		part2_length += 12 * slen3;
		for (i = 12; i; i--) {
		    if (cache_size < slen3) {
			if (!size) {
			    optimistique_moi(audio, &buffer, &size, frame);
			}
			cache_buffer <<= 8;
			cache_buffer |= *buffer++;
			cache_size += 8;
			size--;
		    }
		    cache_size -= slen3;
		    *aea++ = (cache_buffer >> cache_size) & mask;
		}
		*aea++ = 0;
		*aea++ = 0;
		*aea++ = 0;
		*aea++ = 0;
		*aea++ = 0;
		*aea++ = 0;

		BUGGY_FILL___2_();
	    } else {
		unsigned i = 6, mask;

		mask = (1 << slen1) - 1;
		part2_length = 6 * slen1;
		for (; i; i--) {
		    if (cache_size < slen1) {
			if (!size) {
			    optimistique_moi(audio, &buffer, &size, frame);
			}
			cache_buffer <<= 8;
			cache_buffer |= *buffer++;
			cache_size += 8;
			size--;
		    }
		    cache_size -= slen1;
		    *aea++ = (cache_buffer >> cache_size) & mask;
		}
		mask = (1 << slen2) - 1;
		part2_length += 5 * slen2;
		for (i = 5; i; i--) {
		    if (cache_size < slen2) {
			if (!size) {
			    optimistique_moi(audio, &buffer, &size, frame);
			}
			cache_buffer <<= 8;
			cache_buffer |= *buffer++;
			cache_size += 8;
			size--;
		    }
		    cache_size -= slen2;
		    *aea++ = (cache_buffer >> cache_size) & mask;
		}
		mask = (1 << slen3) - 1;
		part2_length += 7 * slen3;
		for (i = 7; i; i--) {
		    if (cache_size < slen3) {
			if (!size) {
			    optimistique_moi(audio, &buffer, &size, frame);
			}
			cache_buffer <<= 8;
			cache_buffer |= *buffer++;
			cache_size += 8;
			size--;
		    }
		    cache_size -= slen3;
		    *aea++ = (cache_buffer >> cache_size) & mask;
		}
		*aea++ = 0;
		*aea++ = 0;
		*aea++ = 0;

		BUGGY_FILL_01_3();
	    }

	    granule->preflag = 0;
	} else {
	    unsigned slen1, slen2;

	    scalefac_compress -= 500;
	    slen1 = scalefac_compress / 3;
	    slen2 = scalefac_compress % 3;
	    if (granule->block_type == 2) {
		unsigned i, mask;

		mask = (1 << slen1) - 1;
		i = 17 + granule->mixed_block_flag;
		part2_length = i * slen1;
		for (; i; i--) {
		    if (cache_size < slen1) {
			if (!size) {
			    optimistique_moi(audio, &buffer, &size, frame);
			}
			cache_buffer <<= 8;
			cache_buffer |= *buffer++;
			cache_size += 8;
			size--;
		    }
		    cache_size -= slen1;
		    *aea++ = (cache_buffer >> cache_size) & mask;
		}
		mask = (1 << slen2) - 1;
		part2_length += 18 * slen2;
		for (i = 18; i; i--) {
		    if (cache_size < slen2) {
			if (!size) {
			    optimistique_moi(audio, &buffer, &size, frame);
			}
			cache_buffer <<= 8;
			cache_buffer |= *buffer++;
			cache_size += 8;
			size--;
		    }
		    cache_size -= slen2;
		    *aea++ = (cache_buffer >> cache_size) & mask;
		}

		BUGGY_FILL___2_();
	    } else {
		unsigned i = 11, mask;

		mask = (1 << slen1) - 1;
		part2_length = 11 * slen1;
		for (; i; i--) {
		    if (cache_size < slen1) {
			if (!size) {
			    optimistique_moi(audio, &buffer, &size, frame);
			}
			cache_buffer <<= 8;
			cache_buffer |= *buffer++;
			cache_size += 8;
			size--;
		    }
		    cache_size -= slen1;
		    *aea++ = (cache_buffer >> cache_size) & mask;
		}
		mask = (1 << slen2) - 1;
		part2_length += 10 * slen2;
		for (i = 10; i; i--) {
		    if (cache_size < slen2) {
			if (!size) {
			    optimistique_moi(audio, &buffer, &size, frame);
			}
			cache_buffer <<= 8;
			cache_buffer |= *buffer++;
			cache_size += 8;
			size--;
		    }
		    cache_size -= slen2;
		    *aea++ = (cache_buffer >> cache_size) & mask;
		}

		BUGGY_FILL_01_3();
	    }

	    granule->preflag = 1;
	}
    }

    granule->part2_3_length -= part2_length;

    *buffer_in_out = buffer;
    *cache_buffer_in_out = cache_buffer;
    *cache_size_in_out = cache_size;
    *size_in_out = size;
}
