/*
 * e1f4.9.11172.c
 * Copyright (C) 2003, 2004, 2005, 2006, 2007  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e1f4.3.h>
#include <e1f4.5.h>

void
Mylene1f4_get_allocation(struct Mylene1f4_audio *audio, unsigned *count,
			 unsigned trans, unsigned *scale)
{
    unsigned frame, trail;

    frame = audio->left_frame;
    trail = audio->last_frame;
    if (trail < frame) {
	trail += MAX_NFRAMES;
    }
    trail -= frame;
    *count = trail;
    if (trans < trail) {
	trail = trans;
    }
    if (trail) {
	do {
	    *scale++ = audio->layer_data.III.frames[frame].size;
	    ADVANCE_FRAME(frame);
	    trail--;
	} while (trail);
    }
}
