/*
 * e1f4.9.c
 * Copyright (C) 2003, 2004, 2005, 2006, 2007  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e1f4.0.h>
#include <e1f4.2.h>
#include <e1f4.3.h>
#include <e1f4.5.h>

void
_Mylene1f4_set_buffer(struct Mylene1f4_audio *audio, unsigned char *buffer)
{
    if (audio->layer == Layer_III) {
	integral_q diff;
	unsigned frame, trail;

	diff = (integral_q) audio->buffer;
	diff -= (integral_q) buffer;
	frame = audio->left_frame;
	trail = audio->last_frame;
#if 0
	while (frame != trail) {
	    audio->layer_data.III.frames[frame].buffer -= diff;
	    ADVANCE_FRAME(frame);
	}
#else
	if (frame != trail) {
	    struct Mylene1f4_frame *shift;

	    shift = audio->layer_data.III.frames;
	    shift += frame;
	    if (frame < trail) {
		trail -= frame;
		while (trail) {
		    shift->buffer -= diff;
		    shift++;
		    trail--;
		}
	    } else {
		frame ^= MAX_XFRAMES;
		while (1) {
		    shift->buffer -= diff;
		    shift++;
		    if (!frame) {
			break;
		    }
		    frame--;
		}
		shift -= MAX_NFRAMES;
		while (trail) {
		    shift->buffer -= diff;
		    shift++;
		    trail--;
		}
	    }
	}
#endif				/* 0 */
    }
    audio->buffer = buffer;
}


void
Mylene1f4_correct_underflow(struct Mylene1f4_audio *audio)
{
    if (audio->layer == Layer_III) {
	unsigned char *buffer, *save_buffer;

	save_buffer = audio->buffer;
	audio->optimistique_moi(audio);
	buffer = audio->buffer;
	audio->buffer = save_buffer;
	_Mylene1f4_set_buffer(audio, buffer);
    } else {
	audio->optimistique_moi(audio);
    }
}
