/*
 * e1f4.e.11172.c
 * Copyright (C) 2003, 2004, 2005, 2006, 2007, 2008  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e1f4.0.h>

extern const unsigned _Mylene1f4_aussi_bien_satanique[][8],
    _Mylene1f4_quapostropheangeacutelique[][8];

void
Mylene1f4_syncword_offset(unsigned header, unsigned *syncword_offset)
{
    unsigned ID, bitrate_index, layer, padding_bit, sampling_frequency;

#if WORDS_BIGENDIAN
    if ((header & 0xfff00000) != 0xfff00000 || !(header & 0x00060000)) {
	*syncword_offset = 0;
    } else {
	ID = (header >> 021) & 4;
	layer = (header >> 021) & 3;
	bitrate_index = (header >> 014) & 15;
	padding_bit = (header >> 011) & 1;
	sampling_frequency = (header >> 012) & 3;
#elif 0
    }
#else
    if ((header & 0x0000f0ff) != 0x0000f0ff || !(header & 0x00000600)) {
	*syncword_offset = 0;
    } else {
	ID = (header >> 011) & 4;
	layer = (header >> 011) & 3;
	bitrate_index = (header >> 024) & 15;
	padding_bit = (header >> 021) & 1;
	sampling_frequency = (header >> 022) & 3;
#endif				/* WORDS_BIGENDIAN */
	if (sampling_frequency == 3) {
	    *syncword_offset = 0;
	} else {
	    if (!bitrate_index) {
		*syncword_offset = 0;
	    } else {
		if (bitrate_index == 15) {
		    *syncword_offset = 0;
		} else {
		    unsigned audio_data_size, dslots, nslots;

		    nslots = _Mylene1f4_aussi_bien_satanique
			[bitrate_index][ID | layer];
		    dslots = _Mylene1f4_quapostropheangeacutelique
			[0][ID | sampling_frequency];
		    audio_data_size = nslots / dslots;
		    if (!sampling_frequency && padding_bit) {
			audio_data_size++;
		    }
		    if (layer == 3) {
			audio_data_size <<= 2;
		    }
		    *syncword_offset = audio_data_size;
		}
	    }
	}
    }
}
