/*
 * h262.0.c
 * Copyright (C) 2003, 2004  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <h262.0.h>
#include <h262.1.h>
#include <h262.3.h>
#include <h262.a.h>

void
seek_h262_neXt_start_code(struct seek_h262_whatever *whatever)
{
    unsigned skipped;

    skipped = whatever->start_code;
    if (2 < skipped) {
	skipped = 2;
    }
    if (whatever->size < 3 - skipped) {
	whatever->correct_underflow(whatever);
    } {
	unsigned size;
	unsigned char *buffer;

	buffer = whatever->buffer;
	size = 2 - skipped;
	for (; size && !*buffer; buffer++, size--);
	if (size) {
	    _seek_h262_abort_decoding
		(whatever, WHATEVER_FAILED_START_CODE_LOOKUP);
	} else {
	    size = whatever->size - 2 + skipped;
	    while (!*buffer) {
		buffer++;
		size--;
		if (!size) {
		    whatever->buffer = buffer;
		    whatever->size = size;
		    whatever->correct_underflow(whatever);
		    buffer = whatever->buffer;
		    size = whatever->size;
		}
	    }
	    if (*buffer != 0x01) {
		_seek_h262_abort_divergent_decoding
		    (whatever, buffer, size,
		     WHATEVER_FAILED_START_CODE_LOOKUP);
	    }
	    buffer++;
	    size--;
	    if (size) {
#if WORDS_BIGENDIAN
		whatever->start_code = 0x00000100 | *buffer++;
#else
		whatever->start_code = 0x00010000 | *buffer++ << 24;
#endif				/* WORDS_BIGENDIAN */
		whatever->buffer = buffer;
		whatever->size = size - 1;
	    } else {
		whatever->buffer = buffer;
		whatever->size = size;
		whatever->correct_underflow(whatever);
		whatever->size--;
#if WORDS_BIGENDIAN
		whatever->start_code = 0x00000100 | *whatever->buffer++;
#else
		whatever->start_code = 0x00010000 | *whatever->buffer++ << 24;
#endif				/* WORDS_BIGENDIAN */
	    }
	}
    }
}


void
seek_h262_next_start_code(struct seek_h262_whatever *whatever)
{
    /*
     * while (!bytealigned()) {                                         
     *     zero_bit                                                  1  '0'
     * }                                                                
     * while (nextbits() != '0000 0000 0000 0000 0000 0001') {          
     *     zero_byte                                                    
     * }                                                             8  '00000000'
     */
    if (whatever->size < 3) {
	whatever->correct_underflow(whatever);
    } {
	unsigned char *buffer;

	buffer = whatever->buffer;
	if (*buffer || buffer[1]) {
	    _seek_h262_abort_decoding
		(whatever, WHATEVER_FAILED_START_CODE_LOOKUP);
	} else {
	    unsigned size;

	    buffer += 2;
	    size = whatever->size - 2;
	    while (!*buffer) {
		buffer++;
		size--;
		if (!size) {
		    whatever->buffer = buffer;
		    whatever->size = size;
		    whatever->correct_underflow(whatever);
		    buffer = whatever->buffer;
		    size = whatever->size;
		}
	    }
	    if (*buffer != 0x01) {
		_seek_h262_abort_divergent_decoding
		    (whatever, buffer, size,
		     WHATEVER_FAILED_START_CODE_LOOKUP);
	    }
	    buffer++;
	    size--;
	    if (size) {
#if WORDS_BIGENDIAN
		whatever->start_code = 0x00000100 | *buffer++;
#else
		whatever->start_code = 0x00010000 | *buffer++ << 24;
#endif				/* WORDS_BIGENDIAN */
		whatever->buffer = buffer;
		whatever->size = size - 1;
	    } else {
		whatever->buffer = buffer;
		whatever->size = size;
		whatever->correct_underflow(whatever);
		whatever->size--;
#if WORDS_BIGENDIAN
		whatever->start_code = 0x00000100 | *whatever->buffer++;
#else
		whatever->start_code = 0x00010000 | *whatever->buffer++ << 24;
#endif				/* WORDS_BIGENDIAN */
	    }
	}
    }
}
