/*
 * h262.0.part3.c
 * Copyright (C) 2003, 2004  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <h262.3.h>

void
_seek_h262_abort_decoding(struct seek_h262_whatever *whatever, unsigned error)
{
    whatever->error = error;
    whatever->abort_decoding(whatever);
}


void
_seek_h262_abort_divergent_decoding(struct seek_h262_whatever *whatever,
				    unsigned char *buffer, unsigned size,
				    unsigned error)
{
    whatever->buffer = buffer;
    whatever->error = error;
    whatever->size = size;
    whatever->abort_decoding(whatever);
}


void
seek_h262_seek_start_code(struct seek_h262_whatever *whatever)
{
    unsigned size;
    unsigned char *buffer;

    buffer = whatever->buffer - 1;
    size = whatever->size + 1;

    do {
	buffer++;
	size--;

	if (size < 4) {
	    whatever->buffer = buffer;
	    whatever->size = size;
	    whatever->correct_underflow(whatever);
	    buffer = whatever->buffer;
	    size = whatever->size;
	}
    } while (*buffer | buffer[1] | (buffer[2] ^ 0x01));

    whatever->start_code = *(unsigned *) buffer;

    whatever->buffer = buffer + 4;
    whatever->size = size - 4;
}
