/*
 * h262.1.d4.h
 * Copyright (C) 2003, 2004, 2005, 2006  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __SEEK_H262_1_D4_H__
#define __SEEK_H262_1_D4_H__

#include <h262.0.h>
#include <h262.5.h>

#define DECODE_11172_B__BLOCK() \
    {									      \
	RESET_SIXTY_THREE(coefficients);				      \
	if (cache_size < 2) {						      \
	    cache_buffer = cache_buffer << 8 | *buffer++;		      \
	    cache_size += 8;						      \
	    size--;							      \
	}								      \
	if ((cache_buffer >> (cache_size - 2) & 3) == 2) {		      \
	} else {							      \
	    unsigned sign;						      \
									      \
	    do {							      \
		int level, v;						      \
		unsigned run;						      \
									      \
		DECODE_11172_Be_COEFFICIENT(_seek_h262_B_e_012_0,	      \
					    _seek_h262_B_e_012_1);	      \
		i += run;						      \
		if (63 < i) {						      \
		    ABORT_DECODING(video, buffer, size, VIDEO_INVALID_CODE);  \
		}							      \
		run = inverse_scan[i];					      \
		v = ((level * (run >> 8 & 255) * quantiser_scale >> 4) - 1)   \
		    | 1;						      \
		level = -(int) ((sign & 4) >> 2);			      \
		if (2047 - level < v) {					      \
		    v = 2047 - level;					      \
		}							      \
		v = (v ^ level) - level;				      \
		coefficients[run & 255] = v;				      \
	    } while ((sign & 3) != 2);					      \
	}								      \
	cache_size -= 2;						      \
    }

#if __ENABLE_BLOCK_META_DATA__
# undef DECODE_11172_B__BLOCK

# define DECODE_11172_B__BLOCK() \
    {									      \
	RESET_SIXTY_THREE(coefficients);				      \
	if (cache_size < 2) {						      \
	    cache_buffer = cache_buffer << 8 | *buffer++;		      \
	    cache_size += 8;						      \
	    size--;							      \
	}								      \
	meta_block = *inverse_scan;					      \
	if ((cache_buffer >> (cache_size - 2) & 3) == 2) {		      \
	} else {							      \
	    unsigned sign;						      \
									      \
	    do {							      \
		int level, v;						      \
		unsigned run;						      \
									      \
		DECODE_11172_Be_COEFFICIENT(_seek_h262_B_e_012_0,	      \
					    _seek_h262_B_e_012_1);	      \
		i += run;						      \
		if (63 < i) {						      \
		    ABORT_DECODING(video, buffer, size, VIDEO_INVALID_CODE);  \
		}							      \
		run = inverse_scan[i];					      \
		meta_block |= run;					      \
		v = ((level * (run >> 8 & 255) * quantiser_scale >> 4) - 1)   \
		    | 1;						      \
		level = -(int) ((sign & 4) >> 2);			      \
		if (2047 - level < v) {					      \
		    v = 2047 - level;					      \
		}							      \
		v = (v ^ level) - level;				      \
		coefficients[run & 255] = v;				      \
	    } while ((sign & 3) != 2);					      \
	}								      \
	cache_size -= 2;						      \
	coefficients[-1] = meta_block >> 16;				      \
    }
#endif				/* __ENABLE_BLOCK_META_DATA__ */

#define DECODE_11172_Be_BLOCK() \
    {									      \
	unsigned i, sign;						      \
									      \
	if (cache_size < 4) {						      \
	    cache_buffer = cache_buffer << 8 | *buffer++;		      \
	    cache_size += 8;						      \
	    size--;							      \
	}								      \
	i = (cache_buffer >> (cache_size - 1) & 1) - 1;			      \
	if (i) {							      \
	    RESET_ONE(coefficients);					      \
	} else {							      \
	    unsigned sign;						      \
									      \
	    cache_size -= 2;						      \
	    sign = cache_buffer >> (cache_size - 2) & 7;		      \
	    *coefficients = ((3 * (*inverse_scan >> 8 & 255)		      \
			      * quantiser_scale >> 4) - 1) | 1;		      \
	    if (sign & 4) {						      \
		*coefficients = -*coefficients;				      \
	    }								      \
	    if ((sign & 3) == 2) {					      \
		cache_size -= 2;					      \
		coefficients += BLOCK_SIZE;				      \
	        continue;						      \
	    }								      \
	}								      \
	RESET_SIXTY_THREE(coefficients);				      \
	do {								      \
	    int level, v;						      \
	    unsigned run;						      \
									      \
	    DECODE_11172_Be_COEFFICIENT(_seek_h262_B_e_012_0,		      \
					_seek_h262_B_e_012_1);		      \
	    i += run;							      \
	    if (63 < i) {						      \
	    	ABORT_DECODING(video, buffer, size, VIDEO_INVALID_CODE);      \
	    }								      \
	    run = inverse_scan[i];					      \
	    v = (((level + 1) * (run >> 8 & 255) * quantiser_scale >> 4) - 1) \
		| 1;							      \
	    level = -(int) ((sign & 4) >> 2);				      \
	    if (2047 - level < v) {					      \
		v = 2047 - level;					      \
	    }								      \
	    v = (v ^ level) - level;					      \
	    coefficients[run & 255] = v;				      \
	} while ((sign & 3) != 2);					      \
	cache_size -= 2;						      \
	if (i) {							      \
	    pattern_code &= ~chroma_format;				      \
	}								      \
    }

#if __ENABLE_BLOCK_META_DATA__
# undef DECODE_11172_Be_BLOCK

# define DECODE_11172_Be_BLOCK() \
    {									      \
	unsigned i, sign;						      \
	unsigned meta_block;						      \
									      \
	if (cache_size < 4) {						      \
	    cache_buffer = cache_buffer << 8 | *buffer++;		      \
	    cache_size += 8;						      \
	    size--;							      \
	}								      \
	i = (cache_buffer >> (cache_size - 1) & 1) - 1;			      \
	if (i) {							      \
	    RESET_ONE(coefficients);					      \
	    meta_block = 0;						      \
	} else {							      \
	    unsigned sign;						      \
									      \
	    cache_size -= 2;						      \
	    sign = cache_buffer >> (cache_size - 2) & 7;		      \
	    *coefficients = ((3 * (*inverse_scan >> 8 & 255)		      \
			      * quantiser_scale >> 4) - 1) | 1;		      \
	    if (sign & 4) {						      \
		*coefficients = -*coefficients;				      \
	    }								      \
	    if ((sign & 3) == 2) {					      \
		cache_size -= 2;					      \
		coefficients[-1] = *inverse_scan >> 16;			      \
		coefficients += BLOCK_SIZE;				      \
	        continue;						      \
	    } else {							      \
		meta_block = *inverse_scan;				      \
	    }								      \
	}								      \
	RESET_SIXTY_THREE(coefficients);				      \
	do {								      \
	    int level, v;						      \
	    unsigned run;						      \
									      \
	    DECODE_11172_Be_COEFFICIENT(_seek_h262_B_e_012_0,		      \
					_seek_h262_B_e_012_1);		      \
	    i += run;							      \
	    if (63 < i) {						      \
	    	ABORT_DECODING(video, buffer, size, VIDEO_INVALID_CODE);      \
	    }								      \
	    run = inverse_scan[i];					      \
	    meta_block |= run;						      \
	    v = (((level + 1) * (run >> 8 & 255) * quantiser_scale >> 4) - 1) \
		| 1;							      \
	    level = -(int) ((sign & 4) >> 2);				      \
	    if (2047 - level < v) {					      \
		v = 2047 - level;					      \
	    }								      \
	    v = (v ^ level) - level;					      \
	    coefficients[run & 255] = v;				      \
	} while ((sign & 3) != 2);					      \
	cache_size -= 2;						      \
	if (i) {							      \
	    pattern_code &= ~chroma_format;				      \
	}								      \
	coefficients[-1] = meta_block >> 16;				      \
    }
#endif				/* __ENABLE_BLOCK_META_DATA__ */

#define DECODE_11172_Be_BLoCK() \
    {									      \
	unsigned i, sign;						      \
									      \
	if (cache_size < 4) {						      \
	    cache_buffer = cache_buffer << 8 | *buffer++;		      \
	    cache_size += 8;						      \
	    size--;							      \
	}								      \
	i = (cache_buffer >> (cache_size - 1) & 1) - 1;			      \
	if (i) {							      \
	    RESET_ONE(coefficients);					      \
	} else {							      \
	    unsigned sign;						      \
									      \
	    cache_size -= 2;						      \
	    sign = cache_buffer >> (cache_size - 2) & 7;		      \
	    *coefficients = ((3 * quantiser_scale) - 1) | 1;		      \
	    if (sign & 4) {						      \
		*coefficients = -*coefficients;				      \
	    }								      \
	    if ((sign & 3) == 2) {					      \
		cache_size -= 2;					      \
		coefficients += BLOCK_SIZE;				      \
		continue;						      \
	    }								      \
	}								      \
	RESET_SIXTY_THREE(coefficients);				      \
	do {								      \
	    int level;							      \
	    unsigned run;						      \
									      \
	    DECODE_11172_Be_COEFFICiENT(_seek_h262_B_e_012_0,		      \
					_seek_h262_B_e_012_1);		      \
	    i += run;							      \
	    if (63 < i) {						      \
		ABORT_DECODING(video, buffer, size, VIDEO_INVALID_CODE);      \
	    }								      \
	    coefficients[inverse_scan[i] & 255] = level;		      \
	} while ((sign & 3) != 2);					      \
	cache_size -= 2;						      \
	if (i) {							      \
	    pattern_code &= ~chroma_format;				      \
	}								      \
    }

#if __ENABLE_BLOCK_META_DATA__
# undef DECODE_11172_Be_BLoCK

# define DECODE_11172_Be_BLoCK() \
    {									      \
	unsigned i, sign;						      \
	unsigned meta_block;						      \
									      \
	if (cache_size < 4) {						      \
	    cache_buffer = cache_buffer << 8 | *buffer++;		      \
	    cache_size += 8;						      \
	    size--;							      \
	}								      \
	i = (cache_buffer >> (cache_size - 1) & 1) - 1;			      \
	if (i) {							      \
	    RESET_ONE(coefficients);					      \
	    meta_block = 0;						      \
	} else {							      \
	    unsigned sign;						      \
									      \
	    cache_size -= 2;						      \
	    sign = cache_buffer >> (cache_size - 2) & 7;		      \
	    *coefficients = ((3 * quantiser_scale) - 1) | 1;		      \
	    if (sign & 4) {						      \
		*coefficients = -*coefficients;				      \
	    }								      \
	    if ((sign & 3) == 2) {					      \
		cache_size -= 2;					      \
		coefficients[-1] = *inverse_scan >> 16;			      \
		coefficients += BLOCK_SIZE;				      \
		continue;						      \
	    } else {							      \
		meta_block = *inverse_scan;				      \
	    }								      \
	}								      \
	RESET_SIXTY_THREE(coefficients);				      \
	do {								      \
	    int level;							      \
	    unsigned run;						      \
									      \
	    DECODE_11172_Be_COEFFICiENT(_seek_h262_B_e_012_0,		      \
					_seek_h262_B_e_012_1);		      \
	    i += run;							      \
	    if (63 < i) {						      \
		ABORT_DECODING(video, buffer, size, VIDEO_INVALID_CODE);      \
	    }								      \
	    run = inverse_scan[i];					      \
	    meta_block |= run;						      \
	    coefficients[run & 255] = level;				      \
	} while ((sign & 3) != 2);					      \
	cache_size -= 2;						      \
	if (i) {							      \
	    pattern_code &= ~chroma_format;				      \
	}								      \
	coefficients[-1] = meta_block >> 16;				      \
    }
#endif				/* __ENABLE_BLOCK_META_DATA__ */

#define DECODE_11172_Be_COEFFICIENT(table_0, table_1) \
    {									      \
	if (cache_size < 16) {						      \
	    cache_buffer = cache_buffer << 16 | *buffer << 8 | buffer[1];     \
	    buffer += 2;						      \
	    cache_size += 16;						      \
	    size -= 2;							      \
	}								      \
	run = cache_buffer >> (cache_size - 10) & 1023;			      \
	if (run & ~7) {							      \
	    run = ((unsigned *) table_1)[run];				      \
	    if (run & 192) {						      \
		if (cache_size < 22) {					      \
		    cache_buffer = cache_buffer << 8 | *buffer++;	      \
		    cache_size += 8;					      \
		    size--;						      \
		}							      \
		cache_size -= 20;					      \
		level = cache_buffer >> cache_size & 16383;		      \
		run = (level >> 8) + 1;					      \
		level &= 255;						      \
		if (!(level & 127)) {					      \
		    if (cache_size < 10) {				      \
			cache_buffer = cache_buffer << 8 | *buffer++;	      \
			cache_size += 8;				      \
			size--;						      \
		    }							      \
		    cache_size -= 8;					      \
		    sign = level >> 5;					      \
		    level = cache_buffer >> cache_size & 255;		      \
		    if (sign) {						      \
			level = 256 - level;				      \
		    }							      \
		    if (level < 128) {					      \
			ABORT_DECODING					      \
			    (video, buffer, size, VIDEO_INVALID_ESCAPE_CODE); \
		    }							      \
		} else if (level & 128) {				      \
		    level = 256 - level;				      \
		    sign = 4;						      \
		} else {						      \
		    sign = 0;						      \
		}							      \
		sign |= cache_buffer >> (cache_size - 2) & 3;		      \
		level <<= 1;						      \
	    } else {							      \
		cache_size -= run >> 16;				      \
		level = (run >> 8) & 255;				      \
		run &= 255;						      \
		sign = cache_buffer >> (cache_size - 2);		      \
	    }								      \
	} else {							      \
	    if (cache_size < 19) {					      \
		cache_buffer = cache_buffer << 8 | *buffer++;		      \
		cache_size += 8;					      \
		size--;							      \
	    }								      \
	    run = ((unsigned *) table_0)				      \
		[cache_buffer >> (cache_size - 16) & 65535];		      \
	    cache_size -= run >> 16;					      \
	    level = (run >> 8) & 255;					      \
	    run &= 255;							      \
	    sign = cache_buffer >> (cache_size - 2);			      \
	}								      \
    }

#define DECODE_11172_Be_COEFFICiENT(table_0, table_1) \
    {									      \
	if (cache_size < 16) {						      \
	    cache_buffer = cache_buffer << 16 | *buffer << 8 | buffer[1];     \
	    buffer += 2;						      \
	    cache_size += 16;						      \
	    size -= 2;							      \
	}								      \
	run = cache_buffer >> (cache_size - 10) & 1023;			      \
	if (run & ~7) {							      \
	    run = ((unsigned *) table_1)[run];				      \
	    if (run & 192) {						      \
		if (cache_size < 22) {					      \
		    cache_buffer = cache_buffer << 8 | *buffer++;	      \
		    cache_size += 8;					      \
		    size--;						      \
		}							      \
		cache_size -= 20;					      \
		level = cache_buffer >> cache_size & 16383;		      \
		run = (level >> 8) + 1;					      \
		level &= 255;						      \
		if (!(level & 127)) {					      \
		    if (cache_size < 10) {				      \
			cache_buffer = cache_buffer << 8 | *buffer++;	      \
			cache_size += 8;				      \
			size--;						      \
		    }							      \
		    cache_size -= 8;					      \
		    sign = level >> 7;					      \
		    level = cache_buffer >> cache_size & 255;		      \
		    if (sign) {						      \
			level = 256 - level;				      \
		    }							      \
		    if (level < 128) {					      \
			ABORT_DECODING					      \
			    (video, buffer, size, VIDEO_INVALID_ESCAPE_CODE); \
		    }							      \
		} else if (level & 128) {				      \
		    level = 256 - level;				      \
		    sign = 1;						      \
		} else {						      \
		    sign = 0;						      \
		}							      \
		level = ((((level << 1) + 1) * quantiser_scale) - 1) | 1;     \
		if (2047 + sign < level) {				      \
		    level = 2047 + sign;				      \
		}							      \
		level = (level ^ -sign) + sign;				      \
		sign = cache_buffer >> (cache_size - 2) & 3;		      \
	    } else {							      \
		cache_size -= run >> 16;				      \
		sign = cache_buffer >> (cache_size - 2) & 7;		      \
		level =							      \
		    non_intra_coefficients[((run >> 8) & 255) | sign >> 2];   \
		run &= 255;						      \
	    }								      \
	} else {							      \
	    if (cache_size < 19) {					      \
		cache_buffer = cache_buffer << 8 | *buffer++;		      \
		cache_size += 8;					      \
		size--;							      \
	    }								      \
	    run = ((unsigned *) table_0)				      \
		[cache_buffer >> (cache_size - 16) & 65535];		      \
	    cache_size -= run >> 16;					      \
	    sign = cache_buffer >> (cache_size - 2) & 7;		      \
	    level = non_intra_coefficients[((run >> 8) & 255) | sign >> 2];   \
	    run &= 255;							      \
	}								      \
    }

#define DETACH_11172_B__BLOCK(table_0, table_1) \
    {									      \
	unsigned i = 64;						      \
									      \
	for (; i; i--) {						      \
	    DETACH_11172_Be_COEFFICIENT(table_0, table_1);		      \
	}								      \
	if (!i) {							      \
	    ABORT_DECODING(video, buffer, size, VIDEO_INVALID_CODE);	      \
	}								      \
    }

#define DETACH_11172_Be_BLOCK(table_0, table_1) \
    {									      \
	unsigned i = 65;						      \
									      \
	if (cache_size < 2) {						      \
	    cache_buffer = cache_buffer << 8 | *buffer++;		      \
	    cache_size += 8;						      \
	    size--;							      \
	}								      \
	if (cache_buffer >> (cache_size - 2) & 2) {			      \
	    cache_size -= 2;						      \
	    i--;							      \
	}								      \
	for (; i; i--) {						      \
	    DETACH_11172_Be_COEFFICIENT(table_0, table_1);		      \
	}								      \
	if (!i) {							      \
	    ABORT_DECODING(video, buffer, size, VIDEO_INVALID_CODE);	      \
	}								      \
    }

#define DETACH_11172_Be_COEFFICIENT(table_0, table_1) \
    {									      \
	unsigned run;							      \
									      \
	if (cache_size < 17) {						      \
	    cache_buffer = cache_buffer << 16 | *buffer << 8 | buffer[1];     \
	    buffer += 2;						      \
	    cache_size += 16;						      \
	    size -= 2;							      \
	}								      \
	run = cache_buffer >> (cache_size - 6) & 63;			      \
	if ((run & 48) == 32) {						      \
	    cache_size -= 2;						      \
	    break;							      \
	} else {							      \
	    switch (run) {						      \
	    case 0:							      \
		if (cache_size < 17) {					      \
		    cache_buffer = cache_buffer << 8 | *buffer++;	      \
		    cache_size += 8;					      \
		    size--;						      \
		}							      \
		run = cache_buffer >> (cache_size - 16) & 1023;		      \
		if (run < 16) {						      \
		    ABORT_DECODING(video, buffer, size, VIDEO_INVALID_CODE);  \
		}							      \
		cache_size -= table_1[run >> 5];			      \
		break;							      \
	    case 1:							      \
	    	cache_size -= 6;					      \
		if (cache_size < 14) {					      \
		    cache_buffer =					      \
			cache_buffer << 16 | *buffer << 8 | buffer[1];	      \
		    buffer += 2;					      \
		    cache_size += 16;					      \
		    size -= 2;						      \
		}							      \
		cache_size -= 14;					      \
		run = cache_buffer >> cache_size & 255;			      \
		if (!(run & 127)) {					      \
		    if (cache_size < 8) {				      \
			cache_buffer = cache_buffer << 8 | *buffer++;	      \
			cache_size += 8;				      \
			size--;						      \
		    }							      \
		    cache_size -= 8;					      \
		    if (run) {						      \
			run = 256 - (cache_buffer >> cache_size & 255);	      \
		    } else {						      \
			run = cache_buffer >> cache_size & 255;		      \
		    }							      \
		    if (run < 128) {					      \
			ABORT_DECODING					      \
			    (video, buffer, size, VIDEO_INVALID_ESCAPE_CODE); \
		    }							      \
		}							      \
		break;							      \
	    default:							      \
		cache_size -= table_0[run];				      \
	    }								      \
	}								      \
    }

#endif				/* __SEEK_H262_1_D4_H__ */
