/*
 * h262.1.part3.c
 * Copyright (C) 2003, 2004  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <h262.1.h>
#include <h262.3.h>
#include <h262.a.h>

#define INCREMENT_INPUT(transport, nbytes) \
    {									      \
	transport->size -= nbytes;					      \
	transport->buffer += nbytes;					      \
    }

#if 0
static void CA_section(struct seek_h262_transport *);
static void TS_program_map_section(struct seek_h262_transport *);
#endif				/* 0 */
static void adaptation_field(struct seek_h262_transport *);
#if 0
static void private_section(struct seek_h262_transport *);
static void program_association_section(struct seek_h262_transport *);
#endif				/* 0 */
static void transport_packet(struct seek_h262_transport *);

#if 0
static void
CA_section(struct seek_h262_transport *transport)
{
    /*
     * table_id                                                      8  uimsbf
     * section_syntax_indicator                                      1  bslbf
     * '0'                                                           1  bslbf
     * reserved                                                      2  bslbf
     * section_length                                               12  uimsbf
     * reserved                                                     18  bslbf
     * version_number                                                5  uimsbf
     * current_next_indicator                                        1  bslbf
     * section_number                                                8  uimsbf
     * last_section_number                                           8  uimsbf
     * for (i = 0; i < N; i++) {                                        
     *     descriptor();                                                
     * }                                                                
     * CRC_32                                                       32  rpchof
     */
}
#endif				/* 0 */


#if 0
static void
TS_program_map_section(struct seek_h262_transport *transport)
{
    /*
     * table_id                                                      8  uimsbf
     * section_syntax_indicator                                      1  bslbf
     * '0'                                                           1  bslbf
     * reserved                                                      2  bslbf
     * section_length                                               12  uimsbf
     * program_number                                               16  uimsbf
     * reserved                                                      2  bslbf
     * version_number                                                5  uimsbf
     * current_next_indicator                                        1  bslbf
     * section_number                                                8  uimsbf
     * last_section_number                                           8  uimsbf
     * reserved                                                      3  bslbf
     * PCR_PID                                                      13  uimsbf
     * reserved                                                      4  bslbf
     * program_info_length                                          12  uimsbf
     * for (i = 0; i < N; i++) {                                        
     *     descriptor();                                                
     * }                                                                
     * for (i = 0; i < P; i++) {                                        
     *     stream_type                                               8  uimsbf
     *     reserved                                                  3  bslbf
     *     elementary_PID                                           13  uimsbf
     *     reserved                                                  4  bslbf
     *     ES_info_length                                           12  uimsbf
     *     for (i = 0; i < Q; i++) {                                    
     *         descriptor();                                            
     *     }                                                            
     * }                                                                
     * CRC_32                                                       32  rpchof
     */
}
#endif				/* 0 */


static void
adaptation_field(struct seek_h262_transport *transport)
{
    /*
     * adaptation_field_length                                       8  uimsbf
     * if (adaptation_field_length > 0) {                               
     *     discontinuity_indicator                                   1  bslbf
     *     random_access_indicator                                   1  bslbf
     *     elementary_stream_priority_indicator                      1  bslbf
     *     PCR_flag                                                  1  bslbf
     *     OPCR_flag                                                 1  bslbf
     *     splicing_point_flag                                       1  bslbf
     *     transport_private_data_flag                               1  bslbf
     *     adaptation_field_extension_flag                           1  bslbf
     *     if (PCR_flag == '1') {                                       
     *         program_clock_reference_base                         33  uimsbf
     *         reserved                                              6  bslbf
     *         program_clock_reference_extension                     9  uimsbf
     *     }                                                            
     *     if (OPCR_flag == '1') {                                      
     *         original_program_clock_reference_base                33  uimsbf
     *         reserved                                              6  bslbf
     *         original_program_clock_reference_extension            9  uimsbf
     *     }                                                            
     *     if (splicing_point_flag == '1') {                            
     *         splice_countdown                                      8  tcimsbf
     *     }                                                            
     *     if (transport_private_data_flag == '1') {                    
     *         transport_private_data_length                         8  uimsbf
     *         for (i = 0; i < transport_private_data_length; i++) {    
     *             private_data_byte                                 8  bslbf
     *         }                                                        
     *     }                                                            
     *     if (adaptation_field_extension_flag == '1') {                
     *         adaptation_field_extension_length                     8  uimsbf
     *         for (i = 0; i < adaptation_field_extension_length; i++) {
     *             reserved                                          8  bslbf
     *         }                                                        
     *     }                                                            
     *     for (i = 0; i < N; i++) {                                    
     *         stuffing_byte                                         8  bslbf
     *     }                                                            
     * }                                                                
     */
}


#if 0
static void
private_section(struct seek_h262_transport *transport)
{
    /*
     * table_id                                                      8  uimsbf
     * section_syntax_indicator                                      1  bslbf
     * private_indicator                                             1  bslbf
     * reserved                                                      2  bslbf
     * private_section_length                                       12  uimsbf
     * if (section_syntax_indicator == '0') {                           
     *     for (i = 0; i < N; i++) {                                    
     *         private_data_byte                                     8  bslbf
     *     }                                                            
     * } else {                                                         
     *     table_id_extension                                       16  uimsbf
     *     reserved                                                  2  bslbf
     *     version_number                                            5  uimsbf
     *     current_next_indicator                                    1  bslbf
     *     section_number                                            8  uimsbf
     *     last_section_number                                       8  uimsbf
     *     for (i = 0; i < private_section_length - 9; i++) {           
     *         private_data_byte                                     8  bslbf
     *     }                                                            
     *     CRC_32                                                   32  rpchof
     * }                                                                
     */
}
#endif				/* 0 */


#if 0
static void
program_association_section(struct seek_h262_transport *transport)
{
    /*
     * table_id                                                      8  uimsbf
     * section_syntax_indicator                                      1  bslbf
     * '0'                                                           1  bslbf
     * reserved                                                      2  bslbf
     * section_length                                               12  uimsbf
     * transport_stream_id                                          16  uimsbf
     * reserved                                                      2  bslbf
     * version_number                                                5  uimsbf
     * current_next_indicator                                        1  bslbf
     * section_number                                                8  uimsbf
     * last_section_number                                           8  uimsbf
     * for (i = 0; i < N; i++) {                                        
     *     program_number                                           16  uimsbf
     *     reserved                                                  3  bslbf
     *     if (program_number == '0') {                                 
     *         network_PID                                          13  uimsbf
     *     } else {                                                     
     *         program_map_PID                                      13  uimsbf
     *     }                                                            
     * }                                                                
     * CRC_32                                                       32  rpchof
     */
}
#endif				/* 0 */


static void
transport_packet(struct seek_h262_transport *transport)
{
    /*
     * sync_byte                                                     8  bslbf
     * transport_error_indicator                                     1  bslbf
     * payload_start_unit_indicator                                  1  bslbf
     * transport_priority                                            1  bslbf
     * PID                                                          13  uimsbf
     * transport_scrambling_control                                  2  bslbf
     * adaptation_field_control                                      2  bslbf
     * continuity_counter                                            4  uimsbf
     * if (adaptation_field_control == '10'                             
     *     || adaptation_field_control == '11') {                       
     *     adaptation_field();                                          
     * }                                                                
     * if (adaptation_field_control == '01'                             
     *     || adaptation_field_control == '11') {                       
     *     for (i = 0; i < N; i++) {                                    
     *         data_byte                                             8  bslbf
     *     }                                                            
     * }                                                                
     */
    {
	unsigned packet_fields, transport_packet_length = 184;

	packet_fields = *(unsigned *) transport->buffer;
	transport->transport_packet = packet_fields;
#if 1
	if (transport->transport_packet_hack_1) {
	    struct seek_h262_transport_packet transport_packet;

	    transport_packet.decoder = transport;
# if WORDS_BIGENDIAN
	    transport_packet.PID = (packet_fields & 0x001fff00) >> 010;
	    transport_packet.adaptation_field_control =
		packet_fields & 0x00000030;
	    transport_packet.continuity_counter = packet_fields & 0x0000000f;
	    transport_packet.payload_start_unit_indicator =
		packet_fields & 0x00400000;
	    transport_packet.transport_error_indicator =
		packet_fields & 0x00800000;
	    transport_packet.transport_priority = packet_fields & 0x00200000;
	    transport_packet.transport_scrambling_control =
		packet_fields & 0x000000c0;
# else
	    transport_packet.PID = (packet_fields & 0x00ff0000) >> 020
		| (packet_fields & 0x00001f00);
	    transport_packet.adaptation_field_control =
		packet_fields & 0x30000000;
	    transport_packet.continuity_counter = packet_fields & 0x0f000000;
	    transport_packet.payload_start_unit_indicator =
		packet_fields & 0x00004000;
	    transport_packet.transport_error_indicator =
		packet_fields & 0x00008000;
	    transport_packet.transport_priority = packet_fields & 0x00002000;
	    transport_packet.transport_scrambling_control =
		packet_fields & 0xc0000000;
# endif				/* WORDS_BIGENDIAN */
	    transport->transport_packet_hack_1(&transport_packet);
	}
#endif				/* 1 */
	INCREMENT_INPUT(transport, 4);
#if WORDS_BIGENDIAN
	if ((packet_fields & 0x00000030) == 0x00000020
	    || (packet_fields & 0x00000030) == 0x00000030) {
	    unsigned adaptation_field_length;

	    adaptation_field_length = *transport->buffer;
	    if (183 < adaptation_field_length) {
		_seek_h262_abort_decoding
		    ((struct seek_h262_whatever *) transport,
		     TRANSPORT_INVALID_ADAPTATION_FIELD_LENGTH);
	    }
	    transport_packet_length -= adaptation_field_length;
	    adaptation_field(transport);
	    INCREMENT_INPUT(transport, adaptation_field_length);
	}
#else
	if ((packet_fields & 0x30000000) == 0x20000000
	    || (packet_fields & 0x30000000) == 0x30000000) {
	    unsigned adaptation_field_length;

	    adaptation_field_length = *transport->buffer;
	    if (183 < adaptation_field_length) {
		_seek_h262_abort_decoding
		    ((struct seek_h262_whatever *) transport,
		     TRANSPORT_INVALID_ADAPTATION_FIELD_LENGTH);
	    }
	    transport_packet_length -= adaptation_field_length;
	    adaptation_field(transport);
	    INCREMENT_INPUT(transport, adaptation_field_length);
	}
#endif				/* WORDS_BIGENDIAN */
#if WORDS_BIGENDIAN
	if ((packet_fields & 0x00000030) == 0x00000010
	    || (packet_fields & 0x00000030) == 0x00000030) {
	    transport->packet_data(transport, transport_packet_length);
	}
#else
	if ((packet_fields & 0x30000000) == 0x10000000
	    || (packet_fields & 0x30000000) == 0x30000000) {
	    transport->packet_data(transport, transport_packet_length);
	}
#endif				/* WORDS_BIGENDIAN */
	INCREMENT_INPUT(transport, transport_packet_length);
    }
}


void
seek_h262_MPEG_transport_stream(struct seek_h262_transport *transport)
{
    /*
     * do {                                                             
     *     transport_packet()                                           
     * } while (nextbits() == sync_byte)                                
     */
    if (transport->size < 188) {
	transport->correct_underflow(transport);
    }
    do {
	transport_packet(transport);
	if (transport->size < 188) {
	    transport->correct_underflow(transport);
	}
    } while (*transport->buffer == 0x47);
}
