/*
 * h262.2.11172.c
 * Copyright (C) 2003, 2004, 2005, 2006, 2007  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <h262.0.h>
#include <h262.1.d4.h>
#include <h262.1.h>
#include <h262.2.d4.h>
#include <h262.2.h>
#include <h262.3.h>
#include <h262.3.l7.h>
#include <h262.6.d4.h>
#include <h262.a.h>
#include <h262.d.l7.h>

#define __HANDLE_INTRA__		0
#define __RUN_FUTILE__			0

#define DC_DCT_PRED			{ 1024, 1024, 1024 }

#define ABORT_DECODING(video, buffer, size, error) \
    {									      \
	_seek_h262_abort_divergent_decoding				      \
	    ((struct seek_h262_whatever *) video, buffer, size, error);	      \
    }

#if __ENABLE_X000001AF___HACK_0__
# define MAMAN_A_TORT(video) \
    (picture_start_code < video->start_code				      \
     && video->start_code < video->break_code)
#elif WORDS_BIGENDIAN
# define MAMAN_A_TORT(video) \
    (picture_start_code < video->start_code && video->start_code < 0x000001b0)
#else
# define MAMAN_A_TORT(video) \
    (picture_start_code < video->start_code && video->start_code < 0xb0010000)
#endif				/* __ENABLE_X000001AF___HACK_0__ */

extern unsigned char _seek_h262_B_1_01[], _seek_h262_B_9_01[],
    _seek_h262_B_5a[], _seek_h262_B_5b[], _seek_h262_B_e_012_0[],
    _seek_h262_B_e_012_1[];

#if !__INLINE_OPTIMISTIQUE_MOI__
static void optimistique_moi(struct seek_h262_video *, unsigned char **,
			     unsigned *);
#endif				/* !__INLINE_OPTIMISTIQUE_MOI__ */

#if !__INLINE_OPTIMISTIQUE_MOI__
static void
optimistique_moi(struct seek_h262_video *video, unsigned char **buffer,
		 unsigned *size)
{
    video->buffer = *buffer;
    video->size = *size;
    video->optimistique_moi(video);
    *buffer = video->buffer;
    *size = video->size;
}
#endif				/* !__INLINE_OPTIMISTIQUE_MOI__ */


void
_seek_h262_YCbCr_____x___11172_slices(struct seek_h262_video *video)
{
    /*
     * block(i)
     */
    /*
     * if (pattern_code[i]) {                                           
     *     if (macroblock_intra) {                                      
     *         if (i < 4) {                                             
     *             dct_dc_size_luminance                           2-7  vlclbf
     *             if (dct_dc_size_luminance != 0) {                    
     *                 dct_dc_differential                         1-8  uimsbf
     *             }                                                    
     *         } else {                                                 
     *             dct_dc_size_chrominance                         2-8  vlclbf
     *             if (dct_dc_size_chrominance != 0) {                  
     *                 dct_dc_differential                         1-8  uimsbf
     *             }                                                    
     *         }                                                        
     *     } else {                                                     
     *         dct_coeff_first                                    2-28  vlclbf
     *     }                                                            
     *     if (picture_coding_type != 4) {                              
     *         while (nextbits() != '10') {                             
     *             dct_coeff_next                                 3-28  vlclbf
     *         }                                                        
     *         end_of_block                                          2  "10"
     *     }                                                            
     * }                                                                
     */
    /*
     * macroblock()
     */
    /*
     * while (nextbits() == '0000 0001 111') {                          
     *     macroblock_stuffing                                      11  bslbf
     * }                                                                
     * while (nextbits() == '0000 0001 000') {                          
     *     macroblock_escape                                        11  bslbf
     * }                                                                
     * macroblock_address_increment                               1-11  vlclbf
     * macroblock_type                                             1-6  vlclbf
     * if (macroblock_quant) {                                          
     *     quantiser_scale                                           5  uimsbf
     * }                                                                
     * if (macroblock_motion_forward) {                                 
     *     motion_horizontal_forward_code                         1-11  vlclbf
     *     if ((forward_f != 1)                                         
     *         && (motion_horizontal_forward_code != 0)) {              
     *         motion_horizontal_forward_r                         1-6  vlclbf
     *     }                                                            
     *     motion_vertical_forward_code                           1-11  vlclbf
     *     if ((forward_f != 1)                                         
     *         && (motion_vertical_forward_code != 0)) {                
     *         motion_vertical_forward_r                           1-6  vlclbf
     *     }                                                            
     * }                                                                
     * if (macroblock_motion_backward) {                                
     *     motion_horizontal_backward_code                        1-11  vlclbf
     *     if ((backward_f != 1)                                        
     *         && (motion_horizontal_backward_code != 0)) {             
     *         motion_horizontal_backward_r                        1-6  vlclbf
     *     }                                                            
     *     motion_vertical_backward_code                          1-11  vlclbf
     *     if ((backward_f != 1)                                        
     *         && (motion_vertical_backward_code != 0)) {               
     *         motion_vertical_backward_r                          1-6  vlclbf
     *     }                                                            
     * }                                                                
     * if (macroblock_pattern) {                                        
     *     coded_block_pattern                                     3-9  vlclbf
     * }                                                                
     * for (i = 0; i < 6; i++) {                                        
     *     block(i)                                                     
     * }                                                                
     * if (picture_coding_type == 4) {                                  
     *     end_of_macroblock                                         1  "1"
     * }                                                                
     */
    /*
     * slice()
     */
    /*
     * slice_start_code                                             32  bslbf
     * quantiser_scale                                               5  uimsbf
     * while (nextbits() == '1') {                                      
     *     extra_bit_slice                                           1  "1"
     *     extra_information_slice                                   8  
     * }                                                                
     * extra_bit_slice                                               1  "0"
     * do {                                                             
     *     macroblock()                                                 
     * } while (nextbits() != '000 0000 0000 0000 0000 0000')           
     * next_start_code()                                                
     */
    __11172_MACROBLOCK_decls;

    __MACROBLOCK_setup();

    video->macroblock = &macroblock;
    _seek_h262_set_YCbCr_____11172_blocks(video);

    do {
	unsigned cache_buffer, cache_size, dc_dct_pred[] = DC_DCT_PRED,
	    future_intra_address, quantiser_scale, size, slice_address;
	unsigned char *buffer;

	buffer = video->buffer;
	size = video->size;
#if WORDS_BIGENDIAN
	slice_address = (video->start_code & 0xff) - 1;
#else
	slice_address = (video->start_code >> 030) - 1;
#endif				/* WORDS_BIGENDIAN */
	OPTIMISTIQUE_MOI_X(4);
	cache_buffer =
	    *buffer << 24 | buffer[1] << 16 | buffer[2] << 8 | buffer[3];
	buffer += 4;
	cache_size = 27;
	size -= 4;
	{
	    quantiser_scale = cache_buffer >> 27;
	    if (!quantiser_scale) {
		ABORT_DECODING
		    (video, buffer, size, VIDEO_NULL_SLICE_QUANTISER_SCALE);
	    }
	    if (cache_buffer >> (cache_size - 1) & 1) {
		do {
		    cache_size -= 9;
		    if (cache_size < 9) {
			OPTIMISTIQUE_MOI_X(2);
			cache_buffer =
			    cache_buffer << 16 | *buffer << 8 | buffer[1];
			buffer += 2;
			cache_size += 16;
			size -= 2;
		    }
#if __ENABLE_X000001AF___HACK_3__
		    if (video->x000001af___hack_3) {
			struct seek_h262_x000001af__ slice;

			slice.decoder = video;
			slice.x.x2.extra_information_slice =
			    cache_buffer >> cache_size & 255;

			video->x000001af___hack_3(&slice);
		    }
#endif				/* __ENABLE_X000001AF___HACK_0__ */
		} while (cache_buffer >> cache_size & 1);
	    }
	    cache_size--;
	}
	future_intra_address = slice_address * video->mb_width;
	video->mb_chroma = future_intra_address << 6;
	video->mb_offset = future_intra_address << 8;
	video->mb_advance = video->mb_offset + (video->mb_width << 4);
	slice_address = future_intra_address - 1;
	macroblock.previous_macroblock_address = slice_address;
	macroblock.recon_down_back = 0;
	macroblock.recon_down_for = 0;
	macroblock.recon_right_back = 0;
	macroblock.recon_right_for = 0;
	video->macroblock = &macroblock;
	if (cache_size < 12) {
	    OPTIMISTIQUE_MOI_X(2);
	    cache_buffer = cache_buffer << 16 | *buffer << 8 | buffer[1];
	    buffer += 2;
	    cache_size += 16;
	    size -= 2;
	}
	{
	    unsigned offset;

	    offset = cache_buffer >> (cache_size - 11) & 2047;
	    while (offset == 15) {
		cache_size -= 11;
		if (cache_size < 12) {
		    OPTIMISTIQUE_MOI_X(2);
		    cache_buffer =
			cache_buffer << 16 | *buffer << 8 | buffer[1];
		    buffer += 2;
		    cache_size += 16;
		    size -= 2;
		}
		offset = cache_buffer >> (cache_size - 11) & 2047;
	    }
	    if (offset & 1024) {
		cache_size--;
		macroblock.macroblock_address_increment = 1;
		macroblock.macroblock_address =
		    macroblock.previous_macroblock_address + 1;
	    } else {
		macroblock.macroblock_address_increment = 0;
		while (offset == 8) {
		    macroblock.macroblock_address_increment += 33;
		    cache_size -= 11;
		    if (cache_size < 11) {
			OPTIMISTIQUE_MOI_X(2);
			cache_buffer =
			    cache_buffer << 16 | *buffer << 8 | buffer[1];
			buffer += 2;
			cache_size += 16;
			size -= 2;
		    }
		    offset = cache_buffer >> (cache_size - 11) & 2047;
		}
		offset = ((unsigned short *) _seek_h262_B_1_01)[offset];
		cache_size -= offset >> 8;
		macroblock.macroblock_address_increment += offset & 255;
		macroblock.macroblock_address =
		    macroblock.previous_macroblock_address
		    + macroblock.macroblock_address_increment;
		if (1) {
		    macroblock.macroblock_address_increment = 1;
		    future_intra_address = macroblock.macroblock_address;
		}
		{
		    unsigned mb_column, mb_width, offset;

		    mb_width = video->mb_width;
		    mb_column = macroblock.macroblock_address % mb_width;
		    offset = (macroblock.macroblock_address - mb_column) << 8;
		    video->mb_advance = offset + (mb_width << 4);
		    video->mb_offset = offset + (mb_column << 4);
		    offset >>= 2;
		    video->mb_chroma = offset + (mb_column << 3);
		}
		if (cache_size < 11) {
		    OPTIMISTIQUE_MOI_X(2);
		    cache_buffer =
			cache_buffer << 16 | *buffer << 8 | buffer[1];
		    buffer += 2;
		    cache_size += 16;
		    size -= 2;
		}
	    }
	}
	do {
	    OPTIMISTIQUE_MOI_c(11172);

	    macroblock.packed_flags =
		((unsigned short *) video->B_2345678_01)
		[cache_buffer >> (cache_size - 6) & 63];
	    cache_size -= macroblock.packed_flags >> 8;
	    macroblock.packed_flags &= 255;
	    if (macroblock.packed_flags & macroblock_quant_mask) {
		quantiser_scale = cache_buffer >> cache_size & 31;
		if (!quantiser_scale) {
		    ABORT_DECODING(video, buffer, size,
				   VIDEO_NULL_MACROBLOCK_QUANTISER_SCALE);
		}
	    }
	    if (macroblock.packed_flags & macroblock_intra_mask) {
		seek_h262_coefficient *coefficients;
		seek_h262_scan_index *inverse_scan;
		unsigned chroma_format = 1;

		if (macroblock.macroblock_address != future_intra_address) {
		    dc_dct_pred[0] = 1024;
		    dc_dct_pred[1] = 1024;
		    dc_dct_pred[2] = 1024;
		    macroblock.recon_down_back = 0;
		    macroblock.recon_down_for = 0;
		    macroblock.recon_right_back = 0;
		    macroblock.recon_right_for = 0;
		}
		coefficients = macroblock.coefficients + _1ST_BLOCK_OFFSET;
		future_intra_address = macroblock.macroblock_address + 1;
		inverse_scan = video->intra_quantiser_matrix[0];
		for (; (chroma_format <<= 1) != 128;) {
		    unsigned i = 0;
#if __ENABLE_BLOCK_META_DATA__
		    unsigned meta_block;
#endif				/* __ENABLE_BLOCK_META_DATA__ */

		    if (cache_size < 16) {
			cache_buffer =
			    cache_buffer << 16 | *buffer << 8 | buffer[1];
			buffer += 2;
			cache_size += 16;
			size -= 2;
		    }
		    if (16 < chroma_format) {
			int dc_dct_size;

			dc_dct_size =
			    ((short *) _seek_h262_B_5b)
			    [cache_buffer >> (cache_size - 7) & 127];
			cache_size -= dc_dct_size & 127;
			if (dc_dct_size & 128) {
			    int dct_diff;
			    unsigned mask;

			    mask = dc_dct_size >> 8 & 255;
			    dct_diff = cache_buffer >> cache_size & mask;
			    if (!(dct_diff & ~(mask >> 1))) {
				dct_diff -= mask;
			    }
			    dc_dct_pred[chroma_format >> 5] += dct_diff << 3;
			} else {
			    dc_dct_pred[chroma_format >> 5] +=
				dc_dct_size >> 8;
			}
			*coefficients = dc_dct_pred[chroma_format >> 5];
		    } else {
			int dc_dct_size;

			dc_dct_size =
			    ((short *) _seek_h262_B_5a)
			    [cache_buffer >> (cache_size - 6) & 63];
			cache_size -= dc_dct_size & 127;
			if (dc_dct_size & 128) {
			    int dct_diff;
			    unsigned mask;

			    mask = dc_dct_size >> 8 & 255;
			    dct_diff = cache_buffer >> cache_size & mask;
			    if (!(dct_diff & ~(mask >> 1))) {
				dct_diff -= mask;
			    }
			    dc_dct_pred[0] += dct_diff << 3;
			} else {
			    dc_dct_pred[0] += dc_dct_size >> 8;
			}
			*coefficients = dc_dct_pred[0];
		    }
		    if (*coefficients < 0) {
			*coefficients = 0;
		    } else if (2047 < *coefficients) {
			*coefficients = 2047;
		    }
		    DECODE_11172_B__BLOCK();
		    coefficients += BLOCK_SIZE;
		}
#if __RUN_FUTILE__
		macroblock.previous_macroblock_address =
		    macroblock.macroblock_address;
#else
		video->______macroblock[4] (video);
#endif				/* __RUN_FUTILE__ */
	    } else {
		if (macroblock.packed_flags
		    & spatial_temporal_weight_code_flag_mask) {
		    macroblock.recon_down_for = 0;
		    macroblock.recon_right_for = 0;
		} else {
		    if (macroblock.packed_flags
			& macroblock_motion_forward_mask) {
			motion_vector(forward, for);
		    }
		    if (macroblock.packed_flags
			& macroblock_motion_backward_mask) {
			motion_vector(backward, back);
		    }
		}
		if (macroblock.packed_flags & macroblock_pattern_mask) {
		    seek_h262_coefficient *coefficients;
		    seek_h262_scan_index *inverse_scan;
		    unsigned chroma_format = 1, pattern_code;

		    if (cache_size < 9) {
			cache_buffer =
			    cache_buffer << 16 | *buffer << 8 | buffer[1];
			buffer += 2;
			cache_size += 16;
			size -= 2;
		    }
		    pattern_code = ((unsigned short *) _seek_h262_B_9_01)
			[cache_buffer >> (cache_size - 9) & 511];
		    cache_size -= pattern_code & 15;
		    pattern_code >>= 4;
		    macroblock.pattern_code = pattern_code;
		    coefficients = macroblock.coefficients + _1ST_BLOCK_OFFSET;
		    inverse_scan = video->non_intra_quantiser_matrix[0];
		    for (; chroma_format < 5461; chroma_format <<= 2) {
			if (pattern_code & chroma_format) {
			    DECODE_11172_Be_BLOCK();
			}
			coefficients += BLOCK_SIZE;
		    }
		    macroblock.dc_sparse = pattern_code;
		    macroblock.pattern_code &= ~macroblock.dc_sparse;
		} else {
		    macroblock.dc_sparse = 0;
		    macroblock.pattern_code = 0;
		}
#if __RUN_FUTILE__
		macroblock.previous_macroblock_address =
		    macroblock.macroblock_address;
#else
		video->______macroblock[macroblock.packed_flags >> 5 & 3]
		    (video);
#endif				/* __RUN_FUTILE__ */
	    }
	    if (cache_size < 23) {
		if (cache_size < 7) {
		    cache_buffer = cache_buffer << 24
			| *buffer << 16 | buffer[1] << 8 | buffer[2];
		    buffer += 3;
		    cache_size += 24;
		    size -= 3;
		} else if (cache_size < 15) {
		    cache_buffer =
			cache_buffer << 16 | *buffer << 8 | buffer[1];
		    buffer += 2;
		    cache_size += 16;
		    size -= 2;
		} else {
		    cache_buffer = cache_buffer << 8 | *buffer++;
		    cache_size += 8;
		    size--;
		}
	    }
	    {
		unsigned offset;

		offset = cache_buffer >> (cache_size - 23) & 8388607;
		if (!offset) {
		    break;
		}

		offset >>= 12;
		while (offset == 15) {
		    cache_size -= 11;
		    if (cache_size < 12) {
			OPTIMISTIQUE_MOI_X(2);
			cache_buffer =
			    cache_buffer << 16 | *buffer << 8 | buffer[1];
			buffer += 2;
			cache_size += 16;
			size -= 2;
		    }
		    offset = cache_buffer >> (cache_size - 11) & 2047;
		}
		if (offset & 1024) {
		    cache_size--;
		    macroblock.macroblock_address_increment = 1;
		    macroblock.macroblock_address =
			macroblock.previous_macroblock_address + 1;
		    video->mb_offset += 16;
		    if (video->mb_offset == video->mb_advance) {
			video->mb_advance += video->mb_width << 8;
			video->mb_offset =
			    video->mb_advance - (video->mb_width << 4);
			video->mb_chroma = video->mb_offset >> 2;
		    } else {
			video->mb_chroma += 8;
		    }
#if __HANDLE_INTRA__
		} else if (video->picture_coding_type == intra_coded) {
		    ABORT_DECODING(video, buffer, size,
				   VIDEO_INVALID_MACROBLOCK_ADDRESS_INCREMENT);
#endif				/* __HANDLE_INTRA__ */
		} else {
		    macroblock.macroblock_address_increment = 0;
		    while (offset == 8) {
			macroblock.macroblock_address_increment += 33;
			cache_size -= 11;
			if (cache_size < 11) {
			    OPTIMISTIQUE_MOI_X(2);
			    cache_buffer =
				cache_buffer << 16 | *buffer << 8 | buffer[1];
			    buffer += 2;
			    cache_size += 16;
			    size -= 2;
			}
			offset = cache_buffer >> (cache_size - 11) & 2047;
		    }
		    offset = ((unsigned short *) _seek_h262_B_1_01)[offset];
		    cache_size -= offset >> 8;
		    macroblock.macroblock_address_increment += offset & 255;
		    macroblock.macroblock_address =
			macroblock.previous_macroblock_address
			+ macroblock.macroblock_address_increment;
		    {
			if (video->picture_coding_type == predictive_coded) {
			    macroblock.recon_down_for = 0;
			    macroblock.recon_right_for = 0;
			}
#if __RUN_FUTILE__
			macroblock.previous_macroblock_address =
			    macroblock.macroblock_address - 1;
			{
			    unsigned mb_column, mb_width, offset;

			    mb_width = video->mb_width;
			    mb_column =
				macroblock.macroblock_address % mb_width;
			    offset =
				(macroblock.macroblock_address - mb_column)
				<< 8;
			    video->mb_advance = offset + (mb_width << 4);
			    video->mb_offset = offset + (mb_column << 4);
			    offset >>= 2;
			    video->mb_chroma = offset + (mb_column << 3);
			}
#else
			video->______skipped_macroblocks_x__(video);
#endif				/* __RUN_FUTILE__ */
		    }
		    if (cache_size < 11) {
			OPTIMISTIQUE_MOI_X(2);
			cache_buffer =
			    cache_buffer << 16 | *buffer << 8 | buffer[1];
			buffer += 2;
			cache_size += 16;
			size -= 2;
		    }
		}
	    }
	} while (1);
	cache_size &= ~7;
	cache_buffer &= (1 << cache_size) - 1;
	video->buffer = buffer;
	video->size = size;
	if (cache_buffer) {
	    if (cache_size != 24 || cache_buffer != 1) {
		ABORT_DECODING(video, buffer, size, VIDEO_SLICE_FAULT);
	    }
	    if (!size) {
		video->optimistique_moi(video);
	    }
#if WORDS_BIGENDIAN
	    video->start_code = 0x00000100 | *video->buffer;
#else
	    video->start_code = 0x00010000 | *video->buffer << 24;
#endif				/* WORDS_BIGENDIAN */
	    video->buffer++;
	    video->size--;
	} else if (cache_size) {
	    video->start_code = cache_size >> 3;
	    video->neXt_start_code(video);
	} else {
	    video->next_start_code(video);
	}
    } while (MAMAN_A_TORT(video));
}
