/*
 * h262.2.d4.h
 * Copyright (C) 2004, 2005  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __SEEK_H262_2_D4_H__
#define __SEEK_H262_2_D4_H__

#define motion_component(s) \
    {									      \
	code &= 1023;							      \
	motion_code = ((short *) video->s##_B_a_01)[code];		      \
	cache_size -= motion_code & 255;				      \
	motion_code >>= 8;						      \
	if (code < video->s##_f_code_limit) {				      \
	    motion_residual(s);						      \
	}								      \
    }

#define motion_residual(s) \
    {									      \
	int sign;							      \
									      \
	sign = motion_code >> 31;					      \
	motion_code = (motion_code ^ sign) - sign;			      \
	motion_code <<= s##_f_code;					      \
	cache_size -= s##_f_code;					      \
	motion_code -= ~(cache_buffer >> cache_size) & video->s##_f_code_mask;\
	motion_code = (motion_code ^ sign) - sign;			      \
    }

#define motion_vector(s, S) \
    {									      \
	unsigned code, s##_f_code;					      \
									      \
	s##_f_code = video->s##_f_code;					      \
									      \
	if (cache_size < 17) {						      \
	    if (!cache_size) {						      \
		OPTIMISTIQUE_MOI_X(4);					      \
		cache_buffer = *buffer << 24 | buffer[1] << 16		      \
		    | buffer[2] << 8 | buffer[3];			      \
		buffer += 4;						      \
		cache_size = 32;					      \
		size -= 4;						      \
	    } else {							      \
		OPTIMISTIQUE_MOI_X(2);					      \
		cache_buffer = cache_buffer << 16 | *buffer << 8 | buffer[1]; \
		buffer += 2;						      \
		cache_size += 16;					      \
		size -= 2;						      \
	    }								      \
	}								      \
	code = cache_buffer >> (cache_size - 11);			      \
	if (code & 1024) {						      \
	    cache_size--;						      \
	} else {							      \
	    int motion_code;						      \
									      \
	    motion_component(s);					      \
	    motion_code <<= video->full_pel_##s##_vector;		      \
	    motion_code += macroblock.recon_right_##S;			      \
	    motion_code = motion_code << video->s##_f_code_range	      \
		>> video->s##_f_code_range;				      \
	    macroblock.recon_right_##S = motion_code;			      \
	}								      \
									      \
	if (cache_size < 17) {						      \
	    if (!cache_size) {						      \
		OPTIMISTIQUE_MOI_X(4);					      \
		cache_buffer = *buffer << 24 | buffer[1] << 16		      \
		    | buffer[2] << 8 | buffer[3];			      \
		buffer += 4;						      \
		cache_size = 32;					      \
		size -= 4;						      \
	    } else {							      \
		OPTIMISTIQUE_MOI_X(2);					      \
		cache_buffer = cache_buffer << 16 | *buffer << 8 | buffer[1]; \
		buffer += 2;						      \
		cache_size += 16;					      \
		size -= 2;						      \
	    }								      \
	}								      \
	code = cache_buffer >> (cache_size - 11);			      \
	if (code & 1024) {						      \
	    cache_size--;						      \
	} else {							      \
	    int motion_code;						      \
									      \
	    motion_component(s);					      \
	    motion_code <<= video->full_pel_##s##_vector;		      \
	    motion_code += macroblock.recon_down_##S;			      \
	    motion_code = motion_code << video->s##_f_code_range	      \
		>> video->s##_f_code_range;				      \
	    macroblock.recon_down_##S = motion_code;			      \
	}								      \
    }

extern unsigned char _seek_h262_B_a_01[];

#endif				/* __SEEK_H262_2_D4_H__ */
