/*
 * h262.3.c
 * Copyright (C) 2003, 2004, 2005, 2006, 2007  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <h262.0.h>
#include <h262.1.h>
#include <h262.2.h>
#include <h262.3.h>
#include <h262.3.l7.h>
#include <h262.4.d4.h>
#include <h262.5.d4.h>
#include <h262.a.h>
#include <h262.6.d4.h>
#include <h262.e.l7.h>

#define Frame_based_prediction_or_16x8_MC \
					2

#define __RUN_FUTILE__			0

#define ABORT_DECODING(video, buffer, size, error) \
    {									      \
	_seek_h262_abort_divergent_decoding				      \
	    ((struct seek_h262_whatever *) video, buffer, size, error);	      \
    }

#if __ENABLE_X000001AF___HACK_0__
# define MAMAN_A_TORT(video) \
    (picture_start_code < video->start_code				      \
     && video->start_code < video->break_code)
#elif WORDS_BIGENDIAN
# define MAMAN_A_TORT(video) \
    (picture_start_code < video->start_code && video->start_code < 0x000001b0)
#else
# define MAMAN_A_TORT(video) \
    (picture_start_code < video->start_code && video->start_code < 0xb0010000)
#endif				/* __ENABLE_X000001AF___HACK_0__ */

extern unsigned char _seek_h262_B_1_01[], _seek_h262_B_9_01[];
extern const unsigned char _seek_h262_B_c_0[], _seek_h262_B_c_1[],
    _seek_h262_B_d_0[], _seek_h262_B_d_1[];

#if !__INLINE_OPTIMISTIQUE_MOI__
static void optimistique_moi(struct seek_h262_video *, unsigned char **,
			     unsigned *);
#endif				/* !__INLINE_OPTIMISTIQUE_MOI__ */

static const unsigned reflex16[] = {
/* *INDENT-OFF* */
    0x000000, 0x004000, 0x001000, 0x005000
/* *INDENT-ON* */
}, reflex64[] = {
/* *INDENT-OFF* */
    0x000000, 0x400000, 0x100000, 0x500000,
    0x040000, 0x440000, 0x140000, 0x540000,
    0x010000, 0x410000, 0x110000, 0x510000,
    0x050000, 0x450000, 0x150000, 0x550000,
    0x004000, 0x404000, 0x104000, 0x504000,
    0x044000, 0x444000, 0x144000, 0x544000,
    0x014000, 0x414000, 0x114000, 0x514000,
    0x054000, 0x454000, 0x154000, 0x554000,
    0x001000, 0x401000, 0x101000, 0x501000,
    0x041000, 0x441000, 0x141000, 0x541000,
    0x011000, 0x411000, 0x111000, 0x511000,
    0x051000, 0x451000, 0x151000, 0x551000,
    0x005000, 0x405000, 0x105000, 0x505000,
    0x045000, 0x445000, 0x145000, 0x545000,
    0x015000, 0x415000, 0x115000, 0x515000,
    0x055000, 0x455000, 0x155000, 0x555000
/* *INDENT-ON* */
};
static const unsigned char B_b_0[] = "\0\0\1\377", B_b_1[] = "\1\1\2\2";
static const unsigned char x7_19[] = {
/* *INDENT-OFF* */
    0x01, 0x01, 0x01, 0x01, 0x03, 0x01, 0x03, 0x01,
    0x02, 0x01, 0x02, 0x01, 0x02, 0x02, 0x03, 0x01
/* *INDENT-ON* */
};

#if !__INLINE_OPTIMISTIQUE_MOI__
static void
optimistique_moi(struct seek_h262_video *video, unsigned char **buffer,
		 unsigned *size)
{
    video->buffer = *buffer;
    video->size = *size;
    video->optimistique_moi(video);
    *buffer = video->buffer;
    *size = video->size;
}
#endif				/* !__INLINE_OPTIMISTIQUE_MOI__ */


void
_seek_h262_YCbCr_____x___13818_slices(struct seek_h262_video *video)
{
    /*
     * block()
     */
    /*
     * if (pattern_code[i]) {                                           
     *     if (macroblock_intra) {                                      
     *         if (i < 4) {                                             
     *             dct_dc_size_luminance                           2-9  vlclbf
     *             if (dct_dc_size_luminance != 0) {                    
     *                 dct_dc_differential                        1-11  uimsbf
     *             }                                                    
     *         } else {                                                 
     *             dct_dc_size_chrominance                        2-10  vlclbf
     *             if (dct_dc_size_chrominance != 0) {                  
     *                 dct_dc_differential                        1-11  uimsbf
     *             }                                                    
     *         }                                                        
     *     } else {                                                     
     *         First DCT coefficient                                    
     *     }                                                            
     *     while (nextbits() != End of block) {                         
     *         Subsequent DCT coefficients                              
     *     }                                                            
     *     End of block                                                 
     * }                                                                
     */
    /*
     * coded_block_pattern()
     */
    /*
     * coded_block_pattern_420                                     3-9  vlclbf
     * if (chroma_format == 4:2:2) {                                    
     *     coded_block_pattern_1                                     2  uimsbf
     * }                                                                
     * if (chroma_format == 4:4:4) {                                    
     *     coded_block_pattern_2                                     6  uimsbf
     * }                                                                
     */
    /*
     * macroblock()
     */
    /*
     * while (nextbits() == '0000 0001 000') {                          
     *     macroblock_escape                                        11  bslbf
     * }                                                                
     * macroblock_address_increment                               1-11  vlclbf
     * macroblock_modes()                                               
     * if (macroblock_quant) {                                          
     *     quantiser_scale_code                                      5  uimsbf
     * }                                                                
     * if (macroblock_motion_forward                                    
     *     || (macroblock_intra                                         
     *         && concealment_motion_vectors)) {                        
     *     motion_vectors(0)                                            
     * }                                                                
     * if (macroblock_motion_backward) {                                
     *     motion_vectors(1)                                            
     * }                                                                
     * if (macroblock_intra && concealment_motion_vectors) {            
     *     marker_bit                                                1  bslbf
     * }                                                                
     * if (macroblock_pattern) {                                        
     *     coded_block_pattern()                                        
     * }                                                                
     * for (i = 0; i < block_count; i++) {                              
     *     block(i)                                                     
     * }                                                                
     */
    /*
     * macroblock_modes()
     */
    /*
     * macroblock_type                                             1-9  vlclbf
     * if (spatial_temporal_weight_code_flag == 1                       
     *     && spatial_temporal_weight_code_table_index != '00') {       
     *     spatial_temporal_weight_code                              2  uimsbf
     * }                                                                
     * if (macroblock_motion_forward                                    
     *     || macroblock_motion_backward) {                             
     *     if (picture_structure == 'frame') {                          
     *         if (frame_pred_frame_dct == 0) {                         
     *             frame_motion_type                                 2  uimsbf
     *         }                                                        
     *     } else {                                                     
     *         field_motion_type                                     2  uimsbf
     *     }                                                            
     * }                                                                
     * if (decode_dct_type) {                                           
     *     dct_type                                                  1  uimsbf
     * }                                                                
     */
    /*
     * motion_vector(r, s)
     */
    /*
     * motion_code[r][s][0]                                       1-11  vlclbf
     * if (f_code[s][0] != 1 && motion_code[r][s][0] != 0) {            
     *     motion_residual[r][s][0]                                1-8  uimsbf
     * }                                                                
     * if (dmv == 1) {                                                  
     *     dmvector[0]                                             1-2  vlclbf
     * }                                                                
     * motion_code[r][s][1]                                       1-11  vlclbf
     * if (f_code[s][0] != 1 && motion_code[r][s][1] != 0) {            
     *     motion_residual[r][s][1]                                1-8  uimsbf
     * }                                                                
     * if (dmv == 1) {                                                  
     *     dmvector[1]                                             1-2  vlclbf
     * }                                                                
     */
    /*
     * motion_vectors(s)
     */
    /*
     * if (motion_vector_count == 1) {                                  
     *     if (mv_format == field && dmv != 1) {                        
     *         motion_vertical_field_select[0][s]                    1  uimsbf
     *     }                                                            
     *     motion_vector(0, s)                                          
     * } else {                                                         
     *     motion_vertical_field_select[0][s]                        1  uimsbf
     *     motion_vector(0, s)                                          
     *     motion_vertical_field_select[1][s]                        1  uimsbf
     *     motion_vector(1, s)                                          
     * }                                                                
     */
    /*
     * slice()
     */
    /*
     * slice_start_code                                             32  bslbf
     * if (vertical_size > 2800) {                                      
     *     slice_vertical_position_extension                         3  uimsbf
     * }                                                                
     * if (<sequence_scalable_extension() is present in the bitstream>) {
     *     if (scalable_mode == "data partitioning") {                  
     *         priority_breakpoint                                   7  uimsbf
     *     }                                                            
     * }                                                                
     * quantiser_scale_code                                          5  uimsbf
     * if (nextbits() == '1') {                                         
     *     intra_slice_flag                                          1  bslbf
     *     intra_slice                                               1  uimsbf
     *     reserved_bits                                             7  uimsbf
     *     while (nextbits() == '1') {                                  
     *         extra_bit_slice  slash* with the value "1" *slash     1  uimsbf
     *         extra_information_slice                               8  
     *     }                                                            
     * }                                                                
     * extra_bit_slice          slash* with the value "0" *slash     1  uimsbf
     * do {                                                             
     *     macroblock()                                                 
     * } while (nextbits() != '000 0000 0000 0000 0000 0000')           
     * next_start_code()                                                
     */
    __13818_MACROBLOCK_decls;
    seek_h262_scan_index *quantiser_matrices[2][12];

    __MACROBLOCK_setup();

    video->macroblock = &macroblock;
    _seek_h262_set_YCbCr_____13818_blocks(video);

    _seek_h262_set_quantiser_matrices(video, quantiser_matrices);

    do {
	unsigned cache_buffer, cache_size, dc_dct_pred[3], quantiser_scale = 0,
	    size;
	unsigned char *buffer;

#if WORDS_BIGENDIAN
	macroblock.mb_row = (video->start_code & 0xff) - 1;
#else
	macroblock.mb_row = (video->start_code >> 24) - 1;
#endif				/* WORDS_BIGENDIAN */
	buffer = video->buffer;
	size = video->size;
	OPTIMISTIQUE_MOI_X(4);
	cache_buffer =
	    *buffer << 24 | buffer[1] << 16 | buffer[2] << 8 | buffer[3];
	buffer += 4;
	cache_size = 32;
	size -= 4;
	if (2800 < video->vertical_size) {
	    if (127 < macroblock.mb_row) {
		ABORT_DECODING(video, buffer, size, VIDEO_SLICE_FAULT);
	    }
	    cache_size = 29;
	    macroblock.mb_row |= (cache_buffer >> 22) & ~127;
	}
	if (video->picture_structure == Frame_picture) {
	    if (video->mb_height < macroblock.mb_row + 1) {
		ABORT_DECODING
		    (video, buffer, size, VIDEO_INVALID_SLICE_START_CODE);
	    }
	} else {
	    if (video->mb_height < (macroblock.mb_row << 1) + 1) {
		ABORT_DECODING
		    (video, buffer, size, VIDEO_INVALID_SLICE_START_CODE);
	    }
	}

	_seek_h262_set_13818_slice_blocks(video);

	{
	    if (video->sequence_scalable_extension_seen) {
		if (video->scalable_mode == data_partitioning) {
		    cache_size -= 7;
		}
	    }
	    cache_size -= 5;
	    quantiser_scale = cache_buffer >> cache_size & 31;
	    if (!quantiser_scale) {
		ABORT_DECODING
		    (video, buffer, size, VIDEO_NULL_SLICE_QUANTISER_SCALE);
	    }
	    quantiser_scale = video->q_scale[quantiser_scale];
	    if (cache_buffer >> (cache_size - 1) & 1) {
		do {
		    cache_size -= 9;
		    if (cache_size < 9) {
			OPTIMISTIQUE_MOI_X(2);
			cache_buffer =
			    cache_buffer << 16 | *buffer << 8 | buffer[1];
			buffer += 2;
			cache_size += 16;
			size -= 2;
		    }
#if __ENABLE_X000001AF___HACK_3__
		    if (video->x000001af___hack_3) {
			struct seek_h262_x000001af__ slice;

			slice.decoder = video;
			slice.x.x2.extra_information_slice =
			    cache_buffer >> cache_size & 255;

			video->x000001af___hack_3(&slice);
		    }
#endif				/* __ENABLE_X000001AF___HACK_0__ */
		} while (cache_buffer >> (cache_size - 1) & 1);
	    }
	    cache_size--;
	}
	dc_dct_pred[0] = dc_dct_pred[1] = dc_dct_pred[2] =
	    video->intra_dc_default;
	macroblock.previous_macroblock_address =
	    macroblock.mb_row * video->mb_width - 1;
	macroblock.PMV_0_0_0 = 0;
	macroblock.PMV_0_0_1 = 0;
	macroblock.PMV_0_1_0 = 0;
	macroblock.PMV_0_1_1 = 0;
	macroblock.PMV_1_0_0 = 0;
	macroblock.PMV_1_0_1 = 0;
	macroblock.PMV_1_1_0 = 0;
	macroblock.PMV_1_1_1 = 0;
	if (cache_size < 9) {
	    OPTIMISTIQUE_MOI_X(3);
	    cache_buffer = cache_buffer << 24
		| *buffer << 16 | buffer[1] << 8 | buffer[2];
	    buffer += 3;
	    cache_size += 24;
	    size -= 3;
	} else if (cache_size < 17) {
	    OPTIMISTIQUE_MOI_X(2);
	    cache_buffer = cache_buffer << 16 | *buffer << 8 | buffer[1];
	    buffer += 2;
	    cache_size += 16;
	    size -= 2;
	} else if (cache_size < 25) {
	    OPTIMISTIQUE_MOI_1(0);
	    cache_buffer = cache_buffer << 8 | *buffer++;
	    cache_size += 8;
	    size--;
	}
	if (cache_buffer >> (cache_size - 1) & 1) {
	    macroblock.macroblock_address_increment = 1;
	    cache_size--;
	    macroblock.macroblock_address =
		macroblock.previous_macroblock_address + 1;
	    macroblock.mb_column = 0;
	} else {
	    unsigned offset;

	    offset = cache_buffer >> (cache_size - 11) & 2047;
	    if (offset != 8) {
		offset = ((unsigned short *) _seek_h262_B_1_01)[offset];
		cache_size -= offset >> 8;
		macroblock.macroblock_address_increment = offset & 255;
	    } else {
		macroblock.macroblock_address_increment = 33;
		cache_size -= 11;
		do {
		    offset = cache_buffer >> (cache_size - 11) & 2047;
		    if (offset == 8) {
			macroblock.macroblock_address_increment += 33;
			cache_size -= 11;
		    } else {
			offset =
			    ((unsigned short *) _seek_h262_B_1_01)[offset];
			cache_size -= offset >> 8;
			macroblock.macroblock_address_increment +=
			    offset & 255;
		    }
		    if (cache_size < 11) {
			OPTIMISTIQUE_MOI_X(2);
			cache_buffer =
			    cache_buffer << 16 | *buffer << 8 | buffer[1];
			buffer += 2;
			cache_size += 16;
			size -= 2;
		    }
		} while (offset == 8);
	    }
	    macroblock.macroblock_address =
		macroblock.previous_macroblock_address
		+ macroblock.macroblock_address_increment;
	    macroblock.mb_column =
		macroblock.macroblock_address % video->mb_width;
	    if (1) {
		macroblock.macroblock_address_increment = 1;
	    }
	}
	do {
	    unsigned dct_type = 0;

	    OPTIMISTIQUE_MOI_c(13818);

	    macroblock.packed_flags = ((unsigned short *) video->B_2345678_01)
		[cache_buffer >> (cache_size - 9) & 511];
	    cache_size -= macroblock.packed_flags >> 8;
	    macroblock.packed_flags &= 255;
	    if (macroblock.packed_flags
		& spatial_temporal_weight_code_flag_mask
		&& video->spatial_temporal_weight_code_table_index) {
		if (cache_size < 2) {
		    cache_buffer = cache_buffer << 8 | *buffer++;
		    cache_size += 8;
		    size--;
		}
		cache_size -= 2;
		macroblock.spatial_temporal_weight_code =
		    cache_buffer >> cache_size & 3;
	    } else {
		macroblock.spatial_temporal_weight_code = 0;
	    }
	    if (cache_size < 17) {
		cache_buffer = cache_buffer << 16 | *buffer << 8 | buffer[1];
		buffer += 2;
		cache_size += 16;
		size -= 2;
	    }
	    if (macroblock.packed_flags & macroblock_intra_mask) {
		seek_h262_coefficient *coefficients;
		seek_h262_scan_index *inverse_scan, **inverse_scan_X;
		unsigned cc = 4;
		unsigned char *B_ef_012_0, *B_ef_012_1;

		if (video->decode_dct_type) {
		    cache_size--;
		    dct_type = cache_buffer >> cache_size & 1;
		}
		if (macroblock.packed_flags & macroblock_quant_mask) {
		    cache_size -= 5;
		    quantiser_scale = cache_buffer >> cache_size & 31;
		    if (!quantiser_scale) {
			ABORT_DECODING
			    (video, buffer, size,
			     VIDEO_NULL_MACROBLOCK_QUANTISER_SCALE);
		    }
		    quantiser_scale = video->q_scale[quantiser_scale];
		} {
		    if (video->concealment_motion_vectors) {
			if (video->picture_structure != Frame_picture) {
			    motion_vertical_field_select(0, 0);
			}
			subsequent_motion_vector(0, 0);
			if (!cache_size) {
			    cache_buffer = *buffer << 8 | buffer[1];
			    buffer += 2;
			    cache_size = 16;
			    size -= 2;
			}
			cache_size--;
			macroblock.PMV_1_0_0 = macroblock.PMV_0_0_0;
			macroblock.PMV_1_0_1 = macroblock.PMV_0_0_1;
		    } else {
			macroblock.PMV_0_0_0 = 0;
			macroblock.PMV_0_0_1 = 0;
			macroblock.PMV_0_1_0 = 0;
			macroblock.PMV_0_1_1 = 0;
			macroblock.PMV_1_0_0 = 0;
			macroblock.PMV_1_0_1 = 0;
			macroblock.PMV_1_1_0 = 0;
			macroblock.PMV_1_1_1 = 0;
		    }
		}
		B_ef_012_0 = video->B_ef_012_0;
		B_ef_012_1 = video->B_ef_012_1;
		inverse_scan_X = quantiser_matrices[0];
		coefficients = macroblock.coefficients + _1ST_BLOCK_OFFSET;
		for (; cc; cc--) {
		    int sum;

		    if (cache_size < 17) {
			cache_buffer = cache_buffer << 16 | *buffer << 8
			    | buffer[1];
			buffer += 2;
			cache_size += 16;
			size -= 2;
		    }
		    {
			int dc_dct_size;

			dc_dct_size = cache_buffer >> (cache_size - 9) & 511;
			if (dc_dct_size < 448) {
			    dc_dct_size =
				((short *) _seek_h262_B_c_0)[dc_dct_size >> 2];
			    cache_size -= dc_dct_size & 255;
			    dc_dct_pred[2] += dc_dct_size >> 8;
			} else {
			    int dct_diff;
			    unsigned mask;

			    if (cache_size < 25) {
				cache_buffer = cache_buffer << 8 | *buffer++;
				cache_size += 8;
				size--;
			    }
			    dc_dct_size =
				((unsigned short *) _seek_h262_B_c_1)
				[dc_dct_size & 63];
			    cache_size -= dc_dct_size >> 8;
			    mask = (1 << (dc_dct_size & 255)) - 1;
			    dct_diff = cache_buffer >> cache_size & mask;
			    if (!(dct_diff & ~(mask >> 1))) {
				dct_diff -= mask;
			    }
			    dc_dct_pred[2] += dct_diff;
			}
			sum = dc_dct_pred[2] << video->intra_dc_precision;
		    }
		    if (sum < 0) {
			sum = 0;
		    } else if (2047 < sum) {
			sum = 2047;
		    }
		    *coefficients = sum;
		    inverse_scan = *inverse_scan_X++;
		    DECODE_13818_B__BLOCK(B_ef_012_0, B_ef_012_1);
		    coefficients += BLOCK_SIZE;
		}
		cc = video->chroma_format - 4;
		for (; cc; cc--) {
		    int sum;

		    if (cache_size < 17) {
			cache_buffer = cache_buffer << 16 | *buffer << 8
			    | buffer[1];
			buffer += 2;
			cache_size += 16;
			size -= 2;
		    }
		    {
			int dc_dct_size;

			dc_dct_size = cache_buffer >> (cache_size - 10) & 1023;
			if (dc_dct_size < 960) {
			    dc_dct_size =
				((short *) _seek_h262_B_d_0)[dc_dct_size >> 2];
			    cache_size -= dc_dct_size & 255;
			    dc_dct_pred[cc & 1] += dc_dct_size >> 8;
			} else {
			    int dct_diff;
			    unsigned mask;

			    if (cache_size < 25) {
				cache_buffer = cache_buffer << 8 | *buffer++;
				cache_size += 8;
				size--;
			    }
			    dc_dct_size =
				((unsigned short *) _seek_h262_B_d_1)
				[dc_dct_size & 63];
			    cache_size -= dc_dct_size >> 8;
			    dc_dct_size &= 255;
			    mask = (1 << dc_dct_size) - 1;
			    dct_diff = cache_buffer >> cache_size & mask;
			    if (!(dct_diff & ~(mask >> 1))) {
				dct_diff -= mask;
			    }
			    dc_dct_pred[cc & 1] += dct_diff;
			}
			sum = dc_dct_pred[cc & 1] << video->intra_dc_precision;
		    }
		    if (sum < 0) {
			sum = 0;
		    } else if (2047 < sum) {
			sum = 2047;
		    }
		    *coefficients = sum;
		    inverse_scan = *inverse_scan_X++;
		    DECODE_13818_B__BLOCK(B_ef_012_0, B_ef_012_1);
		    coefficients += BLOCK_SIZE;
		}
		video->macroblock = &macroblock;
#if __RUN_FUTILE__
		macroblock.previous_macroblock_address =
		    macroblock.macroblock_address;
#else
		video->______macroblock[dct_type << 2] (video);
#endif				/* __RUN_FUTILE__ */
	    } else {
		unsigned motion_type = Frame_based_prediction_or_16x8_MC;

		if (macroblock.packed_flags
		    & (macroblock_motion_backward_mask
		       | macroblock_motion_forward_mask)) {
		    if (video->decode_motion_type) {
			cache_size -= 2;
			motion_type = cache_buffer >> cache_size & 3;
			if (motion_type == video->dmv_abort) {
			    ABORT_DECODING(video, buffer, size,
					   VIDEO_INVALID_MOTION_TYPE);
			}
		    }
		    if (macroblock.packed_flags & video->decode_dct_type) {
			cache_size--;
			dct_type = cache_buffer >> cache_size & 1;
		    }
		    if (macroblock.packed_flags & macroblock_quant_mask) {
			cache_size -= 5;
			quantiser_scale = cache_buffer >> cache_size & 31;
			if (!quantiser_scale) {
			    ABORT_DECODING
				(video, buffer, size,
				 VIDEO_NULL_MACROBLOCK_QUANTISER_SCALE);
			}
			quantiser_scale = video->q_scale[quantiser_scale];
		    }
		    if (video->picture_structure == Frame_picture) {
		        switch (motion_type) {
			case Dual_Prime:
			    if (macroblock.packed_flags
				& macroblock_motion_forward_mask) {
				motion_vector_0(0, 0);
			    }
			    if (macroblock.packed_flags
				& macroblock_motion_backward_mask) {
				subsequent_motion_vector_0(0, 1);
			    }
			    macroblock.PMV_1_0_0 = macroblock.PMV_0_0_0;
			    macroblock.PMV_1_0_1 = macroblock.PMV_0_0_1;
			    break;
			case Field_based_prediction:
			    {
				unsigned motion_vector_count;

				motion_vector_count =
				    video->
				    spatial_temporal_weight_code_table_index
				    << 2
				    | macroblock.spatial_temporal_weight_code;
				motion_vector_count =
				    x7_19[motion_vector_count] < 2 ? 2 : 1;
				if (macroblock.packed_flags
				    & macroblock_motion_forward_mask) {
				    motion_vertical_field_select(0, 0);
				    motion_vector_1(0, 0);
				    if (motion_vector_count != 1) {
					motion_vertical_field_select(1, 0);
					subsequent_motion_vector_1(1, 0);
				    }
				}
				if (macroblock.packed_flags
				    & macroblock_motion_backward_mask) {
				    motion_vertical_field_select(0, 1);
				    subsequent_motion_vector_1(0, 1);
				    if (motion_vector_count != 1) {
					motion_vertical_field_select(1, 1);
					subsequent_motion_vector_1(1, 1);
				    }
				}
			    }
			    break;
			default:
			    if (macroblock.packed_flags
				& macroblock_motion_forward_mask) {
				motion_vector_2(0, 0);
				macroblock.PMV_1_0_0 = macroblock.PMV_0_0_0;
				macroblock.PMV_1_0_1 = macroblock.PMV_0_0_1;
			    }
			    if (macroblock.packed_flags
				& macroblock_motion_backward_mask) {
				subsequent_motion_vector_2(0, 1);
				macroblock.PMV_1_1_0 = macroblock.PMV_0_1_0;
				macroblock.PMV_1_1_1 = macroblock.PMV_0_1_1;
			    }
			}
		    } else {
			switch (motion_type) {
			case Dual_Prime:
			    if (macroblock.packed_flags
				& macroblock_motion_forward_mask) {
				motion_vector_3(0, 0);
			    }
			    if (macroblock.packed_flags
				& macroblock_motion_backward_mask) {
				subsequent_motion_vector_3(0, 1);
			    }
			    macroblock.PMV_1_0_0 = macroblock.PMV_0_0_0;
			    macroblock.PMV_1_0_1 = macroblock.PMV_0_0_1;
			    break;
			case Field_based_prediction:
			    if (macroblock.packed_flags
				& macroblock_motion_forward_mask) {
				motion_vertical_field_select(0, 0);
				motion_vector_4(0, 0);
				macroblock.PMV_1_0_0 = macroblock.PMV_0_0_0;
				macroblock.PMV_1_0_1 = macroblock.PMV_0_0_1;
			    }
			    if (macroblock.packed_flags
				& macroblock_motion_backward_mask) {
				motion_vertical_field_select(0, 1);
				subsequent_motion_vector_4(0, 1);
				macroblock.PMV_1_1_0 = macroblock.PMV_0_1_0;
				macroblock.PMV_1_1_1 = macroblock.PMV_0_1_1;
			    }
			    break;
			default:
			    if (macroblock.packed_flags
				& macroblock_motion_forward_mask) {
				motion_vertical_field_select(0, 0);
				motion_vector_5(0, 0);
				motion_vertical_field_select(1, 0);
				subsequent_motion_vector_5(1, 0);
			    }
			    if (macroblock.packed_flags
				& macroblock_motion_backward_mask) {
				motion_vertical_field_select(0, 1);
				subsequent_motion_vector_5(0, 1);
				motion_vertical_field_select(1, 1);
				subsequent_motion_vector_5(1, 1);
			    }
			}
		    }
		} else {
		    if (macroblock.packed_flags & video->decode_dct_type) {
			cache_size--;
			dct_type = cache_buffer >> cache_size & 1;
		    }
		    if (macroblock.packed_flags & macroblock_quant_mask) {
			cache_size -= 5;
			quantiser_scale = cache_buffer >> cache_size & 31;
			if (!quantiser_scale) {
			    ABORT_DECODING
				(video, buffer, size,
				 VIDEO_NULL_MACROBLOCK_QUANTISER_SCALE);
			}
			quantiser_scale = video->q_scale[quantiser_scale];
		    }
		    if (video->picture_coding_type == predictive_coded) {
			if (video->deinterlaced_release_coding_type
			    == intra_coded) {
			    ABORT_DECODING
				(video, buffer, size, VIDEO_SLICE_FAULT);
			}
			macroblock.PMV_0_0_0 = 0;
			macroblock.PMV_0_0_1 = 0;
			macroblock.PMV_0_1_0 = 0;
			macroblock.PMV_0_1_1 = 0;
			macroblock.PMV_1_0_0 = 0;
			macroblock.PMV_1_0_1 = 0;
			macroblock.PMV_1_1_0 = 0;
			macroblock.PMV_1_1_1 = 0;
			macroblock.motion_vertical_field_select_0_0 =
			    video->picture_structure >> 1;
			macroblock.vector_0_0_0 = 0;
			macroblock.vector_0_0_1 = 0;
			motion_type = video->predictive_coded_motion_type;
		    }
		}
		dc_dct_pred[0] = dc_dct_pred[1] = dc_dct_pred[2] =
		    video->intra_dc_default;
		if (macroblock.packed_flags & macroblock_pattern_mask) {
		    seek_h262_coefficient *coefficients;
		    seek_h262_scan_index **inverse_scan_X;
		    unsigned chroma_format, pattern_code, pattern_code_limit =
			0;

		    if (cache_size < 15) {
			cache_buffer =
			    cache_buffer << 16 | *buffer << 8 | buffer[1];
			buffer += 2;
			cache_size += 16;
			size -= 2;
		    }
		    pattern_code = ((unsigned short *) _seek_h262_B_9_01)
			[cache_buffer >> (cache_size - 9) & 511];
		    cache_size -= pattern_code & 15;
		    pattern_code >>= 4;
		    chroma_format = video->chroma_format;
		    switch (chroma_format) {
		    case H1V1:
			cache_size -= 6;
			pattern_code = pattern_code
			    | reflex64[cache_buffer >> cache_size & 63];
			pattern_code_limit = 0x1555555;
			break;
		    case H2V1:
			cache_size -= 2;
			pattern_code = pattern_code
			    | reflex16[cache_buffer >> cache_size & 3];
			pattern_code_limit = 0x0015555;
			break;
		    case H2V2:
			pattern_code_limit = 0x0001555;
		    }
		    inverse_scan_X = quantiser_matrices[1];
		    macroblock.pattern_code = pattern_code;
		    coefficients = macroblock.coefficients + _1ST_BLOCK_OFFSET;
		    chroma_format = 1;
		    for (; chroma_format < pattern_code_limit;
			 chroma_format <<= 2) {
			if (pattern_code & chroma_format) {
			    seek_h262_scan_index *inverse_scan;

			    inverse_scan = *inverse_scan_X;
			    DECODE_13818_Be_BLOCK();
			}
			inverse_scan_X++;
			coefficients += BLOCK_SIZE;
		    }
		    macroblock.dc_sparse = pattern_code;
		    macroblock.pattern_code &= ~macroblock.dc_sparse;
		} else {
		    macroblock.dc_sparse = 0;
		    macroblock.pattern_code = 0;
		}
		video->macroblock = &macroblock;
#if __RUN_FUTILE__
		macroblock.previous_macroblock_address =
		    macroblock.macroblock_address;
#else
		video->______macroblock[dct_type << 2 | motion_type](video);
#endif				/* __RUN_FUTILE__ */
	    }
	    if (cache_size < 23) {
		if (cache_size < 7) {
		    cache_buffer = cache_buffer << 24
			| *buffer << 16 | buffer[1] << 8 | buffer[2];
		    buffer += 3;
		    cache_size += 24;
		    size -= 3;
		} else if (cache_size < 15) {
		    cache_buffer =
			cache_buffer << 16 | *buffer << 8 | buffer[1];
		    buffer += 2;
		    cache_size += 16;
		    size -= 2;
		} else {
		    cache_buffer = cache_buffer << 8 | *buffer++;
		    cache_size += 8;
		    size--;
		}
	    }
	    {
		unsigned offset;

		offset = cache_buffer >> (cache_size - 23) & 8388607;
		if (!offset) {
		    break;
		}

		if (offset & 4194304) {
		    macroblock.macroblock_address_increment = 1;
		    cache_size--;
		    macroblock.macroblock_address =
			macroblock.previous_macroblock_address + 1;
		    macroblock.mb_column++;
		    if (macroblock.macroblock_address == video->mb_width) {
			macroblock.mb_column = 0;
		    }
		} else {
		    offset >>= 12;
		    if (offset != 8) {
			offset =
			    ((unsigned short *) _seek_h262_B_1_01)[offset];
			cache_size -= offset >> 8;
			macroblock.macroblock_address_increment = offset & 255;
		    } else {
			macroblock.macroblock_address_increment = 33;
			cache_size -= 11;
			do {
			    offset = cache_buffer >> (cache_size - 11) & 2047;
			    if (offset == 8) {
				macroblock.macroblock_address_increment += 33;
				cache_size -= 11;
			    } else {
				offset = ((unsigned short *) _seek_h262_B_1_01)
				    [offset];
				cache_size -= offset >> 8;
				macroblock.macroblock_address_increment +=
				    offset & 255;
			    }
			    if (cache_size < 11) {
				OPTIMISTIQUE_MOI_X(2);
				cache_buffer = cache_buffer << 16
				    | *buffer << 8 | buffer[1];
				buffer += 2;
				cache_size += 16;
				size -= 2;
			    }
			} while (offset == 8);
		    }
		    macroblock.macroblock_address =
			macroblock.previous_macroblock_address
			+ macroblock.macroblock_address_increment;
		    macroblock.mb_column =
			macroblock.macroblock_address % video->mb_width;
		    if (video->picture_coding_type == intra_coded) {
			if (video->scalable_mode == SNR_scalability
			    || video->picture_spatial_scalable_extension_seen) {
			} else {
			    ABORT_DECODING
				(video, buffer, size,
				 VIDEO_INVALID_MACROBLOCK_ADDRESS_INCREMENT);
			}
		    } else if (video->picture_coding_type == predictive_coded) {
			if (video->deinterlaced_release_coding_type
			    == intra_coded) {
			    ABORT_DECODING
				(video, buffer, size,
				 VIDEO_INVALID_MACROBLOCK_ADDRESS_INCREMENT);
			}
			macroblock.PMV_0_0_0 = 0;
			macroblock.PMV_0_0_1 = 0;
			macroblock.PMV_0_1_0 = 0;
			macroblock.PMV_0_1_1 = 0;
			macroblock.PMV_1_0_0 = 0;
			macroblock.PMV_1_0_1 = 0;
			macroblock.PMV_1_1_0 = 0;
			macroblock.PMV_1_1_1 = 0;
		    }
#if __RUN_FUTILE__
#else
		    video->______skipped_macroblocks_x__(video);
#endif				/* __RUN_FUTILE__ */
		    dc_dct_pred[0] = dc_dct_pred[1] = dc_dct_pred[2] =
			video->intra_dc_default;
		}
	    }
	} while (1);
	cache_size &= ~7;
	cache_buffer &= (1 << cache_size) - 1;
	video->buffer = buffer;
	video->size = size;
	if (cache_buffer) {
	    if (cache_size != 24 || cache_buffer != 1) {
		ABORT_DECODING(video, buffer, size, VIDEO_SLICE_FAULT);
	    }
	    if (!size) {
		video->optimistique_moi(video);
	    }
#if WORDS_BIGENDIAN
	    video->start_code = 0x00000100 | *video->buffer;
#else
	    video->start_code = 0x00010000 | *video->buffer << 24;
#endif				/* WORDS_BIGENDIAN */
	    video->buffer++;
	    video->size--;
	} else if (cache_size) {
	    video->start_code = cache_size >> 3;
	    video->neXt_start_code(video);
	} else {
	    video->next_start_code(video);
	}
    } while (MAMAN_A_TORT(video));
}
