/*
 * h262.3.d4.h
 * Copyright (C) 2004, 2005, 2006  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __SEEK_H262_3_D4_H__
#define __SEEK_H262_3_D4_H__

#include <h262.0.h>

#if defined __GNUC__
# define __1st(x)			(x).x08.a0
# define __2nd(x)			(x).x08.b1
# define __3rd(x)			(x).x08.c2
# define __4th(x)			(x).x08.d3
#else
# define __1st(x)			(x).x08[0]
# define __2nd(x)			(x).x08[1]
# define __3rd(x)			(x).x08[2]
# define __4th(x)			(x).x08[3]
#endif				/* __GNUC__ */

#if SIZEOF_LONG == 8
# if defined __GNUC__
#  define __5th(x)			(x).x08.e4
#  define __6th(x)			(x).x08.f5
#  define __7th(x)			(x).x08.g6
#  define __8th(x)			(x).x08.h7
# else
#  define __5th(x)			(x).x08[4]
#  define __6th(x)			(x).x08[5]
#  define __7th(x)			(x).x08[6]
#  define __8th(x)			(x).x08[7]
# endif				/* __GNUC__ */
#endif				/* SIZEOF_LONG == 8 */

#if !defined __GNUC__
typedef union __seek_h262_v4 {
    unsigned x20;
    unsigned char x08[4];
} __seek_h262_v4;
#else
union __seek_h262_v4 {
    unsigned x20;
    struct {
	unsigned char a0, b1, c2, d3;
    } x08;
} __attribute__((packed));
typedef union __seek_h262_v4 __seek_h262_v4;
#endif				/* !__GNUC__ */

#if SIZEOF_LONG == 8
# if !defined __GNUC__
typedef union __seek_h262_v8 {
    unsigned x40;
    unsigned char x08[8];
} __seek_h262_v8;
# else
union __seek_h262_v8 {
    unsigned x40;
    struct {
	unsigned char a0, b1, c2, d3, e4, f5, g6, h7;
    } x08;
} __attribute__((packed));
typedef union __seek_h262_v8 __seek_h262_v8;
# endif				/* !__GNUC__ */
#endif				/* SIZEOF_LONG == 8 */

#endif				/* __SEEK_H262_3_D4_H__ */
