/*
 * h262.3.h
 * Copyright (C) 2003, 2004, 2005, 2006, 2007, 2008  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __SEEK_H262_3_H__
#define __SEEK_H262_3_H__

#include <h262.0.h>
#include <h262.6.d4.h>

/*
 * 11172 definitions
 */
#define backward_B_a_01			B_a_01_0_0
#define backward_f_code			f_code_0_0
#define backward_f_code_limit		f_code_0_0_limit
#define backward_f_code_mask		f_code_0_0_mask
#define backward_f_code_range		f_code_0_0_range
#define forward_B_a_01			B_a_01_0_1
#define forward_f_code			f_code_0_1
#define forward_f_code_limit		f_code_0_1_limit
#define forward_f_code_mask		f_code_0_1_mask
#define forward_f_code_range		f_code_0_1_range
#define full_pel_backward_vector	decode_dct_type
#define full_pel_forward_vector		decode_motion_type
#define mb_advance			concealment_motion_vectors
#define mb_chroma			frame_pred_frame_dct
#define mb_offset			deinterlaced_release_coding_type
#define motion_limit			block_2_motion_limit

#if __SHORT_ENDED_ARITHMETIC__
typedef short seek_h262_coefficient;
#else
typedef int seek_h262_coefficient;
#endif				/* __SHORT_ENDED_ARITHMETIC__ */

typedef unsigned seek_h262_scan_index;

typedef void (*seek_h262_constructOr)
 (unsigned char *, unsigned char *, unsigned char *, unsigned);

#if __Berkeley_FUCK_UP__
typedef seek_h262_constructOr *seek_h262_constructOr_[3];
#else
typedef seek_h262_constructOr *seek_h262_constructOr_;
#endif				/* __Berkeley_FUCK_UP__ */

typedef void (*seek_h262_constructor)
 (unsigned char *, unsigned char *, unsigned);

#if __Berkeley_FUCK_UP__
typedef seek_h262_constructor *seek_h262_constructor_[3];
#else
typedef seek_h262_constructor *seek_h262_constructor_;
#endif				/* __Berkeley_FUCK_UP__ */

typedef struct seek_h262_11172_macroblock {
    int recon_down_back, recon_down_for, recon_right_back, recon_right_for;
#if __CCC_ALIGN_COEFFICIENTS__
    seek_h262_coefficient coefficients[BLOCK_SIZEx006]
	__attribute__ ((aligned(BLOCK_ALIGNMENT)));
#elif __FIX_ALIGN_COEFFICIENTS__
    seek_h262_coefficient *coefficients;
#else
    seek_h262_coefficient coefficients[BLOCK_SIZEx006];
#endif				/* __CCC_ALIGN_COEFFICIENTS__ */
    unsigned dc_sparse, macroblock_address, macroblock_address_increment,
	packed_flags, pattern_code, previous_macroblock_address;
} seek_h262_11172_macroblock;

typedef struct seek_h262_13818_macroblock {
    int PMV_0_0_0, PMV_0_0_1, PMV_0_1_0, PMV_0_1_1, PMV_1_0_0, PMV_1_0_1,
	PMV_1_1_0, PMV_1_1_1, vector_0_0_0, vector_0_0_1, vector_0_1_0,
	vector_0_1_1, vector_1_0_0, vector_1_0_1, vector_1_1_0, vector_1_1_1;
#if __CCC_ALIGN_COEFFICIENTS__
    seek_h262_coefficient coefficients[BLOCK_SIZEx014]
	__attribute__ ((aligned(BLOCK_ALIGNMENT)));
#elif __FIX_ALIGN_COEFFICIENTS__
    seek_h262_coefficient *coefficients;
#else
    seek_h262_coefficient coefficients[BLOCK_SIZEx014];
#endif				/* __CCC_ALIGN_COEFFICIENTS__ */
    unsigned chrominance_slice_address, dc_sparse, dmvector_0, dmvector_1,
	luminance_slice_address, macroblock_address,
	macroblock_address_increment, mb_column, mb_row,
	motion_vertical_field_select_0_0, motion_vertical_field_select_0_1,
	motion_vertical_field_select_1_0, motion_vertical_field_select_1_1,
	packed_flags, pattern_code, previous_macroblock_address,
	spatial_temporal_weight_code;
} seek_h262_13818_macroblock;

typedef struct seek_h262_block {
    seek_h262_coefficient *coefficients;
    unsigned char *base_address;
} seek_h262_block;

typedef struct seek_h262_field_reference {
    unsigned char *Cb, *Cr, *Y;
} seek_h262_field_reference;

typedef struct seek_h262_release {
    unsigned flags;
    unsigned char *Cb, *Cr, *Y;
    void *private;
} seek_h262_release;

#if __ENABLE_X000001BA___HACK_1__
/*
 * pack_header()
 */
typedef struct seek_h262_x000001ba__ {
    unsigned program_mux_rate, system_clock_reference_0,
	system_clock_reference_1;
    void *decoder;
} seek_h262_x000001ba__;
#endif				/* __ENABLE_X000001BA___HACK_1__ */

#if __ENABLE_X000001BB___HACK_1__ || __ENABLE_X000001BB___HACK_2__
/*
 * system_header()
 */
typedef struct seek_h262_x000001bb__ {
    union {
	struct {
	    unsigned CSPS_flag, audio_bound, fixed_flag, rate_bound,
		system_audio_lock_flag, system_video_lock_flag, video_bound;
	} x0;
	struct {
	    unsigned PhyphenSTD_buffer_bound_scale,
		PhyphenSTD_buffer_size_bound, stream_id;
	} x1;
    } x;
    void *decoder;
} seek_h262_x000001bb__;
#endif				/* __ENABLE_X000001BB___HACK_1__ || __ENABLE_X000001BB___HACK_2__ */

#if __ENABLE_X000001BC___HACK_1__ || __ENABLE_X000001BC___HACK_2__ || __ENABLE_X000001BC___HACK_3__ || __ENABLE_X000001BC___HACK_4__
/*
 * program_stream_map()
 */
typedef struct seek_h262_x000001bc__ {
    union {
	struct {
	    unsigned current_next_indicator, program_stream_map_version;
	} x0;
	struct {
	    unsigned descriptor_length, descriptor_tag;
	    unsigned char data[255];
	} x1;
	struct {
	    unsigned elementary_stream_id, stream_type;
	} x2;
	struct {
	    unsigned descriptor_length, descriptor_tag;
	    unsigned char data[255];
	} x3;
    } x;
    void *decoder;
} seek_h262_x000001bc__;
#endif				/* __ENABLE_X000001BC___HACK_1__ || __ENABLE_X000001BC___HACK_2__ || __ENABLE_X000001BC___HACK_3__ || __ENABLE_X000001BC___HACK_4__ */

#if __ENABLE_X000001FF___HACK_1__ || __ENABLE_X000001FF___HACK_2__
/*
 * packet()
 */
typedef struct seek_h262_x000001ff__ {
    union {
	struct {
	    unsigned DTS_0, DTS_1, PTS_0, PTS_1;
	} x0;
	struct {
	    unsigned data_size;
	} x1;
    } x;
    void *decoder;
} seek_h262_x000001ff__;
#endif				/* __ENABLE_X000001FF___HACK_1__ || __ENABLE_X000001FF___HACK_2__ */

#if __ENABLE_X000001S1___HACK_3__
/*
 * packet()
 */
typedef struct seek_h262_x000001s1__ {
    union {
	struct {
	    unsigned DSM_trick_mode_flag, ESCR_flag, ES_rate_flag,
		PES_CRC_flag, PES_extension_flag, PES_header_data_length,
		PES_priority, PES_scrambling_control, PTS_DTS_flags,
		additional_copy_flag, copyright, data_alignment_indicator,
		original_or_copy;
	} x2;
	struct {
	    unsigned ESCR_base_0, ESCR_base_1, ESCR_extension;
	} x3;
	struct {
	    unsigned ES_rate;
	} x4;
	struct {
	    union {
		struct {
		    unsigned field_id, frequency_truncation,
			intra_slice_refresh;
		} v0;
		struct {
		    unsigned field_rep_cntrl;
		} v1;
		struct {
		    unsigned field_id;
		} v2;
		struct {
		    unsigned field_id, frequency_truncation,
			intra_slice_refresh;
		} v3;
	    } v;
	    unsigned trick_mode_control;
	} x5;
	struct {
	    unsigned additional_copy_info;
	} x6;
	struct {
	    unsigned previous_PES_packet_CRC;
	} x7;
	struct {
	    unsigned PES_extension_field_flag, PES_private_data_flag,
		PhyphenSTD_buffer_flag, pack_header_field_flag,
		program_packet_sequence_control_flag;
	} x8;
    } x;
    void *decoder;
} seek_h262_x000001s1__;
#endif				/* __ENABLE_X000001S1___HACK_3__ */

typedef struct seek_h262_system {
    unsigned error, minimum_useful_size, size, start_code;
    unsigned char *buffer;
    void (*abort_decoding) (struct seek_h262_system *),
	(*correct_underflow) (struct seek_h262_system *), *private,
	(*next_start_code) (struct seek_h262_system *),
	(*packet_data) (struct seek_h262_system *, unsigned),
	(*seek_stream) (struct seek_h262_system *, unsigned);
#if __ENABLE_X000001BA___HACK_1__
    void (*x000001ba___hack_1) (struct seek_h262_x000001ba__ *);
#endif				/* __ENABLE_X000001BA___HACK_1__ */
#if __ENABLE_X000001BB___HACK_1__
    void (*x000001bb___hack_1) (struct seek_h262_x000001bb__ *);
#endif				/* __ENABLE_X000001BB___HACK_1__ */
#if __ENABLE_X000001BB___HACK_2__
    void (*x000001bb___hack_2) (struct seek_h262_x000001bb__ *);
#endif				/* __ENABLE_X000001BB___HACK_2__ */
#if __ENABLE_X000001BC___HACK_1__
    void (*x000001bc___hack_1) (struct seek_h262_x000001bc__ *);
#endif				/* __ENABLE_X000001BC___HACK_1__ */
#if __ENABLE_X000001BC___HACK_2__
    void (*x000001bc___hack_2) (struct seek_h262_x000001bc__ *);
#endif				/* __ENABLE_X000001BC___HACK_2__ */
#if __ENABLE_X000001BC___HACK_3__
    void (*x000001bc___hack_3) (struct seek_h262_x000001bc__ *);
#endif				/* __ENABLE_X000001BC___HACK_3__ */
#if __ENABLE_X000001BC___HACK_4__
    void (*x000001bc___hack_4) (struct seek_h262_x000001bc__ *);
#endif				/* __ENABLE_X000001BC___HACK_4__ */
#if __ENABLE_X000001FF___HACK_0__
    void (*x000001ff___hack_0) (struct seek_h262_system *);
#endif				/* __ENABLE_X000001FF___HACK_0__ */
#if __ENABLE_X000001FF___HACK_1__
    void (*x000001ff___hack_1) (struct seek_h262_x000001ff__ *);
#endif				/* __ENABLE_X000001FF___HACK_1__ */
#if __ENABLE_X000001FF___HACK_2__
    void (*x000001ff___hack_2) (struct seek_h262_x000001ff__ *);
#endif				/* __ENABLE_X000001FF___HACK_2__ */
#if __ENABLE_X000001S1___HACK_3__
    void (*x000001s1___hack_3) (struct seek_h262_x000001s1__ *);
#endif				/* __ENABLE_X000001S1___HACK_3__ */
#if __ENABLE_X000001S1___HACK_4__
    void (*x000001s1___hack_4) (struct seek_h262_x000001s1__ *);
#endif				/* __ENABLE_X000001S1___HACK_4__ */
#if __ENABLE_X000001S1___HACK_5__
    void (*x000001s1___hack_5) (struct seek_h262_x000001s1__ *);
#endif				/* __ENABLE_X000001S1___HACK_5__ */
#if __ENABLE_X000001S1___HACK_6__
    void (*x000001s1___hack_6) (struct seek_h262_x000001s1__ *);
#endif				/* __ENABLE_X000001S1___HACK_6__ */
#if __ENABLE_X000001S1___HACK_7__
    void (*x000001s1___hack_7) (struct seek_h262_x000001s1__ *);
#endif				/* __ENABLE_X000001S1___HACK_7__ */
#if __ENABLE_X000001S1___HACK_8__
    void (*x000001s1___hack_8) (struct seek_h262_x000001s1__ *);
#endif				/* __ENABLE_X000001S1___HACK_8__ */
#if __ENABLE_X000001S1___HACK_9__
    void (*x000001s1___hack_9) (struct seek_h262_x000001s1__ *);
#endif				/* __ENABLE_X000001S1___HACK_9__ */
} seek_h262_system;

struct seek_h262_transport_packet {
    unsigned PID, adaptation_field_control, continuity_counter,
	payload_start_unit_indicator, transport_error_indicator,
	transport_priority, transport_scrambling_control;
    void *decoder;
} seek_h262_transport_packet;

typedef struct seek_h262_transport {
    unsigned error, minimum_useful_size, size, transport_packet;
    unsigned char *buffer;
    void (*abort_decoding) (struct seek_h262_transport *),
	(*correct_underflow) (struct seek_h262_transport *), *private,
	(*packet_data) (struct seek_h262_transport *, unsigned);
#if 1
    void (*transport_packet_hack_1) (struct seek_h262_transport_packet *);
#endif				/* 1 */
} seek_h262_transport;

#if __ENABLE_X00000100___HACK_1__
/*
 * picture_header()
 */
typedef struct seek_h262_x00000100__ {
    unsigned backward_f_code, forward_f_code, full_pel_backward_vector,
	full_pel_forward_vector, picture_coding_type, temporal_reference;
    void *decoder;
} seek_h262_x00000100__;
#endif				/* __ENABLE_X00000100___HACK_1__ */

#if __ENABLE_X000001AF___HACK_3__
/*
 * slice()
 */
typedef struct seek_h262_x000001af__ {
    union {
	struct {
	    unsigned extra_information_slice;
	} x2;
    } x;
    void *decoder;
} seek_h262_x000001af__;
#endif				/* __ENABLE_X000001AF___HACK_3__ */

#if __ENABLE_X000001B3___HACK_1__
/*
 * sequence_header()
 */
typedef struct seek_h262_x000001b3__ {
    unsigned aspect_ratio_information, frame_rate_code;
    void *decoder;
} seek_h262_x000001b3__;
#endif				/* __ENABLE_X000001B3___HACK_1__ */

#if __ENABLE_X000001B5_1_HACK_1__
/*
 * sequence_extension()
 */
typedef struct seek_h262_x000001b5_1 {
    int synthetic;
    unsigned bit_rate, chroma_format, frame_rate_extension_d,
	frame_rate_extension_n, horizontal_size, load_intra_quantiser_matrix,
	load_non_intra_quantiser_matrix, profile_and_level_indication,
	progressive_sequence, vertical_size;
    unsigned char chroma_intra_quantiser_matrix[64],
	chroma_non_intra_quantiser_matrix[64], intra_quantiser_matrix[64],
	non_intra_quantiser_matrix[64];
    void *decoder;
} seek_h262_x000001b5_1;
#endif				/* __ENABLE_X000001B5_1_HACK_1__ */

#if __ENABLE_X000001B5_2_HACK_1__
/*
 * sequence_display_extension()
 */
typedef struct seek_h262_x000001b5_2 {
    unsigned colour_description, colour_primaries, display_horizontal_size,
	display_vertical_size, matrix_coefficients, transfer_characteristics,
	video_format;
    void *decoder;
} seek_h262_x000001b5_2;
#endif				/* __ENABLE_X000001B5_2_HACK_1__ */

#if __ENABLE_X000001B5_1_HACK_2__ || __ENABLE_X000001B5_3_HACK_1__
/*
 * quant_matrix_extension()
 */
typedef struct seek_h262_x000001b5_3 {
    unsigned load_chroma_intra_quantiser_matrix,
	load_chroma_non_intra_quantiser_matrix, load_intra_quantiser_matrix,
	load_non_intra_quantiser_matrix;
    unsigned char chroma_intra_quantiser_matrix[64],
	chroma_non_intra_quantiser_matrix[64], intra_quantiser_matrix[64],
	non_intra_quantiser_matrix[64];
    void *decoder;
} seek_h262_x000001b5_3;
#endif				/* __ENABLE_X000001B5_1_HACK_2__ || __ENABLE_X000001B5_3_HACK_1__ */

#if __ENABLE_X000001B5_5_HACK_1__
/*
 * sequence_scalable_extension()
 */
typedef struct seek_h262_x000001b5_5 {
    union {
	struct {
	    unsigned horizontal_subsampling_factor_m,
		horizontal_subsampling_factor_n,
		lower_layer_prediction_horizontal_size,
		lower_layer_prediction_vertical_size,
		vertical_subsampling_factor_m,
		vertical_subsampling_factor_n;
	} x0;
	struct {
	    unsigned mux_to_progressive_sequence, picture_mux_enable,
		picture_mux_factor, picture_mux_order;
	} x1;
    } x;
    unsigned layer_id, scalable_mode;
    void *decoder;
} seek_h262_x000001b5_5;
#endif				/* __ENABLE_X000001B5_5_HACK_1__ */

#if __ENABLE_X000001B5_7_HACK_1__
/*
 * picture_display_extension()
 */
typedef struct seek_h262_x000001b5_7 {
    struct {
	int frame_centre_horizontal_offset, frame_centre_vertical_offset;
    } x[3];
    void *decoder;
} seek_h262_x000001b5_7;
#endif				/* __ENABLE_X000001B5_7_HACK_1__ */

#if __ENABLE_X000001B5_8_HACK_1__
/*
 * picture_coding_extension()
 */
typedef struct seek_h262_x000001b5_8 {
    unsigned alternate_scan, concealment_motion_vectors, decode_dct_type,
	decode_motion_type, f_code_0_0, f_code_0_1, f_code_1_0, f_code_1_1,
	frame_pred_frame_dct, intra_dc_precision, intra_vlc_format,
	picture_structure, progressive_frame, q_scale_type, repeat_first_field,
	top_field_first;
    void *decoder;
} seek_h262_x000001b5_8;
#endif				/* __ENABLE_X000001B5_8_HACK_1__ */

#if __ENABLE_X000001B5_9_HACK_1__
/*
 * picture_spatial_scalable_extension()
 */
typedef struct seek_h262_x000001b5_9 {
    int lower_layer_horizontal_offset, lower_layer_vertical_offset;
    unsigned lower_layer_deinterlaced_field_select,
	lower_layer_progressive_frame, lower_layer_temporal_reference,
	spatial_temporal_weight_code_table_index;
    void *decoder;
} seek_h262_x000001b5_9;
#endif				/* __ENABLE_X000001B5_9_HACK_1__ */

#if __ENABLE_X000001B5_A_HACK_1__
/*
 * picture_temporal_scalable_extension()
 */
typedef struct seek_h262_x000001b5_a {
    unsigned backward_temporal_reference, forward_temporal_reference,
	reference_select_code;
    void *decoder;
} seek_h262_x000001b5_a;
#endif				/* __ENABLE_X000001B5_A_HACK_1__ */

typedef struct seek_h262_video {
    unsigned error, minimum_useful_size, size, start_code;
    unsigned char *buffer;
    void (*abort_decoding) (struct seek_h262_video *),
	(*optimistique_moi) (struct seek_h262_video *), *private;
    int decode_dct_type, decode_motion_type, dmv_abort, expect_field,
	picture_spatial_scalable_extension_seen, progressive_sequence,
	sequence_display_extension_seen, sequence_scalable_extension_seen;
    seek_h262_constructOr_ block_1_0, block_1_1, block_1_2, block_1_3,
	block_1_6;
    seek_h262_constructor_ block_0_0, block_0_1, block_0_2, block_0_3,
	block_0_6;
    seek_h262_scan_index chroma_intra_quantiser_matrix[2][64],
	chroma_non_intra_quantiser_matrix[2][64],
	intra_quantiser_matrix[2][64], non_intra_quantiser_matrix[2][64];
    struct seek_h262_block blocks[24];
    struct seek_h262_field_reference field_references[2];
    struct seek_h262_release Iran_release, Irulan_release, Mylene_release;
    unsigned alternate_scan, block_1_motion_limit[4], block_2_motion_limit[4],
	block_9_motion_limit[4], block_a_motion_limit[4],
	chroma_format, chrominance_line_size, chrominance_slice_size,
	concealment_motion_vectors, deinterlaced_release_coding_type,
	f_code_0_0, f_code_0_0_limit, f_code_0_0_mask, f_code_0_0_range,
	f_code_0_1, f_code_0_1_limit, f_code_0_1_mask, f_code_0_1_range,
	f_code_1_0, f_code_1_0_limit, f_code_1_0_mask, f_code_1_0_range,
	f_code_1_1, f_code_1_1_limit, f_code_1_1_mask, f_code_1_1_range,
	frame_pred_frame_dct, horizontal_size, intra_dc_default,
	intra_dc_precision, *inverse_scan_0, *inverse_scan_1,
	luminance_line_size, luminance_slice_size, m_0_1, m_1_0,
	macroblocks_count, mb_height, mb_width, picture_coding_type,
	picture_structure, picture_substructure, predictive_coded_motion_type,
	*q_scale, scalable_mode, spatial_temporal_weight_code_table_index,
	sequence_header[2], slice_minimum_useful_size, temporal_reference,
	vertical_size;
#if __ENABLE_X000001AF___HACK_0__
    unsigned break_code;
#endif				/* __ENABLE_X000001AF___HACK_0__ */
    unsigned char *B_2345678_01, *B_a_01_0_0, *B_a_01_0_1, *B_a_01_1_0,
	*B_a_01_1_1, *B_ef_012_0, *B_ef_012_1, sequence_display_extension[8],
	sequence_extension[6], sequence_scalable_extension[8];
    void (*______macroblock[8]) (struct seek_h262_video *),
	(*______skipped_macroblocks_x__) (struct seek_h262_video *),
	(*alloc_storage) (struct seek_h262_video *, unsigned char **, unsigned,
			  unsigned),
	(*do_release) (struct seek_h262_video *, struct seek_h262_release *),
	(*field_macroblock[4]) (struct seek_h262_video *),
	(*field_skipped_macroblocks_x10) (struct seek_h262_video *),
	(*field_skipped_macroblocks_x18) (struct seek_h262_video *),
	(*frame_macroblock[8]) (struct seek_h262_video *),
	(*frame_skipped_macroblocks_x10) (struct seek_h262_video *),
	(*frame_skipped_macroblocks_x18) (struct seek_h262_video *),
	(*idct_add_block) (struct seek_h262_block *, unsigned, unsigned,
			   unsigned),
	(*idct_set_block) (struct seek_h262_block *, unsigned, unsigned,
			   unsigned), *macroblock,
	(*neXt_start_code) (struct seek_h262_video *),
	(*next_start_code) (struct seek_h262_video *),
	(*slices[8]) (struct seek_h262_video *);
#if __ENABLE_X00000100___HACK_0__
    void (*x00000100___hack_0) (struct seek_h262_video *);
#endif				/* __ENABLE_X00000100___HACK_0__ */
#if __ENABLE_X00000100___HACK_1__
    void (*x00000100___hack_1) (struct seek_h262_x00000100__ *);
#endif				/* __ENABLE_X00000100___HACK_1__ */
#if __ENABLE_X00000100___HACK_2__
    void (*x00000100___hack_2) (struct seek_h262_x00000100__ *);
#endif				/* __ENABLE_X00000100___HACK_2__ */
#if __ENABLE_X000001AF___HACK_0__
    void (*x000001af___hack_0) (struct seek_h262_video *);
#endif				/* __ENABLE_X000001AF___HACK_0__ */
#if __ENABLE_X000001AF___HACK_3__
    void (*x000001af___hack_3) (struct seek_h262_x000001af__ *);
#endif				/* __ENABLE_X000001AF___HACK_3__ */
#if __ENABLE_X000001AF___HACK_x__
    void (*x000001af___hack_X) (struct seek_h262_video *);
#endif				/* __ENABLE_X000001AF___HACK_x__ */
#if __ENABLE_X000001B2___HACK_0__
    void (*x000001b2___hack_0) (struct seek_h262_video *);
#endif				/* __ENABLE_X000001B2___HACK_0__ */
#if __ENABLE_X000001B3___HACK_0__
    void (*x000001b3___hack_0) (struct seek_h262_video *);
#endif				/* __ENABLE_X000001B3___HACK_0__ */
#if __ENABLE_X000001B3___HACK_1__
    void (*x000001b3___hack_1) (struct seek_h262_x000001b3__ *);
#endif				/* __ENABLE_X000001B3___HACK_1__ */
#if __ENABLE_X000001B5___HACK_0__
    void (*x000001b5___hack_0) (struct seek_h262_video *);
#endif				/* __ENABLE_X000001B5___HACK_0__ */
#if __ENABLE_X000001B5_1_HACK_0__
    void (*x000001b5_1_hack_0) (struct seek_h262_video *);
#endif				/* __ENABLE_X000001B5_1_HACK_0__ */
#if __ENABLE_X000001B5_1_HACK_1__
    void (*x000001b5_1_hack_1) (struct seek_h262_x000001b5_1 *);
#endif				/* __ENABLE_X000001B5_1_HACK_1__ */
#if __ENABLE_X000001B5_1_HACK_2__
    void (*x000001b5_1_hack_2) (struct seek_h262_x000001b5_3 *);
#endif				/* __ENABLE_X000001B5_1_HACK_2__ */
#if __ENABLE_X000001B5_2_HACK_0__
    void (*x000001b5_2_hack_0) (struct seek_h262_video *);
#endif				/* __ENABLE_X000001B5_2_HACK_0__ */
#if __ENABLE_X000001B5_2_HACK_1__
    void (*x000001b5_2_hack_1) (struct seek_h262_x000001b5_2 *);
#endif				/* __ENABLE_X000001B5_2_HACK_1__ */
#if __ENABLE_X000001B5_3_HACK_0__
    void (*x000001b5_3_hack_0) (struct seek_h262_video *);
#endif				/* __ENABLE_X000001B5_3_HACK_0__ */
#if __ENABLE_X000001B5_3_HACK_1__
    void (*x000001b5_3_hack_1) (struct seek_h262_x000001b5_3 *);
#endif				/* __ENABLE_X000001B5_3_HACK_1__ */
#if __ENABLE_X000001B5_5_HACK_0__
    void (*x000001b5_5_hack_0) (struct seek_h262_video *);
#endif				/* __ENABLE_X000001B5_5_HACK_0__ */
#if __ENABLE_X000001B5_5_HACK_1__
    void (*x000001b5_5_hack_1) (struct seek_h262_x000001b5_5 *);
#endif				/* __ENABLE_X000001B5_5_HACK_1__ */
#if __ENABLE_X000001B5_7_HACK_0__
    void (*x000001b5_7_hack_0) (struct seek_h262_video *);
#endif				/* __ENABLE_X000001B5_7_HACK_0__ */
#if __ENABLE_X000001B5_7_HACK_1__
    void (*x000001b5_7_hack_1) (struct seek_h262_x000001b5_7 *);
#endif				/* __ENABLE_X000001B5_7_HACK_1__ */
#if __ENABLE_X000001B5_8_HACK_0__
    void (*x000001b5_8_hack_0) (struct seek_h262_video *);
#endif				/* __ENABLE_X000001B5_8_HACK_0__ */
#if __ENABLE_X000001B5_8_HACK_1__
    void (*x000001b5_8_hack_1) (struct seek_h262_x000001b5_8 *);
#endif				/* __ENABLE_X000001B5_8_HACK_1__ */
#if __ENABLE_X000001B5_9_HACK_0__
    void (*x000001b5_9_hack_0) (struct seek_h262_video *);
#endif				/* __ENABLE_X000001B5_9_HACK_0__ */
#if __ENABLE_X000001B5_9_HACK_1__
    void (*x000001b5_9_hack_1) (struct seek_h262_x000001b5_9 *);
#endif				/* __ENABLE_X000001B5_9_HACK_1__ */
#if __ENABLE_X000001B5_A_HACK_0__
    void (*x000001b5_a_hack_0) (struct seek_h262_video *);
#endif				/* __ENABLE_X000001B5_A_HACK_0__ */
#if __ENABLE_X000001B5_A_HACK_1__
    void (*x000001b5_a_hack_1) (struct seek_h262_x000001b5_a *);
#endif				/* __ENABLE_X000001B5_A_HACK_1__ */
#if __ENABLE_X000001B8___HACK_0__
    void (*x000001b8___hack_0) (struct seek_h262_video *);
#endif				/* __ENABLE_X000001B8___HACK_0__ */
} seek_h262_video;

typedef struct seek_h262_whatever {
    unsigned error, minimum_useful_size, size, start_code;
    unsigned char *buffer;
    void (*abort_decoding) (struct seek_h262_whatever *),
	(*correct_underflow) (struct seek_h262_whatever *), *private;
} seek_h262_whatever;

#endif				/* __SEEK_H262_3_H__ */
