/*
 * h262.4.d4.h
 * Copyright (C) 2004, 2005  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __SEEK_H262_4_D4_H__
#define __SEEK_H262_4_D4_H__

#define motion_code() \
    {									      \
	if (cache_size < 12) {						      \
	    OPTIMISTIQUE_MOI_X(2);					      \
	    cache_buffer = cache_buffer << 16 | *buffer << 8 | buffer[1];     \
	    buffer += 2;						      \
	    cache_size += 16;						      \
	    size -= 2;							      \
	}								      \
	code = cache_buffer >> (cache_size - 11);			      \
    }

#define motion_component(r, s, t) \
    {									      \
	code &= 2047;							      \
	macroblock.vector_##r##_##s##_##t =				      \
	    ((short *) video->B_a_01_##s##_##t)[code];			      \
	cache_size -= macroblock.vector_##r##_##s##_##t & 255;		      \
	macroblock.vector_##r##_##s##_##t >>= 8;			      \
	if (code < video->f_code_##s##_##t##_limit) {			      \
	    motion_residual(r, s, t);					      \
	}								      \
    }

#define motion_residual(r, s, t) \
    {									      \
	int sign;							      \
									      \
	sign = macroblock.vector_##r##_##s##_##t >> 31;			      \
	macroblock.vector_##r##_##s##_##t =				      \
	    (macroblock.vector_##r##_##s##_##t ^ sign) - sign;		      \
	macroblock.vector_##r##_##s##_##t <<= video->f_code_##s##_##t;	      \
	if (cache_size < video->f_code_##s##_##t) {			      \
	    OPTIMISTIQUE_MOI_1(0);					      \
	    cache_buffer = cache_buffer << 8 | *buffer++;		      \
	    cache_size += 8;						      \
	    size--;							      \
	}								      \
	cache_size -= video->f_code_##s##_##t;				      \
	macroblock.vector_##r##_##s##_##t -= 				      \
	    ~(cache_buffer >> cache_size) & video->f_code_##s##_##t##_mask;   \
	macroblock.vector_##r##_##s##_##t =				      \
	    (macroblock.vector_##r##_##s##_##t ^ sign) - sign;		      \
    }

#define dmvector(t) \
    {									      \
	if (cache_size < 2) {						      \
	    OPTIMISTIQUE_MOI_1(0);					      \
	    cache_buffer = cache_buffer << 8 | *buffer++;		      \
	    cache_size += 8;						      \
	    size--;							      \
	}								      \
	macroblock.dmvector_##t = cache_buffer >> (cache_size - 2) & 3;	      \
	cache_size -= B_b_1[macroblock.dmvector_##t];			      \
	macroblock.dmvector_##t =					      \
	    ((char *) B_b_0)[macroblock.dmvector_##t];			      \
    }

#define motion_vector_0(r, s) \
    {									      \
	unsigned code;							      \
									      \
	motion_code();							      \
	if (code & 1024) {						      \
	    cache_size--;						      \
	    macroblock.vector_##r##_##s##_0 = macroblock.PMV_##r##_##s##_0;   \
	} else {							      \
	    motion_component(r, s, 0);					      \
	    macroblock.vector_##r##_##s##_0 += macroblock.PMV_##r##_##s##_0;  \
	    macroblock.vector_##r##_##s##_0 = macroblock.vector_##r##_##s##_0 \
		<< video->f_code_##s##_0_range >> video->f_code_##s##_0_range;\
	    macroblock.PMV_##r##_##s##_0 = macroblock.vector_##r##_##s##_0;   \
	}								      \
	dmvector(0);							      \
	motion_code();							      \
	if (code & 1024) {						      \
	    cache_size--;						      \
	    macroblock.vector_##r##_##s##_1 = macroblock.PMV_##r##_##s##_1;   \
	    macroblock.PMV_##r##_##s##_1 &= ~1;				      \
	    macroblock.vector_##r##_##s##_1 >>= 1;			      \
	} else {							      \
	    motion_component(r, s, 1);					      \
	    macroblock.vector_##r##_##s##_1 +=				      \
		macroblock.PMV_##r##_##s##_1 >> 1;			      \
	    macroblock.vector_##r##_##s##_1 = macroblock.vector_##r##_##s##_1 \
		<< video->f_code_##s##_1_range >> video->f_code_##s##_1_range;\
	    macroblock.PMV_##r##_##s##_1 =				      \
		macroblock.vector_##r##_##s##_1 << 1;			      \
	}								      \
	dmvector(1);							      \
    }

#define motion_vector_1(r, s) \
    {									      \
	unsigned code;							      \
									      \
	motion_code();							      \
	if (code & 1024) {						      \
	    cache_size--;						      \
	    macroblock.vector_##r##_##s##_0 = macroblock.PMV_##r##_##s##_0;   \
	} else {							      \
	    motion_component(r, s, 0);					      \
	    macroblock.vector_##r##_##s##_0 += macroblock.PMV_##r##_##s##_0;  \
	    macroblock.vector_##r##_##s##_0 = macroblock.vector_##r##_##s##_0 \
		<< video->f_code_##s##_0_range >> video->f_code_##s##_0_range;\
	    macroblock.PMV_##r##_##s##_0 = macroblock.vector_##r##_##s##_0;   \
	}								      \
	motion_code();							      \
	if (code & 1024) {						      \
	    cache_size--;						      \
	    macroblock.vector_##r##_##s##_1 = macroblock.PMV_##r##_##s##_1;   \
	    macroblock.PMV_##r##_##s##_1 &= ~1;				      \
	    macroblock.vector_##r##_##s##_1 >>= 1;			      \
	} else {							      \
	    motion_component(r, s, 1);					      \
	    macroblock.vector_##r##_##s##_1 +=				      \
		macroblock.PMV_##r##_##s##_1 >> 1;			      \
	    macroblock.vector_##r##_##s##_1 = macroblock.vector_##r##_##s##_1 \
		<< video->f_code_##s##_1_range >> video->f_code_##s##_1_range;\
	    macroblock.PMV_##r##_##s##_1 =				      \
		macroblock.vector_##r##_##s##_1 << 1;			      \
	}								      \
    }

#define motion_vector_2(r, s) \
    {									      \
	unsigned code;							      \
									      \
	motion_code();							      \
	if (code & 1024) {						      \
	    cache_size--;						      \
	    macroblock.vector_##r##_##s##_0 = macroblock.PMV_##r##_##s##_0;   \
	} else {							      \
	    motion_component(r, s, 0);					      \
	    macroblock.vector_##r##_##s##_0 += macroblock.PMV_##r##_##s##_0;  \
	    macroblock.vector_##r##_##s##_0 = macroblock.vector_##r##_##s##_0 \
		<< video->f_code_##s##_0_range >> video->f_code_##s##_0_range;\
	    macroblock.PMV_##r##_##s##_0 = macroblock.vector_##r##_##s##_0;   \
	}								      \
	motion_code();							      \
	if (code & 1024) {						      \
	    cache_size--;						      \
	    macroblock.vector_##r##_##s##_1 = macroblock.PMV_##r##_##s##_1;   \
	} else {							      \
	    motion_component(r, s, 1);					      \
	    macroblock.vector_##r##_##s##_1 += macroblock.PMV_##r##_##s##_1;  \
	    macroblock.vector_##r##_##s##_1 = macroblock.vector_##r##_##s##_1 \
		<< video->f_code_##s##_1_range >> video->f_code_##s##_1_range;\
	    macroblock.PMV_##r##_##s##_1 = macroblock.vector_##r##_##s##_1;   \
	}								      \
    }

#define motion_vector_3(r, s) \
    {									      \
	unsigned code;							      \
									      \
	motion_code();							      \
	if (code & 1024) {						      \
	    cache_size--;						      \
	    macroblock.vector_##r##_##s##_0 = macroblock.PMV_##r##_##s##_0;   \
	} else {							      \
	    motion_component(r, s, 0);					      \
	    macroblock.vector_##r##_##s##_0 += macroblock.PMV_##r##_##s##_0;  \
	    macroblock.vector_##r##_##s##_0 = macroblock.vector_##r##_##s##_0 \
		<< video->f_code_##s##_0_range >> video->f_code_##s##_0_range;\
	    macroblock.PMV_##r##_##s##_0 = macroblock.vector_##r##_##s##_0;   \
	}								      \
	dmvector(0);							      \
	motion_code();							      \
	if (code & 1024) {						      \
	    cache_size--;						      \
	    macroblock.vector_##r##_##s##_1 = macroblock.PMV_##r##_##s##_1;   \
	} else {							      \
	    motion_component(r, s, 1);					      \
	    macroblock.vector_##r##_##s##_1 += macroblock.PMV_##r##_##s##_1;  \
	    macroblock.vector_##r##_##s##_1 = macroblock.vector_##r##_##s##_1 \
		<< video->f_code_##s##_1_range >> video->f_code_##s##_1_range;\
	    macroblock.PMV_##r##_##s##_1 = macroblock.vector_##r##_##s##_1;   \
	}								      \
	dmvector(1);							      \
    }

#define motion_vector_4(r, s) \
    {									      \
	unsigned code;							      \
									      \
	motion_code();							      \
	if (code & 1024) {						      \
	    cache_size--;						      \
	    macroblock.vector_##r##_##s##_0 = macroblock.PMV_##r##_##s##_0;   \
	} else {							      \
	    motion_component(r, s, 0);					      \
	    macroblock.vector_##r##_##s##_0 += macroblock.PMV_##r##_##s##_0;  \
	    macroblock.vector_##r##_##s##_0 = macroblock.vector_##r##_##s##_0 \
		<< video->f_code_##s##_0_range >> video->f_code_##s##_0_range;\
	    macroblock.PMV_##r##_##s##_0 = macroblock.vector_##r##_##s##_0;   \
	}								      \
	motion_code();							      \
	if (code & 1024) {						      \
	    cache_size--;						      \
	    macroblock.vector_##r##_##s##_1 = macroblock.PMV_##r##_##s##_1;   \
	} else {							      \
	    motion_component(r, s, 1);					      \
	    macroblock.vector_##r##_##s##_1 += macroblock.PMV_##r##_##s##_1;  \
	    macroblock.vector_##r##_##s##_1 = macroblock.vector_##r##_##s##_1 \
		<< video->f_code_##s##_1_range >> video->f_code_##s##_1_range;\
	    macroblock.PMV_##r##_##s##_1 = macroblock.vector_##r##_##s##_1;   \
	}								      \
    }

#define motion_vector_5(r, s) \
    {									      \
	unsigned code;							      \
									      \
	motion_code();							      \
	if (code & 1024) {						      \
	    cache_size--;						      \
	    macroblock.vector_##r##_##s##_0 = macroblock.PMV_##r##_##s##_0;   \
	} else {							      \
	    motion_component(r, s, 0);					      \
	    macroblock.vector_##r##_##s##_0 += macroblock.PMV_##r##_##s##_0;  \
	    macroblock.vector_##r##_##s##_0 = macroblock.vector_##r##_##s##_0 \
		<< video->f_code_##s##_0_range >> video->f_code_##s##_0_range;\
	    macroblock.PMV_##r##_##s##_0 = macroblock.vector_##r##_##s##_0;   \
	}								      \
	motion_code();							      \
	if (code & 1024) {						      \
	    cache_size--;						      \
	    macroblock.vector_##r##_##s##_1 = macroblock.PMV_##r##_##s##_1;   \
	} else {							      \
	    motion_component(r, s, 1);					      \
	    macroblock.vector_##r##_##s##_1 += macroblock.PMV_##r##_##s##_1;  \
	    macroblock.vector_##r##_##s##_1 = macroblock.vector_##r##_##s##_1 \
		<< video->f_code_##s##_1_range >> video->f_code_##s##_1_range;\
	    macroblock.PMV_##r##_##s##_1 = macroblock.vector_##r##_##s##_1;   \
	}								      \
    }

#define motion_vertical_field_select(r, s) \
    {									      \
	if (!cache_size) {						      \
	    OPTIMISTIQUE_MOI_X(2);					      \
	    cache_buffer = *buffer << 8 | buffer[1];			      \
	    buffer += 2;						      \
	    cache_size = 16;						      \
	    size -= 2;							      \
	}								      \
	cache_size--;							      \
	macroblock.motion_vertical_field_select_##r##_##s		      \
	    = cache_buffer >> cache_size & 1;				      \
    }

#define subsequent_motion_vector(r, s) \
    {									      \
	unsigned code;							      \
									      \
	motion_code();							      \
	if (code & 1024) {						      \
	    cache_size--;						      \
	    macroblock.vector_##r##_##s##_0 = macroblock.PMV_##r##_##s##_0;   \
	} else {							      \
	    motion_component(r, s, 0);					      \
	    macroblock.vector_##r##_##s##_0 += macroblock.PMV_##r##_##s##_0;  \
	    macroblock.vector_##r##_##s##_0 = macroblock.vector_##r##_##s##_0 \
		<< video->f_code_##s##_0_range >> video->f_code_##s##_0_range;\
	    macroblock.PMV_##r##_##s##_0 = macroblock.vector_##r##_##s##_0;   \
	}								      \
	motion_code();							      \
	if (code & 1024) {						      \
	    cache_size--;						      \
	    macroblock.vector_##r##_##s##_1 = macroblock.PMV_##r##_##s##_1;   \
	} else {							      \
	    motion_component(r, s, 1);					      \
	    macroblock.vector_##r##_##s##_1 += macroblock.PMV_##r##_##s##_1;  \
	    macroblock.vector_##r##_##s##_1 = macroblock.vector_##r##_##s##_1 \
		<< video->f_code_##s##_1_range >> video->f_code_##s##_1_range;\
	    macroblock.PMV_##r##_##s##_1 = macroblock.vector_##r##_##s##_1;   \
	}								      \
    }

#define subsequent_motion_vector_0(r, s) \
    {									      \
	unsigned code;							      \
									      \
	motion_code();							      \
	if (code & 1024) {						      \
	    cache_size--;						      \
	    macroblock.vector_##r##_##s##_0 = macroblock.PMV_##r##_##s##_0;   \
	} else {							      \
	    motion_component(r, s, 0);					      \
	    macroblock.vector_##r##_##s##_0 += macroblock.PMV_##r##_##s##_0;  \
	    macroblock.vector_##r##_##s##_0 = macroblock.vector_##r##_##s##_0 \
		<< video->f_code_##s##_0_range >> video->f_code_##s##_0_range;\
	    macroblock.PMV_##r##_##s##_0 = macroblock.vector_##r##_##s##_0;   \
	}								      \
	motion_code();							      \
	if (code & 1024) {						      \
	    cache_size--;						      \
	    macroblock.vector_##r##_##s##_1 = macroblock.PMV_##r##_##s##_1;   \
	    macroblock.PMV_##r##_##s##_1 &= ~1;				      \
	    macroblock.vector_##r##_##s##_1 >>= 1;			      \
	} else {							      \
	    motion_component(r, s, 1);					      \
	    macroblock.vector_##r##_##s##_1 +=				      \
		macroblock.PMV_##r##_##s##_1 >> 1;			      \
	    macroblock.vector_##r##_##s##_1 = macroblock.vector_##r##_##s##_1 \
		<< video->f_code_##s##_1_range >> video->f_code_##s##_1_range;\
	    macroblock.PMV_##r##_##s##_1 =				      \
		macroblock.vector_##r##_##s##_1 << 1;			      \
	}								      \
    }

#define subsequent_motion_vector_1(r, s) \
    {									      \
	unsigned code;							      \
									      \
	motion_code();							      \
	if (code & 1024) {						      \
	    cache_size--;						      \
	    macroblock.vector_##r##_##s##_0 = macroblock.PMV_##r##_##s##_0;   \
	} else {							      \
	    motion_component(r, s, 0);					      \
	    macroblock.vector_##r##_##s##_0 += macroblock.PMV_##r##_##s##_0;  \
	    macroblock.vector_##r##_##s##_0 = macroblock.vector_##r##_##s##_0 \
		<< video->f_code_##s##_0_range >> video->f_code_##s##_0_range;\
	    macroblock.PMV_##r##_##s##_0 = macroblock.vector_##r##_##s##_0;   \
	}								      \
	motion_code();							      \
	if (code & 1024) {						      \
	    cache_size--;						      \
	    macroblock.vector_##r##_##s##_1 = macroblock.PMV_##r##_##s##_1;   \
	    macroblock.PMV_##r##_##s##_1 &= ~1;				      \
	    macroblock.vector_##r##_##s##_1 >>= 1;			      \
	} else {							      \
	    motion_component(r, s, 1);					      \
	    macroblock.vector_##r##_##s##_1 +=				      \
		macroblock.PMV_##r##_##s##_1 >> 1;			      \
	    macroblock.vector_##r##_##s##_1 = macroblock.vector_##r##_##s##_1 \
		<< video->f_code_##s##_1_range >> video->f_code_##s##_1_range;\
	    macroblock.PMV_##r##_##s##_1 =				      \
		macroblock.vector_##r##_##s##_1 << 1;			      \
	}								      \
    }

#define subsequent_motion_vector_2(r, s) \
    {									      \
	unsigned code;							      \
									      \
	motion_code();							      \
	if (code & 1024) {						      \
	    cache_size--;						      \
	    macroblock.vector_##r##_##s##_0 = macroblock.PMV_##r##_##s##_0;   \
	} else {							      \
	    motion_component(r, s, 0);					      \
	    macroblock.vector_##r##_##s##_0 += macroblock.PMV_##r##_##s##_0;  \
	    macroblock.vector_##r##_##s##_0 = macroblock.vector_##r##_##s##_0 \
		<< video->f_code_##s##_0_range >> video->f_code_##s##_0_range;\
	    macroblock.PMV_##r##_##s##_0 = macroblock.vector_##r##_##s##_0;   \
	}								      \
	motion_code();							      \
	if (code & 1024) {						      \
	    cache_size--;						      \
	    macroblock.vector_##r##_##s##_1 = macroblock.PMV_##r##_##s##_1;   \
	} else {							      \
	    motion_component(r, s, 1);					      \
	    macroblock.vector_##r##_##s##_1 += macroblock.PMV_##r##_##s##_1;  \
	    macroblock.vector_##r##_##s##_1 = macroblock.vector_##r##_##s##_1 \
		<< video->f_code_##s##_1_range >> video->f_code_##s##_1_range;\
	    macroblock.PMV_##r##_##s##_1 = macroblock.vector_##r##_##s##_1;   \
	}								      \
    }

#define subsequent_motion_vector_3(r, s) \
    {									      \
	unsigned code;							      \
									      \
	motion_code();							      \
	if (code & 1024) {						      \
	    cache_size--;						      \
	    macroblock.vector_##r##_##s##_0 = macroblock.PMV_##r##_##s##_0;   \
	} else {							      \
	    motion_component(r, s, 0);					      \
	    macroblock.vector_##r##_##s##_0 += macroblock.PMV_##r##_##s##_0;  \
	    macroblock.vector_##r##_##s##_0 = macroblock.vector_##r##_##s##_0 \
		<< video->f_code_##s##_0_range >> video->f_code_##s##_0_range;\
	    macroblock.PMV_##r##_##s##_0 = macroblock.vector_##r##_##s##_0;   \
	}								      \
	motion_code();							      \
	if (code & 1024) {						      \
	    cache_size--;						      \
	    macroblock.vector_##r##_##s##_1 = macroblock.PMV_##r##_##s##_1;   \
	} else {							      \
	    motion_component(r, s, 1);					      \
	    macroblock.vector_##r##_##s##_1 += macroblock.PMV_##r##_##s##_1;  \
	    macroblock.vector_##r##_##s##_1 = macroblock.vector_##r##_##s##_1 \
		<< video->f_code_##s##_1_range >> video->f_code_##s##_1_range;\
	    macroblock.PMV_##r##_##s##_1 = macroblock.vector_##r##_##s##_1;   \
	}								      \
    }

#define subsequent_motion_vector_4(r, s) \
    {									      \
	unsigned code;							      \
									      \
	motion_code();							      \
	if (code & 1024) {						      \
	    cache_size--;						      \
	    macroblock.vector_##r##_##s##_0 = macroblock.PMV_##r##_##s##_0;   \
	} else {							      \
	    motion_component(r, s, 0);					      \
	    macroblock.vector_##r##_##s##_0 += macroblock.PMV_##r##_##s##_0;  \
	    macroblock.vector_##r##_##s##_0 = macroblock.vector_##r##_##s##_0 \
		<< video->f_code_##s##_0_range >> video->f_code_##s##_0_range;\
	    macroblock.PMV_##r##_##s##_0 = macroblock.vector_##r##_##s##_0;   \
	}								      \
	motion_code();							      \
	if (code & 1024) {						      \
	    cache_size--;						      \
	    macroblock.vector_##r##_##s##_1 = macroblock.PMV_##r##_##s##_1;   \
	} else {							      \
	    motion_component(r, s, 1);					      \
	    macroblock.vector_##r##_##s##_1 += macroblock.PMV_##r##_##s##_1;  \
	    macroblock.vector_##r##_##s##_1 = macroblock.vector_##r##_##s##_1 \
		<< video->f_code_##s##_1_range >> video->f_code_##s##_1_range;\
	    macroblock.PMV_##r##_##s##_1 = macroblock.vector_##r##_##s##_1;   \
	}								      \
    }

#define subsequent_motion_vector_5(r, s) \
    {									      \
	unsigned code;							      \
									      \
	motion_code();							      \
	if (code & 1024) {						      \
	    cache_size--;						      \
	    macroblock.vector_##r##_##s##_0 = macroblock.PMV_##r##_##s##_0;   \
	} else {							      \
	    motion_component(r, s, 0);					      \
	    macroblock.vector_##r##_##s##_0 += macroblock.PMV_##r##_##s##_0;  \
	    macroblock.vector_##r##_##s##_0 = macroblock.vector_##r##_##s##_0 \
		<< video->f_code_##s##_0_range >> video->f_code_##s##_0_range;\
	    macroblock.PMV_##r##_##s##_0 = macroblock.vector_##r##_##s##_0;   \
	}								      \
	motion_code();							      \
	if (code & 1024) {						      \
	    cache_size--;						      \
	    macroblock.vector_##r##_##s##_1 = macroblock.PMV_##r##_##s##_1;   \
	} else {							      \
	    motion_component(r, s, 1);					      \
	    macroblock.vector_##r##_##s##_1 += macroblock.PMV_##r##_##s##_1;  \
	    macroblock.vector_##r##_##s##_1 = macroblock.vector_##r##_##s##_1 \
		<< video->f_code_##s##_1_range >> video->f_code_##s##_1_range;\
	    macroblock.PMV_##r##_##s##_1 = macroblock.vector_##r##_##s##_1;   \
	}								      \
    }

#endif				/* __SEEK_H262_4_D4_H__ */
