/*
 * h262.5.d4.h
 * Copyright (C) 2004, 2005, 2006, 2007, 2008  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __SEEK_H262_5_D4_H__
#define __SEEK_H262_5_D4_H__

#include <h262.0.h>
#include <h262.5.h>

#define End_of_Block_test_e(run) \
    ((run) == (End_of_Block | End_of_Block << 8 | 2 << 16))
#define End_of_Block_size_e(run) \
    2

#define End_of_Block_test_l(run) \
    (((run) & 255) == End_of_Block)
#define End_of_Block_size_l(run) \
    ((run) >> 16)

#define DECODE_13818_B__BLOCK(table_0, table_1) \
    {									      \
	unsigned i = 0;							      \
									      \
	RESET_SIXTY_THREE(coefficients);				      \
	while (1) {							      \
	    int v, sign;						      \
	    unsigned run;						      \
									      \
	    DECODE_13818_B__COEFFICIENT((table_0), (table_1), l);	      \
	    if (63 < i) {						      \
		ABORT_DECODING(video, buffer, size, VIDEO_INVALID_CODE);      \
	    }								      \
	    run = inverse_scan[i];					      \
	    v = v * (run >> 8 & 255) * quantiser_scale >> 5;		      \
	    if (2047 - sign < v) {					      \
		v = 2047 - sign;					      \
	    }								      \
	    v = (v ^ sign) - sign;					      \
	    sum ^= v;							      \
	    coefficients[run & 255] = v;				      \
	}								      \
	if (sum & 1) {							      \
	} else {							      \
	    coefficients[63] ^= 1;					      \
	}								      \
    }

#if __ENABLE_BLOCK_META_DATA__
# undef DECODE_13818_B__BLOCK

# define DECODE_13818_B__BLOCK(table_0, table_1) \
    {									      \
	unsigned i = 0, meta_block;					      \
									      \
	RESET_SIXTY_THREE(coefficients);				      \
	meta_block = inverse_scan[0];					      \
	while (1) {							      \
	    int v, sign;						      \
	    unsigned run;						      \
									      \
	    DECODE_13818_B__COEFFICIENT((table_0), (table_1), l);	      \
	    if (63 < i) {						      \
		ABORT_DECODING(video, buffer, size, VIDEO_INVALID_CODE);      \
	    }								      \
	    run = inverse_scan[i];					      \
	    meta_block |= run;						      \
	    v = v * (run >> 8 & 255) * quantiser_scale >> 5;		      \
	    if (2047 - sign < v) {					      \
		v = 2047 - sign;					      \
	    }								      \
	    v = (v ^ sign) - sign;					      \
	    sum ^= v;							      \
	    coefficients[run & 255] = v;				      \
	}								      \
	if (sum & 1) {							      \
	} else {							      \
	    coefficients[63] ^= 1;					      \
	    meta_block |= inverse_scan[63];				      \
	}								      \
	coefficients[-1] = meta_block >> 16;				      \
    }
#endif				/* __ENABLE_BLOCK_META_DATA__ */

#define DECODE_13818_B__COEFFICIENT(table_0, table_1, type) \
    {									      \
	if (cache_size < 16) {						      \
	    cache_buffer = cache_buffer << 16 | *buffer << 8 | buffer[1];     \
	    buffer += 2;						      \
	    cache_size += 16;						      \
	    size -= 2;							      \
	}								      \
	run = cache_buffer >> (cache_size - 10) & 1023;			      \
	if (run & ~7) {							      \
	    run = ((unsigned *) (table_1))[run];			      \
	    if (run & 192) {						      \
		if (End_of_Block_test_##type(run)) {			      \
		    cache_size -= End_of_Block_size_##type(run);	      \
		    break;						      \
		} else {						      \
		    if (cache_size < 24) {				      \
			cache_buffer = cache_buffer << 8 | *buffer++;	      \
			cache_size += 8;				      \
			size--;						      \
		    }							      \
		    cache_size -= 24;					      \
		    v = cache_buffer >> cache_size & 262143;		      \
		    i += (v >> 12) + 1;					      \
		    v &= 4095;						      \
		    if (!v) {						      \
			sign = 0;					      \
			ABORT_DECODING					      \
			    (video, buffer, size, VIDEO_INVALID_ESCAPE_CODE); \
		    } else if (2047 < v) {				      \
			v = 4096 - v;					      \
			sign = -1;					      \
		    } else {						      \
			sign = 0;					      \
		    }							      \
		    v <<= 1;						      \
		}							      \
	    } else {							      \
		cache_size -= run >> 16;				      \
		v = (run >> 8) & 255;					      \
		i += run & 255;						      \
		sign = -(int) (cache_buffer >> cache_size & 1);		      \
	    }								      \
	} else {							      \
	    if (cache_size < 17) {					      \
		cache_buffer = cache_buffer << 8 | *buffer++;		      \
		cache_size += 8;					      \
		size--;							      \
	    }								      \
	    run = ((unsigned *) (table_0))				      \
		[cache_buffer >> (cache_size - 16) & 65535];		      \
	    cache_size -= run >> 16;					      \
	    v = (run >> 8) & 255;					      \
	    i += run & 255;						      \
	    sign = -(int) (cache_buffer >> cache_size & 1);		      \
	}								      \
    }

#define DECODE_13818_Be_BLOCK() \
    {									      \
	int sum;							      \
	unsigned i;							      \
									      \
	if (cache_size < 2) {						      \
	    cache_buffer = cache_buffer << 8 | *buffer++;		      \
	    cache_size += 8;						      \
	    size--;							      \
	}								      \
	i = (cache_buffer >> (cache_size - 1) & 1) - 1;			      \
	if (i) {							      \
	    RESET_ONE(coefficients);					      \
	    sum = 0;							      \
	} else {							      \
	    unsigned sign;						      \
									      \
	    cache_size -= 2;						      \
	    sign = -(int) (cache_buffer >> cache_size & 1);		      \
	    sum = 3 * (*inverse_scan >> 8 & 255) * quantiser_scale >> 5;      \
	    if (2047 - sign < sum) {					      \
		sum = 2047 - sign;					      \
	    }								      \
	    sum = (sum ^ sign) - sign;					      \
	    *coefficients = sum;					      \
	}								      \
	RESET_SIXTY_THREE(coefficients);				      \
	while (1) {							      \
	    int sign, v;						      \
	    unsigned run;						      \
									      \
	    DECODE_13818_Be_COEFFICIENT();				      \
	    if (63 < i) {						      \
		ABORT_DECODING(video, buffer, size, VIDEO_INVALID_CODE);      \
	    }								      \
	    run = inverse_scan[i];					      \
	    v = (v + 1) * (run >> 8 & 255) * quantiser_scale >> 5;	      \
	    if (2047 - sign < v) {					      \
		v = 2047 - sign;					      \
	    }								      \
	    v = (v ^ sign) - sign;					      \
	    sum ^= v;							      \
	    coefficients[run & 255] = v;				      \
	}								      \
	if (sum & 1) {							      \
	    if (i) {							      \
		pattern_code &= ~chroma_format;				      \
	    }								      \
	} else {							      \
	    coefficients[63] ^= 1;					      \
	    pattern_code &= ~chroma_format;				      \
	}								      \
    }

#if __ENABLE_BLOCK_META_DATA__
# undef DECODE_13818_Be_BLOCK

# define DECODE_13818_Be_BLOCK() \
    {									      \
	int sum;							      \
	unsigned i, meta_block;						      \
									      \
	if (cache_size < 2) {						      \
	    cache_buffer = cache_buffer << 8 | *buffer++;		      \
	    cache_size += 8;						      \
	    size--;							      \
	}								      \
	i = (cache_buffer >> (cache_size - 1) & 1) - 1;			      \
	if (i) {							      \
	    RESET_ONE(coefficients);					      \
	    meta_block = 0;						      \
	    sum = 0;							      \
	} else {							      \
	    unsigned sign;						      \
									      \
	    cache_size -= 2;						      \
	    sign = -(int) (cache_buffer >> cache_size & 1);		      \
	    meta_block = *inverse_scan;					      \
	    sum = 3 * (*inverse_scan >> 8 & 255) * quantiser_scale >> 5;      \
	    if (2047 - sign < sum) {					      \
		sum = 2047 - sign;					      \
	    }								      \
	    sum = (sum ^ sign) - sign;					      \
	    *coefficients = sum;					      \
	}								      \
	RESET_SIXTY_THREE(coefficients);				      \
	while (1) {							      \
	    int sign, v;						      \
	    unsigned run;						      \
									      \
	    DECODE_13818_Be_COEFFICIENT();				      \
	    if (63 < i) {						      \
		ABORT_DECODING(video, buffer, size, VIDEO_INVALID_CODE);      \
	    }								      \
	    run = inverse_scan[i];					      \
	    meta_block |= run;						      \
	    v = (v + 1) * (run >> 8 & 255) * quantiser_scale >> 5;	      \
	    if (2047 - sign < v) {					      \
		v = 2047 - sign;					      \
	    }								      \
	    v = (v ^ sign) - sign;					      \
	    sum ^= v;							      \
	    coefficients[run & 255] = v;				      \
	}								      \
	if (sum & 1) {							      \
	    if (i) {							      \
		pattern_code &= ~chroma_format;				      \
	    }								      \
	} else {							      \
	    coefficients[63] ^= 1;					      \
	    pattern_code &= ~chroma_format;				      \
	    meta_block |= inverse_scan[63];				      \
	}								      \
	coefficients[-1] = meta_block >> 16;				      \
    }
#endif				/* __ENABLE_BLOCK_META_DATA__ */

#define DECODE_13818_Be_COEFFICIENT() \
    DECODE_13818_B__COEFFICIENT(_seek_h262_B_e_012_0, _seek_h262_B_e_012_1, e)

#define DETACH_13818_B__BLOCK(table_0, table_1) \
    {									      \
	unsigned i = 64;						      \
									      \
	for (; i; i--) {						      \
	    DETACH_13818_B__COEFFICIENT((table_0), (table_1));		      \
	}								      \
	if (!i) {							      \
	    ABORT_DECODING(video, buffer, size, VIDEO_INVALID_CODE);	      \
	}								      \
    }

#define DETACH_13818_B__COEFFICIENT(table_0, table_1) \
    {									      \
	unsigned run;							      \
									      \
	if (cache_size < 16) {						      \
	    cache_buffer = cache_buffer << 16 | *buffer << 8 | buffer[1];     \
	    buffer += 2;						      \
	    cache_size += 16;						      \
	    size -= 2;							      \
	}								      \
	run = cache_buffer >> (cache_size - 10) & 1023;			      \
	if (run & ~7) {							      \
	    run = ((unsigned *) (table_1))[run];			      \
	    cache_size -= run >> 16;					      \
	    if (run & 192) {						      \
		if ((run & 255) == End_of_Block) {			      \
		    break;						      \
		} else {						      \
		    if (cache_size < 24) {				      \
			cache_buffer = cache_buffer << 8 | *buffer++;	      \
			cache_size += 8;				      \
			size--;						      \
		    }							      \
		    cache_size -= 18;					      \
		    if (!(cache_buffer >> cache_size & 4095)) {		      \
			ABORT_DECODING					      \
			    (video, buffer, size, VIDEO_INVALID_ESCAPE_CODE); \
		    }							      \
		}							      \
	    }								      \
	} else {							      \
	    if (cache_size < 17) {					      \
		cache_buffer = cache_buffer << 8 | *buffer++;		      \
		cache_size += 8;					      \
		size--;							      \
	    }								      \
	    run = cache_buffer >> (cache_size - 16) & 65535;		      \
	    if (run < 16) {						      \
		ABORT_DECODING(video, buffer, size, VIDEO_INVALID_CODE);      \
	    }								      \
	    cache_size -= ((unsigned *) (table_0))[run] >> 16;		      \
	}								      \
    }

#if 0
# undef DETACH_13818_B__COEFFICIENT

# define DETACH_13818_B__COEFFICIENT(table_0, table_1) \
    {									      \
	unsigned run;							      \
									      \
	if (cache_size < 16) {						      \
	    cache_buffer = cache_buffer << 16 | *buffer << 8 | buffer[1];     \
	    buffer += 2;						      \
	    cache_size += 16;						      \
	    size -= 2;							      \
	}								      \
	run = cache_buffer >> (cache_size - 10) & 1023;			      \
	if (run & ~7) {							      \
	    run = ((unsigned *) (table_1))[run];			      \
	    cache_size -= run >> 16;					      \
	    if (run & 192) {						      \
		if ((run & 255) == End_of_Block) {			      \
		    break;						      \
		} else {						      \
		    if (cache_size < 18) {				      \
			cache_buffer = cache_buffer << 8 | *buffer++;	      \
			cache_size += 8;				      \
			size--;						      \
		    }							      \
		    cache_size -= 18;					      \
		    if (!(cache_buffer >> cache_size & 4095)) {		      \
			ABORT_DECODING					      \
			    (video, buffer, size, VIDEO_SLICE_FAULT);	      \
		    }							      \
		}							      \
	    }								      \
	} else {							      \
	    run = cache_buffer >> (cache_size - 16) & 65535;		      \
	    if (run < 16) {						      \
		ABORT_DECODING(video, buffer, size, VIDEO_INVALID_CODE);      \
	    }								      \
	    cache_size -= ((unsigned *) (table_0))[run] >> 16;		      \
	    if ((int) cache_size == -1) {				      \
		cache_buffer = *buffer << 16 | buffer[1] << 8 | buffer[2];    \
		buffer += 3;						      \
		cache_size = 23;					      \
		size -= 3;						      \
	    }								      \
	}								      \
    }
#endif				/* 0 */

#define DETACH_13818_Be_BLOCK() \
    {									      \
	unsigned i = 65;						      \
									      \
	if (cache_size < 2) {						      \
	    cache_buffer = cache_buffer << 8 | *buffer++;		      \
	    cache_size += 8;						      \
	    size--;							      \
	}								      \
	if (cache_buffer >> (cache_size - 2) & 2) {			      \
	    cache_size -= 2;						      \
	    i--;							      \
	}								      \
	for (; i; i--) {						      \
	    DETACH_13818_Be_COEFFICIENT();				      \
	}								      \
	if (!i) {							      \
	    ABORT_DECODING(video, buffer, size, VIDEO_INVALID_CODE);	      \
	}								      \
    }

#define DETACH_13818_Be_COEFFICIENT() \
    DETACH_13818_B__COEFFICIENT(_seek_h262_B_e_012_0, _seek_h262_B_e_012_1)

#undef DETACH_13818_Be_COEFFICIENT

#define DETACH_13818_Be_COEFFICIENT() \
    {									      \
	unsigned run;							      \
									      \
	if (cache_size < 17) {						      \
	    cache_buffer = cache_buffer << 16 | *buffer << 8 | buffer[1];     \
	    buffer += 2;						      \
	    cache_size += 16;						      \
	    size -= 2;							      \
	}								      \
	run = cache_buffer >> (cache_size - 6) & 63;			      \
	if ((run & 48) == 32) {						      \
	    cache_size -= 2;						      \
	    break;							      \
	} else {							      \
	    switch (run) {						      \
	    case 0:							      \
		if (cache_size < 17) {					      \
		    cache_buffer = cache_buffer << 8 | *buffer++;	      \
		    cache_size += 8;					      \
		    size--;						      \
		}							      \
		run = cache_buffer >> (cache_size - 16) & 1023;		      \
		if (run < 16) {						      \
		    ABORT_DECODING(video, buffer, size, VIDEO_INVALID_CODE);  \
		}							      \
		cache_size -= _seek_h262_B_e_code_size_1[run >> 5];	      \
		break;							      \
	    case 1:							      \
		cache_size -= 6;					      \
		if (cache_size < 17) {					      \
		    cache_buffer =					      \
			cache_buffer << 16 | *buffer << 8 | buffer[1];	      \
		    buffer += 2;					      \
		    cache_size += 16;					      \
		    size -= 2;						      \
		} else if (cache_size < 25) {				      \
		    cache_buffer = cache_buffer << 8 | *buffer++;	      \
		    cache_size += 8;					      \
		    size--;						      \
		}							      \
		cache_size -= 18;					      \
		if (!(cache_buffer >> cache_size & 4095)) {		      \
		    ABORT_DECODING(video, buffer, size, VIDEO_SLICE_FAULT);   \
		}							      \
		break;							      \
	    default:							      \
		cache_size -= _seek_h262_B_e_code_size_0[run];		      \
	    }								      \
	}								      \
    }

extern unsigned char _seek_h262_B_e_012_0[], _seek_h262_B_e_012_1[];
extern const unsigned char _seek_h262_B_e_code_size_0[],
    _seek_h262_B_e_code_size_1[];

#endif				/* __SEEK_H262_5_D4_H__ */
