/*
 * h262.4.d6.h
 * Copyright (C) 2005, 2006, 2007  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __SEEK_H262_6_D4_H__
#define __SEEK_H262_6_D4_H__

#include <h262.0.h>

#define BLOCK_ALIGNMENT			8

#if BLOCK_ALIGNMENT == 1
#elif BLOCK_ALIGNMENT == 8
#else
# undef BLOCK_ALIGNMENT
# define BLOCK_ALIGNMENT		1
#endif				/* BLOCK_ALIGNMENT == 1 */

#if !__ALIGN_IDCT_BLOCK__
# define __CCC_ALIGN_COEFFICIENTS__	0
#elif !defined ATTRIBUTE_ALIGNED_MAX
# define __CCC_ALIGN_COEFFICIENTS__	0
#elif BLOCK_ALIGNMENT == 1
# define __CCC_ALIGN_COEFFICIENTS__	0
#elif ATTRIBUTE_ALIGNED_MAX < BLOCK_ALIGNMENT
# define __CCC_ALIGN_COEFFICIENTS__	0
#else
# define __CCC_ALIGN_COEFFICIENTS__	1
#endif				/* !__ALIGN_IDCT_BLOCK__ */

#if __CCC_ALIGN_COEFFICIENTS__
# define __FIX_ALIGN_COEFFICIENTS__	0
#elif !__ALIGN_IDCT_BLOCK__
# define __FIX_ALIGN_COEFFICIENTS__	0
#elif BLOCK_ALIGNMENT == 1
# define __FIX_ALIGN_COEFFICIENTS__	0
#else
# define __FIX_ALIGN_COEFFICIENTS__	1
#endif				/* __CCC_ALIGN_COEFFICIENTS__ */

#if !__ENABLE_BLOCK_META_DATA__
# if 1
#  define _1ST_BLOCK_OFFSET		00000
#  define _2ND_BLOCK_OFFSET		00100
#  define _3RD_BLOCK_OFFSET		00200
#  define _4TH_BLOCK_OFFSET		00300
#  define _5TH_BLOCK_OFFSET		00400
#  define _6TH_BLOCK_OFFSET		00500
#  define _7TH_BLOCK_OFFSET		00600
#  define _8TH_BLOCK_OFFSET		00700
#  define _9TH_BLOCK_OFFSET		01000
#  define _aTH_BLOCK_OFFSET		01100
#  define _bTH_BLOCK_OFFSET		01200
#  define _cTH_BLOCK_OFFSET		01300

#  define BLOCK_SIZE			00100

#  define BLOCK_SIZEx006		00600
#  define BLOCK_SIZEx014		01400
# endif				/* 1 */
#elif !__SHORT_ENDED_ARITHMETIC__
# if BLOCK_ALIGNMENT == 1
#  define _1ST_BLOCK_OFFSET		00001
#  define _2ND_BLOCK_OFFSET		00102
#  define _3RD_BLOCK_OFFSET		00203
#  define _4TH_BLOCK_OFFSET		00304
#  define _5TH_BLOCK_OFFSET		00405
#  define _6TH_BLOCK_OFFSET		00506
#  define _7TH_BLOCK_OFFSET		00607
#  define _8TH_BLOCK_OFFSET		00710
#  define _9TH_BLOCK_OFFSET		01011
#  define _aTH_BLOCK_OFFSET		01112
#  define _bTH_BLOCK_OFFSET		01213
#  define _cTH_BLOCK_OFFSET		01314

#  define BLOCK_SIZE			00101

#  define BLOCK_SIZEx006		00606
#  define BLOCK_SIZEx014		01414
# else
#  define _1ST_BLOCK_OFFSET		00002
#  define _2ND_BLOCK_OFFSET		00104
#  define _3RD_BLOCK_OFFSET		00206
#  define _4TH_BLOCK_OFFSET		00310
#  define _5TH_BLOCK_OFFSET		00412
#  define _6TH_BLOCK_OFFSET		00514
#  define _7TH_BLOCK_OFFSET		00616
#  define _8TH_BLOCK_OFFSET		00720
#  define _9TH_BLOCK_OFFSET		01022
#  define _aTH_BLOCK_OFFSET		01124
#  define _bTH_BLOCK_OFFSET		01226
#  define _cTH_BLOCK_OFFSET		01330

#  define BLOCK_SIZE			00102

#  define BLOCK_SIZEx006		00614
#  define BLOCK_SIZEx014		01430
# endif				/* BLOCK_ALIGNMENT == 1 */
#else
# if BLOCK_ALIGNMENT == 1
#  define _1ST_BLOCK_OFFSET		00002
#  define _2ND_BLOCK_OFFSET		00104
#  define _3RD_BLOCK_OFFSET		00206
#  define _4TH_BLOCK_OFFSET		00310
#  define _5TH_BLOCK_OFFSET		00412
#  define _6TH_BLOCK_OFFSET		00514
#  define _7TH_BLOCK_OFFSET		00616
#  define _8TH_BLOCK_OFFSET		00720
#  define _9TH_BLOCK_OFFSET		01022
#  define _aTH_BLOCK_OFFSET		01124
#  define _bTH_BLOCK_OFFSET		01226
#  define _cTH_BLOCK_OFFSET		01330

#  define BLOCK_SIZE			00102

#  define BLOCK_SIZEx006		00614
#  define BLOCK_SIZEx014		01430
# else
#  define _1ST_BLOCK_OFFSET		00004
#  define _2ND_BLOCK_OFFSET		00110
#  define _3RD_BLOCK_OFFSET		00214
#  define _4TH_BLOCK_OFFSET		00320
#  define _5TH_BLOCK_OFFSET		00424
#  define _6TH_BLOCK_OFFSET		00530
#  define _7TH_BLOCK_OFFSET		00634
#  define _8TH_BLOCK_OFFSET		00740
#  define _9TH_BLOCK_OFFSET		01044
#  define _aTH_BLOCK_OFFSET		01150
#  define _bTH_BLOCK_OFFSET		01254
#  define _cTH_BLOCK_OFFSET		01360

#  define BLOCK_SIZE			00104

#  define BLOCK_SIZEx006		00630
#  define BLOCK_SIZEx014		01460
# endif				/* BLOCK_ALIGNMENT == 1 */
#endif				/* !__ENABLE_BLOCK_META_DATA__ */

#if __FIX_ALIGN_COEFFICIENTS__
# if !__SHORT_ENDED_ARITHMETIC__
#  define ALIGNED_BLOCK_SIZEx006	(BLOCK_SIZEx006 + 1)
#  define ALIGNED_BLOCK_SIZEx014	(BLOCK_SIZEx014 + 1)
# else
#  define ALIGNED_BLOCK_SIZEx006	(BLOCK_SIZEx006 + 3)
#  define ALIGNED_BLOCK_SIZEx014	(BLOCK_SIZEx014 + 3)
# endif				/* !__SHORT_ENDED_ARITHMETIC__ */
#endif				/* __FIX_ALIGN_COEFFICIENTS__ */

#endif				/* __SEEK_H262_6_D4_H__ */
