/*
 * h262.6.h
 * Copyright (C) 2003, 2004, 2005  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __SEEK_H262_6_H__
#define __SEEK_H262_6_H__

/*
 * macroblock_type                                                   6  
 * if (macroblock_quant) {                                              
 *     quantiser_scale                                       +       5  
 * }                                                                    
 * if (macroblock_motion_forward) {                                     
 *     motion_horizontal_forward_code                        +      11  
 *     if (forward_f != 1                                               
 *         && motion_horizontal_forward_code) {                         
 *         motion_horizontal_forward_r                       +       6  
 *     }                                                                
 *     motion_vertical_forward_code                          +      11  
 *     if (forward_f != 1                                               
 *         && motion_vertical_forward_code) {                           
 *         motion_vertical_forward_r                         +       6  
 *     }                                                                
 * }                                                                    
 * if (macroblock_motion_backward) {                                    
 *     motion_horizontal_backward_code                       +      11  
 *     if (backward_f != 1                                              
 *         && motion_horizontal_backward_code) {                        
 *         motion_horizontal_backward_r                      +       6  
 *     }                                                                
 *     motion_vertical_backward_code                         +      11  
 *     if (backward_f != 1                                              
 *         && motion_vertical_backward_code) {                          
 *         motion_vertical_backward_r                        +       6  
 *     }                                                                
 * }                                                                    
 * if (macroblock_pattern) {                                            
 *     coded_block_pattern                                   +       9  
 * }                                                                    
 * dct_coeff_next                                            + 64 * 28  
 * end_of_block                                              +       2  
 * dct_coeff_next                                            + 64 * 28  
 * end_of_block                                              +       2  
 * dct_coeff_next                                            + 64 * 28  
 * end_of_block                                              +       2  
 * dct_coeff_next                                            + 64 * 28  
 * end_of_block                                              +       2  
 * dct_coeff_next                                            + 64 * 28  
 * end_of_block                                              +       2  
 * dct_coeff_next                                            + 64 * 28  
 * end_of_block                                              +       2  
 * '000 0000 0000 0000 0000 0000'                            +      23  
 */
#define bidirectionally_predictive_coded_MACROBLOCK_SIZE \
					(025173 + 7)

/*
 * macroblock_type                                                   1  
 * dct_dc_size_luminance                                     +       7  
 * if (dct_dc_size_luminance != 0) {                                    
 *     dct_dc_differential                                   +       8  
 * }                                                                    
 * dct_dc_size_luminance                                     +       7  
 * if (dct_dc_size_luminance != 0) {                                    
 *     dct_dc_differential                                   +       8  
 * }                                                                    
 * dct_dc_size_luminance                                     +       7  
 * if (dct_dc_size_luminance != 0) {                                    
 *     dct_dc_differential                                   +       8  
 * }                                                                    
 * dct_dc_size_luminance                                     +       7  
 * if (dct_dc_size_luminance != 0) {                                    
 *     dct_dc_differential                                   +       8  
 * }                                                                    
 * dct_dc_size_chrominance                                   +       8  
 * if (dct_dc_size_chrominance != 0) {                                  
 *     dct_dc_differential                                   +       8  
 * }                                                                    
 * dct_dc_size_chrominance                                   +       8  
 * if (dct_dc_size_chrominance != 0) {                                  
 *     dct_dc_differential                                   +       8  
 * }                                                                    
 * end_of_macroblock                                         +       1  
 * '000 0000 0000 0000 0000 0000'                            +      23  
 */
#define dc_intra_coded_MACROBLOCK_SIZE	(000165 + 7)

/*
 * macroblock_type                                                   2  
 * if (macroblock_quant) {                                              
 *     quantiser_scale                                       +       5  
 * }                                                                    
 * dct_dc_size_luminance                                     +       7  
 * if (dct_dc_size_luminance != 0) {                                    
 *     dct_dc_differential                                   +       8  
 * }                                                                    
 * dct_coeff_next                                            + 63 * 28  
 * end_of_block                                              +       2  
 * dct_dc_size_luminance                                     +       7  
 * if (dct_dc_size_luminance != 0) {                                    
 *     dct_dc_differential                                   +       8  
 * }                                                                    
 * dct_coeff_next                                            + 63 * 28  
 * end_of_block                                              +       2  
 * dct_dc_size_luminance                                     +       7  
 * if (dct_dc_size_luminance != 0) {                                    
 *     dct_dc_differential                                   +       8  
 * }                                                                    
 * dct_coeff_next                                            + 63 * 28  
 * end_of_block                                              +       2  
 * dct_dc_size_luminance                                     +       7  
 * if (dct_dc_size_luminance != 0) {                                    
 *     dct_dc_differential                                   +       8  
 * }                                                                    
 * dct_coeff_next                                            + 63 * 28  
 * end_of_block                                              +       2  
 * dct_dc_size_chrominance                                   +       8  
 * if (dct_dc_size_chrominance != 0) {                                  
 *     dct_dc_differential                                   +       8  
 * }                                                                    
 * dct_coeff_next                                            + 63 * 28  
 * end_of_block                                              +       2  
 * dct_dc_size_chrominance                                   +       8  
 * if (dct_dc_size_chrominance != 0) {                                  
 *     dct_dc_differential                                   +       8  
 * }                                                                    
 * dct_coeff_next                                            + 63 * 28  
 * end_of_block                                              +       2  
 * '000 0000 0000 0000 0000 0000'                            +      23  
 */
#define intra_coded_MACROBLOCK_SIZE	(024736 + 7)

/*
 * macroblock_type                                                   6  
 * if (macroblock_quant) {                                              
 *     quantiser_scale                                       +       5  
 * }                                                                    
 * if (macroblock_motion_forward) {                                     
 *     motion_horizontal_forward_code                        +      11  
 *     if (forward_f != 1                                               
 *         && motion_horizontal_forward_code) {                         
 *         motion_horizontal_forward_r                       +       6  
 *     }                                                                
 *     motion_vertical_forward_code                          +      11  
 *     if (forward_f != 1                                               
 *         && motion_vertical_forward_code) {                           
 *         motion_vertical_forward_r                         +       6  
 *     }                                                                
 * }                                                                    
 * if (macroblock_pattern) {                                            
 *     coded_block_pattern                                   +       9  
 * }                                                                    
 * dct_coeff_next                                            + 64 * 28  
 * end_of_block                                              +       2  
 * dct_coeff_next                                            + 64 * 28  
 * end_of_block                                              +       2  
 * dct_coeff_next                                            + 64 * 28  
 * end_of_block                                              +       2  
 * dct_coeff_next                                            + 64 * 28  
 * end_of_block                                              +       2  
 * dct_coeff_next                                            + 64 * 28  
 * end_of_block                                              +       2  
 * dct_coeff_next                                            + 64 * 28  
 * end_of_block                                              +       2  
 * '000 0000 0000 0000 0000 0000'                            +      23  
 */
#define predictive_coded_MACROBLOCK_SIZE \
					(025131 + 7)
                                                             
#endif				/* __SEEK_H262_6_H__ */
