/*
 * h262.6.l7.h
 * Copyright (C) 2004, 2005, 2006  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __SEEK_H262_6_L7_H__
#define __SEEK_H262_6_L7_H__

#include <h262.3.d4.h>
#include <h262.8.d4.h>

#define wideblock_0__x_0(predictions, references, stride, line_size, \
			 WIDE_REFERENCE)				      \
    {									      \
	unsigned i = 16;						      \
	unsigned long *prediction4s;					      \
									      \
	prediction4s = (unsigned long *) predictions;			      \
									      \
	for (; i; i--) {						      \
	    WIDE_REFERENCE##_decls;					      \
									      \
	    MAJOR_##WIDE_REFERENCE(references, line_size);		      \
	    WIDE_REFERENCE##_0();					      \
	    MINOR_##WIDE_REFERENCE(references, line_size);		      \
	    WIDE_REFERENCE##_1();					      \
	    *prediction4s = WIDE_REFERENCE##_X();			      \
									      \
	    references += 8;						      \
									      \
	    MAJOR_##WIDE_REFERENCE(references, line_size);		      \
	    WIDE_REFERENCE##_0();					      \
	    MINOR_##WIDE_REFERENCE(references, line_size);		      \
	    WIDE_REFERENCE##_1();					      \
	    prediction4s[1] = WIDE_REFERENCE##_X();			      \
									      \
	    references += stride - 8;					      \
									      \
	    prediction4s = (unsigned long *)				      \
		((unsigned char *) prediction4s + stride);		      \
	}								      \
    }

#define wideblock_0__x_1(predictions, references, stride, line_size, \
			 WIDE_REFERENCE)				      \
    {									      \
	unsigned i = 8;							      \
	unsigned long *prediction4s;					      \
									      \
	prediction4s = (unsigned long *) predictions;			      \
									      \
	for (; i; i--) {						      \
	    WIDE_REFERENCE##_decls;					      \
									      \
	    MAJOR_##WIDE_REFERENCE(references, line_size);		      \
	    WIDE_REFERENCE##_0();					      \
	    MINOR_##WIDE_REFERENCE(references, line_size);		      \
	    WIDE_REFERENCE##_1();					      \
	    *prediction4s = WIDE_REFERENCE##_X();			      \
									      \
	    references += 8;						      \
									      \
	    MAJOR_##WIDE_REFERENCE(references, line_size);		      \
	    WIDE_REFERENCE##_0();					      \
	    MINOR_##WIDE_REFERENCE(references, line_size);		      \
	    WIDE_REFERENCE##_1();					      \
	    prediction4s[1] = WIDE_REFERENCE##_X();			      \
									      \
	    references += stride - 8;					      \
									      \
	    prediction4s = (unsigned long *)				      \
		((unsigned char *) prediction4s + stride);		      \
	}								      \
    }

#define wideblock_0__x_2(predictions, references, stride, line_size, \
			 WIDE_REFERENCE)				      \
    {									      \
	unsigned i = 16;						      \
	unsigned long *prediction4s;					      \
									      \
	prediction4s = (unsigned long *) predictions;			      \
									      \
	for (; i; i--) {						      \
	    WIDE_REFERENCE##_decls;					      \
									      \
	    MAJOR_##WIDE_REFERENCE(references, line_size);		      \
	    WIDE_REFERENCE##_0();					      \
	    MINOR_##WIDE_REFERENCE(references, line_size);		      \
	    WIDE_REFERENCE##_1();					      \
	    *prediction4s = WIDE_REFERENCE##_X();			      \
									      \
	    references += stride;					      \
									      \
	    prediction4s = (unsigned long *)				      \
		((unsigned char *) prediction4s + stride);		      \
	}								      \
    }

#define wideblock_0__x_3(predictions, references, stride, line_size, \
			 WIDE_REFERENCE)				      \
    {									      \
	unsigned i = 8;							      \
	unsigned long *prediction4s;					      \
									      \
	prediction4s = (unsigned long *) predictions;			      \
									      \
	for (; i; i--) {						      \
	    WIDE_REFERENCE##_decls;					      \
									      \
	    MAJOR_##WIDE_REFERENCE(references, line_size);		      \
	    WIDE_REFERENCE##_0();					      \
	    MINOR_##WIDE_REFERENCE(references, line_size);		      \
	    WIDE_REFERENCE##_1();					      \
	    *prediction4s = WIDE_REFERENCE##_X();			      \
									      \
	    references += stride;					      \
									      \
	    prediction4s = (unsigned long *)				      \
		((unsigned char *) prediction4s + stride);		      \
	}								      \
    }

#define wideblock_1__x_0(predictions, references_0, references_1, stride, \
			 line_size, WIDE_REFERENCE)			      \
    {									      \
	unsigned i = 16;						      \
	unsigned long *prediction4s;					      \
									      \
	prediction4s = (unsigned long *) predictions;			      \
									      \
	for (; i; i--) {						      \
	    WIDE_REFERENCE##_decls;					      \
									      \
	    MAJOR_##WIDE_REFERENCE(references_0, references_1, line_size);    \
	    WIDE_REFERENCE##_0();					      \
	    MINOR_##WIDE_REFERENCE(references_0, references_1, line_size);    \
	    WIDE_REFERENCE##_1();					      \
	    *prediction4s = WIDE_REFERENCE##_X();			      \
									      \
	    references_0 += 8;						      \
	    references_1 += 8;						      \
									      \
	    MAJOR_##WIDE_REFERENCE(references_0, references_1, line_size);    \
	    WIDE_REFERENCE##_0();					      \
	    MINOR_##WIDE_REFERENCE(references_0, references_1, line_size);    \
	    WIDE_REFERENCE##_1();					      \
	    prediction4s[1] = WIDE_REFERENCE##_X();			      \
									      \
	    references_0 += stride - 8;					      \
	    references_1 += stride - 8;					      \
									      \
	    prediction4s = (unsigned long *)				      \
		((unsigned char *) prediction4s + stride);		      \
	}								      \
    }

#define wideblock_1__x_1(predictions, references_0, references_1, stride, \
			 line_size, WIDE_REFERENCE)			      \
    {									      \
	unsigned i = 8;							      \
	unsigned long *prediction4s;					      \
									      \
	prediction4s = (unsigned long *) predictions;			      \
									      \
	for (; i; i--) {						      \
	    WIDE_REFERENCE##_decls;					      \
									      \
	    MAJOR_##WIDE_REFERENCE(references_0, references_1, line_size);    \
	    WIDE_REFERENCE##_0();					      \
	    MINOR_##WIDE_REFERENCE(references_0, references_1, line_size);    \
	    WIDE_REFERENCE##_1();					      \
	    *prediction4s = WIDE_REFERENCE##_X();			      \
									      \
	    references_0 += 8;						      \
	    references_1 += 8;						      \
									      \
	    MAJOR_##WIDE_REFERENCE(references_0, references_1, line_size);    \
	    WIDE_REFERENCE##_0();					      \
	    MINOR_##WIDE_REFERENCE(references_0, references_1, line_size);    \
	    WIDE_REFERENCE##_1();					      \
	    prediction4s[1] = WIDE_REFERENCE##_X();			      \
									      \
	    references_0 += stride - 8;					      \
	    references_1 += stride - 8;					      \
									      \
	    prediction4s = (unsigned long *)				      \
		((unsigned char *) prediction4s + stride);		      \
	}								      \
    }

#define wideblock_1__x_2(predictions, references_0, references_1, stride, \
			 line_size, WIDE_REFERENCE)			      \
    {									      \
	unsigned i = 16;						      \
	unsigned long *prediction4s;					      \
									      \
	prediction4s = (unsigned long *) predictions;			      \
									      \
	for (; i; i--) {						      \
	    WIDE_REFERENCE##_decls;					      \
									      \
	    MAJOR_##WIDE_REFERENCE(references_0, references_1, line_size);    \
	    WIDE_REFERENCE##_0();					      \
	    MINOR_##WIDE_REFERENCE(references_0, references_1, line_size);    \
	    WIDE_REFERENCE##_1();					      \
	    *prediction4s = WIDE_REFERENCE##_X();			      \
									      \
	    references_0 += stride;					      \
	    references_1 += stride;					      \
									      \
	    prediction4s = (unsigned long *)				      \
		((unsigned char *) prediction4s + stride);		      \
	}								      \
    }

#define wideblock_1__x_3(predictions, references_0, references_1, stride, \
			 line_size, WIDE_REFERENCE)			      \
    {									      \
	unsigned i = 8;							      \
	unsigned long *prediction4s;					      \
									      \
	prediction4s = (unsigned long *) predictions;			      \
									      \
	for (; i; i--) {						      \
	    WIDE_REFERENCE##_decls;					      \
									      \
	    MAJOR_##WIDE_REFERENCE(references_0, references_1, line_size);    \
	    WIDE_REFERENCE##_0();					      \
	    MINOR_##WIDE_REFERENCE(references_0, references_1, line_size);    \
	    WIDE_REFERENCE##_1();					      \
	    *prediction4s = WIDE_REFERENCE##_X();			      \
									      \
	    references_0 += stride;					      \
	    references_1 += stride;					      \
									      \
	    prediction4s = (unsigned long *)				      \
		((unsigned char *) prediction4s + stride);		      \
	}								      \
    }

#endif				/* __SEEK_H262_6_L7_H__ */
