/*
 * h262.6.part3.c
 * Copyright (C) 2003, 2004, 2005, 2006  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <h262.0.h>
#include <h262.2.h>
#include <h262.3.h>
#include <h262.6.d4.h>

#if __DISPATCH_RESET__
static void reset_coefficients(struct seek_h262_block *, unsigned);
#endif				/* __DISPATCH_RESET__ */

#if __DISPATCH_RESET__
static void
reset_coefficients(struct seek_h262_block *blocks, unsigned count)
{
    for (; count; count--) {
	unsigned *data;

	data = (unsigned *) blocks++->coefficients;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
# if !__SHORT_ENDED_ARITHMETIC__
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
	*data++ = 0;
# endif				/* !__SHORT_ENDED_ARITHMETIC__ */
    }
}
#endif				/* __DISPATCH_RESET__ */


void
_seek_h262_set_13818_slice_blocks(struct seek_h262_video *video)
{
    unsigned chrominance_slice_address, luminance_slice_address;

    {
	struct seek_h262_13818_macroblock *macroblock;

	macroblock = video->macroblock;
	chrominance_slice_address = macroblock->chrominance_slice_address =
	    macroblock->mb_row * video->chrominance_slice_size;
	luminance_slice_address = macroblock->luminance_slice_address =
	    macroblock->mb_row * video->luminance_slice_size;
    }
    if (video->picture_structure == Bottom_Field) {
	chrominance_slice_address += video->chrominance_line_size;
	luminance_slice_address += video->luminance_line_size;
    }
    {
	unsigned char *base_address;

	base_address = video->Mylene_release.Y + luminance_slice_address;
	video->blocks[0x00].base_address = base_address;
	video->blocks[0x01].base_address = base_address + 8;
	base_address += video->luminance_slice_size >> 1;
	video->blocks[0x02].base_address = base_address;
	video->blocks[0x03].base_address = base_address + 8;
	switch (video->chroma_format) {
	case H1V1:
	    base_address =
		video->Mylene_release.Cb + chrominance_slice_address;
	    video->blocks[0x04].base_address = base_address;
	    video->blocks[0x08].base_address = base_address + 8;
	    base_address += video->chrominance_slice_size >> 1;
	    video->blocks[0x06].base_address = base_address;
	    video->blocks[0x0a].base_address = base_address + 8;
	    base_address =
		video->Mylene_release.Cr + chrominance_slice_address;
	    video->blocks[0x05].base_address = base_address;
	    video->blocks[0x09].base_address = base_address + 8;
	    base_address += video->chrominance_slice_size >> 1;
	    video->blocks[0x07].base_address = base_address;
	    video->blocks[0x0b].base_address = base_address + 8;
	    break;
	case H2V1:
	    base_address =
		video->Mylene_release.Cb + chrominance_slice_address;
	    video->blocks[0x04].base_address = base_address;
	    video->blocks[0x06].base_address =
		base_address + (video->chrominance_slice_size >> 1);
	    base_address =
		video->Mylene_release.Cr + chrominance_slice_address;
	    video->blocks[0x05].base_address = base_address;
	    video->blocks[0x07].base_address =
		base_address + (video->chrominance_slice_size >> 1);
	    break;
	case H2V2:
	    video->blocks[0x04].base_address =
		video->Mylene_release.Cb + chrominance_slice_address;
	    video->blocks[0x05].base_address =
		video->Mylene_release.Cr + chrominance_slice_address;
	}
    }
    if (video->decode_dct_type) {
	unsigned char *base_address;

	switch (video->chroma_format) {
	case H1V1:
	    base_address = video->Mylene_release.Y + luminance_slice_address;
	    video->blocks[0x0c].base_address = base_address;
	    video->blocks[0x0d].base_address = base_address + 8;
	    base_address += video->luminance_line_size;
	    video->blocks[0x0e].base_address = base_address;
	    video->blocks[0x0f].base_address = base_address + 8;
	    base_address =
		video->Mylene_release.Cb + chrominance_slice_address;
	    video->blocks[0x10].base_address = base_address;
	    video->blocks[0x14].base_address = base_address + 8;
	    base_address += video->chrominance_line_size;
	    video->blocks[0x12].base_address = base_address;
	    video->blocks[0x16].base_address = base_address + 8;
	    base_address =
		video->Mylene_release.Cr + chrominance_slice_address;
	    video->blocks[0x11].base_address = base_address;
	    video->blocks[0x15].base_address = base_address + 8;
	    base_address += video->chrominance_line_size;
	    video->blocks[0x13].base_address = base_address;
	    video->blocks[0x17].base_address = base_address + 8;
	    break;
	case H2V1:
	    base_address = video->Mylene_release.Y + luminance_slice_address;
	    video->blocks[0x08].base_address = base_address;
	    video->blocks[0x09].base_address = base_address + 8;
	    base_address += video->luminance_line_size;
	    video->blocks[0x0a].base_address = base_address;
	    video->blocks[0x0b].base_address = base_address + 8;
	    base_address =
		video->Mylene_release.Cb + chrominance_slice_address;
	    video->blocks[0x0c].base_address = base_address;
	    video->blocks[0x0e].base_address =
		base_address + video->chrominance_line_size;
	    base_address =
		video->Mylene_release.Cr + chrominance_slice_address;
	    video->blocks[0x0d].base_address = base_address;
	    video->blocks[0x0f].base_address =
		base_address + video->chrominance_line_size;
	    break;
	case H2V2:
	    base_address = video->Mylene_release.Y + luminance_slice_address;
	    video->blocks[0x06].base_address = base_address;
	    video->blocks[0x07].base_address = base_address + 8;
	    base_address += video->luminance_line_size;
	    video->blocks[0x08].base_address = base_address;
	    video->blocks[0x09].base_address = base_address + 8;
	    video->blocks[0x0a].base_address =
		video->Mylene_release.Cb + chrominance_slice_address;
	    video->blocks[0x0b].base_address =
		video->Mylene_release.Cr + chrominance_slice_address;
	}
    }
}


void
_seek_h262_set_GRAYSCALE_11172_blocks(struct seek_h262_video *video)
{
    seek_h262_coefficient *coefficients;
    struct seek_h262_block *blocks;

    blocks = video->blocks;
    coefficients = ((struct seek_h262_11172_macroblock *)
		    video->macroblock)->coefficients + _1ST_BLOCK_OFFSET;
    blocks++->coefficients = coefficients;
    coefficients += BLOCK_SIZE;
    blocks++->coefficients = coefficients;
    coefficients += BLOCK_SIZE;
    blocks++->coefficients = coefficients;
    coefficients += BLOCK_SIZE;
    blocks++->coefficients = coefficients;
    coefficients += BLOCK_SIZE;
    blocks++->coefficients = coefficients;
    coefficients += BLOCK_SIZE;
    blocks++->coefficients = coefficients;

#if __DISPATCH_RESET__
    reset_coefficients(blocks - 6, 4);
#endif				/* __DISPATCH_RESET__ */
}


void
_seek_h262_set_YCbCr_____11172_blocks(struct seek_h262_video *video)
{
    seek_h262_coefficient *coefficients;
    struct seek_h262_block *blocks;

    blocks = video->blocks;
    coefficients = ((struct seek_h262_11172_macroblock *)
		    video->macroblock)->coefficients + _1ST_BLOCK_OFFSET;
    blocks++->coefficients = coefficients;
    coefficients += BLOCK_SIZE;
    blocks++->coefficients = coefficients;
    coefficients += BLOCK_SIZE;
    blocks++->coefficients = coefficients;
    coefficients += BLOCK_SIZE;
    blocks++->coefficients = coefficients;
    coefficients += BLOCK_SIZE;
    blocks++->coefficients = coefficients;
    coefficients += BLOCK_SIZE;
    blocks++->coefficients = coefficients;

#if __DISPATCH_RESET__
    reset_coefficients(blocks - 6, 6);
#endif				/* __DISPATCH_RESET__ */
}


void
_seek_h262_set_GRAYSCALE_13818_blocks(struct seek_h262_video *video)
{
    seek_h262_coefficient *coefficients;
    struct seek_h262_block *blocks;
    unsigned chroma_format, i;

    chroma_format = video->chroma_format;
    blocks = video->blocks;
    coefficients = ((struct seek_h262_13818_macroblock *)
		    video->macroblock)->coefficients + _1ST_BLOCK_OFFSET;
    for (i = chroma_format; i; i--) {
	blocks++->coefficients = coefficients;
	coefficients += BLOCK_SIZE;
    }
#if __DISPATCH_RESET__
    reset_coefficients(blocks - chroma_format, 4);
#endif				/* __DISPATCH_RESET__ */
    if (video->decode_dct_type) {
	coefficients -= chroma_format * BLOCK_SIZE;
	for (i = chroma_format; i; i--) {
	    blocks++->coefficients = coefficients;
	    coefficients += BLOCK_SIZE;
	}
    }
}


void
_seek_h262_set_YCbCr_____13818_blocks(struct seek_h262_video *video)
{
    seek_h262_coefficient *coefficients;
    struct seek_h262_block *blocks;
    unsigned chroma_format, i;

    chroma_format = video->chroma_format;
    blocks = video->blocks;
    coefficients = ((struct seek_h262_13818_macroblock *)
		    video->macroblock)->coefficients + _1ST_BLOCK_OFFSET;
    for (i = chroma_format; i; i--) {
	blocks++->coefficients = coefficients;
	coefficients += BLOCK_SIZE;
    }
#if __DISPATCH_RESET__
    reset_coefficients(blocks - chroma_format, chroma_format);
#endif				/* __DISPATCH_RESET__ */
    if (video->decode_dct_type) {
	coefficients -= chroma_format * BLOCK_SIZE;
	for (i = chroma_format; i; i--) {
	    blocks++->coefficients = coefficients;
	    coefficients += BLOCK_SIZE;
	}
    }
}
