/*
 * h262.7.h
 * Copyright (C) 2003, 2004  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __SEEK_H262_7_H__
#define __SEEK_H262_7_H__

#include <h262.0.h>

#define __HAIRY_DOUBLE_REFERENCE__	1
#define __HAIRY_SIMPLE_REFERENCE__	1

#if __Berkeley_FUCK_UP__
# define Berkeley_REFERENCE(reference, line_size) \
    ((*reference++ + reference[line_size] + 1) >> 1)

# define Berkeley_REFERENCE_3(reference, line_size) \
    ((*reference + reference[line_size] + 1) >> 1)

# define Berkeley_REFERENCE_0		Berkeley_REFERENCE
# define Berkeley_REFERENCE_1		Berkeley_REFERENCE
# define Berkeley_REFERENCE_2		Berkeley_REFERENCE
# define Berkeley_REFERENCE_decls
#endif				/* __Berkeley_FUCK_UP__ */

#define REFERENCE_1_1(reference, line_size) \
    (*reference++)

#define REFERENCE_1_1_3(reference, line_size) \
    (*reference)

#define REFERENCE_1_1_0			REFERENCE_1_1
#define REFERENCE_1_1_1			REFERENCE_1_1
#define REFERENCE_1_1_2			REFERENCE_1_1
#define REFERENCE_1_1_decls

#define REFERENCE_1_2(reference, line_size) \
    ((*reference++ + reference[line_size] + 1) >> 1)

#define REFERENCE_1_2_3(reference, line_size) \
    ((*reference + reference[line_size] + 1) >> 1)

#define REFERENCE_1_2_0			REFERENCE_1_2
#define REFERENCE_1_2_1			REFERENCE_1_2
#define REFERENCE_1_2_2			REFERENCE_1_2
#define REFERENCE_1_2_decls

#if __HAIRY_SIMPLE_REFERENCE__
# define REFERENCE_2_1_0(reference, line_size) \
    ((*reference++ + (sum_0 = reference[1] + 1)) >> 1)

# define REFERENCE_2_1_1(reference, line_size) \
    ((sum_0 + *++reference) >> 1)

# define REFERENCE_2_1_2(reference, line_size) \
    ((*reference++ + (sum_0 = reference[1] + 1)) >> 1)

# define REFERENCE_2_1_3(reference, line_size) \
    ((sum_0 + reference[1]) >> 1)

# define REFERENCE_2_1_decls		unsigned sum_0;
#else
# define REFERENCE_2_1(reference, line_size) \
    ((*reference++ + reference[1] + 1) >> 1)

# define REFERENCE_2_1_3(reference, line_size) \
    ((*reference + reference[1] + 1) >> 1)

# define REFERENCE_2_1_0		REFERENCE_2_1
# define REFERENCE_2_1_1		REFERENCE_2_1
# define REFERENCE_2_1_2		REFERENCE_2_1
# define REFERENCE_2_1_decls
#endif				/* __HAIRY_SIMPLE_REFERENCE__ */

#if __HAIRY_SIMPLE_REFERENCE__
# define REFERENCE_2_2_0(reference, line_size) \
    ((*reference++ + reference[line_size]				      \
      + (sum_0 = reference[1] + reference[line_size + 1] + 2)) >> 2)

# define REFERENCE_2_2_1(reference, line_size) \
    ((sum_0 + (sum_1 = *++reference + reference[line_size])) >> 2)

# define REFERENCE_2_2_2(reference, line_size) \
    ((sum_1 + (sum_0 = *++reference + reference[line_size] + 2)) >> 2)

# define REFERENCE_2_2_3(reference, line_size) \
    ((sum_0 + reference[1] + reference[line_size + 1]) >> 2)

# define REFERENCE_2_2_decls		unsigned sum_0, sum_1;
#else
# define REFERENCE_2_2(reference, line_size) \
    ((*reference++ + reference[1] + reference[line_size]		      \
      + reference[line_size + 1] + 2) >> 2)

# define REFERENCE_2_2_3(reference, line_size) \
    ((*reference + reference[1] + reference[line_size] + reference[line_size  \
      + 1] + 2) >> 2)

# define REFERENCE_2_2_0		REFERENCE_2_2
# define REFERENCE_2_2_1		REFERENCE_2_2
# define REFERENCE_2_2_2		REFERENCE_2_2
# define REFERENCE_2_2_decls
#endif				/* __HAIRY_SIMPLE_REFERENCE__ */

#define REFERENCE_1_1_1_1(reference_0, reference_1, line_size) \
    ((*reference_0++ + *reference_1++ + 1) >> 1)

#define REFERENCE_1_1_1_1_3(reference_0, reference_1, line_size) \
    ((*reference_0 + *reference_1 + 1) >> 1)

#define REFERENCE_1_1_1_1_0		REFERENCE_1_1_1_1
#define REFERENCE_1_1_1_1_1		REFERENCE_1_1_1_1
#define REFERENCE_1_1_1_1_2		REFERENCE_1_1_1_1
#define REFERENCE_1_1_1_1_decls

#define REFERENCE_1_1_1_2(reference_0, reference_1, line_size) \
    ((*reference_0++ + ((*reference_1++ + reference_1[line_size] + 1) >> 1)   \
      + 1) >> 1)

#define REFERENCE_1_1_1_2_3(reference_0, reference_1, line_size) \
    ((*reference_0 + ((*reference_1 + reference_1[line_size] + 1) >> 1) + 1)  \
     >> 1)

#define REFERENCE_1_1_1_2_0		REFERENCE_1_1_1_2
#define REFERENCE_1_1_1_2_1		REFERENCE_1_1_1_2
#define REFERENCE_1_1_1_2_2		REFERENCE_1_1_1_2
#define REFERENCE_1_1_1_2_decls

#if __HAIRY_DOUBLE_REFERENCE__
# define REFERENCE_1_1_2_1_0(reference_0, reference_1, line_size) \
    ((*reference_0++							      \
      + ((*reference_1++ + (sum_1_0 = reference_1[1] + 3)) >> 1)) >> 1)

# define REFERENCE_1_1_2_1_1(reference_0, reference_1, line_size) \
    ((*reference_0++ + ((sum_1_0 + *++reference_1) >> 1)) >> 1)

# define REFERENCE_1_1_2_1_2(reference_0, reference_1, line_size) \
    ((*reference_0++							      \
      + ((*reference_1++ + (sum_1_0 = reference_1[1] + 3)) >> 1)) >> 1)

# define REFERENCE_1_1_2_1_3(reference_0, reference_1, line_size) \
    ((*reference_0 + ((sum_1_0 + reference_1[1]) >> 1)) >> 1)

# define REFERENCE_1_1_2_1_decls	unsigned sum_1_0;
#else
# define REFERENCE_1_1_2_1(reference_0, reference_1, line_size) \
    ((*reference_0++ + ((*reference_1++ + reference_1[1] + 1) >> 1) + 1) >> 1)

# define REFERENCE_1_1_2_1_3(reference_0, reference_1, line_size) \
    ((*reference_0 + ((*reference_1 + reference_1[1] + 1) >> 1) + 1) >> 1)

# define REFERENCE_1_1_2_1_0		REFERENCE_1_1_2_1
# define REFERENCE_1_1_2_1_1		REFERENCE_1_1_2_1
# define REFERENCE_1_1_2_1_2		REFERENCE_1_1_2_1
# define REFERENCE_1_1_2_1_decls
#endif				/* __HAIRY_DOUBLE_REFERENCE__ */

#if __HAIRY_DOUBLE_REFERENCE__
# define REFERENCE_1_1_2_2_0(reference_0, reference_1, line_size) \
    ((*reference_0++							      \
      + ((*reference_1++ + reference_1[line_size]			      \
	  + (sum_1_0 = reference_1[1] + reference_1[line_size + 1] + 6))      \
	 >> 2)) >> 1)

# define REFERENCE_1_1_2_2_1(reference_0, reference_1, line_size) \
    ((*reference_0++							      \
      + ((sum_1_0 + (sum_1_1 = *++reference_1 + reference_1[line_size]))      \
	 >> 2)) >> 1)

# define REFERENCE_1_1_2_2_2(reference_0, reference_1, line_size) \
    ((*reference_0++							      \
      + ((sum_1_1 + (sum_1_0 = *++reference_1 + reference_1[line_size] + 6))  \
	 >> 2)) >> 1)

# define REFERENCE_1_1_2_2_3(reference_0, reference_1, line_size) \
    ((*reference_0							      \
      + ((sum_1_0 + reference_1[1] + reference_1[line_size + 1]) >> 2)) >> 1)

# define REFERENCE_1_1_2_2_decls	unsigned sum_1_0, sum_1_1;
#else
# define REFERENCE_1_1_2_2(reference_0, reference_1, line_size) \
    ((*reference_0++							      \
      + ((*reference_1++ + reference_1[1] + reference_1[line_size]	      \
	  + reference_1[line_size + 1] + 2) >> 2) + 1) >> 1)

# define REFERENCE_1_1_2_2_3(reference_0, reference_1, line_size) \
    ((*reference_0							      \
      + ((*reference_1 + reference_1[1] + reference_1[line_size]	      \
	  + reference_1[line_size + 1] + 2) >> 2) + 1) >> 1)

# define REFERENCE_1_1_2_2_0		REFERENCE_1_1_2_2
# define REFERENCE_1_1_2_2_1		REFERENCE_1_1_2_2
# define REFERENCE_1_1_2_2_2		REFERENCE_1_1_2_2
# define REFERENCE_1_1_2_2_decls
#endif				/* __HAIRY_DOUBLE_REFERENCE__ */

#define REFERENCE_1_2_1_1(reference_0, reference_1, line_size) \
    ((((*reference_0++ + reference_0[line_size] + 1) >> 1) + *reference_1++   \
      + 1) >> 1)

#define REFERENCE_1_2_1_1_3(reference_0, reference_1, line_size) \
    ((((*reference_0 + reference_0[line_size] + 1) >> 1) + *reference_1 + 1)  \
     >> 1)

#define REFERENCE_1_2_1_1_0		REFERENCE_1_2_1_1
#define REFERENCE_1_2_1_1_1		REFERENCE_1_2_1_1
#define REFERENCE_1_2_1_1_2		REFERENCE_1_2_1_1
#define REFERENCE_1_2_1_1_decls

#define REFERENCE_1_2_1_2(reference_0, reference_1, line_size) \
    ((((*reference_0++ + reference_0[line_size] + 1) >> 1)		      \
      + ((*reference_1++ + reference_1[line_size] + 1) >> 1) + 1) >> 1)

#define REFERENCE_1_2_1_2_3(reference_0, reference_1, line_size) \
    ((((*reference_0 + reference_0[line_size] + 1) >> 1)		      \
      + ((*reference_1 + reference_1[line_size] + 1) >> 1) + 1) >> 1)

#define REFERENCE_1_2_1_2_0		REFERENCE_1_2_1_2
#define REFERENCE_1_2_1_2_1		REFERENCE_1_2_1_2
#define REFERENCE_1_2_1_2_2		REFERENCE_1_2_1_2
#define REFERENCE_1_2_1_2_decls

#if __HAIRY_DOUBLE_REFERENCE__
# define REFERENCE_1_2_2_1_0(reference_0, reference_1, line_size) \
    ((((*reference_0++ + reference_0[line_size] + 1) >> 1)		      \
      + ((*reference_1++ + (sum_1_0 = reference_1[1] + 3)) >> 1)) >> 1)

# define REFERENCE_1_2_2_1_1(reference_0, reference_1, line_size) \
    ((((*reference_0++ + reference_0[line_size] + 1) >> 1)		      \
      + ((sum_1_0 + *++reference_1) >> 1)) >> 1)

# define REFERENCE_1_2_2_1_2(reference_0, reference_1, line_size) \
    ((((*reference_0++ + reference_0[line_size] + 1) >> 1)		      \
      + ((*reference_1++ + (sum_1_0 = reference_1[1] + 3)) >> 1)) >> 1)

# define REFERENCE_1_2_2_1_3(reference_0, reference_1, line_size) \
    ((((*reference_0 + reference_0[line_size] + 1) >> 1)		      \
      + ((sum_1_0 + reference_1[1]) >> 1)) >> 1)

# define REFERENCE_1_2_2_1_decls	unsigned sum_1_0;
#else
# define REFERENCE_1_2_2_1(reference_0, reference_1, line_size) \
    ((((*reference_0++ + reference_0[line_size] + 1) >> 1)		      \
      + ((*reference_1++ + reference_1[1] + 1) >> 1) + 1) >> 1)

# define REFERENCE_1_2_2_1_3(reference_0, reference_1, line_size) \
    ((((*reference_0 + reference_0[line_size] + 1) >> 1)		      \
      + ((*reference_1 + reference_1[1] + 1) >> 1) + 1) >> 1)

# define REFERENCE_1_2_2_1_0		REFERENCE_1_2_2_1
# define REFERENCE_1_2_2_1_1		REFERENCE_1_2_2_1
# define REFERENCE_1_2_2_1_2		REFERENCE_1_2_2_1
# define REFERENCE_1_2_2_1_decls
#endif				/* __HAIRY_DOUBLE_REFERENCE__ */

#if __HAIRY_DOUBLE_REFERENCE__
# define REFERENCE_1_2_2_2_0(reference_0, reference_1, line_size) \
    ((((*reference_0++ + reference_0[line_size] + 1) >> 1)		      \
      + ((*reference_1++ + reference_1[line_size]			      \
	  + (sum_1_0 = reference_1[1] + reference_1[line_size + 1] + 6))      \
	 >> 2)) >> 1)

# define REFERENCE_1_2_2_2_1(reference_0, reference_1, line_size) \
    ((((*reference_0++ + reference_0[line_size] + 1) >> 1)		      \
      + ((sum_1_0 + (sum_1_1 = *++reference_1 + reference_1[line_size]))      \
	 >> 2)) >> 1)

# define REFERENCE_1_2_2_2_2(reference_0, reference_1, line_size) \
    ((((*reference_0++ + reference_0[line_size] + 1) >> 1)		      \
      + ((sum_1_1 + (sum_1_0 = *++reference_1 + reference_1[line_size] + 6))  \
	 >> 2)) >> 1)

# define REFERENCE_1_2_2_2_3(reference_0, reference_1, line_size) \
    ((((*reference_0 + reference_0[line_size] + 1) >> 1)		      \
      + ((sum_1_0 + reference_1[1] + reference_1[line_size + 1]) >> 2)) >> 1)

# define REFERENCE_1_2_2_2_decls	unsigned sum_1_0, sum_1_1;
#else
# define REFERENCE_1_2_2_2(reference_0, reference_1, line_size) \
    ((((*reference_0++ + reference_0[line_size] + 1) >> 1)		      \
      + ((*reference_1++ + reference_1[1] + reference_1[line_size]	      \
	  + reference_1[line_size + 1] + 2) >> 2) + 1) >> 1)

# define REFERENCE_1_2_2_2_3(reference_0, reference_1, line_size) \
    ((((*reference_0 + reference_0[line_size] + 1) >> 1)		      \
      + ((*reference_1 + reference_1[1] + reference_1[line_size]	      \
	  + reference_1[line_size + 1] + 2) >> 2) + 1) >> 1)

# define REFERENCE_1_2_2_2_0		REFERENCE_1_2_2_2
# define REFERENCE_1_2_2_2_1		REFERENCE_1_2_2_2
# define REFERENCE_1_2_2_2_2		REFERENCE_1_2_2_2
# define REFERENCE_1_2_2_2_decls
#endif				/* __HAIRY_DOUBLE_REFERENCE__ */

#if __HAIRY_DOUBLE_REFERENCE__
# define REFERENCE_2_1_1_1_0(reference_0, reference_1, line_size) \
    ((((*reference_0++ + (sum_0_0 = reference_0[1] + 3)) >> 1)		      \
      + *reference_1++) >> 1)

# define REFERENCE_2_1_1_1_1(reference_0, reference_1, line_size) \
    ((((sum_0_0 + *++reference_0) >> 1) + *reference_1++) >> 1)

# define REFERENCE_2_1_1_1_2(reference_0, reference_1, line_size) \
    ((((*reference_0++ + (sum_0_0 = reference_0[1] + 3)) >> 1)		      \
      + *reference_1++) >> 1)

# define REFERENCE_2_1_1_1_3(reference_0, reference_1, line_size) \
    ((((sum_0_0 + reference_0[1]) >> 1) + *reference_1) >> 1)

# define REFERENCE_2_1_1_1_decls	unsigned sum_0_0;
#else
# define REFERENCE_2_1_1_1(reference_0, reference_1, line_size) \
    ((((*reference_0++ + reference_0[1] + 1) >> 1) + *reference_1++ + 1) >> 1)

# define REFERENCE_2_1_1_1_3(reference_0, reference_1, line_size) \
    ((((*reference_0 + reference_0[1] + 1) >> 1) + *reference_1 + 1) >> 1)

# define REFERENCE_2_1_1_1_0		REFERENCE_2_1_1_1
# define REFERENCE_2_1_1_1_1		REFERENCE_2_1_1_1
# define REFERENCE_2_1_1_1_2		REFERENCE_2_1_1_1
# define REFERENCE_2_1_1_1_decls
#endif				/* __HAIRY_DOUBLE_REFERENCE__ */

#if __HAIRY_DOUBLE_REFERENCE__
# define REFERENCE_2_1_1_2_0(reference_0, reference_1, line_size) \
    ((((*reference_0++ + (sum_0_0 = reference_0[1] + 3)) >> 1)		      \
      + ((*reference_1++ + reference_1[line_size] + 1) >> 1)) >> 1)

# define REFERENCE_2_1_1_2_1(reference_0, reference_1, line_size) \
    ((((sum_0_0 + *++reference_0) >> 1)					      \
      + ((*reference_1++ + reference_1[line_size] + 1) >> 1)) >> 1)

# define REFERENCE_2_1_1_2_2(reference_0, reference_1, line_size) \
    ((((*reference_0++ + (sum_0_0 = reference_0[1] + 3)) >> 1)		      \
      + ((*reference_1++ + reference_1[line_size] + 1) >> 1)) >> 1)

# define REFERENCE_2_1_1_2_3(reference_0, reference_1, line_size) \
    ((((sum_0_0 + reference_0[1]) >> 1)					      \
      + ((*reference_1 + reference_1[line_size] + 1) >> 1)) >> 1)

# define REFERENCE_2_1_1_2_decls	unsigned sum_0_0;
#else
# define REFERENCE_2_1_1_2(reference_0, reference_1, line_size) \
    ((((*reference_0++ + reference_0[1] + 1) >> 1)			      \
      + ((*reference_1++ + reference_1[line_size] + 1) >> 1) + 1) >> 1)

# define REFERENCE_2_1_1_2_3(reference_0, reference_1, line_size) \
    ((((*reference_0 + reference_0[1] + 1) >> 1)			      \
      + ((*reference_1 + reference_1[line_size] + 1) >> 1) + 1) >> 1)

# define REFERENCE_2_1_1_2_0		REFERENCE_2_1_1_2
# define REFERENCE_2_1_1_2_1		REFERENCE_2_1_1_2
# define REFERENCE_2_1_1_2_2		REFERENCE_2_1_1_2
# define REFERENCE_2_1_1_2_decls
#endif				/* __HAIRY_DOUBLE_REFERENCE__ */

#if __HAIRY_DOUBLE_REFERENCE__
# define REFERENCE_2_1_2_1_0(reference_0, reference_1, line_size) \
    ((((*reference_0++ + (sum_0_0 = reference_0[1] + 3)) >> 1)		      \
      + ((*reference_1++ + (sum_1_0 = reference_1[1] + 1)) >> 1)) >> 1)

# define REFERENCE_2_1_2_1_1(reference_0, reference_1, line_size) \
    ((((sum_0_0 + *++reference_0) >> 1) + ((sum_1_0 + *++reference_1) >> 1))  \
     >> 1)

# define REFERENCE_2_1_2_1_2(reference_0, reference_1, line_size) \
    ((((*reference_0++ + (sum_0_0 = reference_0[1] + 1)) >> 1)		      \
      + ((*reference_1++ + (sum_1_0 = reference_1[1] + 3)) >> 1)) >> 1)

# define REFERENCE_2_1_2_1_3(reference_0, reference_1, line_size) \
    ((((sum_0_0 + reference_0[1]) >> 1) + ((sum_1_0 + reference_1[1]) >> 1))  \
     >> 1)

# define REFERENCE_2_1_2_1_decls	unsigned sum_0_0, sum_1_0;
#else
# define REFERENCE_2_1_2_1(reference_0, reference_1, line_size) \
    ((((*reference_0++ + reference_0[1] + 1) >> 1)			      \
      + ((*reference_1++ + reference_1[1] + 1) >> 1) + 1) >> 1)

# define REFERENCE_2_1_2_1_3(reference_0, reference_1, line_size) \
    ((((*reference_0 + reference_0[1] + 1) >> 1)			      \
      + ((*reference_1 + reference_1[1] + 1) >> 1) + 1) >> 1)

# define REFERENCE_2_1_2_1_0		REFERENCE_2_1_2_1
# define REFERENCE_2_1_2_1_1		REFERENCE_2_1_2_1
# define REFERENCE_2_1_2_1_2		REFERENCE_2_1_2_1
# define REFERENCE_2_1_2_1_decls
#endif				/* __HAIRY_DOUBLE_REFERENCE__ */

#if __HAIRY_DOUBLE_REFERENCE__
# define REFERENCE_2_1_2_2_0(reference_0, reference_1, line_size) \
    ((((*reference_0++ + (sum_0_0 = reference_0[1] + 1)) >> 1)		      \
      + ((*reference_1++ + reference_1[line_size]			      \
	  + (sum_1_0 = reference_1[1] + reference_1[line_size + 1] + 6))      \
	 >> 2)) >> 1)

# define REFERENCE_2_1_2_2_1(reference_0, reference_1, line_size) \
    ((((sum_0_0 + *++reference_0) >> 1)					      \
      + ((sum_1_0 + (sum_1_1 = *++reference_1 + reference_1[line_size]))      \
	 >> 2)) >> 1)

# define REFERENCE_2_1_2_2_2(reference_0, reference_1, line_size) \
    ((((*reference_0++ + (sum_0_0 = reference_0[1] + 1)) >> 1)		      \
      + ((sum_1_1 + (sum_1_0 = *++reference_1 + reference_1[line_size] + 6))  \
	 >> 2)) >> 1)

# define REFERENCE_2_1_2_2_3(reference_0, reference_1, line_size) \
    ((((sum_0_0 + reference_0[1]) >> 1)					      \
      + ((sum_1_0 + reference_1[1] + reference_1[line_size + 1]) >> 2)) >> 1)

# define REFERENCE_2_1_2_2_decls	unsigned sum_0_0, sum_1_0, sum_1_1;
#else
# define REFERENCE_2_1_2_2(reference_0, reference_1, line_size) \
    ((((*reference_0++ + reference_0[1] + 1) >> 1)			      \
      + ((*reference_1++ + reference_1[1]				      \
	  + reference_1[line_size] + reference_1[line_size + 1] + 2) >> 2)    \
      + 1) >> 1)

# define REFERENCE_2_1_2_2_3(reference_0, reference_1, line_size) \
    ((((*reference_0 + reference_0[1] + 1) >> 1)			      \
      + ((*reference_1 + reference_1[1]					      \
	  + reference_1[line_size] + reference_1[line_size + 1] + 2) >> 2)    \
      + 1) >> 1)

# define REFERENCE_2_1_2_2_0		REFERENCE_2_1_2_2
# define REFERENCE_2_1_2_2_1		REFERENCE_2_1_2_2
# define REFERENCE_2_1_2_2_2		REFERENCE_2_1_2_2
# define REFERENCE_2_1_2_2_decls
#endif				/* __HAIRY_DOUBLE_REFERENCE__ */

#if __HAIRY_DOUBLE_REFERENCE__
# define REFERENCE_2_2_1_1_0(reference_0, reference_1, line_size) \
    ((((*reference_0++ + reference_0[line_size]				      \
	+ (sum_0_0 = reference_0[1] + reference_0[line_size + 1] + 6)) >> 2)  \
      + *reference_1++) >> 1)

# define REFERENCE_2_2_1_1_1(reference_0, reference_1, line_size) \
    ((((sum_0_0 + (sum_0_1 = *++reference_0 + reference_0[line_size])) >> 2)  \
      + *reference_1++) >> 1)

# define REFERENCE_2_2_1_1_2(reference_0, reference_1, line_size) \
    ((((sum_0_1 + (sum_0_0 = *++reference_0 + reference_0[line_size] + 6))    \
       >> 2) + *reference_1++) >> 1)

# define REFERENCE_2_2_1_1_3(reference_0, reference_1, line_size) \
    ((((sum_0_0 + reference_0[1] + reference_0[line_size + 1]) >> 2)	      \
      + *reference_1) >> 1)

# define REFERENCE_2_2_1_1_decls	unsigned sum_0_0, sum_0_1;
#else
# define REFERENCE_2_2_1_1(reference_0, reference_1, line_size) \
    ((((*reference_0++ + reference_0[1] + reference_0[line_size]	      \
	+ reference_0[line_size + 1] + 2) >> 2) + *reference_1++ + 1) >> 1)

# define REFERENCE_2_2_1_1_3(reference_0, reference_1, line_size) \
    ((((*reference_0 + reference_0[1] + reference_0[line_size]		      \
	+ reference_0[line_size + 1] + 2) >> 2) + *reference_1 + 1) >> 1)

# define REFERENCE_2_2_1_1_0		REFERENCE_2_2_1_1
# define REFERENCE_2_2_1_1_1		REFERENCE_2_2_1_1
# define REFERENCE_2_2_1_1_2		REFERENCE_2_2_1_1
# define REFERENCE_2_2_1_1_decls
#endif				/* __HAIRY_DOUBLE_REFERENCE__ */

#if __HAIRY_DOUBLE_REFERENCE__
# define REFERENCE_2_2_1_2_0(reference_0, reference_1, line_size) \
    ((((*reference_0++ + reference_0[line_size]				      \
	+ (sum_0_0 = reference_0[1] + reference_0[line_size + 1] + 6))  >> 2) \
      + ((*reference_1++ + reference_1[line_size] + 1) >> 1)) >> 1)

# define REFERENCE_2_2_1_2_1(reference_0, reference_1, line_size) \
    ((((sum_0_0 + (sum_0_1 = *++reference_0 + reference_0[line_size])) >> 2)  \
      + ((*reference_1++ + reference_1[line_size] + 1) >> 1)) >> 1)

# define REFERENCE_2_2_1_2_2(reference_0, reference_1, line_size) \
    ((((sum_0_1 + (sum_0_0 = *++reference_0 + reference_0[line_size] + 6))    \
       >> 2) + ((*reference_1++ + reference_1[line_size] + 1) >> 1)) >> 1)

# define REFERENCE_2_2_1_2_3(reference_0, reference_1, line_size) \
    ((((sum_0_0 + reference_0[1] + reference_0[line_size + 1]) >> 2)	      \
      + ((*reference_1 + reference_1[line_size] + 1) >> 1)) >> 1)

# define REFERENCE_2_2_1_2_decls	unsigned sum_0_0, sum_0_1;
#else
# define REFERENCE_2_2_1_2(reference_0, reference_1, line_size) \
    ((((*reference_0++ + reference_0[1] + reference_0[line_size]	      \
	+ reference_0[line_size + 1] + 2) >> 2)				      \
      + ((*reference_1++ + reference_1[line_size] + 1) >> 1) + 1) >> 1)

# define REFERENCE_2_2_1_2_3(reference_0, reference_1, line_size) \
    ((((*reference_0 + reference_0[1] + reference_0[line_size]		      \
	+ reference_0[line_size + 1] + 2) >> 2)				      \
      + ((*reference_1 + reference_1[line_size] + 1) >> 1) + 1) >> 1)

# define REFERENCE_2_2_1_2_0		REFERENCE_2_2_1_2
# define REFERENCE_2_2_1_2_1		REFERENCE_2_2_1_2
# define REFERENCE_2_2_1_2_2		REFERENCE_2_2_1_2
# define REFERENCE_2_2_1_2_decls
#endif				/* __HAIRY_DOUBLE_REFERENCE__ */

#if __HAIRY_DOUBLE_REFERENCE__
# define REFERENCE_2_2_2_1_0(reference_0, reference_1, line_size) \
    ((((*reference_0++ + reference_0[line_size]				      \
	+ (sum_0_0 = reference_0[1] + reference_0[line_size + 1] + 6)) >> 2)  \
      + ((*reference_1++ + (sum_1_0 = reference_1[1] + 1)) >> 1)) >> 1)

# define REFERENCE_2_2_2_1_1(reference_0, reference_1, line_size) \
    ((((sum_0_0 + (sum_0_1 = *++reference_0 + reference_0[line_size])) >> 2)  \
      + ((sum_1_0 + *++reference_1) >> 1)) >> 1)

# define REFERENCE_2_2_2_1_2(reference_0, reference_1, line_size) \
    ((((sum_0_1 + (sum_0_0 = *++reference_0 + reference_0[line_size] + 6))    \
       >> 2) + ((*reference_1++ + (sum_1_0 = reference_1[1] + 1)) >> 1)) >> 1)

# define REFERENCE_2_2_2_1_3(reference_0, reference_1, line_size) \
    ((((sum_0_0 + reference_0[1] + reference_0[line_size + 1]) >> 2)	      \
      + ((sum_1_0 + reference_1[1]) >> 1)) >> 1)

# define REFERENCE_2_2_2_1_decls	unsigned sum_0_0, sum_0_1, sum_1_0;
#else
# define REFERENCE_2_2_2_1(reference_0, reference_1, line_size) \
    ((((*reference_0++ + reference_0[1] + reference_0[line_size]	      \
	+ reference_0[line_size + 1] + 2) >> 2)				      \
      + ((*reference_1++ + reference_1[1] + 1) >> 1) + 1) >> 1)

# define REFERENCE_2_2_2_1_3(reference_0, reference_1, line_size) \
    ((((*reference_0 + reference_0[1] + reference_0[line_size]		      \
	+ reference_0[line_size + 1] + 2) >> 2)				      \
      + ((*reference_1 + reference_1[1] + 1) >> 1) + 1) >> 1)

# define REFERENCE_2_2_2_1_0		REFERENCE_2_2_2_1
# define REFERENCE_2_2_2_1_1		REFERENCE_2_2_2_1
# define REFERENCE_2_2_2_1_2		REFERENCE_2_2_2_1
# define REFERENCE_2_2_2_1_decls
#endif				/* __HAIRY_DOUBLE_REFERENCE__ */

#if __HAIRY_DOUBLE_REFERENCE__
# define REFERENCE_2_2_2_2_0(reference_0, reference_1, line_size) \
    ((((*reference_0++ + reference_0[line_size]				      \
	+ (sum_0_0 = reference_0[1] + reference_0[line_size + 1] + 6)) >> 2)  \
      + ((*reference_1++ + reference_1[line_size]			      \
	  + (sum_1_0 = reference_1[1] + reference_1[line_size + 1] + 2))      \
	 >> 2)) >> 1)

# define REFERENCE_2_2_2_2_1(reference_0, reference_1, line_size) \
    ((((sum_0_0 + (sum_0_1 = *++reference_0 + reference_0[line_size])) >> 2)  \
      + ((sum_1_0 + (sum_1_1 = *++reference_1 + reference_1[line_size]))      \
	 >> 2)) >> 1)

# define REFERENCE_2_2_2_2_2(reference_0, reference_1, line_size) \
    ((((sum_0_1 + (sum_0_0 = *++reference_0 + reference_0[line_size] + 2))    \
       >> 2)								      \
      + ((sum_1_1 + (sum_1_0 = *++reference_1 + reference_1[line_size] + 6))  \
	 >> 2)) >> 1)

# define REFERENCE_2_2_2_2_3(reference_0, reference_1, line_size) \
    ((((sum_0_0 + reference_0[1] + reference_0[line_size + 1]) >> 2)	      \
      + ((sum_1_0 + reference_1[1] + reference_1[line_size + 1]) >> 2)) >> 1)

# define REFERENCE_2_2_2_2_decls \
    unsigned sum_0_0, sum_0_1, sum_1_0, sum_1_1;
#else
# define REFERENCE_2_2_2_2(reference_0, reference_1, line_size) \
    ((((*reference_0++ + reference_0[1] + reference_0[line_size]	      \
	+ reference_0[line_size + 1] + 2) >> 2)				      \
      + ((*reference_1++ + reference_1[1] + reference_1[line_size]	      \
	  + reference_1[line_size + 1] + 2) >> 2) + 1) >> 1)

# define REFERENCE_2_2_2_2_3(reference_0, reference_1, line_size) \
    ((((*reference_0 + reference_0[1] + reference_0[line_size]		      \
	+ reference_0[line_size + 1] + 2) >> 2)				      \
      + ((*reference_1 + reference_1[1] + reference_1[line_size]	      \
	  + reference_1[line_size + 1] + 2) >> 2) + 1) >> 1)

# define REFERENCE_2_2_2_2_0		REFERENCE_2_2_2_2
# define REFERENCE_2_2_2_2_1		REFERENCE_2_2_2_2
# define REFERENCE_2_2_2_2_2		REFERENCE_2_2_2_2
# define REFERENCE_2_2_2_2_decls
#endif				/* __HAIRY_DOUBLE_REFERENCE__ */

#endif				/* __SEEK_H262_7_H__ */
