/*
 * h262.8.l7.h
 * Copyright (C) 2004, 2005, 2006  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __SEEK_H262_8_L7_H__
#define __SEEK_H262_8_L7_H__

#include <h262.0.h>
#if SIZEOF_LONG == 8
# include <h262.6.l7.h>
#else
# include <h262.7.l7.h>
#endif				/* SIZEOF_LONG == 8 */

#define wideblock_0_0_x(predictions, references, stride, line_size, SELECTOR) \
    {									      \
	wideblock_0__x_##SELECTOR					      \
	    (predictions, references, stride, line_size, WIDE_REFERENCE_1_1); \
    }

#if 0
# undef block_0_0_0

# define block_0_0_0(predictions, references, stride, line_size) \
    wideblock_0_0_x(predictions, references, stride, line_size, 0)
#endif				/* 0 */

#if 0
# undef block_0_0_1

# define block_0_0_1(predictions, references, stride, line_size) \
    wideblock_0_0_x(predictions, references, stride, line_size, 1)
#endif				/* 0 */

#if 0
# undef block_0_0_2

# define block_0_0_2(predictions, references, stride, line_size) \
    wideblock_0_0_x(predictions, references, stride, line_size, 2)
#endif				/* 0 */

#if 0
# undef block_0_0_3

# define block_0_0_3(predictions, references, stride, line_size) \
    wideblock_0_0_x(predictions, references, stride, line_size, 3)
#endif				/* 0 */

#define wideblock_0_1_x(predictions, references, stride, line_size, SELECTOR) \
    {									      \
	wideblock_0__x_##SELECTOR					      \
	    (predictions, references, stride, line_size, WIDE_REFERENCE_2_1); \
    }

#undef block_0_1_0

#define block_0_1_0(predictions, references, stride, line_size) \
    wideblock_0_1_x(predictions, references, stride, line_size, 0)

#undef block_0_1_1

#define block_0_1_1(predictions, references, stride, line_size) \
    wideblock_0_1_x(predictions, references, stride, line_size, 1)

#undef block_0_1_2

#define block_0_1_2(predictions, references, stride, line_size) \
    wideblock_0_1_x(predictions, references, stride, line_size, 2)

#undef block_0_1_3

#define block_0_1_3(predictions, references, stride, line_size) \
    wideblock_0_1_x(predictions, references, stride, line_size, 3)

#define wideblock_0_2_x(predictions, references, stride, line_size, SELECTOR) \
    {									      \
	wideblock_0__x_##SELECTOR					      \
	    (predictions, references, stride, line_size, WIDE_REFERENCE_1_2); \
    }

#undef block_0_2_0

#define block_0_2_0(predictions, references, stride, line_size) \
    wideblock_0_2_x(predictions, references, stride, line_size, 0)

#undef block_0_2_1

#define block_0_2_1(predictions, references, stride, line_size) \
    wideblock_0_2_x(predictions, references, stride, line_size, 1)

#undef block_0_2_2

#define block_0_2_2(predictions, references, stride, line_size) \
    wideblock_0_2_x(predictions, references, stride, line_size, 2)

#undef block_0_2_3

#define block_0_2_3(predictions, references, stride, line_size) \
    wideblock_0_2_x(predictions, references, stride, line_size, 3)

#define wideblock_0_3_x(predictions, references, stride, line_size, SELECTOR) \
    {									      \
	wideblock_0__x_##SELECTOR					      \
	    (predictions, references, stride, line_size, WIDE_REFERENCE_2_2); \
    }

#undef block_0_3_0

#define block_0_3_0(predictions, references, stride, line_size) \
    wideblock_0_3_x(predictions, references, stride, line_size, 0)

#undef block_0_3_1

#define block_0_3_1(predictions, references, stride, line_size) \
    wideblock_0_3_x(predictions, references, stride, line_size, 1)

#undef block_0_3_2

#define block_0_3_2(predictions, references, stride, line_size) \
    wideblock_0_3_x(predictions, references, stride, line_size, 2)

#undef block_0_3_3

#define block_0_3_3(predictions, references, stride, line_size) \
    wideblock_0_3_x(predictions, references, stride, line_size, 3)

#define wideblock_1_0_x(predictions, references_0, references_1, stride, \
			line_size, SELECTOR)				      \
    {									      \
	wideblock_1__x_##SELECTOR					      \
	    (predictions, references_0, references_1, stride, line_size,      \
	     WIDE_REFERENCE_1_1_1_1);					      \
    }

#undef block_1_0_0

#define block_1_0_0(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_0_x(predictions, references_0, references_1, stride,	      \
		    line_size, 0)

#undef block_1_0_1

#define block_1_0_1(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_0_x(predictions, references_0, references_1, stride,	      \
		    line_size, 1)

#undef block_1_0_2

#define block_1_0_2(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_0_x(predictions, references_0, references_1, stride,	      \
		    line_size, 2)

#undef block_1_0_3

#define block_1_0_3(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_0_x(predictions, references_0, references_1, stride,	      \
		    line_size, 3)

#define wideblock_1_1_x(predictions, references_0, references_1, stride, \
			line_size, SELECTOR)				      \
    {									      \
	wideblock_1__x_##SELECTOR					      \
	    (predictions, references_0, references_1, stride, line_size,      \
	     WIDE_REFERENCE_1_1_2_1);					      \
    }

#undef block_1_1_0

#define block_1_1_0(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_1_x(predictions, references_0, references_1, stride,	      \
		    line_size, 0)

#undef block_1_1_1

#define block_1_1_1(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_1_x(predictions, references_0, references_1, stride,	      \
		    line_size, 1)

#undef block_1_1_2

#define block_1_1_2(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_1_x(predictions, references_0, references_1, stride,	      \
		    line_size, 2)

#undef block_1_1_3

#define block_1_1_3(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_1_x(predictions, references_0, references_1, stride,	      \
		    line_size, 3)

#define wideblock_1_2_x(predictions, references_0, references_1, stride, \
			line_size, SELECTOR)				      \
    {									      \
	wideblock_1__x_##SELECTOR					      \
	    (predictions, references_0, references_1, stride, line_size,      \
	     WIDE_REFERENCE_1_1_1_2);					      \
    }

#undef block_1_2_0

#define block_1_2_0(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_2_x(predictions, references_0, references_1, stride,	      \
		    line_size, 0)

#undef block_1_2_1

#define block_1_2_1(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_2_x(predictions, references_0, references_1, stride,	      \
		    line_size, 1)

#undef block_1_2_2

#define block_1_2_2(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_2_x(predictions, references_0, references_1, stride,	      \
		    line_size, 2)

#undef block_1_2_3

#define block_1_2_3(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_2_x(predictions, references_0, references_1, stride,	      \
		    line_size, 3)

#define wideblock_1_3_x(predictions, references_0, references_1, stride, \
			line_size, SELECTOR)				      \
    {									      \
	wideblock_1__x_##SELECTOR					      \
	    (predictions, references_0, references_1, stride, line_size,      \
	     WIDE_REFERENCE_1_1_2_2);					      \
    }

#undef block_1_3_0

#define block_1_3_0(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_3_x(predictions, references_0, references_1, stride,	      \
		    line_size, 0)

#undef block_1_3_1

#define block_1_3_1(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_3_x(predictions, references_0, references_1, stride,	      \
		    line_size, 1)

#undef block_1_3_2

#define block_1_3_2(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_3_x(predictions, references_0, references_1, stride,	      \
		    line_size, 2)

#undef block_1_3_3

#define block_1_3_3(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_3_x(predictions, references_0, references_1, stride,	      \
		    line_size, 3)

#define wideblock_1_4_x(predictions, references_0, references_1, stride, \
			line_size, SELECTOR)				      \
    {									      \
	wideblock_1__x_##SELECTOR					      \
	    (predictions, references_0, references_1, stride, line_size,      \
	     WIDE_REFERENCE_2_1_1_1);					      \
    }

#undef block_1_4_0

#define block_1_4_0(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_4_x(predictions, references_0, references_1, stride,	      \
		    line_size, 0)

#undef block_1_4_1

#define block_1_4_1(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_4_x(predictions, references_0, references_1, stride,	      \
		    line_size, 1)

#undef block_1_4_2

#define block_1_4_2(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_4_x(predictions, references_0, references_1, stride,	      \
		    line_size, 2)

#undef block_1_4_3

#define block_1_4_3(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_4_x(predictions, references_0, references_1, stride,	      \
		    line_size, 3)

#define wideblock_1_5_x(predictions, references_0, references_1, stride, \
			line_size, SELECTOR)				      \
    {									      \
	wideblock_1__x_##SELECTOR					      \
	    (predictions, references_0, references_1, stride, line_size,      \
	     WIDE_REFERENCE_2_1_2_1);					      \
    }

#undef block_1_5_0

#define block_1_5_0(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_5_x(predictions, references_0, references_1, stride,	      \
		    line_size, 0)

#undef block_1_5_1

#define block_1_5_1(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_5_x(predictions, references_0, references_1, stride,	      \
		    line_size, 1)

#undef block_1_5_2

#define block_1_5_2(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_5_x(predictions, references_0, references_1, stride,	      \
		    line_size, 2)

#undef block_1_5_3

#define block_1_5_3(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_5_x(predictions, references_0, references_1, stride,	      \
		    line_size, 3)

#define wideblock_1_6_x(predictions, references_0, references_1, stride, \
			line_size, SELECTOR)				      \
    {									      \
	wideblock_1__x_##SELECTOR					      \
	    (predictions, references_0, references_1, stride, line_size,      \
	     WIDE_REFERENCE_2_1_1_2);					      \
    }

#undef block_1_6_0

#define block_1_6_0(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_6_x(predictions, references_0, references_1, stride,	      \
		    line_size, 0)

#undef block_1_6_1

#define block_1_6_1(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_6_x(predictions, references_0, references_1, stride,	      \
		    line_size, 1)

#undef block_1_6_2

#define block_1_6_2(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_6_x(predictions, references_0, references_1, stride,	      \
		    line_size, 2)

#undef block_1_6_3

#define block_1_6_3(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_6_x(predictions, references_0, references_1, stride,	      \
		    line_size, 3)

#define wideblock_1_7_x(predictions, references_0, references_1, stride, \
			line_size, SELECTOR)				      \
    {									      \
	wideblock_1__x_##SELECTOR					      \
	    (predictions, references_0, references_1, stride, line_size,      \
	     WIDE_REFERENCE_2_1_2_2);					      \
    }

#undef block_1_7_0

#define block_1_7_0(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_7_x(predictions, references_0, references_1, stride,	      \
		    line_size, 0)

#undef block_1_7_1

#define block_1_7_1(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_7_x(predictions, references_0, references_1, stride,	      \
		    line_size, 1)

#undef block_1_7_2

#define block_1_7_2(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_7_x(predictions, references_0, references_1, stride,	      \
		    line_size, 2)

#undef block_1_7_3

#define block_1_7_3(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_7_x(predictions, references_0, references_1, stride,	      \
		    line_size, 3)

#define wideblock_1_8_x(predictions, references_0, references_1, stride, \
			line_size, SELECTOR)				      \
    {									      \
	wideblock_1__x_##SELECTOR					      \
	    (predictions, references_0, references_1, stride, line_size,      \
	     WIDE_REFERENCE_1_2_1_1);					      \
    }

#undef block_1_8_0

#define block_1_8_0(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_8_x(predictions, references_0, references_1, stride,	      \
		    line_size, 0)

#undef block_1_8_1

#define block_1_8_1(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_8_x(predictions, references_0, references_1, stride,	      \
		    line_size, 1)

#undef block_1_8_2

#define block_1_8_2(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_8_x(predictions, references_0, references_1, stride,	      \
		    line_size, 2)

#undef block_1_8_3

#define block_1_8_3(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_8_x(predictions, references_0, references_1, stride,	      \
		    line_size, 3)

#define wideblock_1_9_x(predictions, references_0, references_1, stride, \
			line_size, SELECTOR)				      \
    {									      \
	wideblock_1__x_##SELECTOR					      \
	    (predictions, references_0, references_1, stride, line_size,      \
	     WIDE_REFERENCE_1_2_2_1);					      \
    }

#undef block_1_9_0

#define block_1_9_0(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_9_x(predictions, references_0, references_1, stride,	      \
		    line_size, 0)

#undef block_1_9_1

#define block_1_9_1(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_9_x(predictions, references_0, references_1, stride,	      \
		    line_size, 1)

#undef block_1_9_2

#define block_1_9_2(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_9_x(predictions, references_0, references_1, stride,	      \
		    line_size, 2)

#undef block_1_9_3

#define block_1_9_3(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_9_x(predictions, references_0, references_1, stride,	      \
		    line_size, 3)

#define wideblock_1_a_x(predictions, references_0, references_1, stride, \
			line_size, SELECTOR)				      \
    {									      \
	wideblock_1__x_##SELECTOR					      \
	    (predictions, references_0, references_1, stride, line_size,      \
	     WIDE_REFERENCE_1_2_1_2);					      \
    }

#undef block_1_a_0

#define block_1_a_0(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_a_x(predictions, references_0, references_1, stride,	      \
		    line_size, 0)

#undef block_1_a_1

#define block_1_a_1(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_a_x(predictions, references_0, references_1, stride,	      \
		    line_size, 1)

#undef block_1_a_2

#define block_1_a_2(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_a_x(predictions, references_0, references_1, stride,	      \
		    line_size, 2)

#undef block_1_a_3

#define block_1_a_3(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_a_x(predictions, references_0, references_1, stride,	      \
		    line_size, 3)

#define wideblock_1_b_x(predictions, references_0, references_1, stride, \
			line_size, SELECTOR)				      \
    {									      \
	wideblock_1__x_##SELECTOR					      \
	    (predictions, references_0, references_1, stride, line_size,      \
	     WIDE_REFERENCE_1_2_2_2);					      \
    }

#undef block_1_b_0

#define block_1_b_0(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_b_x(predictions, references_0, references_1, stride,	      \
		    line_size, 0)

#undef block_1_b_1

#define block_1_b_1(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_b_x(predictions, references_0, references_1, stride,	      \
		    line_size, 1)

#undef block_1_b_2

#define block_1_b_2(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_b_x(predictions, references_0, references_1, stride,	      \
		    line_size, 2)

#undef block_1_b_3

#define block_1_b_3(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_b_x(predictions, references_0, references_1, stride,	      \
		    line_size, 3)

#define wideblock_1_c_x(predictions, references_0, references_1, stride, \
			line_size, SELECTOR)				      \
    {									      \
	wideblock_1__x_##SELECTOR					      \
	    (predictions, references_0, references_1, stride, line_size,      \
	     WIDE_REFERENCE_2_2_1_1);					      \
    }

#undef block_1_c_0

#define block_1_c_0(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_c_x(predictions, references_0, references_1, stride,	      \
		    line_size, 0)

#undef block_1_c_1

#define block_1_c_1(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_c_x(predictions, references_0, references_1, stride,	      \
		    line_size, 1)

#undef block_1_c_2

#define block_1_c_2(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_c_x(predictions, references_0, references_1, stride,	      \
		    line_size, 2)

#undef block_1_c_3

#define block_1_c_3(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_c_x(predictions, references_0, references_1, stride,	      \
		    line_size, 3)

#define wideblock_1_d_x(predictions, references_0, references_1, stride, \
			line_size, SELECTOR)				      \
    {									      \
	wideblock_1__x_##SELECTOR					      \
	    (predictions, references_0, references_1, stride, line_size,      \
	     WIDE_REFERENCE_2_2_2_1);					      \
    }

#undef block_1_d_0

#define block_1_d_0(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_d_x(predictions, references_0, references_1, stride,	      \
		    line_size, 0)

#undef block_1_d_1

#define block_1_d_1(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_d_x(predictions, references_0, references_1, stride,	      \
		    line_size, 1)

#undef block_1_d_2

#define block_1_d_2(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_d_x(predictions, references_0, references_1, stride,	      \
		    line_size, 2)

#undef block_1_d_3

#define block_1_d_3(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_d_x(predictions, references_0, references_1, stride,	      \
		    line_size, 3)

#define wideblock_1_e_x(predictions, references_0, references_1, stride, \
			line_size, SELECTOR)				      \
    {									      \
	wideblock_1__x_##SELECTOR					      \
	    (predictions, references_0, references_1, stride, line_size,      \
	     WIDE_REFERENCE_2_2_1_2);					      \
    }

#undef block_1_e_0

#define block_1_e_0(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_e_x(predictions, references_0, references_1, stride,	      \
		    line_size, 0)

#undef block_1_e_1

#define block_1_e_1(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_e_x(predictions, references_0, references_1, stride,	      \
		    line_size, 1)

#undef block_1_e_2

#define block_1_e_2(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_e_x(predictions, references_0, references_1, stride,	      \
		    line_size, 2)

#undef block_1_e_3

#define block_1_e_3(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_e_x(predictions, references_0, references_1, stride,	      \
		    line_size, 3)

#define wideblock_1_f_x(predictions, references_0, references_1, stride, \
			line_size, SELECTOR)				      \
    {									      \
	wideblock_1__x_##SELECTOR					      \
	    (predictions, references_0, references_1, stride, line_size,      \
	     WIDE_REFERENCE_2_2_2_2);					      \
    }

#undef block_1_f_0

#define block_1_f_0(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_f_x(predictions, references_0, references_1, stride,	      \
		    line_size, 0)

#undef block_1_f_1

#define block_1_f_1(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_f_x(predictions, references_0, references_1, stride,	      \
		    line_size, 1)

#undef block_1_f_2

#define block_1_f_2(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_f_x(predictions, references_0, references_1, stride,	      \
		    line_size, 2)

#undef block_1_f_3

#define block_1_f_3(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_f_x(predictions, references_0, references_1, stride,	      \
		    line_size, 3)

#endif				/* __SEEK_H262_8_L7_H__ */
