/*
 * h262.9.d4.h
 * Copyright (C) 2003, 2004, 2005, 2006  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __SEEK_H262_9_D4_H__
#define __SEEK_H262_9_D4_H__

#include <h262.8.h>

#undef block_0_0_0

#define block_0_0_0(predictions, references, stride, line_size) \
    {									      \
	if ((integral_q) references & 3) {				      \
	    block_0_0_x(predictions, references, stride, line_size, 0);	      \
	} else {							      \
	    unsigned i = 16, *prediction4s, *reference4s;		      \
									      \
	    prediction4s = (unsigned *) predictions;			      \
	    reference4s = (unsigned *) references;			      \
	    for (; i; i--) {						      \
		prediction4s[0] = reference4s[0];			      \
		prediction4s[1] = reference4s[1];			      \
		prediction4s[2] = reference4s[2];			      \
		prediction4s[3] = reference4s[3];			      \
		prediction4s = (unsigned *)				      \
		    ((unsigned char *) prediction4s + stride);		      \
		reference4s = (unsigned *)				      \
		    ((unsigned char *) reference4s + stride);		      \
	    }								      \
	}								      \
    }

#undef block_0_0_1

#define block_0_0_1(predictions, references, stride, line_size) \
    {									      \
	if ((integral_q) references & 3) {				      \
	    block_0_0_x(predictions, references, stride, line_size, 1);	      \
	} else {							      \
	    unsigned i = 8, *prediction4s, *reference4s;		      \
									      \
	    prediction4s = (unsigned *) predictions;			      \
	    reference4s = (unsigned *) references;			      \
	    for (; i; i--) {						      \
		prediction4s[0] = reference4s[0];			      \
		prediction4s[1] = reference4s[1];			      \
		prediction4s[2] = reference4s[2];			      \
		prediction4s[3] = reference4s[3];			      \
		prediction4s = (unsigned *)				      \
		    ((unsigned char *) prediction4s + stride);		      \
		reference4s = (unsigned *)				      \
		    ((unsigned char *) reference4s + stride);		      \
	    }								      \
	}								      \
    }

#undef block_0_0_2

#define block_0_0_2(predictions, references, stride, line_size) \
    {									      \
	if ((integral_q) references & 3) {				      \
	    block_0_0_x(predictions, references, stride, line_size, 2);	      \
	} else {							      \
	    unsigned i = 16, *prediction4s, *reference4s;		      \
									      \
	    prediction4s = (unsigned *) predictions;			      \
	    reference4s = (unsigned *) references;			      \
	    for (; i; i--) {						      \
		prediction4s[0] = reference4s[0];			      \
		prediction4s[1] = reference4s[1];			      \
		prediction4s = (unsigned *)				      \
		    ((unsigned char *) prediction4s + stride);		      \
		reference4s = (unsigned *)				      \
		    ((unsigned char *) reference4s + stride);		      \
	    }								      \
	}								      \
    }

#undef block_0_0_3

#define block_0_0_3(predictions, references, stride, line_size) \
    {									      \
	if ((integral_q) references & 3) {				      \
	    block_0_0_x(predictions, references, stride, line_size, 3);	      \
	} else {							      \
	    unsigned i = 8, *prediction4s, *reference4s;		      \
									      \
	    prediction4s = (unsigned *) predictions;			      \
	    reference4s = (unsigned *) references;			      \
	    for (; i; i--) {						      \
		prediction4s[0] = reference4s[0];			      \
		prediction4s[1] = reference4s[1];			      \
		prediction4s = (unsigned *)				      \
		    ((unsigned char *) prediction4s + stride);		      \
		reference4s = (unsigned *)				      \
		    ((unsigned char *) reference4s + stride);		      \
	    }								      \
	}								      \
    }

#endif				/* __SEEK_H262_9_D4_H__ */
