/*
 * h262.9.l7.h
 * Copyright (C) 2004, 2005, 2006  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __SEEK_H262_9_L7_H__
#define __SEEK_H262_9_L7_H__

#include <h262.0.h>
#if SIZEOF_LONG == 8
# include <h262.4.l7.h>
#else
# include <h262.5.l7.h>
#endif				/* SIZEOF_LONG == 8 */

#define wideblock_0_0_x(predictions, references, stride, line_size, SELECTOR) \
    {									      \
	wideblock_0__x_##SELECTOR					      \
	    (predictions, references, stride, line_size, WIDE_REFERENCE_1_1); \
    }

#if 0
# undef block_0_0_4

# define block_0_0_4(predictions, references, stride, line_size) \
    wideblock_0_0_x(predictions, references, stride, line_size, 4)
#endif				/* 0 */

#if 0
# undef block_0_0_5

# define block_0_0_5(predictions, references, stride, line_size) \
    wideblock_0_0_x(predictions, references, stride, line_size, 5)
#endif				/* 0 */

#if 0
# undef block_0_0_6

# define block_0_0_6(predictions, references, stride, line_size) \
    wideblock_0_0_x(predictions, references, stride, line_size, 6)
#endif				/* 0 */

#if 0
# undef block_0_0_7

# define block_0_0_7(predictions, references, stride, line_size) \
    wideblock_0_0_x(predictions, references, stride, line_size, 7)
#endif				/* 0 */

#define wideblock_0_1_x(predictions, references, stride, line_size, SELECTOR) \
    {									      \
	wideblock_0__x_##SELECTOR					      \
	    (predictions, references, stride, line_size, WIDE_REFERENCE_2_1); \
    }

#undef block_0_1_4

#define block_0_1_4(predictions, references, stride, line_size) \
    wideblock_0_1_x(predictions, references, stride, line_size, 4)

#undef block_0_1_5

#define block_0_1_5(predictions, references, stride, line_size) \
    wideblock_0_1_x(predictions, references, stride, line_size, 5)

#undef block_0_1_6

#define block_0_1_6(predictions, references, stride, line_size) \
    wideblock_0_1_x(predictions, references, stride, line_size, 6)

#undef block_0_1_7

#define block_0_1_7(predictions, references, stride, line_size) \
    wideblock_0_1_x(predictions, references, stride, line_size, 7)

#define wideblock_0_2_x(predictions, references, stride, line_size, SELECTOR) \
    {									      \
	wideblock_0__x_##SELECTOR					      \
	    (predictions, references, stride, line_size, WIDE_REFERENCE_1_2); \
    }

#undef block_0_2_4

#define block_0_2_4(predictions, references, stride, line_size) \
    wideblock_0_2_x(predictions, references, stride, line_size, 4)

#undef block_0_2_5

#define block_0_2_5(predictions, references, stride, line_size) \
    wideblock_0_2_x(predictions, references, stride, line_size, 5)

#undef block_0_2_6

#define block_0_2_6(predictions, references, stride, line_size) \
    wideblock_0_2_x(predictions, references, stride, line_size, 6)

#undef block_0_2_7

#define block_0_2_7(predictions, references, stride, line_size) \
    wideblock_0_2_x(predictions, references, stride, line_size, 7)

#define wideblock_0_3_x(predictions, references, stride, line_size, SELECTOR) \
    {									      \
	wideblock_0__x_##SELECTOR					      \
	    (predictions, references, stride, line_size, WIDE_REFERENCE_2_2); \
    }

#undef block_0_3_4

#define block_0_3_4(predictions, references, stride, line_size) \
    wideblock_0_3_x(predictions, references, stride, line_size, 4)

#undef block_0_3_5

#define block_0_3_5(predictions, references, stride, line_size) \
    wideblock_0_3_x(predictions, references, stride, line_size, 5)

#undef block_0_3_6

#define block_0_3_6(predictions, references, stride, line_size) \
    wideblock_0_3_x(predictions, references, stride, line_size, 6)

#undef block_0_3_7

#define block_0_3_7(predictions, references, stride, line_size) \
    wideblock_0_3_x(predictions, references, stride, line_size, 7)

#define wideblock_1_0_x(predictions, references_0, references_1, stride, \
			line_size, SELECTOR)				      \
    {									      \
	wideblock_1__x_##SELECTOR					      \
	    (predictions, references_0, references_1, stride, line_size,      \
	     WIDE_REFERENCE_1_1_1_1);					      \
    }

#undef block_1_0_4

#define block_1_0_4(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_0_x(predictions, references_0, references_1, stride,	      \
		    line_size, 4)

#undef block_1_0_5

#define block_1_0_5(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_0_x(predictions, references_0, references_1, stride,	      \
		    line_size, 5)

#undef block_1_0_6

#define block_1_0_6(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_0_x(predictions, references_0, references_1, stride,	      \
		    line_size, 6)

#undef block_1_0_7

#define block_1_0_7(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_0_x(predictions, references_0, references_1, stride,	      \
		    line_size, 7)

#define wideblock_1_1_x(predictions, references_0, references_1, stride, \
			line_size, SELECTOR)				      \
    {									      \
	wideblock_1__x_##SELECTOR					      \
	    (predictions, references_0, references_1, stride, line_size,      \
	     WIDE_REFERENCE_1_1_2_1);					      \
    }

#undef block_1_1_4

#define block_1_1_4(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_1_x(predictions, references_0, references_1, stride,	      \
		    line_size, 4)

#undef block_1_1_5

#define block_1_1_5(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_1_x(predictions, references_0, references_1, stride,	      \
		    line_size, 5)

#undef block_1_1_6

#define block_1_1_6(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_1_x(predictions, references_0, references_1, stride,	      \
		    line_size, 6)

#undef block_1_1_7

#define block_1_1_7(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_1_x(predictions, references_0, references_1, stride,	      \
		    line_size, 7)

#define wideblock_1_2_x(predictions, references_0, references_1, stride, \
			line_size, SELECTOR)				      \
    {									      \
	wideblock_1__x_##SELECTOR					      \
	    (predictions, references_0, references_1, stride, line_size,      \
	     WIDE_REFERENCE_1_1_1_2);					      \
    }

#undef block_1_2_4

#define block_1_2_4(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_2_x(predictions, references_0, references_1, stride,	      \
		    line_size, 4)

#undef block_1_2_5

#define block_1_2_5(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_2_x(predictions, references_0, references_1, stride,	      \
		    line_size, 5)

#undef block_1_2_6

#define block_1_2_6(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_2_x(predictions, references_0, references_1, stride,	      \
		    line_size, 6)

#undef block_1_2_7

#define block_1_2_7(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_2_x(predictions, references_0, references_1, stride,	      \
		    line_size, 7)

#define wideblock_1_3_x(predictions, references_0, references_1, stride, \
			line_size, SELECTOR)				      \
    {									      \
	wideblock_1__x_##SELECTOR					      \
	    (predictions, references_0, references_1, stride, line_size,      \
	     WIDE_REFERENCE_1_1_2_2);					      \
    }

#undef block_1_3_4

#define block_1_3_4(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_3_x(predictions, references_0, references_1, stride,	      \
		    line_size, 4)

#undef block_1_3_5

#define block_1_3_5(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_3_x(predictions, references_0, references_1, stride,	      \
		    line_size, 5)

#undef block_1_3_6

#define block_1_3_6(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_3_x(predictions, references_0, references_1, stride,	      \
		    line_size, 6)

#undef block_1_3_7

#define block_1_3_7(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_3_x(predictions, references_0, references_1, stride,	      \
		    line_size, 7)

#define wideblock_1_4_x(predictions, references_0, references_1, stride, \
			line_size, SELECTOR)				      \
    {									      \
	wideblock_1__x_##SELECTOR					      \
	    (predictions, references_0, references_1, stride, line_size,      \
	     WIDE_REFERENCE_2_1_1_1);					      \
    }

#undef block_1_4_4

#define block_1_4_4(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_4_x(predictions, references_0, references_1, stride,	      \
		    line_size, 4)

#undef block_1_4_5

#define block_1_4_5(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_4_x(predictions, references_0, references_1, stride,	      \
		    line_size, 5)

#undef block_1_4_6

#define block_1_4_6(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_4_x(predictions, references_0, references_1, stride,	      \
		    line_size, 6)

#undef block_1_4_7

#define block_1_4_7(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_4_x(predictions, references_0, references_1, stride,	      \
		    line_size, 7)

#define wideblock_1_5_x(predictions, references_0, references_1, stride, \
			line_size, SELECTOR)				      \
    {									      \
	wideblock_1__x_##SELECTOR					      \
	    (predictions, references_0, references_1, stride, line_size,      \
	     WIDE_REFERENCE_2_1_2_1);					      \
    }

#undef block_1_5_4

#define block_1_5_4(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_5_x(predictions, references_0, references_1, stride,	      \
		    line_size, 4)

#undef block_1_5_5

#define block_1_5_5(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_5_x(predictions, references_0, references_1, stride,	      \
		    line_size, 5)

#undef block_1_5_6

#define block_1_5_6(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_5_x(predictions, references_0, references_1, stride,	      \
		    line_size, 6)

#undef block_1_5_7

#define block_1_5_7(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_5_x(predictions, references_0, references_1, stride,	      \
		    line_size, 7)

#define wideblock_1_6_x(predictions, references_0, references_1, stride, \
			line_size, SELECTOR)				      \
    {									      \
	wideblock_1__x_##SELECTOR					      \
	    (predictions, references_0, references_1, stride, line_size,      \
	     WIDE_REFERENCE_2_1_1_2);					      \
    }

#undef block_1_6_4

#define block_1_6_4(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_6_x(predictions, references_0, references_1, stride,	      \
		    line_size, 4)

#undef block_1_6_5

#define block_1_6_5(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_6_x(predictions, references_0, references_1, stride,	      \
		    line_size, 5)

#undef block_1_6_6

#define block_1_6_6(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_6_x(predictions, references_0, references_1, stride,	      \
		    line_size, 6)

#undef block_1_6_7

#define block_1_6_7(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_6_x(predictions, references_0, references_1, stride,	      \
		    line_size, 7)

#define wideblock_1_7_x(predictions, references_0, references_1, stride, \
			line_size, SELECTOR)				      \
    {									      \
	wideblock_1__x_##SELECTOR					      \
	    (predictions, references_0, references_1, stride, line_size,      \
	     WIDE_REFERENCE_2_1_2_2);					      \
    }

#undef block_1_7_4

#define block_1_7_4(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_7_x(predictions, references_0, references_1, stride,	      \
		    line_size, 4)

#undef block_1_7_5

#define block_1_7_5(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_7_x(predictions, references_0, references_1, stride,	      \
		    line_size, 5)

#undef block_1_7_6

#define block_1_7_6(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_7_x(predictions, references_0, references_1, stride,	      \
		    line_size, 6)

#undef block_1_7_7

#define block_1_7_7(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_7_x(predictions, references_0, references_1, stride,	      \
		    line_size, 7)

#define wideblock_1_8_x(predictions, references_0, references_1, stride, \
			line_size, SELECTOR)				      \
    {									      \
	wideblock_1__x_##SELECTOR					      \
	    (predictions, references_0, references_1, stride, line_size,      \
	     WIDE_REFERENCE_1_2_1_1);					      \
    }

#undef block_1_8_4

#define block_1_8_4(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_8_x(predictions, references_0, references_1, stride,	      \
		    line_size, 4)

#undef block_1_8_5

#define block_1_8_5(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_8_x(predictions, references_0, references_1, stride,	      \
		    line_size, 5)

#undef block_1_8_6

#define block_1_8_6(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_8_x(predictions, references_0, references_1, stride,	      \
		    line_size, 6)

#undef block_1_8_7

#define block_1_8_7(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_8_x(predictions, references_0, references_1, stride,	      \
		    line_size, 7)

#define wideblock_1_9_x(predictions, references_0, references_1, stride, \
			line_size, SELECTOR)				      \
    {									      \
	wideblock_1__x_##SELECTOR					      \
	    (predictions, references_0, references_1, stride, line_size,      \
	     WIDE_REFERENCE_1_2_2_1);					      \
    }

#undef block_1_9_4

#define block_1_9_4(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_9_x(predictions, references_0, references_1, stride,	      \
		    line_size, 4)

#undef block_1_9_5

#define block_1_9_5(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_9_x(predictions, references_0, references_1, stride,	      \
		    line_size, 5)

#undef block_1_9_6

#define block_1_9_6(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_9_x(predictions, references_0, references_1, stride,	      \
		    line_size, 6)

#undef block_1_9_7

#define block_1_9_7(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_9_x(predictions, references_0, references_1, stride,	      \
		    line_size, 7)

#define wideblock_1_a_x(predictions, references_0, references_1, stride, \
			line_size, SELECTOR)				      \
    {									      \
	wideblock_1__x_##SELECTOR					      \
	    (predictions, references_0, references_1, stride, line_size,      \
	     WIDE_REFERENCE_1_2_1_2);					      \
    }

#undef block_1_a_4

#define block_1_a_4(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_a_x(predictions, references_0, references_1, stride,	      \
		    line_size, 4)

#undef block_1_a_5

#define block_1_a_5(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_a_x(predictions, references_0, references_1, stride,	      \
		    line_size, 5)

#undef block_1_a_6

#define block_1_a_6(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_a_x(predictions, references_0, references_1, stride,	      \
		    line_size, 6)

#undef block_1_a_7

#define block_1_a_7(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_a_x(predictions, references_0, references_1, stride,	      \
		    line_size, 7)

#define wideblock_1_b_x(predictions, references_0, references_1, stride, \
			line_size, SELECTOR)				      \
    {									      \
	wideblock_1__x_##SELECTOR					      \
	    (predictions, references_0, references_1, stride, line_size,      \
	     WIDE_REFERENCE_1_2_2_2);					      \
    }

#undef block_1_b_4

#define block_1_b_4(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_b_x(predictions, references_0, references_1, stride,	      \
		    line_size, 4)

#undef block_1_b_5

#define block_1_b_5(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_b_x(predictions, references_0, references_1, stride,	      \
		    line_size, 5)

#undef block_1_b_6

#define block_1_b_6(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_b_x(predictions, references_0, references_1, stride,	      \
		    line_size, 6)

#undef block_1_b_7

#define block_1_b_7(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_b_x(predictions, references_0, references_1, stride,	      \
		    line_size, 7)

#define wideblock_1_c_x(predictions, references_0, references_1, stride, \
			line_size, SELECTOR)				      \
    {									      \
	wideblock_1__x_##SELECTOR					      \
	    (predictions, references_0, references_1, stride, line_size,      \
	     WIDE_REFERENCE_2_2_1_1);					      \
    }

#undef block_1_c_4

#define block_1_c_4(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_c_x(predictions, references_0, references_1, stride,	      \
		    line_size, 4)

#undef block_1_c_5

#define block_1_c_5(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_c_x(predictions, references_0, references_1, stride,	      \
		    line_size, 5)

#undef block_1_c_6

#define block_1_c_6(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_c_x(predictions, references_0, references_1, stride,	      \
		    line_size, 6)

#undef block_1_c_7

#define block_1_c_7(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_c_x(predictions, references_0, references_1, stride,	      \
		    line_size, 7)

#define wideblock_1_d_x(predictions, references_0, references_1, stride, \
			line_size, SELECTOR)				      \
    {									      \
	wideblock_1__x_##SELECTOR					      \
	    (predictions, references_0, references_1, stride, line_size,      \
	     WIDE_REFERENCE_2_2_2_1);					      \
    }

#undef block_1_d_4

#define block_1_d_4(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_d_x(predictions, references_0, references_1, stride,	      \
		    line_size, 4)

#undef block_1_d_5

#define block_1_d_5(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_d_x(predictions, references_0, references_1, stride,	      \
		    line_size, 5)

#undef block_1_d_6

#define block_1_d_6(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_d_x(predictions, references_0, references_1, stride,	      \
		    line_size, 6)

#undef block_1_d_7

#define block_1_d_7(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_d_x(predictions, references_0, references_1, stride,	      \
		    line_size, 7)

#define wideblock_1_e_x(predictions, references_0, references_1, stride, \
			line_size, SELECTOR)				      \
    {									      \
	wideblock_1__x_##SELECTOR					      \
	    (predictions, references_0, references_1, stride, line_size,      \
	     WIDE_REFERENCE_2_2_1_2);					      \
    }

#undef block_1_e_4

#define block_1_e_4(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_e_x(predictions, references_0, references_1, stride,	      \
		    line_size, 4)

#undef block_1_e_5

#define block_1_e_5(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_e_x(predictions, references_0, references_1, stride,	      \
		    line_size, 5)

#undef block_1_e_6

#define block_1_e_6(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_e_x(predictions, references_0, references_1, stride,	      \
		    line_size, 6)

#undef block_1_e_7

#define block_1_e_7(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_e_x(predictions, references_0, references_1, stride,	      \
		    line_size, 7)

#define wideblock_1_f_x(predictions, references_0, references_1, stride, \
			line_size, SELECTOR)				      \
    {									      \
	wideblock_1__x_##SELECTOR					      \
	    (predictions, references_0, references_1, stride, line_size,      \
	     WIDE_REFERENCE_2_2_2_2);					      \
    }

#undef block_1_f_4

#define block_1_f_4(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_f_x(predictions, references_0, references_1, stride,	      \
		    line_size, 4)

#undef block_1_f_5

#define block_1_f_5(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_f_x(predictions, references_0, references_1, stride,	      \
		    line_size, 5)

#undef block_1_f_6

#define block_1_f_6(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_f_x(predictions, references_0, references_1, stride,	      \
		    line_size, 6)

#undef block_1_f_7

#define block_1_f_7(predictions, references_0, references_1, stride, \
		    line_size)						      \
    wideblock_1_f_x(predictions, references_0, references_1, stride,	      \
		    line_size, 7)

#endif				/* __SEEK_H262_9_L7_H__ */
