/*
 * h262.9.part3.c
 * Copyright (C) 2003, 2004, 2005, 2006  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <h262.1.h>

void
seek_h262_inverse_matrix_coefficients(unsigned matrix_coefficients,
				      double *matrix_coefficients_out)
{
    double bu, gb, gr, rv, ub, ug, vg, vr;
    const int *coefficients;

    seek_h262_matrix_coefficients(matrix_coefficients, &coefficients);

    gb = (double) -coefficients[1] / coefficients[0];
    gr = (double) -coefficients[2] / coefficients[0];

    ub = (double) coefficients[4] / 10000;
    ug = (double) coefficients[3] / 10000;

    ub = ub + ug * gb;

    bu = (double) 1 / ub;

    vg = (double) coefficients[6] / 10000;
    vr = (double) coefficients[8] / 10000;

    vr = vr + vg * gr;

    rv = (double) 1 / vr;

    matrix_coefficients_out[6] = 1;
    matrix_coefficients_out[7] = 0;
    matrix_coefficients_out[8] = rv;

    matrix_coefficients_out[3] = 1;
    matrix_coefficients_out[4] = bu;
    matrix_coefficients_out[5] = 0;

    matrix_coefficients_out[0] = 1;
    matrix_coefficients_out[1] = gb * bu;
    matrix_coefficients_out[2] = gr * rv;
}
