/*
 * h262.a.h
 * Copyright (C) 2003, 2004, 2005, 2006, 2007, 2008  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __SEEK_H262_A_H__
#define __SEEK_H262_A_H__

/*
 * system error definitions
 */
#define SYSTEM_BAD_IMPLEMENTATION	0x02
#define SYSTEM_FAILED_PACK_HEADER_MARKER \
					0x03
#define SYSTEM_FAILED_PACK_MARKER	0x04
#define SYSTEM_FAILED_PES_PACKET_MARKER	0x05
#define SYSTEM_FAILED_P_STD_BUFFER_MARKER \
					0x06
#define SYSTEM_FAILED_STUFFING_BYTE	0x07
#define SYSTEM_IMPROPER_START_CODE	0x08
#define SYSTEM_INVALID_HEADER_LENGTH	0x09
#define SYSTEM_INVALID_PACKET		0x0a
#define SYSTEM_INVALID_PACKET_LENGTH	0x0b
#define SYSTEM_INVALID_PES_HEADER_DATA_LENGTH \
					0x0c
#define SYSTEM_INVALID_PES_PACKET_LENGTH \
					0x0d
#define SYSTEM_INVALID_PROGRAM_STREAM_DIRECTORY_PES_PACKET \
					0x0e
#define SYSTEM_INVALID_PROGRAM_STREAM_MAP_PES_PACKET \
					0x0f
#define SYSTEM_INVALID_PTS_DTS_FLAGS	0x10
#define SYSTEM_UNSET_MARKER_BIT		0x11
#define SYSTEM_UNSET_MARKER_BITS	0x12

#define SYSTEM_NUMBER_OF_ERROR_CODES	0x13

/*
 * transport error definitions
 */
#define TRANSPORT_INVALID_ADAPTATION_FIELD_LENGTH \
					0x01

#define TRANSPORT_NUMBER_OF_ERROR_CODES	0x02

/*
 * video error definitions
 */
#define VIDEO_CHANGED_ASPECT_RATIO_INFORMATION \
					0x02
#define VIDEO_CHANGED_BIT_RATE_EXTENSION \
					0x03
#define VIDEO_CHANGED_BIT_RATE_VALUE	0x04
#define VIDEO_CHANGED_CHROMA_FORMAT	0x05
#define VIDEO_CHANGED_CONSTRAINED_PARAMETERS_FLAG \
					0x06
#define VIDEO_CHANGED_FRAME_RATE_CODE	0x07
#define VIDEO_CHANGED_FRAME_RATE_EXTENSION_D \
					0x08
#define VIDEO_CHANGED_FRAME_RATE_EXTENSION_N \
					0x09
#define VIDEO_CHANGED_HORIZONTAL_SIZE_EXTENSION \
					0x0a
#define VIDEO_CHANGED_HORIZONTAL_SIZE_VALUE \
					0x0b
#define VIDEO_CHANGED_LOW_DELAY		0x0d
#define VIDEO_CHANGED_PROFILE_AND_LEVEL_INDICATION \
					0x0e
#define VIDEO_CHANGED_PROGRESSIVE_SEQUENCE \
					0x0f
#define VIDEO_CHANGED_SEQUENCE_DISPLAY_EXTENSION \
					0x10
#define VIDEO_CHANGED_SEQUENCE_EXTENSION \
					0x11
#define VIDEO_CHANGED_SEQUENCE_HEADER	0x12
#define VIDEO_CHANGED_SEQUENCE_SCALABLE_EXTENSION \
					0x13
#define VIDEO_CHANGED_VBV_BUFFER_SIZE_EXTENSION \
					0x14
#define VIDEO_CHANGED_VBV_BUFFER_SIZE_VALUE \
					0x15
#define VIDEO_CHANGED_VERTICAL_SIZE_EXTENSION \
					0x16
#define VIDEO_CHANGED_VERTICAL_SIZE_VALUE \
					0x17
#define VIDEO_IMPROPER_INTRA_QUANTISER	0x18
#define VIDEO_IMPROPER_START_CODE	0x19
#define VIDEO_INVALID_11172_PICTURE_HEADER_INFORMATION \
					0x1a
#define VIDEO_INVALID_CHROMA_FORMAT	0x1b
#define VIDEO_INVALID_CHROMA_INTRA_QUANTISER \
					0x1c
#define VIDEO_INVALID_CODE		0x1d
#define VIDEO_INVALID_ESCAPE_CODE	0x1e
#define VIDEO_INVALID_EXTENSION_IDENTIFIER \
					0x1f
#define VIDEO_INVALID_FIELD_FRAME_PRED_FRAME_DCT \
					0x20
#define VIDEO_INVALID_FIELD_PICTURE_CODING_TYPE \
					0x21
#define VIDEO_INVALID_FIELD_TEMPORAL_REFERENCE \
					0x22
#define VIDEO_INVALID_F_CODES		0x23
#define VIDEO_INVALID_F_CODE_0__0_	0x24
#define VIDEO_INVALID_F_CODE_0__1_	0x25
#define VIDEO_INVALID_F_CODE_1__0_	0x26
#define VIDEO_INVALID_F_CODE_1__1_	0x27
#define VIDEO_INVALID_INTRA_QUANTISER	0x28
#define VIDEO_INVALID_MACROBLOCK_ADDRESS_INCREMENT \
					0x29
#define VIDEO_INVALID_MACROBLOCK_TYPE	0x2a
#define VIDEO_INVALID_MOTION_TYPE	0x2b
#define VIDEO_INVALID_PICTURE_CODING_TYPE \
					0x2c
#define VIDEO_INVALID_PICTURE_STRUCTURE	0x2d
#define VIDEO_INVALID_PROGRESSIVE_FRAME_PRED_FRAME_DCT \
					0x2e
#define VIDEO_INVALID_PROGRESSIVE_SEQUENCE_PICTURE_STRUCTURE \
					0x2f
#define VIDEO_INVALID_REPEAT_FIRST_FIELD \
					0x30
#define VIDEO_INVALID_SEQUENCE_HEADER	0x31
#define VIDEO_INVALID_SLICE_START_CODE	0x32
#define VIDEO_INVALID_TIME_CODE		0x33
#define VIDEO_MISSING_SEQUENCE_DISPLAY_EXTENSION \
					0x34
#define VIDEO_MISSING_SEQUENCE_SCALABLE_EXTENSION \
					0x35
#define VIDEO_MISS_F_CODE_0__0_		0x36
#define VIDEO_MISS_F_CODE_0__1_		0x37
#define VIDEO_MISS_F_CODE_1__0_		0x38
#define VIDEO_MISS_F_CODE_1__1_		0x39
#define VIDEO_NULL_CHROMA_INTRA_QUANTISER \
					0x3a
#define VIDEO_NULL_CHROMA_NON_INTRA_QUANTISER \
					0x3b
#define VIDEO_NULL_F_CODE_0__0_		0x3c
#define VIDEO_NULL_F_CODE_0__1_		0x3d
#define VIDEO_NULL_F_CODE_1__0_		0x3e
#define VIDEO_NULL_F_CODE_1__1_		0x3f
#define VIDEO_NULL_INTRA_QUANTISER	0x40
#define VIDEO_NULL_MACROBLOCK_QUANTISER_SCALE \
					0x41
#define VIDEO_NULL_NON_INTRA_QUANTISER	0x42
#define VIDEO_NULL_SLICE_QUANTISER_SCALE \
					0x43
#define VIDEO_SLICE_FAULT		0x44
#define VIDEO_UNEXPECTED_PICTURE_DISPLAY_EXTENSION \
					0x45
#define VIDEO_UNEXPECTED_SEQUENCE_END_CODE \
					0x46
#define VIDEO_UNSET_MARKER_BIT		0x47
#define VIDEO_UNSET_MARKER_BITS		0x48

#define VIDEO_NUMBER_OF_ERROR_CODES	0x49

/*
 * whatever error definitions
 */
#define WHATEVER_FAILED_START_CODE_LOOKUP \
					0x01

#endif				/* __SEEK_H262_A_H__ */
