/*
 * h262.b.c
 * Copyright (C) 2003, 2004, 2005  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <h262.0.h>
#include <h262.1.h>
#include <h262.3.h>
#include <h262.8.h>
#if !WORDS_BIGENDIAN
# include <h262.8.l7.h>
#endif				/* !WORDS_BIGENDIAN */
#if SIZEOF_LONG != 8
# include <h262.9.d4.h>
#endif				/* SIZEOF_LONG != 8 */
#if !WORDS_BIGENDIAN
# include <h262.a.l7.h>
#endif				/* !WORDS_BIGENDIAN */
#if SIZEOF_LONG == 8
# include <h262.b.d4.h>
#endif				/* SIZEOF_LONG == 8 */
/*#include <h262.c.h>*/

#define __RUN_FUTILE__			0

#define ARGS_0__0_0 \
    unsigned char *, unsigned char *, unsigned
#define ARGS_0__0_1 \
    unsigned char *predictions, unsigned char *references, unsigned line_size
#define ARGS_0__0_2 \
    predictions, references, line_size, line_size

#define ARGS_0__1_0 \
    unsigned char *, unsigned char *, unsigned
#define ARGS_0__1_1 \
    unsigned char *predictions, unsigned char *references, unsigned line_size
#define ARGS_0__1_2 \
    predictions, references, line_size, line_size

#define ARGS_0__2_0 \
    unsigned char *, unsigned char *, unsigned
#define ARGS_0__2_1 \
    unsigned char *predictions, unsigned char *references, unsigned line_size
#define ARGS_0__2_2 \
    predictions, references, line_size, line_size

#define ARGS_0__3_0 \
    unsigned char *, unsigned char *, unsigned
#define ARGS_0__3_1 \
    unsigned char *predictions, unsigned char *references, unsigned line_size
#define ARGS_0__3_2 \
    predictions, references, line_size, line_size

#define ARGS_1__0_0 \
    unsigned char *, unsigned char *, unsigned char *, unsigned
#define ARGS_1__0_1 \
    unsigned char *predictions, unsigned char *references_0,		      \
    unsigned char *references_1, unsigned line_size
#define ARGS_1__0_2 \
    predictions, references_0, references_1, line_size, line_size

#define ARGS_1__1_0 \
    unsigned char *, unsigned char *, unsigned char *, unsigned
#define ARGS_1__1_1 \
    unsigned char *predictions, unsigned char *references_0,		      \
    unsigned char *references_1, unsigned line_size
#define ARGS_1__1_2 \
    predictions, references_0, references_1, line_size, line_size

#define ARGS_1__2_0 \
    unsigned char *, unsigned char *, unsigned char *, unsigned
#define ARGS_1__2_1 \
    unsigned char *predictions, unsigned char *references_0,		      \
    unsigned char *references_1, unsigned line_size
#define ARGS_1__2_2 \
    predictions, references_0, references_1, line_size, line_size

#define ARGS_1__3_0 \
    unsigned char *, unsigned char *, unsigned char *, unsigned
#define ARGS_1__3_1 \
    unsigned char *predictions, unsigned char *references_0,		      \
    unsigned char *references_1, unsigned line_size
#define ARGS_1__3_2 \
    predictions, references_0, references_1, line_size, line_size

#if __RUN_FUTILE__
# define PSYCHIATRIC(name, args)
#else
# define PSYCHIATRIC(name, args)	name(args)
#endif				/* __RUN_FUTILE__ */

#if __Berkeley_FUCK_UP__
static void xBerkeley_block_0(ARGS_0__0_0);
static void xBerkeley_block_1(ARGS_0__1_0);
static void xBerkeley_block_2(ARGS_0__2_0);
static void xBerkeley_block_3(ARGS_0__3_0);
#endif				/* __Berkeley_FUCK_UP__ */
static void xblock_0_0_0(ARGS_0__0_0);
static void xblock_0_0_1(ARGS_0__1_0);
static void xblock_0_0_2(ARGS_0__2_0);
static void xblock_0_0_3(ARGS_0__3_0);
static void xblock_0_1_0(ARGS_0__0_0);
static void xblock_0_1_1(ARGS_0__1_0);
static void xblock_0_1_2(ARGS_0__2_0);
static void xblock_0_1_3(ARGS_0__3_0);
static void xblock_0_2_0(ARGS_0__0_0);
static void xblock_0_2_1(ARGS_0__1_0);
static void xblock_0_2_2(ARGS_0__2_0);
static void xblock_0_2_3(ARGS_0__3_0);
static void xblock_0_3_0(ARGS_0__0_0);
static void xblock_0_3_1(ARGS_0__1_0);
static void xblock_0_3_2(ARGS_0__2_0);
static void xblock_0_3_3(ARGS_0__3_0);
static void xblock_1_0_0(ARGS_1__0_0);
static void xblock_1_0_1(ARGS_1__1_0);
static void xblock_1_0_2(ARGS_1__2_0);
static void xblock_1_0_3(ARGS_1__3_0);
static void xblock_1_1_0(ARGS_1__0_0);
static void xblock_1_1_1(ARGS_1__1_0);
static void xblock_1_1_2(ARGS_1__2_0);
static void xblock_1_1_3(ARGS_1__3_0);
static void xblock_1_2_0(ARGS_1__0_0);
static void xblock_1_2_1(ARGS_1__1_0);
static void xblock_1_2_2(ARGS_1__2_0);
static void xblock_1_2_3(ARGS_1__3_0);
static void xblock_1_3_0(ARGS_1__0_0);
static void xblock_1_3_1(ARGS_1__1_0);
static void xblock_1_3_2(ARGS_1__2_0);
static void xblock_1_3_3(ARGS_1__3_0);
static void xblock_1_4_0(ARGS_1__0_0);
static void xblock_1_4_1(ARGS_1__1_0);
static void xblock_1_4_2(ARGS_1__2_0);
static void xblock_1_4_3(ARGS_1__3_0);
static void xblock_1_5_0(ARGS_1__0_0);
static void xblock_1_5_1(ARGS_1__1_0);
static void xblock_1_5_2(ARGS_1__2_0);
static void xblock_1_5_3(ARGS_1__3_0);
static void xblock_1_6_0(ARGS_1__0_0);
static void xblock_1_6_1(ARGS_1__1_0);
static void xblock_1_6_2(ARGS_1__2_0);
static void xblock_1_6_3(ARGS_1__3_0);
static void xblock_1_7_0(ARGS_1__0_0);
static void xblock_1_7_1(ARGS_1__1_0);
static void xblock_1_7_2(ARGS_1__2_0);
static void xblock_1_7_3(ARGS_1__3_0);
static void xblock_1_8_0(ARGS_1__0_0);
static void xblock_1_8_1(ARGS_1__1_0);
static void xblock_1_8_2(ARGS_1__2_0);
static void xblock_1_8_3(ARGS_1__3_0);
static void xblock_1_9_0(ARGS_1__0_0);
static void xblock_1_9_1(ARGS_1__1_0);
static void xblock_1_9_2(ARGS_1__2_0);
static void xblock_1_9_3(ARGS_1__3_0);
static void xblock_1_a_0(ARGS_1__0_0);
static void xblock_1_a_1(ARGS_1__1_0);
static void xblock_1_a_2(ARGS_1__2_0);
static void xblock_1_a_3(ARGS_1__3_0);
static void xblock_1_b_0(ARGS_1__0_0);
static void xblock_1_b_1(ARGS_1__1_0);
static void xblock_1_b_2(ARGS_1__2_0);
static void xblock_1_b_3(ARGS_1__3_0);
static void xblock_1_c_0(ARGS_1__0_0);
static void xblock_1_c_1(ARGS_1__1_0);
static void xblock_1_c_2(ARGS_1__2_0);
static void xblock_1_c_3(ARGS_1__3_0);
static void xblock_1_d_0(ARGS_1__0_0);
static void xblock_1_d_1(ARGS_1__1_0);
static void xblock_1_d_2(ARGS_1__2_0);
static void xblock_1_d_3(ARGS_1__3_0);
static void xblock_1_e_0(ARGS_1__0_0);
static void xblock_1_e_1(ARGS_1__1_0);
static void xblock_1_e_2(ARGS_1__2_0);
static void xblock_1_e_3(ARGS_1__3_0);
static void xblock_1_f_0(ARGS_1__0_0);
static void xblock_1_f_1(ARGS_1__1_0);
static void xblock_1_f_2(ARGS_1__2_0);
static void xblock_1_f_3(ARGS_1__3_0);

seek_h262_constructOr _seek_h262_block_1_0_0[] = {
/* *INDENT-OFF* */
    xblock_1_0_3,
    xblock_1_1_3,
    xblock_1_2_3,
    xblock_1_3_3,
    xblock_1_4_3,
    xblock_1_5_3,
    xblock_1_6_3,
    xblock_1_7_3,
    xblock_1_8_3,
    xblock_1_9_3,
    xblock_1_a_3,
    xblock_1_b_3,
    xblock_1_c_3,
    xblock_1_d_3,
    xblock_1_e_3,
    xblock_1_f_3
/* *INDENT-ON* */
#if __Berkeley_FUCK_UP__ == 1
}, _seek_h262_block_1_0_1[] = {
/* *INDENT-OFF* */
    xblock_1_0_3,
    xblock_1_0_3,
    xblock_1_0_3,
    xblock_1_0_3,
    xblock_1_0_3,
    xblock_1_0_3,
    xblock_1_0_3,
    xblock_1_0_3,
    xblock_1_0_3,
    xblock_1_0_3,
    xblock_1_0_3,
    xblock_1_0_3,
    xblock_1_0_3,
    xblock_1_0_3,
    xblock_1_0_3,
    xblock_1_0_3
/* *INDENT-ON* */
#endif				/* __Berkeley_FUCK_UP__ == 1 */
}, _seek_h262_block_1_1_0[] = {
/* *INDENT-OFF* */
    xblock_1_0_2,
    xblock_1_1_2,
    xblock_1_2_2,
    xblock_1_3_2,
    xblock_1_4_2,
    xblock_1_5_2,
    xblock_1_6_2,
    xblock_1_7_2,
    xblock_1_8_2,
    xblock_1_9_2,
    xblock_1_a_2,
    xblock_1_b_2,
    xblock_1_c_2,
    xblock_1_d_2,
    xblock_1_e_2,
    xblock_1_f_2
/* *INDENT-ON* */
#if __Berkeley_FUCK_UP__ == 1
}, _seek_h262_block_1_1_1[] = {
/* *INDENT-OFF* */
    xblock_1_0_2,
    xblock_1_0_2,
    xblock_1_0_2,
    xblock_1_0_2,
    xblock_1_0_2,
    xblock_1_0_2,
    xblock_1_0_2,
    xblock_1_0_2,
    xblock_1_0_2,
    xblock_1_0_2,
    xblock_1_0_2,
    xblock_1_0_2,
    xblock_1_0_2,
    xblock_1_0_2,
    xblock_1_0_2,
    xblock_1_0_2
/* *INDENT-ON* */
#endif				/* __Berkeley_FUCK_UP__ == 1 */
}, _seek_h262_block_1_2_0[] = {
/* *INDENT-OFF* */
    xblock_1_0_1,
    xblock_1_1_1,
    xblock_1_2_1,
    xblock_1_3_1,
    xblock_1_4_1,
    xblock_1_5_1,
    xblock_1_6_1,
    xblock_1_7_1,
    xblock_1_8_1,
    xblock_1_9_1,
    xblock_1_a_1,
    xblock_1_b_1,
    xblock_1_c_1,
    xblock_1_d_1,
    xblock_1_e_1,
    xblock_1_f_1
/* *INDENT-ON* */
#if __Berkeley_FUCK_UP__ == 1
}, _seek_h262_block_1_2_1[] = {
/* *INDENT-OFF* */
    xblock_1_0_1,
    xblock_1_0_1,
    xblock_1_0_1,
    xblock_1_0_1,
    xblock_1_0_1,
    xblock_1_0_1,
    xblock_1_0_1,
    xblock_1_0_1,
    xblock_1_0_1,
    xblock_1_0_1,
    xblock_1_0_1,
    xblock_1_0_1,
    xblock_1_0_1,
    xblock_1_0_1,
    xblock_1_0_1,
    xblock_1_0_1
/* *INDENT-ON* */
#endif				/* __Berkeley_FUCK_UP__ == 1 */
}, _seek_h262_block_1_3_0[] = {
/* *INDENT-OFF* */
    xblock_1_0_0,
    xblock_1_1_0,
    xblock_1_2_0,
    xblock_1_3_0,
    xblock_1_4_0,
    xblock_1_5_0,
    xblock_1_6_0,
    xblock_1_7_0,
    xblock_1_8_0,
    xblock_1_9_0,
    xblock_1_a_0,
    xblock_1_b_0,
    xblock_1_c_0,
    xblock_1_d_0,
    xblock_1_e_0,
    xblock_1_f_0
/* *INDENT-ON* */
#if __Berkeley_FUCK_UP__ == 1
}, _seek_h262_block_1_3_1[] = {
/* *INDENT-OFF* */
    xblock_1_0_0,
    xblock_1_0_0,
    xblock_1_0_0,
    xblock_1_0_0,
    xblock_1_0_0,
    xblock_1_0_0,
    xblock_1_0_0,
    xblock_1_0_0,
    xblock_1_0_0,
    xblock_1_0_0,
    xblock_1_0_0,
    xblock_1_0_0,
    xblock_1_0_0,
    xblock_1_0_0,
    xblock_1_0_0,
    xblock_1_0_0
/* *INDENT-ON* */
#endif				/* __Berkeley_FUCK_UP__ == 1 */
};
seek_h262_constructor _seek_h262_block_0_0_0[] = {
/* *INDENT-OFF* */
    xblock_0_0_3,
    xblock_0_1_3,
    xblock_0_2_3,
    xblock_0_3_3
/* *INDENT-ON* */
#if __Berkeley_FUCK_UP__ == 1
}, _seek_h262_block_0_0_1[] = {
/* *INDENT-OFF* */
    xblock_0_0_3,
    xblock_0_1_3,
    xblock_0_2_3,
    xBerkeley_block_3
/* *INDENT-ON* */
#endif				/* __Berkeley_FUCK_UP__ == 1 */
}, _seek_h262_block_0_1_0[] = {
/* *INDENT-OFF* */
    xblock_0_0_2,
    xblock_0_1_2,
    xblock_0_2_2,
    xblock_0_3_2
/* *INDENT-ON* */
#if __Berkeley_FUCK_UP__ == 1
}, _seek_h262_block_0_1_1[] = {
/* *INDENT-OFF* */
    xblock_0_0_2,
    xblock_0_1_2,
    xblock_0_2_2,
    xBerkeley_block_2
/* *INDENT-ON* */
#endif				/* __Berkeley_FUCK_UP__ == 1 */
}, _seek_h262_block_0_2_0[] = {
/* *INDENT-OFF* */
    xblock_0_0_1,
    xblock_0_1_1,
    xblock_0_2_1,
    xblock_0_3_1
/* *INDENT-ON* */
#if __Berkeley_FUCK_UP__ == 1
}, _seek_h262_block_0_2_1[] = {
/* *INDENT-OFF* */
    xblock_0_0_1,
    xblock_0_1_1,
    xblock_0_2_1,
    xBerkeley_block_1
/* *INDENT-ON* */
#endif				/* __Berkeley_FUCK_UP__ == 1 */
}, _seek_h262_block_0_3_0[] = {
/* *INDENT-OFF* */
    xblock_0_0_0,
    xblock_0_1_0,
    xblock_0_2_0,
    xblock_0_3_0
/* *INDENT-ON* */
#if __Berkeley_FUCK_UP__ == 1
}, _seek_h262_block_0_3_1[] = {
/* *INDENT-OFF* */
    xblock_0_0_0,
    xblock_0_1_0,
    xblock_0_2_0,
    xBerkeley_block_0
/* *INDENT-ON* */
#endif				/* __Berkeley_FUCK_UP__ == 1 */
};

#if __Berkeley_FUCK_UP__
static void
xBerkeley_block_0(ARGS_0__0_1)
{
    PSYCHIATRIC(Berkeley_block_0, ARGS_0__0_2);
}
#endif				/* __Berkeley_FUCK_UP__ */


#if __Berkeley_FUCK_UP__
static void
xBerkeley_block_1(ARGS_0__1_1)
{
    PSYCHIATRIC(Berkeley_block_1, ARGS_0__1_2);
}
#endif				/* __Berkeley_FUCK_UP__ */


#if __Berkeley_FUCK_UP__
static void
xBerkeley_block_2(ARGS_0__2_1)
{
    PSYCHIATRIC(Berkeley_block_2, ARGS_0__2_2);
}
#endif				/* __Berkeley_FUCK_UP__ */


#if __Berkeley_FUCK_UP__
static void
xBerkeley_block_3(ARGS_0__3_1)
{
    PSYCHIATRIC(Berkeley_block_3, ARGS_0__3_2);
}
#endif				/* __Berkeley_FUCK_UP__ */


static void
xblock_0_0_0(ARGS_0__0_1)
{
    PSYCHIATRIC(block_0_0_0, ARGS_0__0_2);
}


static void
xblock_0_0_1(ARGS_0__1_1)
{
    PSYCHIATRIC(block_0_0_1, ARGS_0__1_2);
}


static void
xblock_0_0_2(ARGS_0__2_1)
{
    PSYCHIATRIC(block_0_0_2, ARGS_0__2_2);
}


static void
xblock_0_0_3(ARGS_0__3_1)
{
    PSYCHIATRIC(block_0_0_3, ARGS_0__3_2);
}


static void
xblock_0_1_0(ARGS_0__0_1)
{
    PSYCHIATRIC(block_0_1_0, ARGS_0__0_2);
}


static void
xblock_0_1_1(ARGS_0__1_1)
{
    PSYCHIATRIC(block_0_1_1, ARGS_0__1_2);
}


static void
xblock_0_1_2(ARGS_0__2_1)
{
    PSYCHIATRIC(block_0_1_2, ARGS_0__2_2);
}


static void
xblock_0_1_3(ARGS_0__3_1)
{
    PSYCHIATRIC(block_0_1_3, ARGS_0__3_2);
}


static void
xblock_0_2_0(ARGS_0__0_1)
{
    PSYCHIATRIC(block_0_2_0, ARGS_0__0_2);
}


static void
xblock_0_2_1(ARGS_0__1_1)
{
    PSYCHIATRIC(block_0_2_1, ARGS_0__1_2);
}


static void
xblock_0_2_2(ARGS_0__2_1)
{
    PSYCHIATRIC(block_0_2_2, ARGS_0__2_2);
}


static void
xblock_0_2_3(ARGS_0__3_1)
{
    PSYCHIATRIC(block_0_2_3, ARGS_0__3_2);
}


static void
xblock_0_3_0(ARGS_0__0_1)
{
    PSYCHIATRIC(block_0_3_0, ARGS_0__0_2);
}


static void
xblock_0_3_1(ARGS_0__1_1)
{
    PSYCHIATRIC(block_0_3_1, ARGS_0__1_2);
}


static void
xblock_0_3_2(ARGS_0__2_1)
{
    PSYCHIATRIC(block_0_3_2, ARGS_0__2_2);
}


static void
xblock_0_3_3(ARGS_0__3_1)
{
    PSYCHIATRIC(block_0_3_3, ARGS_0__3_2);
}


static void
xblock_1_0_0(ARGS_1__0_1)
{
    PSYCHIATRIC(block_1_0_0, ARGS_1__0_2);
}


static void
xblock_1_0_1(ARGS_1__1_1)
{
    PSYCHIATRIC(block_1_0_1, ARGS_1__1_2);
}


static void
xblock_1_0_2(ARGS_1__2_1)
{
    PSYCHIATRIC(block_1_0_2, ARGS_1__2_2);
}


static void
xblock_1_0_3(ARGS_1__3_1)
{
    PSYCHIATRIC(block_1_0_3, ARGS_1__3_2);
}


static void
xblock_1_1_0(ARGS_1__0_1)
{
    PSYCHIATRIC(block_1_1_0, ARGS_1__0_2);
}


static void
xblock_1_1_1(ARGS_1__1_1)
{
    PSYCHIATRIC(block_1_1_1, ARGS_1__1_2);
}


static void
xblock_1_1_2(ARGS_1__2_1)
{
    PSYCHIATRIC(block_1_1_2, ARGS_1__2_2);
}


static void
xblock_1_1_3(ARGS_1__3_1)
{
    PSYCHIATRIC(block_1_1_3, ARGS_1__3_2);
}


static void
xblock_1_2_0(ARGS_1__0_1)
{
    PSYCHIATRIC(block_1_2_0, ARGS_1__0_2);
}


static void
xblock_1_2_1(ARGS_1__1_1)
{
    PSYCHIATRIC(block_1_2_1, ARGS_1__1_2);
}


static void
xblock_1_2_2(ARGS_1__2_1)
{
    PSYCHIATRIC(block_1_2_2, ARGS_1__2_2);
}


static void
xblock_1_2_3(ARGS_1__3_1)
{
    PSYCHIATRIC(block_1_2_3, ARGS_1__3_2);
}


static void
xblock_1_3_0(ARGS_1__0_1)
{
    PSYCHIATRIC(block_1_3_0, ARGS_1__0_2);
}


static void
xblock_1_3_1(ARGS_1__1_1)
{
    PSYCHIATRIC(block_1_3_1, ARGS_1__1_2);
}


static void
xblock_1_3_2(ARGS_1__2_1)
{
    PSYCHIATRIC(block_1_3_2, ARGS_1__2_2);
}


static void
xblock_1_3_3(ARGS_1__3_1)
{
    PSYCHIATRIC(block_1_3_3, ARGS_1__3_2);
}


static void
xblock_1_4_0(ARGS_1__0_1)
{
    PSYCHIATRIC(block_1_4_0, ARGS_1__0_2);
}


static void
xblock_1_4_1(ARGS_1__1_1)
{
    PSYCHIATRIC(block_1_4_1, ARGS_1__1_2);
}


static void
xblock_1_4_2(ARGS_1__2_1)
{
    PSYCHIATRIC(block_1_4_2, ARGS_1__2_2);
}


static void
xblock_1_4_3(ARGS_1__3_1)
{
    PSYCHIATRIC(block_1_4_3, ARGS_1__3_2);
}


static void
xblock_1_5_0(ARGS_1__0_1)
{
    PSYCHIATRIC(block_1_5_0, ARGS_1__0_2);
}


static void
xblock_1_5_1(ARGS_1__1_1)
{
    PSYCHIATRIC(block_1_5_1, ARGS_1__1_2);
}


static void
xblock_1_5_2(ARGS_1__2_1)
{
    PSYCHIATRIC(block_1_5_2, ARGS_1__2_2);
}


static void
xblock_1_5_3(ARGS_1__3_1)
{
    PSYCHIATRIC(block_1_5_3, ARGS_1__3_2);
}


static void
xblock_1_6_0(ARGS_1__0_1)
{
    PSYCHIATRIC(block_1_6_0, ARGS_1__0_2);
}


static void
xblock_1_6_1(ARGS_1__1_1)
{
    PSYCHIATRIC(block_1_6_1, ARGS_1__1_2);
}


static void
xblock_1_6_2(ARGS_1__2_1)
{
    PSYCHIATRIC(block_1_6_2, ARGS_1__2_2);
}


static void
xblock_1_6_3(ARGS_1__3_1)
{
    PSYCHIATRIC(block_1_6_3, ARGS_1__3_2);
}


static void
xblock_1_7_0(ARGS_1__0_1)
{
    PSYCHIATRIC(block_1_7_0, ARGS_1__0_2);
}


static void
xblock_1_7_1(ARGS_1__1_1)
{
    PSYCHIATRIC(block_1_7_1, ARGS_1__1_2);
}


static void
xblock_1_7_2(ARGS_1__2_1)
{
    PSYCHIATRIC(block_1_7_2, ARGS_1__2_2);
}


static void
xblock_1_7_3(ARGS_1__3_1)
{
    PSYCHIATRIC(block_1_7_3, ARGS_1__3_2);
}


static void
xblock_1_8_0(ARGS_1__0_1)
{
    PSYCHIATRIC(block_1_8_0, ARGS_1__0_2);
}


static void
xblock_1_8_1(ARGS_1__1_1)
{
    PSYCHIATRIC(block_1_8_1, ARGS_1__1_2);
}


static void
xblock_1_8_2(ARGS_1__2_1)
{
    PSYCHIATRIC(block_1_8_2, ARGS_1__2_2);
}


static void
xblock_1_8_3(ARGS_1__3_1)
{
    PSYCHIATRIC(block_1_8_3, ARGS_1__3_2);
}


static void
xblock_1_9_0(ARGS_1__0_1)
{
    PSYCHIATRIC(block_1_9_0, ARGS_1__0_2);
}


static void
xblock_1_9_1(ARGS_1__1_1)
{
    PSYCHIATRIC(block_1_9_1, ARGS_1__1_2);
}


static void
xblock_1_9_2(ARGS_1__2_1)
{
    PSYCHIATRIC(block_1_9_2, ARGS_1__2_2);
}


static void
xblock_1_9_3(ARGS_1__3_1)
{
    PSYCHIATRIC(block_1_9_3, ARGS_1__3_2);
}


static void
xblock_1_a_0(ARGS_1__0_1)
{
    PSYCHIATRIC(block_1_a_0, ARGS_1__0_2);
}


static void
xblock_1_a_1(ARGS_1__1_1)
{
    PSYCHIATRIC(block_1_a_1, ARGS_1__1_2);
}


static void
xblock_1_a_2(ARGS_1__2_1)
{
    PSYCHIATRIC(block_1_a_2, ARGS_1__2_2);
}


static void
xblock_1_a_3(ARGS_1__3_1)
{
    PSYCHIATRIC(block_1_a_3, ARGS_1__3_2);
}


static void
xblock_1_b_0(ARGS_1__0_1)
{
    PSYCHIATRIC(block_1_b_0, ARGS_1__0_2);
}


static void
xblock_1_b_1(ARGS_1__1_1)
{
    PSYCHIATRIC(block_1_b_1, ARGS_1__1_2);
}


static void
xblock_1_b_2(ARGS_1__2_1)
{
    PSYCHIATRIC(block_1_b_2, ARGS_1__2_2);
}


static void
xblock_1_b_3(ARGS_1__3_1)
{
    PSYCHIATRIC(block_1_b_3, ARGS_1__3_2);
}


static void
xblock_1_c_0(ARGS_1__0_1)
{
    PSYCHIATRIC(block_1_c_0, ARGS_1__0_2);
}


static void
xblock_1_c_1(ARGS_1__1_1)
{
    PSYCHIATRIC(block_1_c_1, ARGS_1__1_2);
}


static void
xblock_1_c_2(ARGS_1__2_1)
{
    PSYCHIATRIC(block_1_c_2, ARGS_1__2_2);
}


static void
xblock_1_c_3(ARGS_1__3_1)
{
    PSYCHIATRIC(block_1_c_3, ARGS_1__3_2);
}


static void
xblock_1_d_0(ARGS_1__0_1)
{
    PSYCHIATRIC(block_1_d_0, ARGS_1__0_2);
}


static void
xblock_1_d_1(ARGS_1__1_1)
{
    PSYCHIATRIC(block_1_d_1, ARGS_1__1_2);
}


static void
xblock_1_d_2(ARGS_1__2_1)
{
    PSYCHIATRIC(block_1_d_2, ARGS_1__2_2);
}


static void
xblock_1_d_3(ARGS_1__3_1)
{
    PSYCHIATRIC(block_1_d_3, ARGS_1__3_2);
}


static void
xblock_1_e_0(ARGS_1__0_1)
{
    PSYCHIATRIC(block_1_e_0, ARGS_1__0_2);
}


static void
xblock_1_e_1(ARGS_1__1_1)
{
    PSYCHIATRIC(block_1_e_1, ARGS_1__1_2);
}


static void
xblock_1_e_2(ARGS_1__2_1)
{
    PSYCHIATRIC(block_1_e_2, ARGS_1__2_2);
}


static void
xblock_1_e_3(ARGS_1__3_1)
{
    PSYCHIATRIC(block_1_e_3, ARGS_1__3_2);
}


static void
xblock_1_f_0(ARGS_1__0_1)
{
    PSYCHIATRIC(block_1_f_0, ARGS_1__0_2);
}


static void
xblock_1_f_1(ARGS_1__1_1)
{
    PSYCHIATRIC(block_1_f_1, ARGS_1__1_2);
}


static void
xblock_1_f_2(ARGS_1__2_1)
{
    PSYCHIATRIC(block_1_f_2, ARGS_1__2_2);
}


static void
xblock_1_f_3(ARGS_1__3_1)
{
    PSYCHIATRIC(block_1_f_3, ARGS_1__3_2);
}
