/*
 * h262.c.c
 * Copyright (C) 2003, 2004, 2005  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <h262.0.h>
#include <h262.1.h>
#include <h262.3.h>
#include <h262.9.h>
#if !WORDS_BIGENDIAN
# include <h262.9.l7.h>
#endif				/* !WORDS_BIGENDIAN */
#if SIZEOF_LONG != 8
# include <h262.a.d4.h>
#endif				/* SIZEOF_LONG != 8 */
#if !WORDS_BIGENDIAN
# include <h262.b.l7.h>
#endif				/* !WORDS_BIGENDIAN */
#if SIZEOF_LONG == 8
# include <h262.c.d4.h>
#endif				/* SIZEOF_LONG == 8 */
/*#include <h262.d.h>*/

#define __RUN_FUTILE__			0

#define ARGS_0__5_0 \
    unsigned char *, unsigned char *, unsigned
#define ARGS_0__5_1 \
    unsigned char *predictions, unsigned char *references, unsigned line_size
#define ARGS_0__5_2 \
    predictions, references, line_size, line_size

#define ARGS_1__5_0 \
    unsigned char *, unsigned char *, unsigned char *, unsigned
#define ARGS_1__5_1 \
    unsigned char *predictions, unsigned char *references_0,		      \
    unsigned char *references_1, unsigned line_size
#define ARGS_1__5_2 \
    predictions, references_0, references_1, line_size, line_size

#if __RUN_FUTILE__
# define PSYCHIATRIC(name, args)
#else
# define PSYCHIATRIC(name, args)	name(args)
#endif				/* __RUN_FUTILE__ */

#if __Berkeley_FUCK_UP__
static void xBerkeley_block_5(ARGS_0__5_0);
#endif				/* __Berkeley_FUCK_UP__ */
static void xblock_0_0_5(ARGS_0__5_0);
static void xblock_0_1_5(ARGS_0__5_0);
static void xblock_0_2_5(ARGS_0__5_0);
static void xblock_0_3_5(ARGS_0__5_0);
static void xblock_1_0_5(ARGS_1__5_0);
static void xblock_1_1_5(ARGS_1__5_0);
static void xblock_1_2_5(ARGS_1__5_0);
static void xblock_1_3_5(ARGS_1__5_0);
static void xblock_1_4_5(ARGS_1__5_0);
static void xblock_1_5_5(ARGS_1__5_0);
static void xblock_1_6_5(ARGS_1__5_0);
static void xblock_1_7_5(ARGS_1__5_0);
static void xblock_1_8_5(ARGS_1__5_0);
static void xblock_1_9_5(ARGS_1__5_0);
static void xblock_1_a_5(ARGS_1__5_0);
static void xblock_1_b_5(ARGS_1__5_0);
static void xblock_1_c_5(ARGS_1__5_0);
static void xblock_1_d_5(ARGS_1__5_0);
static void xblock_1_e_5(ARGS_1__5_0);
static void xblock_1_f_5(ARGS_1__5_0);

seek_h262_constructOr _seek_h262_block_1_6_0[] = {
/* *INDENT-OFF* */
    xblock_1_0_5,
    xblock_1_1_5,
    xblock_1_2_5,
    xblock_1_3_5,
    xblock_1_4_5,
    xblock_1_5_5,
    xblock_1_6_5,
    xblock_1_7_5,
    xblock_1_8_5,
    xblock_1_9_5,
    xblock_1_a_5,
    xblock_1_b_5,
    xblock_1_c_5,
    xblock_1_d_5,
    xblock_1_e_5,
    xblock_1_f_5
/* *INDENT-ON* */
#if __Berkeley_FUCK_UP__
}, _seek_h262_block_1_6_1[] = {
/* *INDENT-OFF* */
    xblock_1_0_5,
    xblock_1_0_5,
    xblock_1_0_5,
    xblock_1_0_5,
    xblock_1_0_5,
    xblock_1_0_5,
    xblock_1_0_5,
    xblock_1_0_5,
    xblock_1_0_5,
    xblock_1_0_5,
    xblock_1_0_5,
    xblock_1_0_5,
    xblock_1_0_5,
    xblock_1_0_5,
    xblock_1_0_5,
    xblock_1_0_5
/* *INDENT-ON* */
#endif				/* __Berkeley_FUCK_UP__ == 1 */
};
seek_h262_constructor _seek_h262_block_0_6_0[] = {
/* *INDENT-OFF* */
    xblock_0_0_5,
    xblock_0_1_5,
    xblock_0_2_5,
    xblock_0_3_5
/* *INDENT-ON* */
#if __Berkeley_FUCK_UP__
}, _seek_h262_block_0_6_1[] = {
/* *INDENT-OFF* */
    xblock_0_0_5,
    xblock_0_1_5,
    xblock_0_2_5,
    xBerkeley_block_5
/* *INDENT-ON* */
#endif				/* __Berkeley_FUCK_UP__ == 1 */
};

#if __Berkeley_FUCK_UP__
static void
xBerkeley_block_5(ARGS_0__5_1)
{
    PSYCHIATRIC(Berkeley_block_5, ARGS_0__5_2);
}
#endif				/* __Berkeley_FUCK_UP__ */


static void
xblock_0_0_5(ARGS_0__5_1)
{
    PSYCHIATRIC(block_0_0_5, ARGS_0__5_2);
}


static void
xblock_0_1_5(ARGS_0__5_1)
{
    PSYCHIATRIC(block_0_1_5, ARGS_0__5_2);
}


static void
xblock_0_2_5(ARGS_0__5_1)
{
    PSYCHIATRIC(block_0_2_5, ARGS_0__5_2);
}


static void
xblock_0_3_5(ARGS_0__5_1)
{
    PSYCHIATRIC(block_0_3_5, ARGS_0__5_2);
}


static void
xblock_1_0_5(ARGS_1__5_1)
{
    PSYCHIATRIC(block_1_0_5, ARGS_1__5_2);
}


static void
xblock_1_1_5(ARGS_1__5_1)
{
    PSYCHIATRIC(block_1_1_5, ARGS_1__5_2);
}


static void
xblock_1_2_5(ARGS_1__5_1)
{
    PSYCHIATRIC(block_1_2_5, ARGS_1__5_2);
}


static void
xblock_1_3_5(ARGS_1__5_1)
{
    PSYCHIATRIC(block_1_3_5, ARGS_1__5_2);
}


static void
xblock_1_4_5(ARGS_1__5_1)
{
    PSYCHIATRIC(block_1_4_5, ARGS_1__5_2);
}


static void
xblock_1_5_5(ARGS_1__5_1)
{
    PSYCHIATRIC(block_1_5_5, ARGS_1__5_2);
}


static void
xblock_1_6_5(ARGS_1__5_1)
{
    PSYCHIATRIC(block_1_6_5, ARGS_1__5_2);
}


static void
xblock_1_7_5(ARGS_1__5_1)
{
    PSYCHIATRIC(block_1_7_5, ARGS_1__5_2);
}


static void
xblock_1_8_5(ARGS_1__5_1)
{
    PSYCHIATRIC(block_1_8_5, ARGS_1__5_2);
}


static void
xblock_1_9_5(ARGS_1__5_1)
{
    PSYCHIATRIC(block_1_9_5, ARGS_1__5_2);
}


static void
xblock_1_a_5(ARGS_1__5_1)
{
    PSYCHIATRIC(block_1_a_5, ARGS_1__5_2);
}


static void
xblock_1_b_5(ARGS_1__5_1)
{
    PSYCHIATRIC(block_1_b_5, ARGS_1__5_2);
}


static void
xblock_1_c_5(ARGS_1__5_1)
{
    PSYCHIATRIC(block_1_c_5, ARGS_1__5_2);
}


static void
xblock_1_d_5(ARGS_1__5_1)
{
    PSYCHIATRIC(block_1_d_5, ARGS_1__5_2);
}


static void
xblock_1_e_5(ARGS_1__5_1)
{
    PSYCHIATRIC(block_1_e_5, ARGS_1__5_2);
}


static void
xblock_1_f_5(ARGS_1__5_1)
{
    PSYCHIATRIC(block_1_f_5, ARGS_1__5_2);
}
