/*
 * h262.c.d4.h
 * Copyright (C) 2003, 2004, 2005, 2006  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __SEEK_H262_C_D4_H__
#define __SEEK_H262_C_D4_H__

#include <h262.9.h>

#undef block_0_0_5

#define block_0_0_5(predictions, references, stride, line_size) \
    {									      \
	if (!((integral_q) references & 7)) {				      \
	    unsigned i = 4;						      \
	    unsigned long *prediction8s, *reference8s;			      \
									      \
	    prediction8s = (unsigned long *) predictions;		      \
	    reference8s = (unsigned long *) references;			      \
	    for (; i; i--) {						      \
		*prediction8s = *reference8s;				      \
		prediction8s = (unsigned long *)			      \
		    ((unsigned char *) prediction8s + stride);		      \
		reference8s = (unsigned long *)				      \
		    ((unsigned char *) reference8s + stride);		      \
	    }								      \
	} else if (!((integral_q) references & 3)) {			      \
	    unsigned i = 4, *prediction4s, *reference4s;		      \
									      \
	    prediction4s = (unsigned *) predictions;			      \
	    reference4s = (unsigned *) references;			      \
	    for (; i; i--) {						      \
		prediction4s[0] = reference4s[0];			      \
		prediction4s[1] = reference4s[1];			      \
		prediction4s = (unsigned *)				      \
		    ((unsigned char *) prediction4s + stride);		      \
		reference4s = (unsigned *)				      \
		    ((unsigned char *) reference4s + stride);		      \
	    }								      \
	} else {							      \
	    block_0_0_x(predictions, references, stride, line_size, 5);	      \
	}								      \
    }

#endif				/* __SEEK_H262_C_D4_H__ */
