/*
 * h262.c.l7.h
 * Copyright (C) 2004, 2005  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __SEEK_H262_C_L7_H__
#define __SEEK_H262_C_L7_H__

#define __TIGHT_SIMPLE_REFERENCE__	1

#if __TIGHT_SIMPLE_REFERENCE__
# define MAJOR_WIDE_REFERENCE_2_2_jane(transfer) \
    {									      \
	(transfer) = ((reference_[0] + reference_[4]) & 0xff00ff00)	      \
	    | (((reference_[1] + reference_[5]) >> 2) & 0x00ff00ff);	      \
    }

# define MINOR_WIDE_REFERENCE_2_2_jane(transfer) \
    {									      \
	(transfer) = ((reference_[2] + reference_[6]) & 0xff00ff00)	      \
	    | (((reference_[3] + reference_[7]) >> 2) & 0x00ff00ff);	      \
    }

# define WIDE_REFERENCE_2_2_jane_decls \
    unsigned reference_[8]

# define WIDE_REFERENCE_2_2_even(reference, line_size, stride) \
    {									      \
	reference_[5] = *(unsigned *) (reference);			      \
	reference_[4] = ((reference_[5] & 0xff00ff00) >> 2) + 0x00800080;     \
	reference_[5] &= 0x00ff00ff;					      \
	reference_[5] += reference_[4] >> 6;				      \
	reference_[4] += (*(unsigned *) ((reference) + 1) & 0xff00ff00) >> 2; \
	reference_[7] = *(unsigned *) ((reference) + 4);		      \
	reference_[6] = ((reference_[7] & 0xff00ff00) >> 2) + 0x00800080;     \
	reference_[7] &= 0x00ff00ff;					      \
	reference_[7] += reference_[6] >> 6;				      \
	reference_[6] += (*(unsigned *) ((reference) + 5) & 0xff00ff00) >> 2; \
									      \
	(reference) += (stride);					      \
    }

# define WIDE_REFERENCE_2_2_init(reference, line_size, stride) \
    WIDE_REFERENCE_2_2_odd(reference, line_size, stride)

# define WIDE_REFERENCE_2_2_odd(reference, line_size, stride) \
    {									      \
	reference_[1] = *(unsigned *) (reference);			      \
	reference_[0] = (reference_[1] & 0xff00ff00) >> 2;		      \
	reference_[1] &= 0x00ff00ff;					      \
	reference_[1] += reference_[0] >> 6;				      \
	reference_[0] += (*(unsigned *) ((reference) + 1) & 0xff00ff00) >> 2; \
	reference_[3] = *(unsigned *) ((reference) + 4);		      \
	reference_[2] = (reference_[3] & 0xff00ff00) >> 2;		      \
	reference_[3] &= 0x00ff00ff;					      \
	reference_[3] += reference_[2] >> 6;				      \
	reference_[2] += (*(unsigned *) ((reference) + 5) & 0xff00ff00) >> 2; \
									      \
	(reference) += (stride);					      \
    }
#else
# define MAJOR_WIDE_REFERENCE_2_2_jane(transfer) \
    {									      \
	(transfer) = ((reference_0_0 + reference_2_0) & 0xff00ff00)	      \
	    | (((reference_0_1 + reference_2_1) >> 2) & 0x00ff00ff);	      \
    }

# define MINOR_WIDE_REFERENCE_2_2_jane(transfer) \
    {									      \
	(transfer) = ((reference_1_0 + reference_3_0) & 0xff00ff00)	      \
	    | (((reference_1_1 + reference_3_1) >> 2) & 0x00ff00ff);	      \
    }

# define WIDE_REFERENCE_2_2_jane_decls \
    unsigned reference_0_0, reference_0_1, reference_1_0, reference_1_1,      \
	reference_2_0, reference_2_1, reference_3_0, reference_3_1

# define WIDE_REFERENCE_2_2_even(reference, line_size, stride) \
    {									      \
	reference_2_1 = *(unsigned *) (reference);			      \
	reference_2_0 = ((reference_2_1 & 0xff00ff00) >> 2) + 0x00800080;     \
	reference_2_1 &= 0x00ff00ff;					      \
	reference_2_1 += reference_2_0 >> 6;				      \
	reference_2_0 += (*(unsigned *) ((reference) + 1) & 0xff00ff00) >> 2; \
	reference_3_1 = *(unsigned *) ((reference) + 4);		      \
	reference_3_0 = ((reference_3_1 & 0xff00ff00) >> 2) + 0x00800080;     \
	reference_3_1 &= 0x00ff00ff;					      \
	reference_3_1 += reference_3_0 >> 6;				      \
	reference_3_0 += (*(unsigned *) ((reference) + 5) & 0xff00ff00) >> 2; \
									      \
	(reference) += (stride);					      \
    }

# define WIDE_REFERENCE_2_2_init(reference, line_size, stride) \
    WIDE_REFERENCE_2_2_odd(reference, line_size, stride)

# define WIDE_REFERENCE_2_2_odd(reference, line_size, stride) \
    {									      \
	reference_0_1 = *(unsigned *) (reference);			      \
	reference_0_0 = (reference_0_1 & 0xff00ff00) >> 2;		      \
	reference_0_1 &= 0x00ff00ff;					      \
	reference_0_1 += reference_0_0 >> 6;				      \
	reference_0_0 += (*(unsigned *) ((reference) + 1) & 0xff00ff00) >> 2; \
	reference_1_1 = *(unsigned *) ((reference) + 4);		      \
	reference_1_0 = (reference_1_1 & 0xff00ff00) >> 2;		      \
	reference_1_1 &= 0x00ff00ff;					      \
	reference_1_1 += reference_1_0 >> 6;				      \
	reference_1_0 += (*(unsigned *) ((reference) + 5) & 0xff00ff00) >> 2; \
									      \
	(reference) += (stride);					      \
    }
#endif				/* __TIGHT_SIMPLE_REFERENCE__ */

#if __TIGHT_SIMPLE_REFERENCE__
# define _1st_WIDE_REFERENCE_2_2_jane2(transfer) \
    {									      \
	(transfer) = ((reference_[0x0] + reference_[0x4]) & 0xff00ff00)	      \
	    | (((reference_[0x1] + reference_[0x5]) >> 2) & 0x00ff00ff);      \
    }

# define _2nd_WIDE_REFERENCE_2_2_jane2(transfer) \
    {									      \
	(transfer) = ((reference_[0x2] + reference_[0x6]) & 0xff00ff00)	      \
	    | (((reference_[0x3] + reference_[0x7]) >> 2) & 0x00ff00ff);      \
    }

# define _3rd_WIDE_REFERENCE_2_2_jane2(transfer) \
    {									      \
	(transfer) = ((reference_[0x8] + reference_[0xc]) & 0xff00ff00)	      \
	    | (((reference_[0x9] + reference_[0xd]) >> 2) & 0x00ff00ff);      \
    }

# define _4th_WIDE_REFERENCE_2_2_jane2(transfer) \
    {									      \
	(transfer) = ((reference_[0xa] + reference_[0xe]) & 0xff00ff00)	      \
	    | (((reference_[0xb] + reference_[0xf]) >> 2) & 0x00ff00ff);      \
    }

# define WIDE_REFERENCE_2_2_jane2_decls \
    unsigned reference_[16]

# define WIDE_REFERENCE_2_2_jane2_even(reference, line_size, stride) \
    {									      \
	reference_[0x5] = *(unsigned *) (reference);			      \
	reference_[0x4] = ((reference_[0x5] & 0xff00ff00) >> 2) + 0x00800080; \
	reference_[0x5] &= 0x00ff00ff;					      \
	reference_[0x5] += reference_[0x4] >> 6;			      \
	reference_[0x4] +=						      \
	    (*(unsigned *) ((reference) + 1) & 0xff00ff00) >> 2;	      \
	reference_[0x7] = *(unsigned *) ((reference) + 4);		      \
	reference_[0x6] = ((reference_[0x7] & 0xff00ff00) >> 2) + 0x00800080; \
	reference_[0x7] &= 0x00ff00ff;					      \
	reference_[0x7] += reference_[0x6] >> 6;			      \
	reference_[0x6] +=						      \
	    (*(unsigned *) ((reference) + 5) & 0xff00ff00) >> 2;	      \
									      \
	reference_[0xd] = *(unsigned *) ((reference) + 8);		      \
	reference_[0xc] = ((reference_[0xd] & 0xff00ff00) >> 2) + 0x00800080; \
	reference_[0xd] &= 0x00ff00ff;					      \
	reference_[0xd] += reference_[0xc] >> 6;			      \
	reference_[0xc] +=						      \
	    (*(unsigned *) ((reference) + 9) & 0xff00ff00) >> 2;	      \
	reference_[0xf] = *(unsigned *) ((reference) + 12);		      \
	reference_[0xe] = ((reference_[0xf] & 0xff00ff00) >> 2) + 0x00800080; \
	reference_[0xf] &= 0x00ff00ff;					      \
	reference_[0xf] += reference_[0xe] >> 6;			      \
	reference_[0xe] +=						      \
	    (*(unsigned *) ((reference) + 13) & 0xff00ff00) >> 2;	      \
									      \
	(reference) += (stride);					      \
    }

# define WIDE_REFERENCE_2_2_jane2_init(reference, line_size, stride) \
    WIDE_REFERENCE_2_2_jane2_odd(reference, line_size, stride)

# define WIDE_REFERENCE_2_2_jane2_odd(reference, line_size, stride) \
    {									      \
	reference_[0x1] = *(unsigned *) (reference);			      \
	reference_[0x0] = (reference_[0x1] & 0xff00ff00) >> 2;		      \
	reference_[0x1] &= 0x00ff00ff;					      \
	reference_[0x1] += reference_[0x0] >> 6;			      \
	reference_[0x0] +=						      \
	    (*(unsigned *) ((reference) + 1) & 0xff00ff00) >> 2;	      \
	reference_[0x3] = *(unsigned *) ((reference) + 4);		      \
	reference_[0x2] = (reference_[0x3] & 0xff00ff00) >> 2;		      \
	reference_[0x3] &= 0x00ff00ff;					      \
	reference_[0x3] += reference_[0x2] >> 6;			      \
	reference_[0x2] +=						      \
	    (*(unsigned *) ((reference) + 5) & 0xff00ff00) >> 2;	      \
									      \
	reference_[0x9] = *(unsigned *) ((reference) + 8);		      \
	reference_[0x8] = (reference_[0x9] & 0xff00ff00) >> 2;		      \
	reference_[0x9] &= 0x00ff00ff;					      \
	reference_[0x9] += reference_[0x8] >> 6;			      \
	reference_[0x8] +=						      \
	    (*(unsigned *) ((reference) + 9) & 0xff00ff00) >> 2;	      \
	reference_[0xb] = *(unsigned *) ((reference) + 12);		      \
	reference_[0xa] = (reference_[0xb] & 0xff00ff00) >> 2;		      \
	reference_[0xb] &= 0x00ff00ff;					      \
	reference_[0xb] += reference_[0xa] >> 6;			      \
	reference_[0xa] +=						      \
	    (*(unsigned *) ((reference) + 13) & 0xff00ff00) >> 2;	      \
									      \
	(reference) += (stride);					      \
    }
#else
#endif				/* __TIGHT_SIMPLE_REFERENCE__ */

#endif				/* __SEEK_H262_C_L7_H__ */
