/*
 * h262.c.part3.c
 * Copyright (C) 2003, 2004  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <h262.0.h>
#include <h262.2.h>
#include <h262.3.h>

#if __ENABLE_X00000100___HACK_2__
void
_seek_h262_x00000100___hack_2(struct seek_h262_video *video)
{
    struct seek_h262_x00000100__ picture_header;

    picture_header.decoder = video;
    picture_header.picture_coding_type = video->picture_coding_type;
    if (picture_header.picture_coding_type == predictive_coded) {
	unsigned char *buffer;

	buffer = video->buffer;
	picture_header.forward_f_code =
	    ((buffer[3] & 3) << 1 | buffer[4] >> 7) - 1;
	picture_header.full_pel_forward_vector = (buffer[3] & 0x04) >> 2;
    } else if (picture_header.picture_coding_type
	       == bidirectionally_predictive_coded) {
	unsigned char *buffer;

	buffer = video->buffer;
	picture_header.backward_f_code = ((buffer[4] & 56) >> 3) - 1;
	picture_header.forward_f_code =
	    ((buffer[3] & 3) << 1 | buffer[4] >> 7) - 1;
	picture_header.full_pel_backward_vector = (buffer[4] & 0x40) >> 6;
	picture_header.full_pel_forward_vector = (buffer[3] & 0x04) >> 2;
    }

    video->x00000100___hack_2(&picture_header);
}
#endif				/* __ENABLE_X00000100___HACK_2__ */
