/*
 * h262.d.h
 * Copyright (C) 2003, 2004, 2005  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __SEEK_H262_D_H__
#define __SEEK_H262_D_H__

#include <h262.0.h>

#define block__3_0_0(predictions, references_0, references_1, coefficients, \
		     line_size, increment)				      \
    {									      \
	int value;							      \
									      \
	if (*coefficients < 0) {					      \
	    value = 256 - ((-(*coefficients | ~2047) + 4) >> 3);	      \
	} else {							      \
	    value = 256 + (((*coefficients & 2047) + 4) >> 3);		      \
	}								      \
	if (value < 256) {						      \
	    unsigned *prediction4s, value_x01010101, value_x7f7f7f7f;	      \
									      \
	    prediction4s = (unsigned *) predictions;			      \
	    value |= value << 010;					      \
	    value |= value << 020;					      \
	    value_x01010101 = value & 0x01010101;			      \
	    value_x7f7f7f7f = (value >> 1) & 0x7f7f7f7f;		      \
	    for (value = 4; value; value--) {				      \
		unsigned sum_0, sum_1;					      \
									      \
		sum_0 = *(unsigned *) (references_0 + 0);		      \
		sum_1 = *(unsigned *) (references_1 + 0);		      \
		sum_1 = ((sum_0 >> 1) & 0x7f7f7f7f)			      \
		    + ((sum_1 >> 1) & 0x7f7f7f7f)			      \
		    + ((((sum_0 & 0x01010101) + (sum_1 & 0x01010101)	      \
			 + 0x01010101) >> 1) & 0x01010101);		      \
		sum_0 = ((sum_1 >> 1) & 0x7f7f7f7f) + value_x7f7f7f7f;	      \
		sum_1 = (sum_1 & 0x01010101) + value_x01010101;		      \
		sum_0 += (sum_1 >> 1) & 0x01010101;			      \
		sum_1 &= 0x01010101;					      \
		sum_1 += ((sum_0 & 0x7f7f7f7f) << 1);			      \
		if ((sum_0 &= 0x80808080) != 0x80808080) {		      \
		    sum_0 |= sum_0 >> 1;				      \
		    sum_0 |= sum_0 >> 2;				      \
		    sum_0 |= sum_0 >> 4;				      \
		    sum_1 &= sum_0;					      \
		}							      \
		prediction4s[0] = sum_1;				      \
		sum_0 = *(unsigned *) (references_0 + 4);		      \
		sum_1 = *(unsigned *) (references_1 + 4);		      \
		sum_1 = ((sum_0 >> 1) & 0x7f7f7f7f)			      \
		    + ((sum_1 >> 1) & 0x7f7f7f7f)			      \
		    + ((((sum_0 & 0x01010101) + (sum_1 & 0x01010101)	      \
			 + 0x01010101) >> 1) & 0x01010101);		      \
		sum_0 = ((sum_1 >> 1) & 0x7f7f7f7f) + value_x7f7f7f7f;	      \
		sum_1 = (sum_1 & 0x01010101) + value_x01010101;		      \
		sum_0 += (sum_1 >> 1) & 0x01010101;			      \
		sum_1 &= 0x01010101;					      \
		sum_1 += ((sum_0 & 0x7f7f7f7f) << 1);			      \
		if ((sum_0 &= 0x80808080) != 0x80808080) {		      \
		    sum_0 |= sum_0 >> 1;				      \
		    sum_0 |= sum_0 >> 2;				      \
		    sum_0 |= sum_0 >> 4;				      \
		    sum_1 &= sum_0;					      \
		}							      \
		prediction4s[1] = sum_1;				      \
		prediction4s = (unsigned *)				      \
		    ((unsigned char *) prediction4s + line_size);	      \
		references_0 += line_size;				      \
		references_1 += line_size;				      \
	    }								      \
	} else {							      \
	    unsigned *prediction4s, value_x01010101, value_x7f7f7f7f;	      \
									      \
	    prediction4s = (unsigned *) predictions;			      \
	    value &= 255;						      \
	    value |= value << 010;					      \
	    value |= value << 020;					      \
	    value_x01010101 = value & 0x01010101;			      \
	    value_x7f7f7f7f = (value >> 1) & 0x7f7f7f7f;		      \
	    for (value = 4; value; value--) {				      \
		unsigned sum_0, sum_1;					      \
									      \
		sum_0 = *(unsigned *) (references_0 + 0);		      \
		sum_1 = *(unsigned *) (references_1 + 0);		      \
		sum_1 = ((sum_0 >> 1) & 0x7f7f7f7f)			      \
		    + ((sum_1 >> 1) & 0x7f7f7f7f)			      \
		    + ((((sum_0 & 0x01010101) + (sum_1 & 0x01010101)	      \
			 + 0x01010101) >> 1) & 0x01010101);		      \
		sum_0 = ((sum_1 >> 1) & 0x7f7f7f7f) + value_x7f7f7f7f;	      \
		sum_1 = (sum_1 & 0x01010101) + value_x01010101;		      \
		sum_0 += (sum_1 >> 1) & 0x01010101;			      \
		sum_1 &= 0x01010101;					      \
		if (sum_0 & 0x80808080) {				      \
		    unsigned mask;					      \
									      \
		    mask = sum_0 & 0x80808080;				      \
		    mask |= mask >> 1;					      \
		    mask |= mask >> 2;					      \
		    mask |= mask >> 4;					      \
		    prediction4s[0] =					      \
			(((sum_0 & 0x7f7f7f7f) << 1) + sum_1) | mask;	      \
		} else {						      \
		    prediction4s[0] = (sum_0 << 1) + sum_1;		      \
		}							      \
		sum_0 = *(unsigned *) (references_0 + 4);		      \
		sum_1 = *(unsigned *) (references_1 + 4);		      \
		sum_1 = ((sum_0 >> 1) & 0x7f7f7f7f)			      \
		    + ((sum_1 >> 1) & 0x7f7f7f7f)			      \
		    + ((((sum_0 & 0x01010101) + (sum_1 & 0x01010101)	      \
			 + 0x01010101) >> 1) & 0x01010101);		      \
		sum_0 = ((sum_1 >> 1) & 0x7f7f7f7f) + value_x7f7f7f7f;	      \
		sum_1 = (sum_1 & 0x01010101) + value_x01010101;		      \
		sum_0 += (sum_1 >> 1) & 0x01010101;			      \
		sum_1 &= 0x01010101;					      \
		if (sum_0 & 0x80808080) {				      \
		    unsigned mask;					      \
									      \
		    mask = sum_0 & 0x80808080;				      \
		    mask |= mask >> 1;					      \
		    mask |= mask >> 2;					      \
		    mask |= mask >> 4;					      \
		    prediction4s[1] =					      \
			(((sum_0 & 0x7f7f7f7f) << 1) + sum_1) | mask;	      \
		} else {						      \
		    prediction4s[1] = (sum_0 << 1) + sum_1;		      \
		}							      \
		prediction4s = (unsigned *)				      \
		    ((unsigned char *) prediction4s + line_size);	      \
		references_0 += line_size;				      \
		references_1 += line_size;				      \
	    }								      \
	}								      \
    }

#define block__3_0_2(predictions, references_0, references_1, coefficients, \
		     line_size, increment)				      \
    {									      \
	unsigned i = 4, *prediction4s, *reference4s_0, *reference4s_1;	      \
									      \
	prediction4s = (unsigned *) predictions;			      \
	reference4s_0 = (unsigned *) references_0;			      \
	reference4s_1 = (unsigned *) references_1;			      \
	for (; i; i--) {						      \
	    unsigned reference4_0, reference4_1;			      \
									      \
	    reference4_0 = reference4s_0[0];				      \
	    reference4_1 = reference4s_1[0];				      \
	    prediction4s[0] = ((reference4_0 >> 1) & 0x7f7f7f7f)	      \
		+ ((reference4_1 >> 1) & 0x7f7f7f7f)			      \
		+ ((((reference4_0 & 0x01010101) + (reference4_1 & 0x01010101)\
		     + 0x01010101) >> 1) & 0x01010101);			      \
	    reference4_0 = reference4s_0[1];				      \
	    reference4_1 = reference4s_1[1];				      \
	    prediction4s[1] = ((reference4_0 >> 1) & 0x7f7f7f7f)	      \
		+ ((reference4_1 >> 1) & 0x7f7f7f7f)			      \
		+ ((((reference4_0 & 0x01010101) + (reference4_1 & 0x01010101)\
		     + 0x01010101) >> 1) & 0x01010101);			      \
	    prediction4s = (unsigned *)					      \
		((unsigned char *) prediction4s + line_size);		      \
	    reference4s_0 = (unsigned *)				      \
		((unsigned char *) reference4s_0 + line_size);		      \
	    reference4s_1 = (unsigned *)				      \
		((unsigned char *) reference4s_1 + line_size);		      \
	}								      \
    }

#if __Berkeley_FUCK_UP__
# if 0
#  undef Berkeley_block_0

#  define Berkeley_block_0(predictions, references, coefficients, line_size, \
			   increment)					      \
    {									      \
	unsigned char *references_2;					      \
									      \
	references_2 = references + line_size + 1;			      \
	block__3_0_0(predictions, references, references_2, coefficients,     \
		     line_size, increment);				      \
    }
# endif				/* 0 */

# undef Berkeley_block_2

# define Berkeley_block_2(predictions, references, coefficients, line_size, \
			  increment)					      \
    {									      \
	unsigned char *references_2;					      \
									      \
	references_2 = references + line_size + 1;			      \
	block__3_0_2(predictions, references, references_2, coefficients,     \
		     line_size, increment);				      \
    }
#endif				/* __Berkeley_FUCK_UP__ */

#if 0
# undef block_2_0_0

# define block_2_0_0(predictions, references, coefficients, line_size, \
		     increment)						      \
    {									      \
	int value;							      \
									      \
	if (*coefficients < 0) {					      \
	    value = 256 - ((-(*coefficients | ~2047) + 4) >> 3);	      \
	} else {							      \
	    value = 256 + (((*coefficients & 2047) + 4) >> 3);		      \
	}								      \
	if (value < 256) {						      \
	    unsigned *prediction4s, value_x01010101, value_x7f7f7f7f;	      \
									      \
	    prediction4s = (unsigned *) predictions;			      \
	    value |= value << 010;					      \
	    value |= value << 020;					      \
	    value_x01010101 = value & 0x01010101;			      \
	    value_x7f7f7f7f = (value >> 1) & 0x7f7f7f7f;		      \
	    for (value = 4; value; value--) {				      \
		unsigned sum_0, sum_1;					      \
									      \
		sum_1 = *(unsigned *) (references + 0);			      \
		sum_0 = ((sum_1 >> 1) & 0x7f7f7f7f) + value_x7f7f7f7f;	      \
		sum_1 = (sum_1 & 0x01010101) + value_x01010101;		      \
		sum_0 += (sum_1 >> 1) & 0x01010101;			      \
		sum_1 &= 0x01010101;					      \
		sum_1 += ((sum_0 & 0x7f7f7f7f) << 1);			      \
		if ((sum_0 &= 0x80808080) != 0x80808080) {		      \
		    sum_0 |= sum_0 >> 1;				      \
		    sum_0 |= sum_0 >> 2;				      \
		    sum_0 |= sum_0 >> 4;				      \
		    sum_1 &= sum_0;					      \
		}							      \
		prediction4s[0] = sum_1;				      \
		sum_1 = *(unsigned *) (references + 4);			      \
		sum_0 = ((sum_1 >> 1) & 0x7f7f7f7f) + value_x7f7f7f7f;	      \
		sum_1 = (sum_1 & 0x01010101) + value_x01010101;		      \
		sum_0 += (sum_1 >> 1) & 0x01010101;			      \
		sum_1 &= 0x01010101;					      \
		sum_1 += ((sum_0 & 0x7f7f7f7f) << 1);			      \
		if ((sum_0 &= 0x80808080) != 0x80808080) {		      \
		    sum_0 |= sum_0 >> 1;				      \
		    sum_0 |= sum_0 >> 2;				      \
		    sum_0 |= sum_0 >> 4;				      \
		    sum_1 &= sum_0;					      \
		}							      \
		prediction4s[1] = sum_1;				      \
		prediction4s = (unsigned *)				      \
		    ((unsigned char *) prediction4s + line_size);	      \
		references += line_size;				      \
	    }								      \
	} else {							      \
	    unsigned *prediction4s, value_x01010101, value_x7f7f7f7f;	      \
									      \
	    prediction4s = (unsigned *) predictions;			      \
	    value &= 255;						      \
	    value |= value << 010;					      \
	    value |= value << 020;					      \
	    value_x01010101 = value & 0x01010101;			      \
	    value_x7f7f7f7f = (value >> 1) & 0x7f7f7f7f;		      \
	    for (value = 4; value; value--) {				      \
		unsigned sum_0, sum_1;					      \
									      \
		sum_1 = *(unsigned *) (references + 0);			      \
		sum_0 = ((sum_1 >> 1) & 0x7f7f7f7f) + value_x7f7f7f7f;	      \
		sum_1 = (sum_1 & 0x01010101) + value_x01010101;		      \
		sum_0 += (sum_1 >> 1) & 0x01010101;			      \
		sum_1 &= 0x01010101;					      \
		if (sum_0 & 0x80808080) {				      \
		    unsigned mask;					      \
									      \
		    mask = sum_0 & 0x80808080;				      \
		    mask |= mask >> 1;					      \
		    mask |= mask >> 2;					      \
		    mask |= mask >> 4;					      \
		    prediction4s[0] =					      \
			(((sum_0 & 0x7f7f7f7f) << 1) + sum_1) | mask;	      \
		} else {						      \
		    prediction4s[0] = (sum_0 << 1) + sum_1;		      \
		}							      \
		sum_1 = *(unsigned *) (references + 4);			      \
		sum_0 = ((sum_1 >> 1) & 0x7f7f7f7f) + value_x7f7f7f7f;	      \
		sum_1 = (sum_1 & 0x01010101) + value_x01010101;		      \
		sum_0 += (sum_1 >> 1) & 0x01010101;			      \
		sum_1 &= 0x01010101;					      \
		if (sum_0 & 0x80808080) {				      \
		    unsigned mask;					      \
									      \
		    mask = sum_0 & 0x80808080;				      \
		    mask |= mask >> 1;					      \
		    mask |= mask >> 2;					      \
		    mask |= mask >> 4;					      \
		    prediction4s[1] =					      \
			(((sum_0 & 0x7f7f7f7f) << 1) + sum_1) | mask;	      \
		} else {						      \
		    prediction4s[1] = (sum_0 << 1) + sum_1;		      \
		}							      \
		prediction4s = (unsigned *)				      \
		    ((unsigned char *) prediction4s + line_size);	      \
		references += line_size;				      \
	    }								      \
	}								      \
    }
#endif				/* 0 */

#if 0
# undef block_2_1_0

# define block_2_1_0(predictions, references, coefficients, line_size, \
		     increment)						      \
    {									      \
	unsigned char *references_2;					      \
									      \
	references_2 = references + 1;					      \
	block__3_0_0(predictions, references, references_2, coefficients,     \
		     line_size, increment);				      \
    }
#endif				/* 0 */

#if 0
# undef block_2_1_2

# define block_2_1_2(predictions, references, coefficients, line_size, \
		    increment)						      \
    {									      \
	unsigned char *references_2;					      \
									      \
	references_2 = references + 1;					      \
	block__3_0_2(predictions, references, references_2, coefficients,     \
		     line_size, increment);				      \
    }
#endif				/* 0 */

#if 0
# undef block_2_2_0

# define block_2_2_0(predictions, references, coefficients, line_size, \
		     increment)						      \
    {									      \
	unsigned char *references_2;					      \
									      \
	references_2 = references + line_size;				      \
	block__3_0_0(predictions, references, references_2, coefficients,     \
		     line_size, increment);				      \
    }
#endif				/* 0 */

#if 0
# undef block_2_2_1

# define block_2_2_1(predictions, references, coefficients, line_size, \
		     increment)						      \
    {									      \
	unsigned char *references_2;					      \
									      \
	references_2 = references + line_size;				      \
	block_3_0_1(predictions, references, references_2, coefficients,      \
		    line_size, increment);				      \
    }
#endif				/* 0 */

#if 0
# undef block_2_2_2

# define block_2_2_2(predictions, references, coefficients, line_size, \
		     increment)						      \
    {									      \
	unsigned char *references_2;					      \
									      \
	references_2 = references + line_size;				      \
	block__3_0_2(predictions, references, references_2, coefficients,     \
		     line_size, increment);				      \
    }
#endif				/* 0 */

#if 0
# undef block_2_3_2

# define block_2_3_2(predictions, references, coefficients, line_size, \
		     increment)						      \
    {									      \
	unsigned bull, i = 2, *prediction4s, reference4_0, reference4_1,      \
	     reference4_2, reference4_3;				      \
									      \
	prediction4s = (unsigned *) predictions;			      \
	bull = *(unsigned *) (references + 0);				      \
	reference4_1 = *(unsigned *) (references + 1);			      \
	reference4_0 =							      \
	    ((bull >> 2) & 0x3f3f3f3f) + ((reference4_1 >> 2) & 0x3f3f3f3f);  \
	reference4_1 =							      \
	    (bull & 0x03030303) + (reference4_1 & 0x03030303) + 0x02020202;   \
	for (; i; i--) {						      \
	    references += line_size;					      \
	    bull = *(unsigned *) (references + 0);			      \
	    reference4_3 = *(unsigned *) (references + 1);		      \
	    reference4_2 = ((bull >> 2) & 0x3f3f3f3f)			      \
		+ ((reference4_3 >> 2) & 0x3f3f3f3f);			      \
	    reference4_3 = (bull & 0x03030303) + (reference4_3 & 0x03030303); \
	    prediction4s[0] = reference4_0 + reference4_2		      \
		+ (((reference4_1 + reference4_3) >> 2) & 0x03030303);	      \
	    prediction4s = (unsigned *)					      \
		((unsigned char *) prediction4s + line_size);		      \
	    references += line_size;					      \
	    bull = *(unsigned *) (references + 0);			      \
	    reference4_1 = *(unsigned *) (references + 1);		      \
	    reference4_0 = ((bull >> 2) & 0x3f3f3f3f)			      \
		+ ((reference4_1 >> 2) & 0x3f3f3f3f);			      \
	    reference4_1 = (bull & 0x03030303) + (reference4_1 & 0x03030303)  \
		+ 0x02020202;						      \
	    prediction4s[0] = reference4_0 + reference4_2		      \
		+ (((reference4_1 + reference4_3) >> 2) & 0x03030303);	      \
	    prediction4s = (unsigned *)					      \
		((unsigned char *) prediction4s + line_size);		      \
	}								      \
	prediction4s = ((unsigned *) predictions) + 1;			      \
	references -= (line_size << 2) - 4;				      \
	bull = *(unsigned *) (references + 0);				      \
	reference4_1 = *(unsigned *) (references + 1);			      \
	reference4_0 =							      \
	    ((bull >> 2) & 0x3f3f3f3f) + ((reference4_1 >> 2) & 0x3f3f3f3f);  \
	reference4_1 =							      \
	    (bull & 0x03030303) + (reference4_1 & 0x03030303) + 0x02020202;   \
	i = 2;								      \
	for (; i; i--) {						      \
	    references += line_size;					      \
	    bull = *(unsigned *) (references + 0);			      \
	    reference4_3 = *(unsigned *) (references + 1);		      \
	    reference4_2 = ((bull >> 2) & 0x3f3f3f3f)			      \
		+ ((reference4_3 >> 2) & 0x3f3f3f3f);			      \
	    reference4_3 = (bull & 0x03030303) + (reference4_3 & 0x03030303); \
	    prediction4s[0] = reference4_0 + reference4_2		      \
		+ (((reference4_1 + reference4_3) >> 2) & 0x03030303);	      \
	    prediction4s = (unsigned *)					      \
		((unsigned char *) prediction4s + line_size);		      \
	    references += line_size;					      \
	    bull = *(unsigned *) (references + 0);			      \
	    reference4_1 = *(unsigned *) (references + 1);		      \
	    reference4_0 = ((bull >> 2) & 0x3f3f3f3f)			      \
		+ ((reference4_1 >> 2) & 0x3f3f3f3f);			      \
	    reference4_1 = (bull & 0x03030303) + (reference4_1 & 0x03030303)  \
		+ 0x02020202;						      \
	    prediction4s[0] = reference4_0 + reference4_2		      \
		+ (((reference4_1 + reference4_3) >> 2) & 0x03030303);	      \
	    prediction4s = (unsigned *)					      \
		((unsigned char *) prediction4s + line_size);		      \
	}								      \
    }
#endif				/* 0 */

#define block__3_1_2(predictions, references_0, references_1, coefficients, \
		     line_size, increment)				      \
    {									      \
	unsigned i = 4, *prediction4s;					      \
									      \
	prediction4s = (unsigned *) predictions;			      \
	for (; i; i--) {						      \
	    unsigned reference4_0, reference4_1, reference4_2;		      \
									      \
	    reference4_0 = *(unsigned *) (references_0 + 0);		      \
	    reference4_1 = *(unsigned *) (references_1 + 0);		      \
	    reference4_2 = *(unsigned *) (references_1 + 1);		      \
	    prediction4s[0] = ((reference4_0 >> 1) & 0x7e7e7e7e)	      \
		+ ((reference4_1 >> 2) & 0x3f3f3f3f)			      \
		+ ((reference4_2 >> 2) & 0x3f3f3f3f)			      \
		+ ((((reference4_0 & 0x03030303)			      \
		     + ((((reference4_1 & 0x03030303)			      \
			  + (reference4_2 & 0x03030303) + 0x01010101) >> 1)   \
			& 0x03030303)					      \
		     + 0x01010101) >> 1) & 0x03030303);			      \
	    reference4_0 = *(unsigned *) (references_0 + 4);		      \
	    reference4_1 = *(unsigned *) (references_1 + 4);		      \
	    reference4_2 = *(unsigned *) (references_1 + 5);		      \
	    prediction4s[1] = ((reference4_0 >> 1) & 0x7e7e7e7e)	      \
		+ ((reference4_1 >> 2) & 0x3f3f3f3f)			      \
		+ ((reference4_2 >> 2) & 0x3f3f3f3f)			      \
		+ ((((reference4_0 & 0x03030303)			      \
		     + ((((reference4_1 & 0x03030303)			      \
			  + (reference4_2 & 0x03030303) + 0x01010101) >> 1)   \
			& 0x03030303)					      \
		     + 0x01010101) >> 1) & 0x03030303);			      \
	    prediction4s = (unsigned *)					      \
		((unsigned char *) prediction4s + line_size);		      \
	    references_0 += line_size;					      \
	    references_1 += line_size;					      \
	}								      \
    }

#define block__3_2_2(predictions, references_0, references_1, coefficients, \
		     line_size, increment)				      \
    {									      \
	unsigned i = 2, *prediction4s, reference4_1_x3f3f3f3f,		      \
	    reference4_1_x03030303;					      \
									      \
	prediction4s = (unsigned *) predictions;			      \
	reference4_1_x03030303 = *(unsigned *) (references_1 + 0);	      \
	reference4_1_x3f3f3f3f =					      \
	    (reference4_1_x03030303 >> 2) & 0x3f3f3f3f;			      \
	reference4_1_x03030303 &= 0x03030303;				      \
	for (; i; i--) {						      \
	    unsigned reference4_0, reference4_2_x03030303,		      \
		reference4_2_x3f3f3f3f;					      \
									      \
	    reference4_0 = *(unsigned *) (references_0 + 0);		      \
	    references_1 += line_size;					      \
	    reference4_2_x3f3f3f3f = *(unsigned *) (references_1 + 0);	      \
	    reference4_2_x03030303 =					      \
		(reference4_2_x3f3f3f3f & 0x03030303) + 0x01010101;	      \
	    reference4_2_x3f3f3f3f =					      \
		(reference4_2_x3f3f3f3f >> 2) & 0x3f3f3f3f;		      \
	    prediction4s[0] = ((reference4_0 >> 1) & 0x7e7e7e7e)	      \
		+ reference4_1_x3f3f3f3f + reference4_2_x3f3f3f3f	      \
		+ ((((reference4_0 & 0x03030303)			      \
		     + (((reference4_1_x03030303 + reference4_2_x03030303)    \
			 >> 1) & 0x03030303) + 0x01010101) >> 1)	      \
		   & 0x03030303);					      \
	    prediction4s = (unsigned *)					      \
		((unsigned char *) prediction4s + line_size);		      \
	    references_0 += line_size;					      \
	    reference4_0 = *(unsigned *) (references_0 + 0);		      \
	    references_1 += line_size;					      \
	    reference4_1_x03030303 = *(unsigned *) (references_1 + 0);	      \
	    reference4_1_x3f3f3f3f =					      \
		(reference4_1_x03030303 >> 2) & 0x3f3f3f3f;		      \
	    reference4_1_x03030303 &= 0x03030303;			      \
	    prediction4s[0] = ((reference4_0 >> 1) & 0x7e7e7e7e)	      \
		+ reference4_1_x3f3f3f3f + reference4_2_x3f3f3f3f	      \
		+ ((((reference4_0 & 0x03030303)			      \
		     + (((reference4_1_x03030303 + reference4_2_x03030303)    \
			 >> 1) & 0x03030303) + 0x01010101) >> 1)	      \
		   & 0x03030303);					      \
	    prediction4s = (unsigned *)					      \
		((unsigned char *) prediction4s + line_size);		      \
	    references_0 += line_size;					      \
	}								      \
	prediction4s = ((unsigned *) predictions) + 1;			      \
	references_0 -= (line_size << 2) - 4;				      \
	references_1 -= (line_size << 2) - 4;				      \
	reference4_1_x03030303 = *(unsigned *) (references_1 + 0);	      \
	reference4_1_x3f3f3f3f =					      \
	    (reference4_1_x03030303 >> 2) & 0x3f3f3f3f;			      \
	reference4_1_x03030303 &= 0x03030303;				      \
	i = 2;								      \
	for (; i; i--) {						      \
	    unsigned reference4_0, reference4_2_x03030303,		      \
		reference4_2_x3f3f3f3f;					      \
									      \
	    reference4_0 = *(unsigned *) (references_0 + 0);		      \
	    references_1 += line_size;					      \
	    reference4_2_x3f3f3f3f = *(unsigned *) (references_1 + 0);	      \
	    reference4_2_x03030303 =					      \
		(reference4_2_x3f3f3f3f & 0x03030303) + 0x01010101;	      \
	    reference4_2_x3f3f3f3f =					      \
		(reference4_2_x3f3f3f3f >> 2) & 0x3f3f3f3f;		      \
	    prediction4s[0] = ((reference4_0 >> 1) & 0x7e7e7e7e)	      \
		+ reference4_1_x3f3f3f3f + reference4_2_x3f3f3f3f	      \
		+ ((((reference4_0 & 0x03030303)			      \
		     + (((reference4_1_x03030303 + reference4_2_x03030303)    \
			 >> 1) & 0x03030303) + 0x01010101) >> 1)	      \
		   & 0x03030303);					      \
	    prediction4s = (unsigned *)					      \
		((unsigned char *) prediction4s + line_size);		      \
	    references_0 += line_size;					      \
	    reference4_0 = *(unsigned *) (references_0 + 0);		      \
	    references_1 += line_size;					      \
	    reference4_1_x03030303 = *(unsigned *) (references_1 + 0);	      \
	    reference4_1_x3f3f3f3f =					      \
		(reference4_1_x03030303 >> 2) & 0x3f3f3f3f;		      \
	    reference4_1_x03030303 &= 0x03030303;			      \
	    prediction4s[0] = ((reference4_0 >> 1) & 0x7e7e7e7e)	      \
		+ reference4_1_x3f3f3f3f + reference4_2_x3f3f3f3f	      \
		+ ((((reference4_0 & 0x03030303)			      \
		     + (((reference4_1_x03030303 + reference4_2_x03030303)    \
			 >> 1) & 0x03030303) + 0x01010101) >> 1)	      \
		   & 0x03030303);					      \
	    prediction4s = (unsigned *)					      \
		((unsigned char *) prediction4s + line_size);		      \
	    references_0 += line_size;					      \
	}								      \
    }

#define block__3_6_2(predictions, references_0, references_1, coefficients, \
		     line_size, increment)				      \
    {									      \
	unsigned i = 2, *prediction4s, reference4_2_x3f3f3f3f,		      \
	    reference4_2_x03030303;					      \
									      \
	prediction4s = (unsigned *) predictions;			      \
	reference4_2_x03030303 = *(unsigned *) (references_1 + 0);	      \
	reference4_2_x3f3f3f3f =					      \
	    (reference4_2_x03030303 >> 2) & 0x3f3f3f3f;			      \
	reference4_2_x03030303 &= 0x03030303;				      \
	for (; i; i--) {						      \
	    unsigned reference4_0, reference4_1, reference4_3_x3f3f3f3f,      \
		reference4_3_x03030303;					      \
									      \
	    reference4_0 = *(unsigned *) (references_0 + 0);		      \
	    reference4_1 = *(unsigned *) (references_0 + 1);		      \
	    references_0 += line_size;					      \
	    references_1 += line_size;					      \
	    reference4_3_x03030303 = *(unsigned *) (references_1 + 0);	      \
	    reference4_3_x3f3f3f3f =					      \
		(reference4_3_x03030303 >> 2) & 0x3f3f3f3f;		      \
	    reference4_3_x03030303 &= 0x03030303;			      \
	    reference4_3_x03030303 += 0x01010101;			      \
	    prediction4s[0] = ((reference4_0 >> 2) & 0x3f3f3f3f)	      \
		+ ((reference4_1 >> 2) & 0x3f3f3f3f)			      \
		+ reference4_2_x3f3f3f3f + reference4_3_x3f3f3f3f	      \
		+ (((((((reference4_0 & 0x03030303)			      \
			+ (reference4_1 & 0x03030303) + 0x01010101) >> 1)     \
		      & 0x03030303)					      \
		     + (((reference4_2_x03030303 + reference4_3_x03030303)    \
			 >> 1) & 0x03030303) + 0x01010101) >> 1)	      \
		   & 0x03030303);					      \
	    prediction4s = (unsigned *)					      \
		((unsigned char *) prediction4s + line_size);		      \
	    reference4_0 = *(unsigned *) (references_0 + 0);		      \
	    reference4_1 = *(unsigned *) (references_0 + 1);		      \
	    references_0 += line_size;					      \
	    references_1 += line_size;					      \
	    reference4_2_x03030303 = *(unsigned *) (references_1 + 0);	      \
	    reference4_2_x3f3f3f3f =					      \
		(reference4_2_x03030303 >> 2) & 0x3f3f3f3f;		      \
	    reference4_2_x03030303 &= 0x03030303;			      \
	    prediction4s[0] = ((reference4_0 >> 2) & 0x3f3f3f3f)	      \
		+ ((reference4_1 >> 2) & 0x3f3f3f3f)			      \
		+ reference4_2_x3f3f3f3f + reference4_3_x3f3f3f3f	      \
		+ (((((((reference4_0 & 0x03030303)			      \
			+ (reference4_1 & 0x03030303) + 0x01010101) >> 1)     \
		      & 0x03030303)					      \
		     + (((reference4_2_x03030303 + reference4_3_x03030303)    \
			 >> 1) & 0x03030303) + 0x01010101) >> 1)	      \
		   & 0x03030303);					      \
	    prediction4s = (unsigned *)					      \
		((unsigned char *) prediction4s + line_size);		      \
	}								      \
	prediction4s = ((unsigned *) predictions) + 1;			      \
	references_0 -= (line_size << 2) - 4;				      \
	references_1 -= (line_size << 2) - 4;				      \
	reference4_2_x03030303 = *(unsigned *) (references_1 + 0);	      \
	reference4_2_x3f3f3f3f =					      \
	    (reference4_2_x03030303 >> 2) & 0x3f3f3f3f;			      \
	reference4_2_x03030303 &= 0x03030303;				      \
	i = 2;								      \
	for (; i; i--) {						      \
	    unsigned reference4_0, reference4_1, reference4_3_x3f3f3f3f,      \
		reference4_3_x03030303;					      \
									      \
	    reference4_0 = *(unsigned *) (references_0 + 0);		      \
	    reference4_1 = *(unsigned *) (references_0 + 1);		      \
	    references_0 += line_size;					      \
	    references_1 += line_size;					      \
	    reference4_3_x03030303 = *(unsigned *) (references_1 + 0);	      \
	    reference4_3_x3f3f3f3f =					      \
		(reference4_3_x03030303 >> 2) & 0x3f3f3f3f;		      \
	    reference4_3_x03030303 &= 0x03030303;			      \
	    reference4_3_x03030303 += 0x01010101;			      \
	    prediction4s[0] = ((reference4_0 >> 2) & 0x3f3f3f3f)	      \
		+ ((reference4_1 >> 2) & 0x3f3f3f3f)			      \
		+ reference4_2_x3f3f3f3f + reference4_3_x3f3f3f3f	      \
		+ (((((((reference4_0 & 0x03030303)			      \
			+ (reference4_1 & 0x03030303) + 0x01010101) >> 1)     \
		      & 0x03030303)					      \
		     + (((reference4_2_x03030303 + reference4_3_x03030303)    \
			 >> 1) & 0x03030303) + 0x01010101) >> 1)	      \
		   & 0x03030303);					      \
	    prediction4s = (unsigned *)					      \
		((unsigned char *) prediction4s + line_size);		      \
	    reference4_0 = *(unsigned *) (references_0 + 0);		      \
	    reference4_1 = *(unsigned *) (references_0 + 1);		      \
	    references_0 += line_size;					      \
	    references_1 += line_size;					      \
	    reference4_2_x03030303 = *(unsigned *) (references_1 + 0);	      \
	    reference4_2_x3f3f3f3f =					      \
		(reference4_2_x03030303 >> 2) & 0x3f3f3f3f;		      \
	    reference4_2_x03030303 &= 0x03030303;			      \
	    prediction4s[0] = ((reference4_0 >> 2) & 0x3f3f3f3f)	      \
		+ ((reference4_1 >> 2) & 0x3f3f3f3f)			      \
		+ reference4_2_x3f3f3f3f + reference4_3_x3f3f3f3f	      \
		+ (((((((reference4_0 & 0x03030303)			      \
			+ (reference4_1 & 0x03030303) + 0x01010101) >> 1)     \
		      & 0x03030303)					      \
		     + (((reference4_2_x03030303 + reference4_3_x03030303)    \
			 >> 1) & 0x03030303) + 0x01010101) >> 1)	      \
		   & 0x03030303);					      \
	    prediction4s = (unsigned *)					      \
		((unsigned char *) prediction4s + line_size);		      \
	}								      \
    }

#if 0
# undef block_3_0_0

# define block_3_0_0(predictions, references_0, references_1, coefficients, \
		     line_size, increment)				      \
    {									      \
	block__3_0_0(predictions, references_0, references_1, coefficients,   \
		     line_size, increment);				      \
    }
#endif				/* 0 */

#if 0
# undef block_3_0_2

# define block_3_0_2(predictions, references_0, references_1, coefficients, \
		     line_size, increment)				      \
    {									      \
	block__3_0_2(predictions, references_0, references_1, coefficients,   \
		     line_size, increment);				      \
    }
#endif				/* 0 */

#if 0
# undef block_3_1_2

# define block_3_1_2(predictions, references_0, references_1, coefficients, \
		     line_size, increment)				      \
    {									      \
	block__3_1_2(predictions, references_0, references_1, coefficients,   \
		     line_size, increment);				      \
    }
#endif				/* 0 */

#if 0
# undef block_3_2_2

# define block_3_2_2(predictions, references_0, references_1, coefficients, \
		     line_size, increment)				      \
    {									      \
	block__3_2_2(predictions, references_0, references_1, coefficients,   \
		     line_size, increment);				      \
    }
#endif				/* 0 */

#if 0
# undef block_3_4_2

# define block_3_4_2(predictions, references_0, references_1, coefficients, \
		     line_size, increment)				      \
    {									      \
	block__3_1_2(predictions, references_1, references_0, coefficients,   \
		     line_size, increment);				      \
    }
#endif				/* 0 */

#if 0
# undef block_3_5_2

# define block_3_5_2(predictions, references_0, references_1, coefficients, \
		     line_size, increment)				      \
    {									      \
	unsigned i = 4, *prediction4s;					      \
									      \
	prediction4s = (unsigned *) predictions;			      \
	for (; i; i--) {						      \
	    unsigned reference4_0, reference4_1, reference4_2, reference4_3;  \
									      \
	    reference4_0 = *(unsigned *) (references_0 + 0);		      \
	    reference4_1 = *(unsigned *) (references_0 + 1);		      \
	    reference4_2 = *(unsigned *) (references_1 + 0);		      \
	    reference4_3 = *(unsigned *) (references_1 + 1);		      \
	    prediction4s[0] = ((reference4_0 >> 2) & 0x3f3f3f3f)	      \
		+ ((reference4_1 >> 2) & 0x3f3f3f3f)			      \
		+ ((reference4_2 >> 2) & 0x3f3f3f3f)			      \
		+ ((reference4_3 >> 2) & 0x3f3f3f3f)			      \
		+ (((((((reference4_0 & 0x03030303)			      \
			+ (reference4_1 & 0x03030303) + 0x01010101) >> 1)     \
		      & 0x03030303)					      \
		     + ((((reference4_2 & 0x03030303)			      \
			  + (reference4_3 & 0x03030303) + 0x01010101) >> 1)   \
			& 0x03030303) + 0x01010101) >> 1) & 0x03030303);      \
	    reference4_0 = *(unsigned *) (references_0 + 4);		      \
	    reference4_1 = *(unsigned *) (references_0 + 5);		      \
	    reference4_2 = *(unsigned *) (references_1 + 4);		      \
	    reference4_3 = *(unsigned *) (references_1 + 5);		      \
	    prediction4s[1] = ((reference4_0 >> 2) & 0x3f3f3f3f)	      \
		+ ((reference4_1 >> 2) & 0x3f3f3f3f)			      \
		+ ((reference4_2 >> 2) & 0x3f3f3f3f)			      \
		+ ((reference4_3 >> 2) & 0x3f3f3f3f)			      \
		+ (((((((reference4_0 & 0x03030303)			      \
			+ (reference4_1 & 0x03030303) + 0x01010101) >> 1)     \
		      & 0x03030303)					      \
		     + ((((reference4_2 & 0x03030303)			      \
			  + (reference4_3 & 0x03030303) + 0x01010101) >> 1)   \
			& 0x03030303) + 0x01010101) >> 1) & 0x03030303);      \
	    prediction4s = (unsigned *)					      \
		((unsigned char *) prediction4s + line_size);		      \
	    references_0 += line_size;					      \
	    references_1 += line_size;					      \
	}								      \
    }
#endif				/* 0 */

#if 0
# undef block_3_6_2

# define block_3_6_2(predictions, references_0, references_1, coefficients, \
		     line_size, increment)				      \
    {									      \
	block__3_6_2(predictions, references_0, references_1, coefficients,   \
		     line_size, increment);				      \
    }
#endif				/* 0 */

#if 0
# undef block_3_8_2

# define block_3_8_2(predictions, references_0, references_1, coefficients, \
		     line_size, increment)				      \
    {									      \
	block__3_2_2(predictions, references_1, references_0, coefficients,   \
		     line_size, increment);				      \
    }
#endif				/* 0 */

#if 0
# undef block_3_9_2

# define block_3_9_2(predictions, references_0, references_1, coefficients, \
		     line_size, increment)				      \
    {									      \
	block__3_6_2(predictions, references_1, references_0, coefficients,   \
		     line_size, increment);				      \
    }
#endif				/* 0 */

#if 0
# undef block_3_a_2

# define block_3_a_2(predictions, references_0, references_1, coefficients, \
		     line_size, increment)				      \
    {									      \
	unsigned i = 2, *prediction4s, reference4_0_x03030303,		      \
	    reference4_02_x3f3f3f3f, reference4_2_x03030303;		      \
									      \
	prediction4s = (unsigned *) predictions;			      \
	reference4_0_x03030303 = *(unsigned *) (references_0 + 0);	      \
	reference4_02_x3f3f3f3f =					      \
	    (reference4_0_x03030303 >> 2) & 0x3f3f3f3f;			      \
	reference4_0_x03030303 &= 0x03030303;				      \
	reference4_2_x03030303 = *(unsigned *) (references_1 + 0);	      \
	reference4_02_x3f3f3f3f +=					      \
	    (reference4_2_x03030303 >> 2) & 0x3f3f3f3f;			      \
	reference4_2_x03030303 &= 0x03030303;				      \
	for (; i; i--) {						      \
	    unsigned reference4_1_x03030303, reference4_13_x3f3f3f3f,	      \
		reference4_3_x03030303;					      \
									      \
	    references_0 += line_size;					      \
	    references_1 += line_size;					      \
	    reference4_1_x03030303 = *(unsigned *) (references_0 + 0);	      \
	    reference4_13_x3f3f3f3f =					      \
		(reference4_1_x03030303 >> 2) & 0x3f3f3f3f;		      \
	    reference4_1_x03030303 &= 0x03030303;			      \
	    reference4_1_x03030303 += 0x01010101;			      \
	    reference4_3_x03030303 = *(unsigned *) (references_1 + 0);	      \
	    reference4_13_x3f3f3f3f +=					      \
		(reference4_3_x03030303 >> 2) & 0x3f3f3f3f;		      \
	    reference4_3_x03030303 &= 0x03030303;			      \
	    reference4_3_x03030303 += 0x01010101;			      \
	    prediction4s[0] = reference4_02_x3f3f3f3f			      \
		+ reference4_13_x3f3f3f3f				      \
		+ ((((((reference4_0_x03030303 + reference4_1_x03030303) >> 1)\
		      & 0x03030303)					      \
		     + (((reference4_2_x03030303 + reference4_3_x03030303)    \
		         >> 1) & 0x03030303) + 0x01010101) >> 1)	      \
		   & 0x03030303);					      \
	    prediction4s = (unsigned *)					      \
		((unsigned char *) prediction4s + line_size);		      \
	    references_0 += line_size;					      \
	    references_1 += line_size;					      \
	    reference4_0_x03030303 = *(unsigned *) (references_0 + 0);	      \
	    reference4_02_x3f3f3f3f =					      \
		(reference4_0_x03030303 >> 2) & 0x3f3f3f3f;		      \
	    reference4_0_x03030303 &= 0x03030303;			      \
	    reference4_2_x03030303 = *(unsigned *) (references_1 + 0);	      \
	    reference4_02_x3f3f3f3f +=					      \
		(reference4_2_x03030303 >> 2) & 0x3f3f3f3f;		      \
	    reference4_2_x03030303 &= 0x03030303;			      \
	    prediction4s[0] = reference4_02_x3f3f3f3f			      \
		+ reference4_13_x3f3f3f3f				      \
		+ ((((((reference4_0_x03030303 + reference4_1_x03030303) >> 1)\
		      & 0x03030303)					      \
		     + (((reference4_2_x03030303 + reference4_3_x03030303)    \
		         >> 1) & 0x03030303) + 0x01010101) >> 1)	      \
		   & 0x03030303);					      \
	    prediction4s = (unsigned *)					      \
		((unsigned char *) prediction4s + line_size);		      \
	}								      \
	prediction4s = ((unsigned *) predictions) + 1;			      \
	references_0 -= (line_size << 2) - 4;				      \
	references_1 -= (line_size << 2) - 4;				      \
	reference4_0_x03030303 = *(unsigned *) (references_0 + 0);	      \
	reference4_02_x3f3f3f3f =					      \
	    (reference4_0_x03030303 >> 2) & 0x3f3f3f3f;			      \
	reference4_0_x03030303 &= 0x03030303;				      \
	reference4_2_x03030303 = *(unsigned *) (references_1 + 0);	      \
	reference4_02_x3f3f3f3f +=					      \
	    (reference4_2_x03030303 >> 2) & 0x3f3f3f3f;			      \
	reference4_2_x03030303 &= 0x03030303;				      \
	i = 2;								      \
	for (; i; i--) {						      \
	    unsigned reference4_1_x03030303, reference4_13_x3f3f3f3f,	      \
		reference4_3_x03030303;					      \
									      \
	    references_0 += line_size;					      \
	    references_1 += line_size;					      \
	    reference4_1_x03030303 = *(unsigned *) (references_0 + 0);	      \
	    reference4_13_x3f3f3f3f =					      \
		(reference4_1_x03030303 >> 2) & 0x3f3f3f3f;		      \
	    reference4_1_x03030303 &= 0x03030303;			      \
	    reference4_1_x03030303 += 0x01010101;			      \
	    reference4_3_x03030303 = *(unsigned *) (references_1 + 0);	      \
	    reference4_13_x3f3f3f3f +=					      \
		(reference4_3_x03030303 >> 2) & 0x3f3f3f3f;		      \
	    reference4_3_x03030303 &= 0x03030303;			      \
	    reference4_3_x03030303 += 0x01010101;			      \
	    prediction4s[0] = reference4_02_x3f3f3f3f			      \
		+ reference4_13_x3f3f3f3f				      \
		+ ((((((reference4_0_x03030303 + reference4_1_x03030303) >> 1)\
		      & 0x03030303)					      \
		     + (((reference4_2_x03030303 + reference4_3_x03030303)    \
		         >> 1) & 0x03030303) + 0x01010101) >> 1)	      \
		   & 0x03030303);					      \
	    prediction4s = (unsigned *)					      \
		((unsigned char *) prediction4s + line_size);		      \
	    references_0 += line_size;					      \
	    references_1 += line_size;					      \
	    reference4_0_x03030303 = *(unsigned *) (references_0 + 0);	      \
	    reference4_02_x3f3f3f3f =					      \
		(reference4_0_x03030303 >> 2) & 0x3f3f3f3f;		      \
	    reference4_0_x03030303 &= 0x03030303;			      \
	    reference4_2_x03030303 = *(unsigned *) (references_1 + 0);	      \
	    reference4_02_x3f3f3f3f +=					      \
		(reference4_2_x03030303 >> 2) & 0x3f3f3f3f;		      \
	    reference4_2_x03030303 &= 0x03030303;			      \
	    prediction4s[0] = reference4_02_x3f3f3f3f			      \
		+ reference4_13_x3f3f3f3f				      \
		+ ((((((reference4_0_x03030303 + reference4_1_x03030303) >> 1)\
		      & 0x03030303)					      \
		     + (((reference4_2_x03030303 + reference4_3_x03030303)    \
		         >> 1) & 0x03030303) + 0x01010101) >> 1)	      \
		   & 0x03030303);					      \
	    prediction4s = (unsigned *)					      \
		((unsigned char *) prediction4s + line_size);		      \
	}								      \
    }
#endif				/* 0 */

#endif				/* __SEEK_H262_D_H__ */
