/*
 * h262.d.part3.c
 * Copyright (C) 2003, 2004  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <h262.0.h>
#include <h262.1.h>
#include <h262.3.h>

extern seek_h262_coefficient _seek_h262_non_intra_coefficients[][82];

static void init_non_intra_coefficients(void);

static void
init_non_intra_coefficients(void)
{
    seek_h262_coefficient coefficient, *coefficients;
    unsigned i = 1, j;

    coefficients = _seek_h262_non_intra_coefficients[1];

    for (; i < 32; i++) {
	for (j = 0; j < 41; j++) {
	    coefficient = (((j << 1) + 1) * i - 1) | 1;
	    *coefficients++ = coefficient;
	    *coefficients++ = -coefficient;
	}
    }
}


void
seek_h262_init_tables(void)
{
    _seek_h262_init_AnnexB();
    init_non_intra_coefficients();
}
