/*
 * h262.e.11172.c
 * Copyright (C) 2003, 2004, 2005, 2006, 2007  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <h262.0.h>
#include <h262.1.h>
#include <h262.2.h>
#include <h262.3.h>
#include <h262.4.h>
#include <h262.b.h>

#define __RUN_FUTILE__			0

void
_seek_h262_GRAYSCALE_x10_macroblocks(struct seek_h262_video *video)
{
    struct seek_h262_11172_macroblock *macroblock;
    unsigned previous_macroblock_address, skipped_a, skipped_b, skipped_c;

    macroblock = video->macroblock;
    if (!(macroblock->macroblock_address < video->macroblocks_count)) {
	return;
    }
    {
	unsigned mb_column;

	mb_column = macroblock->macroblock_address % video->mb_width;
	video->mb_advance = (macroblock->macroblock_address - mb_column) << 8;
	video->mb_offset = video->mb_advance + (mb_column << 4);
	video->mb_advance += video->mb_width << 4;
    }
    previous_macroblock_address = macroblock->previous_macroblock_address + 1;
    skipped_a = NEXT_LEVEL(previous_macroblock_address, video->mb_width);
    if (skipped_a < macroblock->macroblock_address) {
	skipped_b =
	    PREVIOUS_LEVEL(macroblock->macroblock_address, video->mb_width);
	skipped_c = macroblock->macroblock_address - skipped_b;
	skipped_b -= skipped_a;
	skipped_a -= previous_macroblock_address;
    } else {
	skipped_a =
	    macroblock->macroblock_address - previous_macroblock_address;
	skipped_b = 0;
	skipped_c = 0;
    }
#if !__RUN_FUTILE__
    if (skipped_a) {
	unsigned ii = 16, mb_column, mb_row, offset, skip_line;
	unsigned_q *prediction, *reference;

	mb_column = previous_macroblock_address % video->mb_width;
	mb_row = previous_macroblock_address / video->mb_width;
	offset = (mb_row * video->luminance_line_size + mb_column) << 4;
	prediction = (unsigned_q *) (video->Mylene_release.Y + offset);
	reference = (unsigned_q *) (video->Irulan_release.Y + offset);
	skip_line = video->luminance_line_size - (skipped_a << 4);
	for (; ii; ii--) {
	    unsigned iii;

	    for (iii = skipped_a; iii; iii--) {
		*prediction++ = *reference++;
		*prediction++ = *reference++;
# if SIZEOF_LONG != 8
		*prediction++ = *reference++;
		*prediction++ = *reference++;
# endif				/* SIZEOF_LONG != 8 */
	    }
	    prediction = (unsigned_q *)
		((unsigned char *) prediction + skip_line);
	    reference = (unsigned_q *)
		((unsigned char *) reference + skip_line);
	}
    }
#endif				/* !__RUN_FUTILE__ */
    previous_macroblock_address += skipped_a;
#if !__RUN_FUTILE__
    if (skipped_b) {
	unsigned mb_row, offset;
	unsigned_q *prediction, *reference;

	mb_row = previous_macroblock_address / video->mb_width;
	offset = (mb_row * video->luminance_line_size) << 4;
	prediction = (unsigned_q *) (video->Mylene_release.Y + offset);
	reference = (unsigned_q *) (video->Irulan_release.Y + offset);
	{
	    unsigned iii;

	    for (iii = skipped_b; iii; iii--) {
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
# if SIZEOF_LONG != 8
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
# endif				/* SIZEOF_LONG != 8 */
	    }
	}
    }
#endif				/* !__RUN_FUTILE__ */
    previous_macroblock_address += skipped_b;
#if !__RUN_FUTILE__
    if (skipped_c) {
	unsigned ii = 16, mb_row, offset, skip_line;
	unsigned_q *prediction, *reference;

	mb_row = previous_macroblock_address / video->mb_width;
	offset = (mb_row * video->luminance_line_size) << 4;
	prediction = (unsigned_q *) (video->Mylene_release.Y + offset);
	reference = (unsigned_q *) (video->Irulan_release.Y + offset);
	skip_line = video->luminance_line_size - (skipped_c << 4);
	for (; ii; ii--) {
	    unsigned iii;

	    for (iii = skipped_c; iii; iii--) {
		*prediction++ = *reference++;
		*prediction++ = *reference++;
# if SIZEOF_LONG != 8
		*prediction++ = *reference++;
		*prediction++ = *reference++;
# endif				/* SIZEOF_LONG != 8 */
	    }
	    prediction = (unsigned_q *)
		((unsigned char *) prediction + skip_line);
	    reference = (unsigned_q *)
		((unsigned char *) reference + skip_line);
	}
    }
#endif				/* !__RUN_FUTILE__ */
    previous_macroblock_address += skipped_c;
    macroblock->previous_macroblock_address = previous_macroblock_address - 1;
}


void
_seek_h262_YCbCr_____x10_macroblocks(struct seek_h262_video *video)
{
    struct seek_h262_11172_macroblock *macroblock;
    unsigned previous_macroblock_address, skipped_a, skipped_b, skipped_c;

    macroblock = video->macroblock;
    if (!(macroblock->macroblock_address < video->macroblocks_count)) {
	return;
    }
    {
	unsigned mb_column, mb_width, offset;

	mb_width = video->mb_width;
	mb_column = macroblock->macroblock_address % mb_width;
	offset = (macroblock->macroblock_address - mb_column) << 8;
	video->mb_advance = offset + (mb_width << 4);
	video->mb_offset = offset + (mb_column << 4);
	offset >>= 2;
	video->mb_chroma = offset + (mb_column << 3);
    }
    previous_macroblock_address = macroblock->previous_macroblock_address + 1;
    skipped_a = NEXT_LEVEL(previous_macroblock_address, video->mb_width);
    if (skipped_a < macroblock->macroblock_address) {
	skipped_b =
	    PREVIOUS_LEVEL(macroblock->macroblock_address, video->mb_width);
	skipped_c = macroblock->macroblock_address - skipped_b;
	skipped_b -= skipped_a;
	skipped_a -= previous_macroblock_address;
    } else {
	skipped_a =
	    macroblock->macroblock_address - previous_macroblock_address;
	skipped_b = 0;
	skipped_c = 0;
    }
#if !__RUN_FUTILE__
    if (skipped_a) {
	unsigned ii = 16, mb_column, mb_row, offset, skip_line;
	unsigned_q *prediction, *reference;

	mb_column = previous_macroblock_address % video->mb_width;
	mb_row = previous_macroblock_address / video->mb_width;
	offset = (mb_row * video->luminance_line_size + mb_column) << 4;
	prediction = (unsigned_q *) (video->Mylene_release.Y + offset);
	reference = (unsigned_q *) (video->Irulan_release.Y + offset);
	skip_line = video->luminance_line_size - (skipped_a << 4);
	for (; ii; ii--) {
	    unsigned iii;

	    for (iii = skipped_a; iii; iii--) {
		*prediction++ = *reference++;
		*prediction++ = *reference++;
# if SIZEOF_LONG != 8
		*prediction++ = *reference++;
		*prediction++ = *reference++;
# endif				/* SIZEOF_LONG != 8 */
	    }
	    prediction = (unsigned_q *)
		((unsigned char *) prediction + skip_line);
	    reference = (unsigned_q *)
		((unsigned char *) reference + skip_line);
	}
	offset >>= 2;
	offset += mb_column << 2;
	{
	    unsigned i = 0;

	    skip_line = video->chrominance_line_size - (skipped_a << 3);
	    for (; i < 2; i++) {
		if (i) {
		    prediction =
			(unsigned_q *) (video->Mylene_release.Cb + offset);
		    reference =
			(unsigned_q *) (video->Irulan_release.Cb + offset);
		} else {
		    prediction =
			(unsigned_q *) (video->Mylene_release.Cr + offset);
		    reference =
			(unsigned_q *) (video->Irulan_release.Cr + offset);
		}
		for (ii = 8; ii; ii--) {
		    unsigned iii;

		    for (iii = skipped_a; iii; iii--) {
			*prediction++ = *reference++;
# if SIZEOF_LONG != 8
			*prediction++ = *reference++;
# endif				/* SIZEOF_LONG != 8 */
		    }
		    prediction = (unsigned_q *)
			((unsigned char *) prediction + skip_line);
		    reference = (unsigned_q *)
			((unsigned char *) reference + skip_line);
		}
	    }
	}
    }
#endif				/* !__RUN_FUTILE__ */
    previous_macroblock_address += skipped_a;
#if !__RUN_FUTILE__
    if (skipped_b) {
	unsigned mb_row, offset;
	unsigned_q *prediction, *reference;

	mb_row = previous_macroblock_address / video->mb_width;
	offset = (mb_row * video->luminance_line_size) << 4;
	prediction = (unsigned_q *) (video->Mylene_release.Y + offset);
	reference = (unsigned_q *) (video->Irulan_release.Y + offset);
	{
	    unsigned iii;

	    for (iii = skipped_b; iii; iii--) {
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
# if SIZEOF_LONG != 8
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
		*prediction++ = *reference++;
# endif				/* SIZEOF_LONG != 8 */
	    }
	}
	offset >>= 2;
	{
	    unsigned i = 0;

	    for (; i < 2; i++) {
		if (i) {
		    prediction =
			(unsigned_q *) (video->Mylene_release.Cb + offset);
		    reference =
			(unsigned_q *) (video->Irulan_release.Cb + offset);
		} else {
		    prediction =
			(unsigned_q *) (video->Mylene_release.Cr + offset);
		    reference =
			(unsigned_q *) (video->Irulan_release.Cr + offset);
		}
		{
		    unsigned iii;

		    for (iii = skipped_b; iii; iii--) {
			*prediction++ = *reference++;
			*prediction++ = *reference++;
			*prediction++ = *reference++;
			*prediction++ = *reference++;
			*prediction++ = *reference++;
			*prediction++ = *reference++;
			*prediction++ = *reference++;
			*prediction++ = *reference++;
# if SIZEOF_LONG != 8
			*prediction++ = *reference++;
			*prediction++ = *reference++;
			*prediction++ = *reference++;
			*prediction++ = *reference++;
			*prediction++ = *reference++;
			*prediction++ = *reference++;
			*prediction++ = *reference++;
			*prediction++ = *reference++;
# endif				/* SIZEOF_LONG != 8 */
		    }
		}
	    }
	}
    }
#endif				/* !__RUN_FUTILE__ */
    previous_macroblock_address += skipped_b;
#if !__RUN_FUTILE__
    if (skipped_c) {
	unsigned ii = 16, mb_row, offset, skip_line;
	unsigned_q *prediction, *reference;

	mb_row = previous_macroblock_address / video->mb_width;
	offset = (mb_row * video->luminance_line_size) << 4;
	prediction = (unsigned_q *) (video->Mylene_release.Y + offset);
	reference = (unsigned_q *) (video->Irulan_release.Y + offset);
	skip_line = video->luminance_line_size - (skipped_c << 4);
	for (; ii; ii--) {
	    unsigned iii;

	    for (iii = skipped_c; iii; iii--) {
		*prediction++ = *reference++;
		*prediction++ = *reference++;
# if SIZEOF_LONG != 8
		*prediction++ = *reference++;
		*prediction++ = *reference++;
# endif				/* SIZEOF_LONG != 8 */
	    }
	    prediction = (unsigned_q *)
		((unsigned char *) prediction + skip_line);
	    reference = (unsigned_q *)
		((unsigned char *) reference + skip_line);
	}
	offset >>= 2;
	{
	    unsigned i = 0;

	    skip_line = video->chrominance_line_size - (skipped_c << 3);
	    for (; i < 2; i++) {
		if (i) {
		    prediction =
			(unsigned_q *) (video->Mylene_release.Cb + offset);
		    reference =
			(unsigned_q *) (video->Irulan_release.Cb + offset);
		} else {
		    prediction =
			(unsigned_q *) (video->Mylene_release.Cr + offset);
		    reference =
			(unsigned_q *) (video->Irulan_release.Cr + offset);
		}
		for (ii = 8; ii; ii--) {
		    unsigned iii;

		    for (iii = skipped_c; iii; iii--) {
			*prediction++ = *reference++;
# if SIZEOF_LONG != 8
			*prediction++ = *reference++;
# endif				/* SIZEOF_LONG != 8 */
		    }
		    prediction = (unsigned_q *)
			((unsigned char *) prediction + skip_line);
		    reference = (unsigned_q *)
			((unsigned char *) reference + skip_line);
		}
	    }
	}
    }
#endif				/* !__RUN_FUTILE__ */
    previous_macroblock_address += skipped_c;
    macroblock->previous_macroblock_address = previous_macroblock_address - 1;
}


void
_seek_h262___________x18_macroblocks(struct seek_h262_video *video)
{
    struct seek_h262_11172_macroblock *macroblock;

    macroblock = video->macroblock;
    if ((macroblock->packed_flags
	 & (macroblock_motion_backward_mask | macroblock_motion_forward_mask))
	== macroblock_motion_backward_mask) {
	if (!(macroblock->recon_right_back | macroblock->recon_down_back)) {
	    macroblock = NULL;
	    video->frame_skipped_macroblocks_x10(video);
	}
    } else if ((macroblock->packed_flags
		& (macroblock_motion_backward_mask
		   | macroblock_motion_forward_mask))
	       == macroblock_motion_forward_mask) {
	if (!(macroblock->recon_right_for | macroblock->recon_down_for)) {
	    struct seek_h262_release swap;

	    macroblock = NULL;
	    swap = video->Irulan_release;
	    video->Irulan_release = video->Iran_release;
	    video->frame_skipped_macroblocks_x10(video);
	    video->Irulan_release = swap;
	}
    }
    if (macroblock) {
	unsigned i = 1, mb_width, select, skipped;

	macroblock->dc_sparse = 0;
	macroblock->pattern_code = 0;
	select = macroblock->packed_flags >> 5 & 3;
	skipped = macroblock->macroblock_address_increment;
	macroblock->macroblock_address -= skipped - 1;
	mb_width = video->mb_width;
	{
	    video->mb_offset += 16;
	    if (video->mb_offset == video->mb_advance) {
		video->mb_advance += mb_width << 8;
		video->mb_offset = video->mb_advance - (mb_width << 4);
		video->mb_chroma = video->mb_offset >> 2;
	    } else {
		video->mb_chroma += 8;
	    }
	}
	for (; i < skipped; i++) {
	    video->______macroblock[select] (video);
	    macroblock->macroblock_address++;
	    video->mb_offset += 16;
	    if (video->mb_offset == video->mb_advance) {
		video->mb_advance += mb_width << 8;
		video->mb_offset = video->mb_advance - (mb_width << 4);
		video->mb_chroma = video->mb_offset >> 2;
	    } else {
		video->mb_chroma += 8;
	    }
	}
    }
}
