/*
 * h262.e.c
 * Copyright (C) 2003, 2004, 2005, 2006, 2007, 2008  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <h262.0.h>
#include <h262.1.h>
#include <h262.2.h>
#include <h262.3.h>
#include <h262.4.h>
#include <h262.a.h>
#include <h262.e.h>

#define MOTION_ATTRIBUTES \
    struct seek_h262_video_motion_attributes
#define VIDEO_13818_ATTRIBUTES		struct seek_h262_13818_video_attributes
#define VIDEO_ATTRIBUTES		struct seek_h262_video_attributes

#define X08_				(intra_coded)
#define X08q				(intra_coded | 4)
#define X10_				(predictive_coded)
#define X10q				(predictive_coded | 4)
#define X18_				(bidirectionally_predictive_coded)
#define X18q				(bidirectionally_predictive_coded | 4)
#define X20_				(dc_intra_coded)

extern seek_h262_constructOr _seek_h262_block_1_0_0[],
    _seek_h262_block_1_1_0[], _seek_h262_block_1_2_0[],
    _seek_h262_block_1_3_0[], _seek_h262_block_1_6_0[];
#if __Berkeley_FUCK_UP__ == 1
extern seek_h262_constructOr _seek_h262_block_1_0_1[],
    _seek_h262_block_1_1_1[], _seek_h262_block_1_2_1[],
    _seek_h262_block_1_3_1[], _seek_h262_block_1_6_1[];
#endif				/* __Berkeley_FUCK_UP__ == 1 */
extern seek_h262_constructor _seek_h262_block_0_0_0[],
    _seek_h262_block_0_1_0[], _seek_h262_block_0_2_0[],
    _seek_h262_block_0_3_0[], _seek_h262_block_0_6_0[];
#if __Berkeley_FUCK_UP__ == 1
extern seek_h262_constructor _seek_h262_block_0_0_1[],
    _seek_h262_block_0_1_1[], _seek_h262_block_0_2_1[],
    _seek_h262_block_0_3_1[], _seek_h262_block_0_6_1[];
#endif				/* __Berkeley_FUCK_UP__ == 1 */
extern void
    (*_seek_h262_11172_GRAYSCALE_macroblock[]) (struct seek_h262_video *),
    (*_seek_h262_11172_YCbCr_____macroblock[]) (struct seek_h262_video *),
    (*_seek_h262_GRAYSCALE_macroblock[]) (struct seek_h262_video *),
    (*_seek_h262_GRAYSCALE_macroblocks[]) (struct seek_h262_video *),
    (*_seek_h262_YCbCr_420_macroblock[]) (struct seek_h262_video *),
    (*_seek_h262_YCbCr_422_macroblock[]) (struct seek_h262_video *),
    (*_seek_h262_YCbCr_444_macroblock[]) (struct seek_h262_video *),
    (*_seek_h262_YCbCr_4xx_macroblocks[]) (struct seek_h262_video *);

static const char *error_names[] = {
/* *INDENT-OFF* */
    /* no available description */
    "no available description",
    /* FAILED_START_CODE_LOOKUP */
    "failed start code lookup",
    /* x02: CHANGED_ASPECT_RATIO_INFORMATION */
    "changed aspect ratio information",
    /* x03: CHANGED_BIT_RATE_EXTENSION */
    "changed bit rate extension",
    /* x04: CHANGED_BIT_RATE_VALUE */
    "changed bit rate value",
    /* x05: CHANGED_CHROMA_FORMAT */
    "changed chroma format",
    /* x06: CHANGED_CONSTRAINED_PARAMETERS_FLAG */
    "changed constrained parameters flag",
    /* x07: CHANGED_FRAME_RATE_CODE */
    "changed frame rate code",
    /* x08: CHANGED_FRAME_RATE_EXTENSION_D */
    "changed frame rate extension d",
    /* x09: CHANGED_FRAME_RATE_EXTENSION_N */
    "changed frame rate extension n",
    /* x0a: CHANGED_HORIZONTAL_SIZE_EXTENSION */
    "changed horizontal size extension",
    /* x0b: CHANGED_HORIZONTAL_SIZE_VALUE */
    "changed horizontal size value",
    /* x0c: ? */
    "",
    /* x0d: CHANGED_LOW_DELAY */
    "changed low delay",
    /* x0e: CHANGED_PROFILE_AND_LEVEL_INDICATION */
    "changed profile and level indication",
    /* x0f: CHANGED_PROGRESSIVE_SEQUENCE */
    "changed progressive sequence",
    /* x10: CHANGED_SEQUENCE_DISPLAY_EXTENSION */
    "changed sequence display extension",
    /* x11: CHANGED_SEQUENCE_EXTENSION */
    "changed sequence extension",
    /* x12: CHANGED_SEQUENCE_HEADER */
    "changed sequence header",
    /* x13: CHANGED_SEQUENCE_SCALABLE_EXTENSION */
    "changed sequence scalable extension",
    /* x14: CHANGED_VBV_BUFFER_SIZE_EXTENSION */
    "changed vbv buffer size extension",
    /* x15: CHANGED_VBV_BUFFER_SIZE_VALUE */
    "changed vbv buffer size value",
    /* x16: CHANGED_VERTICAL_SIZE_EXTENSION */
    "changed vertical size extension",
    /* x17: CHANGED_VERTICAL_SIZE_VALUE */
    "changed vertical size value",
    /* x18: IMPROPER_INTRA_QUANTISER */
    "improper intra quantiser",
    /* x19: IMPROPER_START_CODE*/
    "improper start code",
    /* x1a: INVALID 11172 PICTURE HEADER INFORMATION */
    "invalid 11172 picture header information",
    /* x1b: INVALID_CHROMA_FORMAT */
    "invalid chroma format",
    /* x1c: INVALID_CHROMA_INTRA_QUANTISER */
    "invalid chroma intra quantiser",
    /* x1d: INVALID_CODE */
    "invalid DCT coefficient code",
    /* x1e: INVALID_ESCAPE_CODE */
    "invalid escape code",
    /* x1f: INVALID_EXTENSION_IDENTIFIER */
    "invalid extension start code identifier",
    /* x20: INVALID_FIELD_FRAME_PRED_FRAME_DCT */
    "invalid field picture frame_pred_frame_dct picture coding extension fie"
    "ld",
    /* x21: INVALID_FIELD_PICTURE_CODING_TYPE */
    "invalid second field picture coding type",
    /* x22: INVALID_FIELD_TEMPORAL_REFERENCE */
    "invalid field temporal_reference",
    /* x23: INVALID_F_CODES */
    "invalid f codes",
    /* x24: INVALID_F_CODE_0__0_ */
    "invalid (forward horizontal) f_code[0][0]",
    /* x25: INVALID_F_CODE_0__1_ */
    "invalid (forward vertical) f_code[0][1]",
    /* x26: INVALID_F_CODE_1__0_ */
    "invalid (backward horizontal) f_code[1][0]",
    /* x27: INVALID_F_CODE_1__1_ */
    "invalid (backward vertical) f_code[1][1]",
    /* x28: INVALID_INTRA_QUANTISER */
    "invalid intra quantiser",
    /* x29: INVALID_MACROBLOCK_ADDRESS_INCREMENT */
    "invalid macroblock address increment",
    /* x2a: INVALID_MACROBLOCK_TYPE */
    "invalid macroblock type",
    /* x2b: INVALID_MOTION_TYPE */
    "invalid (Dual Prime) motion type",
    /* x2c: INVALID_PICTURE_CODING_TYPE */
    "invalid picture coding type",
    /* x2d: INVALID_PICTURE_STRUCTURE */
    "invalid picture structure",
    /* x2e: INVALID_PROGRESSIVE_FRAME_PRED_FRAME_DCT */
    "invalid progressive frame frame_pred_frame_dct picture coding extension"
    " field",
    /* x2f: INVALID_PROGRESSIVE_SEQUENCE_PICTURE_STRUCTURE*/
    "invalid progressive sequence picture structure",
    /* x30: INVALID_REPEAT_FIRST_FIELD */
    "invalid repeat_first_field picture coding extension field",
    /* x31: INVALID_SEQUENCE_HEADER */
    "invalid sequence header",
    /* x32: INVALID_SLICE_START_CODE */
    "invalid slice start code",
    /* x33: INVALID_TIME_CODE */
    "invalid time code",
    /* x34: MISSING_SEQUENCE_DISPLAY_EXTENSION */
    "missing sequence display extension",
    /* x35: MISSING_SEQUENCE_SCALABLE_EXTENSION */
    "missing sequence scalable extension",
    /* x36: MISS_F_CODE_0__0_ */
    "improper (forward horizontal) f_code[0][0] (all bits set)",
    /* x37: MISS_F_CODE_0__1_ */
    "improper (forward vertical) f_code[0][1] (all bits set)",
    /* x38: MISS_F_CODE_1__0_ */
    "improper (backward horizontal) f_code[1][0] (all bits set)",
    /* x39: MISS_F_CODE_1__1_ */
    "improper (backward vertical) f_code[1][1] (all bits set)",
    /* x3a: NULL_CHROMA_INTRA_QUANTISER */
    "null chroma intra quantiser",
    /* x3b: NULL_CHROMA_NON_INTRA_QUANTISER */
    "null chroma non intra quantiser",
    /* x3c: NULL_F_CODE_0__0_ */
    "null (forward horizontal) f_code[0][0]",
    /* x3d: NULL_F_CODE_0__1_ */
    "null (forward vertical) f_code[0][1]",
    /* x3e: NULL_F_CODE_1__0_ */
    "null (backward horizontal) f_code[1][0]",
    /* x3f: NULL_F_CODE_1__1_ */
    "null (backward vertical) f_code[1][1]",
    /* x40: NULL_INTRA_QUANTISER */
    "null intra quantiser",
    /* x41: NULL_MACROBLOCK_QUANTISER_SCALE */
    "null macroblock quantiser scale",
    /* x42: NULL_NON_INTRA_QUANTISER */
    "null non intra quantiser",
    /* x43: NULL_SLICE_QUANTISER_SCALE */
    "null slice quantiser scale",
    /* x44: SLICE_FAULT */
    "slice fault",
    /* x45: UNEXPECTED_PICTURE_DISPLAY_EXTENSION */
    "unexpected picture display extension",
    /* x46: UNEXPECTED_SEQUENCE_END_CODE */
    "unexpected sequence end code",
    /* x47: UNSET_MARKER_BIT */
    "unset marker bit",
    /* x48: UNSET_MARKER_BITS */
    "unset marker bits"
/* *INDENT-ON* */
}, *reserved = "reserved", *table_6_6[] = {
/* *INDENT-OFF* */
    "component",
    "PAL",
    "NTSC",
    "SECAM",
    "MAC",
    "Unspecified video format",
    "reserved",
    "reserved"
/* *INDENT-ON* */
}, *table_6_7[] = {
/* *INDENT-OFF* */
    "(forbidden)",
    "ITU-R Recommendation 709 (1990)",
    "Unspecified Video",
    "reserved",
    "ITU-R Recommendation 624-4 System M",
    "ITU-R Recommendation 624-4 System B, G",
    "SMPTE 170M",
    "SMPTE 240M (1987)"
/* *INDENT-ON* */
}, *table_6_8[] = {
/* *INDENT-OFF* */
    "(forbidden)",
    "ITU-R Recommendation 709 (1990)",
    "Unspecified Video",
    "reserved",
    "ITU-R Recommendation 624-4 System M",
    "ITU-R Recommendation 624-4 System B, G",
    "SMPTE 170M",
    "SMPTE 240M (1987)",
    "Linear transfer characteristics"
/* *INDENT-ON* */
}, *table_6_9[] = {
/* *INDENT-OFF* */
    "(forbidden)",
    "ITU-R Recommendation 709 (1990)",
    "Unspecified Video",
    "reserved",
    "FCC",
    "ITU-R Recommendation 624-4 System B, G",
    "SMPTE 170M",
    "SMPTE 240M (1987)"
/* *INDENT-ON* */
}, *table_8_2[] = {
/* *INDENT-OFF* */
    "(reserved)",
    "High",
    "Spatially Scalable",
    "SNR Scalable",
    "Main",
    "Simple",
    "(reserved)",
    "(reserved)"
/* *INDENT-ON* */
}, *table_8_3[] = {
/* *INDENT-OFF* */
    "(reserved)",
    "(reserved)",
    "(reserved)",
    "(reserved)",
    "High",
    "(reserved)",
    "High 1440",
    "(reserved)",
    "Main",
    "(reserved)",
    "Low",
    "(reserved)",
    "(reserved)",
    "(reserved)",
    "(reserved)",
    "(reserved)"
/* *INDENT-ON* */
};
static const int x6_9[][9] = {
/* *INDENT-OFF* */
    /* 1: ITU-R Recommendation 709 (1990) */
    {	 7154,   721,  2125, -3860,  5000, -1150, -4540,  -460,  5000	},
    /* 4: FCC */
    {	 5900,  1100,  3000, -3310,  5000, -1690, -4210,  -790,  5000	},
    /* 5: ITU-R Recommendation 624-4 System B, G */
    /* 6: SMPTE 170M */
    {	 5870,  1140,  2990, -3310,  5000, -1690, -4190,  -810,  5000	},
    /* 7: SMPTE 240M (1987) */
    {	 7010,   870,  2120, -3840,  5000, -1160, -4450,  -550,  5000	}
/* *INDENT-ON* */
};
static const struct {
    unsigned denominator, numerator;
} pel_aspect_ratio[] = {
/* *INDENT-OFF* */
    {	0,	SEEK_H262_FORBIDDEN	},
    {	10000,	10000			},
    {	10000,	6735			},
    {	10000,	7031			},
    {	10000,	7615			},
    {	10000,	8055			},
    {	10000,	8437			},
    {	10000,	8935			},
    {	10000,	9375			},
    {	10000,	9815			},
    {	10000,	10255			},
    {	10000,	10695			},
    {	10000,	11250			},
    {	10000,	11575			},
    {	10000,	12015			},
    {	1,	SEEK_H262_RESERVED	}
/* *INDENT-ON* */
}, x6_4[] = {
/* *INDENT-OFF* */
    {	0,	SEEK_H262_FORBIDDEN	},
    {	1001,	24000			},
    {	1,	24			},
    {	1,	25			},
    {	1001,	30000			},
    {	1,	30			},
    {	1,	50			},
    {	1001,	60000			},
    {	1,	60			},
    {	1,	SEEK_H262_RESERVED	},
    {	1,	SEEK_H262_RESERVED	},
    {	1,	SEEK_H262_RESERVED	},
    {	1,	SEEK_H262_RESERVED	},
    {	1,	SEEK_H262_RESERVED	},
    {	1,	SEEK_H262_RESERVED	},
    {	1,	SEEK_H262_RESERVED	}
/* *INDENT-ON* */
};

void
seek_h262_aspect_ratio_information(unsigned code, unsigned *reply,
				   unsigned *numerator_return,
				   unsigned *denominator_return)
{
    switch (code) {
    case 0:
	*reply = SEEK_H262_FORBIDDEN;
	break;
    case 1:
	*reply = SEEK_H262_IS_SAR;
	*denominator_return = 1;
	*numerator_return = 1;
	break;
    case 2:
	*reply = SEEK_H262_IS_DAR;
	*denominator_return = 4;
	*numerator_return = 3;
	break;
    case 3:
	*reply = SEEK_H262_IS_DAR;
	*denominator_return = 16;
	*numerator_return = 9;
	break;
    case 4:
	*reply = SEEK_H262_IS_DAR;
	*denominator_return = 221;
	*numerator_return = 100;
	break;
    default:
	*reply = SEEK_H262_RESERVED;
    }
}


void
seek_h262_colour_primaries_reference(unsigned colour_primaries,
				     char **colour_primaries_reference)
{
    if (colour_primaries & ~7) {
	*colour_primaries_reference = (char *) reserved;
    } else {
	*colour_primaries_reference = (char *) table_6_7[colour_primaries];
    }
}


void
seek_h262_do_release(void *video_return)
{
    struct seek_h262_video *video;

    video = (struct seek_h262_video *) video_return;
    if (video->Irulan_release.flags) {
	video->do_release(video, &video->Irulan_release);
    }
}


void
seek_h262_frame_rate_code_to_frame_rate_value(unsigned code,
					      unsigned *numerator_return,
					      unsigned *denominator_return)
{
    *denominator_return = x6_4[code & 15].denominator;
    *numerator_return = x6_4[code & 15].numerator;
}


void
seek_h262_get_13818_video_attributes(void *video_return,
				     VIDEO_13818_ATTRIBUTES *video_attributes,
				     unsigned mask)
{
    struct seek_h262_video *video;

    video = (struct seek_h262_video *) video_return;
    if (((integral_q) video->slices[0] & 65535) == 13818) {
	if (mask & SEEK_H262_13818_VIDEO_FIELD_MACROBLOCK_MASK) {
	    video_attributes->field_macroblock[0] =
		(void (*)(void *)) video->field_macroblock[0];
	    video_attributes->field_macroblock[1] =
		(void (*)(void *)) video->field_macroblock[1];
	    video_attributes->field_macroblock[2] =
		(void (*)(void *)) video->field_macroblock[2];
	    video_attributes->field_macroblock[3] =
		(void (*)(void *)) video->field_macroblock[3];
	}
	if (mask & SEEK_H262_13818_VIDEO_FIELD_SKIPPED_MACROBLOCKS_X10_MASK) {
	    video_attributes->field_skipped_macroblocks_x10 =
		(void (*)(void *)) video->field_skipped_macroblocks_x10;
	}
	if (mask & SEEK_H262_13818_VIDEO_FIELD_SKIPPED_MACROBLOCKS_X18_MASK) {
	    video_attributes->field_skipped_macroblocks_x18 =
		(void (*)(void *)) video->field_skipped_macroblocks_x18;
	}
	if (mask & SEEK_H262_13818_VIDEO_FRAME_MACROBLOCK_MASK) {
	    video_attributes->frame_macroblock[0] =
		(void (*)(void *)) video->frame_macroblock[0];
	    video_attributes->frame_macroblock[1] =
		(void (*)(void *)) video->frame_macroblock[1];
	    video_attributes->frame_macroblock[2] =
		(void (*)(void *)) video->frame_macroblock[2];
	    video_attributes->frame_macroblock[3] =
		(void (*)(void *)) video->frame_macroblock[3];
	    video_attributes->frame_macroblock[4] =
		(void (*)(void *)) video->frame_macroblock[4];
	    video_attributes->frame_macroblock[5] =
		(void (*)(void *)) video->frame_macroblock[5];
	    video_attributes->frame_macroblock[6] =
		(void (*)(void *)) video->frame_macroblock[6];
	    video_attributes->frame_macroblock[7] =
		(void (*)(void *)) video->frame_macroblock[7];
	}
	if (mask & SEEK_H262_13818_VIDEO_FRAME_SKIPPED_MACROBLOCKS_X10_MASK) {
	    video_attributes->frame_skipped_macroblocks_x10 =
		(void (*)(void *)) video->frame_skipped_macroblocks_x10;
	}
	if (mask & SEEK_H262_13818_VIDEO_FRAME_SKIPPED_MACROBLOCKS_X18_MASK) {
	    video_attributes->frame_skipped_macroblocks_x18 =
		(void (*)(void *)) video->frame_skipped_macroblocks_x18;
	}
    }
}


void
seek_h262_get_colorspace(void *video_return, unsigned *color_space)
{
    struct seek_h262_video *video;

    video = (struct seek_h262_video *) video_return;
    if (((integral_q) video->slices[0] & 65535) == 11172) {
	if (video->slices[dc_intra_coded]
	    == _seek_h262_GRAYSCALE_x20_11172_slices) {
	    *color_space = SEEK_H262_GRAYSCALE;
	} else if (video->slices[dc_intra_coded]
		   == _seek_h262_SKIP______x_________slices) {
	    *color_space = SEEK_H262_SKIP;
	} else if (video->slices[dc_intra_coded]
		   == _seek_h262_YCbCr_____x20_11172_slices) {
	    *color_space = SEEK_H262_YCbCr;
	} else {
	    *color_space = SEEK_H262_none;
	}
    } else {
	if (video->slices[intra_coded]
	    == _seek_h262_GRAYSCALE_x___13818_slices) {
	    *color_space = SEEK_H262_GRAYSCALE;
	} else if (video->slices[intra_coded]
		   == _seek_h262_SKIP______x_________slices) {
	    *color_space = SEEK_H262_SKIP;
	} else if (video->slices[intra_coded]
		   == _seek_h262_YCbCr_____x___13818_slices) {
	    *color_space = SEEK_H262_YCbCr;
	} else {
	    *color_space = SEEK_H262_none;
	}
    }
}


void
seek_h262_get_macroblock(void *video, void ***macroblock)
{
    *macroblock = &((struct seek_h262_video *) video)->macroblock;
}


void
seek_h262_get_release(void *video, struct seek_h262_release **release)
{
    *release = &((struct seek_h262_video *) video)->Mylene_release;
}


void
seek_h262_get_video_attributes(void *video_return,
			       VIDEO_ATTRIBUTES *video_attributes,
			       unsigned mask, unsigned extra_mask)
{
    struct seek_h262_video *video;

    video = (struct seek_h262_video *) video_return;
    if (!mask) {
	goto extra_attributes;
    }
    if (mask & SEEK_H262_VIDEO_ABORT_DECODING_MASK) {
	video_attributes->abort_decoding =
	    (void (*)(void *)) video->abort_decoding;
    }
    if (mask & SEEK_H262_VIDEO_ALLOC_STORAGE_MASK) {
	video_attributes->alloc_storage =
	    (void (*)(void *, unsigned char **, unsigned, unsigned))
	    video->alloc_storage;
    }
    if (mask & SEEK_H262_VIDEO_BUFFER_MASK) {
	video_attributes->buffer = video->buffer;
    }
#if __Berkeley_FUCK_UP__
    if (mask & SEEK_H262_VIDEO_Berkeley_FUCK_UP_MASK) {
	video_attributes->Berkeley_fuck_up =
	    (integral_q) video->slices[0] & 2147483648u;
    }
#endif				/* __Berkeley_FUCK_UP__ */
    if (mask & SEEK_H262_VIDEO_COLOR_SPACE_MASK) {
	seek_h262_get_colorspace(video_return, &video_attributes->color_space);
    }
    if (mask & SEEK_H262_VIDEO_CORRECT_UNDERFLOW_MASK) {
	video_attributes->correct_underflow =
	    (void (*)(void *)) video->optimistique_moi;
    }
    if (mask & SEEK_H262_VIDEO_DO_RELEASE_MASK) {
	video_attributes->do_release =
	    (void (*)(void *, struct seek_h262_release *)) video->do_release;
    }
    if (mask & SEEK_H262_VIDEO_IDCT_ADD_BLOCK_MASK) {
	video_attributes->idct_add_block = video->idct_add_block;
    }
    if (mask & SEEK_H262_VIDEO_IDCT_SET_BLOCK_MASK) {
	video_attributes->idct_set_block = video->idct_set_block;
    }
    if (mask & SEEK_H262_VIDEO_MINIMUM_USEFUL_SIZE_MASK) {
	video_attributes->minimum_useful_size = video->minimum_useful_size;
    }
    if (mask & SEEK_H262_VIDEO_NEXT_START_CODE_MASK) {
	video_attributes->next_start_code =
	    (void (*)(void *)) video->next_start_code;
    }
    if (mask & SEEK_H262_VIDEO_NExT_START_CODE_MASK) {
	video_attributes->neXt_start_code =
	    (void (*)(void *)) video->neXt_start_code;
    }
    if (mask & SEEK_H262_VIDEO_SIZE_MASK) {
	video_attributes->size = video->size;
    }
  extra_attributes:
    if (!extra_mask) {
	return;
    }
#if __ENABLE_X00000100___HACK_0__
    if (extra_mask & SEEK_H262_VIDEO_X00000100___HACK_0_MASK) {
	video_attributes->x00000100___hack_0 =
	    (void (*)(void *)) video->x00000100___hack_0;
    }
#endif				/* __ENABLE_X00000100___HACK_0__ */
#if __ENABLE_X00000100___HACK_1__
    if (extra_mask & SEEK_H262_VIDEO_X00000100___HACK_1_MASK) {
	video_attributes->x00000100___hack_1 = video->x00000100___hack_1;
    }
#endif				/* __ENABLE_X00000100___HACK_1__ */
#if __ENABLE_X00000100___HACK_2__
    if (extra_mask & SEEK_H262_VIDEO_X00000100___HACK_2_MASK) {
	video_attributes->x00000100___hack_2 = video->x00000100___hack_2;
    }
#endif				/* __ENABLE_X00000100___HACK_2__ */
#if __ENABLE_X000001AF___HACK_0__
    if (extra_mask & SEEK_H262_VIDEO_X000001AF___HACK_0_MASK) {
	video_attributes->x000001af___hack_0 =
	    (void (*)(void *)) video->x000001af___hack_0;
    }
#endif				/* __ENABLE_X000001AF___HACK_0__ */
#if __ENABLE_X000001AF___HACK_3__
    if (extra_mask & SEEK_H262_VIDEO_X000001AF___HACK_3_MASK) {
	video_attributes->x000001af___hack_3 = video->x000001af___hack_3;
    }
#endif				/* __ENABLE_X000001AF___HACK_0__ */
#if __ENABLE_X000001AF___HACK_x__
    if (extra_mask & SEEK_H262_VIDEO_X000001AF___HACK_x_MASK) {
	video_attributes->x000001af___hack_X =
	    (void (*)(void *)) video->x000001af___hack_X;
    }
#endif				/* __ENABLE_X000001AF___HACK_x__ */
#if __ENABLE_X000001B2___HACK_0__
    if (extra_mask & SEEK_H262_VIDEO_X000001B2___HACK_0_MASK) {
	video_attributes->x000001b2___hack_0 =
	    (void (*)(void *)) video->x000001b2___hack_0;
    }
#endif				/* __ENABLE_X000001B2___HACK_0__ */
#if __ENABLE_X000001B3___HACK_0__
    if (extra_mask & SEEK_H262_VIDEO_X000001B3___HACK_0_MASK) {
	video_attributes->x000001b3___hack_0 =
	    (void (*)(void *)) video->x000001b3___hack_0;
    }
#endif				/* __ENABLE_X000001B3___HACK_0__ */
#if __ENABLE_X000001B3___HACK_1__
    if (extra_mask & SEEK_H262_VIDEO_X000001B3___HACK_1_MASK) {
	video_attributes->x000001b3___hack_1 = video->x000001b3___hack_1;
    }
#endif				/* __ENABLE_X000001B3___HACK_1__ */
#if __ENABLE_X000001B5___HACK_0__
    if (extra_mask & SEEK_H262_VIDEO_X000001B5___HACK_0_MASK) {
	video_attributes->x000001b5___hack_0 =
	    (void (*)(void *)) video->x000001b5___hack_0;
    }
#endif				/* __ENABLE_X000001B5___HACK_0__ */
#if __ENABLE_X000001B5_1_HACK_0__
    if (extra_mask & SEEK_H262_VIDEO_X000001B5_1_HACK_0_MASK) {
	video_attributes->x000001b5_1_hack_0 =
	    (void (*)(void *)) video->x000001b5_1_hack_0;
    }
#endif				/* __ENABLE_X000001B5_1_HACK_0__ */
#if __ENABLE_X000001B5_1_HACK_1__
    if (extra_mask & SEEK_H262_VIDEO_X000001B5_1_HACK_1_MASK) {
	video_attributes->x000001b5_1_hack_1 = video->x000001b5_1_hack_1;
    }
#endif				/* __ENABLE_X000001B5_1_HACK_1__ */
#if __ENABLE_X000001B5_1_HACK_2__
    if (extra_mask & SEEK_H262_VIDEO_X000001B5_1_HACK_2_MASK) {
	video_attributes->x000001b5_1_hack_2 = video->x000001b5_1_hack_2;
    }
#endif				/* __ENABLE_X000001B5_1_HACK_2__ */
#if __ENABLE_X000001B5_2_HACK_0__
    if (extra_mask & SEEK_H262_VIDEO_X000001B5_2_HACK_0_MASK) {
	video_attributes->x000001b5_2_hack_0 =
	    (void (*)(void *)) video->x000001b5_2_hack_0;
    }
#endif				/* __ENABLE_X000001B5_3_HACK_0__ */
#if __ENABLE_X000001B5_2_HACK_1__
    if (extra_mask & SEEK_H262_VIDEO_X000001B5_2_HACK_1_MASK) {
	video_attributes->x000001b5_2_hack_1 = video->x000001b5_2_hack_1;
    }
#endif				/* __ENABLE_X000001B5_2_HACK_1__ */
#if __ENABLE_X000001B5_3_HACK_0__
    if (extra_mask & SEEK_H262_VIDEO_X000001B5_3_HACK_0_MASK) {
	video_attributes->x000001b5_3_hack_0 =
	    (void (*)(void *)) video->x000001b5_3_hack_0;
    }
#endif				/* __ENABLE_X000001B5_3_HACK_0__ */
#if __ENABLE_X000001B5_3_HACK_1__
    if (extra_mask & SEEK_H262_VIDEO_X000001B5_3_HACK_1_MASK) {
	video_attributes->x000001b5_3_hack_1 = video->x000001b5_3_hack_1;
    }
#endif				/* __ENABLE_X000001B5_3_HACK_1__ */
#if __ENABLE_X000001B5_5_HACK_0__
    if (extra_mask & SEEK_H262_VIDEO_X000001B5_5_HACK_0_MASK) {
	video_attributes->x000001b5_5_hack_0 =
	    (void (*)(void *)) video->x000001b5_5_hack_0;
    }
#endif				/* __ENABLE_X000001B5_5_HACK_0__ */
#if __ENABLE_X000001B5_5_HACK_1__
    if (extra_mask & SEEK_H262_VIDEO_X000001B5_5_HACK_1_MASK) {
	video_attributes->x000001b5_5_hack_1 = video->x000001b5_5_hack_1;
    }
#endif				/* __ENABLE_X000001B5_5_HACK_1__ */
#if __ENABLE_X000001B5_7_HACK_0__
    if (extra_mask & SEEK_H262_VIDEO_X000001B5_7_HACK_0_MASK) {
	video_attributes->x000001b5_7_hack_0 =
	    (void (*)(void *)) video->x000001b5_7_hack_0;
    }
#endif				/* __ENABLE_X000001B5_7_HACK_0__ */
#if __ENABLE_X000001B5_7_HACK_1__
    if (extra_mask & SEEK_H262_VIDEO_X000001B5_7_HACK_1_MASK) {
	video_attributes->x000001b5_7_hack_1 = video->x000001b5_7_hack_1;
    }
#endif				/* __ENABLE_X000001B5_7_HACK_1__ */
#if __ENABLE_X000001B5_8_HACK_0__
    if (extra_mask & SEEK_H262_VIDEO_X000001B5_8_HACK_0_MASK) {
	video_attributes->x000001b5_8_hack_0 =
	    (void (*)(void *)) video->x000001b5_8_hack_0;
    }
#endif				/* __ENABLE_X000001B5_8_HACK_0__ */
#if __ENABLE_X000001B5_8_HACK_1__
    if (extra_mask & SEEK_H262_VIDEO_X000001B5_8_HACK_1_MASK) {
	video_attributes->x000001b5_8_hack_1 = video->x000001b5_8_hack_1;
    }
#endif				/* __ENABLE_X000001B5_8_HACK_1__ */
#if __ENABLE_X000001B5_9_HACK_0__
    if (extra_mask & SEEK_H262_VIDEO_X000001B5_9_HACK_0_MASK) {
	video_attributes->x000001b5_9_hack_0 =
	    (void (*)(void *)) video->x000001b5_9_hack_0;
    }
#endif				/* __ENABLE_X000001B5_9_HACK_0__ */
#if __ENABLE_X000001B5_9_HACK_1__
    if (extra_mask & SEEK_H262_VIDEO_X000001B5_9_HACK_1_MASK) {
	video_attributes->x000001b5_9_hack_1 = video->x000001b5_9_hack_1;
    }
#endif				/* __ENABLE_X000001B5_9_HACK_1__ */
#if __ENABLE_X000001B5_A_HACK_0__
    if (extra_mask & SEEK_H262_VIDEO_X000001B5_A_HACK_0_MASK) {
	video_attributes->x000001b5_a_hack_0 =
	    (void (*)(void *)) video->x000001b5_a_hack_0;
    }
#endif				/* __ENABLE_X000001B5_A_HACK_0__ */
#if __ENABLE_X000001B5_A_HACK_1__
    if (extra_mask & SEEK_H262_VIDEO_X000001B5_A_HACK_1_MASK) {
	video_attributes->x000001b5_a_hack_1 = video->x000001b5_a_hack_1;
    }
#endif				/* __ENABLE_X000001B5_A_HACK_1__ */
#if __ENABLE_X000001B8___HACK_0__
    if (extra_mask & SEEK_H262_VIDEO_X000001B8___HACK_0_MASK) {
	video_attributes->x000001b8___hack_0 =
	    (void (*)(void *)) video->x000001b8___hack_0;
    }
#endif				/* __ENABLE_X000001B8___HACK_0__ */
}


void
seek_h262_get_video_motion_attributes(void *video_return,
				      MOTION_ATTRIBUTES *motion_attributes,
				      unsigned mask)
{
    struct seek_h262_video *video;

    video = (struct seek_h262_video *) video_return;
#if !__Berkeley_FUCK_UP__
    if (mask & SEEK_H262_VIDEO_BLOCK_0_0___MASK) {
	motion_attributes->block_0_0__ = video->block_0_0;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_0_1___MASK) {
	motion_attributes->block_0_1__ = video->block_0_1;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_0_2___MASK) {
	motion_attributes->block_0_2__ = video->block_0_2;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_0_3___MASK) {
	motion_attributes->block_0_3__ = video->block_0_3;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_0_6___MASK) {
	motion_attributes->block_0_6__ = video->block_0_6;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_1_0___MASK) {
	motion_attributes->block_1_0__ = video->block_1_0;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_1_1___MASK) {
	motion_attributes->block_1_1__ = video->block_1_1;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_1_2___MASK) {
	motion_attributes->block_1_2__ = video->block_1_2;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_1_3___MASK) {
	motion_attributes->block_1_3__ = video->block_1_3;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_1_6___MASK) {
	motion_attributes->block_1_6__ = video->block_1_6;
    }
#else
    if (mask & SEEK_H262_VIDEO_BLOCK_0_0___MASK) {
	motion_attributes->block_0_0__ = video->block_0_0[1];
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_0_0_1_MASK) {
	motion_attributes->block_0_0_1 = video->block_0_0[2];
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_0_1___MASK) {
	motion_attributes->block_0_1__ = video->block_0_1[1];
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_0_1_1_MASK) {
	motion_attributes->block_0_1_1 = video->block_0_1[2];
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_0_2___MASK) {
	motion_attributes->block_0_2__ = video->block_0_2[1];
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_0_2_1_MASK) {
	motion_attributes->block_0_2_1 = video->block_0_2[2];
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_0_3___MASK) {
	motion_attributes->block_0_3__ = video->block_0_3[1];
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_0_3_1_MASK) {
	motion_attributes->block_0_3_1 = video->block_0_3[2];
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_0_6___MASK) {
	motion_attributes->block_0_6__ = video->block_0_6[1];
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_0_6_1_MASK) {
	motion_attributes->block_0_6_1 = video->block_0_6[2];
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_1_0___MASK) {
	motion_attributes->block_1_0__ = video->block_1_0[1];
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_1_0_1_MASK) {
	motion_attributes->block_1_0_1 = video->block_1_0[2];
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_1_1___MASK) {
	motion_attributes->block_1_1__ = video->block_1_1[1];
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_1_1_1_MASK) {
	motion_attributes->block_1_1_1 = video->block_1_1[2];
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_1_2___MASK) {
	motion_attributes->block_1_2__ = video->block_1_2[1];
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_1_2_1_MASK) {
	motion_attributes->block_1_2_1 = video->block_1_2[2];
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_1_3___MASK) {
	motion_attributes->block_1_3__ = video->block_1_3[1];
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_1_3_1_MASK) {
	motion_attributes->block_1_3_1 = video->block_1_3[2];
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_1_6___MASK) {
	motion_attributes->block_1_6__ = video->block_1_6[1];
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_1_6_1_MASK) {
	motion_attributes->block_1_6_1 = video->block_1_6[2];
    }
#endif				/* !__Berkeley_FUCK_UP__ */
}


void
seek_h262_matrix_coefficients(unsigned matrix_coefficients,
			      const int **matrix_coefficients_out)
{
    if (matrix_coefficients & ~7) {
	*matrix_coefficients_out = x6_9[0];
    } else {
	*matrix_coefficients_out =
	    x6_9[0x32210000 >> (matrix_coefficients << 2) & 7];
    }
}


void
seek_h262_matrix_coefficients_index(unsigned matrix_coefficients,
				    unsigned *matrix_coefficients_index)
{
    if (matrix_coefficients & ~7) {
	*matrix_coefficients_index = 0;
    } else {
	*matrix_coefficients_index =
	    0x32210000 >> (matrix_coefficients << 2) & 7;
    }
}


void
seek_h262_matrix_coefficients_reference(unsigned matrix_coefficients,
					char **matrix_coefficients_reference)
{
    if (matrix_coefficients & ~7) {
	*matrix_coefficients_reference = (char *) reserved;
    } else {
	*matrix_coefficients_reference =
	    (char *) table_6_9[matrix_coefficients];
    }
}


void
seek_h262_pel_aspect_ratio(unsigned code, unsigned *numerator_return,
			   unsigned *denominator_return)
{
    *denominator_return = pel_aspect_ratio[code & 15].denominator;
    *numerator_return = pel_aspect_ratio[code & 15].numerator;
}


void
seek_h262_profile_and_level_indication(unsigned profile_and_level_indication,
				       char **profile_identification,
				       char **level_identification)
{
    *level_identification =
	(char *) table_8_3[profile_and_level_indication & 15];
    *profile_identification =
	(char *) table_8_2[(profile_and_level_indication >> 4) & 7];
}


void
seek_h262_reset_release(void *video)
{
    ((struct seek_h262_video *) video)->Irulan_release.flags = 0;
}


void
seek_h262_reset_video(void *video_return)
{
    struct seek_h262_video *video;

    video = (struct seek_h262_video *) video_return;
#if __ENABLE_X000001AF___HACK_0__
# if WORDS_BIGENDIAN
    video->break_code = 0x000001af;
# else
    video->break_code = 0xaf010000;
# endif				/* WORDS_BIGENDIAN */
#endif				/* __ENABLE_X000001AF___HACK_0__ */
    video->buffer = NULL;
    video->chroma_format = H2V2;
    video->error = 0;
    video->inverse_scan_0 = NULL;
    video->inverse_scan_1 = NULL;
    video->minimum_useful_size = 64;
    video->neXt_start_code =
	(void (*)(struct seek_h262_video *)) seek_h262_neXt_start_code;
    video->next_start_code =
	(void (*)(struct seek_h262_video *)) seek_h262_next_start_code;
    video->size = 0;
    video->slices[0] = (void (*)(struct seek_h262_video *)) 13818;
    video->slices[1] = _seek_h262___________x___13818_slices;
    video->slices[2] = _seek_h262___________x___13818_slices;
    video->slices[3] = _seek_h262___________x___13818_slices;
    video->slices[4] = _seek_h262___________x___13818_slices;
#if __ENABLE_X00000100___HACK_0__
    video->x00000100___hack_0 = NULL;
#endif				/* __ENABLE_X00000100___HACK_0__ */
#if __ENABLE_X00000100___HACK_1__
    video->x00000100___hack_1 = NULL;
#endif				/* __ENABLE_X00000100___HACK_1__ */
#if __ENABLE_X00000100___HACK_2__
    video->x00000100___hack_2 = NULL;
#endif				/* __ENABLE_X00000100___HACK_2__ */
#if __ENABLE_X000001AF___HACK_0__
    video->x000001af___hack_0 = NULL;
#endif				/* __ENABLE_X000001AF___HACK_0__ */
#if __ENABLE_X000001AF___HACK_3__
    video->x000001af___hack_3 = NULL;
#endif				/* __ENABLE_X000001AF___HACK_3__ */
#if __ENABLE_X000001AF___HACK_x__
    video->x000001af___hack_X = NULL;
#endif				/* __ENABLE_X000001AF___HACK_x__ */
#if __ENABLE_X000001B2___HACK_0__
    video->x000001b2___hack_0 = NULL;
#endif				/* __ENABLE_X000001B2___HACK_0__ */
#if __ENABLE_X000001B3___HACK_0__
    video->x000001b3___hack_0 = NULL;
#endif				/* __ENABLE_X000001B3___HACK_0__ */
#if __ENABLE_X000001B3___HACK_1__
    video->x000001b3___hack_1 = NULL;
#endif				/* __ENABLE_X000001B3___HACK_1__ */
#if __ENABLE_X000001B5___HACK_0__
    video->x000001b5___hack_0 = NULL;
#endif				/* __ENABLE_X000001B5___HACK_0__ */
#if __ENABLE_X000001B5_1_HACK_0__
    video->x000001b5_1_hack_0 = NULL;
#endif				/* __ENABLE_X000001B5_1_HACK_0__ */
#if __ENABLE_X000001B5_1_HACK_1__
    video->x000001b5_1_hack_1 = NULL;
#endif				/* __ENABLE_X000001B5_1_HACK_1__ */
#if __ENABLE_X000001B5_1_HACK_2__
    video->x000001b5_1_hack_2 = NULL;
#endif				/* __ENABLE_X000001B5_1_HACK_2__ */
#if __ENABLE_X000001B5_2_HACK_0__
    video->x000001b5_2_hack_0 = NULL;
#endif				/* __ENABLE_X000001B5_2_HACK_0__ */
#if __ENABLE_X000001B5_2_HACK_1__
    video->x000001b5_2_hack_1 = NULL;
#endif				/* __ENABLE_X000001B5_2_HACK_1__ */
#if __ENABLE_X000001B5_3_HACK_0__
    video->x000001b5_3_hack_0 = NULL;
#endif				/* __ENABLE_X000001B5_3_HACK_0__ */
#if __ENABLE_X000001B5_3_HACK_1__
    video->x000001b5_3_hack_1 = NULL;
#endif				/* __ENABLE_X000001B5_3_HACK_1__ */
#if __ENABLE_X000001B5_5_HACK_0__
    video->x000001b5_5_hack_0 = NULL;
#endif				/* __ENABLE_X000001B5_5_HACK_0__ */
#if __ENABLE_X000001B5_5_HACK_1__
    video->x000001b5_5_hack_1 = NULL;
#endif				/* __ENABLE_X000001B5_5_HACK_1__ */
#if __ENABLE_X000001B5_7_HACK_0__
    video->x000001b5_7_hack_0 = NULL;
#endif				/* __ENABLE_X000001B5_7_HACK_0__ */
#if __ENABLE_X000001B5_7_HACK_1__
    video->x000001b5_7_hack_1 = NULL;
#endif				/* __ENABLE_X000001B5_7_HACK_1__ */
#if __ENABLE_X000001B5_8_HACK_0__
    video->x000001b5_8_hack_0 = NULL;
#endif				/* __ENABLE_X000001B5_8_HACK_0__ */
#if __ENABLE_X000001B5_8_HACK_1__
    video->x000001b5_8_hack_1 = NULL;
#endif				/* __ENABLE_X000001B5_8_HACK_1__ */
#if __ENABLE_X000001B5_9_HACK_0__
    video->x000001b5_9_hack_0 = NULL;
#endif				/* __ENABLE_X000001B5_9_HACK_0__ */
#if __ENABLE_X000001B5_9_HACK_1__
    video->x000001b5_9_hack_1 = NULL;
#endif				/* __ENABLE_X000001B5_9_HACK_1__ */
#if __ENABLE_X000001B5_A_HACK_0__
    video->x000001b5_a_hack_0 = NULL;
#endif				/* __ENABLE_X000001B5_A_HACK_0__ */
#if __ENABLE_X000001B5_A_HACK_1__
    video->x000001b5_a_hack_1 = NULL;
#endif				/* __ENABLE_X000001B5_A_HACK_1__ */
#if __ENABLE_X000001B8___HACK_0__
    video->x000001b8___hack_0 = NULL;
#endif				/* __ENABLE_X000001B8___HACK_0__ */

    _seek_h262_set_quantisers(video);

    seek_h262_reset_video_motion_attributes(video, ~0);
}


void
seek_h262_reset_video_attributes(void *video_return, unsigned mask,
				 unsigned extra_mask)
{
    struct seek_h262_video *video;

    video = (struct seek_h262_video *) video_return;
    if (!mask) {
	goto extra_attributes;
    }
    if (mask & SEEK_H262_VIDEO_BUFFER_MASK) {
	video->buffer = NULL;
    }
#if __Berkeley_FUCK_UP__
    if (mask & SEEK_H262_VIDEO_Berkeley_FUCK_UP_MASK) {
	video->slices[0] = (void (*)(struct seek_h262_video *))
	    ((integral_q) video->slices[0] & 2147483647);
	seek_h262_reset_video_motion_attributes
	    (video,
	     SEEK_H262_VIDEO_BLOCK_0_0_1_MASK
	     | SEEK_H262_VIDEO_BLOCK_0_1_1_MASK
	     | SEEK_H262_VIDEO_BLOCK_0_2_1_MASK
	     | SEEK_H262_VIDEO_BLOCK_0_3_1_MASK
	     | SEEK_H262_VIDEO_BLOCK_0_6_1_MASK
	     | SEEK_H262_VIDEO_BLOCK_1_0_1_MASK
	     | SEEK_H262_VIDEO_BLOCK_1_1_1_MASK
	     | SEEK_H262_VIDEO_BLOCK_1_2_1_MASK
	     | SEEK_H262_VIDEO_BLOCK_1_3_1_MASK
	     | SEEK_H262_VIDEO_BLOCK_1_6_1_MASK);
    }
#endif				/* __Berkeley_FUCK_UP__ */
    if (mask & SEEK_H262_VIDEO_COLOR_SPACE_MASK) {
	seek_h262_set_colorspace(video_return, SEEK_H262_none);
    }
    if (mask & SEEK_H262_VIDEO_NEXT_START_CODE_MASK) {
	video->next_start_code =
	    (void (*)(struct seek_h262_video *)) seek_h262_next_start_code;
    }
    if (mask & SEEK_H262_VIDEO_NExT_START_CODE_MASK) {
	video->neXt_start_code =
	    (void (*)(struct seek_h262_video *)) seek_h262_neXt_start_code;
    }
    if (mask & SEEK_H262_VIDEO_SIZE_MASK) {
	video->size = 0;
    }
  extra_attributes:
    if (!extra_mask) {
	return;
    }
#if __ENABLE_X00000100___HACK_0__
    if (extra_mask & SEEK_H262_VIDEO_X00000100___HACK_0_MASK) {
	video->x00000100___hack_0 = NULL;
    }
#endif				/* __ENABLE_X00000100___HACK_0__ */
#if __ENABLE_X00000100___HACK_1__
    if (extra_mask & SEEK_H262_VIDEO_X00000100___HACK_1_MASK) {
	video->x00000100___hack_1 = NULL;
    }
#endif				/* __ENABLE_X00000100___HACK_1__ */
#if __ENABLE_X00000100___HACK_2__
    if (extra_mask & SEEK_H262_VIDEO_X00000100___HACK_2_MASK) {
	video->x00000100___hack_2 = NULL;
    }
#endif				/* __ENABLE_X00000100___HACK_2__ */
#if __ENABLE_X000001AF___HACK_0__
    if (extra_mask & SEEK_H262_VIDEO_X000001AF___HACK_0_MASK) {
# if WORDS_BIGENDIAN
	video->break_code = 0x000001af;
# else
	video->break_code = 0xaf010000;
# endif				/* WORDS_BIGENDIAN */
	video->x000001af___hack_0 = NULL;
    }
#endif				/* __ENABLE_X000001AF___HACK_0__ */
#if __ENABLE_X000001AF___HACK_3__
    if (extra_mask & SEEK_H262_VIDEO_X000001AF___HACK_3_MASK) {
	video->x000001af___hack_3 = NULL;
    }
#endif				/* __ENABLE_X000001AF___HACK_3__ */
#if __ENABLE_X000001AF___HACK_x__
    if (extra_mask & SEEK_H262_VIDEO_X000001AF___HACK_x_MASK) {
	video->x000001af___hack_X = NULL;
    }
#endif				/* __ENABLE_X000001AF___HACK_x__ */
#if __ENABLE_X000001B2___HACK_0__
    if (extra_mask & SEEK_H262_VIDEO_X000001B2___HACK_0_MASK) {
	video->x000001b2___hack_0 = NULL;
    }
#endif				/* __ENABLE_X000001B2___HACK_0__ */
#if __ENABLE_X000001B3___HACK_0__
    if (extra_mask & SEEK_H262_VIDEO_X000001B3___HACK_0_MASK) {
	video->x000001b3___hack_0 = NULL;
    }
#endif				/* __ENABLE_X000001B3___HACK_0__ */
#if __ENABLE_X000001B3___HACK_1__
    if (extra_mask & SEEK_H262_VIDEO_X000001B3___HACK_1_MASK) {
	video->x000001b3___hack_1 = NULL;
    }
#endif				/* __ENABLE_X000001B3___HACK_1__ */
#if __ENABLE_X000001B5___HACK_0__
    if (extra_mask & SEEK_H262_VIDEO_X000001B5___HACK_0_MASK) {
	video->x000001b5___hack_0 = NULL;
    }
#endif				/* __ENABLE_X000001B5___HACK_0__ */
#if __ENABLE_X000001B5_1_HACK_0__
    if (extra_mask & SEEK_H262_VIDEO_X000001B5_1_HACK_0_MASK) {
	video->x000001b5_1_hack_0 = NULL;
    }
#endif				/* __ENABLE_X000001B5_1_HACK_0__ */
#if __ENABLE_X000001B5_1_HACK_1__
    if (extra_mask & SEEK_H262_VIDEO_X000001B5_1_HACK_1_MASK) {
	video->x000001b5_1_hack_1 = NULL;
    }
#endif				/* __ENABLE_X000001B5_1_HACK_1__ */
#if __ENABLE_X000001B5_1_HACK_2__
    if (extra_mask & SEEK_H262_VIDEO_X000001B5_1_HACK_2_MASK) {
	video->x000001b5_1_hack_2 = NULL;
    }
#endif				/* __ENABLE_X000001B5_1_HACK_2__ */
#if __ENABLE_X000001B5_2_HACK_0__
    if (extra_mask & SEEK_H262_VIDEO_X000001B5_2_HACK_0_MASK) {
	video->x000001b5_2_hack_0 = NULL;
    }
#endif				/* __ENABLE_X000001B5_2_HACK_0__ */
#if __ENABLE_X000001B5_2_HACK_1__
    if (extra_mask & SEEK_H262_VIDEO_X000001B5_2_HACK_1_MASK) {
	video->x000001b5_2_hack_1 = NULL;
    }
#endif				/* __ENABLE_X000001B5_2_HACK_1__ */
#if __ENABLE_X000001B5_3_HACK_0__
    if (extra_mask & SEEK_H262_VIDEO_X000001B5_3_HACK_0_MASK) {
	video->x000001b5_3_hack_0 = NULL;
    }
#endif				/* __ENABLE_X000001B5_3_HACK_0__ */
#if __ENABLE_X000001B5_3_HACK_1__
    if (extra_mask & SEEK_H262_VIDEO_X000001B5_3_HACK_1_MASK) {
	video->x000001b5_3_hack_1 = NULL;
    }
#endif				/* __ENABLE_X000001B5_3_HACK_1__ */
#if __ENABLE_X000001B5_5_HACK_0__
    if (extra_mask & SEEK_H262_VIDEO_X000001B5_5_HACK_0_MASK) {
	video->x000001b5_5_hack_0 = NULL;
    }
#endif				/* __ENABLE_X000001B5_5_HACK_0__ */
#if __ENABLE_X000001B5_5_HACK_1__
    if (extra_mask & SEEK_H262_VIDEO_X000001B5_5_HACK_1_MASK) {
	video->x000001b5_5_hack_1 = NULL;
    }
#endif				/* __ENABLE_X000001B5_5_HACK_1__ */
#if __ENABLE_X000001B5_7_HACK_0__
    if (extra_mask & SEEK_H262_VIDEO_X000001B5_7_HACK_0_MASK) {
	video->x000001b5_7_hack_0 = NULL;
    }
#endif				/* __ENABLE_X000001B5_7_HACK_0__ */
#if __ENABLE_X000001B5_7_HACK_1__
    if (extra_mask & SEEK_H262_VIDEO_X000001B5_7_HACK_1_MASK) {
	video->x000001b5_7_hack_1 = NULL;
    }
#endif				/* __ENABLE_X000001B5_7_HACK_1__ */
#if __ENABLE_X000001B5_8_HACK_0__
    if (extra_mask & SEEK_H262_VIDEO_X000001B5_8_HACK_0_MASK) {
	video->x000001b5_8_hack_0 = NULL;
    }
#endif				/* __ENABLE_X000001B5_8_HACK_0__ */
#if __ENABLE_X000001B5_8_HACK_1__
    if (extra_mask & SEEK_H262_VIDEO_X000001B5_8_HACK_1_MASK) {
	video->x000001b5_8_hack_1 = NULL;
    }
#endif				/* __ENABLE_X000001B5_8_HACK_1__ */
#if __ENABLE_X000001B5_9_HACK_0__
    if (extra_mask & SEEK_H262_VIDEO_X000001B5_9_HACK_0_MASK) {
	video->x000001b5_9_hack_0 = NULL;
    }
#endif				/* __ENABLE_X000001B5_9_HACK_0__ */
#if __ENABLE_X000001B5_9_HACK_1__
    if (extra_mask & SEEK_H262_VIDEO_X000001B5_9_HACK_1_MASK) {
	video->x000001b5_9_hack_1 = NULL;
    }
#endif				/* __ENABLE_X000001B5_9_HACK_1__ */
#if __ENABLE_X000001B5_A_HACK_0__
    if (extra_mask & SEEK_H262_VIDEO_X000001B5_A_HACK_0_MASK) {
	video->x000001b5_a_hack_0 = NULL;
    }
#endif				/* __ENABLE_X000001B5_A_HACK_0__ */
#if __ENABLE_X000001B5_A_HACK_1__
    if (extra_mask & SEEK_H262_VIDEO_X000001B5_A_HACK_1_MASK) {
	video->x000001b5_a_hack_1 = NULL;
    }
#endif				/* __ENABLE_X000001B5_A_HACK_1__ */
#if __ENABLE_X000001B8___HACK_0__
    if (extra_mask & SEEK_H262_VIDEO_X000001B8___HACK_0_MASK) {
	video->x000001b8___hack_0 = NULL;
    }
#endif				/* __ENABLE_X000001B8___HACK_0__ */
}


void
seek_h262_reset_video_motion_attributes(void *video_return, unsigned mask)
{
    struct seek_h262_video *video;

    video = (struct seek_h262_video *) video_return;
#if !__Berkeley_FUCK_UP__
    if (mask & SEEK_H262_VIDEO_BLOCK_0_0___MASK) {
	video->block_0_0 = _seek_h262_block_0_0_0;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_0_1___MASK) {
	video->block_0_1 = _seek_h262_block_0_1_0;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_0_2___MASK) {
	video->block_0_2 = _seek_h262_block_0_2_0;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_0_3___MASK) {
	video->block_0_3 = _seek_h262_block_0_3_0;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_0_6___MASK) {
	video->block_0_6 = _seek_h262_block_0_6_0;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_1_0___MASK) {
	video->block_1_0 = _seek_h262_block_1_0_0;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_1_1___MASK) {
	video->block_1_1 = _seek_h262_block_1_1_0;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_1_2___MASK) {
	video->block_1_2 = _seek_h262_block_1_2_0;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_1_3___MASK) {
	video->block_1_3 = _seek_h262_block_1_3_0;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_1_6___MASK) {
	video->block_1_6 = _seek_h262_block_1_6_0;
    }
#else
    if (mask & SEEK_H262_VIDEO_BLOCK_0_0___MASK) {
	video->block_0_0[1] = _seek_h262_block_0_0_0;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_0_0_1_MASK) {
	if ((integral_q) video->slices[0] & 2147483648u) {
	    video->block_0_0[2] = _seek_h262_block_0_0_1;
	} else {
	    video->block_0_0[2] = _seek_h262_block_0_0_0;
	}
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_0_1___MASK) {
	video->block_0_1[1] = _seek_h262_block_0_1_0;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_0_1_1_MASK) {
	if ((integral_q) video->slices[0] & 2147483648u) {
	    video->block_0_1[2] = _seek_h262_block_0_1_1;
	} else {
	    video->block_0_1[2] = _seek_h262_block_0_1_0;
	}
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_0_2___MASK) {
	video->block_0_2[1] = _seek_h262_block_0_2_0;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_0_2_1_MASK) {
	if ((integral_q) video->slices[0] & 2147483648u) {
	    video->block_0_2[2] = _seek_h262_block_0_2_1;
	} else {
	    video->block_0_2[2] = _seek_h262_block_0_2_0;
	}
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_0_3___MASK) {
	video->block_0_3[1] = _seek_h262_block_0_3_0;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_0_3_1_MASK) {
	if ((integral_q) video->slices[0] & 2147483648u) {
	    video->block_0_3[2] = _seek_h262_block_0_3_1;
	} else {
	    video->block_0_3[2] = _seek_h262_block_0_3_0;
	}
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_0_6___MASK) {
	video->block_0_6[1] = _seek_h262_block_0_6_0;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_0_6_1_MASK) {
	if ((integral_q) video->slices[0] & 2147483648u) {
	    video->block_0_6[2] = _seek_h262_block_0_6_1;
	} else {
	    video->block_0_6[2] = _seek_h262_block_0_6_0;
	}
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_1_0___MASK) {
	video->block_1_0[1] = _seek_h262_block_1_0_0;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_1_0_1_MASK) {
	if ((integral_q) video->slices[0] & 2147483648u) {
	    video->block_1_0[2] = _seek_h262_block_1_0_1;
	} else {
	    video->block_1_0[2] = _seek_h262_block_1_0_0;
	}
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_1_1___MASK) {
	video->block_1_1[1] = _seek_h262_block_1_1_0;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_1_1_1_MASK) {
	if ((integral_q) video->slices[0] & 2147483648u) {
	    video->block_1_1[2] = _seek_h262_block_1_1_1;
	} else {
	    video->block_1_1[2] = _seek_h262_block_1_1_0;
	}
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_1_2___MASK) {
	video->block_1_2[1] = _seek_h262_block_1_2_0;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_1_2_1_MASK) {
	if ((integral_q) video->slices[0] & 2147483648u) {
	    video->block_1_2[2] = _seek_h262_block_1_2_1;
	} else {
	    video->block_1_2[2] = _seek_h262_block_1_2_0;
	}
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_1_3___MASK) {
	video->block_1_3[1] = _seek_h262_block_1_3_0;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_1_3_1_MASK) {
	if ((integral_q) video->slices[0] & 2147483648u) {
	    video->block_1_3[2] = _seek_h262_block_1_3_1;
	} else {
	    video->block_1_3[2] = _seek_h262_block_1_3_0;
	}
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_1_6___MASK) {
	video->block_1_6[1] = _seek_h262_block_1_6_0;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_1_6_1_MASK) {
	if ((integral_q) video->slices[0] & 2147483648u) {
	    video->block_1_6[2] = _seek_h262_block_1_6_1;
	} else {
	    video->block_1_6[2] = _seek_h262_block_1_6_0;
	}
    }
#endif				/* !__Berkeley_FUCK_UP__ */
}


void
seek_h262_set_13818_video_attributes(void *video_return,
				     VIDEO_13818_ATTRIBUTES *video_attributes,
				     unsigned mask)
{
    struct seek_h262_video *video;

    video = (struct seek_h262_video *) video_return;
    if (((integral_q) video->slices[0] & 65535) == 13818) {
	if (mask & SEEK_H262_13818_VIDEO_FIELD_MACROBLOCK_MASK) {
	    video->field_macroblock[0] = (void (*)(struct seek_h262_video *))
		video_attributes->field_macroblock[0];
	    video->field_macroblock[1] = (void (*)(struct seek_h262_video *))
		video_attributes->field_macroblock[1];
	    video->field_macroblock[2] = (void (*)(struct seek_h262_video *))
		video_attributes->field_macroblock[2];
	    video->field_macroblock[3] = (void (*)(struct seek_h262_video *))
		video_attributes->field_macroblock[3];
	}
	if (mask & SEEK_H262_13818_VIDEO_FIELD_SKIPPED_MACROBLOCKS_X10_MASK) {
	    video->field_skipped_macroblocks_x10 =
		(void (*)(struct seek_h262_video *))
		video_attributes->field_skipped_macroblocks_x10;
	}
	if (mask & SEEK_H262_13818_VIDEO_FIELD_SKIPPED_MACROBLOCKS_X18_MASK) {
	    video->field_skipped_macroblocks_x18 =
		(void (*)(struct seek_h262_video *))
		video_attributes->field_skipped_macroblocks_x18;
	}
	if (mask & SEEK_H262_13818_VIDEO_FRAME_MACROBLOCK_MASK) {
	    video->frame_macroblock[0] = (void (*)(struct seek_h262_video *))
		video_attributes->frame_macroblock[0];
	    video->frame_macroblock[1] = (void (*)(struct seek_h262_video *))
		video_attributes->frame_macroblock[1];
	    video->frame_macroblock[2] = (void (*)(struct seek_h262_video *))
		video_attributes->frame_macroblock[2];
	    video->frame_macroblock[3] = (void (*)(struct seek_h262_video *))
		video_attributes->frame_macroblock[3];
	    video->frame_macroblock[4] = (void (*)(struct seek_h262_video *))
		video_attributes->frame_macroblock[4];
	    video->frame_macroblock[5] = (void (*)(struct seek_h262_video *))
		video_attributes->frame_macroblock[5];
	    video->frame_macroblock[6] = (void (*)(struct seek_h262_video *))
		video_attributes->frame_macroblock[6];
	    video->frame_macroblock[7] = (void (*)(struct seek_h262_video *))
		video_attributes->frame_macroblock[7];
	}
	if (mask & SEEK_H262_13818_VIDEO_FRAME_SKIPPED_MACROBLOCKS_X10_MASK) {
	    video->frame_skipped_macroblocks_x10 =
		(void (*)(struct seek_h262_video *))
		video_attributes->frame_skipped_macroblocks_x10;
	}
	if (mask & SEEK_H262_13818_VIDEO_FRAME_SKIPPED_MACROBLOCKS_X18_MASK) {
	    video->frame_skipped_macroblocks_x18 =
		(void (*)(struct seek_h262_video *))
		video_attributes->frame_skipped_macroblocks_x18;
	}
    }
}


void
seek_h262_set_colorspace(void *video_return, unsigned color_space)
{
    struct seek_h262_video *video;

    video = (struct seek_h262_video *) video_return;
    if (((integral_q) video->slices[0] & 65535) == 11172) {
	if (color_space == SEEK_H262_GRAYSCALE) {
	    video->______macroblock[0] =
		_seek_h262_11172_GRAYSCALE_macroblock[0];
	    video->______macroblock[1] =
		_seek_h262_11172_GRAYSCALE_macroblock[2];
	    video->______macroblock[2] =
		_seek_h262_11172_GRAYSCALE_macroblock[1];
	    video->______macroblock[3] =
		_seek_h262_11172_GRAYSCALE_macroblock[3];
	    video->______macroblock[4] =
		_seek_h262_11172_GRAYSCALE_macroblock[4];
	    video->______macroblock[7] =
		_seek_h262_11172_GRAYSCALE_macroblock[7];
	    video->frame_skipped_macroblocks_x10 =
		_seek_h262_GRAYSCALE_x10_macroblocks;
	    video->frame_skipped_macroblocks_x18 =
		_seek_h262___________x18_macroblocks;
	    video->slices[X08_] = _seek_h262_GRAYSCALE_x08_11172_slices;
	    video->slices[X08q] = _seek_h262_GRAYSCALE_x08_11172_slices;
	    video->slices[X10_] = _seek_h262_GRAYSCALE_x___11172_slices;
	    video->slices[X10q] = _seek_h262_GRAYSCALE_x___11172_slicEs;
	    video->slices[X18_] = _seek_h262_GRAYSCALE_x___11172_slices;
	    video->slices[X18q] = _seek_h262_GRAYSCALE_x___11172_slicEs;
	    video->slices[X20_] = _seek_h262_GRAYSCALE_x20_11172_slices;
	} else if (color_space == SEEK_H262_SKIP) {
	    video->slices[X08_] = _seek_h262_SKIP______x_________slices;
	    video->slices[X08q] = _seek_h262_SKIP______x_________slices;
	    video->slices[X10_] = _seek_h262_SKIP______x_________slices;
	    video->slices[X10q] = _seek_h262_SKIP______x_________slices;
	    video->slices[X18_] = _seek_h262_SKIP______x_________slices;
	    video->slices[X18q] = _seek_h262_SKIP______x_________slices;
	    video->slices[X20_] = _seek_h262_SKIP______x_________slices;
	} else if (color_space == SEEK_H262_YCbCr) {
	    video->______macroblock[0] =
		_seek_h262_11172_YCbCr_____macroblock[0];
	    video->______macroblock[1] =
		_seek_h262_11172_YCbCr_____macroblock[2];
	    video->______macroblock[2] =
		_seek_h262_11172_YCbCr_____macroblock[1];
	    video->______macroblock[3] =
		_seek_h262_11172_YCbCr_____macroblock[3];
	    video->______macroblock[4] =
		_seek_h262_11172_YCbCr_____macroblock[4];
	    video->______macroblock[7] =
		_seek_h262_11172_YCbCr_____macroblock[7];
	    video->frame_skipped_macroblocks_x10 =
		_seek_h262_YCbCr_____x10_macroblocks;
	    video->frame_skipped_macroblocks_x18 =
		_seek_h262___________x18_macroblocks;
	    video->slices[X08_] = _seek_h262_YCbCr_____x08_11172_slices;
	    video->slices[X08q] = _seek_h262_YCbCr_____x08_11172_slices;
	    video->slices[X10_] = _seek_h262_YCbCr_____x___11172_slices;
	    video->slices[X10q] = _seek_h262_YCbCr_____x___11172_slicEs;
	    video->slices[X18_] = _seek_h262_YCbCr_____x___11172_slices;
	    video->slices[X18q] = _seek_h262_YCbCr_____x___11172_slicEs;
	    video->slices[X20_] = _seek_h262_YCbCr_____x20_11172_slices;
	} else {
	    video->slices[X08_] = _seek_h262___________x08_11172_slices;
	    video->slices[X08q] = _seek_h262___________x08_11172_slices;
	    video->slices[X10_] = _seek_h262___________x___11172_slices;
	    video->slices[X10q] = _seek_h262___________x___11172_slices;
	    video->slices[X18_] = _seek_h262___________x___11172_slices;
	    video->slices[X18q] = _seek_h262___________x___11172_slices;
	    video->slices[X20_] = _seek_h262___________x20_11172_slices;
	}
    } else {
	if (color_space == SEEK_H262_GRAYSCALE) {
	    video->field_macroblock[0] = _seek_h262_GRAYSCALE_macroblock[0x8];
	    video->field_macroblock[1] = _seek_h262_GRAYSCALE_macroblock[0x9];
	    video->field_macroblock[2] = _seek_h262_GRAYSCALE_macroblock[0xa];
	    video->field_macroblock[3] = _seek_h262_GRAYSCALE_macroblock[0xb];
	    video->field_skipped_macroblocks_x10 =
		_seek_h262_GRAYSCALE_macroblocks[1];
	    video->field_skipped_macroblocks_x18 =
		_seek_h262___________macroblocks;
	    video->frame_macroblock[0] = _seek_h262_GRAYSCALE_macroblock[0x0];
	    video->frame_macroblock[1] = _seek_h262_GRAYSCALE_macroblock[0x1];
	    video->frame_macroblock[2] = _seek_h262_GRAYSCALE_macroblock[0x2];
	    video->frame_macroblock[3] = _seek_h262_GRAYSCALE_macroblock[0x3];
	    video->frame_macroblock[4] = _seek_h262_GRAYSCALE_macroblock[0x4];
	    video->frame_macroblock[5] = _seek_h262_GRAYSCALE_macroblock[0x5];
	    video->frame_macroblock[6] = _seek_h262_GRAYSCALE_macroblock[0x6];
	    video->frame_macroblock[7] = _seek_h262_GRAYSCALE_macroblock[0x7];
	    video->frame_skipped_macroblocks_x10 =
		_seek_h262_GRAYSCALE_macroblocks[0];
	    video->frame_skipped_macroblocks_x18 =
		_seek_h262___________macroblocks;
	    video->slices[X08_] = _seek_h262_GRAYSCALE_x___13818_slices;
	    video->slices[X10_] = _seek_h262_GRAYSCALE_x___13818_slices;
	    video->slices[X18_] = _seek_h262_GRAYSCALE_x___13818_slices;
	    video->slices[X20_] = _seek_h262_GRAYSCALE_x___13818_slices;
	} else if (color_space == SEEK_H262_SKIP) {
	    video->slices[X08_] = _seek_h262_SKIP______x_________slices;
	    video->slices[X10_] = _seek_h262_SKIP______x_________slices;
	    video->slices[X18_] = _seek_h262_SKIP______x_________slices;
	    video->slices[X20_] = _seek_h262_SKIP______x_________slices;
	} else if (color_space == SEEK_H262_YCbCr) {
	    void (**macroblock) (struct seek_h262_video *);

	    if (video->chroma_format == H1V1) {
		macroblock = _seek_h262_YCbCr_444_macroblock;
	    } else if (video->chroma_format == H2V1) {
		macroblock = _seek_h262_YCbCr_422_macroblock;
	    } else {
		macroblock = _seek_h262_YCbCr_420_macroblock;
	    }
	    video->field_macroblock[0] = macroblock[0x8];
	    video->field_macroblock[1] = macroblock[0x9];
	    video->field_macroblock[2] = macroblock[0xa];
	    video->field_macroblock[3] = macroblock[0xb];
	    if (video->chroma_format == H1V1) {
		video->field_skipped_macroblocks_x10 =
		    _seek_h262_YCbCr_4xx_macroblocks[5];
	    } else if (video->chroma_format == H2V1) {
		video->field_skipped_macroblocks_x10 =
		    _seek_h262_YCbCr_4xx_macroblocks[3];
	    } else {
		video->field_skipped_macroblocks_x10 =
		    _seek_h262_YCbCr_4xx_macroblocks[1];
	    }
	    video->field_skipped_macroblocks_x18 =
		_seek_h262___________macroblocks;
	    video->frame_macroblock[0] = macroblock[0x0];
	    video->frame_macroblock[1] = macroblock[0x1];
	    video->frame_macroblock[2] = macroblock[0x2];
	    video->frame_macroblock[3] = macroblock[0x3];
	    video->frame_macroblock[4] = macroblock[0x4];
	    video->frame_macroblock[5] = macroblock[0x5];
	    video->frame_macroblock[6] = macroblock[0x6];
	    video->frame_macroblock[7] = macroblock[0x7];
	    if (video->chroma_format == H1V1) {
		video->frame_skipped_macroblocks_x10 =
		    _seek_h262_YCbCr_4xx_macroblocks[4];
	    } else if (video->chroma_format == H2V1) {
		video->frame_skipped_macroblocks_x10 =
		    _seek_h262_YCbCr_4xx_macroblocks[2];
	    } else {
		video->frame_skipped_macroblocks_x10 =
		    _seek_h262_YCbCr_4xx_macroblocks[0];
	    }
	    video->frame_skipped_macroblocks_x18 =
		_seek_h262___________macroblocks;
	    video->slices[X08_] = _seek_h262_YCbCr_____x___13818_slices;
	    video->slices[X10_] = _seek_h262_YCbCr_____x___13818_slices;
	    video->slices[X18_] = _seek_h262_YCbCr_____x___13818_slices;
	    video->slices[X20_] = _seek_h262_YCbCr_____x___13818_slices;
	} else {
	    video->slices[X08_] = _seek_h262___________x___13818_slices;
	    video->slices[X10_] = _seek_h262___________x___13818_slices;
	    video->slices[X18_] = _seek_h262___________x___13818_slices;
	    video->slices[X20_] = _seek_h262___________x___13818_slices;
	}
    }
}


void
seek_h262_set_video_attributes(void *video_return,
			       VIDEO_ATTRIBUTES *video_attributes,
			       unsigned mask, unsigned extra_mask)
{
    struct seek_h262_video *video;

    video = (struct seek_h262_video *) video_return;
    if (!mask) {
	goto extra_attributes;
    }
    if (mask & SEEK_H262_VIDEO_ABORT_DECODING_MASK) {
	video->abort_decoding = (void (*)(struct seek_h262_video *))
	    video_attributes->abort_decoding;
    }
    if (mask & SEEK_H262_VIDEO_ALLOC_STORAGE_MASK) {
	video->alloc_storage =
	    (void (*)(struct seek_h262_video *, unsigned char **, unsigned,
		      unsigned)) video_attributes->alloc_storage;
    }
    if (mask & SEEK_H262_VIDEO_BUFFER_MASK) {
	video->buffer = video_attributes->buffer;
    }
#if __Berkeley_FUCK_UP__
    if (mask & SEEK_H262_VIDEO_Berkeley_FUCK_UP_MASK) {
	if (video_attributes->Berkeley_fuck_up) {
	    video->slices[0] = (void (*)(struct seek_h262_video *))
		(((integral_q) video->slices[0] & 2147483647) | 2147483648u);
	} else {
	    video->slices[0] = (void (*)(struct seek_h262_video *))
		((integral_q) video->slices[0] & 2147483647);
	}
	seek_h262_reset_video_motion_attributes
	    (video,
	     SEEK_H262_VIDEO_BLOCK_0_0_1_MASK
	     | SEEK_H262_VIDEO_BLOCK_0_1_1_MASK
	     | SEEK_H262_VIDEO_BLOCK_0_2_1_MASK
	     | SEEK_H262_VIDEO_BLOCK_0_3_1_MASK
	     | SEEK_H262_VIDEO_BLOCK_0_6_1_MASK
	     | SEEK_H262_VIDEO_BLOCK_1_0_1_MASK
	     | SEEK_H262_VIDEO_BLOCK_1_1_1_MASK
	     | SEEK_H262_VIDEO_BLOCK_1_2_1_MASK
	     | SEEK_H262_VIDEO_BLOCK_1_3_1_MASK
	     | SEEK_H262_VIDEO_BLOCK_1_6_1_MASK);
    }
#endif				/* __Berkeley_FUCK_UP__ */
    if (mask & SEEK_H262_VIDEO_COLOR_SPACE_MASK) {
	seek_h262_set_colorspace(video_return, video_attributes->color_space);
    }
    if (mask & SEEK_H262_VIDEO_CORRECT_UNDERFLOW_MASK) {
	video->optimistique_moi = (void (*)(struct seek_h262_video *))
	    video_attributes->correct_underflow;
    }
    if (mask & SEEK_H262_VIDEO_DO_RELEASE_MASK) {
	video->do_release =
	    (void (*)(struct seek_h262_video *, struct seek_h262_release *))
	    video_attributes->do_release;
    }
    if (mask & SEEK_H262_VIDEO_IDCT_ADD_BLOCK_MASK) {
	video->idct_add_block = video_attributes->idct_add_block;
    }
    if (mask & SEEK_H262_VIDEO_IDCT_SET_BLOCK_MASK) {
	video->idct_set_block = video_attributes->idct_set_block;
    }
    if (mask & SEEK_H262_VIDEO_NEXT_START_CODE_MASK) {
	video->next_start_code = (void (*)(struct seek_h262_video *))
	    video_attributes->next_start_code;
    }
    if (mask & SEEK_H262_VIDEO_NExT_START_CODE_MASK) {
	video->neXt_start_code = (void (*)(struct seek_h262_video *))
	    video_attributes->neXt_start_code;
    }
    if (mask & SEEK_H262_VIDEO_SIZE_MASK) {
	video->size = video_attributes->size;
    }
  extra_attributes:
    if (!extra_mask) {
	return;
    }
#if __ENABLE_X00000100___HACK_0__
    if (extra_mask & SEEK_H262_VIDEO_X00000100___HACK_0_MASK) {
	video->x00000100___hack_0 = (void (*)(struct seek_h262_video *))
	    video_attributes->x00000100___hack_0;
    }
#endif				/* __ENABLE_X00000100___HACK_0__ */
#if __ENABLE_X00000100___HACK_1__
    if (extra_mask & SEEK_H262_VIDEO_X00000100___HACK_1_MASK) {
	video->x00000100___hack_1 = video_attributes->x00000100___hack_1;
    }
#endif				/* __ENABLE_X00000100___HACK_1__ */
#if __ENABLE_X00000100___HACK_2__
    if (extra_mask & SEEK_H262_VIDEO_X00000100___HACK_2_MASK) {
	video->x00000100___hack_2 = video_attributes->x00000100___hack_2;
    }
#endif				/* __ENABLE_X00000100___HACK_2__ */
#if __ENABLE_X000001AF___HACK_0__
    if (extra_mask & SEEK_H262_VIDEO_X000001AF___HACK_0_MASK) {
	video->x000001af___hack_0 = (void (*)(struct seek_h262_video *))
	    video_attributes->x000001af___hack_0;
	if (video->x000001af___hack_0) {
# if WORDS_BIGENDIAN
	    video->break_code = 0x00000101;
# else
	    video->break_code = 0x01010000;
# endif				/* WORDS_BIGENDIAN */
	} else {
# if WORDS_BIGENDIAN
	    video->break_code = 0x000001af;
# else
	    video->break_code = 0xaf010000;
# endif				/* WORDS_BIGENDIAN */
	}
    }
#endif				/* __ENABLE_X000001AF___HACK_0__ */
#if __ENABLE_X000001AF___HACK_3__
    if (extra_mask & SEEK_H262_VIDEO_X000001AF___HACK_3_MASK) {
	video->x000001af___hack_3 = video_attributes->x000001af___hack_3;
    }
#endif				/* __ENABLE_X000001AF___HACK_3__ */
#if __ENABLE_X000001AF___HACK_x__
    if (extra_mask & SEEK_H262_VIDEO_X000001AF___HACK_x_MASK) {
	video->x000001af___hack_X = (void (*)(struct seek_h262_video *))
	    video_attributes->x000001af___hack_X;
    }
#endif				/* __ENABLE_X000001AF___HACK_x__ */
#if __ENABLE_X000001B2___HACK_0__
    if (extra_mask & SEEK_H262_VIDEO_X000001B2___HACK_0_MASK) {
	video->x000001b2___hack_0 = (void (*)(struct seek_h262_video *))
	    video_attributes->x000001b2___hack_0;
    }
#endif				/* __ENABLE_X000001B2___HACK_0__ */
#if __ENABLE_X000001B3___HACK_0__
    if (extra_mask & SEEK_H262_VIDEO_X000001B3___HACK_0_MASK) {
	video->x000001b3___hack_0 = (void (*)(struct seek_h262_video *))
	    video_attributes->x000001b3___hack_0;
    }
#endif				/* __ENABLE_X000001B3___HACK_0__ */
#if __ENABLE_X000001B3___HACK_1__
    if (extra_mask & SEEK_H262_VIDEO_X000001B3___HACK_1_MASK) {
	video->x000001b3___hack_1 = video_attributes->x000001b3___hack_1;
    }
#endif				/* __ENABLE_X000001B3___HACK_1__ */
#if __ENABLE_X000001B5___HACK_0__
    if (extra_mask & SEEK_H262_VIDEO_X000001B5___HACK_0_MASK) {
	video->x000001b5___hack_0 = (void (*)(struct seek_h262_video *))
	    video_attributes->x000001b5___hack_0;
    }
#endif				/* __ENABLE_X000001B5___HACK_0__ */
#if __ENABLE_X000001B5_1_HACK_0__
    if (extra_mask & SEEK_H262_VIDEO_X000001B5_1_HACK_0_MASK) {
	video->x000001b5_1_hack_0 = (void (*)(struct seek_h262_video *))
	    video_attributes->x000001b5_1_hack_0;
    }
#endif				/* __ENABLE_X000001B5_1_HACK_0__ */
#if __ENABLE_X000001B5_1_HACK_1__
    if (extra_mask & SEEK_H262_VIDEO_X000001B5_1_HACK_1_MASK) {
	video->x000001b5_1_hack_1 = video_attributes->x000001b5_1_hack_1;
    }
#endif				/* __ENABLE_X000001B5_1_HACK_1__ */
#if __ENABLE_X000001B5_1_HACK_2__
    if (extra_mask & SEEK_H262_VIDEO_X000001B5_1_HACK_2_MASK) {
	video->x000001b5_1_hack_2 = video_attributes->x000001b5_1_hack_2;
    }
#endif				/* __ENABLE_X000001B5_1_HACK_2__ */
#if __ENABLE_X000001B5_2_HACK_0__
    if (extra_mask & SEEK_H262_VIDEO_X000001B5_2_HACK_0_MASK) {
	video->x000001b5_2_hack_0 = (void (*)(struct seek_h262_video *))
	    video_attributes->x000001b5_2_hack_0;
    }
#endif				/* __ENABLE_X000001B5_2_HACK_0__ */
#if __ENABLE_X000001B5_2_HACK_1__
    if (extra_mask & SEEK_H262_VIDEO_X000001B5_2_HACK_1_MASK) {
	video->x000001b5_2_hack_1 = video_attributes->x000001b5_2_hack_1;
    }
#endif				/* __ENABLE_X000001B5_2_HACK_1__ */
#if __ENABLE_X000001B5_3_HACK_0__
    if (extra_mask & SEEK_H262_VIDEO_X000001B5_3_HACK_0_MASK) {
	video->x000001b5_3_hack_0 = (void (*)(struct seek_h262_video *))
	    video_attributes->x000001b5_3_hack_0;
    }
#endif				/* __ENABLE_X000001B5_3_HACK_0__ */
#if __ENABLE_X000001B5_3_HACK_1__
    if (extra_mask & SEEK_H262_VIDEO_X000001B5_3_HACK_1_MASK) {
	video->x000001b5_3_hack_1 = video_attributes->x000001b5_3_hack_1;
    }
#endif				/* __ENABLE_X000001B5_3_HACK_1__ */
#if __ENABLE_X000001B5_5_HACK_0__
    if (extra_mask & SEEK_H262_VIDEO_X000001B5_5_HACK_0_MASK) {
	video->x000001b5_5_hack_0 = (void (*)(struct seek_h262_video *))
	    video_attributes->x000001b5_5_hack_0;
    }
#endif				/* __ENABLE_X000001B5_5_HACK_0__ */
#if __ENABLE_X000001B5_5_HACK_1__
    if (extra_mask & SEEK_H262_VIDEO_X000001B5_5_HACK_1_MASK) {
	video->x000001b5_5_hack_1 = video_attributes->x000001b5_5_hack_1;
    }
#endif				/* __ENABLE_X000001B5_5_HACK_1__ */
#if __ENABLE_X000001B5_7_HACK_0__
    if (extra_mask & SEEK_H262_VIDEO_X000001B5_7_HACK_0_MASK) {
	video->x000001b5_7_hack_0 = (void (*)(struct seek_h262_video *))
	    video_attributes->x000001b5_7_hack_0;
    }
#endif				/* __ENABLE_X000001B5_7_HACK_0__ */
#if __ENABLE_X000001B5_7_HACK_1__
    if (extra_mask & SEEK_H262_VIDEO_X000001B5_7_HACK_1_MASK) {
	video->x000001b5_7_hack_1 = video_attributes->x000001b5_7_hack_1;
    }
#endif				/* __ENABLE_X000001B5_7_HACK_1__ */
#if __ENABLE_X000001B5_8_HACK_0__
    if (extra_mask & SEEK_H262_VIDEO_X000001B5_8_HACK_0_MASK) {
	video->x000001b5_8_hack_0 = (void (*)(struct seek_h262_video *))
	    video_attributes->x000001b5_8_hack_0;
    }
#endif				/* __ENABLE_X000001B5_8_HACK_0__ */
#if __ENABLE_X000001B5_8_HACK_1__
    if (extra_mask & SEEK_H262_VIDEO_X000001B5_8_HACK_1_MASK) {
	video->x000001b5_8_hack_1 = video_attributes->x000001b5_8_hack_1;
    }
#endif				/* __ENABLE_X000001B5_8_HACK_1__ */
#if __ENABLE_X000001B5_9_HACK_0__
    if (extra_mask & SEEK_H262_VIDEO_X000001B5_9_HACK_0_MASK) {
	video->x000001b5_9_hack_0 = (void (*)(struct seek_h262_video *))
	    video_attributes->x000001b5_9_hack_0;
    }
#endif				/* __ENABLE_X000001B5_9_HACK_0__ */
#if __ENABLE_X000001B5_9_HACK_1__
    if (extra_mask & SEEK_H262_VIDEO_X000001B5_9_HACK_1_MASK) {
	video->x000001b5_9_hack_1 = video_attributes->x000001b5_9_hack_1;
    }
#endif				/* __ENABLE_X000001B5_9_HACK_1__ */
#if __ENABLE_X000001B5_A_HACK_0__
    if (extra_mask & SEEK_H262_VIDEO_X000001B5_A_HACK_0_MASK) {
	video->x000001b5_a_hack_0 = (void (*)(struct seek_h262_video *))
	    video_attributes->x000001b5_a_hack_0;
    }
#endif				/* __ENABLE_X000001B5_A_HACK_0__ */
#if __ENABLE_X000001B5_A_HACK_1__
    if (extra_mask & SEEK_H262_VIDEO_X000001B5_A_HACK_1_MASK) {
	video->x000001b5_a_hack_1 = video_attributes->x000001b5_a_hack_1;
    }
#endif				/* __ENABLE_X000001B5_A_HACK_1__ */
#if __ENABLE_X000001B8___HACK_0__
    if (extra_mask & SEEK_H262_VIDEO_X000001B8___HACK_0_MASK) {
	video->x000001b8___hack_0 = (void (*)(struct seek_h262_video *))
	    video_attributes->x000001b8___hack_0;
    }
#endif				/* __ENABLE_X000001B8___HACK_0__ */
}


void
seek_h262_set_video_motion_attributes(void *video_return,
				      MOTION_ATTRIBUTES *motion_attributes,
				      unsigned mask)
{
    struct seek_h262_video *video;

    video = (struct seek_h262_video *) video_return;
#if !__Berkeley_FUCK_UP__
    if (mask & SEEK_H262_VIDEO_BLOCK_0_0___MASK) {
	video->block_0_0 = motion_attributes->block_0_0__;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_0_1___MASK) {
	video->block_0_1 = motion_attributes->block_0_1__;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_0_2___MASK) {
	video->block_0_2 = motion_attributes->block_0_2__;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_0_3___MASK) {
	video->block_0_3 = motion_attributes->block_0_3__;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_0_6___MASK) {
	video->block_0_6 = motion_attributes->block_0_6__;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_1_0___MASK) {
	video->block_1_0 = motion_attributes->block_1_0__;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_1_1___MASK) {
	video->block_1_1 = motion_attributes->block_1_1__;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_1_2___MASK) {
	video->block_1_2 = motion_attributes->block_1_2__;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_1_3___MASK) {
	video->block_1_3 = motion_attributes->block_1_3__;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_1_6___MASK) {
	video->block_1_6 = motion_attributes->block_1_6__;
    }
#else
    if (mask & SEEK_H262_VIDEO_BLOCK_0_0___MASK) {
	video->block_0_0[1] = motion_attributes->block_0_0__;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_0_0_1_MASK) {
	video->block_0_0[2] = motion_attributes->block_0_0_1;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_0_1___MASK) {
	video->block_0_1[1] = motion_attributes->block_0_1__;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_0_1_1_MASK) {
	video->block_0_1[2] = motion_attributes->block_0_1_1;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_0_2___MASK) {
	video->block_0_2[1] = motion_attributes->block_0_2__;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_0_2_1_MASK) {
	video->block_0_2[2] = motion_attributes->block_0_2_1;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_0_3___MASK) {
	video->block_0_3[1] = motion_attributes->block_0_3__;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_0_3_1_MASK) {
	video->block_0_3[2] = motion_attributes->block_0_3_1;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_0_6___MASK) {
	video->block_0_6[1] = motion_attributes->block_0_6__;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_0_6_1_MASK) {
	video->block_0_6[2] = motion_attributes->block_0_6_1;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_1_0___MASK) {
	video->block_1_0[1] = motion_attributes->block_1_0__;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_1_0_1_MASK) {
	video->block_1_0[2] = motion_attributes->block_1_0_1;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_1_1___MASK) {
	video->block_1_1[1] = motion_attributes->block_1_1__;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_1_1_1_MASK) {
	video->block_1_1[2] = motion_attributes->block_1_1_1;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_1_2___MASK) {
	video->block_1_2[1] = motion_attributes->block_1_2__;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_1_2_1_MASK) {
	video->block_1_2[2] = motion_attributes->block_1_2_1;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_1_3___MASK) {
	video->block_1_3[1] = motion_attributes->block_1_3__;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_1_3_1_MASK) {
	video->block_1_3[2] = motion_attributes->block_1_3_1;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_1_6___MASK) {
	video->block_1_6[1] = motion_attributes->block_1_6__;
    }
    if (mask & SEEK_H262_VIDEO_BLOCK_1_6_1_MASK) {
	video->block_1_6[2] = motion_attributes->block_1_6_1;
    }
#endif				/* !__Berkeley_FUCK_UP__ */
}


void
seek_h262_transfer_characteristics_reference
    (unsigned transfer_characteristics,
     char **transfer_characteristics_reference)
{
    if (8 < transfer_characteristics) {
	*transfer_characteristics_reference = (char *) reserved;
    } else {
	*transfer_characteristics_reference =
	    (char *) table_6_8[transfer_characteristics];
    }
}


void
seek_h262_video_error_string(unsigned error, char **error_name)
{
    if (error < VIDEO_NUMBER_OF_ERROR_CODES) {
	*error_name = (char *) error_names[error];
    } else {
	*error_name = NULL;
    }
}


void
seek_h262_video_format_description(unsigned video_format,
				   char **video_format_description)
{
    *video_format_description = (char *) table_6_6[video_format];
}


void
seek_h262_video_size(unsigned *size_return)
{
    *size_return = sizeof(struct seek_h262_video);
}
