/*
 * h262.e.h
 * Copyright (C) 2003, 2004, 2005  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __SEEK_H262_E_H__
#define __SEEK_H262_E_H__

#include <h262.0.h>
#include <h262.3.h>

/*
 * 11172 video attribute mask definitions
 */
#define SEEK_H262_11172_VIDEO_______MACROBLOCK_MASK \
					(1L << 0x00)
#define SEEK_H262_11172_VIDEO_______SKIPPED_MACROBLOCKS_X10_MASK \
					(1L << 0x01)
#define SEEK_H262_11172_VIDEO_______SKIPPED_MACROBLOCKS_X18_MASK \
					(1L << 0x02)

/*
 * 13818 video attribute mask definitions
 */
#define SEEK_H262_13818_VIDEO_FIELD_MACROBLOCK_MASK \
					(1L << 0x00)
#define SEEK_H262_13818_VIDEO_FIELD_SKIPPED_MACROBLOCKS_X10_MASK \
					(1L << 0x01)
#define SEEK_H262_13818_VIDEO_FIELD_SKIPPED_MACROBLOCKS_X18_MASK \
					(1L << 0x02)
#define SEEK_H262_13818_VIDEO_FRAME_MACROBLOCK_MASK \
					(1L << 0x03)
#define SEEK_H262_13818_VIDEO_FRAME_SKIPPED_MACROBLOCKS_X10_MASK \
					(1L << 0x04)
#define SEEK_H262_13818_VIDEO_FRAME_SKIPPED_MACROBLOCKS_X18_MASK \
					(1L << 0x05)

/*
 * aspect ratio information definitions
 */
#define SEEK_H262_IS_DAR		1
#define SEEK_H262_IS_SAR		2

/*
 * color space definitions
 */
#define SEEK_H262_GRAYSCALE		0
#define SEEK_H262_YCbCr			1
#define SEEK_H262_none			2
#define SEEK_H262_SKIP			3

/*
 * berkeley video motion attribute mask definitions
 */
#if __Berkeley_FUCK_UP__
# define SEEK_H262_VIDEO_BLOCK_0_0_1_MASK \
					(1L << 0x00)
# define SEEK_H262_VIDEO_BLOCK_0_1_1_MASK \
					(1L << 0x02)
# define SEEK_H262_VIDEO_BLOCK_0_2_1_MASK \
					(1L << 0x04)
# define SEEK_H262_VIDEO_BLOCK_0_3_1_MASK \
					(1L << 0x06)
# define SEEK_H262_VIDEO_BLOCK_0_6_1_MASK \
					(1L << 0x08)
# define SEEK_H262_VIDEO_BLOCK_1_0_1_MASK \
					(1L << 0x0a)
# define SEEK_H262_VIDEO_BLOCK_1_1_1_MASK \
					(1L << 0x0c)
# define SEEK_H262_VIDEO_BLOCK_1_2_1_MASK \
					(1L << 0x0e)
# define SEEK_H262_VIDEO_BLOCK_1_3_1_MASK \
					(1L << 0x10)
# define SEEK_H262_VIDEO_BLOCK_1_6_1_MASK \
					(1L << 0x12)
#endif				/* __Berkeley_FUCK_UP__ */

/*
 * extra video attribute mask definitions
 */
#if __ENABLE_X00000100___HACK_0__
# define SEEK_H262_VIDEO_X00000100___HACK_0_MASK \
					(1L << 0x00)
#endif				/* __ENABLE_X00000100___HACK_0__ */
#if __ENABLE_X00000100___HACK_1__
# define SEEK_H262_VIDEO_X00000100___HACK_1_MASK \
					(1L << 0x01)
#endif				/* __ENABLE_X00000100___HACK_1__ */
#if __ENABLE_X00000100___HACK_2__
# define SEEK_H262_VIDEO_X00000100___HACK_2_MASK \
					(1L << 0x02)
#endif				/* __ENABLE_X00000100___HACK_2__ */
#if __ENABLE_X000001AF___HACK_0__
# define SEEK_H262_VIDEO_X000001AF___HACK_0_MASK \
					(1L << 0x03)
#endif				/* __ENABLE_X000001AF___HACK_0__ */
#if __ENABLE_X000001AF___HACK_3__
# define SEEK_H262_VIDEO_X000001AF___HACK_3_MASK \
					(1L << 0x04)
#endif				/* __ENABLE_X000001AF___HACK_3__ */
#if __ENABLE_X000001AF___HACK_x__
# define SEEK_H262_VIDEO_X000001AF___HACK_x_MASK \
					(1L << 0x05)
#endif				/* __ENABLE_X000001AF___HACK_x__ */
#if __ENABLE_X000001B2___HACK_0__
# define SEEK_H262_VIDEO_X000001B2___HACK_0_MASK \
					(1L << 0x06)
#endif				/* __ENABLE_X000001B2___HACK_0__ */
#if __ENABLE_X000001B3___HACK_0__
# define SEEK_H262_VIDEO_X000001B3___HACK_0_MASK \
					(1L << 0x07)
#endif				/* __ENABLE_X000001B3___HACK_0__ */
#if __ENABLE_X000001B3___HACK_1__
# define SEEK_H262_VIDEO_X000001B3___HACK_1_MASK \
					(1L << 0x08)
#endif				/* __ENABLE_X000001B3___HACK_1__ */
#if __ENABLE_X000001B5___HACK_0__
# define SEEK_H262_VIDEO_X000001B5___HACK_0_MASK \
					(1L << 0x09)
#endif				/* __ENABLE_X000001B5___HACK_0__ */
#if __ENABLE_X000001B5_1_HACK_0__
# define SEEK_H262_VIDEO_X000001B5_1_HACK_0_MASK \
					(1L << 0x0a)
#endif				/* __ENABLE_X000001B5_1_HACK_0__ */
#if __ENABLE_X000001B5_1_HACK_1__
# define SEEK_H262_VIDEO_X000001B5_1_HACK_1_MASK \
					(1L << 0x0b)
#endif				/* __ENABLE_X000001B5_1_HACK_1__ */
#if __ENABLE_X000001B5_1_HACK_2__
# define SEEK_H262_VIDEO_X000001B5_1_HACK_2_MASK \
					(1L << 0x0c)
#endif				/* __ENABLE_X000001B5_1_HACK_2__ */
#if __ENABLE_X000001B5_2_HACK_0__
# define SEEK_H262_VIDEO_X000001B5_2_HACK_0_MASK \
					(1L << 0x0d)
#endif				/* __ENABLE_X000001B5_2_HACK_0__ */
#if __ENABLE_X000001B5_2_HACK_1__
# define SEEK_H262_VIDEO_X000001B5_2_HACK_1_MASK \
					(1L << 0x0e)
#endif				/* __ENABLE_X000001B5_2_HACK_1__ */
#if __ENABLE_X000001B5_3_HACK_0__
# define SEEK_H262_VIDEO_X000001B5_3_HACK_0_MASK \
					(1L << 0x0f)
#endif				/* __ENABLE_X000001B5_3_HACK_0__ */
#if __ENABLE_X000001B5_3_HACK_1__
# define SEEK_H262_VIDEO_X000001B5_3_HACK_1_MASK \
					(1L << 0x10)
#endif				/* __ENABLE_X000001B5_3_HACK_1__ */
#if __ENABLE_X000001B5_5_HACK_0__
# define SEEK_H262_VIDEO_X000001B5_5_HACK_0_MASK \
					(1L << 0x11)
#endif				/* __ENABLE_X000001B5_5_HACK_0__ */
#if __ENABLE_X000001B5_5_HACK_1__
# define SEEK_H262_VIDEO_X000001B5_5_HACK_1_MASK \
					(1L << 0x12)
#endif				/* __ENABLE_X000001B5_5_HACK_1__ */
#if __ENABLE_X000001B5_7_HACK_0__
# define SEEK_H262_VIDEO_X000001B5_7_HACK_0_MASK \
					(1L << 0x13)
#endif				/* __ENABLE_X000001B5_7_HACK_0__ */
#if __ENABLE_X000001B5_7_HACK_1__
# define SEEK_H262_VIDEO_X000001B5_7_HACK_1_MASK \
					(1L << 0x14)
#endif				/* __ENABLE_X000001B5_7_HACK_1__ */
#if __ENABLE_X000001B5_8_HACK_0__
# define SEEK_H262_VIDEO_X000001B5_8_HACK_0_MASK \
					(1L << 0x15)
#endif				/* __ENABLE_X000001B5_8_HACK_0__ */
#if __ENABLE_X000001B5_8_HACK_1__
# define SEEK_H262_VIDEO_X000001B5_8_HACK_1_MASK \
					(1L << 0x16)
#endif				/* __ENABLE_X000001B5_8_HACK_1__ */
#if __ENABLE_X000001B5_9_HACK_0__
# define SEEK_H262_VIDEO_X000001B5_9_HACK_0_MASK \
					(1L << 0x17)
#endif				/* __ENABLE_X000001B5_9_HACK_0__ */
#if __ENABLE_X000001B5_9_HACK_1__
# define SEEK_H262_VIDEO_X000001B5_9_HACK_1_MASK \
					(1L << 0x18)
#endif				/* __ENABLE_X000001B5_9_HACK_1__ */
#if __ENABLE_X000001B5_A_HACK_0__
# define SEEK_H262_VIDEO_X000001B5_A_HACK_0_MASK \
					(1L << 0x19)
#endif				/* __ENABLE_X000001B5_A_HACK_0__ */
#if __ENABLE_X000001B5_A_HACK_1__
# define SEEK_H262_VIDEO_X000001B5_A_HACK_1_MASK \
					(1L << 0x1a)
#endif				/* __ENABLE_X000001B5_A_HACK_1__ */
#if __ENABLE_X000001B8___HACK_0__
# define SEEK_H262_VIDEO_X000001B8___HACK_0_MASK \
					(1L << 0x1b)
#endif				/* __ENABLE_X000001B8___HACK_0__ */

/*
 * frame_rate_code definitions
 */
#define SEEK_H262_FORBIDDEN		0
#define SEEK_H262_RESERVED		((unsigned) ~0)

/*
 * skip frames definitions
 */
#define SEEK_H262_SAVE_PAST		(1L << 0x00)
#define SEEK_H262_SKIP_bidirectionally_predictive_coded \
					(1L << 0x01)

/*
 * video attribute mask definitions
 */
#define SEEK_H262_VIDEO_ABORT_DECODING_MASK \
					(1L << 0x00)
#define SEEK_H262_VIDEO_ALLOC_STORAGE_MASK \
					(1L << 0x01)
#define SEEK_H262_VIDEO_BUFFER_MASK	(1L << 0x02)
#if __Berkeley_FUCK_UP__ == 1
# define SEEK_H262_VIDEO_Berkeley_FUCK_UP_MASK \
					(1L << 0x03)
#endif				/* __Berkeley_FUCK_UP__ == 1 */
#define SEEK_H262_VIDEO_COLOR_SPACE_MASK \
					(1L << 0x04)
#define SEEK_H262_VIDEO_CORRECT_UNDERFLOW_MASK \
					(1L << 0x05)
#define SEEK_H262_VIDEO_DO_RELEASE_MASK (1L << 0x06)
#define SEEK_H262_VIDEO_IDCT_ADD_BLOCK_MASK \
					(1L << 0x07)
#define SEEK_H262_VIDEO_IDCT_SET_BLOCK_MASK \
					(1L << 0x08)
#define SEEK_H262_VIDEO_MINIMUM_USEFUL_SIZE_MASK \
					(1L << 0x09)
#define SEEK_H262_VIDEO_NEXT_START_CODE_MASK \
					(1L << 0x0a)
#define SEEK_H262_VIDEO_NExT_START_CODE_MASK \
					(1L << 0x0b)
#define SEEK_H262_VIDEO_SIZE_MASK	(1L << 0x0c)

/*
 * video motion attribute mask definitions
 */
#define SEEK_H262_VIDEO_BLOCK_0_0___MASK \
					(1L << 0x01)
#define SEEK_H262_VIDEO_BLOCK_0_1___MASK \
					(1L << 0x03)
#define SEEK_H262_VIDEO_BLOCK_0_2___MASK \
					(1L << 0x05)
#define SEEK_H262_VIDEO_BLOCK_0_3___MASK \
					(1L << 0x07)
#define SEEK_H262_VIDEO_BLOCK_0_6___MASK \
					(1L << 0x09)
#define SEEK_H262_VIDEO_BLOCK_1_0___MASK \
					(1L << 0x0b)
#define SEEK_H262_VIDEO_BLOCK_1_1___MASK \
					(1L << 0x0d)
#define SEEK_H262_VIDEO_BLOCK_1_2___MASK \
					(1L << 0x0f)
#define SEEK_H262_VIDEO_BLOCK_1_3___MASK \
					(1L << 0x11)
#define SEEK_H262_VIDEO_BLOCK_1_6___MASK \
					(1L << 0x13)

typedef struct seek_h262_11172_video_attributes {
    void (*______macroblock[8]) (void *),
	(*______skipped_macroblocks_x10) (void *),
	(*______skipped_macroblocks_x18) (void *);
} seek_h262_11172_video_attributes;

typedef struct seek_h262_13818_video_attributes {
    void (*field_macroblock[4]) (void *),
	(*field_skipped_macroblocks_x10) (void *),
	(*field_skipped_macroblocks_x18) (void *),
	(*frame_macroblock[8]) (void *),
	(*frame_skipped_macroblocks_x10) (void *),
	(*frame_skipped_macroblocks_x18) (void *);
} seek_h262_13818_video_attributes;

typedef struct seek_h262_time_code_semantics_ {
    unsigned drop_frame_flag, time_code_hours, time_code_minutes,
	time_code_pictures, time_code_seconds;
} seek_h262_time_code_semantics_;

typedef struct seek_h262_video_attributes {
#if __Berkeley_FUCK_UP__ == 1
    int Berkeley_fuck_up;
#endif				/* __Berkeley_FUCK_UP__ == 1 */
    unsigned color_space, minimum_useful_size, size;
    unsigned char *buffer;
    void (*abort_decoding) (void *),
	(*alloc_storage) (void *, unsigned char **, unsigned, unsigned),
	(*correct_underflow) (void *),
	(*do_release) (void *, struct seek_h262_release *),
	(*idct_add_block) (struct seek_h262_block *, unsigned, unsigned,
			   unsigned),
	(*idct_set_block) (struct seek_h262_block *, unsigned, unsigned,
			   unsigned),
	(*neXt_start_code) (void *), (*next_start_code) (void *);
#if __ENABLE_X00000100___HACK_0__
    void (*x00000100___hack_0) (void *);
#endif				/* __ENABLE_X00000100___HACK_0__ */
#if __ENABLE_X00000100___HACK_1__
    void (*x00000100___hack_1) (struct seek_h262_x00000100__ *);
#endif				/* __ENABLE_X00000100___HACK_1__ */
#if __ENABLE_X00000100___HACK_2__
    void (*x00000100___hack_2) (struct seek_h262_x00000100__ *);
#endif				/* __ENABLE_X00000100___HACK_2__ */
#if __ENABLE_X000001AF___HACK_0__
    void (*x000001af___hack_0) (void *);
#endif				/* __ENABLE_X000001AF___HACK_0__ */
#if __ENABLE_X000001AF___HACK_3__
    void (*x000001af___hack_3) (struct seek_h262_x000001af__ *);
#endif				/* __ENABLE_X000001AF___HACK_3__ */
#if __ENABLE_X000001AF___HACK_x__
    void (*x000001af___hack_X) (void *);
#endif				/* __ENABLE_X000001AF___HACK_x__ */
#if __ENABLE_X000001B2___HACK_0__
    void (*x000001b2___hack_0) (void *);
#endif				/* __ENABLE_X000001B2___HACK_0__ */
#if __ENABLE_X000001B3___HACK_0__
    void (*x000001b3___hack_0) (void *);
#endif				/* __ENABLE_X000001B3___HACK_0__ */
#if __ENABLE_X000001B3___HACK_1__
    void (*x000001b3___hack_1) (struct seek_h262_x000001b3__ *);
#endif				/* __ENABLE_X000001B3___HACK_1__ */
#if __ENABLE_X000001B5___HACK_0__
    void (*x000001b5___hack_0) (void *);
#endif				/* __ENABLE_X000001B5___HACK_0__ */
#if __ENABLE_X000001B5_1_HACK_0__
    void (*x000001b5_1_hack_0) (void *);
#endif				/* __ENABLE_X000001B5_1_HACK_0__ */
#if __ENABLE_X000001B5_1_HACK_1__
    void (*x000001b5_1_hack_1) (struct seek_h262_x000001b5_1 *);
#endif				/* __ENABLE_X000001B5_1_HACK_1__ */
#if __ENABLE_X000001B5_1_HACK_2__
    void (*x000001b5_1_hack_2) (struct seek_h262_x000001b5_3 *);
#endif				/* __ENABLE_X000001B5_1_HACK_2__ */
#if __ENABLE_X000001B5_2_HACK_0__
    void (*x000001b5_2_hack_0) (void *);
#endif				/* __ENABLE_X000001B5_2_HACK_0__ */
#if __ENABLE_X000001B5_2_HACK_1__
    void (*x000001b5_2_hack_1) (struct seek_h262_x000001b5_2 *);
#endif				/* __ENABLE_X000001B5_2_HACK_1__ */
#if __ENABLE_X000001B5_3_HACK_0__
    void (*x000001b5_3_hack_0) (void *);
#endif				/* __ENABLE_X000001B5_3_HACK_0__ */
#if __ENABLE_X000001B5_3_HACK_1__
    void (*x000001b5_3_hack_1) (struct seek_h262_x000001b5_3 *);
#endif				/* __ENABLE_X000001B5_3_HACK_1__ */
#if __ENABLE_X000001B5_5_HACK_0__
    void (*x000001b5_5_hack_0) (void *);
#endif				/* __ENABLE_X000001B5_5_HACK_0__ */
#if __ENABLE_X000001B5_5_HACK_1__
    void (*x000001b5_5_hack_1) (struct seek_h262_x000001b5_5 *);
#endif				/* __ENABLE_X000001B5_5_HACK_1__ */
#if __ENABLE_X000001B5_7_HACK_0__
    void (*x000001b5_7_hack_0) (void *);
#endif				/* __ENABLE_X000001B5_7_HACK_0__ */
#if __ENABLE_X000001B5_7_HACK_1__
    void (*x000001b5_7_hack_1) (struct seek_h262_x000001b5_7 *);
#endif				/* __ENABLE_X000001B5_7_HACK_1__ */
#if __ENABLE_X000001B5_8_HACK_0__
    void (*x000001b5_8_hack_0) (void *);
#endif				/* __ENABLE_X000001B5_8_HACK_0__ */
#if __ENABLE_X000001B5_8_HACK_1__
    void (*x000001b5_8_hack_1) (struct seek_h262_x000001b5_8 *);
#endif				/* __ENABLE_X000001B5_8_HACK_1__ */
#if __ENABLE_X000001B5_9_HACK_0__
    void (*x000001b5_9_hack_0) (void *);
#endif				/* __ENABLE_X000001B5_9_HACK_0__ */
#if __ENABLE_X000001B5_9_HACK_1__
    void (*x000001b5_9_hack_1) (struct seek_h262_x000001b5_9 *);
#endif				/* __ENABLE_X000001B5_9_HACK_1__ */
#if __ENABLE_X000001B5_A_HACK_0__
    void (*x000001b5_a_hack_0) (void *);
#endif				/* __ENABLE_X000001B5_A_HACK_0__ */
#if __ENABLE_X000001B5_A_HACK_1__
    void (*x000001b5_a_hack_1) (struct seek_h262_x000001b5_a *);
#endif				/* __ENABLE_X000001B5_A_HACK_1__ */
#if __ENABLE_X000001B8___HACK_0__
    void (*x000001b8___hack_0) (void *);
#endif				/* __ENABLE_X000001B8___HACK_0__ */
} seek_h262_video_attributes;

typedef struct seek_h262_video_motion_attributes {
    seek_h262_constructOr *block_1_0__, *block_1_1__, *block_1_2__,
	*block_1_3__, *block_1_6__;
#if __Berkeley_FUCK_UP__
    seek_h262_constructOr *block_1_0_1, *block_1_1_1, *block_1_2_1,
	*block_1_3_1, *block_1_6_1;
#endif				/* __Berkeley_FUCK_UP__ */
    seek_h262_constructor *block_0_0__, *block_0_1__, *block_0_2__,
	*block_0_3__, *block_0_6__;
#if __Berkeley_FUCK_UP__
    seek_h262_constructor *block_0_0_1, *block_0_1_1, *block_0_2_1,
	*block_0_3_1, *block_0_6_1;
#endif				/* __Berkeley_FUCK_UP__ */
} seek_h262_video_motion_attributes;

#endif				/* __SEEK_H262_E_H__ */
