/*
 * h262.e.l7.h
 * Copyright (C) 2004, 2005  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __SEEK_H262_E_L7_H__
#define __SEEK_H262_E_L7_H__

#define __INLINE_OPTIMISTIQUE_MOI__	0

#if !__INLINE_OPTIMISTIQUE_MOI__
# define OPTIMISTIQUE_MOI_1(nbytes) \
    {									      \
	if (!size) {							      \
	    optimistique_moi(video, &buffer, &size);			      \
	}								      \
    }
#else
# define OPTIMISTIQUE_MOI_1(nbytes) \
    {									      \
	if (!size) {							      \
	    video->buffer = buffer;					      \
	    video->size = size;						      \
	    video->optimistique_moi(video);				      \
	    buffer = video->buffer;					      \
	    size = video->size;						      \
	}								      \
    }
#endif				/* !__INLINE_OPTIMISTIQUE_MOI__ */

#if !__INLINE_OPTIMISTIQUE_MOI__
# define OPTIMISTIQUE_MOI_X(nbytes) \
    {									      \
	if (size < nbytes) {						      \
	    optimistique_moi(video, &buffer, &size);			      \
	}								      \
    }
#else
# define OPTIMISTIQUE_MOI_X(nbytes) \
    {									      \
	if (size < nbytes) {						      \
	    video->buffer = buffer;					      \
	    video->size = size;						      \
	    video->optimistique_moi(video);				      \
	    buffer = video->buffer;					      \
	    size = video->size;						      \
	}								      \
    }
#endif				/* !__INLINE_OPTIMISTIQUE_MOI__ */

#if !__INLINE_OPTIMISTIQUE_MOI__
# define OPTIMISTIQUE_MOI_c(nbytes) \
    {									      \
	unsigned minimum_useful_size;					      \
									      \
	minimum_useful_size =						      \
	    (video->slice_minimum_useful_size - cache_size) >> 3;	      \
	if (size < minimum_useful_size) {				      \
	    video->minimum_useful_size = minimum_useful_size;		      \
	    optimistique_moi(video, &buffer, &size);			      \
	}								      \
    }
#else
# define OPTIMISTIQUE_MOI_c(nbytes) \
    {									      \
	unsigned minimum_useful_size;					      \
									      \
	minimum_useful_size =						      \
	    (video->slice_minimum_useful_size - cache_size) >> 3;	      \
	if (size < minimum_useful_size) {				      \
	    video->buffer = buffer;					      \
	    video->minimum_useful_size = minimum_useful_size;		      \
	    video->size = size;						      \
	    video->optimistique_moi(video);				      \
	    buffer = video->buffer;					      \
	    size = video->size;						      \
	}								      \
    }
#endif				/* !__INLINE_OPTIMISTIQUE_MOI__ */

#endif				/* __SEEK_H262_E_L7_H__ */
