/*
 * h262.f.11172.c
 * Copyright (C) 2003, 2004, 2005, 2006  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <h262.0.h>
#include <h262.1.h>
#include <h262.2.h>
#include <h262.3.h>
#include <h262.e.h>

#define VIDEO_11172_ATTRIBUTES		struct seek_h262_11172_video_attributes

#define X08_				(intra_coded)
#define X08q				(intra_coded | 4)
#define X10_				(predictive_coded)
#define X10q				(predictive_coded | 4)
#define X18_				(bidirectionally_predictive_coded)
#define X18q				(bidirectionally_predictive_coded | 4)
#define X20_				(dc_intra_coded)

extern void
    (*_seek_h262_11172_GRAYSCALE_macroblock[]) (struct seek_h262_video *),
    (*_seek_h262_11172_YCbCr_____macroblock[]) (struct seek_h262_video *);

void
_seek_h262_set_11172_video_attributes(struct seek_h262_video *video)
{
    if (((integral_q) video->slices[0] & 65535) == 11172) {
    } else {
#if __Berkeley_FUCK_UP__
	video->block_1_0[0] = video->block_1_0[2];
	video->block_1_3[0] = video->block_1_3[2];
#endif				/* __Berkeley_FUCK_UP__ */
	video->slices[0] = (void (*)(struct seek_h262_video *))
	    (((integral_q) video->slices[0] & ~65535) | 11172);
	if (video->slices[intra_coded]
	    == _seek_h262_GRAYSCALE_x___13818_slices) {
	    video->______macroblock[0] =
		_seek_h262_11172_GRAYSCALE_macroblock[0];
	    video->______macroblock[1] =
		_seek_h262_11172_GRAYSCALE_macroblock[2];
	    video->______macroblock[2] =
		_seek_h262_11172_GRAYSCALE_macroblock[1];
	    video->______macroblock[3] =
		_seek_h262_11172_GRAYSCALE_macroblock[3];
	    video->______macroblock[4] =
		_seek_h262_11172_GRAYSCALE_macroblock[4];
	    video->______macroblock[7] =
		_seek_h262_11172_GRAYSCALE_macroblock[7];
	    video->frame_skipped_macroblocks_x10 =
		_seek_h262_GRAYSCALE_x10_macroblocks;
	    video->frame_skipped_macroblocks_x18 =
		_seek_h262___________x18_macroblocks;
	    video->slices[X08_] = _seek_h262_GRAYSCALE_x08_11172_slices;
	    video->slices[X08q] = _seek_h262_GRAYSCALE_x08_11172_slices;
	    video->slices[X10_] = _seek_h262_GRAYSCALE_x___11172_slices;
	    video->slices[X10q] = _seek_h262_GRAYSCALE_x___11172_slicEs;
	    video->slices[X18_] = _seek_h262_GRAYSCALE_x___11172_slices;
	    video->slices[X18q] = _seek_h262_GRAYSCALE_x___11172_slicEs;
	    video->slices[X20_] = _seek_h262_GRAYSCALE_x20_11172_slices;
	} else if (video->slices[intra_coded]
		   == _seek_h262_YCbCr_____x___13818_slices) {
	    video->______macroblock[0] =
		_seek_h262_11172_YCbCr_____macroblock[0];
	    video->______macroblock[1] =
		_seek_h262_11172_YCbCr_____macroblock[2];
	    video->______macroblock[2] =
		_seek_h262_11172_YCbCr_____macroblock[1];
	    video->______macroblock[3] =
		_seek_h262_11172_YCbCr_____macroblock[3];
	    video->______macroblock[4] =
		_seek_h262_11172_YCbCr_____macroblock[4];
	    video->______macroblock[7] =
		_seek_h262_11172_YCbCr_____macroblock[7];
	    video->frame_skipped_macroblocks_x10 =
		_seek_h262_YCbCr_____x10_macroblocks;
	    video->frame_skipped_macroblocks_x18 =
		_seek_h262___________x18_macroblocks;
	    video->slices[X08_] = _seek_h262_YCbCr_____x08_11172_slices;
	    video->slices[X08q] = _seek_h262_YCbCr_____x08_11172_slices;
	    video->slices[X10_] = _seek_h262_YCbCr_____x___11172_slices;
	    video->slices[X10q] = _seek_h262_YCbCr_____x___11172_slicEs;
	    video->slices[X18_] = _seek_h262_YCbCr_____x___11172_slices;
	    video->slices[X18q] = _seek_h262_YCbCr_____x___11172_slicEs;
	    video->slices[X20_] = _seek_h262_YCbCr_____x20_11172_slices;
	} else if (video->slices[intra_coded]
		   == _seek_h262_SKIP______x_________slices) {
	    video->slices[X08q] = _seek_h262_SKIP______x_________slices;
	    video->slices[X10q] = _seek_h262_SKIP______x_________slices;
	    video->slices[X18q] = _seek_h262_SKIP______x_________slices;
	    video->slices[X20_] = _seek_h262_SKIP______x_________slices;
	} else {
	    video->slices[X08_] = _seek_h262___________x08_11172_slices;
	    video->slices[X08q] = _seek_h262___________x08_11172_slices;
	    video->slices[X10_] = _seek_h262___________x___11172_slices;
	    video->slices[X10q] = _seek_h262___________x___11172_slices;
	    video->slices[X18_] = _seek_h262___________x___11172_slices;
	    video->slices[X18q] = _seek_h262___________x___11172_slices;
	    video->slices[X20_] = _seek_h262___________x20_11172_slices;
	}
    }
}


void
seek_h262_get_11172_video_attributes(void *video_return,
				     VIDEO_11172_ATTRIBUTES *video_attributes,
				     unsigned mask)
{
    struct seek_h262_video *video;

    video = (struct seek_h262_video *) video_return;
    if (((integral_q) video->slices[0] & 65535) == 11172) {
	if (mask & SEEK_H262_11172_VIDEO_______MACROBLOCK_MASK) {
	    video_attributes->______macroblock[0] =
		(void (*)(void *)) video->______macroblock[0];
	    video_attributes->______macroblock[1] =
		(void (*)(void *)) video->______macroblock[1];
	    video_attributes->______macroblock[2] =
		(void (*)(void *)) video->______macroblock[2];
	}
	if (mask & SEEK_H262_11172_VIDEO_______SKIPPED_MACROBLOCKS_X10_MASK) {
	    video_attributes->______skipped_macroblocks_x10 =
		(void (*)(void *)) video->frame_skipped_macroblocks_x10;
	}
	if (mask & SEEK_H262_11172_VIDEO_______SKIPPED_MACROBLOCKS_X18_MASK) {
	    video_attributes->______skipped_macroblocks_x18 =
		(void (*)(void *)) video->frame_skipped_macroblocks_x18;
	}
    }
}


void
seek_h262_set_11172_video_attributes(void *video_return,
				     VIDEO_11172_ATTRIBUTES *video_attributes,
				     unsigned mask)
{
    struct seek_h262_video *video;

    video = (struct seek_h262_video *) video_return;
    if (((integral_q) video->slices[0] & 65535) == 11172) {
	if (mask & SEEK_H262_11172_VIDEO_______MACROBLOCK_MASK) {
	    video->______macroblock[0] = (void (*)(struct seek_h262_video *))
		video_attributes->______macroblock[0];
	    video->______macroblock[1] = (void (*)(struct seek_h262_video *))
		video_attributes->______macroblock[2];
	    video->______macroblock[2] = (void (*)(struct seek_h262_video *))
		video_attributes->______macroblock[1];
	    video->______macroblock[3] = (void (*)(struct seek_h262_video *))
		video_attributes->______macroblock[3];
	    video->______macroblock[4] = (void (*)(struct seek_h262_video *))
		video_attributes->______macroblock[4];
	    video->______macroblock[7] = (void (*)(struct seek_h262_video *))
		video_attributes->______macroblock[7];
	}
	if (mask & SEEK_H262_11172_VIDEO_______SKIPPED_MACROBLOCKS_X10_MASK) {
	    video->frame_skipped_macroblocks_x10 =
		(void (*)(struct seek_h262_video *))
		video_attributes->______skipped_macroblocks_x10;
	}
	if (mask & SEEK_H262_11172_VIDEO_______SKIPPED_MACROBLOCKS_X18_MASK) {
	    video->frame_skipped_macroblocks_x18 =
		(void (*)(struct seek_h262_video *))
		video_attributes->______skipped_macroblocks_x18;
	}
    }
}
