/*
 * h262.f.l7.h
 * Copyright (C) 2004, 2005  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __SEEK_H262_F_L7_H__
#define __SEEK_H262_F_L7_H__

/*
 * dct_dc_size_luminance                                     +       9  
 * if (dct_dc_size_luminance != 0) {                                    
 *     dct_dc_differential                                   +      11  
 * }                                                                    
 * while (nextbits() != End of block) {                                 
 *     Subsequent DCT coefficients                           + 63 * 24  
 * }                                                                    
 * End of block                                              +       4  
 */
#define Y_intra_BLOCK_SIZE		003000

/*
 * dct_dc_size_chrominance                                   +      10  
 * if (dct_dc_size_chrominance != 0) {                                  
 *     dct_dc_differential                                   +      11  
 * }                                                                    
 * while (nextbits() != End of block) {                                 
 *     Subsequent DCT coefficients                           + 63 * 24  
 * }                                                                    
 * End of block                                              +       4  
 */
#define C_intra_BLOCK_SIZE		003001

/*
 * First DCT coefficient                                     +      24  
 * while (nextbits() != End of block) {                                 
 *     Subsequent DCT coefficients                           + 63 * 24  
 * }                                                                    
 * End of block                                              +       2  
 */
#define non_intra_BLOCK_SIZE		003002

#define MAXIMUM_intra_BLOCK_SIZE \
    (C_intra_BLOCK_SIZE < Y_intra_BLOCK_SIZE				      \
     ? Y_intra_BLOCK_SIZE : C_intra_BLOCK_SIZE)

#define MAXIMUM_BLOCK_SIZE \
    (MAXIMUM_intra_BLOCK_SIZE < non_intra_BLOCK_SIZE			      \
     ? non_intra_BLOCK_SIZE : MAXIMUM_intra_BLOCK_SIZE)

/*
 * macroblock_type                                                   2  
 * if (decode_dct_type) {                                               
 *     dct_type                                              +       1  
 * }                                                                    
 * if (macroblock_quant) {                                              
 *     quantiser_scale_code                                  +       5  
 * }                                                                    
 * if (concealment_motion_vectors) {                                    
 *     {                                                                
 *         if (motion_vector_count != 1                                 
 *             || (mv_format == field && dmv != 1)) {                   
 *             motion_vertical_field_select[0][0]            +       1  
 *         }                                                            
 *         motion_code[0][0][0]                              +      11  
 *         if (f_code[0][0] != 1 && motion_code[0][0][0]) {             
 *             motion_residual[0][0][0]                      +       8  
 *         }                                                            
 *         if (dmv == 1) {                                              
 *             dmvector[0]                                   +       2  
 *         }                                                            
 *         motion_code[0][0][1]                              +      11  
 *         if (f_code[0][0] != 1 && motion_code[0][0][1]) {             
 *             motion_residual[0][0][1]                      +       8  
 *         }                                                            
 *         if (dmv == 1) {                                              
 *             dmvector[1]                                   +       2  
 *         }                                                            
 *     }                                                                
 *     if (motion_vector_count == 2) {                                  
 *         motion_vertical_field_select[1][0]                +       1  
 *         motion_code[1][0][0]                              +      11  
 *         if (f_code[0][0] != 1 && motion_code[1][0][0]) {             
 *             motion_residual[1][0][0]                      +       8  
 *         }                                                            
 *         if (dmv == 1) {                                              
 *             dmvector[0]                                   +       2  
 *         }                                                            
 *         motion_code[1][0][1]                              +      11  
 *         if (f_code[0][0] != 1 && motion_code[1][0][1]) {             
 *             motion_residual[1][0][1]                      +       8  
 *         }                                                            
 *         if (dmv == 1) {                                              
 *             dmvector[1]                                   +       2  
 *         }                                                            
 *     }                                                                
 *     marker_bit                                            +       1  
 * }                                                                    
 * '000 0000 0000 0000 0000 0000'                            +      23  
 */
#define B2_MACROBLOCK_SIZE		(000166 + 7)

#define B2__C_BLOCK_SIZE		C_intra_BLOCK_SIZE
#define B2__Y_BLOCK_SIZE		Y_intra_BLOCK_SIZE

#define B2__coded_block_pattern_SIZE(chroma_format) \
					0

/*
 * macroblock_type                                           +       6  
 * if (macroblock_motion_forward                                        
 *     && (picture_structure != 'frame'                                 
 *         || frame_pred_frame_dct == 0)) {                             
 *     motion_type                                           +       2  
 * }                                                                    
 * if (decode_dct_type) {                                               
 *     dct_type                                              +       1  
 * }                                                                    
 * if (macroblock_quant) {                                              
 *     quantiser_scale_code                                  +       5  
 * }                                                                    
 * if (macroblock_motion_forward                                        
 *     || (macroblock_intra                                             
 *         && concealment_motion_vectors)) {                            
 *     {                                                                
 *         if (motion_vector_count != 1                                 
 *             || (mv_format == field && dmv != 1)) {                   
 *             motion_vertical_field_select[0][0]            +       1  
 *         }                                                            
 *         motion_code[0][0][0]                              +      11  
 *         if (f_code[0][0] != 1 && motion_code[0][0][0]) {             
 *             motion_residual[0][0][0]                      +       8  
 *         }                                                            
 *         if (dmv == 1) {                                              
 *             dmvector[0]                                   +       2  
 *         }                                                            
 *         motion_code[0][0][1]                              +      11  
 *         if (f_code[0][0] != 1 && motion_code[0][0][1]) {             
 *             motion_residual[0][0][1]                      +       8  
 *         }                                                            
 *         if (dmv == 1) {                                              
 *             dmvector[1]                                   +       2  
 *         }                                                            
 *     }                                                                
 *     if (motion_vector_count == 2) {                                  
 *         motion_vertical_field_select[1][0]                +       1  
 *         motion_code[1][0][0]                              +      11  
 *         if (f_code[0][0] != 1 && motion_code[1][0][0]) {             
 *             motion_residual[1][0][0]                      +       8  
 *         }                                                            
 *         if (dmv == 1) {                                              
 *             dmvector[0]                                   +       2  
 *         }                                                            
 *         motion_code[1][0][1]                              +      11  
 *         if (f_code[0][0] != 1 && motion_code[1][0][1]) {             
 *             motion_residual[1][0][1]                      +       8  
 *         }                                                            
 *         if (dmv == 1) {                                              
 *             dmvector[1]                                   +       2  
 *         }                                                            
 *     }                                                                
 * }                                                                    
 * if (macroblock_intra && concealment_motion_vectors) {                
 *     marker_bit                                            +       1  
 * }                                                                    
 * '000 0000 0000 0000 0000 0000'                            +      23  
 */
#define B3_MACROBLOCK_SIZE		(000174 + 7)

#define B3__C_BLOCK_SIZE		MAXIMUM_BLOCK_SIZE
#define B3__Y_BLOCK_SIZE		MAXIMUM_BLOCK_SIZE

#define B3__coded_block_pattern_SIZE(chroma_format) \
    ((chroma_format) + 3)

/*
 * macroblock_type                                           +       6  
 * if ((macroblock_motion_forward                                       
 *      || macroblock_motion_backward)                                  
 *     && (picture_structure != 'frame'                                 
 *         || frame_pred_frame_dct == 0)) {                             
 *     motion_type                                           +       2  
 * }                                                                    
 * if (decode_dct_type) {                                               
 *     dct_type                                              +       1  
 * }                                                                    
 * if (macroblock_quant) {                                              
 *     quantiser_scale_code                                  +       5  
 * }                                                                    
 * if (macroblock_motion_forward                                        
 *     || (macroblock_intra                                             
 *         && concealment_motion_vectors)) {                            
 *     {                                                                
 *         if (motion_vector_count != 1                                 
 *             || (mv_format == field && dmv != 1)) {                   
 *             motion_vertical_field_select[0][0]            +       1  
 *         }                                                            
 *         motion_code[0][0][0]                              +      11  
 *         if (f_code[0][0] != 1 && motion_code[0][0][0]) {             
 *             motion_residual[0][0][0]                      +       8  
 *         }                                                            
 *         if (dmv == 1) {                                              
 *             dmvector[0]                                   +       2  
 *         }                                                            
 *         motion_code[0][0][1]                              +      11  
 *         if (f_code[0][0] != 1 && motion_code[0][0][1]) {             
 *             motion_residual[0][0][1]                      +       8  
 *         }                                                            
 *         if (dmv == 1) {                                              
 *             dmvector[1]                                   +       2  
 *         }                                                            
 *     }                                                                
 *     if (motion_vector_count == 2) {                                  
 *         motion_vertical_field_select[1][0]                +       1  
 *         motion_code[1][0][0]                              +      11  
 *         if (f_code[0][0] != 1 && motion_code[1][0][0]) {             
 *             motion_residual[1][0][0]                      +       8  
 *         }                                                            
 *         if (dmv == 1) {                                              
 *             dmvector[0]                                   +       2  
 *         }                                                            
 *         motion_code[1][0][1]                              +      11  
 *         if (f_code[0][0] != 1 && motion_code[1][0][1]) {             
 *             motion_residual[1][0][1]                      +       8  
 *         }                                                            
 *         if (dmv == 1) {                                              
 *             dmvector[1]                                   +       2  
 *         }                                                            
 *     }                                                                
 * }                                                                    
 * if (macroblock_motion_backward) {                                    
 *     {                                                                
 *         if (motion_vector_count != 1                                 
 *             || (mv_format == field && dmv != 1)) {                   
 *             motion_vertical_field_select[0][1]            +       1  
 *         }                                                            
 *         motion_code[0][1][0]                              +      11  
 *         if (f_code[1][0] != 1 && motion_code[0][1][0]) {             
 *             motion_residual[0][1][0]                      +       8  
 *         }                                                            
 *         if (dmv == 1) {                                              
 *             dmvector[0]                                   +       2  
 *         }                                                            
 *         motion_code[0][1][1]                              +      11  
 *         if (f_code[1][0] != 1 && motion_code[0][1][1]) {             
 *             motion_residual[0][1][1]                      +       8  
 *         }                                                            
 *         if (dmv == 1) {                                              
 *             dmvector[1]                                   +       2  
 *         }                                                            
 *     }                                                                
 *     if (motion_vector_count == 2) {                                  
 *         motion_vertical_field_select[1][1]                +       1  
 *         motion_code[1][1][0]                              +      11  
 *         if (f_code[1][0] != 1 && motion_code[1][1][0]) {             
 *             motion_residual[1][1][0]                      +       8  
 *         }                                                            
 *         if (dmv == 1) {                                              
 *             dmvector[0]                                   +       2  
 *         }                                                            
 *         motion_code[1][1][1]                              +      11  
 *         if (f_code[1][0] != 1 && motion_code[1][1][1]) {             
 *             motion_residual[1][1][1]                      +       8  
 *         }                                                            
 *         if (dmv == 1) {                                              
 *             dmvector[1]                                   +       2  
 *         }                                                            
 *     }                                                                
 * }                                                                    
 * if (macroblock_intra && concealment_motion_vectors) {                
 *     marker_bit                                            +       1  
 * }                                                                    
 * '000 0000 0000 0000 0000 0000'                            +      23  
 */
#define B4_MACROBLOCK_SIZE		(000322 + 7)

#define B4__C_BLOCK_SIZE		MAXIMUM_BLOCK_SIZE
#define B4__Y_BLOCK_SIZE		MAXIMUM_BLOCK_SIZE

#define B4__coded_block_pattern_SIZE(chroma_format) \
    ((chroma_format) + 3)

/*
 * macroblock_type                                           +       4  
 * if (decode_dct_type) {                                               
 *     dct_type                                              +       1  
 * }                                                                    
 * if (macroblock_quant) {                                              
 *     quantiser_scale_code                                  +       5  
 * }                                                                    
 * if (macroblock_intra && concealment_motion_vectors) {                
 *     {                                                                
 *         if (motion_vector_count != 1                                 
 *             || (mv_format == field && dmv != 1)) {                   
 *             motion_vertical_field_select[0][0]            +       1  
 *         }                                                            
 *         motion_code[0][0][0]                              +      11  
 *         if (f_code[0][0] != 1 && motion_code[0][0][0]) {             
 *             motion_residual[0][0][0]                      +       8  
 *         }                                                            
 *         if (dmv == 1) {                                              
 *             dmvector[0]                                   +       2  
 *         }                                                            
 *         motion_code[0][0][1]                              +      11  
 *         if (f_code[0][0] != 1 && motion_code[0][0][1]) {             
 *             motion_residual[0][0][1]                      +       8  
 *         }                                                            
 *         if (dmv == 1) {                                              
 *             dmvector[1]                                   +       2  
 *         }                                                            
 *     }                                                                
 *     if (motion_vector_count == 2) {                                  
 *         motion_vertical_field_select[1][0]                +       1  
 *         motion_code[1][0][0]                              +      11  
 *         if (f_code[0][0] != 1 && motion_code[1][0][0]) {             
 *             motion_residual[1][0][0]                      +       8  
 *         }                                                            
 *         if (dmv == 1) {                                              
 *             dmvector[0]                                   +       2  
 *         }                                                            
 *         motion_code[1][0][1]                              +      11  
 *         if (f_code[0][0] != 1 && motion_code[1][0][1]) {             
 *             motion_residual[1][0][1]                      +       8  
 *         }                                                            
 *         if (dmv == 1) {                                              
 *             dmvector[1]                                   +       2  
 *         }                                                            
 *     }                                                                
 *     marker_bit                                            +       1  
 * }                                                                    
 * '000 0000 0000 0000 0000 0000'                            +      23  
 */
#define B5_MACROBLOCK_SIZE		(000170 + 7)

#define B5__C_BLOCK_SIZE		MAXIMUM_BLOCK_SIZE
#define B5__Y_BLOCK_SIZE		MAXIMUM_BLOCK_SIZE

#define B5__coded_block_pattern_SIZE(chroma_format) \
    ((chroma_format) + 3)

/*
 * macroblock_type                                           +       7  
 * if (spatial_temporal_weight_code_flag == 1                           
 *     && spatial_temporal_weight_code_table_index != '00') {           
 *     spatial_temporal_weight_code                          +       2  
 * }                                                                    
 * if (macroblock_motion_forward                                        
 *     && (picture_structure != 'frame'                                 
 *         || frame_pred_frame_dct == 0)) {                             
 *     motion_type                                           +       2  
 * }                                                                    
 * if (decode_dct_type) {                                               
 *     dct_type                                              +       1  
 * }                                                                    
 * if (macroblock_quant) {                                              
 *     quantiser_scale_code                                  +       5  
 * }                                                                    
 * if (macroblock_motion_forward                                        
 *     || (macroblock_intra                                             
 *         && concealment_motion_vectors)) {                            
 *     {                                                                
 *         if (motion_vector_count != 1                                 
 *             || (mv_format == field && dmv != 1)) {                   
 *             motion_vertical_field_select[0][0]            +       1  
 *         }                                                            
 *         motion_code[0][0][0]                              +      11  
 *         if (f_code[0][0] != 1 && motion_code[0][0][0]) {             
 *             motion_residual[0][0][0]                      +       8  
 *         }                                                            
 *         if (dmv == 1) {                                              
 *             dmvector[0]                                   +       2  
 *         }                                                            
 *         motion_code[0][0][1]                              +      11  
 *         if (f_code[0][0] != 1 && motion_code[0][0][1]) {             
 *             motion_residual[0][0][1]                      +       8  
 *         }                                                            
 *         if (dmv == 1) {                                              
 *             dmvector[1]                                   +       2  
 *         }                                                            
 *     }                                                                
 *     if (motion_vector_count == 2) {                                  
 *         motion_vertical_field_select[1][0]                +       1  
 *         motion_code[1][0][0]                              +      11  
 *         if (f_code[0][0] != 1 && motion_code[1][0][0]) {             
 *             motion_residual[1][0][0]                      +       8  
 *         }                                                            
 *         if (dmv == 1) {                                              
 *             dmvector[0]                                   +       2  
 *         }                                                            
 *         motion_code[1][0][1]                              +      11  
 *         if (f_code[0][0] != 1 && motion_code[1][0][1]) {             
 *             motion_residual[1][0][1]                      +       8  
 *         }                                                            
 *         if (dmv == 1) {                                              
 *             dmvector[1]                                   +       2  
 *         }                                                            
 *     }                                                                
 * }                                                                    
 * if (macroblock_intra && concealment_motion_vectors) {                
 *     marker_bit                                            +       1  
 * }                                                                    
 * '000 0000 0000 0000 0000 0000'                            +      23  
 */
#define B6_MACROBLOCK_SIZE		(000177 + 7)

#define B6__C_BLOCK_SIZE		MAXIMUM_BLOCK_SIZE
#define B6__Y_BLOCK_SIZE		MAXIMUM_BLOCK_SIZE

#define B6__coded_block_pattern_SIZE(chroma_format) \
    ((chroma_format) + 3)

/*
 * macroblock_type                                           +       9  
 * if (spatial_temporal_weight_code_flag == 1                           
 *     && spatial_temporal_weight_code_table_index != '00') {           
 *     spatial_temporal_weight_code                          +       2  
 * }                                                                    
 * if ((macroblock_motion_forward                                       
 *      || macroblock_motion_backward)                                  
 *     && (picture_structure != 'frame'                                 
 *         || frame_pred_frame_dct == 0)) {                             
 *     motion_type                                           +       2  
 * }                                                                    
 * if (decode_dct_type) {                                               
 *     dct_type                                              +       1  
 * }                                                                    
 * if (macroblock_quant) {                                              
 *     quantiser_scale_code                                  +       5  
 * }                                                                    
 * if (macroblock_motion_forward                                        
 *     || (macroblock_intra                                             
 *         && concealment_motion_vectors)) {                            
 *     {                                                                
 *         if (motion_vector_count != 1                                 
 *             || (mv_format == field && dmv != 1)) {                   
 *             motion_vertical_field_select[0][0]            +       1  
 *         }                                                            
 *         motion_code[0][0][0]                              +      11  
 *         if (f_code[0][0] != 1 && motion_code[0][0][0]) {             
 *             motion_residual[0][0][0]                      +       8  
 *         }                                                            
 *         if (dmv == 1) {                                              
 *             dmvector[0]                                   +       2  
 *         }                                                            
 *         motion_code[0][0][1]                              +      11  
 *         if (f_code[0][0] != 1 && motion_code[0][0][1]) {             
 *             motion_residual[0][0][1]                      +       8  
 *         }                                                            
 *         if (dmv == 1) {                                              
 *             dmvector[1]                                   +       2  
 *         }                                                            
 *     }                                                                
 *     if (motion_vector_count == 2) {                                  
 *         motion_vertical_field_select[1][0]                +       1  
 *         motion_code[1][0][0]                              +      11  
 *         if (f_code[0][0] != 1 && motion_code[1][0][0]) {             
 *             motion_residual[1][0][0]                      +       8  
 *         }                                                            
 *         if (dmv == 1) {                                              
 *             dmvector[0]                                   +       2  
 *         }                                                            
 *         motion_code[1][0][1]                              +      11  
 *         if (f_code[0][0] != 1 && motion_code[1][0][1]) {             
 *             motion_residual[1][0][1]                      +       8  
 *         }                                                            
 *         if (dmv == 1) {                                              
 *             dmvector[1]                                   +       2  
 *         }                                                            
 *     }                                                                
 * }                                                                    
 * if (macroblock_motion_backward) {                                    
 *     {                                                                
 *         if (motion_vector_count != 1                                 
 *             || (mv_format == field && dmv != 1)) {                   
 *             motion_vertical_field_select[0][1]            +       1  
 *         }                                                            
 *         motion_code[0][1][0]                              +      11  
 *         if (f_code[1][0] != 1 && motion_code[0][1][0]) {             
 *             motion_residual[0][1][0]                      +       8  
 *         }                                                            
 *         if (dmv == 1) {                                              
 *             dmvector[0]                                   +       2  
 *         }                                                            
 *         motion_code[0][1][1]                              +      11  
 *         if (f_code[1][0] != 1 && motion_code[0][1][1]) {             
 *             motion_residual[0][1][1]                      +       8  
 *         }                                                            
 *         if (dmv == 1) {                                              
 *             dmvector[1]                                   +       2  
 *         }                                                            
 *     }                                                                
 *     if (motion_vector_count == 2) {                                  
 *         motion_vertical_field_select[1][1]                +       1  
 *         motion_code[1][1][0]                              +      11  
 *         if (f_code[1][0] != 1 && motion_code[1][1][0]) {             
 *             motion_residual[1][1][0]                      +       8  
 *         }                                                            
 *         if (dmv == 1) {                                              
 *             dmvector[0]                                   +       2  
 *         }                                                            
 *         motion_code[1][1][1]                              +      11  
 *         if (f_code[1][0] != 1 && motion_code[1][1][1]) {             
 *             motion_residual[1][1][1]                      +       8  
 *         }                                                            
 *         if (dmv == 1) {                                              
 *             dmvector[1]                                   +       2  
 *         }                                                            
 *     }                                                                
 * }                                                                    
 * if (macroblock_intra && concealment_motion_vectors) {                
 *     marker_bit                                            +       1  
 * }                                                                    
 * '000 0000 0000 0000 0000 0000'                            +      23  
 */
#define B7_MACROBLOCK_SIZE		(000327 + 7)

#define B7__C_BLOCK_SIZE		MAXIMUM_BLOCK_SIZE
#define B7__Y_BLOCK_SIZE		MAXIMUM_BLOCK_SIZE

#define B7__coded_block_pattern_SIZE(chroma_format) \
    ((chroma_format) + 3)

/*
 * macroblock_type                                           +       3  
 * if (decode_dct_type) {                                               
 *     dct_type                                              +       1  
 * }                                                                    
 * if (macroblock_quant) {                                              
 *     quantiser_scale_code                                  +       5  
 * }                                                                    
 * '000 0000 0000 0000 0000 0000'                            +      23  
 */
#define B8_MACROBLOCK_SIZE		(000040 + 7)

#define B8__C_BLOCK_SIZE		non_intra_BLOCK_SIZE
#define B8__Y_BLOCK_SIZE		non_intra_BLOCK_SIZE

#define B8__coded_block_pattern_SIZE(chroma_format) \
    ((chroma_format) + 3)

#define MACROBLOCK_SIZE(block, chroma_format) \
    (block##_MACROBLOCK_SIZE						      \
     + (block##__Y_BLOCK_SIZE << 2)					      \
     + block##__C_BLOCK_SIZE * ((chroma_format) - 4)			      \
     + block##__coded_block_pattern_SIZE(chroma_format))

#endif				/* __SEEK_H262_F_L7_H__ */
