/*
 * e1f4.h
 * Copyright (C) 2003, 2004, 2005, 2006, 2007, 2008  Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __Mylene1f4_H__
#define __Mylene1f4_H__

#define __ENABLE_HEADER_HACK_0__	1
#define __ENABLE_HEADER_HACK_1__	1
#define __ENABLE_HEADER_HACK_2__	1
#define __ENABLE_HEADER_HACK_3__	1

#define __ENABLE_EQUALIZER_0__		1

/*
 * audio attribute mask definitions
 */
#define Mylene1f4_AUDIO_ABORT_DECODING_MASK \
					(1L << 0x00)
#define Mylene1f4_AUDIO_BUFFER_MASK	(1L << 0x01)
#define Mylene1f4_AUDIO_CORRECT_UNDERFLOW_MASK \
					(1L << 0x02)
#define Mylene1f4_AUDIO_DCT_64_MASK	(1L << 0x03)
#define Mylene1f4_AUDIO_DO_RELEASE_MASK	(1L << 0x04)
#if __ENABLE_EQUALIZER_0__
# define Mylene1f4_AUDIO_EQUALIZER_0_MASK \
					(1L << 0x05)
# define Mylene1f4_AUDIO_EQUALIZE_0_MASK \
					(1L << 0x06)
#endif				/* __ENABLE_EQUALIZER_0__ */
#define Mylene1f4_AUDIO_MINIMUM_USEFUL_SIZE_MASK \
					(1L << 0x07)
#define Mylene1f4_AUDIO_OUTPUT_MASK	(1L << 0x08)
#define Mylene1f4_AUDIO_POLYPHASE_BUFFER_MASK \
					(1L << 0x09)
#define Mylene1f4_AUDIO_POLYPHASE_SYNTHESIS_0_MASK \
					(1L << 0x0a)
#define Mylene1f4_AUDIO_POLYPHASE_SYNTHESIS_1_MASK \
					(1L << 0x0b)
#define Mylene1f4_AUDIO_PROCESS_MASK	(1L << 0x0c)
#define Mylene1f4_AUDIO_SAMPLE_SHIFT_MASK \
					(1L << 0x0d)
#define Mylene1f4_AUDIO_SIZE_MASK	(1L << 0x0e)
#define Mylene1f4_AUDIO_SYNCWORD_OFFSET_MASK \
					(1L << 0x0f)
#define Mylene1f4_AUDIO_TRANSFORM_BUFFER_MASK \
					(1L << 0x10)
#define Mylene1f4_AUDIO_TRANSFORM_SYNTHESIS_MASK \
					(1L << 0x11)

/*
 * audio error code definitions
 */
#define Mylene1f4_AUDIO_AUDIO_DATA_FAULT \
					0x01
#define Mylene1f4_AUDIO_BAD_IMPLEMENTATION \
					0x02
#define Mylene1f4_AUDIO_FORBIDDEN_BITRATE_INDEX	\
					0x03
#define Mylene1f4_AUDIO_FUCKED_UP_AUDIO_HEADER \
					0x04
#define Mylene1f4_AUDIO_INVALID_BACKWARD_SEEK \
					0x05
#define Mylene1f4_AUDIO_NULL_BLOCK_TYPE	0x06
#define Mylene1f4_AUDIO_RESERVED_SAMPLING_FREQUENCY \
					0x07
#define Mylene1f4_AUDIO_SHORT_SAMPLES_SECTION \
					0x08
#define Mylene1f4_AUDIO_UNSUPPORTED_BITRATE_INDEX \
					0x09

#define Mylene1f4_AUDIO_NUMBER_OF_ERROR_CODES \
					0x0a

/*
 * bit rate definitions
 */
#define Mylene1f4_FORBIDDEN		0
#define Mylene1f4_FREE_FORMAT		((unsigned) ~0)

/*
 * extra audio attribute mask definitions
 */
#if __ENABLE_HEADER_HACK_2__
# define Mylene1f4_AUDIO_HEADER_CHANGE_MASK \
					(1L << 0x00)
#endif				/* __ENABLE_HEADER_HACK_2__ */
#if __ENABLE_HEADER_HACK_0__
# define Mylene1f4_AUDIO_HEADER_HACK_0_MASK \
					(1L << 0x01)
#endif				/* __ENABLE_HEADER_HACK_0__ */
#if __ENABLE_HEADER_HACK_1__
# define Mylene1f4_AUDIO_HEADER_HACK_1_MASK \
					(1L << 0x02)
#endif				/* __ENABLE_HEADER_HACK_1__ */
#if __ENABLE_HEADER_HACK_2__
# define Mylene1f4_AUDIO_HEADER_HACK_2_MASK \
					(1L << 0x03)
#endif				/* __ENABLE_HEADER_HACK_2__ */
#if __ENABLE_HEADER_HACK_3__
# define Mylene1f4_AUDIO_HEADER_HACK_3_MASK \
					(1L << 0x04)
#endif				/* __ENABLE_HEADER_HACK_3__ */

/*
 * header change mask definitions
 */
#define Mylene1f4_AUDIO_BITRATE_INDEX_MASK \
					0x0000f000
#define Mylene1f4_AUDIO_COPYRIGHT_MASK	0x00000008
#define Mylene1f4_AUDIO_EMPHASIS_MASK	0x00000003
#define Mylene1f4_AUDIO_LAYER_MASK	0x00060000
#define Mylene1f4_AUDIO_MODE_EXTENSION_MASK \
					0x00000030
#define Mylene1f4_AUDIO_MODE_MASK	0x000000c0
#define Mylene1f4_AUDIO_ORIGINALslashHOME_MASK \
					0x00000004
#define Mylene1f4_AUDIO_PADDING_BIT_MASK \
					0x00000200
#define Mylene1f4_AUDIO_PRIVATE_BIT_MASK \
					0x00000100
#define Mylene1f4_AUDIO_PROTECTION_BIT_MASK \
					0x00010000
#define Mylene1f4_AUDIO_SAMPLING_FREQUENCY_MASK \
					0x00000c00
#define Mylene1f4_AUDIO_SYNCWORD_MASK	0xfff00000
#define Mylene1f4_AUDIO_id_MASK		0x00080000

/*
 * layer definitions
 */
#define Mylene1f4_Layer_I		3
#define Mylene1f4_Layer_II		2
#define Mylene1f4_Layer_III		1

/*
 * mode definitions
 */
#define Mylene1f4_dual_channel		2
#define Mylene1f4_joint_stereo		1
#define Mylene1f4_single_channel	3
#define Mylene1f4_stereo		0

/*
 * process definitions
 */
#define Mylene1f4_4294967291		0
#define Mylene1f4_FUTILE		1
#define Mylene1f4_UTTERLY_FUTILE	2

/*
 * sampling_frequency definitions
 */
#define Mylene1f4_RESERVED		((unsigned) ~0)

typedef float Mylene1f4_real;

#if __ENABLE_HEADER_HACK_1__
typedef struct Mylene1f4_header_type {
    unsigned ID, bitrate_index, copyright, emphasis, layer, mode,
	mode_extension, originalslashhome, padding_bit, private_bit,
	protection_bit, sampling_frequency;
    void *decoder;
} Mylene1f4_header_type;
#endif				/* __ENABLE_HEADER_HACK_1__ */

typedef struct Mylene1f4_release_type {
    unsigned flags;
    unsigned char *samples;
} Mylene1f4_release_type;

typedef struct Mylene1f4_audio_attributes_type {
    unsigned minimum_useful_size, process, sample_shift, size, syncword_offset;
#if __ENABLE_HEADER_HACK_2__
    unsigned header_change_mask;
#endif				/* __ENABLE_HEADER_HACK_2__ */
    unsigned char *buffer, *output;
    void (*abort_decoding) (void *), (*correct_underflow) (void *),
	(*dct_64) (Mylene1f4_real *, Mylene1f4_real *, Mylene1f4_real *),
	(*do_release) (void *, struct Mylene1f4_release_type *),
	*polyphase_buffer,
	(*polyphase_synthesis_0) (void *, Mylene1f4_real *, void *, unsigned),
	(*polyphase_synthesis_1) (void *, Mylene1f4_real *, unsigned,
				  void *, unsigned), *transform_buffer,
	(*transform_synthesis) (void);
#if __ENABLE_EQUALIZER_0__
    void (*equalize_0) (void *, Mylene1f4_real *), *equalizer_0;
#endif				/* __ENABLE_EQUALIZER_0__ */
#if __ENABLE_HEADER_HACK_0__
    void (*header_hack_0) (void *);
#endif				/* __ENABLE_HEADER_HACK_0__ */
#if __ENABLE_HEADER_HACK_1__
    void (*header_hack_1) (struct Mylene1f4_header_type *);
#endif				/* __ENABLE_HEADER_HACK_1__ */
#if __ENABLE_HEADER_HACK_2__
    void (*header_hack_2) (struct Mylene1f4_header_type *);
#endif				/* __ENABLE_HEADER_HACK_2__ */
#if __ENABLE_HEADER_HACK_3__
    void (*header_hack_3) (struct Mylene1f4_header_type *);
#endif				/* __ENABLE_HEADER_HACK_3__ */
} Mylene1f4_audio_attributes_type;

typedef struct Mylene1f4_whatever_type {
    unsigned error, minimum_useful_size, size, syncword_offset;
    unsigned char *buffer;
    void (*abort_decoding) (void *), (*correct_underflow) (void *), *private;
} Mylene1f4_whatever_type;

typedef void *Mylene1f4_audio_type;

#define __Mylene1f4_11172_frame_defined__ \
					1

extern void Mylene1f4_11172_frame(Mylene1f4_audio_type);

#define __Mylene1f4_audio_error_string_defined__ \
					1

extern void Mylene1f4_audio_error_string(unsigned, char **);

#define __Mylene1f4_audio_release_size_defined__ \
					1

extern void Mylene1f4_audio_release_size(Mylene1f4_audio_type, unsigned *);

#define __Mylene1f4_audio_sequence_defined__ \
					1

extern void Mylene1f4_audio_sequence(Mylene1f4_audio_type);

#define __Mylene1f4_audio_size_defined__ \
					1

extern void Mylene1f4_audio_size(unsigned *);

#define __Mylene1f4_bitrate_defined__	1

extern void Mylene1f4_bitrate(struct Mylene1f4_header_type *, unsigned *);

#define __Mylene1f4_clear_state_defined__ \
					1

extern void Mylene1f4_clear_state(Mylene1f4_audio_type);

#define __Mylene1f4_correct_underflow_defined__ \
					1

extern void Mylene1f4_correct_underflow(Mylene1f4_audio_type);

#define __Mylene1f4_dct64_0_defined__	1

extern void Mylene1f4_dct64_0
    (Mylene1f4_real *, Mylene1f4_real *, Mylene1f4_real *);

#define __Mylene1f4_dct64_1_defined__	1

extern void Mylene1f4_dct64_1
    (Mylene1f4_real *, Mylene1f4_real *, Mylene1f4_real *);

#define __Mylene1f4_find_audio_defined__ \
					1

extern void Mylene1f4_find_audio(Mylene1f4_audio_type);

#define __Mylene1f4_framerate_defined__	1

extern void Mylene1f4_framerate
    (struct Mylene1f4_header_type *, unsigned *, unsigned *);

#define __Mylene1f4_framerate_string_defined__ \
					1

extern void Mylene1f4_framerate_string
    (struct Mylene1f4_header_type *, const char **);

#define __Mylene1f4_get_ID_defined__	1

extern void Mylene1f4_get_ID(Mylene1f4_audio_type, unsigned *);

#define __Mylene1f4_get_allocation_defined__ \
					1

extern void Mylene1f4_get_allocation
    (Mylene1f4_audio_type, unsigned *, unsigned, unsigned *);

#define __Mylene1f4_get_audio_attributes_defined__ \
					1

extern void Mylene1f4_get_audio_attributes
    (Mylene1f4_audio_type, struct Mylene1f4_audio_attributes_type *, unsigned,
     unsigned);

#define __Mylene1f4_get_audio_data_size_defined__ \
					1

extern void Mylene1f4_get_audio_data_size(Mylene1f4_audio_type, unsigned *);

#define __Mylene1f4_get_bitrate_defined__ \
					1

extern void Mylene1f4_get_bitrate(Mylene1f4_audio_type, unsigned *);

#define __Mylene1f4_get_bitrate_index_defined__ \
					1

extern void Mylene1f4_get_bitrate_index(Mylene1f4_audio_type, unsigned *);

#define __Mylene1f4_get_header_defined__ \
					1

extern void Mylene1f4_get_header(Mylene1f4_audio_type, unsigned *);

#define __Mylene1f4_get_layer_defined__	1

extern void Mylene1f4_get_layer(Mylene1f4_audio_type, unsigned *);

#define __Mylene1f4_get_mode_defined__	1

extern void Mylene1f4_get_mode(Mylene1f4_audio_type, unsigned *);

#define __Mylene1f4_get_mode_extension_defined__ \
					1

extern void Mylene1f4_get_mode_extension(Mylene1f4_audio_type, unsigned *);

#define __Mylene1f4_get_output_defined__ \
					1

extern void Mylene1f4_get_output(Mylene1f4_audio_type, unsigned char ***);

#define __Mylene1f4_get_sampling_frequency_defined__ \
					1

extern void Mylene1f4_get_sampling_frequency(Mylene1f4_audio_type, unsigned *);

#define __Mylene1f4_header_semantics_defined__ \
					1

extern void Mylene1f4_header_semantics
    (unsigned, struct Mylene1f4_header_type *);

#define __Mylene1f4_init_tables_defined__ \
					1

extern void Mylene1f4_init_tables(void);

#define __Mylene1f4_polyphase_synthesis_0_defined__ \
					1

extern void Mylene1f4_polyphase_synthesis_0
    (Mylene1f4_audio_type, Mylene1f4_real *, void *, unsigned);

#define __Mylene1f4_polyphase_synthesis_1_defined__ \
					1

extern void Mylene1f4_polyphase_synthesis_1
    (Mylene1f4_audio_type, Mylene1f4_real *, unsigned, void *, unsigned);

#define __Mylene1f4_polyphase_synthesis_2_defined__ \
					1

extern void Mylene1f4_polyphase_synthesis_2
    (Mylene1f4_audio_type, Mylene1f4_real *, void *, unsigned);

#define __Mylene1f4_polyphase_synthesis_3_defined__ \
					1

extern void Mylene1f4_polyphase_synthesis_3
    (Mylene1f4_audio_type, Mylene1f4_real *, unsigned, void *, unsigned);

#define __Mylene1f4_polyphase_synthesis_8_defined__ \
					1

extern void Mylene1f4_polyphase_synthesis_8
    (Mylene1f4_audio_type, Mylene1f4_real *, void *, unsigned);

#define __Mylene1f4_polyphase_synthesis_9_defined__ \
					1

extern void Mylene1f4_polyphase_synthesis_9
    (Mylene1f4_audio_type, Mylene1f4_real *, unsigned, void *, unsigned);

#define __Mylene1f4_polyphase_synthesis_a_defined__ \
					1

extern void Mylene1f4_polyphase_synthesis_a
    (Mylene1f4_audio_type, Mylene1f4_real *, void *, unsigned);

#define __Mylene1f4_polyphase_synthesis_b_defined__ \
					1

extern void Mylene1f4_polyphase_synthesis_b
    (Mylene1f4_audio_type, Mylene1f4_real *, unsigned, void *, unsigned);

#define __Mylene1f4_release_size_defined__ \
					1

extern void Mylene1f4_release_size(unsigned, unsigned *);

#define __Mylene1f4_reset_audio_defined__ \
					1

extern void Mylene1f4_reset_audio(Mylene1f4_audio_type);

#define __Mylene1f4_reset_audio_attributes_defined__ \
					1

extern void Mylene1f4_reset_audio_attributes
    (Mylene1f4_audio_type, unsigned, unsigned);

#define __Mylene1f4_reset_state_defined__ \
					1

extern void Mylene1f4_reset_state(Mylene1f4_audio_type);

#define __Mylene1f4_sampling_frequency_defined__ \
					1

extern void Mylene1f4_sampling_frequency
    (struct Mylene1f4_header_type *, unsigned *);

#define __Mylene1f4_seek_audio_defined__ \
					1

extern void Mylene1f4_seek_audio(Mylene1f4_audio_type);

#define __Mylene1f4_set_audio_attributes_defined__ \
					1

extern void Mylene1f4_set_audio_attributes
    (Mylene1f4_audio_type, struct Mylene1f4_audio_attributes_type *, unsigned,
     unsigned);

#define __Mylene1f4_synchronize_audio_defined__ \
					1

extern void Mylene1f4_synchronize_audio(Mylene1f4_audio_type, unsigned);

#define __Mylene1f4_syncword_offset_defined__ \
					1

extern void Mylene1f4_syncword_offset(unsigned, unsigned *);

#define __Mylene1f4_version_defined__	1

extern void Mylene1f4_version(const char **);

#endif				/* __Mylene1f4_H__ */
